/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(J){for(var e=[],g=0,L=J.length;g<L;g++)e[g]=ge[J[g]];return e};define(ge[54],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=g}),define(ge[55],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(n){const A=[];for(let d in n)g.call(n,d)&&A.push(n[d]);return A}e.values=L;function k(n,A){for(let d in n)if(g.call(n,d)&&A({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=k;function C(n,A){const d=Object.create(null);for(const m of n){const l=A(m);let v=d[l];v||(v=d[l]=[]),v.push(m)}return d}e.groupBy=C;function T(n){const A=Object.create(null);return n&&n.forEach((d,m)=>{A[m]=d}),A}e.fromMap=T;function y(n,A){const d=[],m=[];for(let l of n)A.has(l)||d.push(l);for(let l of A)n.has(l)||m.push(l);return{removed:d,added:m}}e.diffSets=y;function _(n,A){const d=[],m=[];for(let[l,v]of n)A.has(l)||d.push(v);for(let[l,v]of A)n.has(l)||m.push(v);return{removed:d,added:m}}e.diffMaps=_;class I{constructor(){this.map=new Map}add(A,d){let m=this.map.get(A);m||(m=new Set,this.map.set(A,m)),m.add(d)}delete(A,d){const m=this.map.get(A);!m||(m.delete(d),m.size===0&&this.map.delete(A))}forEach(A,d){const m=this.map.get(A);!m||m.forEach(d)}}e.SetMap=I}),define(ge[56],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(y,_,I)=>{let n=null,A=null;if(typeof I.value=="function"?(n="value",A=I.value):typeof I.get=="function"&&(n="get",A=I.get),!A)throw new Error("not supported");I[n]=T(A,_)}}e.createDecorator=g;function L(T,y,_){let I=null,n=null;if(typeof _.value=="function"?(I="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",n=_.get),!n)throw new Error("not supported");const A=`$memoize$${y}`;_[I]=function(...d){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[A]}}e.memoize=L;function k(T,y,_){return g((I,n)=>{const A=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...m){this[d]||(this[d]=_?_():void 0),clearTimeout(this[A]),y&&(this[d]=y(this[d],...m),m=[this[d]]),this[A]=setTimeout(()=>{I.apply(this,m),this[d]=_?_():void 0},T)}})}e.debounce=k;function C(T,y,_){return g((I,n)=>{const A=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,l=`$throttle$pending$${n}`;return function(...v){if(this[d]||(this[d]=_?_():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),y&&(this[d]=y(this[d],...v)),this[l])return;const S=this[m]+T;S<=Date.now()?(this[m]=Date.now(),I.apply(this,[this[d]]),this[d]=_?_():void 0):(this[l]=!0,this[A]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),I.apply(this,[this[d]]),this[d]=_?_():void 0},S-Date.now()))}})}e.throttle=C}),define(ge[16],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function k(p){_(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=k;function C(p){_(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=C;function T(p){if(p instanceof Error){let{name:t,message:r}=p;const o=p.stacktrace||p.stack;return{$isError:!0,name:t,message:r,stack:o}}return p}e.transformErrorForSerialization=T;const y="Canceled";function _(p){return p instanceof Error&&p.name===y&&p.message===y}e.isPromiseCanceledError=_;class I extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=I;function n(){const p=new Error(y);return p.name=p.message,p}e.canceled=n;function A(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=A;function d(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=d;function m(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function l(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function f(p,t=Object.create(null)){const r=new Error(p);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=f}),define(ge[20],pe([0,1,16]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(B,K=0){return B[B.length-(1+K)]}e.tail=L;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function C(B,K,te=(he,De)=>he===De){if(B===K)return!0;if(!B||!K||B.length!==K.length)return!1;for(let he=0,De=B.length;he<De;he++)if(!te(B[he],K[he]))return!1;return!0}e.equals=C;function T(B,K,te){let he=0,De=B.length-1;for(;he<=De;){const Pe=(he+De)/2|0,Fe=te(B[Pe],K);if(Fe<0)he=Pe+1;else if(Fe>0)De=Pe-1;else return Pe}return-(he+1)}e.binarySearch=T;function y(B,K){let te=0,he=B.length;if(he===0)return 0;for(;te<he;){const De=Math.floor((te+he)/2);K(B[De])?he=De:te=De+1}return te}e.findFirstInSorted=y;function _(B,K,te){if(B=B|0,B>=K.length)throw new TypeError("invalid index");let he=K[Math.floor(K.length*Math.random())],De=[],Pe=[],Fe=[];for(let qe of K){const We=te(qe,he);We<0?De.push(qe):We>0?Pe.push(qe):Fe.push(qe)}return B<De.length?_(B,De,te):B<De.length+Fe.length?Fe[0]:_(B-(De.length+Fe.length),Pe,te)}e.quickSelect=_;function I(B,K){const te=[];let he;for(const De of B.slice(0).sort(K))!he||K(he[0],De)!==0?(he=[De],te.push(he)):he.push(De);return te}e.groupBy=I;function n(B,K,te){const he=[];function De(qe,We,je){if(We===0&&je.length===0)return;const W=he[he.length-1];W&&W.start+W.deleteCount===qe?(W.deleteCount+=We,W.toInsert.push(...je)):he.push({start:qe,deleteCount:We,toInsert:je})}let Pe=0,Fe=0;for(;;){if(Pe===B.length){De(Pe,0,K.slice(Fe));break}if(Fe===K.length){De(Pe,B.length-Pe,[]);break}const qe=B[Pe],We=K[Fe],je=te(qe,We);je===0?(Pe+=1,Fe+=1):je<0?(De(Pe,1,[]),Pe+=1):je>0&&(De(Pe,0,[We]),Fe+=1)}return he}e.sortedDiff=n;function A(B,K,te){const he=n(B,K,te),De=[],Pe=[];for(const Fe of he)De.push(...B.slice(Fe.start,Fe.start+Fe.deleteCount)),Pe.push(...Fe.toInsert);return{removed:De,added:Pe}}e.delta=A;function d(B,K,te){if(te===0)return[];const he=B.slice(0,te).sort(K);return l(B,K,he,te,B.length),he}e.top=d;function m(B,K,te,he,De){return te===0?Promise.resolve([]):new Promise((Pe,Fe)=>{(async()=>{const qe=B.length,We=B.slice(0,te).sort(K);for(let je=te,W=Math.min(te+he,qe);je<qe;je=W,W=Math.min(W+he,qe)){if(je>te&&await new Promise(Z=>setTimeout(Z)),De&&De.isCancellationRequested)throw(0,g.canceled)();l(B,K,We,je,W)}return We})().then(Pe,Fe)})}e.topAsync=m;function l(B,K,te,he,De){for(const Pe=te.length;he<De;he++){const Fe=B[he];if(K(Fe,te[Pe-1])<0){te.pop();const qe=y(te,We=>K(Fe,We)<0);te.splice(qe,0,Fe)}}}function v(B){return B.filter(K=>!!K)}e.coalesce=v;function S(B){let K=0;for(let te=0;te<B.length;te++)B[te]&&(B[K]=B[te],K+=1);B.length=K}e.coalesceInPlace=S;function b(B,K,te){B.splice(te,0,B.splice(K,1)[0])}e.move=b;function P(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=P;function c(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=c;function f(B,K){if(!K)return B.filter((he,De)=>B.indexOf(he)===De);const te=Object.create(null);return B.filter(he=>{const De=K(he);return te[De]?!1:(te[De]=!0,!0)})}e.distinct=f;function p(B){const K=new Set;return B.filter(te=>K.has(te)?!1:(K.add(te),!0))}e.distinctES6=p;function t(B){const K=Object.create(null);return te=>{const he=B(te);return K[he]?!1:(K[he]=!0,!0)}}e.uniqueFilter=t;function r(B,K){for(let te=B.length-1;te>=0;te--){const he=B[te];if(K(he))return te}return-1}e.lastIndex=r;function o(B,K){return B.length>0?B[0]:K}e.firstOrDefault=o;function i(B,K,te=(he,De)=>he===De){let he=0;for(let De=0,Pe=Math.min(B.length,K.length);De<Pe&&te(B[De],K[De]);De++)he++;return he}e.commonPrefixLength=i;function a(B){return[].concat(...B)}e.flatten=a;function h(B,K){let te=typeof K=="number"?B:0;typeof K=="number"?te=B:(te=0,K=B);const he=[];if(te<=K)for(let De=te;De<K;De++)he.push(De);else for(let De=te;De>K;De--)he.push(De);return he}e.range=h;function u(B,K,te){return B.reduce((he,De)=>(he[K(De)]=te?te(De):De,he),Object.create(null))}e.index=u;function w(B,K){return B.push(K),()=>E(B,K)}e.insert=w;function E(B,K){const te=B.indexOf(K);if(te>-1)return B.splice(te,1),K}e.remove=E;function s(B,K,te){const he=B.slice(0,K),De=B.slice(K);return he.concat(te,De)}e.arrayInsert=s;function D(B,K){let te;if(typeof K=="number"){let he=K;te=()=>{const De=Math.sin(he++)*179426549;return De-Math.floor(De)}}else te=Math.random;for(let he=B.length-1;he>0;he-=1){const De=Math.floor(te()*(he+1)),Pe=B[he];B[he]=B[De],B[De]=Pe}}e.shuffle=D;function R(B,K){const te=B.indexOf(K);te>-1&&(B.splice(te,1),B.unshift(K))}e.pushToStart=R;function U(B,K){const te=B.indexOf(K);te>-1&&(B.splice(te,1),B.push(K))}e.pushToEnd=U;function V(B,K){return Array.isArray(B)?B.map(K):K(B)}e.mapArrayOrNot=V;function ee(B){return Array.isArray(B)?B:[B]}e.asArray=ee;function Q(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=Q;function O(B,K){for(const te of B){const he=K(te);if(he!==void 0)return he}}e.mapFind=O;function x(B,K,te){const he=z(B,K),De=B.length,Pe=te.length;B.length=De+Pe;for(let Fe=De-1;Fe>=he;Fe--)B[Fe+Pe]=B[Fe];for(let Fe=0;Fe<Pe;Fe++)B[Fe+he]=te[Fe]}e.insertInto=x;function F(B,K,te,he){const De=z(B,K),Pe=B.splice(De,te);return x(B,De,he),Pe}e.splice=F;function z(B,K){return K<0?Math.max(K+B.length,0):Math.min(K,B.length)}function M(B,K){let te=Number.MAX_SAFE_INTEGER,he=0;return B.forEach((De,Pe)=>{const Fe=K(De);Fe<te&&(te=Fe,he=Pe)}),he}e.minIndex=M;function N(B,K){let te=Number.MIN_SAFE_INTEGER,he=0;return B.forEach((De,Pe)=>{const Fe=K(De);Fe>te&&(te=Fe,he=Pe)}),he}e.maxIndex=N;class q{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let te=this.firstIdx;for(;te<this.items.length&&K(this.items[te]);)te++;const he=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,he}takeFromEndWhile(K){let te=this.lastIdx;for(;te>=0&&K(this.items[te]);)te--;const he=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,he}}e.ArrayQueue=q}),define(ge[72],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const k=this;let C=!1,T;return function(){return C||(C=!0,T=L.apply(k,arguments)),T}}e.once=g}),define(ge[73],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(ge[74],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=k;const C=Object.freeze([]);function T(){return C}L.empty=T;function*y(p){yield p}L.single=y;function _(p){return p||C}L.from=_;function I(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=I;function n(p){return p[Symbol.iterator]().next().value}L.first=n;function A(p,t){for(const r of p)if(t(r))return!0;return!1}L.some=A;function d(p,t){for(const r of p)if(t(r))return r}L.find=d;function*m(p,t){for(const r of p)t(r)&&(yield r)}L.filter=m;function*l(p,t){let r=0;for(const o of p)yield t(o,r++)}L.map=l;function*v(...p){for(const t of p)for(const r of t)yield r}L.concat=v;function*S(p){for(const t of p)for(const r of t)yield r}L.concatNested=S;function b(p,t,r){let o=r;for(const i of p)o=t(o,i);return o}L.reduce=b;function*P(p,t,r=p.length){for(t<0&&(t+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);t<r;t++)yield p[t]}L.slice=P;function c(p,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,p];const o=p[Symbol.iterator]();for(let i=0;i<t;i++){const a=o.next();if(a.done)return[r,L.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return o}}]}L.consume=c;function f(p,t,r=(o,i)=>o===i){const o=p[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const a=o.next(),h=i.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!r(a.value,h.value))return!1}}L.equals=f})(g=e.Iterable||(e.Iterable={}))}),define(ge[57],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(t,r=!1){let o=0,i=t.length,a="",h=0,u=16,w=0;function E(Q){let O=0,x=0;for(;O<Q;){const F=t.charCodeAt(o);if(F>=48&&F<=57)x=x*16+F-48;else if(F>=65&&F<=70)x=x*16+F-65+10;else if(F>=97&&F<=102)x=x*16+F-97+10;else break;o++,O++}return O<Q&&(x=-1),x}function s(Q){o=Q,a="",h=0,u=16,w=0}function D(){const Q=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&I(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&I(t.charCodeAt(o)))for(o++;o<t.length&&I(t.charCodeAt(o));)o++;else return w=3,t.substring(Q,o);let O=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&I(t.charCodeAt(o))){for(o++;o<t.length&&I(t.charCodeAt(o));)o++;O=o}else w=3;return t.substring(Q,O)}function R(){let Q="",O=o;for(;;){if(o>=i){Q+=t.substring(O,o),w=2;break}const x=t.charCodeAt(o);if(x===34){Q+=t.substring(O,o),o++;break}if(x===92){if(Q+=t.substring(O,o),o++,o>=i){w=2;break}switch(t.charCodeAt(o++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const z=E(4);z>=0?Q+=String.fromCharCode(z):w=4;break;default:w=5}O=o;continue}if(x>=0&&x<=31)if(_(x)){Q+=t.substring(O,o),w=2;break}else w=6;o++}return Q}function U(){if(a="",w=0,h=o,o>=i)return h=i,u=17;let Q=t.charCodeAt(o);if(y(Q)){do o++,a+=String.fromCharCode(Q),Q=t.charCodeAt(o);while(y(Q));return u=15}if(_(Q))return o++,a+=String.fromCharCode(Q),Q===13&&t.charCodeAt(o)===10&&(o++,a+=`
`),u=14;switch(Q){case 123:return o++,u=1;case 125:return o++,u=2;case 91:return o++,u=3;case 93:return o++,u=4;case 58:return o++,u=6;case 44:return o++,u=5;case 34:return o++,a=R(),u=10;case 47:const O=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!_(t.charCodeAt(o));)o++;return a=t.substring(O,o),u=12}if(t.charCodeAt(o+1)===42){o+=2;const x=i-1;let F=!1;for(;o<x;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,F=!0;break}o++}return F||(o++,w=1),a=t.substring(O,o),u=13}return a+=String.fromCharCode(Q),o++,u=16;case 45:if(a+=String.fromCharCode(Q),o++,o===i||!I(t.charCodeAt(o)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=D(),u=11;default:for(;o<i&&V(Q);)o++,Q=t.charCodeAt(o);if(h!==o){switch(a=t.substring(h,o),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode(Q),o++,u=16}}function V(Q){if(y(Q)||_(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let Q;do Q=U();while(Q>=12&&Q<=15);return Q}return{setPosition:s,getPosition:()=>o,scan:r?ee:U,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>w}}e.createScanner=T;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function A(t,r){const o=[],i=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function w(E,s,D,R){h.value=E,h.offset=s,h.length=D,h.type=R,h.colonOffset=void 0,a=h}try{c(t,{onObjectBegin:(E,s)=>{if(r<=E)throw i;a=void 0,u=r>E,o.push("")},onObjectProperty:(E,s,D)=>{if(r<s||(w(E,s,D,"property"),o[o.length-1]=E,r<=s+D))throw i},onObjectEnd:(E,s)=>{if(r<=E)throw i;a=void 0,o.pop()},onArrayBegin:(E,s)=>{if(r<=E)throw i;a=void 0,o.push(0)},onArrayEnd:(E,s)=>{if(r<=E)throw i;a=void 0,o.pop()},onLiteralValue:(E,s,D)=>{if(r<s||(w(E,s,D,p(E)),r<=s+D))throw i},onSeparator:(E,s,D)=>{if(r<=s)throw i;if(E===":"&&a&&a.type==="property")a.colonOffset=s,u=!1,a=void 0;else if(E===","){const R=o[o.length-1];typeof R=="number"?o[o.length-1]=R+1:(u=!0,o[o.length-1]=""),a=void 0}}})}catch(E){if(E!==i)throw E}return{path:o,previousNode:a,isAtPropertyKey:u,matches:E=>{let s=0;for(let D=0;s<E.length&&D<o.length;D++)if(E[s]===o[D]||E[s]==="*")s++;else if(E[s]!=="**")return!1;return s===E.length}}}e.getLocation=A;function d(t,r=[],o=C.DEFAULT){let i=null,a=[];const h=[];function u(E){Array.isArray(a)?a.push(E):i!==null&&(a[i]=E)}return c(t,{onObjectBegin:()=>{const E={};u(E),h.push(a),a=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const E=[];u(E),h.push(a),a=E,i=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:u,onError:(E,s,D)=>{r.push({error:E,offset:s,length:D})}},o),a[0]}e.parse=d;function m(t,r=[],o=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function h(E){return i.children.push(E),E}c(t,{onObjectBegin:E=>{i=h({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,s,D)=>{i=h({type:"property",offset:s,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:s,length:D,parent:i})},onObjectEnd:(E,s)=>{i.length=E+s-i.offset,i=i.parent,a(E+s)},onArrayBegin:(E,s)=>{i=h({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,s)=>{i.length=E+s-i.offset,i=i.parent,a(E+s)},onLiteralValue:(E,s,D)=>{h({type:p(E),offset:s,length:D,parent:i,value:E}),a(s+D)},onSeparator:(E,s,D)=>{i.type==="property"&&(E===":"?i.colonOffset=s:E===","&&a(s))},onError:(E,s,D)=>{r.push({error:E,offset:s,length:D})}},o);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=m;function l(t,r){if(!t)return;let o=t;for(let i of r)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===i){o=h.children[1],a=!0;break}if(!a)return}else{const a=i;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=l;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=v;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const r=Object.create(null);for(let o of t.children){const i=o.children[1];i&&(r[o.children[0].value]=S(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function b(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=b;function P(t,r,o=!1){if(b(t,r,o)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=r;a++){const h=P(i[a],r,o);if(h)return h}return t}}e.findNodeAtOffset=P;function c(t,r,o=C.DEFAULT){const i=T(t,!1);function a(te){return te?()=>te(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(te){return te?he=>te(he,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=a(r.onObjectBegin),w=h(r.onObjectProperty),E=a(r.onObjectEnd),s=a(r.onArrayBegin),D=a(r.onArrayEnd),R=h(r.onLiteralValue),U=h(r.onSeparator),V=a(r.onComment),ee=h(r.onError),Q=o&&o.disallowComments,O=o&&o.allowTrailingComma;function x(){for(;;){const te=i.scan();switch(i.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:Q||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(te){case 12:case 13:Q?F(10):V();break;case 16:F(1);break;case 15:case 14:break;default:return te}}}function F(te,he=[],De=[]){if(ee(te),he.length+De.length>0){let Pe=i.getToken();for(;Pe!==17;){if(he.indexOf(Pe)!==-1){x();break}else if(De.indexOf(Pe)!==-1)break;Pe=x()}}}function z(te){const he=i.getTokenValue();return te?R(he):w(he),x(),!0}function M(){switch(i.getToken()){case 11:let te=0;try{te=JSON.parse(i.getTokenValue()),typeof te!="number"&&(F(2),te=0)}catch(he){F(2)}R(te);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return x(),!0}function N(){return i.getToken()!==10?(F(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(U(":"),x(),K()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function q(){u(),x();let te=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(te||F(4,[],[]),U(","),x(),i.getToken()===2&&O)break}else te&&F(6,[],[]);N()||F(4,[],[2,5]),te=!0}return E(),i.getToken()!==2?F(7,[2],[]):x(),!0}function B(){s(),x();let te=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(te||F(4,[],[]),U(","),x(),i.getToken()===4&&O)break}else te&&F(6,[],[]);K()||F(4,[],[4,5]),te=!0}return D(),i.getToken()!==4?F(8,[4],[]):x(),!0}function K(){switch(i.getToken()){case 3:return B();case 1:return q();case 10:return z(!0);default:return M()}}return x(),i.getToken()===17?o.allowEmptyContent?!0:(F(4,[],[]),!1):K()?(i.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=c;function f(t,r){let o=T(t),i=[],a,h=0,u;do switch(u=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:h!==u&&i.push(t.substring(h,u)),r!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,r)),h=o.getPosition();break}while(a!==17);return i.join("")}e.stripComments=f;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ge[137],pe([0,1,57]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(_,I,n){let A,d,m,l,v;if(I){for(l=I.offset,v=l+I.length,m=l;m>0&&!y(_,m-1);)m--;let h=v;for(;h<_.length&&!y(_,h);)h++;d=_.substring(m,h),A=C(d,n)}else d=_,A=0,m=0,l=0,v=_.length;const S=T(n,_);let b=!1,P=0,c;n.insertSpaces?c=k(" ",n.tabSize||4):c="	";const f=(0,g.createScanner)(d,!1);let p=!1;function t(){return S+k(c,A+P)}function r(){let h=f.scan();for(b=!1;h===15||h===14;)b=b||h===14,h=f.scan();return p=h===16||f.getTokenError()!==0,h}const o=[];function i(h,u,w){!p&&u<v&&w>l&&_.substring(u,w)!==h&&o.push({offset:u,length:w-u,content:h})}let a=r();if(a!==17){const h=f.getTokenOffset()+m,u=k(c,A);i(u,m,h)}for(;a!==17;){let h=f.getTokenOffset()+f.getTokenLength()+m,u=r(),w="";for(;!b&&(u===12||u===13);){const s=f.getTokenOffset()+m;i(" ",h,s),h=f.getTokenOffset()+f.getTokenLength()+m,w=u===12?t():"",u=r()}if(u===2)a!==1&&(P--,w=t());else if(u===4)a!==3&&(P--,w=t());else{switch(a){case 3:case 1:P++,w=t();break;case 5:case 12:w=t();break;case 13:b?w=t():w=" ";break;case 6:w=" ";break;case 10:if(u===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?w=" ":u!==5&&u!==17&&(p=!0);break;case 16:p=!0;break}b&&(u===12||u===13)&&(w=t())}const E=f.getTokenOffset()+m;i(w,h,E),a=u}return o}e.format=L;function k(_,I){let n="";for(let A=0;A<I;A++)n+=_;return n}function C(_,I){let n=0,A=0;const d=I.tabSize||4;for(;n<_.length;){const m=_.charAt(n);if(m===" ")A++;else if(m==="	")A+=d;else break;n++}return Math.floor(A/d)}function T(_,I){for(let n=0;n<I.length;n++){const A=I.charAt(n);if(A==="\r")return n+1<I.length&&I.charAt(n+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return _&&_.eol||`
`}e.getEOL=T;function y(_,I){return`\r
`.indexOf(_.charAt(I))!==-1}e.isEOL=y}),define(ge[138],pe([0,1,57,137]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(I,n,A){return C(I,n,void 0,A)}e.removeProperty=k;function C(I,n,A,d,m){const l=n.slice(),v=[],S=(0,g.parseTree)(I,v);let b,P;for(;l.length>0&&(P=l.pop(),b=(0,g.findNodeAtLocation)(S,l),b===void 0&&A!==void 0);)typeof P=="string"?A={[P]:A}:A=[A];if(b)if(b.type==="object"&&typeof P=="string"&&Array.isArray(b.children)){const c=(0,g.findNodeAtLocation)(b,[P]);if(c!==void 0)if(A===void 0){if(!c.parent)throw new Error("Malformed AST");const f=b.children.indexOf(c.parent);let p,t=c.parent.offset+c.parent.length;if(f>0){const r=b.children[f-1];p=r.offset+r.length}else p=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return T(I,{offset:p,length:t-p,content:""},d)}else return T(I,{offset:c.offset,length:c.length,content:JSON.stringify(A)},d);else{if(A===void 0)return[];const f=`${JSON.stringify(P)}: ${JSON.stringify(A)}`,p=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(p>0){const r=b.children[p-1];t={offset:r.offset+r.length,length:0,content:","+f}}else b.children.length===0?t={offset:b.offset+1,length:0,content:f}:t={offset:b.offset+1,length:0,content:f+","};return T(I,t,d)}}else if(b.type==="array"&&typeof P=="number"&&Array.isArray(b.children))if(A!==void 0){const c=`${JSON.stringify(A)}`;let f;if(b.children.length===0||P===0)f={offset:b.offset+1,length:0,content:b.children.length===0?c:c+","};else{const p=P===-1||P>b.children.length?b.children.length:P,t=b.children[p-1];f={offset:t.offset+t.length,length:0,content:","+c}}return T(I,f,d)}else{const c=P,f=b.children[c];let p;if(b.children.length===1)p={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===c){const t=b.children[c-1],r=t.offset+t.length,o=b.offset+b.length;p={offset:r,length:o-2-r,content:""}}else p={offset:f.offset,length:b.children[c+1].offset-f.offset,content:""};return T(I,p,d)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${b.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return T(I,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(A)},d)}}e.setProperty=C;function T(I,n,A){let d=y(I,n),m=n.offset,l=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,L.isEOL)(d,m-1);)m--;for(;l<d.length&&!(0,L.isEOL)(d,l);)l++}const v=(0,L.format)(d,{offset:m,length:l-m},A);for(let b=v.length-1;b>=0;b--){const P=v[b];d=y(d,P),m=Math.min(m,P.offset),l=Math.max(l,P.offset+P.length),l+=P.content.length-P.length}const S=I.length-(d.length-l)-m;return[{offset:m,length:S,content:d.substring(m,l)}]}e.withFormatting=T;function y(I,n){return I.substring(0,n.offset)+n.content+I.substring(n.offset+n.length)}e.applyEdit=y;function _(I,n){let A=n.slice(0).sort((m,l)=>{const v=m.offset-l.offset;return v===0?m.length-l.length:v}),d=I.length;for(let m=A.length-1;m>=0;m--){let l=A[m];if(l.offset+l.length<=d)I=y(I,l);else throw new Error("Overlapping edit");d=l.offset}return I}e.applyEdits=_}),define(ge[139],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new g(()=>k(this.getValue()))}}e.Lazy=g}),define(ge[6],pe([0,1,72,74]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let C=null;function T(o){C=o}if(e.setDisposableTracker=T,k){const o="__is_disposable_tracked__";T(new class{trackDisposable(i){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[o]||console.log(a)},3e3)}setParent(i,a){if(i&&i!==P.None)try{i[o]=!0}catch{}}markAsDisposed(i){if(i&&i!==P.None)try{i[o]=!0}catch{}}markAsSingleton(i){}})}function y(o){return C?.trackDisposable(o),o}function _(o){C?.markAsDisposed(o)}function I(o,i){C?.setParent(o,i)}function n(o,i){if(!!C)for(const a of o)C.setParent(a,i)}function A(o){return C?.markAsSingleton(o),o}e.markAsSingleton=A;class d extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=d;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function l(o){if(L.Iterable.is(o)){let i=[];for(const a of o)if(a)try{a.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new d(i);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=l;function v(...o){const i=S(()=>l(o));return n(o,i),i}e.combinedDisposable=v;function S(o){const i=y({dispose:(0,g.once)(()=>{_(i),o()})});return i}e.toDisposable=S;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return I(i,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new b,y(this),I(this._store,this)}dispose(){_(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&I(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&I(i,null),i}}e.MutableDisposable=c;class f{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class p{constructor(){this.references=new Map}acquire(i,...a){let h=this.references.get(i);h||(h={counter:0,object:this.createReferencedObject(i,...a)},this.references.set(i,h));const{object:u}=h,w=(0,g.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(i,h.object),this.references.delete(i))});return h.counter++,{object:u,dispose:w}}}e.ReferenceCollection=p;class t{constructor(i){this.referenceCollection=i}async acquire(i,...a){const h=this.referenceCollection.acquire(i,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(u){throw h.dispose(),u}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(ge[95],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(C){this.element=C,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let C=this._first;for(;C!==g.Undefined;){const T=C.next;C.prev=g.Undefined,C.next=g.Undefined,C=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const y=new g(C);if(this._first===g.Undefined)this._first=y,this._last=y;else if(T){const I=this._last;this._last=y,y.prev=I,I.next=y}else{const I=this._first;this._first=y,y.next=I,I.prev=y}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==g.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==g.Undefined&&C.next!==g.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===g.Undefined&&C.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):C.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):C.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==g.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(ke,Ce){for(var Te=0;Te<Ce.length;Te++){var le=Ce[Te];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(ke,le.key,le)}}function e(ke,Ce,Te){return Ce&&J(ke.prototype,Ce),Te&&J(ke,Te),ke}function g(ke,Ce){if(!!ke){if(typeof ke=="string")return L(ke,Ce);var Te=Object.prototype.toString.call(ke).slice(8,-1);if(Te==="Object"&&ke.constructor&&(Te=ke.constructor.name),Te==="Map"||Te==="Set")return Array.from(ke);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(ke,Ce)}}function L(ke,Ce){(Ce==null||Ce>ke.length)&&(Ce=ke.length);for(var Te=0,le=new Array(Ce);Te<Ce;Te++)le[Te]=ke[Te];return le}function k(ke,Ce){var Te;if(typeof Symbol=="undefined"||ke[Symbol.iterator]==null){if(Array.isArray(ke)||(Te=g(ke))||Ce&&ke&&typeof ke.length=="number"){Te&&(ke=Te);var le=0;return function(){return le>=ke.length?{done:!0}:{done:!1,value:ke[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Te=ke[Symbol.iterator](),Te.next.bind(Te)}function C(ke){var Ce={exports:{}};return ke(Ce,Ce.exports),Ce.exports}var T=C(function(ke){function Ce(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Te(le){ke.exports.defaults=le}ke.exports={defaults:Ce(),getDefaults:Ce,changeDefaults:Te}}),y=/[&<>"']/,_=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Ce){return A[Ce]};function m(ke,Ce){if(Ce){if(y.test(ke))return ke.replace(_,d)}else if(I.test(ke))return ke.replace(n,d);return ke}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(ke){return ke.replace(l,function(Ce,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var S=/(^|[^\[])\^/g;function b(ke,Ce){ke=ke.source||ke,Ce=Ce||"";var Te={replace:function(ce,ve){return ve=ve.source||ve,ve=ve.replace(S,"$1"),ke=ke.replace(ce,ve),Te},getRegex:function(){return new RegExp(ke,Ce)}};return Te}var P=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(ke,Ce,Te){if(ke){var le;try{le=decodeURIComponent(v(Te)).replace(P,"").toLowerCase()}catch(ce){return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}Ce&&!c.test(Te)&&(Te=i(Ce,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ce){return null}return Te}var p={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(ke,Ce){p[" "+ke]||(t.test(ke)?p[" "+ke]=ke+"/":p[" "+ke]=w(ke,"/",!0)),ke=p[" "+ke];var Te=ke.indexOf(":")===-1;return Ce.substring(0,2)==="//"?Te?Ce:ke.replace(r,"$1")+Ce:Ce.charAt(0)==="/"?Te?Ce:ke.replace(o,"$1")+Ce:ke+Ce}var a={exec:function(){}};function h(ke){for(var Ce=1,Te,le;Ce<arguments.length;Ce++){Te=arguments[Ce];for(le in Te)Object.prototype.hasOwnProperty.call(Te,le)&&(ke[le]=Te[le])}return ke}function u(ke,Ce){var Te=ke.replace(/\|/g,function(ve,Ee,j){for(var be=!1,Se=Ee;--Se>=0&&j[Se]==="\\";)be=!be;return be?"|":" |"}),le=Te.split(/ \|/),ce=0;if(le.length>Ce)le.splice(Ce);else for(;le.length<Ce;)le.push("");for(;ce<le.length;ce++)le[ce]=le[ce].trim().replace(/\\\|/g,"|");return le}function w(ke,Ce,Te){var le=ke.length;if(le===0)return"";for(var ce=0;ce<le;){var ve=ke.charAt(le-ce-1);if(ve===Ce&&!Te)ce++;else if(ve!==Ce&&Te)ce++;else break}return ke.substr(0,le-ce)}function E(ke,Ce){if(ke.indexOf(Ce[1])===-1)return-1;for(var Te=ke.length,le=0,ce=0;ce<Te;ce++)if(ke[ce]==="\\")ce++;else if(ke[ce]===Ce[0])le++;else if(ke[ce]===Ce[1]&&(le--,le<0))return ce;return-1}function s(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(ke,Ce){if(Ce<1)return"";for(var Te="";Ce>1;)Ce&1&&(Te+=ke),Ce>>=1,ke+=ke;return Te+ke}var R={escape:m,unescape:v,edit:b,cleanUrl:f,resolveUrl:i,noopTest:a,merge:h,splitCells:u,rtrim:w,findClosingBracket:E,checkSanitizeDeprecation:s,repeatString:D},U=T.defaults,V=R.rtrim,ee=R.splitCells,Q=R.escape,O=R.findClosingBracket;function x(ke,Ce,Te){var le=Ce.href,ce=Ce.title?Q(Ce.title):null,ve=ke[1].replace(/\\([\[\]])/g,"$1");return ke[0].charAt(0)!=="!"?{type:"link",raw:Te,href:le,title:ce,text:ve}:{type:"image",raw:Te,href:le,title:ce,text:Q(ve)}}function F(ke,Ce){var Te=ke.match(/^(\s+)(?:```)/);if(Te===null)return Ce;var le=Te[1];return Ce.split(`
`).map(function(ce){var ve=ce.match(/^\s+/);if(ve===null)return ce;var Ee=ve[0];return Ee.length>=le.length?ce.slice(le.length):ce}).join(`
`)}var z=function(){function ke(Te){this.options=Te||U}var Ce=ke.prototype;return Ce.space=function(le){var ce=this.rules.block.newline.exec(le);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},Ce.code=function(le){var ce=this.rules.block.code.exec(le);if(ce){var ve=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ve:V(ve,`
`)}}},Ce.fences=function(le){var ce=this.rules.block.fences.exec(le);if(ce){var ve=ce[0],Ee=F(ve,ce[3]||"");return{type:"code",raw:ve,lang:ce[2]?ce[2].trim():ce[2],text:Ee}}},Ce.heading=function(le){var ce=this.rules.block.heading.exec(le);if(ce){var ve=ce[2].trim();if(/#$/.test(ve)){var Ee=V(ve,"#");(this.options.pedantic||!Ee||/ $/.test(Ee))&&(ve=Ee.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ve}}},Ce.nptable=function(le){var ce=this.rules.block.nptable.exec(le);if(ce){var ve={type:"table",header:ee(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[],raw:ce[0]};if(ve.header.length===ve.align.length){var Ee=ve.align.length,j;for(j=0;j<Ee;j++)/^ *-+: *$/.test(ve.align[j])?ve.align[j]="right":/^ *:-+: *$/.test(ve.align[j])?ve.align[j]="center":/^ *:-+ *$/.test(ve.align[j])?ve.align[j]="left":ve.align[j]=null;for(Ee=ve.cells.length,j=0;j<Ee;j++)ve.cells[j]=ee(ve.cells[j],ve.header.length);return ve}}},Ce.hr=function(le){var ce=this.rules.block.hr.exec(le);if(ce)return{type:"hr",raw:ce[0]}},Ce.blockquote=function(le){var ce=this.rules.block.blockquote.exec(le);if(ce){var ve=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],text:ve}}},Ce.list=function(le){var ce=this.rules.block.list.exec(le);if(ce){var ve=ce[0],Ee=ce[2],j=Ee.length>1,be={type:"list",raw:ve,ordered:j,start:j?+Ee.slice(0,-1):"",loose:!1,items:[]},Se=ce[0].match(this.rules.block.item),Ae=!1,Ue,Ge,Ze,Qe,Xe,lt,ht,Et,ot=Se.length;Ze=this.rules.block.listItemStart.exec(Se[0]);for(var at=0;at<ot;at++){if(Ue=Se[at],ve=Ue,at!==ot-1){if(Qe=this.rules.block.listItemStart.exec(Se[at+1]),this.options.pedantic?Qe[1].length>Ze[1].length:Qe[1].length>Ze[0].length||Qe[1].length>3){Se.splice(at,2,Se[at]+`
`+Se[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==Ee[Ee.length-1]:j===(Qe[2].length===1))&&(Xe=Se.slice(at+1).join(`
`),be.raw=be.raw.substring(0,be.raw.length-Xe.length),at=ot-1);Ze=Qe}Ge=Ue.length,Ue=Ue.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ue.indexOf(`
 `)&&(Ge-=Ue.length,Ue=this.options.pedantic?Ue.replace(/^ {1,4}/gm,""):Ue.replace(new RegExp("^ {1,"+Ge+"}","gm"),"")),lt=Ae||/\n\n(?!\s*$)/.test(Ue),at!==ot-1&&(Ae=Ue.charAt(Ue.length-1)===`
`,lt||(lt=Ae)),lt&&(be.loose=!0),this.options.gfm&&(ht=/^\[[ xX]\] /.test(Ue),Et=void 0,ht&&(Et=Ue[1]!==" ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:ve,task:ht,checked:Et,loose:lt,text:Ue})}return be}},Ce.html=function(le){var ce=this.rules.block.html.exec(le);if(ce)return{type:this.options.sanitize?"paragraph":"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):Q(ce[0]):ce[0]}},Ce.def=function(le){var ce=this.rules.block.def.exec(le);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ve=ce[1].toLowerCase().replace(/\s+/g," ");return{tag:ve,raw:ce[0],href:ce[2],title:ce[3]}}},Ce.table=function(le){var ce=this.rules.block.table.exec(le);if(ce){var ve={type:"table",header:ee(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(ve.header.length===ve.align.length){ve.raw=ce[0];var Ee=ve.align.length,j;for(j=0;j<Ee;j++)/^ *-+: *$/.test(ve.align[j])?ve.align[j]="right":/^ *:-+: *$/.test(ve.align[j])?ve.align[j]="center":/^ *:-+ *$/.test(ve.align[j])?ve.align[j]="left":ve.align[j]=null;for(Ee=ve.cells.length,j=0;j<Ee;j++)ve.cells[j]=ee(ve.cells[j].replace(/^ *\| *| *\| *$/g,""),ve.header.length);return ve}}},Ce.lheading=function(le){var ce=this.rules.block.lheading.exec(le);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1]}},Ce.paragraph=function(le){var ce=this.rules.block.paragraph.exec(le);if(ce)return{type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1]}},Ce.text=function(le){var ce=this.rules.block.text.exec(le);if(ce)return{type:"text",raw:ce[0],text:ce[0]}},Ce.escape=function(le){var ce=this.rules.inline.escape.exec(le);if(ce)return{type:"escape",raw:ce[0],text:Q(ce[1])}},Ce.tag=function(le,ce,ve){var Ee=this.rules.inline.tag.exec(le);if(Ee)return!ce&&/^<a /i.test(Ee[0])?ce=!0:ce&&/^<\/a>/i.test(Ee[0])&&(ce=!1),!ve&&/^<(pre|code|kbd|script)(\s|>)/i.test(Ee[0])?ve=!0:ve&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Ee[0])&&(ve=!1),{type:this.options.sanitize?"text":"html",raw:Ee[0],inLink:ce,inRawBlock:ve,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):Q(Ee[0]):Ee[0]}},Ce.link=function(le){var ce=this.rules.inline.link.exec(le);if(ce){var ve=ce[2].trim();if(!this.options.pedantic&&/^</.test(ve)){if(!/>$/.test(ve))return;var Ee=V(ve.slice(0,-1),"\\");if((ve.length-Ee.length)%2==0)return}else{var j=O(ce[2],"()");if(j>-1){var be=ce[0].indexOf("!")===0?5:4,Se=be+ce[1].length+j;ce[2]=ce[2].substring(0,j),ce[0]=ce[0].substring(0,Se).trim(),ce[3]=""}}var Ae=ce[2],Ue="";if(this.options.pedantic){var Ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ge&&(Ae=Ge[1],Ue=Ge[3])}else Ue=ce[3]?ce[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ve)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),x(ce,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},ce[0])}},Ce.reflink=function(le,ce){var ve;if((ve=this.rules.inline.reflink.exec(le))||(ve=this.rules.inline.nolink.exec(le))){var Ee=(ve[2]||ve[1]).replace(/\s+/g," ");if(Ee=ce[Ee.toLowerCase()],!Ee||!Ee.href){var j=ve[0].charAt(0);return{type:"text",raw:j,text:j}}return x(ve,Ee,ve[0])}},Ce.emStrong=function(le,ce,ve){ve===void 0&&(ve="");var Ee=this.rules.inline.emStrong.lDelim.exec(le);if(!!Ee&&!(Ee[3]&&ve.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=Ee[1]||Ee[2]||"";if(!j||j&&(ve===""||this.rules.inline.punctuation.exec(ve))){var be=Ee[0].length-1,Se,Ae,Ue=be,Ge=0,Ze=Ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,ce=ce.slice(-1*le.length+be);(Ee=Ze.exec(ce))!=null;)if(Se=Ee[1]||Ee[2]||Ee[3]||Ee[4]||Ee[5]||Ee[6],!!Se){if(Ae=Se.length,Ee[3]||Ee[4]){Ue+=Ae;continue}else if((Ee[5]||Ee[6])&&be%3&&!((be+Ae)%3)){Ge+=Ae;continue}if(Ue-=Ae,!(Ue>0)){if(Ue+Ge-Ae<=0&&!ce.slice(Ze.lastIndex).match(Ze)&&(Ae=Math.min(Ae,Ae+Ue+Ge)),Math.min(be,Ae)%2)return{type:"em",raw:le.slice(0,be+Ee.index+Ae+1),text:le.slice(1,be+Ee.index+Ae)};if(Math.min(be,Ae)%2==0)return{type:"strong",raw:le.slice(0,be+Ee.index+Ae+1),text:le.slice(2,be+Ee.index+Ae-1)}}}}}},Ce.codespan=function(le){var ce=this.rules.inline.code.exec(le);if(ce){var ve=ce[2].replace(/\n/g," "),Ee=/[^ ]/.test(ve),j=/^ /.test(ve)&&/ $/.test(ve);return Ee&&j&&(ve=ve.substring(1,ve.length-1)),ve=Q(ve,!0),{type:"codespan",raw:ce[0],text:ve}}},Ce.br=function(le){var ce=this.rules.inline.br.exec(le);if(ce)return{type:"br",raw:ce[0]}},Ce.del=function(le){var ce=this.rules.inline.del.exec(le);if(ce)return{type:"del",raw:ce[0],text:ce[2]}},Ce.autolink=function(le,ce){var ve=this.rules.inline.autolink.exec(le);if(ve){var Ee,j;return ve[2]==="@"?(Ee=Q(this.options.mangle?ce(ve[1]):ve[1]),j="mailto:"+Ee):(Ee=Q(ve[1]),j=Ee),{type:"link",raw:ve[0],text:Ee,href:j,tokens:[{type:"text",raw:Ee,text:Ee}]}}},Ce.url=function(le,ce){var ve;if(ve=this.rules.inline.url.exec(le)){var Ee,j;if(ve[2]==="@")Ee=Q(this.options.mangle?ce(ve[0]):ve[0]),j="mailto:"+Ee;else{var be;do be=ve[0],ve[0]=this.rules.inline._backpedal.exec(ve[0])[0];while(be!==ve[0]);Ee=Q(ve[0]),ve[1]==="www."?j="http://"+Ee:j=Ee}return{type:"link",raw:ve[0],text:Ee,href:j,tokens:[{type:"text",raw:Ee,text:Ee}]}}},Ce.inlineText=function(le,ce,ve){var Ee=this.rules.inline.text.exec(le);if(Ee){var j;return ce?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):Q(Ee[0]):Ee[0]:j=Q(this.options.smartypants?ve(Ee[0]):Ee[0]),{type:"text",raw:Ee[0],text:j}}},ke}(),M=R.noopTest,N=R.edit,q=R.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=N(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=N(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=N(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=N(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=N(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=N(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=N(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=q({},B),B.gfm=q({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=N(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=N(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=q({},B.normal,{html:N(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:N(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=N(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=N(B._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=N(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=N(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=N(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=N(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=N(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=N(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=N(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=N(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=q({},K),K.pedantic=q({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:N(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:N(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=q({},K.normal,{escape:N(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=N(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=q({},K.gfm,{br:N(K.br).replace("{2,}","*").getRegex(),text:N(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var te={block:B,inline:K},he=T.defaults,De=te.block,Pe=te.inline,Fe=R.repeatString;function qe(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function We(ke){var Ce="",Te,le,ce=ke.length;for(Te=0;Te<ce;Te++)le=ke.charCodeAt(Te),Math.random()>.5&&(le="x"+le.toString(16)),Ce+="&#"+le+";";return Ce}var je=function(){function ke(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||he,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var le={block:De.normal,inline:Pe.normal};this.options.pedantic?(le.block=De.pedantic,le.inline=Pe.pedantic):this.options.gfm&&(le.block=De.gfm,this.options.breaks?le.inline=Pe.breaks:le.inline=Pe.gfm),this.tokenizer.rules=le}ke.lex=function(le,ce){var ve=new ke(ce);return ve.lex(le)},ke.lexInline=function(le,ce){var ve=new ke(ce);return ve.inlineTokens(le)};var Ce=ke.prototype;return Ce.lex=function(le){return le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens,!0),this.inline(this.tokens),this.tokens},Ce.blockTokens=function(le,ce,ve){ce===void 0&&(ce=[]),ve===void 0&&(ve=!0),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var Ee,j,be,Se;le;){if(Ee=this.tokenizer.space(le)){le=le.substring(Ee.raw.length),Ee.type&&ce.push(Ee);continue}if(Ee=this.tokenizer.code(le)){le=le.substring(Ee.raw.length),Se=ce[ce.length-1],Se&&Se.type==="paragraph"?(Se.raw+=`
`+Ee.raw,Se.text+=`
`+Ee.text):ce.push(Ee);continue}if(Ee=this.tokenizer.fences(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.heading(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.nptable(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.hr(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.blockquote(le)){le=le.substring(Ee.raw.length),Ee.tokens=this.blockTokens(Ee.text,[],ve),ce.push(Ee);continue}if(Ee=this.tokenizer.list(le)){for(le=le.substring(Ee.raw.length),be=Ee.items.length,j=0;j<be;j++)Ee.items[j].tokens=this.blockTokens(Ee.items[j].text,[],!1);ce.push(Ee);continue}if(Ee=this.tokenizer.html(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(ve&&(Ee=this.tokenizer.def(le))){le=le.substring(Ee.raw.length),this.tokens.links[Ee.tag]||(this.tokens.links[Ee.tag]={href:Ee.href,title:Ee.title});continue}if(Ee=this.tokenizer.table(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.lheading(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(ve&&(Ee=this.tokenizer.paragraph(le))){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.text(le)){le=le.substring(Ee.raw.length),Se=ce[ce.length-1],Se&&Se.type==="text"?(Se.raw+=`
`+Ee.raw,Se.text+=`
`+Ee.text):ce.push(Ee);continue}if(le){var Ae="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ce},Ce.inline=function(le){var ce,ve,Ee,j,be,Se,Ae=le.length;for(ce=0;ce<Ae;ce++)switch(Se=le[ce],Se.type){case"paragraph":case"text":case"heading":{Se.tokens=[],this.inlineTokens(Se.text,Se.tokens);break}case"table":{for(Se.tokens={header:[],cells:[]},j=Se.header.length,ve=0;ve<j;ve++)Se.tokens.header[ve]=[],this.inlineTokens(Se.header[ve],Se.tokens.header[ve]);for(j=Se.cells.length,ve=0;ve<j;ve++)for(be=Se.cells[ve],Se.tokens.cells[ve]=[],Ee=0;Ee<be.length;Ee++)Se.tokens.cells[ve][Ee]=[],this.inlineTokens(be[Ee],Se.tokens.cells[ve][Ee]);break}case"blockquote":{this.inline(Se.tokens);break}case"list":{for(j=Se.items.length,ve=0;ve<j;ve++)this.inline(Se.items[ve].tokens);break}}return le},Ce.inlineTokens=function(le,ce,ve,Ee){ce===void 0&&(ce=[]),ve===void 0&&(ve=!1),Ee===void 0&&(Ee=!1);var j,be,Se=le,Ae,Ue,Ge;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)Ze.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ae.index)+"["+Fe("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"["+Fe("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;){if(Ue||(Ge=""),Ue=!1,j=this.tokenizer.escape(le)){le=le.substring(j.raw.length),ce.push(j);continue}if(j=this.tokenizer.tag(le,ve,Ee)){le=le.substring(j.raw.length),ve=j.inLink,Ee=j.inRawBlock;var Qe=ce[ce.length-1];Qe&&j.type==="text"&&Qe.type==="text"?(Qe.raw+=j.raw,Qe.text+=j.text):ce.push(j);continue}if(j=this.tokenizer.link(le)){le=le.substring(j.raw.length),j.type==="link"&&(j.tokens=this.inlineTokens(j.text,[],!0,Ee)),ce.push(j);continue}if(j=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(j.raw.length);var Xe=ce[ce.length-1];j.type==="link"?(j.tokens=this.inlineTokens(j.text,[],!0,Ee),ce.push(j)):Xe&&j.type==="text"&&Xe.type==="text"?(Xe.raw+=j.raw,Xe.text+=j.text):ce.push(j);continue}if(j=this.tokenizer.emStrong(le,Se,Ge)){le=le.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],ve,Ee),ce.push(j);continue}if(j=this.tokenizer.codespan(le)){le=le.substring(j.raw.length),ce.push(j);continue}if(j=this.tokenizer.br(le)){le=le.substring(j.raw.length),ce.push(j);continue}if(j=this.tokenizer.del(le)){le=le.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],ve,Ee),ce.push(j);continue}if(j=this.tokenizer.autolink(le,We)){le=le.substring(j.raw.length),ce.push(j);continue}if(!ve&&(j=this.tokenizer.url(le,We))){le=le.substring(j.raw.length),ce.push(j);continue}if(j=this.tokenizer.inlineText(le,Ee,qe)){le=le.substring(j.raw.length),j.raw.slice(-1)!=="_"&&(Ge=j.raw.slice(-1)),Ue=!0,be=ce[ce.length-1],be&&be.type==="text"?(be.raw+=j.raw,be.text+=j.text):ce.push(j);continue}if(le){var lt="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return ce},e(ke,null,[{key:"rules",get:function(){return{block:De,inline:Pe}}}]),ke}(),W=T.defaults,Z=R.cleanUrl,ne=R.escape,ae=function(){function ke(Te){this.options=Te||W}var Ce=ke.prototype;return Ce.code=function(le,ce,ve){var Ee=(ce||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(le,Ee);j!=null&&j!==le&&(ve=!0,le=j)}return le=le.replace(/\n$/,"")+`
`,Ee?'<pre><code class="'+this.options.langPrefix+ne(Ee,!0)+'">'+(ve?le:ne(le,!0))+`</code></pre>
`:"<pre><code>"+(ve?le:ne(le,!0))+`</code></pre>
`},Ce.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},Ce.html=function(le){return le},Ce.heading=function(le,ce,ve,Ee){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+Ee.slug(ve)+'">'+le+"</h"+ce+`>
`:"<h"+ce+">"+le+"</h"+ce+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(le,ce,ve){var Ee=ce?"ol":"ul",j=ce&&ve!==1?' start="'+ve+'"':"";return"<"+Ee+j+`>
`+le+"</"+Ee+`>
`},Ce.listitem=function(le){return"<li>"+le+`</li>
`},Ce.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(le){return"<p>"+le+`</p>
`},Ce.table=function(le,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+ce+`</table>
`},Ce.tablerow=function(le){return`<tr>
`+le+`</tr>
`},Ce.tablecell=function(le,ce){var ve=ce.header?"th":"td",Ee=ce.align?"<"+ve+' align="'+ce.align+'">':"<"+ve+">";return Ee+le+"</"+ve+`>
`},Ce.strong=function(le){return"<strong>"+le+"</strong>"},Ce.em=function(le){return"<em>"+le+"</em>"},Ce.codespan=function(le){return"<code>"+le+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(le){return"<del>"+le+"</del>"},Ce.link=function(le,ce,ve){if(le=Z(this.options.sanitize,this.options.baseUrl,le),le===null)return ve;var Ee='<a href="'+ne(le)+'"';return ce&&(Ee+=' title="'+ce+'"'),Ee+=">"+ve+"</a>",Ee},Ce.image=function(le,ce,ve){if(le=Z(this.options.sanitize,this.options.baseUrl,le),le===null)return ve;var Ee='<img src="'+le+'" alt="'+ve+'"';return ce&&(Ee+=' title="'+ce+'"'),Ee+=this.options.xhtml?"/>":">",Ee},Ce.text=function(le){return le},ke}(),Y=function(){function ke(){}var Ce=ke.prototype;return Ce.strong=function(le){return le},Ce.em=function(le){return le},Ce.codespan=function(le){return le},Ce.del=function(le){return le},Ce.html=function(le){return le},Ce.text=function(le){return le},Ce.link=function(le,ce,ve){return""+ve},Ce.image=function(le,ce,ve){return""+ve},Ce.br=function(){return""},ke}(),oe=function(){function ke(){this.seen={}}var Ce=ke.prototype;return Ce.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(le,ce){var ve=le,Ee=0;if(this.seen.hasOwnProperty(ve)){Ee=this.seen[le];do Ee++,ve=le+"-"+Ee;while(this.seen.hasOwnProperty(ve))}return ce||(this.seen[le]=Ee,this.seen[ve]=0),ve},Ce.slug=function(le,ce){ce===void 0&&(ce={});var ve=this.serialize(le);return this.getNextSafeSlug(ve,ce.dryrun)},ke}(),we=T.defaults,Me=R.unescape,Ve=function(){function ke(Te){this.options=Te||we,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new oe}ke.parse=function(le,ce){var ve=new ke(ce);return ve.parse(le)},ke.parseInline=function(le,ce){var ve=new ke(ce);return ve.parseInline(le)};var Ce=ke.prototype;return Ce.parse=function(le,ce){ce===void 0&&(ce=!0);var ve="",Ee,j,be,Se,Ae,Ue,Ge,Ze,Qe,Xe,lt,ht,Et,ot,at,Dt,ye,fe,ue=le.length;for(Ee=0;Ee<ue;Ee++)switch(Xe=le[Ee],Xe.type){case"space":continue;case"hr":{ve+=this.renderer.hr();continue}case"heading":{ve+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,Me(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{ve+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(Ze="",Ge="",Se=Xe.header.length,j=0;j<Se;j++)Ge+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[j]),{header:!0,align:Xe.align[j]});for(Ze+=this.renderer.tablerow(Ge),Qe="",Se=Xe.cells.length,j=0;j<Se;j++){for(Ue=Xe.tokens.cells[j],Ge="",Ae=Ue.length,be=0;be<Ae;be++)Ge+=this.renderer.tablecell(this.parseInline(Ue[be]),{header:!1,align:Xe.align[be]});Qe+=this.renderer.tablerow(Ge)}ve+=this.renderer.table(Ze,Qe);continue}case"blockquote":{Qe=this.parse(Xe.tokens),ve+=this.renderer.blockquote(Qe);continue}case"list":{for(lt=Xe.ordered,ht=Xe.start,Et=Xe.loose,Se=Xe.items.length,Qe="",j=0;j<Se;j++)at=Xe.items[j],Dt=at.checked,ye=at.task,ot="",at.task&&(fe=this.renderer.checkbox(Dt),Et?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=fe+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=fe+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:fe}):ot+=fe),ot+=this.parse(at.tokens,Et),Qe+=this.renderer.listitem(ot,ye,Dt);ve+=this.renderer.list(Qe,lt,ht);continue}case"html":{ve+=this.renderer.html(Xe.text);continue}case"paragraph":{ve+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for(Qe=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;Ee+1<ue&&le[Ee+1].type==="text";)Xe=le[++Ee],Qe+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);ve+=ce?this.renderer.paragraph(Qe):Qe;continue}default:{var G='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}return ve},Ce.parseInline=function(le,ce){ce=ce||this.renderer;var ve="",Ee,j,be=le.length;for(Ee=0;Ee<be;Ee++)switch(j=le[Ee],j.type){case"escape":{ve+=ce.text(j.text);break}case"html":{ve+=ce.html(j.text);break}case"link":{ve+=ce.link(j.href,j.title,this.parseInline(j.tokens,ce));break}case"image":{ve+=ce.image(j.href,j.title,j.text);break}case"strong":{ve+=ce.strong(this.parseInline(j.tokens,ce));break}case"em":{ve+=ce.em(this.parseInline(j.tokens,ce));break}case"codespan":{ve+=ce.codespan(j.text);break}case"br":{ve+=ce.br();break}case"del":{ve+=ce.del(this.parseInline(j.tokens,ce));break}case"text":{ve+=ce.text(j.text);break}default:{var Se='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(Se);return}else throw new Error(Se)}}return ve},ke}(),_e=R.merge,Je=R.checkSanitizeDeprecation,X=R.escape,re=T.getDefaults,me=T.changeDefaults,xe=T.defaults;function Be(ke,Ce,Te){if(typeof ke=="undefined"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof Ce=="function"&&(Te=Ce,Ce=null),Ce=_e({},Be.defaults,Ce||{}),Je(Ce),Te){var le=Ce.highlight,ce;try{ce=je.lex(ke,Ce)}catch(be){return Te(be)}var ve=function(Se){var Ae;if(!Se)try{Ae=Ve.parse(ce,Ce)}catch(Ue){Se=Ue}return Ce.highlight=le,Se?Te(Se):Te(null,Ae)};if(!le||le.length<3||(delete Ce.highlight,!ce.length))return ve();var Ee=0;Be.walkTokens(ce,function(be){be.type==="code"&&(Ee++,setTimeout(function(){le(be.text,be.lang,function(Se,Ae){if(Se)return ve(Se);Ae!=null&&Ae!==be.text&&(be.text=Ae,be.escaped=!0),Ee--,Ee===0&&ve()})},0))}),Ee===0&&ve();return}try{var j=je.lex(ke,Ce);return Ce.walkTokens&&Be.walkTokens(j,Ce.walkTokens),Ve.parse(j,Ce)}catch(be){if(be.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+X(be.message+"",!0)+"</pre>";throw be}}Be.options=Be.setOptions=function(ke){return _e(Be.defaults,ke),me(Be.defaults),Be},Be.getDefaults=re,Be.defaults=xe,Be.use=function(ke){var Ce=_e({},ke);if(ke.renderer&&function(){var le=Be.defaults.renderer||new ae,ce=function(j){var be=le[j];le[j]=function(){for(var Se=arguments.length,Ae=new Array(Se),Ue=0;Ue<Se;Ue++)Ae[Ue]=arguments[Ue];var Ge=ke.renderer[j].apply(le,Ae);return Ge===!1&&(Ge=be.apply(le,Ae)),Ge}};for(var ve in ke.renderer)ce(ve);Ce.renderer=le}(),ke.tokenizer&&function(){var le=Be.defaults.tokenizer||new z,ce=function(j){var be=le[j];le[j]=function(){for(var Se=arguments.length,Ae=new Array(Se),Ue=0;Ue<Se;Ue++)Ae[Ue]=arguments[Ue];var Ge=ke.tokenizer[j].apply(le,Ae);return Ge===!1&&(Ge=be.apply(le,Ae)),Ge}};for(var ve in ke.tokenizer)ce(ve);Ce.tokenizer=le}(),ke.walkTokens){var Te=Be.defaults.walkTokens;Ce.walkTokens=function(le){ke.walkTokens(le),Te&&Te(le)}}Be.setOptions(Ce)},Be.walkTokens=function(ke,Ce){for(var Te=k(ke),le;!(le=Te()).done;){var ce=le.value;switch(Ce(ce),ce.type){case"table":{for(var ve=k(ce.tokens.header),Ee;!(Ee=ve()).done;){var j=Ee.value;Be.walkTokens(j,Ce)}for(var be=k(ce.tokens.cells),Se;!(Se=be()).done;)for(var Ae=Se.value,Ue=k(Ae),Ge;!(Ge=Ue()).done;){var Ze=Ge.value;Be.walkTokens(Ze,Ce)}break}case"list":{Be.walkTokens(ce.items,Ce);break}default:ce.tokens&&Be.walkTokens(ce.tokens,Ce)}}},Be.parseInline=function(ke,Ce){if(typeof ke=="undefined"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");Ce=_e({},Be.defaults,Ce||{}),Je(Ce);try{var Te=je.lexInline(ke,Ce);return Ce.walkTokens&&Be.walkTokens(Te,Ce.walkTokens),Ve.parseInline(Te,Ce)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+X(le.message+"",!0)+"</pre>";throw le}},Be.Parser=Ve,Be.parser=Ve.parse,Be.Renderer=ae,Be.TextRenderer=Y,Be.Lexer=je,Be.lexer=je.lex,Be.Tokenizer=z,Be.Slugger=oe,Be.parse=Be;var et=Be;return et}),define(ge[75],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,y,_){return Math.min(Math.max(T,y),_)}e.clamp=g;function L(T,y){return(y+T%y)%y}e.rot=L;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class C{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function J(k){const C=[];typeof k=="number"&&C.push("code/timeOrigin",k);function T(_){C.push(_,Date.now())}function y(){const _=[];for(let I=0;I<C.length;I+=2)_.push({name:C[I],startTime:C[I+1]});return _}return{mark:T,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(k+T.startTime)});return C}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function g(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(ge[11],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,k=!1,C=!1,T=!1,y=!1,_=!1,I=!1,n,A=g,d,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const v=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=v&&l?.sandboxed,typeof navigator=="object"&&!v)m=navigator.userAgent,L=m.indexOf("Windows")>=0,k=m.indexOf("Macintosh")>=0,I=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,_=!0,n=navigator.language,A=n;else if(typeof l=="object"){L=l.platform==="win32",k=l.platform==="darwin",C=l.platform==="linux",T=C&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,n=g,A=g;const o=l.env.VSCODE_NLS_CONFIG;if(o)try{const i=JSON.parse(o),a=i.availableLanguages["*"];n=i.locale,A=a||g,d=i._translationsConfigFile}catch(i){}y=!0}else console.error("Unable to resolve platform.");var S;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function b(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let P=0;k?P=1:L?P=3:C&&(P=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=C,e.isLinuxSnap=T,e.isNative=y,e.isWeb=_,e.isIOS=I,e.platform=P,e.userAgent=m,e.language=A;var c;(function(o){function i(){return e.language}o.value=i;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=a;function h(){return e.language==="en"}o.isDefault=h})(c=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let w=0,E=a.length;w<E;w++){const s=a[w];if(s.id===u.data.vscodeSetImmediateId){a.splice(w,1),s.callback();return}}});let h=0;return u=>{const w=++h;a.push({id:w,callback:u}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const i=Promise.resolve();return a=>i.then(a)}();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||I?2:L?1:3;let p=!0,t=!1;function r(){if(!t){t=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,p=new Uint16Array(o.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=r}),define(ge[38],pe([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const k=g.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(C){return(0,g.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(k){return(0,g.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(ge[9],pe([0,1,38]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,C=90,T=122,y=46,_=47,I=92,n=58,A=63;class d extends Error{constructor(f,p,t){let r;typeof p=="string"&&p.indexOf("not ")===0?(r="must not be",p=p.replace(/^not /,"")):r="must be";const o=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${o} ${r} of type ${p}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,f){if(typeof c!="string")throw new d(f,"string",c)}function l(c){return c===_||c===I}function v(c){return c===_}function S(c){return c>=L&&c<=C||c>=k&&c<=T}function b(c,f,p,t){let r="",o=0,i=-1,a=0,h=0;for(let u=0;u<=c.length;++u){if(u<c.length)h=c.charCodeAt(u);else{if(t(h))break;h=_}if(t(h)){if(!(i===u-1||a===1))if(a===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const w=r.lastIndexOf(p);w===-1?(r="",o=0):(r=r.slice(0,w),o=r.length-1-r.lastIndexOf(p)),i=u,a=0;continue}else if(r.length!==0){r="",o=0,i=u,a=0;continue}}f&&(r+=r.length>0?`${p}..`:"..",o=2)}else r.length>0?r+=`${p}${c.slice(i+1,u)}`:r=c.slice(i+1,u),o=u-i-1;i=u,a=0}else h===y&&a!==-1?++a:a=-1}return r}function P(c,f){if(f===null||typeof f!="object")throw new d("pathObject","Object",f);const p=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return p?p===f.root?`${p}${t}`:`${p}${c}${t}`:t}e.win32={resolve(...c){let f="",p="",t=!1;for(let r=c.length-1;r>=-1;r--){let o;if(r>=0){if(o=c[r],m(o,"path"),o.length===0)continue}else f.length===0?o=g.cwd():(o=g.env[`=${f}`]||g.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==f.toLowerCase()&&o.charCodeAt(2)===I)&&(o=`${f}\\`));const i=o.length;let a=0,h="",u=!1;const w=o.charCodeAt(0);if(i===1)l(w)&&(a=1,u=!0);else if(l(w))if(u=!0,l(o.charCodeAt(1))){let E=2,s=E;for(;E<i&&!l(o.charCodeAt(E));)E++;if(E<i&&E!==s){const D=o.slice(s,E);for(s=E;E<i&&l(o.charCodeAt(E));)E++;if(E<i&&E!==s){for(s=E;E<i&&!l(o.charCodeAt(E));)E++;(E===i||E!==s)&&(h=`\\\\${D}\\${o.slice(s,E)}`,a=E)}}}else a=1;else S(w)&&o.charCodeAt(1)===n&&(h=o.slice(0,2),a=2,i>2&&l(o.charCodeAt(2))&&(u=!0,a=3));if(h.length>0)if(f.length>0){if(h.toLowerCase()!==f.toLowerCase())continue}else f=h;if(t){if(f.length>0)break}else if(p=`${o.slice(a)}\\${p}`,t=u,u&&f.length>0)break}return p=b(p,!t,"\\",l),t?`${f}\\${p}`:`${f}${p}`||"."},normalize(c){m(c,"path");const f=c.length;if(f===0)return".";let p=0,t,r=!1;const o=c.charCodeAt(0);if(f===1)return v(o)?"\\":c;if(l(o))if(r=!0,l(c.charCodeAt(1))){let a=2,h=a;for(;a<f&&!l(c.charCodeAt(a));)a++;if(a<f&&a!==h){const u=c.slice(h,a);for(h=a;a<f&&l(c.charCodeAt(a));)a++;if(a<f&&a!==h){for(h=a;a<f&&!l(c.charCodeAt(a));)a++;if(a===f)return`\\\\${u}\\${c.slice(h)}\\`;a!==h&&(t=`\\\\${u}\\${c.slice(h,a)}`,p=a)}}}else p=1;else S(o)&&c.charCodeAt(1)===n&&(t=c.slice(0,2),p=2,f>2&&l(c.charCodeAt(2))&&(r=!0,p=3));let i=p<f?b(c.slice(p),!r,"\\",l):"";return i.length===0&&!r&&(i="."),i.length>0&&l(c.charCodeAt(f-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(c){m(c,"path");const f=c.length;if(f===0)return!1;const p=c.charCodeAt(0);return l(p)||f>2&&S(p)&&c.charCodeAt(1)===n&&l(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let f,p;for(let o=0;o<c.length;++o){const i=c[o];m(i,"path"),i.length>0&&(f===void 0?f=p=i:f+=`\\${i}`)}if(f===void 0)return".";let t=!0,r=0;if(typeof p=="string"&&l(p.charCodeAt(0))){++r;const o=p.length;o>1&&l(p.charCodeAt(1))&&(++r,o>2&&(l(p.charCodeAt(2))?++r:t=!1))}if(t){for(;r<f.length&&l(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(c,f){if(m(c,"from"),m(f,"to"),c===f)return"";const p=e.win32.resolve(c),t=e.win32.resolve(f);if(p===t||(c=p.toLowerCase(),f=t.toLowerCase(),c===f))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===I;)r++;let o=c.length;for(;o-1>r&&c.charCodeAt(o-1)===I;)o--;const i=o-r;let a=0;for(;a<f.length&&f.charCodeAt(a)===I;)a++;let h=f.length;for(;h-1>a&&f.charCodeAt(h-1)===I;)h--;const u=h-a,w=i<u?i:u;let E=-1,s=0;for(;s<w;s++){const R=c.charCodeAt(r+s);if(R!==f.charCodeAt(a+s))break;R===I&&(E=s)}if(s!==w){if(E===-1)return t}else{if(u>w){if(f.charCodeAt(a+s)===I)return t.slice(a+s+1);if(s===2)return t.slice(a+s)}i>w&&(c.charCodeAt(r+s)===I?E=s:s===2&&(E=3)),E===-1&&(E=0)}let D="";for(s=r+E+1;s<=o;++s)(s===o||c.charCodeAt(s)===I)&&(D+=D.length===0?"..":"\\..");return a+=E,D.length>0?`${D}${t.slice(a,h)}`:(t.charCodeAt(a)===I&&++a,t.slice(a,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const f=e.win32.resolve(c);if(f.length<=2)return c;if(f.charCodeAt(0)===I){if(f.charCodeAt(1)===I){const p=f.charCodeAt(2);if(p!==A&&p!==y)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(S(f.charCodeAt(0))&&f.charCodeAt(1)===n&&f.charCodeAt(2)===I)return`\\\\?\\${f}`;return c},dirname(c){m(c,"path");const f=c.length;if(f===0)return".";let p=-1,t=0;const r=c.charCodeAt(0);if(f===1)return l(r)?c:".";if(l(r)){if(p=t=1,l(c.charCodeAt(1))){let a=2,h=a;for(;a<f&&!l(c.charCodeAt(a));)a++;if(a<f&&a!==h){for(h=a;a<f&&l(c.charCodeAt(a));)a++;if(a<f&&a!==h){for(h=a;a<f&&!l(c.charCodeAt(a));)a++;if(a===f)return c;a!==h&&(p=t=a+1)}}}}else S(r)&&c.charCodeAt(1)===n&&(p=f>2&&l(c.charCodeAt(2))?3:2,t=p);let o=-1,i=!0;for(let a=f-1;a>=t;--a)if(l(c.charCodeAt(a))){if(!i){o=a;break}}else i=!1;if(o===-1){if(p===-1)return".";o=p}return c.slice(0,o)},basename(c,f){f!==void 0&&m(f,"ext"),m(c,"path");let p=0,t=-1,r=!0,o;if(c.length>=2&&S(c.charCodeAt(0))&&c.charCodeAt(1)===n&&(p=2),f!==void 0&&f.length>0&&f.length<=c.length){if(f===c)return"";let i=f.length-1,a=-1;for(o=c.length-1;o>=p;--o){const h=c.charCodeAt(o);if(l(h)){if(!r){p=o+1;break}}else a===-1&&(r=!1,a=o+1),i>=0&&(h===f.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=a))}return p===t?t=a:t===-1&&(t=c.length),c.slice(p,t)}for(o=c.length-1;o>=p;--o)if(l(c.charCodeAt(o))){if(!r){p=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(p,t)},extname(c){m(c,"path");let f=0,p=-1,t=0,r=-1,o=!0,i=0;c.length>=2&&c.charCodeAt(1)===n&&S(c.charCodeAt(0))&&(f=t=2);for(let a=c.length-1;a>=f;--a){const h=c.charCodeAt(a);if(l(h)){if(!o){t=a+1;break}continue}r===-1&&(o=!1,r=a+1),h===y?p===-1?p=a:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||r===-1||i===0||i===1&&p===r-1&&p===t+1?"":c.slice(p,r)},format:P.bind(null,"\\"),parse(c){m(c,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return f;const p=c.length;let t=0,r=c.charCodeAt(0);if(p===1)return l(r)?(f.root=f.dir=c,f):(f.base=f.name=c,f);if(l(r)){if(t=1,l(c.charCodeAt(1))){let E=2,s=E;for(;E<p&&!l(c.charCodeAt(E));)E++;if(E<p&&E!==s){for(s=E;E<p&&l(c.charCodeAt(E));)E++;if(E<p&&E!==s){for(s=E;E<p&&!l(c.charCodeAt(E));)E++;E===p?t=E:E!==s&&(t=E+1)}}}}else if(S(r)&&c.charCodeAt(1)===n){if(p<=2)return f.root=f.dir=c,f;if(t=2,l(c.charCodeAt(2))){if(p===3)return f.root=f.dir=c,f;t=3}}t>0&&(f.root=c.slice(0,t));let o=-1,i=t,a=-1,h=!0,u=c.length-1,w=0;for(;u>=t;--u){if(r=c.charCodeAt(u),l(r)){if(!h){i=u+1;break}continue}a===-1&&(h=!1,a=u+1),r===y?o===-1?o=u:w!==1&&(w=1):o!==-1&&(w=-1)}return a!==-1&&(o===-1||w===0||w===1&&o===a-1&&o===i+1?f.base=f.name=c.slice(i,a):(f.name=c.slice(i,o),f.base=c.slice(i,a),f.ext=c.slice(o,a))),i>0&&i!==t?f.dir=c.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let f="",p=!1;for(let t=c.length-1;t>=-1&&!p;t--){const r=t>=0?c[t]:g.cwd();m(r,"path"),r.length!==0&&(f=`${r}/${f}`,p=r.charCodeAt(0)===_)}return f=b(f,!p,"/",v),p?`/${f}`:f.length>0?f:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const f=c.charCodeAt(0)===_,p=c.charCodeAt(c.length-1)===_;return c=b(c,!f,"/",v),c.length===0?f?"/":p?"./":".":(p&&(c+="/"),f?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===_},join(...c){if(c.length===0)return".";let f;for(let p=0;p<c.length;++p){const t=c[p];m(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(c,f){if(m(c,"from"),m(f,"to"),c===f||(c=e.posix.resolve(c),f=e.posix.resolve(f),c===f))return"";const p=1,t=c.length,r=t-p,o=1,i=f.length-o,a=r<i?r:i;let h=-1,u=0;for(;u<a;u++){const E=c.charCodeAt(p+u);if(E!==f.charCodeAt(o+u))break;E===_&&(h=u)}if(u===a)if(i>a){if(f.charCodeAt(o+u)===_)return f.slice(o+u+1);if(u===0)return f.slice(o+u)}else r>a&&(c.charCodeAt(p+u)===_?h=u:u===0&&(h=0));let w="";for(u=p+h+1;u<=t;++u)(u===t||c.charCodeAt(u)===_)&&(w+=w.length===0?"..":"/..");return`${w}${f.slice(o+h)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const f=c.charCodeAt(0)===_;let p=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===_){if(!t){p=r;break}}else t=!1;return p===-1?f?"/":".":f&&p===1?"//":c.slice(0,p)},basename(c,f){f!==void 0&&m(f,"ext"),m(c,"path");let p=0,t=-1,r=!0,o;if(f!==void 0&&f.length>0&&f.length<=c.length){if(f===c)return"";let i=f.length-1,a=-1;for(o=c.length-1;o>=0;--o){const h=c.charCodeAt(o);if(h===_){if(!r){p=o+1;break}}else a===-1&&(r=!1,a=o+1),i>=0&&(h===f.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=a))}return p===t?t=a:t===-1&&(t=c.length),c.slice(p,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===_){if(!r){p=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(p,t)},extname(c){m(c,"path");let f=-1,p=0,t=-1,r=!0,o=0;for(let i=c.length-1;i>=0;--i){const a=c.charCodeAt(i);if(a===_){if(!r){p=i+1;break}continue}t===-1&&(r=!1,t=i+1),a===y?f===-1?f=i:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||t===-1||o===0||o===1&&f===t-1&&f===p+1?"":c.slice(f,t)},format:P.bind(null,"/"),parse(c){m(c,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return f;const p=c.charCodeAt(0)===_;let t;p?(f.root="/",t=1):t=0;let r=-1,o=0,i=-1,a=!0,h=c.length-1,u=0;for(;h>=t;--h){const w=c.charCodeAt(h);if(w===_){if(!a){o=h+1;break}continue}i===-1&&(a=!1,i=h+1),w===y?r===-1?r=h:u!==1&&(u=1):r!==-1&&(u=-1)}if(i!==-1){const w=o===0&&p?1:o;r===-1||u===0||u===1&&r===i-1&&r===o+1?f.base=f.name=c.slice(w,i):(f.name=c.slice(w,r),f.base=c.slice(w,i),f.ext=c.slice(r,i))}return o>0?f.dir=c.slice(0,o-1):p&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[140],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(C,...T){const y=T.reduce((n,A)=>(n[A]=!0,n),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!y[n]).forEach(n=>{for(let A=0;A<_.length;A++)if(n.search(_[A])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=k}),define(ge[46],pe([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class k{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ge[3],pe([0,1,16,72,6,95,46]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(c){c.None=()=>k.Disposable.None;function f(Q){return(O,x=null,F)=>{let z=!1,M;return M=Q(N=>{if(!z)return M?M.dispose():z=!0,O.call(x,N)},null,F),z&&M.dispose(),M}}c.once=f;function p(Q,O){return h((x,F=null,z)=>Q(M=>x.call(F,O(M)),null,z))}c.map=p;function t(Q,O){return h((x,F=null,z)=>Q(M=>{O(M),x.call(F,M)},null,z))}c.forEach=t;function r(Q,O){return h((x,F=null,z)=>Q(M=>O(M)&&x.call(F,M),null,z))}c.filter=r;function o(Q){return Q}c.signal=o;function i(...Q){return(O,x=null,F)=>(0,k.combinedDisposable)(...Q.map(z=>z(M=>O.call(x,M),null,F)))}c.any=i;function a(Q,O,x){let F=x;return p(Q,z=>(F=O(F,z),F))}c.reduce=a;function h(Q){let O;const x=new d({onFirstListenerAdd(){O=Q(x.fire,x)},onLastListenerRemove(){O.dispose()}});return x.event}function u(Q,O,x=100,F=!1,z){let M,N,q,B=0;const K=new d({leakWarningThreshold:z,onFirstListenerAdd(){M=Q(te=>{B++,N=O(N,te),F&&!q&&(K.fire(N),N=void 0),clearTimeout(q),q=setTimeout(()=>{const he=N;N=void 0,q=void 0,(!F||B>1)&&K.fire(he),B=0},x)})},onLastListenerRemove(){M.dispose()}});return K.event}c.debounce=u;function w(Q,O=(x,F)=>x===F){let x=!0,F;return r(Q,z=>{const M=x||!O(z,F);return x=!1,F=z,M})}c.latch=w;function E(Q,O){return[c.filter(Q,O),c.filter(Q,x=>!O(x))]}c.split=E;function s(Q,O=!1,x=[]){let F=x.slice(),z=Q(q=>{F?F.push(q):N.fire(q)});const M=()=>{F&&F.forEach(q=>N.fire(q)),F=null},N=new d({onFirstListenerAdd(){z||(z=Q(q=>N.fire(q)))},onFirstListenerDidAdd(){F&&(O?setTimeout(M):M())},onLastListenerRemove(){z&&z.dispose(),z=null}});return N.event}c.buffer=s;class D{constructor(O){this.event=O}map(O){return new D(p(this.event,O))}forEach(O){return new D(t(this.event,O))}filter(O){return new D(r(this.event,O))}reduce(O,x){return new D(a(this.event,O,x))}latch(){return new D(w(this.event))}debounce(O,x=100,F=!1,z){return new D(u(this.event,O,x,F,z))}on(O,x,F){return this.event(O,x,F)}once(O,x,F){return f(this.event)(O,x,F)}}function R(Q){return new D(Q)}c.chain=R;function U(Q,O,x=F=>F){const F=(...q)=>N.fire(x(...q)),z=()=>Q.on(O,F),M=()=>Q.removeListener(O,F),N=new d({onFirstListenerAdd:z,onLastListenerRemove:M});return N.event}c.fromNodeEventEmitter=U;function V(Q,O,x=F=>F){const F=(...q)=>N.fire(x(...q)),z=()=>Q.addEventListener(O,F),M=()=>Q.removeEventListener(O,F),N=new d({onFirstListenerAdd:z,onLastListenerRemove:M});return N.event}c.fromDOMEventEmitter=V;function ee(Q){return new Promise(O=>f(Q)(O))}c.toPromise=ee})(y=e.Event||(e.Event={}));class _{constructor(f){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${f}_${_._idPool++}`}start(f){this._stopWatch=new T.StopWatch(!0),this._listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this._elapsedOverall+=f,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${f.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let I=-1;function n(c){const f=I;return I=c,{dispose(){I=f}}}e.setGlobalLeakWarningThreshold=n;class A{constructor(f,p=Math.random().toString(18).slice(2,5)){this.customThreshold=f,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(f){let p=I;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||f<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let o,i=0;for(const[a,h]of this._stacks)(!o||i<h)&&(o=a,i=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${i}):`),console.warn(o)}return()=>{const o=this._stacks.get(t)||0;this._stacks.set(t,o-1)}}}class d{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=I>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(f,p,t)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(p?[f,p]:f);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,f,p);const i=this._leakageMon?.check(this._listeners.size),a=(0,k.toDisposable)(()=>{i&&i(),this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,f]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class m extends d{async fireAsync(f,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,f]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[r,o]=this._asyncDeliveryQueue.shift(),i=[],a={...o,waitUntil:h=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(h=t(h,typeof r=="function"?r:r[0])),i.push(h)}};try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(h){(0,g.onUnexpectedError)(h);continue}Object.freeze(i),await Promise.allSettled(i).then(h=>{for(const u of h)u.status==="rejected"&&(0,g.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=m;class l extends d{constructor(f){super(f);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=l;class v extends l{constructor(f){super(f);this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=v;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const p={event:f,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const r=this.events.indexOf(p);this.events.splice(r,1)};return(0,k.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(p=>this.emitter.fire(p))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class b{constructor(){this.buffers=[]}wrapEvent(f){return(p,t,r)=>f(o=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(t,o)):p.call(t,o)},void 0,r)}bufferEvents(f){const p=[];this.buffers.push(p);const t=f();return this.buffers.pop(),p.forEach(r=>r()),t}}e.EventBufferer=b;class P{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=k.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(ge[21],pe([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(y,_){const I=setTimeout(y.bind(_),0);return{dispose(){clearTimeout(I)}}});var k;(function(y){function _(I){return I===y.None||I===y.Cancelled||I instanceof C?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}y.isCancellationToken=_,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=k.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(ge[47],pe([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(A){const d=this._icons.get(A.id);d?A.description?d.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function C(n,A){return new y(n,A)}e.registerCodicon=C;function T(n){return n?n.replace(/\$\((.*?)\)/g,(A,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=T;class y{constructor(A,d,m){this.id=A,this.definition=d,this.description=m,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function _(n,A){const d=["codicon","codicon-"+n];return A&&d.push("codicon-modifier-"+A),d}e.getClassNamesArray=_;var I;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(v){if(v instanceof y)return["codicon","codicon-"+v.id];const S=A.exec(v.id);if(!S)return d(y.error);let[,b,P]=S;const c=["codicon","codicon-"+b];return P&&c.push("codicon-modifier-"+P.substr(1)),c}n.asClassNameArray=d;function m(v){return d(v).join(" ")}n.asClassName=m;function l(v){return"."+d(v).join(".")}n.asCSSSelector=l})(I=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(ge[96],pe([0,1,16,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(c){const f=c;return f?[f.on,f.pause,f.resume,f.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=k;function C(c){const f=c;return f?k(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(c,f){return new y(c,f)}e.newWriteableStream=T;class y{constructor(f,p){this.reducer=f,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(p=>p(f))}emitError(f){this.listeners.error.length===0?(0,g.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(p=>p(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,p){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(f,p){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(p);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(c,f){const p=[];let t;for(;(t=c.read())!==null;)p.push(t);return f(p)}e.consumeReadable=_;function I(c,f,p){const t=[];let r;for(;(r=c.read())!==null&&t.length<p;)t.push(r);return r===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const o=r;return r=void 0,o}return c.read()}}}e.peekReadable=I;function n(c,f){return new Promise((p,t)=>{const r=[];A(c,{onData:o=>{f&&r.push(o)},onError:o=>{f?t(o):p(void 0)},onEnd:()=>{p(f?f(r):void 0)}})})}e.consumeStream=n;function A(c,f){c.on("error",p=>f.onError(p)),c.on("end",()=>f.onEnd()),c.on("data",p=>f.onData(p))}e.listenStream=A;function d(c,f){return new Promise((p,t)=>{const r=new L.DisposableStore,o=[],i=u=>{if(o.push(u),o.length>f)return r.dispose(),c.pause(),p({stream:c,buffer:o,ended:!1})},a=u=>t(u),h=()=>p({stream:c,buffer:o,ended:!0});r.add((0,L.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),r.add((0,L.toDisposable)(()=>c.removeListener("end",h))),c.on("end",h),r.add((0,L.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=d;function m(c,f){const p=T(f);return p.end(c),p}e.toStream=m;function l(){const c=T(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=l;function v(c){let f=!1;return{read:()=>f?null:(f=!0,c)}}e.toReadable=v;function S(c,f,p){const t=T(p);return A(c,{onData:r=>t.write(f.data(r)),onError:r=>t.error(f.error?f.error(r):r),onEnd:()=>t.end()}),t}e.transform=S;function b(c,f,p){let t=!1;return{read:()=>{const r=f.read();return t?r:(t=!0,r!==null?p([c,r]):c)}}}e.prefixedReadable=b;function P(c,f,p){let t=!1;const r=T(p);return A(f,{onData:o=>t?r.write(o):(t=!0,r.write(p([c,o]))),onError:o=>r.error(o),onEnd:()=>{t||(t=!0,r.write(c)),r.end()}}),r}e.prefixedStream=P}),define(ge[8],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function k(j,...be){return be.length===0?j:j.replace(L,function(Se,Ae){const Ue=parseInt(Ae,10);return isNaN(Ue)||Ue<0||Ue>=be.length?Se:be[Ue]})}e.format=k;const C=/{([^}]+)}/g;function T(j,be){return j.replace(C,(Se,Ae)=>be[Ae]??Se)}e.format2=T;function y(j){return j.replace(/[<>&]/g,function(be){switch(be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return be}})}e.escape=y;function _(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function I(j,be){let Se=0;const Ae=be.charCodeAt(0);for(let Ue=j.length-1;Ue>=0;Ue--)j.charCodeAt(Ue)===Ae&&Se++;return Se}e.count=I;function n(j,be,Se="\u2026"){return j.length<=be?j:`${j.substr(0,be)}${Se}`}e.truncate=n;function A(j,be=" "){const Se=d(j,be);return m(Se,be)}e.trim=A;function d(j,be){if(!j||!be)return j;const Se=be.length;if(Se===0||j.length===0)return j;let Ae=0;for(;j.indexOf(be,Ae)===Ae;)Ae=Ae+Se;return j.substring(Ae)}e.ltrim=d;function m(j,be){if(!j||!be)return j;const Se=be.length,Ae=j.length;if(Se===0||Ae===0)return j;let Ue=Ae,Ge=-1;for(;Ge=j.lastIndexOf(be,Ue-1),!(Ge===-1||Ge+Se!==Ue);){if(Ge===0)return"";Ue=Ge}return j.substring(0,Ue)}e.rtrim=m;function l(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function v(j){return j.replace(/\*/g,"")}e.stripWildcards=v;function S(j,be,Se={}){if(!j)throw new Error("Cannot create regex from empty string");be||(j=_(j)),Se.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let Ae="";return Se.global&&(Ae+="g"),Se.matchCase||(Ae+="i"),Se.multiline&&(Ae+="m"),Se.unicode&&(Ae+="u"),new RegExp(j,Ae)}e.createRegExp=S;function b(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function P(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function c(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=c;function f(j){return j.split(/\r\n|\r|\n/)}e.splitLines=f;function p(j){for(let be=0,Se=j.length;be<Se;be++){const Ae=j.charCodeAt(be);if(Ae!==32&&Ae!==9)return be}return-1}e.firstNonWhitespaceIndex=p;function t(j,be=0,Se=j.length){for(let Ae=be;Ae<Se;Ae++){const Ue=j.charCodeAt(Ae);if(Ue!==32&&Ue!==9)return j.substring(be,Ae)}return j.substring(be,Se)}e.getLeadingWhitespace=t;function r(j,be=j.length-1){for(let Se=be;Se>=0;Se--){const Ae=j.charCodeAt(Se);if(Ae!==32&&Ae!==9)return Se}return-1}e.lastNonWhitespaceIndex=r;function o(j,be){return j<be?-1:j>be?1:0}e.compare=o;function i(j,be,Se=0,Ae=j.length,Ue=0,Ge=be.length){for(;Se<Ae&&Ue<Ge;Se++,Ue++){let Xe=j.charCodeAt(Se),lt=be.charCodeAt(Ue);if(Xe<lt)return-1;if(Xe>lt)return 1}const Ze=Ae-Se,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstring=i;function a(j,be){return h(j,be,0,j.length,0,be.length)}e.compareIgnoreCase=a;function h(j,be,Se=0,Ae=j.length,Ue=0,Ge=be.length){for(;Se<Ae&&Ue<Ge;Se++,Ue++){let Xe=j.charCodeAt(Se),lt=be.charCodeAt(Ue);if(Xe===lt)continue;const ht=Xe-lt;if(!(ht===32&&w(lt))&&!(ht===-32&&w(Xe)))return u(Xe)&&u(lt)?ht:i(j.toLowerCase(),be.toLowerCase(),Se,Ae,Ue,Ge)}const Ze=Ae-Se,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstringIgnoreCase=h;function u(j){return j>=97&&j<=122}e.isLowerAsciiLetter=u;function w(j){return j>=65&&j<=90}e.isUpperAsciiLetter=w;function E(j){return u(j)||w(j)}function s(j,be){return j.length===be.length&&D(j,be)}e.equalsIgnoreCase=s;function D(j,be,Se=j.length){for(let Ae=0;Ae<Se;Ae++){const Ue=j.charCodeAt(Ae),Ge=be.charCodeAt(Ae);if(Ue!==Ge){if(E(Ue)&&E(Ge)){const Ze=Math.abs(Ue-Ge);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Ue).toLowerCase()!==String.fromCharCode(Ge).toLowerCase())return!1}}return!0}function R(j,be){const Se=be.length;return be.length>j.length?!1:D(j,be,Se)}e.startsWithIgnoreCase=R;function U(j,be){let Se,Ae=Math.min(j.length,be.length);for(Se=0;Se<Ae;Se++)if(j.charCodeAt(Se)!==be.charCodeAt(Se))return Se;return Ae}e.commonPrefixLength=U;function V(j,be){let Se,Ae=Math.min(j.length,be.length);const Ue=j.length-1,Ge=be.length-1;for(Se=0;Se<Ae;Se++)if(j.charCodeAt(Ue-Se)!==be.charCodeAt(Ge-Se))return Se;return Ae}e.commonSuffixLength=V;function ee(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ee;function Q(j){return 56320<=j&&j<=57343}e.isLowSurrogate=Q;function O(j,be){return(j-55296<<10)+(be-56320)+65536}e.computeCodePoint=O;function x(j,be,Se){const Ae=j.charCodeAt(Se);if(ee(Ae)&&Se+1<be){const Ue=j.charCodeAt(Se+1);if(Q(Ue))return O(Ae,Ue)}return Ae}e.getNextCodePoint=x;function F(j,be){const Se=j.charCodeAt(be-1);if(Q(Se)&&be>1){const Ae=j.charCodeAt(be-2);if(ee(Ae))return O(Ae,Se)}return Se}function z(j,be){const Se=ke.getInstance(),Ae=be,Ue=j.length,Ge=x(j,Ue,be);be+=Ge>=65536?2:1;let Ze=Se.getGraphemeBreakType(Ge);for(;be<Ue;){const Qe=x(j,Ue,be),Xe=Se.getGraphemeBreakType(Qe);if(Be(Ze,Xe))break;be+=Qe>=65536?2:1,Ze=Xe}return be-Ae}e.nextCharLength=z;function M(j,be){const Se=ke.getInstance(),Ae=be,Ue=F(j,be);be-=Ue>=65536?2:1;let Ge=Se.getGraphemeBreakType(Ue);for(;be>0;){const Ze=F(j,be),Qe=Se.getGraphemeBreakType(Ze);if(Be(Qe,Ge))break;be-=Ze>=65536?2:1,Ge=Qe}return Ae-be}e.prevCharLength=M;function N(j,be){const Se=ke.getInstance(),Ae=j.length,Ue=be,Ge=x(j,Ae,be),Ze=Se.getGraphemeBreakType(Ge);be+=Ge>=65536?2:1;let Qe=Ze;for(;be<Ae;){const lt=x(j,Ae,be),ht=Se.getGraphemeBreakType(lt);if(Be(Qe,ht))break;be+=lt>=65536?2:1,Qe=ht}const Xe=be;for(be=Ue,Qe=Ze;be>0;){const lt=F(j,be),ht=Se.getGraphemeBreakType(lt);if(Be(ht,Qe))break;be-=lt>=65536?2:1,Qe=ht}return[be,Xe]}function q(j,be){return be>0&&Q(j.charCodeAt(be))?N(j,be-1):N(j,be)}e.getCharContainingOffset=q;function B(j){const be=j.length;let Se=0,Ae=0;for(;Ae<be;){const Ze=x(j,be,Ae);Ae+=Ze>=65536?2:1,Ze<128?Se+=1:Ze<2048?Se+=2:Ze<65536?Se+=3:Se+=4}const Ue=new Uint8Array(Se);Ae=0;let Ge=0;for(;Ae<be;){const Ze=x(j,be,Ae);Ae+=Ze>=65536?2:1,Ze<128?Ue[Ge++]=Ze:Ze<2048?(Ue[Ge++]=192|(Ze&1984)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):Ze<65536?(Ue[Ge++]=224|(Ze&61440)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):(Ue[Ge++]=240|(Ze&1835008)>>>18,Ue[Ge++]=128|(Ze&258048)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0)}return Ue}e.encodeUTF8=B;function K(j){const be=j.byteLength,Se=[];let Ae=0;for(;Ae<be;){const Ue=j[Ae];let Ge;if(Ue>=240&&Ae+3<be?Ge=(j[Ae++]&7)<<18>>>0|(j[Ae++]&63)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=224&&Ae+2<be?Ge=(j[Ae++]&15)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=192&&Ae+1<be?Ge=(j[Ae++]&31)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ge=j[Ae++],Ge>=0&&Ge<=55295||Ge>=57344&&Ge<=65535)Se.push(String.fromCharCode(Ge));else if(Ge>=65536&&Ge<=1114111){const Ze=Ge-65536,Qe=55296+((Ze&1047552)>>>10),Xe=56320+((Ze&1023)>>>0);Se.push(String.fromCharCode(Qe)),Se.push(String.fromCharCode(Xe))}else Se.push(String.fromCharCode(65533))}return Se.join("")}e.decodeUTF8=K;const te=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function he(j){return te.test(j)}e.containsRTL=he;const De=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Pe(j){return De.test(j)}e.containsEmoji=Pe;const Fe=/^[\t\n\r\x20-\x7E]*$/;function qe(j){return Fe.test(j)}e.isBasicASCII=qe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=We;function je(j){for(let be=0,Se=j.length;be<Se;be++)if(W(j.charCodeAt(be)))return!0;return!1}e.containsFullWidthCharacter=je;function W(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=W;function Z(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=Z;function ne(j,be){if(j.length<be)return j;const Se=/\b/g;let Ae=0;for(;Se.test(j)&&!(j.length-Se.lastIndex<be);)Ae=Se.lastIndex,Se.lastIndex+=1;return j.substring(Ae).replace(/^\s/,"")}e.lcut=ne;const ae=/\x1B\x5B[12]?K/g,Y=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function we(j){return j&&(j=j.replace(ae,""),j=j.replace(Y,""),j=j.replace(oe,"")),j}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function Ve(j){return Me(j)?j.substr(1):j}e.stripUTF8BOM=Ve;function _e(j,be){if(!j||!be||j.length<be.length)return!1;const Se=be.length,Ae=j.toLowerCase();let Ue=0,Ge=-1;for(;Ue<Se;){const Ze=Ae.indexOf(be[Ue],Ge+1);if(Ze<0)return!1;Ge=Ze,Ue++}return!0}e.fuzzyContains=_e;function Je(j,be=!1){return j?(be&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=Je;function X(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=X;function re(j,be=1){if(be===0)return"";let Se=-1;do Se=j.indexOf(`
`,Se+1),be--;while(be>0&&Se>=0);return Se===-1?j:(j[Se-1]==="\r"&&Se--,j.substr(0,Se))}e.getNLines=re;function me(j){const be=90-65+1;return j=j%(2*be),j<be?String.fromCharCode(97+j):String.fromCharCode(65+j-be)}e.singleLetterHash=me;function xe(j){return ke.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=xe;function Be(j,be){return j===0?be!==5&&be!==7:j===2&&be===3?!1:j===4||j===2||j===3||be===4||be===2||be===3?!0:!(j===8&&(be===8||be===9||be===11||be===12)||(j===11||j===9)&&(be===9||be===10)||(j===12||j===10)&&be===10||be===5||be===13||be===7||j===1||j===13&&be===14||j===6&&be===6)}e.breakBetweenGraphemeBreakType=Be;var et;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ke{constructor(){this._data=Ce()}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}getGraphemeBreakType(be){if(be<32)return be===10?3:be===13?2:4;if(be<127)return 0;const Se=this._data,Ae=Se.length/3;let Ue=1;for(;Ue<=Ae;)if(be<Se[3*Ue])Ue=2*Ue;else if(be>Se[3*Ue+1])Ue=2*Ue+1;else return Se[3*Ue+2];return 0}}ke._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Te(j,be){if(j===0)return 0;const Se=le(j,be);if(Se!==void 0)return Se;const Ae=F(be,j);return j-=ce(Ae),j}e.getLeftDeleteOffset=Te;function le(j,be){let Se=F(be,j);for(j-=ce(Se);ve(Se)||Se===65039||Se===8419;){if(j===0)return;Se=F(be,j),j-=ce(Se)}if(!!Z(Se)){if(j>=0){const Ae=F(be,j);Ae===8205&&(j-=ce(Ae))}return j}}function ce(j){return j>=65536?2:1}function ve(j){return 127995<=j&&j<=127999}var Ee;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(Ee||(Ee={}))}),define(ge[24],pe([0,1,96,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",C=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let y,_;class I{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return k?new I(Buffer.allocUnsafe(u)):new I(new Uint8Array(u))}static wrap(u){return k&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new I(u)}static fromString(u,w){return!(w?.dontUseNodeBuffer||!1)&&k?new I(Buffer.from(u)):C?(y||(y=new TextEncoder),new I(y.encode(u))):new I(L.encodeUTF8(u))}static concat(u,w){if(typeof w=="undefined"){w=0;for(let D=0,R=u.length;D<R;D++)w+=u[D].byteLength}const E=I.alloc(w);let s=0;for(let D=0,R=u.length;D<R;D++){const U=u[D];E.set(U,s),s+=U.byteLength}return E}toString(){return k?this.buffer.toString():T?(_||(_=new TextDecoder),_.decode(this.buffer)):L.decodeUTF8(this.buffer)}slice(u,w){return new I(this.buffer.subarray(u,w))}set(u,w){u instanceof I?this.buffer.set(u.buffer,w):this.buffer.set(u,w)}readUInt32BE(u){return d(this.buffer,u)}writeUInt32BE(u,w){m(this.buffer,u,w)}readUInt32LE(u){return l(this.buffer,u)}writeUInt32LE(u,w){v(this.buffer,u,w)}readUInt8(u){return S(this.buffer,u)}writeUInt8(u,w){b(this.buffer,u,w)}}e.VSBuffer=I;function n(h,u){return h[u+0]<<0>>>0|h[u+1]<<8>>>0}e.readUInt16LE=n;function A(h,u,w){h[w+0]=u&255,u=u>>>8,h[w+1]=u&255}e.writeUInt16LE=A;function d(h,u){return h[u]*2**24+h[u+1]*2**16+h[u+2]*2**8+h[u+3]}e.readUInt32BE=d;function m(h,u,w){h[w+3]=u,u=u>>>8,h[w+2]=u,u=u>>>8,h[w+1]=u,u=u>>>8,h[w]=u}e.writeUInt32BE=m;function l(h,u){return h[u+0]<<0>>>0|h[u+1]<<8>>>0|h[u+2]<<16>>>0|h[u+3]<<24>>>0}e.readUInt32LE=l;function v(h,u,w){h[w+0]=u&255,u=u>>>8,h[w+1]=u&255,u=u>>>8,h[w+2]=u&255,u=u>>>8,h[w+3]=u&255}e.writeUInt32LE=v;function S(h,u){return h[u]}e.readUInt8=S;function b(h,u,w){h[w]=u}e.writeUInt8=b;function P(h){return g.consumeReadable(h,u=>I.concat(u))}e.readableToBuffer=P;function c(h){return g.toReadable(h)}e.bufferToReadable=c;function f(h){return g.consumeStream(h,u=>I.concat(u))}e.streamToBuffer=f;async function p(h){return h.ended?I.concat(h.buffer):I.concat([...h.buffer,await f(h.stream)])}e.bufferedStreamToBuffer=p;function t(h){return g.toStream(h,u=>I.concat(u))}e.bufferToStream=t;function r(h){return g.transform(h,{data:u=>typeof u=="string"?I.fromString(u):I.wrap(u)},u=>I.concat(u))}e.streamToBufferReadableStream=r;function o(h){return g.newWriteableStream(u=>I.concat(u),h)}e.newWriteableBufferStream=o;function i(h,u){return g.prefixedReadable(h,u,w=>I.concat(w))}e.prefixedBufferReadable=i;function a(h,u){return g.prefixedStream(h,u,w=>I.concat(w))}e.prefixedBufferStream=a}),define(ge[58],pe([0,1,8]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(b){return k(b,0)}e.hash=L;function k(b,P){switch(typeof b){case"object":return b===null?C(349,P):Array.isArray(b)?_(b,P):I(b,P);case"string":return y(b,P);case"boolean":return T(b,P);case"number":return C(b,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=k;function C(b,P){return(P<<5)-P+b|0}function T(b,P){return C(b?433:863,P)}function y(b,P){P=C(149417,P);for(let c=0,f=b.length;c<f;c++)P=C(b.charCodeAt(c),P);return P}e.stringHash=y;function _(b,P){return P=C(104579,P),b.reduce((c,f)=>k(f,c),P)}function I(b,P){return P=C(181387,P),Object.keys(b).sort().reduce((c,f)=>(c=y(f,c),k(b[f],c)),P)}class n{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=k(P,this._value),this._value}}e.Hasher=n;var A;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function d(b,P,c=32){const f=c-P,p=~((1<<f)-1);return(b<<P|(p&b)>>>f)>>>0}function m(b,P=0,c=b.byteLength,f=0){for(let p=0;p<c;p++)b[P+p]=f}function l(b,P,c="0"){for(;b.length<P;)b=c+b;return b}function v(b,P=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(c=>c.toString(16).padStart(2,"0")).join(""):l((b>>>0).toString(16),P/4)}e.toHexString=v;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const f=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=P.charCodeAt(0),o=0);;){let i=r;if(g.isHighSurrogate(r))if(o+1<c){const a=P.charCodeAt(o+1);g.isLowSurrogate(a)?(o++,i=g.computeCodePoint(r,a)):i=65533}else{t=r;break}else g.isLowSurrogate(r)&&(i=65533);if(p=this._push(f,p,i),o++,o<c)r=P.charCodeAt(o);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(P,c,f){return f<128?P[c++]=f:f<2048?(P[c++]=192|(f&1984)>>>6,P[c++]=128|(f&63)>>>0):f<65536?(P[c++]=224|(f&61440)>>>12,P[c++]=128|(f&4032)>>>6,P[c++]=128|(f&63)>>>0):(P[c++]=240|(f&1835008)>>>18,P[c++]=128|(f&258048)>>>12,P[c++]=128|(f&4032)>>>6,P[c++]=128|(f&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=S._bigBlock32,c=this._buffDV;for(let u=0;u<64;u+=4)P.setUint32(u,c.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)P.setUint32(u,d(P.getUint32(u-12,!1)^P.getUint32(u-32,!1)^P.getUint32(u-56,!1)^P.getUint32(u-64,!1),1),!1);let f=this._h0,p=this._h1,t=this._h2,r=this._h3,o=this._h4,i,a,h;for(let u=0;u<80;u++)u<20?(i=p&t|~p&r,a=1518500249):u<40?(i=p^t^r,a=1859775393):u<60?(i=p&t|p&r|t&r,a=2400959708):(i=p^t^r,a=3395469782),h=d(f,5)+i+o+a+P.getUint32(u*4,!1)&4294967295,o=r,r=t,t=d(p,30),p=f,f=h;this._h0=this._h0+f&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[48],pe([0,1,8]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const C="error",T="warning",y="warn",_="info",I="ignore";function n(d){return d?g.equalsIgnoreCase(C,d)?k.Error:g.equalsIgnoreCase(T,d)||g.equalsIgnoreCase(y,d)?k.Warning:g.equalsIgnoreCase(_,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=n;function A(d){switch(d){case k.Error:return C;case k.Warning:return T;case k.Info:return _;default:return I}}k.toString=A}(L||(L={})),e.default=L}),define(ge[14],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(u){return Array.isArray(u)}e.isArray=g;function L(u){return typeof u=="string"}e.isString=L;function k(u){return Array.isArray(u)&&u.every(w=>L(w))}e.isStringArray=k;function C(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=C;function T(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=T;function y(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=y;function _(u){return u===!0||u===!1}e.isBoolean=_;function I(u){return typeof u=="undefined"}e.isUndefined=I;function n(u){return!A(u)}e.isDefined=n;function A(u){return I(u)||u===null}e.isUndefinedOrNull=A;function d(u,w){if(!u)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=d;function m(u){if(A(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=m;function l(...u){const w=[];for(let E=0;E<u.length;E++){const s=u[E];if(A(s))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);w.push(s)}return w}e.assertAllDefined=l;const v=Object.prototype.hasOwnProperty;function S(u){if(!C(u))return!1;for(let w in u)if(v.call(u,w))return!1;return!0}e.isEmptyObject=S;function b(u){return typeof u=="function"}e.isFunction=b;function P(...u){return u.length>0&&u.every(b)}e.areFunctions=P;function c(u,w){const E=Math.min(u.length,w.length);for(let s=0;s<E;s++)f(u[s],w[s])}e.validateConstraints=c;function f(u,w){if(L(w)){if(typeof u!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(b(w)){try{if(u instanceof w)return}catch{}if(!A(u)&&u.constructor===w||w.length===1&&w.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function p(u){let w=[],E=Object.getPrototypeOf(u);for(;Object.prototype!==E;)w=w.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return w}e.getAllPropertyNames=p;function t(u){const w=[];for(const E of p(u))typeof u[E]=="function"&&w.push(E);return w}e.getAllMethodNames=t;function r(u,w){const E=D=>function(){const R=Array.prototype.slice.call(arguments,0);return w(D,R)};let s={};for(const D of u)s[D]=E(D);return s}e.createProxyObject=r;function o(u){return u===null?void 0:u}e.withNullAsUndefined=o;function i(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=i;function a(u){return class{constructor(){return new Proxy({},{get(w,E){if(w[E])return w[E];throw new Error(`Not Implemented: ${u}->${String(E)}`)}})}}}e.NotImplementedProxy=a;function h(u,w="Unreachable"){throw new Error(w)}e.assertNever=h}),define(ge[29],pe([0,1,9,11,8,14]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function y(o){return o.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=y;function _(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=_;function I(o,i=g.posix.sep){if(!o)return"";const a=o.length,h=o.charCodeAt(0);if(T(h)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let w=3;const E=w;for(;w<a&&!T(o.charCodeAt(w));w++);if(E!==w&&!T(o.charCodeAt(w+1))){for(w+=1;w<a;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(b(h)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+i:o.slice(0,2);let u=o.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(T(o.charCodeAt(u)))return o.slice(0,u+1)}return""}e.getRoot=I;function n(o){if(!L.isWindows||!o||o.length<5)return!1;let i=o.charCodeAt(0);if(i!==92||(i=o.charCodeAt(1),i!==92))return!1;let a=2;const h=a;for(;a<o.length&&(i=o.charCodeAt(a),i!==92);a++);return!(h===a||(i=o.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(o,i=L.isWindows){const a=i?A:d;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||i&&m.test(o)||o==="."||o===".."||i&&o[o.length-1]==="."||i&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=l;function v(o,i,a){const h=o===i;return!a||h?h:!o||!i?!1:(0,k.equalsIgnoreCase)(o,i)}e.isEqual=v;function S(o,i,a,h=g.sep){if(o===i)return!0;if(!o||!i||i.length>o.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(o,i))return!1;if(i.length===o.length)return!0;let w=i.length;return i.charAt(i.length-1)===h&&w--,o.charAt(w)===h}return i.charAt(i.length-1)!==h&&(i+=h),o.indexOf(i)===0}e.isEqualOrParent=S;function b(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=b;function P(o,i){return L.isWindows&&o.endsWith(":")&&(o+=g.sep),(0,g.isAbsolute)(o)||(o=(0,g.join)(i,o)),o=(0,g.normalize)(o),L.isWindows?(o=(0,k.rtrim)(o,g.sep),o.endsWith(":")&&(o+=g.sep)):(o=(0,k.rtrim)(o,g.sep),o||(o=g.sep)),o}e.sanitizeFilePath=P;function c(o){const i=(0,g.normalize)(o);return L.isWindows?o.length>3?!1:f(i)&&(o.length===2||i.charCodeAt(2)===92):i===g.posix.sep}e.isRootOrDriveLetter=c;function f(o){return L.isWindows?b(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function p(o){return f(o)?o[0]:void 0}e.getDriveLetter=p;function t(o,i,a){return i.length>o.length?-1:o===i?0:(a&&(o=o.toLowerCase(),i=i.toLowerCase()),o.indexOf(i))}e.indexOfPath=t;function r(o){const i=o.split(":");let a,h,u;if(i.forEach(w=>{const E=Number(w);(0,C.isNumber)(E)?h===void 0?h=E:u===void 0&&(u=E):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:u!==void 0?u:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(ge[25],pe([0,1,14]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const S=Array.isArray(v)?[]:{};return Object.keys(v).forEach(b=>{v[b]&&typeof v[b]=="object"?S[b]=L(v[b]):S[b]=v[b]}),S}e.deepClone=L;function k(v){if(!v||typeof v!="object")return v;const S=[v];for(;S.length>0;){const b=S.shift();Object.freeze(b);for(const P in b)if(C.call(b,P)){const c=b[P];typeof c=="object"&&!Object.isFrozen(c)&&S.push(c)}}return v}e.deepFreeze=k;const C=Object.prototype.hasOwnProperty;function T(v,S){return y(v,S,new Set)}e.cloneAndChange=T;function y(v,S,b){if((0,g.isUndefinedOrNull)(v))return v;const P=S(v);if(typeof P!="undefined")return P;if((0,g.isArray)(v)){const c=[];for(const f of v)c.push(y(f,S,b));return c}if((0,g.isObject)(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const c={};for(let f in v)C.call(v,f)&&(c[f]=y(v[f],S,b));return b.delete(v),c}return v}function _(v,S,b=!0){return(0,g.isObject)(v)?((0,g.isObject)(S)&&Object.keys(S).forEach(P=>{P in v?b&&((0,g.isObject)(v[P])&&(0,g.isObject)(S[P])?_(v[P],S[P],b):v[P]=S[P]):v[P]=S[P]}),v):S}e.mixin=_;function I(v,S){if(v===S)return!0;if(v==null||S===null||S===void 0||typeof v!=typeof S||typeof v!="object"||Array.isArray(v)!==Array.isArray(S))return!1;let b,P;if(Array.isArray(v)){if(v.length!==S.length)return!1;for(b=0;b<v.length;b++)if(!I(v[b],S[b]))return!1}else{const c=[];for(P in v)c.push(P);c.sort();const f=[];for(P in S)f.push(P);if(f.sort(),!I(c,f))return!1;for(b=0;b<c.length;b++)if(!I(v[c[b]],S[c[b]]))return!1}return!0}e.equals=I;function n(v){const S=new Set;return JSON.stringify(v,(b,P)=>{if((0,g.isObject)(P)||Array.isArray(P)){if(S.has(P))return"[Circular]";S.add(P)}return P})}e.safeStringify=n;function A(v,S,b){const P=S(v);return typeof P=="undefined"?b:P}e.getOrDefault=A;function d(v,S){const b=Object.create(null);return!v||!S||Object.keys(S).forEach(c=>{const f=v[c],p=S[c];I(f,p)||(b[c]=p)}),b}e.distinct=d;function m(v,S){const b=S.toLowerCase(),P=Object.keys(v).find(c=>c.toLowerCase()===b);return P?v[P]:v[S]}e.getCaseInsensitive=m;function l(v,S){const b=Object.create(null);for(const P of Object.keys(v))S(P,v[P])&&(b[P]=v[P]);return b}e.filter=l}),define(ge[97],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function k(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=k}),define(ge[2],pe([0,1,9,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function y(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!k.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!C.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(o,i){return!o&&!i?"file":o}function I(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==A&&(i=A+i):i=A;break}return i}const n="",A="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,a,h,u,w,E=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=_(i,E),this.authority=a||n,this.path=I(this.scheme,h||n),this.query=u||n,this.fragment=w||n,y(this,E))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:h,path:u,query:w,fragment:E}=i;return a===void 0?a=this.scheme:a===null&&(a=n),h===void 0?h=this.authority:h===null&&(h=n),u===void 0?u=this.path:u===null&&(u=n),w===void 0?w=this.query:w===null&&(w=n),E===void 0?E=this.fragment:E===null&&(E=n),a===this.scheme&&h===this.authority&&u===this.path&&w===this.query&&E===this.fragment?this:new v(a,h,u,w,E)}static parse(i,a=!1){const h=d.exec(i);return h?new v(h[2]||n,r(h[4]||n),r(h[5]||n),r(h[7]||n),r(h[9]||n),a):new v(n,n,n,n,n)}static file(i){let a=n;if(L.isWindows&&(i=i.replace(/\\/g,A)),i[0]===A&&i[1]===A){const h=i.indexOf(A,2);h===-1?(a=i.substring(2),i=A):(a=i.substring(2,h),i=i.substring(h)||A)}return new v("file",a,i,n,n)}static from(i){const a=new v(i.scheme,i.authority,i.path,i.query,i.fragment);return y(a,!0),a}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return L.isWindows&&i.scheme==="file"?h=m.file(g.win32.join(c(i,!0),...a)).path:h=g.posix.join(i.path,...a),i.with({path:h})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const a=new v(i);return a._formatted=i.external,a._fsPath=i._sep===l?i.fsPath:null,a}}else return i}}e.URI=m;const l=L.isWindows?1:void 0;class v extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=l),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(o,i){let a,h=-1;for(let u=0;u<o.length;u++){const w=o.charCodeAt(u);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47)h!==-1&&(a+=encodeURIComponent(o.substring(h,u)),h=-1),a!==void 0&&(a+=o.charAt(u));else{a===void 0&&(a=o.substr(0,u));const E=S[w];E!==void 0?(h!==-1&&(a+=encodeURIComponent(o.substring(h,u)),h=-1),a+=E):h===-1&&(h=u)}}return h!==-1&&(a+=encodeURIComponent(o.substring(h))),a!==void 0?a:o}function P(o){let i;for(let a=0;a<o.length;a++){const h=o.charCodeAt(a);h===35||h===63?(i===void 0&&(i=o.substr(0,a)),i+=S[h]):i!==void 0&&(i+=o[a])}return i!==void 0?i:o}function c(o,i){let a;return o.authority&&o.path.length>1&&o.scheme==="file"?a=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?a=o.path.substr(1):a=o.path[1].toLowerCase()+o.path.substr(2):a=o.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=c;function f(o,i){const a=i?P:b;let h="",{scheme:u,authority:w,path:E,query:s,fragment:D}=o;if(u&&(h+=u,h+=":"),(w||u==="file")&&(h+=A,h+=A),w){let R=w.indexOf("@");if(R!==-1){const U=w.substr(0,R);w=w.substr(R+1),R=U.indexOf(":"),R===-1?h+=a(U,!1):(h+=a(U.substr(0,R),!1),h+=":",h+=a(U.substr(R+1),!1)),h+="@"}w=w.toLowerCase(),R=w.indexOf(":"),R===-1?h+=a(w,!1):(h+=a(w.substr(0,R),!1),h+=w.substr(R))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const R=E.charCodeAt(1);R>=65&&R<=90&&(E=`/${String.fromCharCode(R+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const R=E.charCodeAt(0);R>=65&&R<=90&&(E=`${String.fromCharCode(R+32)}:${E.substr(2)}`)}h+=a(E,!0)}return s&&(h+="?",h+=a(s,!1)),D&&(h+="#",h+=i?D:b(D,!1)),h}function p(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+p(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,i=>p(i)):o}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[22],pe([0,1,8,2]),function(J,e,g,L){"use strict";var k,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,r,o){let i=t.get(r);return i===void 0&&(i=o,t.set(r,i)),i}e.getOrSet=y;function _(t){const r=[];return t.forEach((o,i)=>{r.push(`${i} => ${o}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=_;function I(t){const r=[];return t.forEach(o=>{r.push(o)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=I;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return o-i}value(){return this._value[this._pos]}}e.StringIterator=n;class A{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class d{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,g.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,g.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,g.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,g.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(r){this._iter=r}static forUris(r=()=>!1){return new S(new l(r))}static forPaths(){return new S(new d)}static forStrings(){return new S(new n)}static forConfigKeys(){return new S(new A)}clear(){this._root=void 0}set(r,o){const i=this._iter.reset(r);let a;for(this._root||(this._root=new v,this._root.segment=i.value()),a=this._root;;){const u=i.cmp(a.segment);if(u>0)a.left||(a.left=new v,a.left.segment=i.value()),a=a.left;else if(u<0)a.right||(a.right=new v,a.right.segment=i.value()),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new v,a.mid.segment=i.value()),a=a.mid;else break}const h=a.value;return a.value=o,a.key=r,h}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let i=this._root;for(;i;){const a=o.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else break}return i}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const i=this._iter.reset(r),a=[];let h=this._root;for(;h;){const u=i.cmp(h.segment);if(u>0)a.push([1,h]),h=h.left;else if(u<0)a.push([-1,h]),h=h.right;else if(i.hasNext())i.next(),a.push([0,h]),h=h.mid;else{for(o?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;a.length>0&&h.isEmpty();){let[w,E]=a.pop();switch(w){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}h=E}break}}}findSubstr(r){const o=this._iter.reset(r);let i=this._root,a;for(;i;){const h=o.cmp(i.segment);if(h>0)i=i.left;else if(h<0)i=i.right;else if(o.hasNext())o.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(r){const o=this._iter.reset(r);let i=this._root;for(;i;){const a=o.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[o,i]of this)r(i,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const o=[r];for(;o.length>0;){const i=o.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&o.push(i.left),i.mid&&o.push(i.mid),i.right&&o.push(i.right))}}}e.TernarySearchTree=S;class b{constructor(r,o){this[k]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=o??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),o),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o!="undefined"&&(r=r.bind(o));for(let[i,a]of this.map)r(a,L.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class c{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const i=this._map.get(r);if(!!i)return o!==0&&this.touch(i,o),i.value}set(r,o,i=0){let a=this._map.get(r);if(a)a.value=o,i!==0&&this.touch(a,i);else{switch(a={key:r,value:o,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(r,a),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const i=this._state;let a=this._head;for(;a;){if(o?r.bind(o)(a.value,a.key,this):r(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const r=this,o=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.key,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return a}values(){const r=this,o=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.value,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return a}entries(){const r=this,o=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:[i.key,i.value],done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return a}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,i=this.size;for(;o&&i>r;)this._map.delete(o.key),o=o.next,i--;this._head=o,this._size=i,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,i=r.previous;if(!o||!i)throw new Error("Invalid list");o.previous=i,i.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const i=r.next,a=r.previous;r===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const i=r.next,a=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,i)=>{r.push([i,o])}),r}fromJSON(r){this.clear();for(const[o,i]of r)this.set(o,i)}}e.LinkedMap=c;class f extends c{constructor(r,o=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class p{constructor(r){T.set(this,void 0),it(this,T,r,"f")}get size(){return He(this,T,"f").size}forEach(r,o){He(this,T,"f").forEach(r,o)}get(r){return He(this,T,"f").get(r)}has(r){return He(this,T,"f").has(r)}entries(){return He(this,T,"f").entries()}keys(){return He(this,T,"f").keys()}values(){return He(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return He(this,T,"f").entries()}}e.ReadonlyMapView=p}),define(ge[98],pe([0,1,22,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Y){return function(oe,we){for(let Me=0,Ve=Y.length;Me<Ve;Me++){const _e=Y[Me](oe,we);if(_e)return _e}return null}}e.or=k,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Y,oe,we){if(!we||we.length<oe.length)return null;let Me;return Y?Me=L.startsWithIgnoreCase(we,oe):Me=we.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function T(Y,oe){const we=oe.toLowerCase().indexOf(Y.toLowerCase());return we===-1?null:[{start:we,end:we+Y.length}]}e.matchesContiguousSubString=T;function y(Y,oe){return _(Y.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=y;function _(Y,oe,we,Me){if(we===Y.length)return[];if(Me===oe.length)return null;if(Y[we]===oe[Me]){let Ve=null;return(Ve=_(Y,oe,we+1,Me+1))?b({start:Me,end:Me+1},Ve):null}return _(Y,oe,we,Me+1)}function I(Y){return 97<=Y&&Y<=122}function n(Y){return 65<=Y&&Y<=90}e.isUpper=n;function A(Y){return 48<=Y&&Y<=57}function d(Y){return Y===32||Y===9||Y===10||Y===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>m.add(Y.charCodeAt(0)));function l(Y){return d(Y)||m.has(Y)}function v(Y,oe){return Y===oe||l(Y)&&l(oe)}function S(Y){return I(Y)||n(Y)||A(Y)}function b(Y,oe){return oe.length===0?oe=[Y]:Y.end===oe[0].start?oe[0].start=Y.start:oe.unshift(Y),oe}function P(Y,oe){for(let we=oe;we<Y.length;we++){const Me=Y.charCodeAt(we);if(n(Me)||A(Me)||we>0&&!S(Y.charCodeAt(we-1)))return we}return Y.length}function c(Y,oe,we,Me){if(we===Y.length)return[];if(Me===oe.length)return null;if(Y[we]!==oe[Me].toLowerCase())return null;{let Ve=null,_e=Me+1;for(Ve=c(Y,oe,we+1,Me+1);!Ve&&(_e=P(oe,_e))<oe.length;)Ve=c(Y,oe,we+1,_e),_e++;return Ve===null?null:b({start:Me,end:Me+1},Ve)}}function f(Y){let oe=0,we=0,Me=0,Ve=0,_e=0;for(let xe=0;xe<Y.length;xe++)_e=Y.charCodeAt(xe),n(_e)&&oe++,I(_e)&&we++,S(_e)&&Me++,A(_e)&&Ve++;const Je=oe/Y.length,X=we/Y.length,re=Me/Y.length,me=Ve/Y.length;return{upperPercent:Je,lowerPercent:X,alphaPercent:re,numericPercent:me}}function p(Y){const{upperPercent:oe,lowerPercent:we}=Y;return we===0&&oe>.6}function t(Y){const{upperPercent:oe,lowerPercent:we,alphaPercent:Me,numericPercent:Ve}=Y;return we>.2&&oe<.8&&Me>.6&&Ve<.2}function r(Y){let oe=0,we=0,Me=0,Ve=0;for(let _e=0;_e<Y.length;_e++)Me=Y.charCodeAt(_e),n(Me)&&oe++,I(Me)&&we++,d(Me)&&Ve++;return(oe===0||we===0)&&Ve===0?Y.length<=30:oe<=5}function o(Y,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(Y)||oe.length>60)return null;const we=f(oe);if(!t(we)){if(!p(we))return null;oe=oe.toLowerCase()}let Me=null,Ve=0;for(Y=Y.toLowerCase();Ve<oe.length&&(Me=c(Y,oe,0,Ve))===null;)Ve=P(oe,Ve+1);return Me}e.matchesCamelCase=o;function i(Y,oe,we=!1){if(!oe||oe.length===0)return null;let Me=null,Ve=0;for(Y=Y.toLowerCase(),oe=oe.toLowerCase();Ve<oe.length&&(Me=a(Y,oe,0,Ve,we))===null;)Ve=h(oe,Ve+1);return Me}e.matchesWords=i;function a(Y,oe,we,Me,Ve){if(we===Y.length)return[];if(Me===oe.length)return null;if(v(Y.charCodeAt(we),oe.charCodeAt(Me))){let _e=null,Je=Me+1;if(_e=a(Y,oe,we+1,Me+1,Ve),!Ve)for(;!_e&&(Je=h(oe,Je))<oe.length;)_e=a(Y,oe,we+1,Je,Ve),Je++;return _e===null?null:b({start:Me,end:Me+1},_e)}else return null}function h(Y,oe){for(let we=oe;we<Y.length;we++)if(l(Y.charCodeAt(we))||we>0&&l(Y.charCodeAt(we-1)))return we;return Y.length}const u=k(e.matchesPrefix,o,T),w=k(e.matchesPrefix,o,y),E=new g.LRUCache(1e4);function s(Y,oe,we=!1){if(typeof Y!="string"||typeof oe!="string")return null;let Me=E.get(Y);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),E.set(Y,Me));const Ve=Me.exec(oe);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:we?w(Y,oe):u(Y,oe)}e.matchesFuzzy=s;function D(Y,oe){const we=qe(Y,Y.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return we?U(we):null}e.matchesFuzzy2=D;function R(Y,oe,we,Me,Ve,_e){const Je=Math.min(13,Y.length);for(;we<Je;we++){const X=qe(Y,oe,we,Me,Ve,_e,!1);if(X)return X}return[0,_e]}e.anyScore=R;function U(Y){if(typeof Y=="undefined")return[];const oe=[],we=Y[1];for(let Me=Y.length-1;Me>1;Me--){const Ve=Y[Me]+we,_e=oe[oe.length-1];_e&&_e.end===Ve?_e.end=Ve+1:oe.push({start:Ve,end:Ve+1})}return oe}e.createMatches=U;const V=128;function ee(){const Y=[],oe=[];for(let we=0;we<=V;we++)oe[we]=0;for(let we=0;we<=V;we++)Y.push(oe.slice(0));return Y}function Q(Y){const oe=[];for(let we=0;we<=Y;we++)oe[we]=0;return oe}const O=Q(2*V),x=Q(2*V),F=ee(),z=ee(),M=ee(),N=!1;function q(Y,oe,we,Me,Ve){function _e(X,re,me=" "){for(;X.length<re;)X=me+X;return X}let Je=` |   |${Me.split("").map(X=>_e(X,3)).join("|")}
`;for(let X=0;X<=we;X++)X===0?Je+=" |":Je+=`${oe[X-1]}|`,Je+=Y[X].slice(0,Ve+1).map(re=>_e(re.toString(),3)).join("|")+`
`;return Je}function B(Y,oe,we,Me){Y=Y.substr(oe),we=we.substr(Me),console.log(q(z,Y,Y.length,we,we.length)),console.log(q(M,Y,Y.length,we,we.length)),console.log(q(F,Y,Y.length,we,we.length))}function K(Y,oe){if(oe<0||oe>=Y.length)return!1;const we=Y.codePointAt(oe);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(we)}}function te(Y,oe){if(oe<0||oe>=Y.length)return!1;switch(Y.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function he(Y,oe,we){return oe[Y]!==we[Y]}function De(Y,oe,we,Me,Ve,_e,Je=!1){for(;oe<we&&Ve<_e;)Y[oe]===Me[Ve]&&(Je&&(O[oe]=Ve),oe+=1),Ve+=1;return oe===we}e.isPatternInWord=De;var Pe;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Pe||(Pe={}));var Fe;(function(Y){Y.Default=[-100,0];function oe(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}Y.isDefault=oe})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function qe(Y,oe,we,Me,Ve,_e,Je){const X=Y.length>V?V:Y.length,re=Me.length>V?V:Me.length;if(we>=X||_e>=re||X-we>re-_e||!De(oe,we,X,Ve,_e,re,!0))return;We(X,re,we,_e,oe,Ve);let me=1,xe=1,Be=we,et=_e;const ke=[!1];for(me=1,Be=we;Be<X;me++,Be++){const ve=O[Be],Ee=x[Be],j=Be+1<X?x[Be+1]:re;for(xe=ve-_e+1,et=ve;et<j;xe++,et++){let be=Number.MIN_SAFE_INTEGER,Se=!1;et<=Ee&&(be=je(Y,oe,Be,we,Me,Ve,et,re,_e,F[me-1][xe-1]===0,ke));let Ae=0;be!==Number.MAX_SAFE_INTEGER&&(Se=!0,Ae=be+z[me-1][xe-1]);const Ue=et>ve,Ge=Ue?z[me][xe-1]+(F[me][xe-1]>0?-5:0):0,Ze=et>ve+1&&F[me][xe-1]>0,Qe=Ze?z[me][xe-2]+(F[me][xe-2]>0?-5:0):0;if(Ze&&(!Ue||Qe>=Ge)&&(!Se||Qe>=Ae))z[me][xe]=Qe,M[me][xe]=3,F[me][xe]=0;else if(Ue&&(!Se||Ge>=Ae))z[me][xe]=Ge,M[me][xe]=2,F[me][xe]=0;else if(Se)z[me][xe]=Ae,M[me][xe]=1,F[me][xe]=F[me-1][xe-1]+1;else throw new Error("not possible")}}if(N&&B(Y,we,Me,_e),!ke[0]&&!Je)return;me--,xe--;const Ce=[z[me][xe],_e];let Te=0,le=0;for(;me>=1;){let ve=xe;do{const Ee=M[me][ve];if(Ee===3)ve=ve-2;else if(Ee===2)ve=ve-1;else break}while(ve>=1);Te>1&&oe[we+me-1]===Ve[_e+xe-1]&&!he(ve+_e-1,Me,Ve)&&Te+1>F[me][ve]&&(ve=xe),ve===xe?Te++:Te=1,le||(le=ve),me--,xe=ve-1,Ce.push(xe)}re===X&&(Ce[0]+=2);const ce=le-X;return Ce[0]-=ce,Ce}e.fuzzyScore=qe;function We(Y,oe,we,Me,Ve,_e){let Je=Y-1,X=oe-1;for(;Je>=we&&X>=Me;)Ve[Je]===_e[X]&&(x[Je]=X,Je--),X--}function je(Y,oe,we,Me,Ve,_e,Je,X,re,me,xe){if(oe[we]!==_e[Je])return Number.MIN_SAFE_INTEGER;let Be=1,et=!1;return Je===we-Me?Be=Y[we]===Ve[Je]?7:5:he(Je,Ve,_e)&&(Je===0||!he(Je-1,Ve,_e))?(Be=Y[we]===Ve[Je]?7:5,et=!0):K(_e,Je)&&(Je===0||!K(_e,Je-1))?Be=5:(K(_e,Je-1)||te(_e,Je-1))&&(Be=5,et=!0),Be>1&&we===Me&&(xe[0]=!0),et||(et=he(Je,Ve,_e)||K(_e,Je-1)||te(_e,Je-1)),we===Me?Je>re&&(Be-=et?3:5):me?Be+=et?2:0:Be+=et?0:1,Je+1===X&&(Be-=et?3:5),Be}function W(Y,oe,we,Me,Ve,_e,Je){return ne(Y,oe,we,Me,Ve,_e,!0,Je)}e.fuzzyScoreGracefulAggressive=W;function Z(Y,oe,we,Me,Ve,_e,Je){return ne(Y,oe,we,Me,Ve,_e,!1,Je)}e.fuzzyScoreGraceful=Z;function ne(Y,oe,we,Me,Ve,_e,Je,X){let re=qe(Y,oe,we,Me,Ve,_e,X);if(re&&!Je)return re;if(Y.length>=3){const me=Math.min(7,Y.length-1);for(let xe=we+1;xe<me;xe++){const Be=ae(Y,xe);if(Be){const et=qe(Be,Be.toLowerCase(),we,Me,Ve,_e,X);et&&(et[0]-=3,(!re||et[0]>re[0])&&(re=et))}}}return re}function ae(Y,oe){if(oe+1>=Y.length)return;const we=Y[oe],Me=Y[oe+1];if(we!==Me)return Y.slice(0,oe)+Me+we+Y.slice(oe+2)}}),define(ge[141],pe([0,1,47,98,8]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${C.source}`,"g");function y(v){return v.replace(T,(S,b)=>b?S:`\\${S}`)}e.escapeIcons=y;const _=new RegExp(`\\\\${C.source}`,"g");function I(v){return v.replace(_,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=I;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function A(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(n,(S,b,P,c)=>P?S:b||c||"")}e.stripIcons=A;function d(v){const S=v.indexOf(e.iconStartMarker);return S===-1?{text:v}:m(v,S)}e.parseLabelWithIcons=d;function m(v,S){const b=[];let P="";function c(h){if(h){P+=h;for(const u of h)b.push(t)}}let f=-1,p="",t=0,r,o,i=S;const a=v.length;for(c(v.substr(0,S));i<a;)r=v[i],o=v[i+1],r===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(f=i,c(p),p=e.iconStartMarker,i++):r===")"&&f!==-1?(t+=i-f+1,f=-1,p=""):f!==-1?/^[a-z0-9\-]$/i.test(r)?p+=r:(c(p),f=-1,p=""):c(r),i++;return c(p),{text:P,iconOffsets:b}}function l(v,S,b=!1){const{text:P,iconOffsets:c}=S;if(!c||c.length===0)return(0,L.matchesFuzzy)(v,P,b);const f=(0,k.ltrim)(P," "),p=P.length-f.length,t=(0,L.matchesFuzzy)(v,f,b);if(t)for(const r of t){const o=c[r.start+p]+p;r.start+=o,r.end+=o}return t}e.matchesFuzzyIconAware=l}),define(ge[99],pe([0,1,16,141]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(m="",l=!1){if(this.value=m,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1)}appendText(m,l=0){return this.value+=I(this.supportThemeIcons?(0,L.escapeIcons)(m):m).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,l){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=C;function T(d){return y(d)?!d.value:Array.isArray(d)?d.every(T):!0}e.isEmptyMarkdownString=T;function y(d){return d instanceof C?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function _(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=_;function I(d){return d.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function n(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function A(d){const m=[],l=d.split("|").map(S=>S.trim());d=l[0];const v=l[1];if(v){const S=/height=(\d+)/.exec(v),b=/width=(\d+)/.exec(v),P=S?S[1]:"",c=b?b[1]:"",f=isFinite(parseInt(c)),p=isFinite(parseInt(P));f&&m.push(`width="${c}"`),p&&m.push(`height="${P}"`)}return{href:d,dimensions:m}}e.parseHrefAndDimensions=A}),define(ge[59],pe([0,1,24,8,2]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,_)}e.stringify=C;function T(n){let A=JSON.parse(n);return A=I(A),A}e.parse=T;var y;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(y=e.MarshalledId||(e.MarshalledId={}));function _(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,L.regExpFlags)(A)}:A}function I(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let d=0;d<n.length;++d)n[d]=I(n[d],A+1);else for(const d in n)Object.hasOwnProperty.call(n,d)&&(n[d]=I(n[d],A+1))}return n}e.revive=I}),define(ge[10],pe([0,1,11,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,I,n){this._hosts[_]=I,this._ports[_]=n}setConnectionToken(_,I){this._connectionTokens[_]=I}rewrite(_){if(this._delegate)return this._delegate(_);const I=_.authority;let n=this._hosts[I];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const A=this._ports[I],d=this._connectionTokens[I];let m=`path=${encodeURIComponent(_.path)}`;return typeof d=="string"&&(m+=`&tkn=${encodeURIComponent(d)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${A}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new C;class T{asBrowserUri(_,I){const n=this.toUri(_,I);return n.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===k.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?n.with({scheme:k.vscodeFileResource,authority:n.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(_,I){const n=this.toUri(_,I);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==T.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,I){return L.URI.isUri(_)?_:L.URI.parse(I.toUrl(_))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ge[76],pe([0,1,22]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function k(I){return _(I,"NFC",L)}e.normalizeNFC=k;const C=new g.LRUCache(1e4);function T(I){return _(I,"NFD",C)}e.normalizeNFD=T;const y=/[^\u0000-\u0080]/;function _(I,n,A){if(!I)return I;const d=A.get(I);if(d)return d;let m;return y.test(I)?m=I.normalize(n):m=I,A.set(I,m),m}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(n){return T(n).replace(I,"")}}()}),define(ge[23],pe([0,1,29,10,9,11,8,2]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(m){return(0,y.uriToFsPath)(m,!0)}e.originalFSPath=_;class I{constructor(l){this._ignorePathCasing=l}compare(l,v,S=!1){return l===v?0:(0,T.compare)(this.getComparisonKey(l,S),this.getComparisonKey(v,S))}isEqual(l,v,S=!1){return l===v?!0:!l||!v?!1:this.getComparisonKey(l,S)===this.getComparisonKey(v,S)}getComparisonKey(l,v=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,v,S=!1){if(l.scheme===v.scheme){if(l.scheme===L.Schemas.file)return g.isEqualOrParent(_(l),_(v),this._ignorePathCasing(l))&&l.query===v.query&&(S||l.fragment===v.fragment);if((0,e.isEqualAuthority)(l.authority,v.authority))return g.isEqualOrParent(l.path,v.path,this._ignorePathCasing(l),"/")&&l.query===v.query&&(S||l.fragment===v.fragment)}return!1}joinPath(l,...v){return y.URI.joinPath(l,...v)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return k.posix.basename(l.path)}extname(l){const v=k.posix.extname(l.path),S=v.indexOf("?");return S!==-1?v.substr(0,S):v}dirname(l){if(l.path.length===0)return l;let v;return l.scheme===L.Schemas.file?v=y.URI.file(k.dirname(_(l))).path:(v=k.posix.dirname(l.path),l.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),v="/")),l.with({path:v})}normalizePath(l){if(!l.path.length)return l;let v;return l.scheme===L.Schemas.file?v=y.URI.file(k.normalize(_(l))).path:v=k.posix.normalize(l.path),l.with({path:v})}relativePath(l,v){if(l.scheme!==v.scheme||!(0,e.isEqualAuthority)(l.authority,v.authority))return;if(l.scheme===L.Schemas.file){const P=k.relative(_(l),_(v));return C.isWindows?g.toSlashes(P):P}let S=l.path||"/",b=v.path||"/";if(this._ignorePathCasing(l)){let P=0;for(const c=Math.min(S.length,b.length);P<c&&!(S.charCodeAt(P)!==b.charCodeAt(P)&&S.charAt(P).toLowerCase()!==b.charAt(P).toLowerCase());P++);S=b.substr(0,P)+S.substr(P)}return k.posix.relative(S,b)}resolvePath(l,v){if(l.scheme===L.Schemas.file){const S=y.URI.file(k.resolve(_(l),v));return l.with({authority:S.authority,path:S.path})}return v=g.toPosixPath(v),l.with({path:k.posix.resolve(l.path,v)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,v){return l===v||(0,T.equalsIgnoreCase)(l,v)}hasTrailingPathSeparator(l,v=k.sep){if(l.scheme===L.Schemas.file){const S=_(l);return S.length>g.getRoot(S).length&&S[S.length-1]===v}else{const S=l.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,v=k.sep){return(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,v=k.sep){let S=!1;if(l.scheme===L.Schemas.file){const b=_(l);S=b!==void 0&&b.length===g.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=l.path;S=b.length===1&&b.charCodeAt(b.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path+"/"}):l}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(m=>m.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new I(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,l){const v=[];for(let S=0;S<m.length;S++){const b=l(m[S]);m.some((P,c)=>c===S?!1:(0,e.isEqualOrParent)(b,l(P)))||v.push(m[S])}return v}e.distinctParents=n;var A;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(v){const S=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[f,p]=c.split(":");f&&p&&S.set(f,p)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&S.set(m.META_DATA_MIME,P),S}m.parseMetaData=l})(A=e.DataUri||(e.DataUri={}));function d(m,l,v){if(l){let S=m.path;return S&&S[0]!==k.posix.sep&&(S=k.posix.sep+S),m.with({scheme:v,authority:l,path:S})}return m.with({scheme:v})}e.toLocalResource=d}),define(ge[17],pe([0,1,21,16,3,6,23]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(x){return!!x&&typeof x.then=="function"}e.isThenable=y;function _(x){const F=new g.CancellationTokenSource,z=x(F.token),M=new Promise((N,q)=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),q((0,L.canceled)())});Promise.resolve(z).then(K=>{B.dispose(),F.dispose(),N(K)},K=>{B.dispose(),F.dispose(),q(K)})});return new class{cancel(){F.cancel()}then(N,q){return M.then(N,q)}catch(N){return this.then(void 0,N)}finally(N){return M.finally(N)}}}e.createCancelablePromise=_;function I(x,F,z){return Promise.race([x,new Promise(M=>F.onCancellationRequested(()=>M(z)))])}e.raceCancellation=I;async function n(x){let F=-1;const z=x.map((N,q)=>N.then(B=>(F=q,B))),M=await Promise.race(z);return x.forEach((N,q)=>{q!==F&&N.cancel()}),M}e.raceCancellablePromises=n;function A(x,F,z){let M;const N=setTimeout(()=>{M?.(void 0),z?.()},F);return Promise.race([x.finally(()=>clearTimeout(N)),new Promise(q=>M=q)])}e.raceTimeout=A;function d(x){return new Promise((F,z)=>{const M=x();y(M)?M.then(F,z):F(M)})}e.asPromise=d;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(z,z).then(M)})}return new Promise((z,M)=>{this.queuedPromise.then(z,M)})}return this.activePromise=F(),new Promise((z,M)=>{this.activePromise.then(N=>{this.activePromise=null,z(N)},N=>{this.activePromise=null,M(N)})})}}e.Throttler=m;class l{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=l;class v{constructor(){this.promiseMap=new Map}queue(F,z){const N=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(F)===N&&this.promiseMap.delete(F)});return this.promiseMap.set(F,N),N}}e.SequencerByKey=v;class S{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,z=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,N)=>{this.doResolve=M,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class b{constructor(F){this.delayer=new S(F),this.throttler=new m}trigger(F,z){return this.delayer.trigger(()=>this.throttler.queue(F),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class P{constructor(){this._isOpen=!1,this._promise=new Promise((F,z)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class c extends P{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function f(x,F){return F?new Promise((z,M)=>{const N=setTimeout(()=>{q.dispose(),z()},x),q=F.onCancellationRequested(()=>{clearTimeout(N),q.dispose(),M((0,L.canceled)())})}):_(z=>f(x,z))}e.timeout=f;function p(x,F=0){const z=setTimeout(x,F);return(0,C.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=p;function t(x){const F=[];let z=0;const M=x.length;function N(){return z<M?x[z++]():null}function q(B){B!=null&&F.push(B);const K=N();return K?K.then(q):Promise.resolve(F)}return Promise.resolve(null).then(q)}e.sequence=t;function r(x,F=M=>!!M,z=null){let M=0;const N=x.length,q=()=>{if(M>=N)return Promise.resolve(z);const B=x[M++];return Promise.resolve(B()).then(te=>F(te)?Promise.resolve(te):q())};return q()}e.first=r;function o(x,F=M=>!!M,z=null){if(x.length===0)return Promise.resolve(z);let M=x.length;const N=()=>{M=-1;for(const q of x)q.cancel?.()};return new Promise((q,B)=>{for(const K of x)K.then(te=>{--M>=0&&F(te)?(N(),q(te)):M===0&&q(z)}).catch(te=>{--M>=0&&(N(),B(te))})})}e.firstParallel=o;class i{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((z,M)=>{this.outstandingPromises.push({factory:F,c:z,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const z=F.factory();z.then(F.c,F.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class a extends i{constructor(){super(1)}}e.Queue=a;class h{constructor(){this.queues=new Map}queueFor(F,z=T.extUri){const M=z.getComparisonKey(F);let N=this.queues.get(M);return N||(N=new a,k.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(M)}),this.queues.set(M,N)),N}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=h;class u{constructor(F,z){this._token=-1,typeof F=="function"&&typeof z=="number"&&this.setIfNotSet(F,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},z)}setIfNotSet(F,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},z))}}e.TimeoutTimer=u;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setInterval(()=>{F()},z)}}e.IntervalTimer=w;class E{constructor(F,z){this.timeoutToken=-1,this.runner=F,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class s extends E{constructor(F,z){super(F,z);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=s;class D extends C.Disposable{constructor(F,z,M,N){super();this.maxWorkChunkSize=F,this.maxPendingWork=z,this.throttleDelay=M,this.handler=N,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=D,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const z=setTimeout(()=>F(x));let M=!1;return{dispose(){M||(M=!0,clearTimeout(z))}}}}else e.runWhenIdle=(x,F)=>{const z=requestIdleCallback(x,typeof F=="number"?{timeout:F}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(z))}}}}();class R{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=R;async function U(x,F,z){let M;for(let N=0;N<z;N++)try{return await x()}catch(q){M=q,await f(F)}throw M}e.retry=U;class V{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,z,M){return this._pending={taskId:F,cancel:()=>M?.(),promise:z},z.then(()=>this.donePending(F),()=>this.donePending(F)),z}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let z,M;const N=new Promise((q,B)=>{z=q,M=B});this._next={run:F,promise:N,promiseResolve:z,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=V;class ee{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,z)=>{this.completeCallback=F,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(z=>{this.completeCallback(F),this.resolved=!0,z()})}error(F){return new Promise(z=>{this.errorCallback(F),this.rejected=!0,z()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=Q;var O;(function(x){async function F(z){let M;const N=await Promise.all(z.map(q=>q.then(B=>B,B=>{M||(M=B)})));if(typeof M!="undefined")throw M;return N}x.settled=F})(O=e.Promises||(e.Promises={}))}),define(ge[100],pe([0,1,17,9]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new g.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),C=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(E,s,D=!1){const R=E||"",U=s||"",V=k.value.collator.compare(R,U);return k.value.collatorIsNumeric&&V===0&&R!==U?R<U?-1:1:V}e.compareFileNames=y;function _(E,s){const D=C.value.collator;return E=E||"",s=s||"",p(D,E,s)}e.compareFileNamesDefault=_;function I(E,s){const D=C.value.collator;return E=E||"",s=s||"",i(E,s)||p(D,E,s)}e.compareFileNamesUpper=I;function n(E,s){const D=C.value.collator;return E=E||"",s=s||"",o(E,s)||p(D,E,s)}e.compareFileNamesLower=n;function A(E,s){return E=E||"",s=s||"",E===s?0:E<s?-1:1}e.compareFileNamesUnicode=A;function d(E,s,D=!1){D||(E=E&&E.toLowerCase(),s=s&&s.toLowerCase());const[R,U]=c(E),[V,ee]=c(s);return R!==V?R<V?-1:1:U===ee?0:U<ee?-1:1}e.noIntlCompareFileNames=d;function m(E,s){const[D,R]=c(E),[U,V]=c(s);let ee=k.value.collator.compare(R,V);if(ee===0){if(k.value.collatorIsNumeric&&R!==V)return R<V?-1:1;if(ee=k.value.collator.compare(D,U),k.value.collatorIsNumeric&&ee===0&&D!==U)return D<U?-1:1}return ee}e.compareFileExtensions=m;function l(E,s){E=E||"",s=s||"";const D=f(E),R=f(s),U=C.value.collator,V=T.value.collator;return p(V,D,R)||p(U,E,s)}e.compareFileExtensionsDefault=l;function v(E,s){E=E||"",s=s||"";const D=f(E),R=f(s),U=C.value.collator,V=T.value.collator;return p(V,D,R)||i(E,s)||p(U,E,s)}e.compareFileExtensionsUpper=v;function S(E,s){E=E||"",s=s||"";const D=f(E),R=f(s),U=C.value.collator,V=T.value.collator;return p(V,D,R)||o(E,s)||p(U,E,s)}e.compareFileExtensionsLower=S;function b(E,s){E=E||"",s=s||"";const D=f(E).toLowerCase(),R=f(s).toLowerCase();return D!==R?D<R?-1:1:E!==s?E<s?-1:1:0}e.compareFileExtensionsUnicode=b;const P=/^(.*?)(\.([^.]*))?$/;function c(E,s=!1){const D=E?P.exec(E):[];let R=[D&&D[1]||"",D&&D[3]||""];return s&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function f(E){const s=E?P.exec(E):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function p(E,s,D){let R=E.compare(s,D);return R!==0?R:s.length!==D.length?s.length<D.length?-1:1:0}function t(E){const s=E.charAt(0);return s.toLocaleUpperCase()!==s}function r(E){const s=E.charAt(0);return s.toLocaleLowerCase()!==s}function o(E,s){return t(E)&&r(s)?-1:r(E)&&t(s)?1:0}function i(E,s){return r(E)&&t(s)?-1:t(E)&&r(s)?1:0}function a(E,s,D=!1){return D||(E=E&&E.toLowerCase(),s=s&&s.toLowerCase()),E===s?0:E<s?-1:1}function h(E,s,D=!1){const R=E.split(L.sep),U=s.split(L.sep),V=R.length-1,ee=U.length-1;let Q,O;for(let x=0;;x++){if(Q=V===x,O=ee===x,Q&&O)return y(R[x],U[x],D);if(Q)return-1;if(O)return 1;const F=a(R[x],U[x],D);if(F!==0)return F}}e.comparePaths=h;function u(E,s,D){const R=E.toLowerCase(),U=s.toLowerCase(),V=w(E,s,D);if(V)return V;const ee=R.endsWith(D),Q=U.endsWith(D);if(ee!==Q)return ee?-1:1;const O=y(R,U);return O!==0?O:R.localeCompare(U)}e.compareAnything=u;function w(E,s,D){const R=E.toLowerCase(),U=s.toLowerCase(),V=R.startsWith(D),ee=U.startsWith(D);if(V!==ee)return V?-1:1;if(V&&ee){if(R.length<U.length)return-1;if(R.length>U.length)return 1}return 0}e.compareByPrefix=w}),define(ge[101],pe([0,1,100,98,9,11,8]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,_=[y,[]];function I(Q,O,x,F){if(!Q||!O)return _;const z=Q.length,M=O.length;if(z<M)return _;const N=Q.toLowerCase();return!F&&!N.includes(x)?_:n(O,x,M,Q,N,z)}e.scoreFuzzy=I;function n(Q,O,x,F,z,M){const N=[],q=[];for(let he=0;he<x;he++){const De=he*M,Pe=De-M,Fe=he>0,qe=Q[he],We=O[he];for(let je=0;je<M;je++){const W=je>0,Z=De+je,ne=Z-1,ae=Pe+je-1,Y=W?N[ne]:0,oe=Fe&&W?N[ae]:0,we=Fe&&W?q[ae]:0;let Me;!oe&&Fe?Me=0:Me=A(qe,We,F,z,je,we),Me&&oe+Me>=Y?(q[Z]=we+1,N[Z]=oe+Me):(q[Z]=y,N[Z]=Y)}}const B=[];let K=x-1,te=M-1;for(;K>=0&&te>=0;){const he=K*M+te;q[he]===y||(B.push(te),K--),te--}return[N[x*M-1],B.reverse()]}function A(Q,O,x,F,z,M){let N=0;if(!d(O,F[z]))return N;if(N+=1,M>0&&(N+=M*5),Q===x[z]&&(N+=1),z===0)N+=8;else{const q=m(x.charCodeAt(z-1));q?N+=q:(0,L.isUpper)(x.charCodeAt(z))&&(N+=2)}return N}function d(Q,O){return Q===O?!0:Q==="/"||Q==="\\"?O==="/"||O==="\\":!1}function m(Q){switch(Q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function v(Q,O,x=0,F=0){const z=O;return z.values&&z.values.length>1?S(Q,z.values,x,F):b(Q,O,x,F)}e.scoreFuzzy2=v;function S(Q,O,x,F){let z=0;const M=[];for(const N of O){const[q,B]=b(Q,N,x,F);if(typeof q!="number")return l;z+=q,M.push(...B)}return[z,h(M)]}function b(Q,O,x,F){const z=(0,L.fuzzyScore)(O.original,O.originalLowercase,x,Q,Q.toLowerCase(),F,!0);return z?[z[0],(0,L.createMatches)(z)]:l}const P=Object.freeze({score:0}),c=1<<18,f=1<<17,p=1<<16;function t(Q,O,x,F,z){if(!Q||!O.normalized)return P;const M=F.getItemLabel(Q);if(!M)return P;const N=F.getItemDescription(Q);let q;N?q=`${M}${N}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${x}`:q=`${M}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${x}`;const B=z[q];if(B)return B;const K=r(M,N,F.getItemPath(Q),O,x);return z[q]=K,K}e.scoreItemFuzzy=t;function r(Q,O,x,F,z){const M=!x||!F.containsPathSeparator;return x&&(C.isLinux?F.pathNormalized===x:(0,T.equalsIgnoreCase)(F.pathNormalized,x))?{score:c,labelMatch:[{start:0,end:Q.length}],descriptionMatch:O?[{start:0,end:O.length}]:void 0}:F.values&&F.values.length>1?o(Q,O,x,F.values,M,z):i(Q,O,x,F,M,z)}function o(Q,O,x,F,z,M){let N=0;const q=[],B=[];for(const K of F){const{score:te,labelMatch:he,descriptionMatch:De}=i(Q,O,x,K,z,M);if(te===y)return P;N+=te,he&&q.push(...he),De&&B.push(...De)}return{score:N,labelMatch:h(q),descriptionMatch:h(B)}}function i(Q,O,x,F,z,M){if(z||!O){const[N,q]=I(Q,F.normalized,F.normalizedLowercase,M);if(N){const B=(0,L.matchesPrefix)(F.normalized,Q);let K;return B?(K=f,K+=Math.round(F.normalized.length/Q.length*100)):K=p,{score:K+N,labelMatch:B||a(q)}}}if(O){let N=O;x&&(N=`${O}${k.sep}`);const q=N.length,B=`${N}${Q}`,[K,te]=I(B,F.normalized,F.normalizedLowercase,M);if(K){const he=a(te),De=[],Pe=[];return he.forEach(Fe=>{Fe.start<q&&Fe.end>q?(De.push({start:0,end:Fe.end-q}),Pe.push({start:Fe.start,end:q})):Fe.start>=q?De.push({start:Fe.start-q,end:Fe.end-q}):Pe.push(Fe)}),{score:K,labelMatch:De,descriptionMatch:Pe}}}return P}function a(Q){const O=[];if(!Q)return O;let x;for(const F of Q)x&&x.end===F?x.end+=1:(x={start:F,end:F+1},O.push(x));return O}function h(Q){const O=Q.sort((z,M)=>z.start-M.start),x=[];let F;for(const z of O)!F||!u(F,z)?(F=z,x.push(z)):(F.start=Math.min(F.start,z.start),F.end=Math.max(F.end,z.end));return x}function u(Q,O){return!(Q.end<O.start||O.end<Q.start)}function w(Q,O,x,F,z,M){const N=t(Q,x,F,z,M),q=t(O,x,F,z,M),B=N.score,K=q.score;if((B===c||K===c)&&B!==K)return B===c?-1:1;if(B>p||K>p){if(B!==K)return B>K?-1:1;if(B<f&&K<f){const We=s(N.labelMatch,q.labelMatch);if(We!==0)return We}const Fe=z.getItemLabel(Q)||"",qe=z.getItemLabel(O)||"";if(Fe.length!==qe.length)return Fe.length-qe.length}if(B!==K)return B>K?-1:1;const te=Array.isArray(N.labelMatch)&&N.labelMatch.length>0,he=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(te&&!he)return-1;if(he&&!te)return 1;const De=E(Q,N,z),Pe=E(O,q,z);return De&&Pe&&De!==Pe?Pe>De?-1:1:D(Q,O,x,z)}e.compareItemsByFuzzyScore=w;function E(Q,O,x){let F=-1,z=-1;if(O.descriptionMatch&&O.descriptionMatch.length?F=O.descriptionMatch[0].start:O.labelMatch&&O.labelMatch.length&&(F=O.labelMatch[0].start),O.labelMatch&&O.labelMatch.length){if(z=O.labelMatch[O.labelMatch.length-1].end,O.descriptionMatch&&O.descriptionMatch.length){const M=x.getItemDescription(Q);M&&(z+=M.length)}}else O.descriptionMatch&&O.descriptionMatch.length&&(z=O.descriptionMatch[O.descriptionMatch.length-1].end);return z-F}function s(Q,O){if(!Q&&!O||(!Q||!Q.length)&&(!O||!O.length))return 0;if(!O||!O.length)return-1;if(!Q||!Q.length)return 1;const x=Q[0].start,z=Q[Q.length-1].end-x,M=O[0].start,q=O[O.length-1].end-M;return z===q?0:q<z?1:-1}function D(Q,O,x,F){const z=F.getItemLabel(Q)||"",M=F.getItemLabel(O)||"",N=F.getItemDescription(Q),q=F.getItemDescription(O),B=z.length+(N?N.length:0),K=M.length+(q?q.length:0);if(B!==K)return B-K;const te=F.getItemPath(Q),he=F.getItemPath(O);return te&&he&&te.length!==he.length?te.length-he.length:z!==M?(0,g.compareAnything)(z,M,x.normalized):N&&q&&N!==q?(0,g.compareAnything)(N,q,x.normalized):te&&he&&te!==he?(0,g.compareAnything)(te,he,x.normalized):0}const R=" ";function U(Q){typeof Q!="string"&&(Q="");const O=Q.toLowerCase(),{pathNormalized:x,normalized:F,normalizedLowercase:z}=V(Q),M=x.indexOf(k.sep)>=0;let N;const q=Q.split(R);if(q.length>1)for(const B of q){const{pathNormalized:K,normalized:te,normalizedLowercase:he}=V(B);te&&(N||(N=[]),N.push({original:B,originalLowercase:B.toLowerCase(),pathNormalized:K,normalized:te,normalizedLowercase:he}))}return{original:Q,originalLowercase:O,pathNormalized:x,normalized:F,normalizedLowercase:z,values:N,containsPathSeparator:M}}e.prepareQuery=U;function V(Q){let O;C.isWindows?O=Q.replace(/\//g,k.sep):O=Q.replace(/\\/g,k.sep);const x=(0,T.stripWildcards)(O).replace(/\s/g,"");return{pathNormalized:O,normalized:x,normalizedLowercase:x.toLowerCase()}}function ee(Q){return Array.isArray(Q)?U(Q.map(O=>O.original).join(R)):U(Q.original)}e.pieceToQuery=ee}),define(ge[30],pe([0,1,17,29,22,9,8]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const _="**",I="/",n="[/\\\\]",A="[^/\\\\]",d=/\//g;function m(N){switch(N){case 0:return"";case 1:return`${A}*?`;default:return`(?:${n}|${A}+${n}|${n}${A}+)*?`}}function l(N,q){if(!N)return[];const B=[];let K=!1,te=!1,he="";for(const De of N){switch(De){case q:if(!K&&!te){B.push(he),he="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":te=!0;break;case"]":te=!1;break}he+=De}return he&&B.push(he),B}e.splitGlobAware=l;function v(N){if(!N)return"";let q="";const B=l(N,I);if(B.every(K=>K===_))q=".*";else{let K=!1;B.forEach((te,he)=>{if(te===_){K||(q+=m(2),K=!0);return}let De=!1,Pe="",Fe=!1,qe="";for(const We of te){if(We!=="}"&&De){Pe+=We;continue}if(Fe&&(We!=="]"||!qe)){let je;We==="-"?je=We:(We==="^"||We==="!")&&!qe?je="^":We===I?je="":je=T.escapeRegExpCharacters(We),qe+=je;continue}switch(We){case"{":De=!0;continue;case"[":Fe=!0;continue;case"}":q+=`(?:${l(Pe,",").map(Z=>v(Z)).join("|")})`,De=!1,Pe="";break;case"]":q+="["+qe+"]",Fe=!1,qe="";break;case"?":q+=A;continue;case"*":q+=m(1);continue;default:q+=T.escapeRegExpCharacters(We)}}he<B.length-1&&(B[he+1]!==_||he+2<B.length)&&(q+=n),K=!1})}return q}const S=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},o=function(){return null};function i(N,q){if(!N)return o;let B;typeof N!="string"?B=N.pattern:B=N,B=B.trim();const K=`${B}_${!!q.trimForExclusions}`;let te=t.get(K);if(te)return a(te,N);let he;if(S.test(B)){const De=B.substr(4);te=function(Pe,Fe){return typeof Pe=="string"&&Pe.endsWith(De)?B:null}}else(he=b.exec(h(B,q)))?te=u(he[1],B):(q.trimForExclusions?c:P).test(B)?te=w(B,q):(he=f.exec(h(B,q)))?te=E(he[1].substr(1),B,!0):(he=p.exec(h(B,q)))?te=E(he[1],B,!1):te=s(B);return t.set(K,te),a(te,N)}function a(N,q){return typeof q=="string"?N:function(B,K){return L.isEqualOrParent(B,q.base)?N(C.relative(q.base,B),K):null}}function h(N,q){return q.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function u(N,q){const B=`/${N}`,K=`\\${N}`,te=function(De,Pe){return typeof De!="string"?null:Pe?Pe===N?q:null:De===N||De.endsWith(B)||De.endsWith(K)?q:null},he=[N];return te.basenames=he,te.patterns=[q],te.allBasenames=he,te}function w(N,q){const B=M(N.slice(1,-1).split(",").map(Pe=>i(Pe,q)).filter(Pe=>Pe!==o),N),K=B.length;if(!K)return o;if(K===1)return B[0];const te=function(Pe,Fe){for(let qe=0,We=B.length;qe<We;qe++)if(B[qe](Pe,Fe))return N;return null},he=B.find(Pe=>!!Pe.allBasenames);he&&(te.allBasenames=he.allBasenames);const De=B.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return De.length&&(te.allPaths=De),te}function E(N,q,B){const K=C.sep===C.posix.sep,te=K?N:N.replace(d,C.sep),he=C.sep+te,De=C.posix.sep+N,Pe=B?function(Fe,qe){return typeof Fe=="string"&&(Fe===te||Fe.endsWith(he)||!K&&(Fe===N||Fe.endsWith(De)))?q:null}:function(Fe,qe){return typeof Fe=="string"&&(Fe===te||!K&&Fe===N)?q:null};return Pe.allPaths=[(B?"*/":"./")+N],Pe}function s(N){try{const q=new RegExp(`^${v(N)}$`);return function(B){return q.lastIndex=0,typeof B=="string"&&q.test(B)?N:null}}catch(q){return o}}function D(N,q,B){return!N||typeof q!="string"?!1:R(N)(q,void 0,B)}e.match=D;function R(N,q={}){if(!N)return r;if(typeof N=="string"||Q(N)){const B=i(N,q);if(B===o)return r;const K=function(te,he){return!!B(te,he)};return B.allBasenames&&(K.allBasenames=B.allBasenames),B.allPaths&&(K.allPaths=B.allPaths),K}return F(N,q)}e.parse=R;function U(N){if(!N)return;let q;return B=>(q||(q=(N()||Promise.resolve([])).then(K=>K?ee(K):{})),q.then(K=>!!K[B]))}e.hasSiblingPromiseFn=U;function V(N){if(!N)return;let q;return B=>{if(!q){const K=N();q=K?ee(K):{}}return!!q[B]}}e.hasSiblingFn=V;function ee(N){const q={};for(const B of N)q[B]=!0;return q}function Q(N){const q=N;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=Q;function O(N){return N.allBasenames||[]}e.getBasenameTerms=O;function x(N){return N.allPaths||[]}e.getPathTerms=x;function F(N,q){const B=M(Object.getOwnPropertyNames(N).map(Pe=>z(Pe,N[Pe],q)).filter(Pe=>Pe!==o)),K=B.length;if(!K)return o;if(!B.some(Pe=>!!Pe.requiresSiblings)){if(K===1)return B[0];const Pe=function(We,je){for(let W=0,Z=B.length;W<Z;W++){const ne=B[W](We,je);if(ne)return ne}return null},Fe=B.find(We=>!!We.allBasenames);Fe&&(Pe.allBasenames=Fe.allBasenames);const qe=B.reduce((We,je)=>je.allPaths?We.concat(je.allPaths):We,[]);return qe.length&&(Pe.allPaths=qe),Pe}const te=function(Pe,Fe,qe){let We;for(let je=0,W=B.length;je<W;je++){const Z=B[je];Z.requiresSiblings&&qe&&(Fe||(Fe=C.basename(Pe)),We||(We=Fe.substr(0,Fe.length-C.extname(Pe).length)));const ne=Z(Pe,Fe,We,qe);if(ne)return ne}return null},he=B.find(Pe=>!!Pe.allBasenames);he&&(te.allBasenames=he.allBasenames);const De=B.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return De.length&&(te.allPaths=De),te}function z(N,q,B){if(q===!1)return o;const K=i(N,B);if(K===o)return o;if(typeof q=="boolean")return K;if(q){const te=q.when;if(typeof te=="string"){const he=(De,Pe,Fe,qe)=>{if(!qe||!K(De,Pe))return null;const We=te.replace("$(basename)",Fe),je=qe(We);return(0,g.isThenable)(je)?je.then(W=>W?N:null):je?N:null};return he.requiresSiblings=!0,he}}return K}function M(N,q){const B=N.filter(Pe=>!!Pe.basenames);if(B.length<2)return N;const K=B.reduce((Pe,Fe)=>{const qe=Fe.basenames;return qe?Pe.concat(qe):Pe},[]);let te;if(q){te=[];for(let Pe=0,Fe=K.length;Pe<Fe;Pe++)te.push(q)}else te=B.reduce((Pe,Fe)=>{const qe=Fe.patterns;return qe?Pe.concat(qe):Pe},[]);const he=function(Pe,Fe){if(typeof Pe!="string")return null;if(!Fe){let We;for(We=Pe.length;We>0;We--){const je=Pe.charCodeAt(We-1);if(je===47||je===92)break}Fe=Pe.substr(We)}const qe=K.indexOf(Fe);return qe!==-1?te[qe]:null};he.basenames=K,he.patterns=te,he.allBasenames=K;const De=N.filter(Pe=>!Pe.basenames);return De.push(he),De}}),define(ge[77],pe([0,1,29,10,9,11,23,8,2]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(i,a,h){if(typeof i=="string"&&(i=_.URI.file(i)),h){const w=h.getWorkspaceFolder(i);if(w){const E=h.getWorkspace().folders.length>1;let s;if((0,T.isEqual)(w.uri,i)?s="":s=(0,T.relativePath)(w.uri,i),E){const D=w.name?w.name:(0,T.basename)(w.uri);s=s?D+" \u2022 "+s:D}return s}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(i.fsPath))return(0,k.normalize)(A(i.fsPath));let u=(0,k.normalize)(i.fsPath);return!C.isWindows&&a?.userHome&&(u=m(u,a.userHome.fsPath)),u}e.getPathLabel=I;function n(i){if(!i)return;typeof i=="string"&&(i=_.URI.file(i));const a=(0,T.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,g.isRootOrDriveLetter)(a)?A(a):a}e.getBaseLabel=n;function A(i){return(0,g.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=A;let d=Object.create(null);function m(i,a){if(C.isWindows||!i||!a)return i;let h=d.original===a?d.normalized:void 0;return h||(h=`${(0,y.rtrim)(a,k.posix.sep)}${k.posix.sep}`,d={original:a,normalized:h}),(C.isLinux?i.startsWith(h):(0,y.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=m;function l(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=l;const v="\u2026",S="\\\\",b="~";function P(i,a=k.sep){const h=new Array(i.length);let u=!1;for(let w=0;w<i.length;w++){let E=i[w];if(E===""){h[w]=`.${a}`;continue}if(!E){h[w]=E;continue}u=!0;let s="";E.indexOf(S)===0?(s=E.substr(0,E.indexOf(S)+S.length),E=E.substr(E.indexOf(S)+S.length)):E.indexOf(a)===0?(s=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(b)===0&&(s=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length));const D=E.split(a);for(let R=1;u&&R<=D.length;R++)for(let U=D.length-R;u&&U>=0;U--){u=!1;let V=D.slice(U,U+R).join(a);for(let ee=0;!u&&ee<i.length;ee++)if(ee!==w&&i[ee]&&i[ee].indexOf(V)>-1){const Q=U+R===D.length,O=U>0&&i[ee].indexOf(a)>-1?a+V:V,x=i[ee].endsWith(O);u=!Q||x}if(!u){let ee="";(D[0].endsWith(":")||s!=="")&&(U===1&&(U=0,R++,V=D[0]+a+V),U>0&&(ee=D[0]+a),ee=s+ee),U>0&&(ee=ee+v+a),ee=ee+V,U+R<D.length&&(ee=ee+a+v),h[w]=ee}}u&&(h[w]=E)}return h}e.shorten=P;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function f(i,a=Object.create(null)){const h=[];let u=!1,w="";for(const E of i)if(E==="$"||u&&E==="{")w&&h.push({value:w,type:c.TEXT}),w="",u=!0;else if(E==="}"&&u){const s=a[w];if(typeof s=="string")s.length&&h.push({value:s,type:c.VARIABLE});else if(s){const D=h[h.length-1];(!D||D.type!==c.SEPARATOR)&&h.push({value:s.label,type:c.SEPARATOR})}w="",u=!1}else w+=E;return w&&!u&&h.push({value:w,type:c.TEXT}),h.filter((E,s)=>{if(E.type===c.SEPARATOR){const D=h[s-1],R=h[s+1];return[D,R].every(U=>U&&(U.type===c.VARIABLE||U.type===c.TEXT)&&U.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=f;function p(i,a){return C.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(i,a){return C.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(i){const a=i.indexOf("/")!==-1?k.posix:k.win32,h=a.basename(i),u=a.dirname(i);return h.length?{name:h,parentPath:u}:{name:u,parentPath:""}}e.splitName=o}),define(ge[102],pe([0,1,30,10,9,23,8]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var y;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(y=e.Mimes||(e.Mimes={}));let _=[],I=[],n=[];function A(i,a=!1){const h=d(i);_.push(h),h.userConfigured?n.push(h):I.push(h),a&&!h.userConfigured&&_.forEach(u=>{u.mime===h.mime||u.userConfigured||(h.extension&&u.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&u.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&u.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&u.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=A;function d(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(k.posix.sep)>=0:!1}}function m(i){i?(_=_.filter(a=>!a.userConfigured),n=[]):(_=[],I=[],n=[])}e.clearTextMimes=m;function l(i,a){let h;if(i)switch(i.scheme){case L.Schemas.file:h=i.fsPath;break;case L.Schemas.data:h=C.DataUri.parseMetaData(i).get(C.DataUri.META_DATA_LABEL);break;default:h=i.path}if(!h)return[y.unknown];h=h.toLowerCase();const u=(0,k.basename)(h),w=v(h,u,n);if(w)return[w,y.text];const E=v(h,u,I);if(E)return[E,y.text];if(a){const s=S(a);if(s)return[s,y.text]}return[y.unknown]}e.guessMimeTypes=l;function v(i,a,h){let u=null,w=null,E=null;for(let s=h.length-1;s>=0;s--){const D=h[s];if(a===D.filenameLowercase){u=D;break}if(D.filepattern&&(!w||D.filepattern.length>w.filepattern.length)){const R=D.filepatternOnPath?i:a;(0,g.match)(D.filepatternLowercase,R)&&(w=D)}D.extension&&(!E||D.extension.length>E.extension.length)&&a.endsWith(D.extensionLowercase)&&(E=D)}return u?u.mime:w?w.mime:E?E.mime:null}function S(i){if((0,T.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let a=_.length-1;a>=0;a--){const h=_[a];if(!h.firstline)continue;const u=i.match(h.firstline);if(u&&u.length>0)return h.mime}return null}function b(i){return i?typeof i=="string"?i===y.binary||i===y.text||i===y.unknown:i.length===1&&b(i[0]):!0}e.isUnspecific=b;const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(i){const a=(0,k.extname)(i),h=P[a.toLowerCase()];return h!==void 0?h:p(i)}e.getMediaOrTextMime=f;function p(i){const a=(0,k.extname)(i);return c[a.toLowerCase()]}e.getMediaMime=p;function t(i){for(const a in c)if(c[a]===i)return a}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function o(i,a){const h=r.exec(i);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:a?void 0:i}e.normalizeMimeType=o}),define(ge[103],pe([0,1,2]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class k{constructor(A){this._uriTransformer=A}transformIncoming(A){const d=this._uriTransformer.transformIncoming(A);return d===A?A:L(g.URI.from(d))}transformOutgoing(A){const d=this._uriTransformer.transformOutgoing(A);return d===A?A:L(g.URI.from(d))}transformOutgoingURI(A){const d=this._uriTransformer.transformOutgoing(A);return d===A?A:g.URI.from(d)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,A,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return A.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const l=C(n[m],A,d+1);l!==null&&(n[m]=l)}}return null}function T(n,A){const d=C(n,A,0);return d===null?n:d}e.transformOutgoingURIs=T;function y(n,A,d,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?g.URI.revive(A.transformIncoming(n)):A.transformIncoming(n);for(let l in n)if(Object.hasOwnProperty.call(n,l)){const v=y(n[l],A,d,m+1);v!==null&&(n[l]=v)}}return null}function _(n,A){const d=y(n,A,!1,0);return d===null?n:d}e.transformIncomingURIs=_;function I(n,A){const d=y(n,A,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=I}),define(ge[32],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(_){return g.test(_)}e.isUUID=L;const k=new Uint8Array(16),C=[];for(let _=0;_<256;_++)C.push(_.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(_){for(let I=0;I<_.length;I++)_[I]=Math.floor(Math.random()*256);return _};function y(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let _=0,I="";return I+=C[k[_++]],I+=C[k[_++]],I+=C[k[_++]],I+=C[k[_++]],I+="-",I+=C[k[_++]],I+=C[k[_++]],I+="-",I+=C[k[_++]],I+=C[k[_++]],I+="-",I+=C[k[_++]],I+=C[k[_++]],I+="-",I+=C[k[_++]],I+=C[k[_++]],I+=C[k[_++]],I+=C[k[_++]],I+=C[k[_++]],I+=C[k[_++]],I}e.generateUuid=y}),define(ge[142],pe([0,1,104]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new g.StringDecoder(C),this.remaining=null}write(C){const T=[],y=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(y.length<1)return T;let _=0,I,n=_;for(;n<y.length;)if(I=y.charCodeAt(n),I===13||I===10){if(T.push(y.substring(_,n)),n++,n<y.length){const A=I;I=y.charCodeAt(n),(A===13&&I===10||A===10&&I===13)&&n++}_=n}else n++;return this.remaining=_<y.length?y.substr(_):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(ge[28],pe([0,1,49,78,289,17,29,76,9,11,23,2,32]),function(J,e,g,L,k,C,T,y,_,I,n,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function l(O,x=m.UNLINK){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?S(O):v(O)}async function v(O){try{const x=(0,_.join)((0,L.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(O,x)}catch(F){return S(O)}S(x).catch(F=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function S(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function b(O){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(O,{recursive:!0})}e.rimrafSync=b;async function P(O,x){return p(await(x?c(O):(0,k.promisify)(g.readdir)(O)))}async function c(O){try{return await(0,k.promisify)(g.readdir)(O,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const x=[],F=await P(O);for(const z of F){let M=!1,N=!1,q=!1;try{const B=await e.Promises.lstat((0,_.join)(O,z));M=B.isFile(),N=B.isDirectory(),q=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}x.push({name:z,isFile:()=>M,isDirectory:()=>N,isSymbolicLink:()=>q})}return x}function f(O){return p(g.readdirSync(O))}e.readdirSync=f;function p(O){return O.map(x=>typeof x=="string"?I.isMacintosh?(0,y.normalizeNFC)(x):x:(x.name=I.isMacintosh?(0,y.normalizeNFC)(x.name):x.name,x))}async function t(O){const x=await P(O),F=[];for(const z of x)await o.existsDirectory((0,_.join)(O,z))&&F.push(z);return F}function r(O,x=1e3){return new Promise(F=>{let z=!1;const M=setInterval(()=>{z||(z=!0,g.access(O,N=>{z=!1,N&&(clearInterval(M),F(void 0))}))},x)})}e.whenDeleted=r;var o;(function(O){async function x(M){let N;try{if(N=await e.Promises.lstat(M),!N.isSymbolicLink())return{stat:N}}catch(q){}try{return{stat:await e.Promises.stat(M),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw B}throw q}}O.stat=x;async function F(M){try{const{stat:N,symbolicLink:q}=await O.stat(M);return N.isFile()&&q?.dangling!==!0}catch(N){}return!1}O.existsFile=F;async function z(M){try{const{stat:N,symbolicLink:q}=await O.stat(M);return N.isDirectory()&&q?.dangling!==!0}catch(N){}return!1}O.existsDirectory=z})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function a(O,x,F){return i.queueFor(A.URI.file(O),n.extUriBiasedIgnorePathCase).queue(()=>{const z=E(F);return new Promise((M,N)=>u(O,x,z,q=>q?N(q):M()))})}let h=!0;function u(O,x,F,z){if(!h)return g.writeFile(O,x,{mode:F.mode,flag:F.flag},z);g.open(O,F.flag,F.mode,(M,N)=>{if(M)return z(M);g.writeFile(N,x,q=>{if(q)return g.close(N,()=>z(q));g.fdatasync(N,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),h=!1),g.close(N,K=>z(K))))})})}function w(O,x,F){const z=E(F);if(!h)return g.writeFileSync(O,x,{mode:z.mode,flag:z.flag});const M=g.openSync(O,z.flag,z.mode);try{g.writeFileSync(M,x);try{g.fdatasyncSync(M)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),h=!1}}finally{g.closeSync(M)}}e.writeFileSync=w;function E(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function s(O,x){if(O===x)return;async function F(z){try{const M=await e.Promises.lstat(z);if(M.isDirectory()||M.isSymbolicLink())return;await e.Promises.utimes(z,M.atime,new Date)}catch(M){}}try{await e.Promises.rename(O,x),await F(x)}catch(z){if(O.toLowerCase()!==x.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await D(O,x,{preserveSymlinks:!1}),await l(O,m.MOVE),await F(x);else throw z}}async function D(O,x,F){return U(O,x,{root:{source:O,target:x},options:F,handledSourcePaths:new Set})}const R=511;async function U(O,x,F){if(F.handledSourcePaths.has(O))return;F.handledSourcePaths.add(O);const{stat:z,symbolicLink:M}=await o.stat(O);if(M){if(F.options.preserveSymlinks)try{return await Q(O,x,F)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(M.dangling)return}return z.isDirectory()?V(O,x,z.mode&R,F):ee(O,x,z.mode&R)}async function V(O,x,F,z){await e.Promises.mkdir(x,{recursive:!0,mode:F});const M=await P(O);for(const N of M)await U((0,_.join)(O,N),(0,_.join)(x,N),z)}async function ee(O,x,F){await e.Promises.copyFile(O,x),await e.Promises.chmod(x,F)}async function Q(O,x,F){let z=await e.Promises.readlink(O);(0,T.isEqualOrParent)(z,F.root.source,!I.isLinux)&&(z=(0,_.join)(F.root.target,z.substr(F.root.source.length+1))),await e.Promises.symlink(z,x)}e.Promises=new class{get access(){return(0,k.promisify)(g.access)}get stat(){return(0,k.promisify)(g.stat)}get lstat(){return(0,k.promisify)(g.lstat)}get utimes(){return(0,k.promisify)(g.utimes)}get read(){return(0,k.promisify)(g.read)}get readFile(){return(0,k.promisify)(g.readFile)}get write(){return(0,k.promisify)(g.write)}get appendFile(){return(0,k.promisify)(g.appendFile)}get fdatasync(){return(0,k.promisify)(g.fdatasync)}get truncate(){return(0,k.promisify)(g.truncate)}get rename(){return(0,k.promisify)(g.rename)}get copyFile(){return(0,k.promisify)(g.copyFile)}get open(){return(0,k.promisify)(g.open)}get close(){return(0,k.promisify)(g.close)}get symlink(){return(0,k.promisify)(g.symlink)}get readlink(){return(0,k.promisify)(g.readlink)}get chmod(){return(0,k.promisify)(g.chmod)}get mkdir(){return(0,k.promisify)(g.mkdir)}get unlink(){return(0,k.promisify)(g.unlink)}get rmdir(){return(0,k.promisify)(g.rmdir)}get realpath(){return(0,k.promisify)(g.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return l}get move(){return s}get copy(){return D}}}),define(ge[105],pe([0,1,49,9,8,28]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(n){const A=(0,L.dirname)(n);if(n===A)return n;const d=((0,L.basename)(n)||n).toLowerCase();try{const l=(0,C.readdirSync)(A).filter(v=>v.toLowerCase()===d);if(l.length===1){const v=T(A);if(v)return(0,L.join)(v,l[0])}else if(l.length>1){const v=l.indexOf(d);if(v>=0){const S=T(A);if(S)return(0,L.join)(S,l[v])}}}catch(m){}return null}e.realcaseSync=T;async function y(n){try{return await C.Promises.realpath(n)}catch(A){const d=I(n);return await C.Promises.access(d,g.constants.R_OK),d}}e.realpath=y;function _(n){try{return g.realpathSync(n)}catch(A){const d=I(n);return g.accessSync(d,g.constants.R_OK),d}}e.realpathSync=_;function I(n){return(0,k.rtrim)((0,L.normalize)(n),L.sep)}});var ze=this&&this.__decorate||function(J,e,g,L){var k=arguments.length,C=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(J,e,g,L);else for(var y=J.length-1;y>=0;y--)(T=J[y])&&(C=(k<3?T(C):k>3?T(e,g,C):T(e,g))||C);return k>3&&C&&Object.defineProperty(e,g,C),C};define(ge[106],pe([0,1,20,17,24,21,56,16,3,6,59,8,14]),function(J,e,g,L,k,C,T,y,_,I,n,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function S(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(b||(b={}));class P{constructor(N){this.buffer=N,this.pos=0}read(N){const q=this.buffer.slice(this.pos,this.pos+N);return this.pos+=q.byteLength,q}}class c{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function p(M){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function t(M){return M.read(4).readUInt32BE(0)}function r(M){const N=k.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const o={Undefined:r(f.Undefined),String:r(f.String),Buffer:r(f.Buffer),VSBuffer:r(f.VSBuffer),Array:r(f.Array),Object:r(f.Object)},i=typeof Buffer!="undefined";function a(M,N){if(typeof N=="undefined")M.write(o.Undefined);else if(typeof N=="string"){const q=k.VSBuffer.fromString(N);M.write(o.String),M.write(p(q.byteLength)),M.write(q)}else if(i&&Buffer.isBuffer(N)){const q=k.VSBuffer.wrap(N);M.write(o.Buffer),M.write(p(q.byteLength)),M.write(q)}else if(N instanceof k.VSBuffer)M.write(o.VSBuffer),M.write(p(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(o.Array),M.write(p(N.length));for(const q of N)a(M,q)}else{const q=k.VSBuffer.fromString(JSON.stringify(N));M.write(o.Object),M.write(p(q.byteLength)),M.write(q)}}function h(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(t(M)).toString();case f.Buffer:return M.read(t(M)).buffer;case f.VSBuffer:return M.read(t(M));case f.Array:{const q=t(M),B=[];for(let K=0;K<q;K++)B.push(h(M));return B}case f.Object:return JSON.parse(M.read(t(M)).toString())}}class u{constructor(N,q,B=null,K=1e3){this.protocol=N,this.ctx=q,this.logger=B,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:200})}registerChannel(N,q){this.channels.set(N,q),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const q=this.send([N.type]);this.logger&&this.logger.logOutgoing(q,0,1,S(N.type));return}case 201:case 202:case 204:case 203:{const q=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(q,N.id,1,S(N.type),N.data);return}}}send(N,q=void 0){const B=new c;return a(B,N),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(q){return 0}}onRawMessage(N){const q=new P(N),B=h(q),K=h(q),te=B[0];switch(te){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(te)}: ${B[2]}.${B[3]}`,K),this.onPromise({type:te,id:B[1],channelName:B[2],name:B[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(te)}: ${B[2]}.${B[3]}`,K),this.onEventListen({type:te,id:B[1],channelName:B[2],name:B[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(te)}`),this.disposeActiveRequest({type:te,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(te)}`),this.disposeActiveRequest({type:te,id:B[1]})}}onPromise(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const B=new C.CancellationTokenSource;let K;try{K=q.call(this.ctx,N.name,N.arg,B.token)}catch(De){K=Promise.reject(De)}const te=N.id;K.then(De=>{this.sendResponse({id:te,data:De,type:201}),this.activeRequests.delete(N.id)},De=>{De instanceof Error?this.sendResponse({id:te,data:{message:De.message,name:De.name,stack:De.stack?De.stack.split?De.stack.split(`
`):De.stack:void 0},type:202}):this.sendResponse({id:te,data:De,type:203}),this.activeRequests.delete(N.id)});const he=(0,I.toDisposable)(()=>B.cancel());this.activeRequests.set(N.id,he)}onEventListen(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const B=N.id,te=q.listen(this.ctx,N.name,N.arg)(he=>this.sendResponse({id:B,data:he,type:204}));this.activeRequests.set(N.id,te)}disposeActiveRequest(N){const q=this.activeRequests.get(N.id);q&&(q.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let q=this.pendingRequests.get(N.channelName);q||(q=[],this.pendingRequests.set(N.channelName,q));const B=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:N,timeoutTimer:B})}flushPendingRequests(N){const q=this.pendingRequests.get(N);if(q){for(const B of q)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var w;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,q=null){this.protocol=N,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=q}getChannel(N){const q=this;return{call(B,K,te){return q.isDisposed?Promise.reject(y.canceled()):q.requestPromise(N,B,K,te)},listen(B,K){return q.isDisposed?Promise.reject(y.canceled()):q.requestEvent(N,B,K)}}}requestPromise(N,q,B,K=C.CancellationToken.None){const te=this.lastRequestId++,De={id:te,type:100,channelName:N,name:q,arg:B};if(K.isCancellationRequested)return Promise.reject(y.canceled());let Pe;return new Promise((qe,We)=>{if(K.isCancellationRequested)return We(y.canceled());const je=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(te),qe(Y.data);break;case 202:this.handlers.delete(te);const oe=new Error(Y.data.message);oe.stack=Y.data.stack,oe.name=Y.data.name,We(oe);break;case 203:this.handlers.delete(te),We(Y.data);break}};this.handlers.set(te,ae),this.sendRequest(De)};let W=null;this.state===b.Idle?je():(W=(0,L.createCancelablePromise)(ae=>this.whenInitialized()),W.then(()=>{W=null,je()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:te,type:101}),We(y.canceled())},ne=K.onCancellationRequested(Z);Pe=(0,I.combinedDisposable)((0,I.toDisposable)(Z),ne),this.activeRequests.add(Pe)}).finally(()=>{this.activeRequests.delete(Pe)})}requestEvent(N,q,B){const K=this.lastRequestId++,he={id:K,type:102,channelName:N,name:q,arg:B};let De=null;const Pe=new _.Emitter({onFirstListenerAdd:()=>{De=(0,L.createCancelablePromise)(qe=>this.whenInitialized()),De.then(()=>{De=null,this.activeRequests.add(Pe),this.sendRequest(he)})},onLastListenerRemove:()=>{De?(De.cancel(),De=null):(this.activeRequests.delete(Pe),this.sendRequest({id:K,type:103}))}}),Fe=qe=>Pe.fire(qe.data);return this.handlers.set(K,Fe),Pe.event}sendRequest(N){switch(N.type){case 100:case 102:{const q=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(q,N.id,0,`${l(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const q=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(q,N.id,0,l(N.type));return}}}send(N,q=void 0){const B=new c;return a(B,N),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(q){return 0}}onBuffer(N){const q=new P(N),B=h(q),K=h(q),te=B[0];switch(te){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,S(te)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],0,S(te),K),this.onResponse({type:B[0],id:B[1],data:K})}}onResponse(N){if(N.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(N.id);q&&q(N)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}ze([T.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class s{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:q,onDidClientDisconnect:B})=>{_.Event.once(q.onMessage)(te=>{const he=new P(te),De=h(he),Pe=new u(q,De),Fe=new E(q);this.channels.forEach((We,je)=>Pe.registerChannel(je,We));const qe={channelServer:Pe,channelClient:Fe,ctx:De};this._connections.add(qe),this._onDidAddConnection.fire(qe),B(()=>{Pe.dispose(),Fe.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const N=[];return this._connections.forEach(q=>N.push(q)),N}getChannel(N,q){const B=this;return{call(K,te,he){let De;if((0,d.isFunction)(q)){let Fe=(0,g.getRandomElement)(B.connections.filter(q));De=Fe?Promise.resolve(Fe):_.Event.toPromise(_.Event.filter(B.onDidAddConnection,q))}else De=q.routeCall(B,K,te);const Pe=De.then(Fe=>Fe.channelClient.getChannel(N));return R(Pe).call(K,te,he)},listen(K,te){if((0,d.isFunction)(q))return B.getMulticastEvent(N,q,K,te);const he=q.routeEvent(B,K,te).then(De=>De.channelClient.getChannel(N));return R(he).listen(K,te)}}}getMulticastEvent(N,q,B,K){const te=this;let he=new I.DisposableStore;const De=new _.Emitter({onFirstListenerAdd:()=>{he=new I.DisposableStore;const Pe=new _.EventMultiplexer,Fe=new Map,qe=je=>{const Z=je.channelClient.getChannel(N).listen(B,K),ne=Pe.add(Z);Fe.set(je,ne)},We=je=>{const W=Fe.get(je);!W||(W.dispose(),Fe.delete(je))};te.connections.filter(q).forEach(qe),_.Event.filter(te.onDidAddConnection,q)(qe,void 0,he),te.onDidRemoveConnection(We,void 0,he),Pe.event(De.fire,De,he),he.add(Pe)},onLastListenerRemove:()=>{he.dispose()}});return De.event}registerChannel(N,q){this.channels.set(N,q),this._connections.forEach(B=>{B.channelServer.registerChannel(N,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=s;class D{constructor(N,q,B=null){const K=new c;a(K,q),N.send(K.buffer),this.channelClient=new E(N,B),this.channelServer=new u(N,q,B)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,q){this.channelServer.registerChannel(N,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function R(M){return{call(N,q,B){return M.then(K=>K.call(N,q,B))},listen(N,q){const B=new _.Relay;return M.then(K=>B.input=K.listen(N,q)),B.event}}}e.getDelayedChannel=R;function U(M){let N=!1;return{call(q,B,K){return N?M.call(q,B,K):(0,L.timeout)(0).then(()=>N=!0).then(()=>M.call(q,B,K))},listen(q,B){if(N)return M.listen(q,B);const K=new _.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>K.input=M.listen(q,B)),K.event}}}e.getNextTickChannel=U;class V{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const q of N.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await _.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=V;var ee;(function(M){function N(K,te){const he=K,De=te&&te.disableMarshalling,Pe=new Map;for(const Fe in he)B(Fe)&&Pe.set(Fe,_.Event.buffer(he[Fe],!0));return new class{listen(Fe,qe){const We=Pe.get(qe);if(We)return We;throw new Error(`Event not found: ${qe}`)}call(Fe,qe,We){const je=he[qe];if(typeof je=="function"){if(!De&&Array.isArray(We))for(let W=0;W<We.length;W++)We[W]=(0,n.revive)(We[W]);return je.apply(he,We)}throw new Error(`Method not found: ${qe}`)}}}M.fromService=N;function q(K,te){const he=te&&te.disableMarshalling;return new Proxy({},{get(De,Pe){if(typeof Pe=="string")return te?.properties?.has(Pe)?te.properties.get(Pe):B(Pe)?K.listen(Pe):async function(...Fe){let qe;te&&!(0,d.isUndefinedOrNull)(te.context)?qe=[te.context,...Fe]:qe=Fe;const We=await K.call(Pe,qe);return he?We:(0,n.revive)(We)};throw new Error(`Property not found: ${String(Pe)}`)}})}M.toService=q;function B(K){return K[0]==="o"&&K[1]==="n"&&A.isUpperAsciiLetter(K.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function x(M){return Array.isArray(M)?M.map(O):O(M)}function F(M,N,q,B,K,te,he){he=x(he);const De=Q[K],Pe=De[B%De.length];let Fe=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Pe}`];/\($/.test(te)?(Fe=Fe.concat(he),Fe.push(")")):Fe.push(he),console.log.apply(console,Fe)}e.logWithColors=F;class z{constructor(N,q){this._outgoingPrefix=N,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,q,B,K,te){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,q,B,K,te)}logIncoming(N,q,B,K,te){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,q,B,K,te)}}e.IPCLogger=z}),define(ge[107],pe([0,1,24,3,6,11,38,106]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var _;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function n(){return I||(I=g.VSBuffer.alloc(0)),I}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,a){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const E=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=i),E}if(this._chunks[0].byteLength>i){const E=this._chunks[0].slice(0,i);return a&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),E}let h=g.VSBuffer.alloc(i),u=0,w=0;for(;i>0;){const E=this._chunks[w];if(E.byteLength>i){const s=E.slice(0,i);h.set(s,u),u+=i,a&&(this._chunks[w]=E.slice(i),this._totalLength-=i),i-=i}else h.set(E,u),u+=E.byteLength,a?(this._chunks.shift(),this._totalLength-=E.byteLength):w++,i-=E.byteLength}return h}}e.ChunkStream=A;var d;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.KeepAlive=4]="KeepAlive",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var m;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",o[o.KeepAliveTime=5e3]="KeepAliveTime",o[o.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(i,a,h,u){this.type=i,this.id=a,this.ack=h,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const h=this._state.messageType,u=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new l(h,u,w,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=g.VSBuffer.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this._writeSoon(a,i.data)}_bufferAdd(i,a){const h=this._totalLength===0;return this._data.push(i,a),this._totalLength+=i.byteLength+a.byteLength,h}_bufferTake(){const i=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,a){this._bufferAdd(i,a)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends k.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new l(1,0,0,i))}}e.Protocol=b;class P extends y.IPCClient{constructor(i,a,h=null){super(i,a,h);this.protocol=i}static fromSocket(i,a){return new P(new b(i),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=P;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,T.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class f{constructor(i){this.data=i,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],a=0,h=this._first;for(;h;)i[a++]=h.data,h=h.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const a=new f(i);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=i-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let h=0;for(let u=0;u<t._HISTORY_LENGTH;u++)i-this.lastRuns[u]<=a&&h++;return 1-h/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(i,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new l(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const a=new l(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let a=0,h=i.length;a<h;a++)this._socketWriter.write(i[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new l(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const a=this._outgoingUnackMsg.toArray();for(let h=0,u=a.length;h<u;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new l(1,a,this._incomingAckId,i);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(i){const a=new l(2,0,0,i);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),a=Date.now()-i.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new l(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(ge[108],pe([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(y){let _=(0,g.toUint8)(y);this._defaultValue=_,this._asciiMap=L._createAsciiMap(_),this._map=new Map}static _createAsciiMap(y){let _=new Uint8Array(256);for(let I=0;I<256;I++)_[I]=y;return _}set(y,_){let I=(0,g.toUint8)(_);y>=0&&y<256?this._asciiMap[y]=I:this._map.set(y,I)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=L;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class C{constructor(){this._actual=new L(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=C}),define(ge[143],pe([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends g.CharacterClassifier{constructor(y){super(0);for(let _=0,I=y.length;_<I;_++)this.set(y.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function C(T){let y={};return _=>(y.hasOwnProperty(_)||(y[_]=T(_)),y[_])}e.getMapForWordSeparators=C(T=>new k(T))}),define(ge[50],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(k,C){this.lineNumber=k,this.column=C}with(k=this.lineNumber,C=this.column){return k===this.lineNumber&&C===this.column?this:new g(k,C)}delta(k=0,C=0){return this.with(this.lineNumber+k,this.column+C)}equals(k){return g.equals(this,k)}static equals(k,C){return!k&&!C?!0:!!k&&!!C&&k.lineNumber===C.lineNumber&&k.column===C.column}isBefore(k){return g.isBefore(this,k)}static isBefore(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<C.column}isBeforeOrEqual(k){return g.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<=C.column}static compare(k,C){let T=k.lineNumber|0,y=C.lineNumber|0;if(T===y){let _=k.column|0,I=C.column|0;return _-I}return T-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new g(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=g}),define(ge[41],pe([0,1,50]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,T,y,_){C>y||C===y&&T>_?(this.startLineNumber=y,this.startColumn=_,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=y,this.endColumn=_)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,T){let y,_,I,n;return T.startLineNumber<C.startLineNumber?(y=T.startLineNumber,_=T.startColumn):T.startLineNumber===C.startLineNumber?(y=T.startLineNumber,_=Math.min(T.startColumn,C.startColumn)):(y=C.startLineNumber,_=C.startColumn),T.endLineNumber>C.endLineNumber?(I=T.endLineNumber,n=T.endColumn):T.endLineNumber===C.endLineNumber?(I=T.endLineNumber,n=Math.max(T.endColumn,C.endColumn)):(I=C.endLineNumber,n=C.endColumn),new L(y,_,I,n)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,T){let y=C.startLineNumber,_=C.startColumn,I=C.endLineNumber,n=C.endColumn,A=T.startLineNumber,d=T.startColumn,m=T.endLineNumber,l=T.endColumn;return y<A?(y=A,_=d):y===A&&(_=Math.max(_,d)),I>m?(I=m,n=l):I===m&&(n=Math.min(n,l)),y>I||y===I&&_>n?null:new L(y,_,I,n)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new g.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new g.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new L(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new L(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new L(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const I=C.startLineNumber|0,n=T.startLineNumber|0;if(I===n){const A=C.startColumn|0,d=T.startColumn|0;if(A===d){const m=C.endLineNumber|0,l=T.endLineNumber|0;if(m===l){const v=C.endColumn|0,S=T.endColumn|0;return v-S}return m-l}return A-d}return I-n}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(ge[144],pe([0,1,50,41]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(y,_,I,n){super(y,_,I,n);this.selectionStartLineNumber=y,this.selectionStartColumn=_,this.positionLineNumber=I,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return C.selectionsEqual(this,y)}static selectionsEqual(y,_){return y.selectionStartLineNumber===_.selectionStartLineNumber&&y.selectionStartColumn===_.selectionStartColumn&&y.positionLineNumber===_.positionLineNumber&&y.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,_){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,y,_):new C(y,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,_){return this.getDirection()===0?new C(y,_,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,y,_)}static fromPositions(y,_=y){return new C(y.lineNumber,y.column,_.lineNumber,_.column)}static liftSelection(y){return new C(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,_){if(y&&!_||!y&&_)return!1;if(!y&&!_)return!0;if(y.length!==_.length)return!1;for(let I=0,n=y.length;I<n;I++)if(!this.selectionsEqual(y[I],_[I]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,_,I,n,A){return A===0?new C(y,_,I,n):new C(I,n,y,_)}}e.Selection=C}),define(ge[109],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var L;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(L=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var C;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(C=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace)}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class _{constructor(v,S){this._findMatchBrand=void 0,this.range=v,this.matches=S}}e.FindMatch=_;var I;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var A;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class d{constructor(v,S,b,P,c,f){this.identifier=v,this.range=S,this.text=b,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=c,this._isTracked=f}}e.ValidAnnotatedEditOperation=d;class m{constructor(v,S,b){this.reverseEdits=v,this.changes=S,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=m}),define(ge[145],pe([0,1,8,143,50,41,109]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class _{constructor(c,f,p,t){this.searchString=c,this.isRegex=f,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=I(this.searchString):c=this.searchString.indexOf(`
`)>=0;let f=null;try{f=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let p=!this.isRegex&&!c;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(f,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=_;function I(P){if(!P||P.length===0)return!1;for(let c=0,f=P.length;c<f;c++)if(P.charCodeAt(c)===92){if(c++,c>=f)break;const t=P.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=I;class n{constructor(c,f,p){this.regex=c,this.wordSeparators=f,this.simpleSearch=p}}e.SearchData=n;function A(P,c,f){if(!f)return new T.FindMatch(P,null);let p=[];for(let t=0,r=c.length;t<r;t++)p[t]=c[t];return new T.FindMatch(P,p)}e.createFindMatch=A;class d{constructor(c){let f=[],p=0;for(let t=0,r=c.length;t<r;t++)c.charCodeAt(t)===10&&(f[p++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(c){const f=this._lineFeedsOffsets;let p=0,t=f.length-1;if(t===-1||c<=f[0])return 0;for(;p<t;){const r=p+((t-p)/2>>0);f[r]>=c?t=r-1:f[r+1]>=c?(p=r,t=r):p=r+1}return p+1}}class m{static findMatches(c,f,p,t,r){const o=f.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(c,p,new b(o.wordSeparators,o.regex),t,r):this._doFindMatchesLineByLine(c,p,o,t,r):[]}static _getMultilineMatchRange(c,f,p,t,r,o){let i,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),i=f+r+a):i=f+r;let h;if(t){let s=t.findLineFeedCountBeforeOffset(r+o.length)-a;h=i+o.length+s}else h=i+o.length;const u=c.getPositionAt(i),w=c.getPositionAt(h);return new C.Range(u.lineNumber,u.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(c,f,p,t,r){const o=c.getOffsetAt(f.getStartPosition()),i=c.getValueInRange(f,1),a=c.getEOL()===`\r
`?new d(i):null,h=[];let u=0,w;for(p.reset(0);w=p.next(i);)if(h[u++]=A(this._getMultilineMatchRange(c,o,i,a,w.index,w[0]),w,t),u>=r)return h;return h}static _doFindMatchesLineByLine(c,f,p,t,r){const o=[];let i=0;if(f.startLineNumber===f.endLineNumber){const h=c.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return i=this._findMatchesInLine(p,h,f.startLineNumber,f.startColumn-1,i,o,t,r),o}const a=c.getLineContent(f.startLineNumber).substring(f.startColumn-1);i=this._findMatchesInLine(p,a,f.startLineNumber,f.startColumn-1,i,o,t,r);for(let h=f.startLineNumber+1;h<f.endLineNumber&&i<r;h++)i=this._findMatchesInLine(p,c.getLineContent(h),h,0,i,o,t,r);if(i<r){const h=c.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);i=this._findMatchesInLine(p,h,f.endLineNumber,0,i,o,t,r)}return o}static _findMatchesInLine(c,f,p,t,r,o,i,a){const h=c.wordSeparators;if(!i&&c.simpleSearch){const E=c.simpleSearch,s=E.length,D=f.length;let R=-s;for(;(R=f.indexOf(E,R+s))!==-1;)if((!h||S(h,f,D,R,s))&&(o[r++]=new T.FindMatch(new C.Range(p,R+1+t,p,R+1+s+t),null),r>=a))return r;return r}const u=new b(c.wordSeparators,c.regex);let w;u.reset(0);do if(w=u.next(f),w&&(o[r++]=A(new C.Range(p,w.index+1+t,p,w.index+1+w[0].length+t),w,i),r>=a))return r;while(w);return r}static findNextMatch(c,f,p,t){const r=f.parseSearchRequest();if(!r)return null;const o=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(c,p,o,t):this._doFindNextMatchLineByLine(c,p,o,t)}static _doFindNextMatchMultiline(c,f,p,t){const r=new k.Position(f.lineNumber,1),o=c.getOffsetAt(r),i=c.getLineCount(),a=c.getValueInRange(new C.Range(r.lineNumber,r.column,i,c.getLineMaxColumn(i)),1),h=c.getEOL()===`\r
`?new d(a):null;p.reset(f.column-1);let u=p.next(a);return u?A(this._getMultilineMatchRange(c,o,a,h,u.index,u[0]),u,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(c,new k.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(c,f,p,t){const r=c.getLineCount(),o=f.lineNumber,i=c.getLineContent(o),a=this._findFirstMatchInLine(p,i,o,f.column,t);if(a)return a;for(let h=1;h<=r;h++){const u=(o+h-1)%r,w=c.getLineContent(u+1),E=this._findFirstMatchInLine(p,w,u+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(c,f,p,t,r){c.reset(t-1);const o=c.next(f);return o?A(new C.Range(p,o.index+1,p,o.index+1+o[0].length),o,r):null}static findPreviousMatch(c,f,p,t){const r=f.parseSearchRequest();if(!r)return null;const o=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(c,p,o,t):this._doFindPreviousMatchLineByLine(c,p,o,t)}static _doFindPreviousMatchMultiline(c,f,p,t){const r=this._doFindMatchesMultiline(c,new C.Range(1,1,f.lineNumber,f.column),p,t,10*y);if(r.length>0)return r[r.length-1];const o=c.getLineCount();return f.lineNumber!==o||f.column!==c.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(c,new k.Position(o,c.getLineMaxColumn(o)),p,t):null}static _doFindPreviousMatchLineByLine(c,f,p,t){const r=c.getLineCount(),o=f.lineNumber,i=c.getLineContent(o).substring(0,f.column-1),a=this._findLastMatchInLine(p,i,o,t);if(a)return a;for(let h=1;h<=r;h++){const u=(r+o-h-1)%r,w=c.getLineContent(u+1),E=this._findLastMatchInLine(p,w,u+1,t);if(E)return E}return null}static _findLastMatchInLine(c,f,p,t){let r=null,o;for(c.reset(0);o=c.next(f);)r=A(new C.Range(p,o.index+1,p,o.index+1+o[0].length),o,t);return r}}e.TextModelSearch=m;function l(P,c,f,p,t){if(p===0)return!0;const r=c.charCodeAt(p-1);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(p);if(P.get(o)!==0)return!0}return!1}function v(P,c,f,p,t){if(p+t===f)return!0;const r=c.charCodeAt(p+t);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(p+t-1);if(P.get(o)!==0)return!0}return!1}function S(P,c,f,p,t){return l(P,c,f,p,t)&&v(P,c,f,p,t)}e.isValidMatch=S;class b{constructor(c,f){this._wordSeparators=c,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const f=c.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(p=this._searchRegex.exec(c),!p))return null;const t=p.index,r=p[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(c,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||S(this._wordSeparators,c,f,t,r))return p}while(p);return null}}e.Searcher=b}),define(ge[110],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)y.indexOf(I)>=0||(_+="\\"+I);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function L(y){let _=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)_=y;else{let I="g";y.ignoreCase&&(I+="i"),y.multiline&&(I+="m"),y.unicode&&(I+="u"),_=new RegExp(y.source,I)}return _.lastIndex=0,_}e.ensureValidWordDefinition=L;const k={maxLen:1e3,windowSize:15,timeBudget:150};function C(y,_,I,n,A=k){if(I.length>A.maxLen){let S=y-A.maxLen/2;return S<0?S=0:n+=S,I=I.substring(S,y+A.maxLen/2),C(y,_,I,n,A)}const d=Date.now(),m=y-1-n;let l=-1,v=null;for(let S=1;!(Date.now()-d>=A.timeBudget);S++){const b=m-A.windowSize*S;_.lastIndex=Math.max(0,b);const P=T(_,I,m,l);if(!P&&v||(v=P,b<=0))break;l=b}if(v){let S={word:v[0],startColumn:n+1+v.index,endColumn:n+1+v.index+v[0].length};return _.lastIndex=0,S}return null}e.getWordAtText=C;function T(y,_,I,n){let A;for(;A=y.exec(_);){const d=A.index||0;if(d<=I&&y.lastIndex>=I)return A;if(n>0&&d>n)return null}return null}}),define(ge[146],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(y){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let _=0,I=y.notIn.length;_<I;_++)switch(y.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=L;class k{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of y)C(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),C(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),C(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),C(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&C(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=k;function C(T,y,_){T.has(y)?T.get(y).push(_):T.set(y,[_])}}),define(ge[79],pe([0,1,30,9]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(C,T,y,_){if(Array.isArray(C)){let I=0;for(const n of C){const A=k(n,T,y,_);if(A===10)return A;A>I&&(I=A)}return I}else{if(typeof C=="string")return _?C==="*"?5:C===y?10:0:0;if(C){const{language:I,pattern:n,scheme:A,hasAccessToAllModels:d}=C;if(!_&&!d)return 0;let m=0;if(A)if(A===T.scheme)m=10;else if(A==="*")m=5;else return 0;if(I)if(I===y)m=10;else if(I==="*")m=Math.max(m,5);else return 0;if(n){let l;if(typeof n=="string"?l=n:l={...n,base:(0,L.normalize)(n.base)},l===T.fsPath||(0,g.match)(l,T.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(ge[147],pe([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class k{constructor(l,v,S){const b=new Uint8Array(l*v);for(let P=0,c=l*v;P<c;P++)b[P]=S;this._data=b,this.rows=l,this.cols=v}get(l,v){return this._data[l*this.cols+v]}set(l,v,S){this._data[l*this.cols+v]=S}}e.Uint8Matrix=k;class C{constructor(l){let v=0,S=0;for(let P=0,c=l.length;P<c;P++){let[f,p,t]=l[P];p>v&&(v=p),f>S&&(S=f),t>S&&(S=t)}v++,S++;let b=new k(S,v,0);for(let P=0,c=l.length;P<c;P++){let[f,p,t]=l[P];b.set(f,p,t)}this._states=b,this._maxCharCode=v}nextState(l,v){return v<0||v>=this._maxCharCode?0:this._states.get(l,v)}}e.StateMachine=C;let T=null;function y(){return T===null&&(T=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var _;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let I=null;function n(){if(I===null){I=new g.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)I.set(m.charCodeAt(v),1);const l=".,;";for(let v=0;v<l.length;v++)I.set(l.charCodeAt(v),2)}return I}class A{static _createLink(l,v,S,b,P){let c=P-1;do{const f=v.charCodeAt(c);if(l.get(f)!==2)break;c--}while(c>b);if(b>0){const f=v.charCodeAt(b-1),p=v.charCodeAt(c);(f===40&&p===41||f===91&&p===93||f===123&&p===125)&&c--}return{range:{startLineNumber:S,startColumn:b+1,endLineNumber:S,endColumn:c+2},url:v.substring(b,c+1)}}static computeLinks(l,v=y()){const S=n();let b=[];for(let P=1,c=l.getLineCount();P<=c;P++){const f=l.getLineContent(P),p=f.length;let t=0,r=0,o=0,i=1,a=!1,h=!1,u=!1,w=!1;for(;t<p;){let E=!1;const s=f.charCodeAt(t);if(i===13){let D;switch(s){case 40:a=!0,D=0;break;case 41:D=a?0:1;break;case 91:u=!0,h=!0,D=0;break;case 93:u=!1,D=h?0:1;break;case 123:w=!0,D=0;break;case 125:D=w?0:1;break;case 39:D=o===34||o===96?0:1;break;case 34:D=o===39||o===96?0:1;break;case 96:D=o===39||o===34?0:1;break;case 42:D=o===42?1:0;break;case 124:D=o===124?1:0;break;case 32:D=u?0:1;break;default:D=S.get(s)}D===1&&(b.push(A._createLink(S,f,P,r,t)),E=!0)}else if(i===12){let D;s===91?(h=!0,D=0):D=S.get(s),D===1?E=!0:i=13}else i=v.nextState(i,s),i===0&&(E=!0);E&&(i=1,a=!1,h=!1,w=!1,r=t+1,o=s),t++}i===13&&b.push(A._createLink(S,f,P,r,p))}return b}}e.LinkComputer=A;function d(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:A.computeLinks(m)}e.computeLinks=d}),define(ge[148],pe([0,1,3,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,y){return this._map.set(T,y),this.fire([T]),(0,L.toDisposable)(()=>{this._map.get(T)===y&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,y){let _=null,I=!1;return this._promises.set(T,y.then(n=>{this._promises.delete(T),!(I||!n)&&(_=this.register(T,n))})),(0,L.toDisposable)(()=>{I=!0,_&&_.dispose()})}getPromise(T){const y=this.get(T);if(y)return Promise.resolve(y);const _=this._promises.get(T);return _?_.then(I=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(ge[111],pe([0,1,24,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(k||(k={}));function C(A){for(let d=0,m=A.length;d<m;d+=4){const l=A[d+0],v=A[d+1],S=A[d+2],b=A[d+3];A[d+0]=b,A[d+1]=S,A[d+2]=v,A[d+3]=l}}function T(A){const d=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return L.isLittleEndian()||C(d),g.VSBuffer.wrap(d)}function y(A){const d=A.buffer;if(L.isLittleEndian()||C(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const m=new Uint8Array(d.byteLength);return m.set(d),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function _(A){const d=new Uint32Array(I(A));let m=0;if(d[m++]=A.id,A.type==="full")d[m++]=1,d[m++]=A.data.length,d.set(A.data,m),m+=A.data.length;else{d[m++]=2,d[m++]=A.deltas.length;for(const l of A.deltas)d[m++]=l.start,d[m++]=l.deleteCount,l.data?(d[m++]=l.data.length,d.set(l.data,m),m+=l.data.length):d[m++]=0}return T(d)}e.encodeSemanticTokensDto=_;function I(A){let d=0;if(d+=1+1,A.type==="full")d+=1+A.data.length;else{d+=1,d+=(1+1+1)*A.deltas.length;for(const m of A.deltas)m.data&&(d+=m.data.length)}return d}function n(A){const d=y(A);let m=0;const l=d[m++];if(d[m++]===1){const P=d[m++],c=d.subarray(m,m+P);return m+=P,{id:l,type:"full",data:c}}const S=d[m++];let b=[];for(let P=0;P<S;P++){const c=d[m++],f=d[m++],p=d[m++];let t;p>0&&(t=d.subarray(m,m+p),m+=p),b[P]={start:c,deleteCount:f,data:t}}return{id:l,type:"delta",deltas:b}}e.decodeSemanticTokensDto=n}),define(ge[112],pe([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(T,y){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=y}}e.PrefixSumIndexOfResult=L;class k{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,y){T=(0,g.toUint32)(T);const _=this.values,I=this.prefixSum,n=y.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,T),0),this.values.set(_.subarray(T),T+n),this.values.set(y,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,y){return T=(0,g.toUint32)(T),y=(0,g.toUint32)(y),this.values[T]===y?!1:(this.values[T]=y,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,y){T=(0,g.toUint32)(T),y=(0,g.toUint32)(y);const _=this.values,I=this.prefixSum;if(T>=_.length)return!1;let n=_.length-T;return y>=n&&(y=n),y===0?!1:(this.values=new Uint32Array(_.length-y),this.values.set(_.subarray(0,T),0),this.values.set(_.subarray(T+y),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,g.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),T>=this.values.length&&(T=this.values.length-1);for(let _=y;_<=T;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let y=0,_=this.values.length-1,I=0,n=0,A=0;for(;y<=_;)if(I=y+(_-y)/2|0,n=this.prefixSum[I],A=n-this.values[I],T<A)_=I-1;else if(T>=n)y=I+1;else break;return new L(I,T-A)}}e.PrefixSumComputer=k}),define(ge[149],pe([0,1,8,50,112]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(y,_,I,n){this._uri=y,this._lines=_,this._eol=I,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const _=y.changes;for(const I of _)this._acceptDeleteRange(I.range),this._acceptInsertText(new L.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,_=this._lines.length,I=new Uint32Array(_);for(let n=0;n<_;n++)I[n]=this._lines[n].length+y;this._lineStarts=new k.PrefixSumComputer(I)}}_setLineText(y,_){this._lines[y]=_,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,_){if(_.length===0)return;let I=(0,g.splitLines)(_);if(I.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}I[I.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]);let n=new Uint32Array(I.length-1);for(let A=1;A<I.length;A++)this._lines.splice(y.lineNumber+A-1,0,I[A]),n[A-1]=I[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,n)}}e.MirrorTextModel=C}),define(ge[150],pe([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(ge[151],pe([0,1,150]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,C=k*24,T=C*7,y=C*30,_=C*365;function I(A,d){typeof A!="number"&&(A=A.getTime());const m=Math.round((new Date().getTime()-A)/1e3);if(m<-30)return(0,g.localize)(0,null,I(new Date().getTime()+m*1e3,!1));if(m<30)return(0,g.localize)(1,null);let l;return m<L?(l=m,d?l===1?(0,g.localize)(2,null,l):(0,g.localize)(3,null,l):l===1?(0,g.localize)(4,null,l):(0,g.localize)(5,null,l)):m<k?(l=Math.floor(m/L),d?l===1?(0,g.localize)(6,null,l):(0,g.localize)(7,null,l):l===1?(0,g.localize)(8,null,l):(0,g.localize)(9,null,l)):m<C?(l=Math.floor(m/k),d?l===1?(0,g.localize)(10,null,l):(0,g.localize)(11,null,l):l===1?(0,g.localize)(12,null,l):(0,g.localize)(13,null,l)):m<T?(l=Math.floor(m/C),d?l===1?(0,g.localize)(14,null,l):(0,g.localize)(15,null,l):l===1?(0,g.localize)(16,null,l):(0,g.localize)(17,null,l)):m<y?(l=Math.floor(m/T),d?l===1?(0,g.localize)(18,null,l):(0,g.localize)(19,null,l):l===1?(0,g.localize)(20,null,l):(0,g.localize)(21,null,l)):m<_?(l=Math.floor(m/y),d?l===1?(0,g.localize)(22,null,l):(0,g.localize)(23,null,l):l===1?(0,g.localize)(24,null,l):(0,g.localize)(25,null,l)):(l=Math.floor(m/_),d?l===1?(0,g.localize)(26,null,l):(0,g.localize)(27,null,l):l===1?(0,g.localize)(28,null,l):(0,g.localize)(29,null,l))}e.fromNow=I;function n(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(ge[152],pe([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ge[60],pe([0,1,20,14,152]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(I,n){return n&&(I.stack||I.stacktrace)?k.localize(0,null,y(I),T(I.stack)||T(I.stacktrace)):y(I)}function T(I){return Array.isArray(I)?I.join(`
`):I}function y(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?k.localize(1,null,I.message):I.message||k.localize(2,null)}function _(I=null,n=!1){if(!I)return k.localize(3,null);if(Array.isArray(I)){const A=g.coalesce(I),d=_(A[0],n);return A.length>1?k.localize(4,null,d,A.length):d}if(L.isString(I))return I;if(I.detail){const A=I.detail;if(A.error)return C(A.error,n);if(A.exception)return C(A.exception,n)}return I.stack?C(I,n):I.message?I.message:k.localize(5,null)}e.toErrorMessage=_}),define(ge[153],pe([18,19]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ge[113],pe([0,1,39,29,10,25,9,11,38,14,142,28,153]),function(J,e,g,L,k,C,T,y,_,I,n,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(f,p){if(y.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const r=g.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],t);return new Promise(o=>{r.once("error",i=>{o({success:!1,error:i})}),r.once("exit",(i,a)=>{o(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(y.isLinux||y.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(r=>{g.execFile(t,[f.pid.toString()],{encoding:"utf8",shell:!0},(o,i,a)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function v(f=_.env){return f.comspec||"cmd.exe"}e.getWindowsShell=v;class S{constructor(p,t,r,o){if(t!==void 0&&r!==void 0&&o!==void 0)this.cmd=p,this.args=t,this.shell=r,this.options=o;else{const i=p;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(_.env).forEach(a=>{i[a]=_.env[a]}),Object.keys(this.options.env).forEach(a=>{i[a]=this.options.env[a]}),this.options.env=i}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(T.sep);return t!==-1&&(p=p.substring(t+1)),S.WellKnowCommands[p]?p:"other"}start(p){return y.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(_.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(t=>{let r,o;const i=new Promise((a,h)=>{r=a,o=h});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=g.exec(a,this.options,(h,u,w)=>{this.childProcess=null;const E=h;E&&E.killed?o({killed:this.terminateRequested,stdout:u.toString(),stderr:w.toString()}):this.handleExec(r,p,h,u,w)})}else{let a=null;const h=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,r,p,o);const w={terminated:this.terminateRequested};I.isNumber(u)&&(w.cmdCode=u),r(w)};if(this.shell&&y.isWindows){const u=C.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let w=!1,E=!1;const s=[];let D=this.ensureQuotes(this.cmd);s.push(D.value),w=D.quoted,this.args&&this.args.forEach(U=>{D=this.ensureQuotes(U),s.push(D.value),E=E&&D.quoted});const R=["/s","/c"];w?E?R.push('"'+s.join(" ")+'"'):s.length>1?R.push('"'+s[0]+'" '+s.slice(1).join(" ")):R.push('"'+s[0]+'"'):R.push(s.join(" ")),a=g.spawn(v(),R,u)}else this.cmd&&(a=g.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(I.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",u=>{this.childProcess=null,o({terminated:this.terminateRequested,error:u})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,r,p,o,!0)))}return i})}handleClose(p,t,r,o){}ensureQuotes(p){return S.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,l(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!y.isWindows)return p(!1);const t=g.spawn(v(),["/s","/c"]);t.on("error",r=>p(!0)),t.on("exit",r=>p(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class b extends S{constructor(p,t,r,o){super(p,t,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,r,o,i){[o,i].forEach((a,h)=>{const u=new n.LineDecoder;u.write(a).forEach(s=>{t({line:s,source:h===0?0:1})});const E=u.end();E&&t({line:E,source:h===0?0:1})}),p({terminated:this.terminateRequested,error:r})}handleSpawn(p,t,r,o,i){const a=new n.LineDecoder,h=new n.LineDecoder;p.stdout.on("data",u=>{a.write(u).forEach(E=>r({line:E,source:0}))}),p.stderr.on("data",u=>{h.write(u).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(p,t,r,o){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&r({line:a,source:1})}}e.LineProcess=b;function P(f){let p=[],t=!1;const r=function(o){if(t){p.push(o);return}(!f.send(o,a=>{if(a&&console.error(a),t=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(u=>r(u))}})||y.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=P;var c;(function(f){async function p(t,r,o){if(T.isAbsolute(t))return t;if(r===void 0&&(r=_.cwd()),T.dirname(t)!=="."||(o===void 0&&I.isString(_.env.PATH)&&(o=_.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(r,t);async function a(h){return await A.Promises.exists(h)?!(await A.Promises.stat(h)).isDirectory():!1}for(let h of o){let u;if(T.isAbsolute(h)?u=T.join(h,t):u=T.join(r,h,t),await a(u))return u;let w=u+".com";if(await a(w)||(w=u+".exe",await a(w)))return w}return T.join(r,t)}f.findExecutable=p})(c=e.win32||(e.win32={}))}),define(ge[154],pe([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ge[114],pe([0,1,154,11,110]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=T;class y{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,me){this._values[re]=me}}e.ValidatedEditorOptions=y;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class I{constructor(re,me,xe,Be){this.id=re,this.name=me,this.defaultValue=xe,this.schema=Be}compute(re,me,xe){return xe}}class n{constructor(re,me=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(re){return this.defaultValue}}class A{constructor(re,me,xe,Be){this.id=re,this.name=me,this.defaultValue=xe,this.schema=Be}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,me,xe){return xe}}function d(X,re){return typeof X=="undefined"?re:X==="false"?!1:Boolean(X)}e.boolean=d;class m extends A{constructor(re,me,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="boolean",Be.default=xe),super(re,me,xe,Be)}validate(re){return d(re,this.defaultValue)}}class l extends A{constructor(re,me,xe,Be,et,ke=void 0){typeof ke!="undefined"&&(ke.type="integer",ke.default=xe,ke.minimum=Be,ke.maximum=et),super(re,me,xe,ke),this.minimum=Be,this.maximum=et}static clampedInt(re,me,xe,Be){if(typeof re=="undefined")return me;let et=parseInt(re,10);return isNaN(et)?me:(et=Math.max(xe,et),et=Math.min(Be,et),et|0)}validate(re){return l.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class v extends A{constructor(re,me,xe,Be,et){typeof et!="undefined"&&(et.type="number",et.default=xe),super(re,me,xe,et),this.validationFn=Be}static clamp(re,me,xe){return re<me?me:re>xe?xe:re}static float(re,me){if(typeof re=="number")return re;if(typeof re=="undefined")return me;const xe=parseFloat(re);return isNaN(xe)?me:xe}validate(re){return this.validationFn(v.float(re,this.defaultValue))}}class S extends A{static string(re,me){return typeof re!="string"?me:re}constructor(re,me,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.default=xe),super(re,me,xe,Be)}validate(re){return S.string(re,this.defaultValue)}}function b(X,re,me){return typeof X!="string"||me.indexOf(X)===-1?re:X}e.stringSet=b;class P extends A{constructor(re,me,xe,Be,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=Be,et.default=xe),super(re,me,xe,et),this._allowedValues=Be}validate(re){return b(re,this.defaultValue,this._allowedValues)}}class c extends I{constructor(re,me,xe,Be,et,ke,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.enum=et,Ce.default=Be),super(re,me,xe,Ce),this._allowedValues=et,this._convert=ke}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function f(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,me,xe){return xe===0?re.accessibilitySupport:xe}}class t extends I{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:g.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{insertSpace:d(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(X){switch(X){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function h(X){switch(X){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class u extends n{constructor(){super(126,[64,31])}compute(re,me,xe){const Be=["monaco-editor"];return me.get(31)&&Be.push(me.get(31)),re.extraEditorClassName&&Be.push(re.extraEditorClassName),me.get(64)==="default"?Be.push("mouse-default"):me.get(64)==="copy"&&Be.push("mouse-copy"),me.get(99)&&Be.push("showUnused"),me.get(124)&&Be.push("showDeprecated"),Be.join(" ")}}class w extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(re,me,xe){return xe&&re.emptySelectionClipboard}}class E extends I{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:g.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{cursorMoveOnType:d(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(me.loop,this.defaultValue.loop)}}}class s extends I{constructor(){super(42,"fontLigatures",s.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?s.OFF:re==="true"?s.ON:re:Boolean(re)?s.ON:s.OFF}}e.EditorFontLigatures=s,s.OFF='"liga" off, "calt" off',s.ON='"liga" on, "calt" on';class D extends n{constructor(){super(41)}compute(re,me,xe){return re.fontInfo}}class R extends A{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(re){let me=v.float(re,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(me,6,100)}compute(re,me,xe){return re.fontInfo.fontSize}}class U extends I{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(re){return re==="normal"||re==="bold"?re:String(l.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class V extends I{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:xe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:xe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:xe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:xe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:xe,description:g.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends I{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(51,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:re.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:g.localize(41,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{enabled:d(me.enabled,this.defaultValue.enabled),delay:l.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:d(me.sticky,this.defaultValue.sticky)}}}var Q;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class O extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(re,me,xe){return O.computeLayout(me,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const me=re.height/re.lineHeight,xe=re.scrollBeyondLastLine?me-1:0,Be=(re.viewLineCount+xe)/(re.pixelRatio*re.height),et=Math.floor(re.viewLineCount/Be);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:xe,desiredRatio:Be,minimapLineCount:et}}static _computeMinimapLayout(re,me){const xe=re.outerWidth,Be=re.outerHeight,et=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const ke=me.stableMinimapLayoutInput,Ce=ke&&re.outerHeight===ke.outerHeight&&re.lineHeight===ke.lineHeight&&re.typicalHalfwidthCharacterWidth===ke.typicalHalfwidthCharacterWidth&&re.pixelRatio===ke.pixelRatio&&re.scrollBeyondLastLine===ke.scrollBeyondLastLine&&re.minimap.enabled===ke.minimap.enabled&&re.minimap.side===ke.minimap.side&&re.minimap.size===ke.minimap.size&&re.minimap.showSlider===ke.minimap.showSlider&&re.minimap.renderCharacters===ke.minimap.renderCharacters&&re.minimap.maxColumn===ke.minimap.maxColumn&&re.minimap.scale===ke.minimap.scale&&re.verticalScrollbarWidth===ke.verticalScrollbarWidth&&re.isViewportWrapping===ke.isViewportWrapping,Te=re.lineHeight,le=re.typicalHalfwidthCharacterWidth,ce=re.scrollBeyondLastLine,ve=re.minimap.renderCharacters;let Ee=et>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const j=re.minimap.maxColumn,be=re.minimap.size,Se=re.minimap.side,Ae=re.verticalScrollbarWidth,Ue=re.viewLineCount,Ge=re.remainingWidth,Ze=re.isViewportWrapping,Qe=ve?2:3;let Xe=Math.floor(et*Be);const lt=Xe/et;let ht=!1,Et=!1,ot=Qe*Ee,at=Ee/et,Dt=1;if(be==="fill"||be==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:Ke,desiredRatio:gt,minimapLineCount:bt}=O.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:ce,height:Be,lineHeight:Te,pixelRatio:et});if(Ue/bt>1)ht=!0,Et=!0,Ee=1,ot=1,at=Ee/et;else{let ft=!1,ut=Ee+1;if(be==="fit"){const mt=Math.ceil((Ue+Ke)*ot);Ze&&Ce&&Ge<=me.stableFitRemainingWidth?(ft=!0,ut=me.stableFitMaxMinimapScale):ft=mt>Xe}if(be==="fill"||ft){ht=!0;const mt=Ee;ot=Math.min(Te*et,Math.max(1,Math.floor(1/gt))),Ze&&Ce&&Ge<=me.stableFitRemainingWidth&&(ut=me.stableFitMaxMinimapScale),Ee=Math.min(ut,Math.max(1,Math.floor(ot/Qe))),Ee>mt&&(Dt=Math.min(2,Ee/mt)),at=Ee/et/Dt,Xe=Math.ceil(Math.max(tt,Ue+Ke)*ot),Ze?(me.stableMinimapLayoutInput=re,me.stableFitRemainingWidth=Ge,me.stableFitMaxMinimapScale=Ee):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ye=Math.floor(j*at),fe=Math.min(ye,Math.max(0,Math.floor((Ge-Ae-2)*at/(le+at)))+e.MINIMAP_GUTTER_WIDTH);let ue=Math.floor(et*fe);const G=ue/et;ue=Math.floor(ue*Dt);const Re=ve?1:2,Ne=Se==="left"?0:xe-fe-Ae;return{renderMinimap:Re,minimapLeft:Ne,minimapWidth:fe,minimapHeightIsEditorHeight:ht,minimapIsSampling:Et,minimapScale:Ee,minimapLineHeight:ot,minimapCanvasInnerWidth:ue,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:G,minimapCanvasOuterHeight:lt}}static computeLayout(re,me){const xe=me.outerWidth|0,Be=me.outerHeight|0,et=me.lineHeight|0,ke=me.lineNumbersDigitCount|0,Ce=me.typicalHalfwidthCharacterWidth,Te=me.maxDigitWidth,le=me.pixelRatio,ce=me.viewLineCount,ve=re.get(121),Ee=ve==="inherit"?re.get(120):ve,j=Ee==="inherit"?re.get(116):Ee,be=re.get(119),Se=re.get(2),Ae=me.isDominatedByLongLines,Ue=re.get(47),Ge=re.get(58).renderType!==0,Ze=re.get(59),Qe=re.get(93),Xe=re.get(63),lt=re.get(91),ht=lt.verticalScrollbarSize,Et=lt.verticalHasArrows,ot=lt.arrowSize,at=lt.horizontalScrollbarSize,Dt=re.get(56),ye=re.get(35);let fe;if(typeof Dt=="string"&&/^\d+(\.\d+)?ch$/.test(Dt)){const It=parseFloat(Dt.substr(0,Dt.length-2));fe=l.clampedInt(It*Ce,0,0,1e3)}else fe=l.clampedInt(Dt,0,0,1e3);ye&&(fe+=16);let ue=0;if(Ge){const It=Math.max(ke,Ze);ue=Math.round(It*Te)}let G=0;Ue&&(G=et);let Re=0,Ne=Re+G,tt=Ne+ue,Ke=tt+fe;const gt=xe-G-ue-fe;let bt=!1,kt=!1,ft=-1;Se!==2&&(Ee==="inherit"&&Ae?(bt=!0,kt=!0):j==="on"||j==="bounded"?kt=!0:j==="wordWrapColumn"&&(ft=be));const ut=O._computeMinimapLayout({outerWidth:xe,outerHeight:Be,lineHeight:et,typicalHalfwidthCharacterWidth:Ce,pixelRatio:le,scrollBeyondLastLine:Qe,minimap:Xe,verticalScrollbarWidth:ht,viewLineCount:ce,remainingWidth:gt,isViewportWrapping:kt},me.memory||new _);ut.renderMinimap!==0&&ut.minimapLeft===0&&(Re+=ut.minimapWidth,Ne+=ut.minimapWidth,tt+=ut.minimapWidth,Ke+=ut.minimapWidth);const mt=gt-ut.minimapWidth,_t=Math.max(1,Math.floor((mt-ht-2)/Ce)),Tt=Et?ot:0;return kt&&(ft=Math.max(1,_t),j==="bounded"&&(ft=Math.min(ft,be))),{width:xe,height:Be,glyphMarginLeft:Re,glyphMarginWidth:G,lineNumbersLeft:Ne,lineNumbersWidth:ue,decorationsLeft:tt,decorationsWidth:fe,contentLeft:Ke,contentWidth:mt,minimap:ut,viewportColumn:_t,isWordWrapMinified:bt,isViewportWrapping:kt,wrappingColumn:ft,verticalScrollbarWidth:ht,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:ht,height:Be-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=O;class x extends I{constructor(){const re={enabled:!0};super(55,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:g.localize(42,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:d(re.enabled,this.defaultValue.enabled)}}}class F extends I{constructor(){const re={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",re,{"editor.inlayHints.enabled":{type:"boolean",default:re.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,description:g.localize(45,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{enabled:d(me.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(me.fontFamily,this.defaultValue.fontFamily)}}}class z extends v{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>v.clamp(re,0,150),{markdownDescription:g.localize(46,null)})}compute(re,me,xe){return re.fontInfo.lineHeight}}class M extends I{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:re.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:g.localize(56,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{enabled:d(me.enabled,this.defaultValue.enabled),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(me.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(me.scale,1,1,3),maxColumn:l.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function N(X){return X==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends I{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{top:l.clampedInt(me.top,0,0,1e3),bottom:l.clampedInt(me.bottom,0,0,1e3)}}}class B extends I{constructor(){const re={enabled:!0,cycle:!1};super(74,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:g.localize(60,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{enabled:d(me.enabled,this.defaultValue.enabled),cycle:d(me.cycle,this.defaultValue.cycle)}}}class K extends n{constructor(){super(127)}compute(re,me,xe){return re.pixelRatio}}class te extends I{constructor(){const re={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:g.localize(61,null)},comments:{type:"boolean",default:re.comments,description:g.localize(62,null)},other:{type:"boolean",default:re.other,description:g.localize(63,null)}}}],default:re,description:g.localize(64,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const me=re,xe={other:d(me.other,this.defaultValue.other),comments:d(me.comments,this.defaultValue.comments),strings:d(me.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var he;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class De extends I{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(re){let me=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(me=4,xe=re):re==="interval"?me=3:re==="relative"?me=2:re==="on"?me=1:me=0),{renderType:me,renderFn:xe}}}function Pe(X){const re=X.get(86);return re==="editable"?X.get(79):re!=="on"}e.filterValidationDecorations=Pe;class Fe extends I{constructor(){const re=[],me={type:"number",description:g.localize(70,null)};super(90,"rulers",re,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:re,description:g.localize(72,null)})}validate(re){if(Array.isArray(re)){let me=[];for(let xe of re)if(typeof xe=="number")me.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Be=xe;me.push({column:l.clampedInt(Be.column,0,0,1e4),color:Be.color})}return me.sort((xe,Be)=>xe.column-Be.column),me}return this.defaultValue}}function qe(X,re){if(typeof X!="string")return re;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class We extends I{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:g.localize(83,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re,xe=l.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=l.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(me.vertical,this.defaultValue.vertical),horizontal:qe(me.horizontal,this.defaultValue.horizontal),useShadows:d(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(me.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:l.clampedInt(me.verticalSliderSize,Be,0,1e3),scrollByPage:d(me.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends I{constructor(){const re={enabled:!0,mode:"subwordSmart"};super(53,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:re.mode,description:g.localize(88,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{enabled:d(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends I{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(89,null),g.localize(90,null)],default:re.insertMode,description:g.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:g.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:g.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:g.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:g.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:g.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:g.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:g.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(99,null),g.localize(100,null),g.localize(101,null)],default:re.previewMode,description:g.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:g.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const me=re;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(me.showIcons,this.defaultValue.showIcons),showStatusBar:d(me.showStatusBar,this.defaultValue.showStatusBar),preview:d(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(me.showMethods,this.defaultValue.showMethods),showFunctions:d(me.showFunctions,this.defaultValue.showFunctions),showConstructors:d(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(me.showDeprecated,this.defaultValue.showDeprecated),showFields:d(me.showFields,this.defaultValue.showFields),showVariables:d(me.showVariables,this.defaultValue.showVariables),showClasses:d(me.showClasses,this.defaultValue.showClasses),showStructs:d(me.showStructs,this.defaultValue.showStructs),showInterfaces:d(me.showInterfaces,this.defaultValue.showInterfaces),showModules:d(me.showModules,this.defaultValue.showModules),showProperties:d(me.showProperties,this.defaultValue.showProperties),showEvents:d(me.showEvents,this.defaultValue.showEvents),showOperators:d(me.showOperators,this.defaultValue.showOperators),showUnits:d(me.showUnits,this.defaultValue.showUnits),showValues:d(me.showValues,this.defaultValue.showValues),showConstants:d(me.showConstants,this.defaultValue.showConstants),showEnums:d(me.showEnums,this.defaultValue.showEnums),showEnumMembers:d(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(me.showKeywords,this.defaultValue.showKeywords),showWords:d(me.showWords,this.defaultValue.showWords),showColors:d(me.showColors,this.defaultValue.showColors),showFiles:d(me.showFiles,this.defaultValue.showFiles),showReferences:d(me.showReferences,this.defaultValue.showReferences),showFolders:d(me.showFolders,this.defaultValue.showFolders),showTypeParameters:d(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(me.showSnippets,this.defaultValue.showSnippets),showUsers:d(me.showUsers,this.defaultValue.showUsers),showIssues:d(me.showIssues,this.defaultValue.showIssues)}}}class Z extends I{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(135,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends n{constructor(){super(128,[79])}compute(re,me,xe){return me.get(79)?!0:re.tabFocusMode}}var ae;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(ae=e.WrappingIndent||(e.WrappingIndent={}));function Y(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class oe extends n{constructor(){super(130,[129])}compute(re,me,xe){const Be=me.get(129);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}const we="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Me:L.isLinux?Ve:we,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(X){return e.editorOptionsRegistry[X.id]=X,X}var Je;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.foldingImportsByDefault=38]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=40]="fontFamily",X[X.fontInfo=41]="fontInfo",X[X.fontLigatures=42]="fontLigatures",X[X.fontSize=43]="fontSize",X[X.fontWeight=44]="fontWeight",X[X.formatOnPaste=45]="formatOnPaste",X[X.formatOnType=46]="formatOnType",X[X.glyphMargin=47]="glyphMargin",X[X.gotoLocation=48]="gotoLocation",X[X.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",X[X.hover=51]="hover",X[X.inDiffEditor=52]="inDiffEditor",X[X.inlineSuggest=53]="inlineSuggest",X[X.letterSpacing=54]="letterSpacing",X[X.lightbulb=55]="lightbulb",X[X.lineDecorationsWidth=56]="lineDecorationsWidth",X[X.lineHeight=57]="lineHeight",X[X.lineNumbers=58]="lineNumbers",X[X.lineNumbersMinChars=59]="lineNumbersMinChars",X[X.linkedEditing=60]="linkedEditing",X[X.links=61]="links",X[X.matchBrackets=62]="matchBrackets",X[X.minimap=63]="minimap",X[X.mouseStyle=64]="mouseStyle",X[X.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=66]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",X[X.multiCursorModifier=68]="multiCursorModifier",X[X.multiCursorPaste=69]="multiCursorPaste",X[X.occurrencesHighlight=70]="occurrencesHighlight",X[X.overviewRulerBorder=71]="overviewRulerBorder",X[X.overviewRulerLanes=72]="overviewRulerLanes",X[X.padding=73]="padding",X[X.parameterHints=74]="parameterHints",X[X.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",X[X.quickSuggestions=77]="quickSuggestions",X[X.quickSuggestionsDelay=78]="quickSuggestionsDelay",X[X.readOnly=79]="readOnly",X[X.renameOnType=80]="renameOnType",X[X.renderControlCharacters=81]="renderControlCharacters",X[X.renderIndentGuides=82]="renderIndentGuides",X[X.renderFinalNewline=83]="renderFinalNewline",X[X.renderLineHighlight=84]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=86]="renderValidationDecorations",X[X.renderWhitespace=87]="renderWhitespace",X[X.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",X[X.roundedSelection=89]="roundedSelection",X[X.rulers=90]="rulers",X[X.scrollbar=91]="scrollbar",X[X.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=93]="scrollBeyondLastLine",X[X.scrollPredominantAxis=94]="scrollPredominantAxis",X[X.selectionClipboard=95]="selectionClipboard",X[X.selectionHighlight=96]="selectionHighlight",X[X.selectOnLineNumbers=97]="selectOnLineNumbers",X[X.showFoldingControls=98]="showFoldingControls",X[X.showUnused=99]="showUnused",X[X.snippetSuggestions=100]="snippetSuggestions",X[X.smartSelect=101]="smartSelect",X[X.smoothScrolling=102]="smoothScrolling",X[X.stickyTabStops=103]="stickyTabStops",X[X.stopRenderingLineAfter=104]="stopRenderingLineAfter",X[X.suggest=105]="suggest",X[X.suggestFontSize=106]="suggestFontSize",X[X.suggestLineHeight=107]="suggestLineHeight",X[X.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",X[X.suggestSelection=109]="suggestSelection",X[X.tabCompletion=110]="tabCompletion",X[X.tabIndex=111]="tabIndex",X[X.unusualLineTerminators=112]="unusualLineTerminators",X[X.useShadowDOM=113]="useShadowDOM",X[X.useTabStops=114]="useTabStops",X[X.wordSeparators=115]="wordSeparators",X[X.wordWrap=116]="wordWrap",X[X.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=119]="wordWrapColumn",X[X.wordWrapOverride1=120]="wordWrapOverride1",X[X.wordWrapOverride2=121]="wordWrapOverride2",X[X.wrappingIndent=122]="wrappingIndent",X[X.wrappingStrategy=123]="wrappingStrategy",X[X.showDeprecated=124]="showDeprecated",X[X.inlayHints=125]="inlayHints",X[X.editorClassName=126]="editorClassName",X[X.pixelRatio=127]="pixelRatio",X[X.tabFocusMode=128]="tabFocusMode",X[X.layoutInfo=129]="layoutInfo",X[X.wrappingInfo=130]="wrappingInfo"})(Je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(136,null)})),acceptSuggestionOnEnter:_e(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(137,null),""],markdownDescription:g.localize(138,null)})),accessibilitySupport:_e(new p),accessibilityPageSize:_e(new l(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(139,null)})),ariaLabel:_e(new S(4,"ariaLabel",g.localize(140,null))),autoClosingBrackets:_e(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(141,null),g.localize(142,null),""],description:g.localize(143,null)})),autoClosingDelete:_e(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(144,null),""],description:g.localize(145,null)})),autoClosingOvertype:_e(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(146,null),""],description:g.localize(147,null)})),autoClosingQuotes:_e(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(148,null),g.localize(149,null),""],description:g.localize(150,null)})),autoIndent:_e(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[g.localize(151,null),g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null)],description:g.localize(156,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(157,null),g.localize(158,null),g.localize(159,null),""],description:g.localize(160,null)})),stickyTabStops:_e(new m(103,"stickyTabStops",!1,{description:g.localize(161,null)})),codeLens:_e(new m(12,"codeLens",!0,{description:g.localize(162,null)})),codeLensFontFamily:_e(new S(13,"codeLensFontFamily","",{description:g.localize(163,null)})),codeLensFontSize:_e(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(164,null)})),colorDecorators:_e(new m(15,"colorDecorators",!0,{description:g.localize(165,null)})),columnSelection:_e(new m(16,"columnSelection",!1,{description:g.localize(166,null)})),comments:_e(new t),contextmenu:_e(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(167,null)})),cursorBlinking:_e(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:g.localize(168,null)})),cursorSmoothCaretAnimation:_e(new m(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(169,null)})),cursorStyle:_e(new c(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:g.localize(170,null)})),cursorSurroundingLines:_e(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(171,null)})),cursorSurroundingLinesStyle:_e(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(172,null),g.localize(173,null)],description:g.localize(174,null)})),cursorWidth:_e(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(175,null)})),disableLayerHinting:_e(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(28,"domReadOnly",!1)),dragAndDrop:_e(new m(29,"dragAndDrop",!0,{description:g.localize(176,null)})),emptySelectionClipboard:_e(new w),extraEditorClassName:_e(new S(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new v(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(177,null)})),find:_e(new E),fixedOverflowWidgets:_e(new m(34,"fixedOverflowWidgets",!1)),folding:_e(new m(35,"folding",!0,{description:g.localize(178,null)})),foldingStrategy:_e(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(179,null),g.localize(180,null)],description:g.localize(181,null)})),foldingHighlight:_e(new m(37,"foldingHighlight",!0,{description:g.localize(182,null)})),foldingImportsByDefault:_e(new m(38,"foldingImportsByDefault",!1,{description:g.localize(183,null)})),unfoldOnClickAfterEndOfLine:_e(new m(39,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(184,null)})),fontFamily:_e(new S(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(185,null)})),fontInfo:_e(new D),fontLigatures2:_e(new s),fontSize:_e(new R),fontWeight:_e(new U),formatOnPaste:_e(new m(45,"formatOnPaste",!1,{description:g.localize(186,null)})),formatOnType:_e(new m(46,"formatOnType",!1,{description:g.localize(187,null)})),glyphMargin:_e(new m(47,"glyphMargin",!0,{description:g.localize(188,null)})),gotoLocation:_e(new V),hideCursorInOverviewRuler:_e(new m(49,"hideCursorInOverviewRuler",!1,{description:g.localize(189,null)})),highlightActiveIndentGuide:_e(new m(50,"highlightActiveIndentGuide",!0,{description:g.localize(190,null)})),hover:_e(new ee),inDiffEditor:_e(new m(52,"inDiffEditor",!1)),letterSpacing:_e(new v(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>v.clamp(X,-5,20),{description:g.localize(191,null)})),lightbulb:_e(new x),lineDecorationsWidth:_e(new A(56,"lineDecorationsWidth",10)),lineHeight:_e(new z),lineNumbers:_e(new De),lineNumbersMinChars:_e(new l(59,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(60,"linkedEditing",!1,{description:g.localize(192,null)})),links:_e(new m(61,"links",!0,{description:g.localize(193,null)})),matchBrackets:_e(new P(62,"matchBrackets","always",["always","near","never"],{description:g.localize(194,null)})),minimap:_e(new M),mouseStyle:_e(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new v(65,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(195,null)})),mouseWheelZoom:_e(new m(66,"mouseWheelZoom",!1,{markdownDescription:g.localize(196,null)})),multiCursorMergeOverlapping:_e(new m(67,"multiCursorMergeOverlapping",!0,{description:g.localize(197,null)})),multiCursorModifier:_e(new c(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],N,{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),multiCursorPaste:_e(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(201,null),g.localize(202,null)],markdownDescription:g.localize(203,null)})),occurrencesHighlight:_e(new m(70,"occurrencesHighlight",!0,{description:g.localize(204,null)})),overviewRulerBorder:_e(new m(71,"overviewRulerBorder",!0,{description:g.localize(205,null)})),overviewRulerLanes:_e(new l(72,"overviewRulerLanes",3,0,3)),padding:_e(new q),parameterHints:_e(new B),peekWidgetDefaultFocus:_e(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(206,null),g.localize(207,null)],description:g.localize(208,null)})),definitionLinkOpensInPeek:_e(new m(76,"definitionLinkOpensInPeek",!1,{description:g.localize(209,null)})),quickSuggestions:_e(new te),quickSuggestionsDelay:_e(new l(78,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(210,null)})),readOnly:_e(new m(79,"readOnly",!1)),renameOnType:_e(new m(80,"renameOnType",!1,{description:g.localize(211,null),markdownDeprecationMessage:g.localize(212,null)})),renderControlCharacters:_e(new m(81,"renderControlCharacters",!1,{description:g.localize(213,null)})),renderIndentGuides:_e(new m(82,"renderIndentGuides",!0,{description:g.localize(214,null)})),renderFinalNewline:_e(new m(83,"renderFinalNewline",!0,{description:g.localize(215,null)})),renderLineHighlight:_e(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(216,null)],description:g.localize(217,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(218,null)})),renderValidationDecorations:_e(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(219,null),g.localize(220,null),g.localize(221,null),""],description:g.localize(222,null)})),revealHorizontalRightPadding:_e(new l(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(89,"roundedSelection",!0,{description:g.localize(223,null)})),rulers:_e(new Fe),scrollbar:_e(new We),scrollBeyondLastColumn:_e(new l(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(224,null)})),scrollBeyondLastLine:_e(new m(93,"scrollBeyondLastLine",!0,{description:g.localize(225,null)})),scrollPredominantAxis:_e(new m(94,"scrollPredominantAxis",!0,{description:g.localize(226,null)})),selectionClipboard:_e(new m(95,"selectionClipboard",!0,{description:g.localize(227,null),included:L.isLinux})),selectionHighlight:_e(new m(96,"selectionHighlight",!0,{description:g.localize(228,null)})),selectOnLineNumbers:_e(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:_e(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(229,null),g.localize(230,null)],description:g.localize(231,null)})),showUnused:_e(new m(99,"showUnused",!0,{description:g.localize(232,null)})),showDeprecated:_e(new m(124,"showDeprecated",!0,{description:g.localize(233,null)})),inlayHints:_e(new F),snippetSuggestions:_e(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),g.localize(237,null)],description:g.localize(238,null)})),smartSelect:_e(new Z),smoothScrolling:_e(new m(102,"smoothScrolling",!1,{description:g.localize(239,null)})),stopRenderingLineAfter:_e(new l(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new W),inlineSuggest:_e(new je),suggestFontSize:_e(new l(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(240,null)})),suggestLineHeight:_e(new l(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestOnTriggerCharacters:_e(new m(108,"suggestOnTriggerCharacters",!0,{description:g.localize(242,null)})),suggestSelection:_e(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),tabCompletion:_e(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(247,null),g.localize(248,null),g.localize(249,null)],description:g.localize(250,null)})),tabIndex:_e(new l(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),useShadowDOM:_e(new m(113,"useShadowDOM",!0)),useTabStops:_e(new m(114,"useTabStops",!0,{description:g.localize(255,null)})),wordSeparators:_e(new S(115,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:g.localize(256,null)})),wordWrap:_e(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(257,null),g.localize(258,null),g.localize(259,null),g.localize(260,null)],description:g.localize(261,null)})),wordWrapBreakAfterCharacters:_e(new S(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new S(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new l(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(262,null)})),wordWrapOverride1:_e(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new c(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[g.localize(263,null),g.localize(264,null),g.localize(265,null),g.localize(266,null)],description:g.localize(267,null)})),wrappingStrategy:_e(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),editorClassName:_e(new u),pixelRatio:_e(new K),tabFocusMode:_e(new ne),layoutInfo:_e(new O),wrappingInfo:_e(new oe)}}),define(ge[155],pe([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[156],pe([18,19]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[157],pe([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[158],pe([18,19]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[159],pe([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ge[160],pe([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ge[161],pe([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[162],pe([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[163],pe([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[164],pe([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[165],pe([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[166],pe([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[167],pe([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[168],pe([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[169],pe([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[170],pe([18,19]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[171],pe([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(ge[172],pe([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(ge[173],pe([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[174],pe([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[175],pe([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[176],pe([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[177],pe([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[178],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[179],pe([0,1,157]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function C(d){return d=d.trim(),d==="*"||L.test(d)}e.isValidVersionStr=C;function T(d){if(!C(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=d.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=T;function y(d){if(!d)return null;let m=d.majorBase,l=d.majorMustEqual,v=d.minorBase,S=d.minorMustEqual,b=d.patchBase,P=d.patchMustEqual;d.hasCaret&&(m===0||(S=!1),P=!1);let c=0;if(d.preRelease){const f=k.exec(d.preRelease);if(f){const[,p,t,r]=f;c=Date.UTC(Number(p),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:l,minorBase:v,minorMustEqual:S,patchBase:b,patchMustEqual:P,isMinimum:d.hasGreaterEquals,notBefore:c}}e.normalizeVersion=y;function _(d,m,l){let v;typeof d=="string"?v=y(T(d)):v=d;let S;m instanceof Date?S=m.getTime():typeof m=="string"&&(S=new Date(m).getTime());let b;if(typeof l=="string"?b=y(T(l)):b=l,!v||!b)return!1;let P=v.majorBase,c=v.minorBase,f=v.patchBase,p=b.majorBase,t=b.minorBase,r=b.patchBase,o=b.notBefore,i=b.majorMustEqual,a=b.minorMustEqual,h=b.patchMustEqual;return b.isMinimum?P>p?!0:P<p?!1:c>t?!0:c<t||S&&S<o?!1:f>=r:(P===1&&p===0&&(!i||!a||!h)&&(p=1,t=0,r=0,i=!0,a=!1,h=!1),P<p?!1:P>p?!i:c<t?!1:c>t?!a:f<r?!1:f>r?!h:!(S&&S<o))}e.isValidVersion=_;function I(d,m,l,v){return l.isBuiltin||typeof l.main=="undefined"?!0:A(d,m,l.engines.vscode,v)}e.isValidExtensionVersion=I;function n(d,m,l){return d==="*"||A(m,l,d)}e.isEngineValid=n;function A(d,m,l,v=[]){let S=y(T(l));if(!S)return v.push(g.localize(0,null,l)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return v.push(g.localize(1,null,l)),!1}else if(!S.majorMustEqual)return v.push(g.localize(2,null,l)),!1;return _(d,m,S)?!0:(v.push(g.localize(3,null,d,l)),!1)}}),define(ge[115],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(k,C=[],T=!1){this.ctor=k,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(ge[80],pe([0,1,115]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(T,y,_){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],_)),L.push([T,y])}e.registerSingleton=k;function C(){return L}e.getSingletonServiceDescriptors=C}),define(ge[180],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=g;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const y=this.lookupOrInsertNode(C),_=this.lookupOrInsertNode(T);y.outgoing.set(this._hashFn(T),_),_.incoming.set(this._hashFn(C),y)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(let y of this._nodes.values())y.outgoing.delete(T),y.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let y=this._nodes.get(T);return y||(y=new g(C),this._nodes.set(T,y)),y}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[T,y]of this._nodes)C.push(`${T}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,T]of this._nodes){const y=new Set([C]),_=this._findCycle(T,y);if(_)return _}}_findCycle(C,T){for(let[y,_]of C.outgoing){if(T.has(y))return[...T,y].join(" -> ");T.add(y);const I=this._findCycle(_,T);if(I)return I;T.delete(y)}}}e.Graph=L}),define(ge[4],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function _(I){return I[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=_})(g=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(y,_,I,n){_[g.DI_TARGET]===_?_[g.DI_DEPENDENCIES].push({id:y,index:I,optional:n}):(_[g.DI_DEPENDENCIES]=[{id:y,index:I,optional:n}],_[g.DI_TARGET]=_)}function k(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const _=function(I,n,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(_,I,A,!1)};return _.toString=()=>y,g.serviceIds.set(y,_),_}e.createDecorator=k;function C(y){return y}e.refineServiceDecorator=C;function T(y){return function(_,I,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(y,_,n,!0)}}e.optional=T}),define(ge[181],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(ge[182],pe([0,1,3,58,6,22,75,79,181]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(I):!!d.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(m,l){let v={selector:m,provider:l,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(v){let S=this._entries.indexOf(v);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const l=[];for(let v of this._entries)v._score>0&&l.push(v.provider);return l}ordered(m){const l=[];return this._orderedForEach(m,v=>l.push(v.provider)),l}orderedGroups(m){const l=[];let v,S;return this._orderedForEach(m,b=>{v&&S===b._score?v.push(b.provider):(S=b._score,v=[b.provider],l.push(v))}),l}_orderedForEach(m,l){if(!!m){this._updateScores(m);for(const v of this._entries)v._score>0&&l(v)}}_updateScores(m){let l={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let v of this._entries)if(v._score=(0,y.score)(v.selector,m.uri,m.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(m)),I(v.selector)&&v._score>0){for(let S of this._entries)S._score=0;v._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(m,l){return m._score<l._score?1:m._score>l._score?-1:m._time<l._time?1:m._time>l._time?-1:0}}e.LanguageFeatureRegistry=n;class A{constructor(m,l,v=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=l,this.max=v,this._cache=new C.LRUCache(50,.7)}_key(m){return m.id+(0,L.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const l=this._key(m),v=this._cache.get(l);return this._clamp(v?.value)}update(m,l){const v=this._key(m);let S=this._cache.get(v);return S||(S=new T.MovingAverage,this._cache.set(v,S)),S.update(l),this.get(m)}}e.LanguageFeatureRequestDelays=A}),define(ge[81],pe([0,1,2,41,182,148,47]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(s){s[s.Null=0]="Null",s[s.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class _{constructor(D,R){this.language=D,this.id=R}}e.LanguageIdentifier=_;var I;(function(s){s[s.NotSet=-1]="NotSet",s[s.None=0]="None",s[s.Italic=1]="Italic",s[s.Bold=2]="Bold",s[s.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var n;(function(s){s[s.None=0]="None",s[s.DefaultForeground=1]="DefaultForeground",s[s.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var A;(function(s){s[s.Other=0]="Other",s[s.Comment=1]="Comment",s[s.String=2]="String",s[s.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(s){s[s.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",s[s.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",s[s.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",s[s.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",s[s.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",s[s.ITALIC_MASK=2048]="ITALIC_MASK",s[s.BOLD_MASK=4096]="BOLD_MASK",s[s.UNDERLINE_MASK=8192]="UNDERLINE_MASK",s[s.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",s[s.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",s[s.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",s[s.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",s[s.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",s[s.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",s[s.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",s[s.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",s[s.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",s[s.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let R=this.getForeground(D),U="mtk"+R,V=this.getFontStyle(D);return V&1&&(U+=" mtki"),V&2&&(U+=" mtkb"),V&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(D,R){const U=this.getForeground(D),V=this.getFontStyle(D);let ee=`color: ${R[U]};`;return V&1&&(ee+="font-style: italic;"),V&2&&(ee+="font-weight: bold;"),V&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=m;var l;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let s=Object.create(null);return s[0]="symbol-method",s[1]="symbol-function",s[2]="symbol-constructor",s[3]="symbol-field",s[4]="symbol-variable",s[5]="symbol-class",s[6]="symbol-struct",s[7]="symbol-interface",s[8]="symbol-module",s[9]="symbol-property",s[10]="symbol-event",s[11]="symbol-operator",s[12]="symbol-unit",s[13]="symbol-value",s[14]="symbol-constant",s[15]="symbol-enum",s[16]="symbol-enum-member",s[17]="symbol-keyword",s[27]="symbol-snippet",s[18]="symbol-text",s[19]="symbol-color",s[20]="symbol-file",s[21]="symbol-reference",s[22]="symbol-customcolor",s[23]="symbol-folder",s[24]="symbol-type-parameter",s[25]="account",s[26]="issues",function(D){const R=s[D];let U=R&&T.iconRegistry.get(R);return U||(console.info("No codicon found for CompletionItemKind "+D),U=T.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let s=Object.create(null);return s.method=0,s.function=1,s.constructor=2,s.field=3,s.variable=4,s.class=5,s.struct=6,s.interface=7,s.module=8,s.property=9,s.event=10,s.operator=11,s.unit=12,s.value=13,s.constant=14,s.enum=15,s["enum-member"]=16,s.enumMember=16,s.keyword=17,s.snippet=27,s.text=18,s.color=19,s.file=20,s.reference=21,s.customcolor=22,s.folder=23,s["type-parameter"]=24,s.typeParameter=24,s.account=25,s.issue=26,function(D,R){let U=s[D];return typeof U=="undefined"&&!R&&(U=9),U}}();var v;(function(s){s[s.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(s){s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(s){return s&&g.URI.isUri(s.uri)&&L.Range.isIRange(s.range)&&(L.Range.isIRange(s.originSelectionRange)||L.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=t;var r;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var o;(function(s){s[s.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var i;(function(s){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function U(Q){return D.get(Q)}s.fromString=U;function V(Q){return R.get(Q)}s.toString=V;function ee(Q,O){const x=R.get(Q);let F=x&&T.iconRegistry.get("symbol-"+x);return F||(console.info("No codicon found for SymbolKind "+Q),F=T.Codicon.symbolProperty),`${O?"inline":"block"} ${F.classNames}`}s.toCssClassName=ee})(i=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(D){this.value=D}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var h;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var w;(function(s){s[s.Other=0]="Other",s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var E;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[61],pe([0,1,11,8,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",g.isMacintosh),T.set("isLinux",g.isLinux),T.set("isWindows",g.isWindows),T.set("isWeb",g.isWeb),T.set("isMacNative",g.isMacintosh&&!g.isWeb),T.set("isEdge",C.indexOf("Edg/")>=0),T.set("isFirefox",C.indexOf("Firefox")>=0),T.set("isChrome",C.indexOf("Chrome")>=0),T.set("isSafari",C.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var _;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return A.INSTANCE}static true(){return d.INSTANCE}static has(s){return m.create(s)}static equals(s,D){return l.create(s,D)}static notEquals(s,D){return b.create(s,D)}static regex(s,D){return r.create(s,D)}static in(s,D){return v.create(s,D)}static not(s){return P.create(s)}static and(...s){return i.create(s)}static or(...s){return a.create(s)}static greater(s,D){return c.create(s,D)}static less(s,D){return p.create(s,D)}static deserialize(s,D=!1){if(!!s)return this._deserializeOrExpression(s,D)}static _deserializeOrExpression(s,D){let R=s.split("||");return a.create(R.map(U=>this._deserializeAndExpression(U,D)))}static _deserializeAndExpression(s,D){let R=s.split("&&");return i.create(R.map(U=>this._deserializeOne(U,D)))}static _deserializeOne(s,D){if(s=s.trim(),s.indexOf("!=")>=0){let R=s.split("!=");return b.create(R[0].trim(),this._deserializeValue(R[1],D))}if(s.indexOf("==")>=0){let R=s.split("==");return l.create(R[0].trim(),this._deserializeValue(R[1],D))}if(s.indexOf("=~")>=0){let R=s.split("=~");return r.create(R[0].trim(),this._deserializeRegexValue(R[1],D))}if(s.indexOf(" in ")>=0){let R=s.split(" in ");return v.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(s)){const R=s.split(">=");return f.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(s)){const R=s.split(">");return c.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(s)){const R=s.split("<=");return t.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(s)){const R=s.split("<");return p.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(s)?P.create(s.substr(1).trim()):m.create(s)}static _deserializeValue(s,D){if(s=s.trim(),s==="true")return!0;if(s==="false")return!1;let R=/^'([^']*)'$/.exec(s);return R?R[1].trim():s}static _deserializeRegexValue(s,D){if((0,L.isFalsyOrWhitespace)(s)){if(D)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let R=s.indexOf("/"),U=s.lastIndexOf("/");if(R===U||R<0){if(D)throw new Error(`bad regexp-value '${s}', missing /-enclosure`);return console.warn(`bad regexp-value '${s}', missing /-enclosure`),null}let V=s.slice(R+1,U),ee=s[U+1]==="i"?"i":"";try{return new RegExp(V,ee)}catch(Q){if(D)throw new Error(`bad regexp-value '${s}', parse error: ${Q}`);return console.warn(`bad regexp-value '${s}', parse error: ${Q}`),null}}}e.ContextKeyExpr=I;function n(E,s){return E.cmp(s)}class A{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class d{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class m{constructor(s){this.key=s,this.type=2}static create(s){const D=T.get(s);return typeof D=="boolean"?D?d.INSTANCE:A.INSTANCE:new m(s)}cmp(s){return s.type!==this.type?this.type-s.type:u(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=m;class l{constructor(s,D){this.key=s,this.value=D,this.type=4}static create(s,D){if(typeof D=="boolean")return D?m.create(s):P.create(s);const R=T.get(s);return typeof R=="boolean"?D===(R?"true":"false")?d.INSTANCE:A.INSTANCE:new l(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class v{constructor(s,D){this.key=s,this.valueKey=D,this.type=10}static create(s,D){return new v(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}evaluate(s){const D=s.getValue(this.valueKey),R=s.getValue(this.key);return Array.isArray(D)?D.indexOf(R)>=0:typeof R=="string"&&typeof D=="object"&&D!==null?y.call(D,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=v;class S{constructor(s){this._actual=s,this.type=11}static create(s){return new S(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new S(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class b{constructor(s,D){this.key=s,this.value=D,this.type=5}static create(s,D){if(typeof D=="boolean")return D?P.create(s):m.create(s);const R=T.get(s);return typeof R=="boolean"?D===(R?"true":"false")?A.INSTANCE:d.INSTANCE:new b(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class P{constructor(s){this.key=s,this.type=3}static create(s){const D=T.get(s);return typeof D=="boolean"?D?A.INSTANCE:d.INSTANCE:new P(s)}cmp(s){return s.type!==this.type?this.type-s.type:u(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=P;class c{constructor(s,D){this.key=s,this.value=D,this.type=12}static create(s,D){return new c(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class f{constructor(s,D){this.key=s,this.value=D,this.type=13}static create(s,D){return new f(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class p{constructor(s,D){this.key=s,this.value=D,this.type=14}static create(s,D){return new p(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(s,D){this.key=s,this.value=D,this.type=15}static create(s,D){return new t(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(s,D){this.key=s,this.regexp=D,this.type=7}static create(s,D){return new r(s,D)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const D=this.regexp?this.regexp.source:"",R=s.regexp?s.regexp.source:"";return D<R?-1:D>R?1:0}equals(s){if(s.type===this.type){const D=this.regexp?this.regexp.source:"",R=s.regexp?s.regexp.source:"";return this.key===s.key&&D===R}return!1}evaluate(s){let D=s.getValue(this.key);return this.regexp?this.regexp.test(D):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=r;class o{constructor(s){this._actual=s,this.type=8}static create(s){return new o(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new o(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class i{constructor(s){this.expr=s,this.type=6}static create(s){return i._normalizeArr(s)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let D=0,R=this.expr.length;D<R;D++){const U=n(this.expr[D],s.expr[D]);if(U!==0)return U}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].equals(s.expr[D]))return!1;return!0}return!1}evaluate(s){for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].evaluate(s))return!1;return!0}static _normalizeArr(s){const D=[];let R=!1;for(const U of s)if(!!U){if(U.type===1){R=!0;continue}if(U.type===0)return A.INSTANCE;if(U.type===6){D.push(...U.expr);continue}D.push(U)}if(D.length===0&&R)return d.INSTANCE;if(D.length!==0){if(D.length===1)return D[0];for(D.sort(n);D.length>1;){const U=D[D.length-1];if(U.type!==9)break;D.pop();const V=D.pop(),ee=a.create(U.expr.map(Q=>i.create([Q,V])));ee&&(D.push(ee),D.sort(n))}return D.length===1?D[0]:new i(D)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(let D of this.expr)s.push(...D.keys());return s}map(s){return new i(this.expr.map(D=>D.map(s)))}negate(){let s=[];for(let D of this.expr)s.push(D.negate());return a.create(s)}}e.ContextKeyAndExpr=i;class a{constructor(s){this.expr=s,this.type=9}static create(s){const D=a._normalizeArr(s);if(D.length!==0)return D.length===1?D[0]:new a(D)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let D=0,R=this.expr.length;D<R;D++){const U=n(this.expr[D],s.expr[D]);if(U!==0)return U}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].equals(s.expr[D]))return!1;return!0}return!1}evaluate(s){for(let D=0,R=this.expr.length;D<R;D++)if(this.expr[D].evaluate(s))return!0;return!1}static _normalizeArr(s){let D=[],R=!1;if(s){for(let U=0,V=s.length;U<V;U++){const ee=s[U];if(!!ee){if(ee.type===0){R=!0;continue}if(ee.type===1)return[d.INSTANCE];if(ee.type===9){D=D.concat(ee.expr);continue}D.push(ee)}}if(D.length===0&&R)return[A.INSTANCE];D.sort(n)}return D}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(let D of this.expr)s.push(...D.keys());return s}map(s){return new a(this.expr.map(D=>D.map(s)))}negate(){let s=[];for(let R of this.expr)s.push(R.negate());const D=R=>R.type===9?R.expr:[R];for(;s.length>1;){const R=s.shift(),U=s.shift(),V=[];for(const ee of D(R))for(const Q of D(U))V.push(I.and(ee,Q));s.unshift(I.or(...V))}return s[0]}}e.ContextKeyOrExpr=a;class h extends m{constructor(s,D,R){super(s);this._defaultValue=D,typeof R=="object"?h._info.push({...R,key:s}):R!==!0&&h._info.push({key:s,description:R,type:D!=null?typeof D:void 0})}static all(){return h._info.values()}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return I.not(this.key)}isEqualTo(s){return I.equals(this.key,s)}notEqualsTo(s){return I.notEquals(this.key,s)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(E,s){return E<s?-1:E>s?1:0}function w(E,s,D,R){return E<D?-1:E>D?1:s<R?-1:s>R?1:0}}),define(ge[183],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[184],pe([0,1,10,156,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(A){return A&&typeof A=="object"&&typeof A.id=="string"&&(!A.uuid||typeof A.uuid=="string")}e.isIExtensionIdentifier=C;var T;(function(A){A[A.NoneOrRelevance=0]="NoneOrRelevance",A[A.LastUpdatedDate=1]="LastUpdatedDate",A[A.Title=2]="Title",A[A.PublisherName=3]="PublisherName",A[A.InstallCount=4]="InstallCount",A[A.PublishedDate=5]="PublishedDate",A[A.AverageRating=6]="AverageRating",A[A.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var y;(function(A){A[A.Default=0]="Default",A[A.Ascending=1]="Ascending",A[A.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var _;(function(A){A.Install="install",A.Uninstall="uninstall"})(_=e.StatisticType||(e.StatisticType={}));var I;(function(A){A[A.None=0]="None",A[A.Install=1]="Install",A[A.Update=2]="Update"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(d,m){super(d);this.code=m,this.name=m}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=k;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,d){if(typeof A=="undefined"||A===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof A=="string"||typeof d=="string"){let m=typeof A=="string"?A:A.value,l=typeof d=="string"?d:d.value;return g.equalsIgnoreCase(m,l)}return A._lower===d._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=y;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function I(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[185],pe([0,1,8,26]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(l,v){return l.uuid&&v.uuid?l.uuid===v.uuid:l.id===v.id?!0:(0,g.compareIgnoreCase)(l.id,v.id)===0}e.areSameExtensions=k;class C{constructor(v,S){this.version=S,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?k(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function T(l,v){return`${l}.${v}`}e.getExtensionId=T;function y(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function _(l,v){return y(T(l,v))}e.getGalleryExtensionId=_;function I(l,v){const S=[],b=P=>{for(const c of S)if(c.some(f=>k(v(f),v(P))))return c;return null};for(const P of l){const c=b(P);c?c.push(P):S.push([P])}return S}e.groupByExtension=I;function n(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function A(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function d(l){const v=new Set;for(const S of l)S.malicious&&v.add(S.id.id);return v}e.getMaliciousExtensionsSet=d;function m(l,v){const S=[],b=v.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const P=b.shift();if(P&&S.every(c=>!k(c.identifier,{id:P}))){const c=l.filter(f=>k(f.identifier,{id:P}));c.length===1&&(S.push(c[0]),b.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=m}),define(ge[186],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(ge[187],pe([0,1,39,10,9,11,140,28,113,158,186]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const A=I.localize(0,null);class d{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends d{openTerminal(f,p){return this.spawnTerminal(g,f,_.getWindowsShell(),p)}spawnTerminal(f,p,t,r){const o=p.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=k.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return f.spawn(o,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),(i==="wt"||i==="wt.exe")&&a.push("-d ."),new Promise((h,u)=>{const w=S(process),E=f.spawn(t,a,{cwd:r,env:w});E.on("error",u),E.on("exit",()=>h())})}runInTerminal(f,p,t,r,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,h)=>{const u=`"${p} - ${A}"`,w=`""${t.join('" "')}" & pause"`,E=["/c","start",u,"/wait",i,"/c",w],s=Object.assign({},S(process),r);Object.keys(s).filter(U=>s[U]===null).forEach(U=>delete s[U]);const D={cwd:p,env:s,windowsVerbatimArguments:!0};g.spawn(m.CMD,E,D).on("error",U=>{h(b(U))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class l extends d{openTerminal(f,p){return this.spawnTerminal(g,f,p)}runInTerminal(f,p,t,r,o){const i=o.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((a,h)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const u=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,J).fsPath,"-t",f||A,"-w",p];for(let R of t)E.push("-a"),E.push(R);if(r){const R=Object.assign({},S(process),r);for(let U in R){const V=R[U];V===null?(E.push("-u"),E.push(U)):(E.push("-e"),E.push(`${U}=${V}`))}}let s="";const D=g.spawn(l.OSASCRIPT,E);D.on("error",R=>{h(b(R))}),D.stderr.on("data",R=>{s+=R.toString()}),D.on("exit",R=>{if(R===0)a(void 0);else if(s){const U=s.split(`
`,1);h(new Error(U[0]))}else h(new Error(I.localize(1,null,u,R)))})}else h(new Error(I.localize(2,null,i)))})}spawnTerminal(f,p,t){const r=p.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const a=["-a",r];t&&a.push(t);const h=S(process),u=f.spawn("/usr/bin/open",a,{cwd:t,env:h});u.on("error",i),u.on("exit",()=>o())})}}e.MacExternalTerminalService=l,l.OSASCRIPT="/usr/bin/osascript";class v extends d{openTerminal(f,p){return this.spawnTerminal(g,f,p)}runInTerminal(f,p,t,r,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,h)=>{let u=[];i.then(w=>{w.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const E=`${P(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;u.push(`''${E}''`);const s=Object.assign({},S(process),r);Object.keys(s).filter(V=>s[V]===null).forEach(V=>delete s[V]);const D={cwd:p,env:s};let R="";const U=g.spawn(w,u,D);U.on("error",V=>{h(b(V))}),U.stderr.on("data",V=>{R+=V.toString()}),U.on("exit",V=>{if(V===0)a(void 0);else if(R){const ee=R.split(`
`,1);h(new Error(ee[0]))}else h(new Error(I.localize(4,null,w,V)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async f=>{C.isLinux?await y.Promises.exists("/etc/debian_version")?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm"):f("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,p,t){const r=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{r.then(a=>{const h=S(process),u=f.spawn(a,[],{cwd:t,env:h});u.on("error",i),u.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=I.localize(3,null);function S(c){const f={...c.env};return(0,T.sanitizeProcessEnvironment)(f),f}function b(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(I.localize(5,null,c.path)):c}function P(c){let f="";for(let p of c)p.indexOf(" ")>=0?f+='"'+p+'"':f+=p,f+=" ";return f}}),define(ge[42],pe([0,1,22,9,8,14,2,159,4]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function I(O){return O.create===!0}e.isFileOpenForWriteOptions=I;var n;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var A;(function(O){O[O.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var d;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=m;function l(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=l;function v(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function S(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=S;var b;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(x,F){super(x);this.code=F}}e.FileSystemProviderError=P;function c(O,x){const F=new P(O.toString(),x);return p(F,x),F}e.createFileSystemProviderError=c;function f(O){return O||c((0,y.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=f;function p(O,x){return O.name=x?`${x} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=p;function t(O){if(!O)return b.Unknown;if(O instanceof P)return O.code;const x=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(O){if(O instanceof w)return O.fileOperationResult;switch(t(O)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(o=e.FileOperation||(e.FileOperation={}));class i{constructor(x,F,z){this.resource=x,this.operation=F,this.target=z}isOperation(x){return this.operation===x}}e.FileOperationEvent=i;var a;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(x,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of x)switch(z.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>F)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>F)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>F)),this.deleted.set(z.resource,z);break}}contains(x,...F){return this.doContains(x,{includeChildren:!1},...F)}affects(x,...F){return this.doContains(x,{includeChildren:!0},...F)}doContains(x,F,...z){if(!x)return!1;const M=z.length>0;return!!((!M||z.includes(1))&&(this.added?.get(x)||F.includeChildren&&this.added?.findSuperstr(x))||(!M||z.includes(0))&&(this.updated?.get(x)||F.includeChildren&&this.updated?.findSuperstr(x))||(!M||z.includes(2))&&(this.deleted?.findSubstr(x)||F.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function u(O,x,F){return!O||!x||O===x||x.length>O.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),F?(0,k.startsWithIgnoreCase)(O,x):O.indexOf(x)===0)}e.isParent=u;class w extends Error{constructor(x,F,z){super(x);this.fileOperationResult=F,this.options=z}}e.FileOperationError=w;class E extends w{constructor(x,F,z){super(x,2,z);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var s;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(s=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=R;async function U(O,x){if(!x.canHandleResource(T.URI.from({scheme:O.scheme})))return new Promise(F=>{const z=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===O.scheme&&M.added&&(z.dispose(),F())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize(x){return(0,C.isNumber)(x)||(x=0),x<V.KB?(0,y.localize)(1,null,x.toFixed(0)):x<V.MB?(0,y.localize)(2,null,(x/V.KB).toFixed(2)):x<V.GB?(0,y.localize)(3,null,(x/V.MB).toFixed(2)):x<V.TB?(0,y.localize)(4,null,(x/V.GB).toFixed(2)):(0,y.localize)(5,null,(x/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var ee;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ee=e.Arch||(e.Arch={}));function Q(O){return{maxFileSize:O===0?300*V.MB:16*V.GB,maxHeapSize:O===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=Q}),define(ge[82],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...k){this._entries=new Map;for(let[C,T]of k)this.set(C,T)}set(k,C){const T=this._entries.get(k);return this._entries.set(k,C),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=g}),define(ge[188],pe([0,1,17,16,115,180,4,82]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class I extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class n{constructor(l=new y.ServiceCollection,v=!1,S){this._activeInstantiations=new Set,this._services=l,this._strict=v,this._parent=S,this._services.set(T.IInstantiationService,this)}createChild(l){return new n(l,this._strict,this)}invokeFunction(l,...v){let S=d.traceInvocation(l),b=!1;try{return l({get:(c,f)=>{if(b)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(c,S);if(!p&&f!==T.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return p}},...v)}finally{b=!0,S.stop()}}createInstance(l,...v){let S,b;return l instanceof k.SyncDescriptor?(S=d.traceCreation(l.ctor),b=this._createInstance(l.ctor,l.staticArguments.concat(v),S)):(S=d.traceCreation(l),b=this._createInstance(l,v,S)),S.stop(),b}_createInstance(l,v=[],S){let b=T._util.getServiceDependencies(l).sort((f,p)=>f.index-p.index),P=[];for(const f of b){let p=this._getOrCreateServiceInstance(f.id,S);if(!p&&this._strict&&!f.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${f.id}.`);P.push(p)}let c=b.length>0?b[0].index:v.length;if(v.length!==c){console.warn(`[createInstance] First service dependency of ${l.name} at position ${c+1} conflicts with ${v.length} static arguments`);let f=c-v.length;f>0?v=v.concat(new Array(f)):v=v.slice(0,c)}return new l(...[...v,...P])}_setServiceInstance(l,v){if(this._services.get(l)instanceof k.SyncDescriptor)this._services.set(l,v);else if(this._parent)this._parent._setServiceInstance(l,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let v=this._services.get(l);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):v}_getOrCreateServiceInstance(l,v){let S=this._getServiceInstanceOrDescriptor(l);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,S,v.branch(l,!0)):(v.branch(l,!1),S)}_safeCreateAndCacheServiceInstance(l,v,S){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,v,S)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,v,S){const b=new C.Graph(f=>f.id.toString());let P=0;const c=[{id:l,desc:v,_trace:S}];for(;c.length;){const f=c.pop();if(b.lookupOrInsertNode(f),P++>1e3)throw new I(b);for(let p of T._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${l} depends on ${p.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:p.id,desc:t,_trace:f._trace.branch(p.id,!0)};b.insertEdge(f,r),c.push(r)}}}for(;;){const f=b.roots();if(f.length===0){if(!b.isEmpty())throw new I(b);break}for(const{data:p}of f){if(this._getServiceInstanceOrDescriptor(p.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,r)}b.removeNode(p)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,v,S=[],b,P){if(this._services.get(l)instanceof k.SyncDescriptor)return this._createServiceInstance(v,S,b,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,v,S,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(l,v=[],S,b){if(S){const P=new g.IdleValue(()=>this._createInstance(l,v,b));return new Proxy(Object.create(null),{get(c,f){if(f in c)return c[f];let p=P.value,t=p[f];return typeof t!="function"||(t=t.bind(p),c[f]=t),t},set(c,f,p){return P.value[f]=p,!0}})}else return this._createInstance(l,v,b)}}e.InstantiationService=n;var A;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(A||(A={}));class d{constructor(l,v){this.type=l,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return _?new d(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(l){return _?new d(0,l.name):d._None}branch(l,v){let S=new d(2,l.toString());return this._dep.push([l,v,S]),S}stop(){let l=Date.now()-this._start;d._totals+=l;let v=!1;function S(P,c){let f=[],p=new Array(P+1).join("	");for(const[t,r,o]of c._dep)if(r&&o){v=!0,f.push(`${p}CREATES -> ${t}`);let i=S(P+1,o);i&&f.push(i)}else f.push(`${p}uses -> ${t}`);return f.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(l>2||v)&&console.log(b.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ge[12],pe([0,1,60,3,6,11,4]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function y(){return new Date().toISOString()}var _;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class I extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class n extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(_.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(_.Error,this.format(o))}else this.log(_.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let o=0;o<t.length;o++){let i=t[o];if(typeof i=="object")try{i=JSON.stringify(i)}catch(a){}r+=(o>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class A extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...r){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}debug(t,...r){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}info(t,...r){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}warn(t,...r){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...r):console.warn(`[main ${y()}]`,t,...r))}error(t,...r){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}critical(t,...r){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class d extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class m extends I{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class l extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class v extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=v;class S extends k.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?_.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class b{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function P(p){if(p.verbose)return _.Trace;if(typeof p.logLevel=="string"){const t=c(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function c(p){switch(p){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=c;function f(p){switch(p){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=f}),define(ge[116],pe([0,1,42,12]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(_,I,n,A){try{const d=await new Promise((m,l)=>{J(["spdlog"],m,l)});return d.setFlushOn(L.LogLevel.Trace),d.createAsyncRotatingLogger(_,I,n,A)}catch(d){console.error(d)}return null}function C(_,I,n,A){const d=J.__$__nodeRequire("spdlog");return d.setFlushOn(L.LogLevel.Trace),d.createRotatingLogger(_,I,n,A)}e.createRotatingLogger=C;function T(_,I,n){switch(I){case L.LogLevel.Trace:_.trace(n);break;case L.LogLevel.Debug:_.debug(n);break;case L.LogLevel.Info:_.info(n);break;case L.LogLevel.Warning:_.warn(n);break;case L.LogLevel.Error:_.error(n);break;case L.LogLevel.Critical:_.critical(n);break;default:throw new Error("Invalid log level")}}class y extends L.AbstractMessageLogger{constructor(I,n,A,d){super();this.name=I,this.filepath=n,this.rotating=A,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const I=this.rotating?6:1,n=30/I*g.ByteSize.MB;return k(this.name,this.filepath,n,I).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:d,message:m}of this.buffer)T(this._logger,d,m);this.buffer=[]}})}log(I,n){this._logger?T(this._logger,I,n):this.getLevel()<=I&&this.buffer.push({level:I,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(ge[117],pe([0,1,48,160,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(l,v){return v-l}_.compare=I;const n=Object.create(null);n[_.Error]=(0,L.localize)(0,null),n[_.Warning]=(0,L.localize)(1,null),n[_.Info]=(0,L.localize)(2,null);function A(l){return n[l]||""}_.toString=A;function d(l){switch(l){case g.default.Error:return _.Error;case g.default.Warning:return _.Warning;case g.default.Info:return _.Info;case g.default.Ignore:return _.Hint}}_.fromSeverity=d;function m(l){switch(l){case _.Error:return g.default.Error;case _.Warning:return g.default.Warning;case _.Info:return g.default.Info;case _.Hint:return g.default.Ignore}}_.toSeverity=m}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(_){const I="";function n(d){return A(d,!0)}_.makeKey=n;function A(d,m){let l=[I];return d.source?l.push(d.source.replace("\xA6","\\\xA6")):l.push(I),d.code?typeof d.code=="string"?l.push(d.code.replace("\xA6","\\\xA6")):l.push(d.code.value.replace("\xA6","\\\xA6")):l.push(I),d.severity!==void 0&&d.severity!==null?l.push(T.toString(d.severity)):l.push(I),d.message&&m?l.push(d.message.replace("\xA6","\\\xA6")):l.push(I),d.startLineNumber!==void 0&&d.startLineNumber!==null?l.push(d.startLineNumber.toString()):l.push(I),d.startColumn!==void 0&&d.startColumn!==null?l.push(d.startColumn.toString()):l.push(I),d.endLineNumber!==void 0&&d.endLineNumber!==null?l.push(d.endLineNumber.toString()):l.push(I),d.endColumn!==void 0&&d.endColumn!==null?l.push(d.endColumn.toString()):l.push(I),l.push(I),l.join("\xA6")}_.makeKeyOptionalMessage=A})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ge[189],pe([0,1,3,48,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,k.createDecorator)("notificationService");var C;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new _,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=y;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(ge[190],pe([0,1,6,8,2,4]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function T(y,_){return k.URI.isUri(y)?(0,L.equalsIgnoreCase)(y.scheme,_):(0,L.startsWithIgnoreCase)(y,_+":")}e.matchesScheme=T}),define(ge[191],pe([0,1,10,11,38,23]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const y=L.globals.vscode.context.configuration();if(y)T=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const y=(0,C.dirname)(g.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,C.joinPath)(y,"product.json").fsPath);const _=J.__$__nodeRequire((0,C.joinPath)(y,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:_.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var $e=this&&this.__param||function(J,e){return function(g,L){e(g,L,J)}};define(ge[118],pe([0,1,17,21,6,4]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var T;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let _=class extends k.Disposable{constructor(A,d){super();this.deferred=new g.DeferredPromise,d.withProgress(A,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};_=ze([$e(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends k.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(A){this.stop();const d=++this.currentOperationId,m=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:m.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ge[34],pe([0,1,54,14]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,y){g.ok(L.isString(T)),g.ok(L.isObject(y)),g.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,y)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ge[119],pe([0,1,3,34]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class C{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[k(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;L.Registry.add(e.Extensions.JSONContribution,T)}),define(ge[83],pe([0,1,3,14,155,119,34]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=T.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new g.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new g.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,c=!0){this.registerConfigurations([P],c)}registerConfigurations(P,c=!0){const f=[];P.forEach(p=>{f.push(...this.validateAndRegisterProperties(p,c,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(P){const c=[],f=p=>{if(p.properties)for(const t in p.properties)c.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>f(t))};for(const p of P){f(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(P){const c=[],f=[];for(const p of P)for(const t in p)if(c.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const r={type:"object",default:this.defaultValues[t],description:k.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};f.push(d(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=p[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(P){const c=[];for(const f of P)for(const p in f)if(c.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const c of P)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,c=!0,f,p=3){p=L.isUndefinedOrNull(P.scope)?p:P.scope;let t=[],r=P.properties;if(r)for(let i in r){if(c&&v(i)){delete r[i];continue}const a=r[i];if(this.updatePropertyDefaultValue(i,a),e.OVERRIDE_PROPERTY_PATTERN.test(i)?a.scope=void 0:(a.scope=L.isUndefinedOrNull(a.scope)?p:a.scope,a.restricted=L.isUndefinedOrNull(a.restricted)?!!f?.restrictedConfigurations?.includes(i):a.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let o=P.allOf;if(o)for(let i of o)t.push(...this.validateAndRegisterProperties(i,c,f,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const c=f=>{let p=f.properties;if(p)for(const r in p)this.updateSchema(r,p[r]);let t=f.allOf;t&&t.forEach(c)};c(P)}updateSchema(P,c){switch(e.allSettings.properties[P]=c,c.scope){case 1:e.applicationSettings.properties[P]=c;break;case 2:e.machineSettings.properties[P]=c;break;case 6:e.machineOverridableSettings.properties[P]=c;break;case 3:e.windowSettings.properties[P]=c;break;case 4:e.resourceSettings.properties[P]=c;break;case 5:e.resourceSettings.properties[P]=c,this.resourceLanguageSettingsSchema.properties[P]=c;break}}removeFromSchema(P,c){switch(delete e.allSettings.properties[P],c.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const c=`[${P}]`,f={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,f),e.allSettings.properties[c]=f,e.applicationSettings.properties[c]=f,e.machineSettings.properties[c]=f,e.machineOverridableSettings.properties[c]=f,e.windowSettings.properties[c]=f,e.resourceSettings.properties[c]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,c){let f=this.defaultValues[P];L.isUndefined(f)&&(f=c.default),L.isUndefined(f)&&(f=m(c.type)),c.default=f}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function d(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=d;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const l=new n;T.Registry.add(e.Extensions.Configuration,l);function v(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?k.localize(5,null,b):l.getConfigurationProperties()[b]!==void 0?k.localize(6,null,b):null:k.localize(4,null)}e.validateProperty=v;function S(){const b=[],P=l.getConfigurationProperties();for(const c of Object.keys(P))b.push([c,P[c].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=S}),define(ge[120],pe([0,1,25,14,2,83,4,34]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function _(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=_;var I;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function A(r,o){const i=o?r?o.keys.filter(D=>r.keys.indexOf(D)===-1):[...o.keys]:[],a=r?o?r.keys.filter(D=>o.keys.indexOf(D)===-1):[...r.keys]:[],h=[];if(o&&r){for(const D of r.keys)if(o.keys.indexOf(D)!==-1){const R=b(r.contents,D),U=b(o.contents,D);g.equals(R,U)||h.push(D)}}const u=[],w=D=>{const R={};for(const U of D)for(const V of U.identifiers)R[p(V)]=U;return R},E=o?w(o.overrides):{},s=r?w(r.overrides):{};if(Object.keys(E).length)for(const D of i){const R=E[D];R&&u.push([(0,C.overrideIdentifierFromKey)(D),R.keys])}if(Object.keys(s).length)for(const D of a){const R=s[D];R&&u.push([(0,C.overrideIdentifierFromKey)(D),R.keys])}if(Object.keys(E).length&&Object.keys(s).length)for(const D of h){const R=s[D],U=E[D];if(R&&U){const V=A({contents:R.contents,keys:R.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});u.push([(0,C.overrideIdentifierFromKey)(D),[...V.added,...V.removed,...V.updated]])}}return{added:i,removed:a,updated:h,overrides:u}}e.compare=A;function d(r,o){const i=[];for(const a of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const u in r[a])h[u]=r[a][u];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:m(h,o)})}return i}e.toOverrides=d;function m(r,o){const i=Object.create(null);for(let a in r)l(i,a,r[a],o);return i}e.toValuesTree=m;function l(r,o,i,a){const h=o.split("."),u=h.pop();let w=r;for(let E=0;E<h.length;E++){let s=h[E],D=w[s];switch(typeof D){case"undefined":D=w[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${o} as ${h.slice(0,E+1).join(".")} is ${JSON.stringify(D)}`);return}w=D}if(typeof w=="object"&&w!==null)try{w[u]=i}catch(E){a(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}else a(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=l;function v(r,o){const i=o.split(".");S(r,i)}e.removeFromValueTree=v;function S(r,o){const i=o.shift();if(o.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const a=r[i];typeof a=="object"&&!Array.isArray(a)&&(S(a,o),Object.keys(a).length===0&&delete r[i])}}function b(r,o,i){function a(w,E){let s=w;for(const D of E){if(typeof s!="object"||s===null)return;s=s[D]}return s}const h=o.split("."),u=a(r,h);return typeof u=="undefined"?i:u}e.getConfigurationValue=b;function P(r,o,i){Object.keys(o).forEach(a=>{a!=="__proto__"&&(a in r?L.isObject(r[a])&&L.isObject(o[a])?P(r[a],o[a],i):i&&(r[a]=o[a]):r[a]=o[a])})}e.merge=P;function c(){const r=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function f(){const r=Object.create(null),o=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in o){let a=o[i].default;l(r,i,a,h=>console.error(`Conflict in default settings: ${h}`))}return r}e.getDefaultValues=f;function p(r){return`[${r}]`}e.keyFromOverrideIdentifier=p;function t(r,o,i){const a=r.inspect(o),h=r.inspect(i);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}e.getMigratedSettingValue=t}),define(ge[192],pe([0,1,20,3,57,6,22,25,14,2,120,83,34]),function(J,e,g,L,k,C,T,y,_,I,n,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const i of g.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[i],h=r[i];h&&(typeof a=="object"&&typeof h=="object"?(a=y.deepClone(a),this.mergeContents(a,h)):a=h),o[i]=a}return new m(o,this.keys,this.overrides)}merge(...t){const r=y.deepClone(this.contents),o=y.deepClone(this.overrides),i=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const h of a.overrides){const[u]=o.filter(w=>g.equals(w.identifiers,h.identifiers));u?this.mergeContents(u.contents,h.contents):o.push(y.deepClone(h))}for(const h of a.keys)i.indexOf(h)===-1&&i.push(h)}return new m(r,i,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&_.isObject(t[o])&&_.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=y.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class l extends m{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),o=[];for(const i of Object.keys(t))A.OVERRIDE_PROPERTY_PATTERN.test(i)&&o.push({identifiers:[(0,A.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,o)}}e.DefaultConfigurationModel=l;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!_.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:o,keys:i,overrides:a,restricted:h}=this.doParseRaw(t,r);this._configurationModel=new m(o,i,a),this._restrictedConfigurations=h||[]}doParseContent(t){let r={},o=null,i=[],a=[],h=[];function u(E){Array.isArray(i)?i.push(E):o!==null&&(i[o]=E)}let w={onObjectBegin:()=>{let E={};u(E),a.push(i),i=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let E=[];u(E),a.push(i),i=E,o=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:u,onError:(E,s,D)=>{h.push({error:E,offset:s,length:D})}};if(t)try{k.visit(t,w),r=i[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const o=d.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,o,!0,r);t=i.raw;const a=(0,n.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),h=Object.keys(t),u=(0,n.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:h,overrides:u,restricted:i.restricted}}filter(t,r,o,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const a={},h=[];for(let u in t)if(A.OVERRIDE_PROPERTY_PATTERN.test(u)&&o){const w=this.filter(t[u],r,!1,i);a[u]=w.raw,h.push(...w.restricted)}else{const w=r[u],E=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&h.push(u),(E===void 0||i.scopes===void 0||i.scopes.includes(E))&&(i.skipRestricted&&w?.restricted||(a[u]=t[u]))}return{raw:a,restricted:h}}}e.ConfigurationModelParser=v;class S extends C.Disposable{constructor(t,r,o,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class b{constructor(t,r,o=new m,i=new m,a=new T.ResourceMap,h=new m,u=new T.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=u,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let i;o.resource?(i=this._memoryConfigurationByResource.get(o.resource),i||(i=new m,this._memoryConfigurationByResource.set(o.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const i=this.getConsolidateConfigurationModel(r,o),a=this.getFolderConfigurationModelForResource(r.resource,o),h=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,u=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),s=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),D=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,R=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,U=r.overrideIdentifier?h.override(r.overrideIdentifier).getValue(t):h.getValue(t),V=i.getValue(t),ee=g.distinct(g.flatten(i.overrides.map(Q=>Q.identifiers))).filter(Q=>i.getOverrideValue(t,Q)!==void 0);return{defaultValue:u,userValue:w,userLocalValue:E,userRemoteValue:s,workspaceValue:D,workspaceFolderValue:R,memoryValue:U,value:V,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:s!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:a?.freeze().getValue(t),override:r.overrideIdentifier?a?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:h.getValue(t),override:r.overrideIdentifier?h.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(i=>A.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const a=(0,A.overrideIdentifierFromKey)(i),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),w=[...u.filter(E=>h.indexOf(E)===-1),...h.filter(E=>u.indexOf(E)===-1),...h.filter(E=>!y.equals(this._defaultConfiguration.override(a).getValue(E),t.override(a).getValue(E)))];return[a,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:i,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),h=[...r,...o,...i];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:i,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let h=[...r,...o,...i];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:i,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let h=[...r,...o,...i];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:i,updated:a,removed:h,overrides:u}=(0,n.compare)(o,r);let w=[...i,...a,...h];return(w.length||!o)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:i,removed:a,overrides:h}=(0,n.compare)(r,void 0);return{keys:[...o,...i,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(o=this.getFolderConsolidatedConfiguration(i.uri)||o);const a=this._memoryConfigurationByResource.get(t);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=o.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:i,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:i,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((h,u)=>(h.set(I.URI.revive(u[0]),this.parseConfigurationModel(u[1])),h),new T.ResourceMap);return new b(r,o,new m,i,a,new m,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function P(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,r=new Map;for(const i of p)i.keys.forEach(a=>t.add(a)),i.overrides.forEach(([a,h])=>{const u=(0,T.getOrSet)(r,a,new Set);h.forEach(w=>u.add(w))});const o=[];return r.forEach((i,a)=>o.push([a,[...i.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=P;class c{constructor(t,r,o,i){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const h=new m;this.affectedKeys.forEach(u=>h.setValue(u,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!y.equals(o,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=(0,n.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof o=="object"&&(i=Object.keys(o)[0]);){if(t=t[i],!t)return!1;o=o[i]}return!0}}e.ConfigurationChangeEvent=c;class f extends c{constructor(t,r,o,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=f}),define(ge[121],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,y=L.Unknown,_){super(T);this._message=T,this._code=y,this._detail=_,this.isHandled=y===L.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(ge[84],pe([0,1,10]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(I){return I.scheme===g.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=L;function k(I){if(!I)return;const n=I.indexOf("+");return n<0?I:I.substr(0,n)}e.getRemoteName=k;function C(I){return I.scheme!==g.Schemas.file&&I.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=C;function T(I){if(I.folders.length)return I.folders.every(n=>C(n.uri))?I.folders[0].uri:void 0;if(I.configuration&&C(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=T;function y(I){return T(I)?.scheme}e.getVirtualWorkspaceScheme=y;function _(I){return T(I)!==void 0}e.isVirtualWorkspace=_}),define(ge[193],pe([0,1,3,11,4,12]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function _(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=_,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=n;function A(m,l){return l?l!==1&&m<1024:!L.isWindows&&m<1024}e.isPortPrivileged=A;let d=class{constructor(l){this.logService=l,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,v){return this._tunnelProvider=l,l?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async l=>{const v=[],S=Array.from(this._tunnels.values());for(let b of S){const P=Array.from(b.values());for(let c of P){const f=await c.value;f&&v.push(f)}}l(v)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:v}of l.values())await v.then(S=>S?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,v,S,b,P=!1,c=!1,f){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${S} on local port ${b}.`),!l)return;v||(v="localhost");const p=this.retainOrCreateTunnel(l,v,S,b,P,c,f);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,public:l.public,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const v=this._tunnels.get(l.tunnelRemoteHost);if(v){const S=v.get(l.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,S))}}}}async tryDisposeTunnel(l,v,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${v}.`);const b=S.value.then(async P=>{P&&(await P.dispose(!0),this._onTunnelClosed.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(v),b}}async closeTunnel(l,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${v} `);const S=this._tunnels.get(l);if(S&&S.has(v)){const b=S.get(v);b.refcount=0,await this.tryDisposeTunnel(l,v,b)}}addTunnelToMap(l,v,S){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(v,{refcount:1,value:S})}async removeEmptyTunnelFromMap(l,v){const S=this._tunnels.get(l);S&&(await S.get(v)||S.delete(v),S.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,v){let S=[l];I(l)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):n(l)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const b=S.map(P=>this._tunnels.get(P));for(const P of b){const c=P?.get(v);if(c)return c}}canTunnel(l){return!!_(l)}createWithProvider(l,v,S,b,P,c,f){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${S} on local port ${b}.`);const t={elevationRequired:P?A(b===void 0?S:b):!1},r={remoteAddress:{host:v,port:S},localAddressPort:b,public:c,protocol:f},o=l.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),o&&this.addTunnelToMap(v,S,o),o}};d=ze([$e(0,C.ILogService)],d),e.AbstractTunnelService=d}),define(ge[194],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((k,C)=>J(["vsda"],k,C))}async sign(k){try{const C=await this.vsda(),T=new C.signer;if(T)return T.sign(k)}catch(C){}return k}}e.SignService=g}),define(ge[195],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,C,T=5){let y;return y=C(_=>{const I=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(k);if(n){n.data.push(I);return}const A=setTimeout(()=>this.flushBuffer(k),T);n={data:[I],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(k),y.dispose()}},this._terminalBufferMap.set(k,n)}),y}stopBuffering(k){const C=this._terminalBufferMap.get(k);C&&C.dispose()}flushBuffer(k){const C=this._terminalBufferMap.get(k);C&&(this._terminalBufferMap.delete(k),this._callback(k,C.data.join("")))}}e.TerminalDataBufferer=g}),define(ge[196],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(ge[85],pe([0,1,47,3,6,4,34,196]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var _;(function(S){function b(P){return P&&typeof P=="object"&&typeof P.id=="string"}S.isThemeColor=b})(_=e.ThemeColor||(e.ThemeColor={}));function I(S){return{id:S}}e.themeColorFromId=I;var n;(function(S){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||_.isThemeColor(r.color))}S.isThemeIcon=b;const P=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const o=P.exec(r);if(!o)return;let[,i]=o;return{id:i}}S.fromString=c;function f(r,o){let i=r.id;const a=i.lastIndexOf("~");return a!==-1&&(i=i.substring(0,a)),o&&(i=`${i}~${o}`),{id:i}}S.modify=f;function p(r,o){return r.id===o.id&&r.color?.id===o.color?.id}S.isEqual=p;function t(r,o){return{id:r.id,color:o?I(o):void 0}}S.asThemeIcon=t,S.asClassNameArray=g.CSSIcon.asClassNameArray,S.asClassName=g.CSSIcon.asClassName,S.asCSSSelector=g.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function A(S){switch(S){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,k.toDisposable)(()=>{const P=this.themingParticipants.indexOf(b);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new d;T.Registry.add(e.Extensions.ThemingContribution,m);function l(S){return m.onColorThemeChange(S)}e.registerThemingParticipant=l;class v extends k.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,P){let c=this.theme.getColor(b);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=v}),define(ge[197],pe([0,1,17,47,3,161,119,34,85]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,P,c,f){const p=this.iconsById[b];if(p){if(c&&!p.description){p.description=c,this.iconSchema.properties[b].markdownDescription=`${c} $(${b})`;const o=this.iconReferenceSchema.enum.indexOf(b);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=c),this._onDidChange.fire()}return p}let t={id:b,description:c,defaults:P,deprecationMessage:f};this.iconsById[b]=t;let r={$ref:"#/definitions/icons"};return f&&(r.deprecationMessage=f),c&&(r.markdownDescription=`${c}: $(${b})`),this.iconSchema.properties[b]=r,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const P=this.iconReferenceSchema.enum.indexOf(b);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,P){const c=this.iconFontsById[b];if(c)return c;let f={id:b,definition:P};return this.iconFontsById[b]=f,this._onDidChange.fire(),f}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(p,t)=>p.id.localeCompare(t.id),P=p=>{for(;_.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of f.filter(t=>!!t.description).sort(b))c.push(`|<i class="${P(p)}"></i>|${p.id}|${_.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const p of f.filter(t=>!_.ThemeIcon.isThemeIcon(t.defaults)).sort(b))c.push(`|<i class="${P(p)}"></i>|${p.id}|`);return c.join(`
`)}}const n=new I;y.Registry.add(e.Extensions.IconContribution,n);function A(S,b,P,c){return n.registerIcon(S,b,P,c)}e.registerIcon=A;function d(){return n}e.getIconRegistry=d;function m(){for(const S of L.iconRegistry.all)n.registerIcon(S.id,S.definition,S.description);L.iconRegistry.onDidRegister(S=>n.registerIcon(S.id,S.definition,S.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let l=y.Registry.as(T.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,n.getIconSchema());const v=new g.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=A("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=A("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=A("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=_.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(ge[43],pe([0,1,22,23,2,4]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function y(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=y;function _(d){const m=d;return!!(m&&typeof m=="object"&&k.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=_;class I{constructor(m,l,v,S){this._id=m,this._configuration=v,this._ignorePathCasing=S,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class n{constructor(m,l){this.raw=l,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function A(d){return new n({uri:d,index:0,name:(0,L.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=A}),define(ge[198],pe([0,1,29,57,138,77,10,9,11,23,2,162,4,84,43]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(O){return(typeof O=="string"?(0,y.extname)(O):(0,I.extname)(O))===v}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,d.createDecorator)("workspacesService");function b(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function P(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=c;function f(O){const x=O;return typeof x?.id=="string"&&n.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=f;function p(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(O){const x=O;return typeof x?.id=="string"&&n.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function r(O){const x=O;if(x?.uri)return{id:x.id,uri:n.URI.revive(x.uri)};const F=O;if(F?.configPath)return{id:F.id,configPath:n.URI.revive(F.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=r;function o(O,x){return I.extUriBiasedIgnorePathCase.isEqualOrParent(O,x.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function i(O){return a(O)||h(O)}e.isStoredWorkspaceFolder=i;function a(O){const x=O;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function h(O){const x=O;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=h;function u(O,x,F,z,M=!_.isWindows,N){if(O.scheme!==z.scheme)return{name:F,uri:O.toString(!0)};let q=x?void 0:N.relativePath(z,O);if(q!==void 0)q.length===0?q=".":_.isWindows&&O.scheme===T.Schemas.file&&!M&&(q=q.replace(/\//g,"\\"));else if(O.scheme===T.Schemas.file)q=O.fsPath,_.isWindows&&(q=(0,C.normalizeDriveLetter)(q),M&&(q=(0,g.toSlashes)(q)));else{if(!N.isEqualAuthority(O.authority,z.authority))return{name:F,uri:O.toString(!0)};q=O.path}return{name:F,path:q}}e.getStoredWorkspaceFolder=u;function w(O,x,F){let z=[],M=new Set;const N=F.dirname(x);for(let q of O){let B;if(a(q))q.path&&(B=F.resolvePath(N,q.path));else if(h(q))try{B=n.URI.parse(q.uri),B.path[0]!=="/"&&(B=B.with({path:"/"+B.path}))}catch(K){console.warn(K)}if(B){let K=F.getComparisonKey(B);if(!M.has(K)){M.add(K);const te=q.name||F.basenameOrAuthority(B);z.push(new l.WorkspaceFolder({uri:B,name:te,index:z.length},q))}}}return z}e.toWorkspaceFolders=w;function E(O,x,F,z,M){let N=s(x,O);const q=M.dirname(x),B=M.dirname(z),K=[],te=D(N.folders);for(const Fe of N.folders){const qe=a(Fe)?M.resolvePath(q,Fe.path):n.URI.parse(Fe.uri);let We;F?We=!1:We=!a(Fe)||(0,y.isAbsolute)(Fe.path),K.push(u(qe,We,Fe.name,B,te,M))}const he={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},De=k.setProperty(O,["folders"],K,he);let Pe=k.applyEdits(O,De);return N.remoteAuthority===(0,m.getRemoteAuthority)(z)&&(Pe=k.applyEdits(Pe,k.removeProperty(Pe,["remoteAuthority"],he))),Pe}e.rewriteWorkspaceFileForNewLocation=E;function s(O,x){let F=L.parse(x);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(z=>i(z));else throw new Error(`${O} looks like an invalid workspace file.`);return F}function D(O){return _.isWindows?O.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=D;function R(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function U(O){return typeof O.folderUri=="string"}function V(O){return typeof O.fileUri=="string"}function ee(O,x){const F={workspaces:[],files:[]};if(O){const z=function(N,q){for(let B=0;B<N.length;B++)try{q(N[B],B)}catch(K){x.warn(`Error restoring recent entry ${JSON.stringify(N[B])}: ${K.toString()}. Skip entry.`)}},M=O;if(Array.isArray(M.entries))z(M.entries,N=>{const q=N.label,B=N.remoteAuthority;R(N)?F.workspaces.push({label:q,remoteAuthority:B,workspace:{id:N.workspace.id,configPath:n.URI.parse(N.workspace.configPath)}}):U(N)?F.workspaces.push({label:q,remoteAuthority:B,folderUri:n.URI.parse(N.folderUri)}):V(N)&&F.files.push({label:q,remoteAuthority:B,fileUri:n.URI.parse(N.fileUri)})});else{const N=O;Array.isArray(N.workspaces3)&&z(N.workspaces3,(q,B)=>{const K=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[B]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?F.workspaces.push({label:K,workspace:{id:q.id,configPath:n.URI.parse(q.configURIPath)}}):typeof q=="string"&&F.workspaces.push({label:K,folderUri:n.URI.parse(q)})}),Array.isArray(N.files2)&&z(N.files2,(q,B)=>{const K=Array.isArray(N.fileLabels)&&N.fileLabels[B]||void 0;typeof q=="string"&&F.files.push({label:K,fileUri:n.URI.parse(q)})})}}return F}e.restoreRecentlyOpened=ee;function Q(O){const x={entries:[]};for(const F of O.workspaces)P(F)?x.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):x.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of O.files)x.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return x}e.toStoreData=Q}),define(ge[86],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const C=this._idPool++;return this._data.set(C,k),this.logDebugInfo(),C}get(k,C){return this._data.has(k)?this._data.get(k)[C]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(ge[51],pe([0,1,2,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class C{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(_=>({name:_.name,group:_.group,resource:g.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=C}),define(ge[62],pe([0,1,10,4]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,y){y===null?this._providerInfo.delete(T):this._providerInfo.set(T,y)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(ge[199],pe([0,1,17]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,y,_){this._deferredPromises=new Map,this._id=T,this._shared=y,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of I.values())n.complete()}catch(n){for(const A of I.values())A.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,y){let _=this._value[T];return typeof _=="undefined"&&(_=y),_}update(T,y){this._value[T]=y;let _=this._deferredPromises.get(T);if(_!==void 0)return _.p;const I=new g.DeferredPromise;return this._deferredPromises.set(T,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class k extends L{constructor(T,y){super(T.identifier.value,!0,y);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(ge[200],pe([0,1,3,2,12]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(y,_){this._logService=y,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(y,_,I){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y)).acceptModelChanged(_,I)}$acceptDirtyStateChanged(y,_){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y)).acceptDirty(_)}$acceptModelSaved(y){const _=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(y,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",y.path,_);const I=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y));I.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};C=ze([$e(0,k.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(ge[13],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[201],pe([0,1,26,3]),function(J,e,g,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(y,_){k.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),it(this,k,_,"f"),He(this,k,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(y){return He(this,k,"f").get(this._id,y)}store(y,_){return He(this,k,"f").store(this._id,y,_)}delete(y){return He(this,k,"f").delete(this._id,y)}}e.ExtensionSecrets=C,k=new WeakMap}),define(ge[122],pe([0,1,4,3]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(ge[87],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,k=(P,c)=>{const f={controllerId:c};return L.set(P,f),f};e.createPrivateApiFor=k;const C=P=>L.get(P);e.getPrivateApiFor=C;const T=(P,c,f,p)=>{let t=f;return{enumerable:!0,configurable:!1,get(){return t},set(r){p(t,r)||(t=r,P.listener?.({op:3,key:c,value:r}))}}},y=(P,c)=>P===c,_={range:(P,c)=>P===c?!0:!P||!c?!1:P.isEqual(c),label:y,description:y,busy:y,error:y,canResolveChildren:y,tags:(P,c)=>!(P.length!==c.length||P.some(f=>!c.find(p=>f.id===p.id)))},I=Object.keys(_),n=(P,c)=>({range:T(P,"range",void 0,_.range),label:T(P,"label",c,_.label),description:T(P,"description",void 0,_.description),canResolveChildren:T(P,"canResolveChildren",!1,_.canResolveChildren),busy:T(P,"busy",!1,_.busy),error:T(P,"error",void 0,_.error),tags:T(P,"tags",[],_.tags)}),A=(P,c)=>{const f=new Map;for(const p of I)_[p](P[p],c[p])||f.set(p,c[p]);return f};e.diffTestItems=A;class d extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=d;class m extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class l extends Error{constructor(c,f,p){super(`TestItem with ID "${c}" is from controller "${f}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=l;const v=P=>{const c=(0,e.getPrivateApiFor)(P);let f=new Map;return{get size(){return f.size},forEach(p,t){for(const r of f.values())p.call(t,r,this)},replace(p){const t=new Map,r=new Set(f.keys()),o={op:4,ops:[]};for(const i of p){if(!(i instanceof S))throw new m(i.id);const a=(0,e.getPrivateApiFor)(i).controllerId;if(a!==c.controllerId)throw new l(i.id,a,c.controllerId);if(t.has(i.id))throw new d(i.id);t.set(i.id,i),r.delete(i.id),o.ops.push({op:0,item:i})}for(const i of r.keys())o.ops.push({op:1,id:i});c.listener?.(o),f=t},add(p){if(!(p instanceof S))throw new m(p.id);f.set(p.id,p),c.listener?.({op:0,item:p})},delete(p){f.delete(p)&&c.listener?.({op:1,id:p})},get(p){return f.get(p)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class S{constructor(c,f,p,t){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const r=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof b?void 0:r.parent}},children:{value:v(this),enumerable:!0,writable:!1},...n(r,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=S;class b extends S{constructor(c,f){super(c,c,f,void 0)}}e.TestItemRootImpl=b}),define(ge[52],pe([0,1,4,3,13]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(y){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}y.fromApiTunnel=_;function I(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}y.fromServiceTunnel=I})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let T=class{constructor(_){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,I){return{dispose:()=>{}}}async $providePortAttributes(_,I,n,A,d){return[]}async $forwardPort(_,I){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=ze([$e(0,k.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[7],pe([0,1,20,16,99,22,102,14,2,32,42,121]),function(J,e,g,L,k,C,T,y,_,I,n,A){"use strict";var d,m,l,v,S,b,P,c,f,p,t,r,o,i,a,h,u,w,E,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(H){function $(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf($,H),Object.setPrototypeOf($.prototype,H.prototype),$}let R=S=class{constructor($){d.set(this,void 0),it(this,d,$,"f")}static from(...$){let se=$;return new S(function(){if(se){for(const Ie of se)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();se=void 0}})}dispose(){typeof He(this,d,"f")=="function"&&(He(this,d,"f").call(this),it(this,d,void 0,"f"))}};d=new WeakMap,R=S=ze([D],R),e.Disposable=R;let U=b=class{constructor($,se){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=se}static Min(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ie=1;Ie<$.length;Ie++){const Ye=$[Ie];Ye.isBefore(se)&&(se=Ye)}return se}static Max(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ie=1;Ie<$.length;Ie++){const Ye=$[Ie];Ye.isAfter(se)&&(se=Ye)}return se}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;let{line:se,character:Ie}=$;return typeof se=="number"&&typeof Ie=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,se=0){if($===null||se===null)throw(0,L.illegalArgument)();let Ie;return typeof $=="undefined"?Ie=0:typeof $=="number"?Ie=$:(Ie=typeof $.lineDelta=="number"?$.lineDelta:0,se=typeof $.characterDelta=="number"?$.characterDelta:0),Ie===0&&se===0?this:new b(this.line+Ie,this.character+se)}with($,se=this.character){if($===null||se===null)throw(0,L.illegalArgument)();let Ie;return typeof $=="undefined"?Ie=this.line:typeof $=="number"?Ie=$:(Ie=typeof $.line=="number"?$.line:this.line,se=typeof $.character=="number"?$.character:this.character),Ie===this.line&&se===this.character?this:new b(Ie,se)}toJSON(){return{line:this.line,character:this.character}}};U=b=ze([D],U),e.Position=U;let V=P=class{constructor($,se,Ie,Ye){let nt,st;if(typeof $=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ye=="number"?(nt=new U($,se),st=new U(Ie,Ye)):$ instanceof U&&se instanceof U&&(nt=$,st=se),!nt||!st)throw new Error("Invalid arguments");nt.isBefore(st)?(this._start=nt,this._end=st):(this._start=st,this._end=nt)}static isRange($){return $ instanceof P?!0:$?U.isPosition($.start)&&U.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof P?this.contains($._start)&&this.contains($._end):$ instanceof U?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const se=U.Max($.start,this._start),Ie=U.Min($.end,this._end);if(!se.isAfter(Ie))return new P(se,Ie)}union($){if(this.contains($))return this;if($.contains(this))return $;const se=U.Min($.start,this._start),Ie=U.Max($.end,this.end);return new P(se,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,se=this.end){if($===null||se===null)throw(0,L.illegalArgument)();let Ie;return $?U.isPosition($)?Ie=$:(Ie=$.start||this.start,se=$.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&se.isEqual(this.end)?this:new P(Ie,se)}toJSON(){return[this.start,this.end]}};V=P=ze([D],V),e.Range=V;let ee=c=class extends V{constructor($,se,Ie,Ye){let nt,st;if(typeof $=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ye=="number"?(nt=new U($,se),st=new U(Ie,Ye)):$ instanceof U&&se instanceof U&&(nt=$,st=se),!nt||!st)throw new Error("Invalid arguments");super(nt,st);this._anchor=nt,this._active=st}static isSelection($){return $ instanceof c?!0:$?V.isRange($)&&U.isPosition($.anchor)&&U.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=c=ze([D],ee),e.Selection=ee;class Q{constructor($,se,Ie){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof Ie!="undefined"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z\-]+$/.test(Ie)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(se),this.connectionToken=Ie}}e.ResolvedAuthority=Q;class O extends Error{constructor($,se=A.RemoteAuthorityResolverErrorCode.Unknown,Ie){super($);this._message=$,this._code=se,this._detail=Ie,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable($,se){return new O($,A.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable($){return new O($,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var F;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=f=class{constructor($,se){this._range=$,this._newText=se}static isTextEdit($){return $ instanceof f?!0:$?V.isRange($)&&typeof $.newText=="string":!1}static replace($,se){return new f($,se)}static insert($,se){return f.replace(new V($,$),se)}static delete($){return f.replace($,"")}static setEndOfLine($){const se=new f(new V(new U(0,0),new U(0,0)),"");return se.newEol=$,se}get range(){return this._range}set range($){if($&&!V.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=f=ze([D],z),e.TextEdit=z;var M;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(M=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,se,Ie,Ye){this._edits.push({_type:1,from:$,to:se,options:Ie,metadata:Ye})}createFile($,se,Ie){this._edits.push({_type:1,from:void 0,to:$,options:se,metadata:Ie})}deleteFile($,se,Ie){this._edits.push({_type:1,from:$,to:void 0,options:se,metadata:Ie})}replaceNotebookMetadata($,se,Ie){this._edits.push({_type:3,metadata:Ie,uri:$,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells($,se,Ie,Ye,nt){let st,ct,yt=[],At;if(Bt.isNotebookRange(se)&&Lt.isNotebookCellDataArray(Ie)&&!Lt.isNotebookCellDataArray(Ye)?(st=se.start,ct=se.end,yt=Ie,At=Ye):typeof se=="number"&&typeof Ie=="number"&&Lt.isNotebookCellDataArray(Ye)&&(st=se,ct=Ie,yt=Ye,At=nt),st===void 0||ct===void 0)throw new Error("Invalid arguments");(st!==ct||yt.length>0)&&this._edits.push({_type:5,uri:$,index:st,count:ct-st,cells:yt,metadata:At})}replaceNotebookCellMetadata($,se,Ie,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:se,metadata:Ie}})}replace($,se,Ie,Ye){this._edits.push({_type:2,uri:$,edit:new z(se,Ie),metadata:Ye})}insert($,se,Ie,Ye){this.replace($,new V(se,se),Ie,Ye)}delete($,se,Ie){this.replace($,se,"",Ie)}has($){return this._edits.some(se=>se._type===2&&se.uri.toString()===$.toString())}set($,se){if(se)for(const Ie of se)Ie&&this._edits.push({_type:2,uri:$,edit:Ie});else{for(let Ie=0;Ie<this._edits.length;Ie++){const Ye=this._edits[Ie];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[Ie]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get($){const se=[];for(let Ie of this._edits)Ie._type===2&&Ie.uri.toString()===$.toString()&&se.push(Ie.edit);return se}entries(){const $=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let Ie=$.get(se.uri);Ie||(Ie=[se.uri,[]],$.set(se.uri,Ie)),Ie[1].push(se.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=ze([D],N),e.WorkspaceEdit=N;let q=p=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof p?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=p._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,se=this._tabstop++){if(typeof $=="function"){const Ie=new p;Ie._tabstop=this._tabstop,$(Ie),this._tabstop=Ie._tabstop,$=Ie.value}else $=p._escape($);return this.value+="${",this.value+=se,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,se=this._tabstop++){const Ie=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable($,se){if(typeof se=="function"){const Ie=new p;Ie._tabstop=this._tabstop,se(Ie),this._tabstop=Ie._tabstop,se=Ie.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,se&&(this.value+=":",this.value+=se),this.value+="}",this}};q=p=ze([D],q),e.SnippetString=q;var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let te=t=class{constructor($,se){if(this.uri=$,se)if(se instanceof V)this.range=se;else if(se instanceof U)this.range=new V(se,se);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?V.isRange($.range)&&_.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};te=t=ze([D],te),e.Location=te;let he=class{constructor($,se){this.location=$,this.message=se}static is($){return $?typeof $.message=="string"&&$.location&&V.isRange($.location.range)&&_.URI.isUri($.location.uri):!1}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.location.range.isEqual(se.location.range)&&$.location.uri.toString()===se.location.uri.toString()}};he=ze([D],he),e.DiagnosticRelatedInformation=he;let De=class{constructor($,se,Ie=K.Error){if(!V.isRange($))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=$,this.message=se,this.severity=Ie}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.severity===se.severity&&$.code===se.code&&$.severity===se.severity&&$.source===se.source&&$.range.isEqual(se.range)&&(0,g.equals)($.tags,se.tags)&&(0,g.equals)($.relatedInformation,se.relatedInformation,he.isEqual)}};De=ze([D],De),e.Diagnostic=De;let Pe=class{constructor($,se){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=se}};Pe=ze([D],Pe),e.Hover=Pe;var Fe;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Fe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor($,se=Fe.Text){this.range=$,this.kind=se}toJSON(){return{range:this.range,kind:Fe[this.kind]}}};qe=ze([D],qe),e.DocumentHighlight=qe;var We;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var je;(function(H){H[H.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let W=r=class{constructor($,se,Ie,Ye,nt){this.name=$,this.kind=se,this.containerName=nt,typeof Ie=="string"&&(this.containerName=Ie),Ye instanceof te?this.location=Ye:Ie instanceof V&&(this.location=new te(Ye,Ie)),r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};W=r=ze([D],W),e.SymbolInformation=W;let Z=o=class{constructor($,se,Ie,Ye,nt){this.name=$,this.detail=se,this.kind=Ie,this.range=Ye,this.selectionRange=nt,this.children=[],o.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(o.validate)}};Z=o=ze([D],Z),e.DocumentSymbol=Z;var ne;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor($,se){this.title=$,this.kind=se}};ae=ze([D],ae),e.CodeAction=ae;let Y=i=class{constructor($){this.value=$}append($){return new i(this.value?this.value+i.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+i.sep)}};Y.sep=".",Y=i=ze([D],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let oe=class{constructor($,se){if(this.range=$,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=ze([D],oe),e.SelectionRange=oe;class we{constructor($,se,Ie,Ye,nt,st){this.kind=$,this.name=se,this.detail=Ie,this.uri=Ye,this.range=nt,this.selectionRange=st}}e.CallHierarchyItem=we;class Me{constructor($,se){this.fromRanges=se,this.from=$}}e.CallHierarchyIncomingCall=Me;class Ve{constructor($,se){this.fromRanges=se,this.to=$}}e.CallHierarchyOutgoingCall=Ve;var _e;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor($,se){this.range=$,this.command=se}get isResolved(){return!!this.command}};Je=ze([D],Je),e.CodeLens=Je;let X=a=class{constructor($,se=!1){m.set(this,void 0),it(this,m,new k.MarkdownString($,{supportThemeIcons:se}),"f")}static isMarkdownString($){return $ instanceof a?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return He(this,m,"f").value}set value($){He(this,m,"f").value=$}get isTrusted(){return He(this,m,"f").isTrusted}set isTrusted($){He(this,m,"f").isTrusted=$}get supportThemeIcons(){return He(this,m,"f").supportThemeIcons}set supportThemeIcons($){He(this,m,"f").supportThemeIcons=$}appendText($){return He(this,m,"f").appendText($),this}appendMarkdown($){return He(this,m,"f").appendMarkdown($),this}appendCodeblock($,se){return He(this,m,"f").appendCodeblock(se??"",$),this}};m=new WeakMap,X=a=ze([D],X),e.MarkdownString=X;let re=class{constructor($,se){this.label=$,this.documentation=se}};re=ze([D],re),e.ParameterInformation=re;let me=class{constructor($,se){this.label=$,this.documentation=se,this.parameters=[]}};me=ze([D],me),e.SignatureInformation=me;let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};xe=ze([D],xe),e.SignatureHelp=xe;var Be;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor($,se,Ie){this.text=$,this.position=se,this.kind=Ie}};ke=ze([D],ke),e.InlayHint=ke;var Ce;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Te;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Te=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(H){H[H.Deprecated=1]="Deprecated"})(le=e.CompletionItemTag||(e.CompletionItemTag={}));let ce=class{constructor($,se){this.label=$,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ce=ze([D],ce),e.CompletionItem=ce;let ve=class{constructor($=[],se=!1){this.items=$,this.isIncomplete=se}};ve=ze([D],ve),e.CompletionList=ve;let Ee=class{constructor($,se,Ie){this.text=$,this.range=se,this.command=Ie}};Ee=ze([D],Ee),e.InlineSuggestion=Ee;let j=class{constructor($){this.items=$}};j=ze([D],j),e.InlineSuggestions=j;var be;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(be=e.ViewColumn||(e.ViewColumn={}));var Se;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Se=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ue;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Xe;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Xe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function $(se){switch(se){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=$}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let lt=class{constructor($,se){if(se&&!_.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!V.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=se}};lt=ze([D],lt),e.DocumentLink=lt;let ht=class{constructor($,se,Ie,Ye){this.red=$,this.green=se,this.blue=Ie,this.alpha=Ye}};ht=ze([D],ht),e.Color=ht;let Et=class{constructor($,se){if(se&&!(se instanceof ht))throw(0,L.illegalArgument)("color");if(!V.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=se}};Et=ze([D],Et),e.ColorInformation=Et;let ot=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};ot=ze([D],ot),e.ColorPresentation=ot;var at;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var Dt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ye{constructor($,se,Ie){if(this.startIndex=$,this.length=se,this.tooltip=Ie,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=ye;class fe{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=fe;var ue;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(ue=e.TaskRevealKind||(e.TaskRevealKind={}));var G;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(G=e.TaskPanelKind||(e.TaskPanelKind={}));let Re=h=class{constructor($,se){if(typeof $!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};Re.Clean=new h("clean","Clean"),Re.Build=new h("build","Build"),Re.Rebuild=new h("rebuild","Rebuild"),Re.Test=new h("test","Test"),Re=h=ze([D],Re),e.TaskGroup=Re;function Ne(H){let $="";for(let se=0;se<H.length;se++)$+=H[se].replace(/,/g,",,")+",";return $}let tt=class{constructor($,se,Ie){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ie):this._options=se)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let se of this._args)$.push(se);return Ne($)}};tt=ze([D],tt),e.ProcessExecution=tt;let Ke=class{constructor($,se,Ie){if(this._args=[],Array.isArray(se)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=se,this._options=Ie}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=se}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)$.push(typeof se=="string"?se:se.value);return Ne($)}};Ke=ze([D],Ke),e.ShellExecution=Ke;var gt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=kt;let ft=u=class{constructor($,se,Ie,Ye,nt,st){this.__deprecated=!1,this._definition=this.definition=$;let ct;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ie,this.execution=Ye,ct=nt,this.__deprecated=!0):se===bt.Global||se===bt.Workspace?(this.target=se,this._name=this.name=Ie,this._source=this.source=Ye,this.execution=nt,ct=st):(this.target=se,this._name=this.name=Ie,this._source=this.source=Ye,this.execution=nt,ct=st),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof tt?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ke?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const se=this._definition.type;(u.EmptyType===se||u.ProcessType===se||u.ShellType===se||u.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=u=ze([D],ft),e.Task=ft;var ut;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(ut=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor($,se=_t.None){this.collapsibleState=se,_.URI.isUri($)?this.resourceUri=$:this.label=$}};mt=ze([D],mt),e.TreeItem=mt;var _t;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor($,se){this.id=$,this.color=se}};Tt=ze([D],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor($){this.id=$}};It=ze([D],It),e.ThemeColor=It;var bn;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor($,se){if(typeof $!="string"&&(!$||!_.URI.isUri($)&&!_.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=_.URI.file($),this.base=$):_.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=se}};Vt=ze([D],Vt),e.RelativePattern=Vt;let St=class{constructor($,se,Ie,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof se=="string"&&(this.condition=se),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,I.generateUuid)()),this._id}};St=ze([D],St),e.Breakpoint=St;let Xt=class extends St{constructor($,se,Ie,Ye,nt){super(se,Ie,Ye,nt);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};Xt=ze([D],Xt),e.SourceBreakpoint=Xt;let Yt=class extends St{constructor($,se,Ie,Ye,nt){super(se,Ie,Ye,nt);this.functionName=$}};Yt=ze([D],Yt),e.FunctionBreakpoint=Yt;let pt=class extends St{constructor($,se,Ie,Ye,nt,st,ct){super(Ye,nt,st,ct);if(!se)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=se,this.canPersist=Ie}};pt=ze([D],pt),e.DataBreakpoint=pt;let jt=class{constructor($,se,Ie){this.command=$,this.args=se||[],this.options=Ie}};jt=ze([D],jt),e.DebugAdapterExecutable=jt;let Wt=class{constructor($,se){this.port=$,this.host=se}};Wt=ze([D],Wt),e.DebugAdapterServer=Wt;let Jt=class{constructor($){this.path=$}};Jt=ze([D],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor($){this.implementation=$}};Zt=ze([D],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor($,se){this.range=$,this.expression=se}};Pt=ze([D],Pt),e.EvaluatableExpression=Pt;var dn;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor($,se){this.range=$,this.text=se}};en=ze([D],en),e.InlineValueText=en;let xt=class{constructor($,se,Ie=!0){this.range=$,this.variableName=se,this.caseSensitiveLookup=Ie}};xt=ze([D],xt),e.InlineValueVariableLookup=xt;let dt=class{constructor($,se){this.range=$,this.expression=se}};dt=ze([D],dt),e.InlineValueEvaluatableExpression=dt;let tn=class{constructor($,se){this.frameId=$,this.stoppedLocation=se}};tn=ze([D],tn),e.InlineValueContext=tn;var Mt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Ot=w=class extends Error{constructor($,se=n.FileSystemProviderErrorCode.Unknown,Ie){super(_.URI.isUri($)?$.toString(!0):$);this.code=Ie?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}static FileExists($){return new w($,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound($){return new w($,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory($){return new w($,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory($){return new w($,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions($){return new w($,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable($){return new w($,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Ot=w=ze([D],Ot),e.FileSystemError=Ot;let qt=class{constructor($,se,Ie){this.start=$,this.end=se,this.kind=Ie}};qt=ze([D],qt),e.FoldingRange=qt;var En;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor($,se=[]){this.tokenTypes=$,this.tokenModifiers=se}}e.SemanticTokensLegend=fn;function nn(H){return typeof H=="undefined"||(0,y.isStringArray)(H)}class rn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let se=0,Ie=$.tokenTypes.length;se<Ie;se++)this._tokenTypeStrToInt.set($.tokenTypes[se],se);for(let se=0,Ie=$.tokenModifiers.length;se<Ie;se++)this._tokenModifierStrToInt.set($.tokenModifiers[se],se)}}push($,se,Ie,Ye,nt){if(typeof $=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded($,se,Ie,Ye,nt);if(V.isRange($)&&typeof se=="string"&&nn(Ie))return this._push($,se,Ie);throw(0,L.illegalArgument)()}_push($,se,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,nt=$.start.character,st=$.end.character-$.start.character,ct=this._tokenTypeStrToInt.get(se);let yt=0;if(Ie)for(const At of Ie){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);yt|=1<<Rt>>>0}this._pushEncoded(Ye,nt,st,ct,yt)}_pushEncoded($,se,Ie,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Rt=0;for(let Ft=0;Ft<yt;Ft++){let Nt=this._data[5*Ft],cn=this._data[5*Ft+1];Nt===0?(Nt=At,cn+=Rt):Nt+=At,this._data[5*Ft]=Nt,this._data[5*Ft+1]=cn,At=Nt,Rt=cn}}let st=$,ct=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=$,this._prevChar=se}static _sortAndDeltaEncode($){let se=[];const Ie=$.length/5|0;for(let ct=0;ct<Ie;ct++)se[ct]=ct;se.sort((ct,yt)=>{const At=$[5*ct],Rt=$[5*yt];if(At===Rt){const Ft=$[5*ct+1],Nt=$[5*yt+1];return Ft-Nt}return At-Rt});const Ye=new Uint32Array($.length);let nt=0,st=0;for(let ct=0;ct<Ie;ct++){const yt=5*se[ct],At=$[yt+0],Rt=$[yt+1],Ft=$[yt+2],Nt=$[yt+3],cn=$[yt+4],xn=At-nt,Gn=xn===0?Rt-st:Rt,un=5*ct;Ye[un+0]=xn,Ye[un+1]=Gn,Ye[un+2]=Ft,Ye[un+3]=Nt,Ye[un+4]=cn,nt=At,st=Rt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),$):new Ht(rn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=rn;class Ht{constructor($,se){this.resultId=se,this.data=$}}e.SemanticTokens=Ht;class sn{constructor($,se,Ie){this.start=$,this.deleteCount=se,this.data=Ie}}e.SemanticTokensEdit=sn;class Sn{constructor($,se){this.resultId=se,this.edits=$}}e.SemanticTokensEdits=Sn;var yn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=ze([D],Gt),e.QuickInputButtons=Gt;var Dn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor($,se,Ie){this.badge=$,this.tooltip=se,this.color=Ie}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor($){this.kind=$}};on=ze([D],on),e.ColorTheme=on;var an;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor($,se){if($<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");$<=se?(this._start=$,this._end=se):(this._start=se,this._end=$)}static isNotebookRange($){return $ instanceof Bt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let se=this._start,Ie=this._end;return $.start!==void 0&&(se=$.start),$.end!==void 0&&(Ie=$.end),se===this._start&&Ie===this._end?this:new Bt(se,Ie)}}e.NotebookRange=Bt;class Lt{constructor($,se,Ie,Ye,nt,st,ct){this.kind=$,this.value=se,this.languageId=Ie,this.mime=Ye,this.outputs=nt??[],this.metadata=st,this.executionSummary=ct,Lt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(se=>Lt.isNotebookCellData(se))}static isNotebookCellData($){return!0}}e.NotebookCellData=Lt;class Kt{constructor($){this.cells=$}}e.NotebookData=Kt;class Oe{constructor($,se){this.data=$,this.mime=se;const Ie=(0,T.normalizeMimeType)(se,!0);if(!Ie)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}static isNotebookCellOutputItem($){return $ instanceof Oe?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const se={name:$.name,message:$.message,stack:$.stack};return Oe.json(se,"application/vnd.code.notebook.error")}static stdout($){return Oe.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Oe.text($,"application/vnd.code.notebook.stderr")}static bytes($,se="application/octet-stream"){return new Oe($,se)}static text($,se=T.Mimes.text){const Ie=He(Oe,l,"f",v).encode(String($));return new Oe(Ie,se)}static json($,se="application/json"){const Ie=JSON.stringify($,void 0,"	");return Oe.text(Ie,se)}}e.NotebookCellOutputItem=Oe,l=Oe,v={value:new TextEncoder};class $t{constructor($,se,Ie){this.items=$t.ensureUniqueMimeTypes($,!0),typeof se=="string"?(this.id=se,this.metadata=Ie):(this.id=(0,I.generateUuid)(),this.metadata=se??Ie)}static isNotebookCellOutput($){return $ instanceof $t?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,y.isArray)($.items)}static ensureUniqueMimeTypes($,se=!1){const Ie=new Set,Ye=new Set;for(let nt=0;nt<$.length;nt++){const st=$[nt],ct=(0,T.normalizeMimeType)(st.mime);if(!Ie.has(ct)){Ie.add(ct);continue}Ye.add(nt),se&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ye.size===0?$:$.filter((nt,st)=>!Ye.has(st))}}e.NotebookCellOutput=$t;var mn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var vt;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(vt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor($,se){this.text=$,this.alignment=se}}e.NotebookCellStatusBarItem=gn;var pn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor($,se=[]){this.uri=$,this.provides=(0,g.asArray)(se)}}e.NotebookRendererScript=Pn;let ln=class{constructor($,se){this.label=$,this.timestamp=se}};ln=ze([D],ln),e.TimelineItem=ln;var An;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor($,se){this.ranges=$,this.wordPattern=se}}e.LinkedEditingRanges=Rn;class Ln{constructor($,se){this._port=$,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var Mn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(Mn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var On;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor($,se,Ie){this.include=$,this.exclude=se,this.profile=Ie}};ie=ze([D],ie),e.TestRunRequest=ie;let de=E=class{constructor($){this.message=$}static diff($,se,Ie){const Ye=new E($);return Ye.expectedOutput=se,Ye.actualOutput=Ie,Ye}};de=E=ze([D],de),e.TestMessage=de;let Le=class{constructor($,se){this.id=$,this.label=se}};Le=ze([D],Le),e.TestTag=Le;let rt=class{constructor($,se){this.covered=$,this.total=se}};rt=ze([D],rt),e.CoveredCount=rt;let wt=s=class{constructor($,se,Ie,Ye){this.uri=$,this.statementCoverage=se,this.branchCoverage=Ie,this.functionCoverage=Ye}static fromDetails($,se){const Ie=new rt(0,0),Ye=new rt(0,0),nt=new rt(0,0);for(const ct of se)if("branches"in ct){Ie.total+=1,Ie.covered+=ct.executionCount>0?1:0;for(const yt of ct.branches)Ye.total+=1,Ye.covered+=yt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ct.executionCount>0?1:0;const st=new s($,Ie,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return st.detailedCoverage=se,st}};wt=s=ze([D],wt),e.FileCoverage=wt;let Ct=class{constructor($,se,Ie=[]){this.executionCount=$,this.location=se,this.branches=Ie}};Ct=ze([D],Ct),e.StatementCoverage=Ct;let Nn=class{constructor($,se){this.executionCount=$,this.location=se}};Nn=ze([D],Nn),e.BranchCoverage=Nn;let Un=class{constructor($,se){this.executionCount=$,this.location=se}};Un=ze([D],Un),e.FunctionCoverage=Un;var zn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor($,se,Ie,Ye,nt,st){this.kind=$,this.name=se,this.detail=Ie,this.uri=Ye,this.range=nt,this.selectionRange=st}}e.TypeHierarchyItem=qn}),define(ge[123],pe([0,1,54,10,8,149,110,7,20]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function n(l,v){v?I.set(l,v):I.delete(l)}e.setWordDefinitionFor=n;function A(l){return I.get(l)}e.getWordDefinitionFor=A;class d extends C.MirrorTextModel{constructor(v,S,b,P,c,f,p,t){super(S,b,P,c);this._proxy=v,this._languageId=f,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,_.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(S){return S?v._getTextInRange(S):v.getText()},get eol(){return v._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(S){return v._lineAt(S)},offsetAt(S){return v._offsetAt(S)},positionAt(S){return v._positionAt(S)},validateRange(S){return v._validateRange(S)},validatePosition(S){return v._validatePosition(S)},getWordRangeAtPosition(S,b){return v._getWordRangeAtPosition(S,b)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,g.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,g.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const S=this._validateRange(v);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const b=this._eol,P=S.start.line,c=S.end.line,f=[];f.push(this._lines[P].substring(S.start.character));for(let p=P+1;p<c;p++)f.push(this._lines[p]);return f.push(this._lines[c].substring(0,S.end.character)),f.join(b)}_lineAt(v){let S;if(v instanceof y.Position?S=v.line:typeof v=="number"&&(S=v),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new m(S,this._lines[S],S===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(v),b=this._lines[S.index].length;return new y.Position(S.index,Math.min(S.remainder,b))}_validateRange(v){if(!(v instanceof y.Range))throw new Error("Invalid argument");const S=this._validatePosition(v.start),b=this._validatePosition(v.end);return S===v.start&&b===v.end?v:new y.Range(S.line,S.character,b.line,b.character)}_validatePosition(v){if(!(v instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:S,character:b}=v,P=!1;if(S<0)S=0,b=0,P=!0;else if(S>=this._lines.length)S=this._lines.length-1,b=this._lines[S].length,P=!0;else{const c=this._lines[S].length;b<0?(b=0,P=!0):b>c&&(b=c,P=!0)}return P?new y.Position(S,b):v}_getWordRangeAtPosition(v,S){const b=this._validatePosition(v);if(!S)S=A(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const P=(0,T.getWordAtText)(b.character+1,(0,T.ensureValidWordDefinition)(S),this._lines[b.line],0);if(P)return new y.Range(b.line,P.startColumn-1,b.line,P.endColumn-1)}}e.ExtHostDocumentData=d;class m{constructor(v,S,b){this._line=v,this._text=S,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(ge[202],pe([0,1,7,3,112,6,79,22,2,32]),function(J,e,g,L,k,C,T,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(d,m,l,v){this._notebook=l,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(b=>{const P=this._cellUris.get(b.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(b=>S(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const d=[],m=[];for(const l of this._notebook.getCells())l.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),d.push(l.document.getText().length+1),m.push(l.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(d){if(!d){let P="";for(const c of this._cells)P+=c.document.getText()+`
`;return P=P.slice(0,-1),P}if(d.isEmpty)return"";const m=this.locationAt(d.start),l=this.locationAt(d.end),v=this._cellUris.get(m.uri),S=this._cellUris.get(l.uri);if(v===void 0||S===void 0)return"";if(v===S)return this._cells[v].document.getText(new g.Range(m.range.start,l.range.end));const b=[this._cells[v].document.getText(new g.Range(m.range.start,new g.Position(this._cells[v].document.lineCount,0)))];for(let P=v+1;P<S;P++)b.push(this._cells[P].document.getText());return b.push(this._cells[S].document.getText(new g.Range(new g.Position(0,0),l.range.end))),b.join(`
`)}offsetAt(d){const m=this._cellLines.getIndexOf(d.line),l=this._cellLengths.getPrefixSum(m.index-1),v=this._cells[m.index].document.offsetAt(d.with(m.remainder));return l+v}positionAt(d){if(typeof d=="number"){const l=this._cellLengths.getIndexOf(d),v=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(v)}const m=this._cellUris.get(d.uri);if(m!==void 0){const l=this._cellLines.getPrefixSum(m-1);return new g.Position(l+d.range.start.line,d.range.start.character)}return new g.Position(0,0)}locationAt(d){g.Range.isRange(d)||(d=new g.Range(d,d));const m=this._cellLines.getIndexOf(d.start.line);let l=m;d.isEmpty||(l=this._cellLines.getIndexOf(d.end.line));const v=new g.Position(m.remainder,d.start.character),S=new g.Position(l.remainder,d.end.character),b=new g.Range(v,S),P=this._cells[m.index];return new g.Location(P.document.uri,P.document.validateRange(b))}contains(d){return this._cellUris.has(d)}validateRange(d){const m=this.validatePosition(d.start),l=this.validatePosition(d.end);return d.with(m,l)}validatePosition(d){const m=this._cellLines.getIndexOf(d.line),l=new g.Position(m.remainder,d.character),v=this._cells[m.index].document.validatePosition(l),S=this._cellLines.getPrefixSum(m.index-1);return new g.Position(S+v.line,v.character)}}e.ExtHostNotebookConcatDocument=n}),define(ge[203],pe([0,1,7,13,3]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let _=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=ze([$e(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(ge[63],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(ge[204],pe([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function k(y,_){if(_.serializeBuffersForPostMessage){const I=new L,n=(m,l)=>{if(l instanceof ArrayBuffer){const v=I.add(l);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(l)){const v=C(l);if(v){const S=I.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:v,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},A=JSON.stringify(y,n),d=I.buffers.map(m=>{const l=new Uint8Array(m);return g.VSBuffer.wrap(l)});return{message:A,buffers:d}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=k;function C(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(y,_){const I=_.map(d=>{const m=new ArrayBuffer(d.byteLength);return new Uint8Array(m).set(d.buffer),m}),n=_.length?(d,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const l=m,{index:v}=l,S=I[v];if(l.view)switch(l.view.type){case 1:return new Int8Array(S,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return m}:void 0;return{message:JSON.parse(y,n),arrayBuffers:I}}e.deserializeWebviewMessage=T}),define(ge[205],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function k(T){const y={items:new Map};return T.types.forEach((_,I)=>{y.items.set(_,{asString:async()=>T.items[I].asString})}),y}L.toITreeDataTransfer=k;async function C(T){const y={types:[],items:[]},_=Array.from(T.items.entries());for(const I of _)y.types.push(I[0]),y.items.push({asString:await I[1].asString()});return y}L.toTreeDataTransferDTO=C})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ge[88],pe([0,1,10,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,_){return y.scheme===g.Schemas.http||y.scheme===g.Schemas.https?y:(_&&_.authority&&_.isRemote&&y.scheme===g.Schemas.file&&(y=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:_.authority,path:y.path})),L.URI.from({scheme:g.Schemas.https,authority:`${y.scheme}+${C(y.authority)}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k;function C(y){return y.replace(/./g,_=>{const I=_.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?_:"-"+I.toString(16).padStart(4,"0")})}function T(y){return y.replace(/-([0-9a-f]{4})/g,(_,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=T}),define(ge[206],pe([0,1,3,6,88]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(y,_,I){this._proxy=y,this._editors=_,this._initData=I,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const A of this._insets.values())n.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,_,I,n,A){let d;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){d=c;break}if(!d)throw new Error("not a visible editor");const m=this,l=this._handlePool++,v=new g.Emitter,S=new g.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,k.asWebviewUri)(c,m._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(c){this._options=c,m._proxy.$setOptions(l,c)}get options(){return this._options}set html(c){this._html=c,m._proxy.$setHtml(l,c)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(c){return m._proxy.$postMessage(l,c)}},P=new class{constructor(){this.editor=y,this.line=_,this.height=I,this.webview=b,this.onDidDispose=S.event}dispose(){m._insets.has(l)&&(m._insets.delete(l),m._proxy.$disposeEditorInset(l),S.fire(),S.dispose(),v.dispose())}};return this._proxy.$createEditorInset(l,d.id,d.value.document.uri,_+1,I,n||{},A.identifier,A.extensionLocation),this._insets.set(l,{editor:y,inset:P,onDidReceiveMessage:v}),P}$onDidDispose(y){const _=this._insets.get(y);_&&_.inset.dispose()}$onDidReceiveMessage(y,_){const I=this._insets.get(y);I&&I.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=C}),define(ge[207],pe([0,1,171,14,2,6,4,61,34,20,10]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new y.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new y.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new y.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new y.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new y.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new y.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new y.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new y.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new y.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new y.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new y.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new y.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new y.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new y.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new y.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new y.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new y.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new y.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new y.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function A(s){return typeof s?.getViewState=="function"}e.isTextEditorPane=A;function d(s){if(c(s))return!1;const D=s;return k.URI.isUri(D?.resource)}e.isResourceEditorInput=d;function m(s){if(c(s))return!1;const D=s;return D?.original!==void 0&&D.modified!==void 0}e.isResourceDiffEditorInput=m;function l(s){if(c(s))return!1;const D=s;return D?D.resource===void 0||D.resource.scheme===n.Schemas.untitled||D.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var v;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var S;(function(s){s[s.EXPLICIT=1]="EXPLICIT",s[s.AUTO=2]="AUTO",s[s.FOCUS_CHANGE=3]="FOCUS_CHANGE",s[s.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var b;(function(s){s[s.None=0]="None",s[s.Readonly=2]="Readonly",s[s.Untitled=4]="Untitled",s[s.Singleton=8]="Singleton",s[s.RequiresTrust=16]="RequiresTrust"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends C.Disposable{}e.AbstractEditorInput=P;function c(s){return s instanceof P}e.isEditorInput=c;function f(s){const D=s;return k.URI.isUri(D?.preferredResource)}function p(s){const D=s;return c(D?.primary)&&c(D?.secondary)}e.isSideBySideEditorInput=p;function t(s){return c(s?.editor)}e.isEditorInputWithOptions=t;function r(s){const D=s;return t(s)&&D?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function o(s){const D=s;return typeof D?.groupId=="number"&&c(D.editor)}e.isEditorIdentifier=o;var i;(function(s){s[s.PRIMARY=1]="PRIMARY",s[s.SECONDARY=2]="SECONDARY",s[s.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(D,R){if(!D)return;const U=p(D)?D.primary:m(D)?D.modified:void 0,V=p(D)?D.secondary:m(D)?D.original:void 0;if(R?.supportSideBySide&&U&&V){if(R?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:R.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:R.filterByScheme})};D=R.supportSideBySide===i.PRIMARY?U:V}if(m(D))return;const ee=f(D)?D.preferredResource:D.resource;return!ee||!R||!R.filterByScheme?ee:this.filterUri(ee,R.filterByScheme)}getCanonicalUri(D,R){if(!D)return;const U=p(D)?D.primary:m(D)?D.modified:void 0,V=p(D)?D.secondary:m(D)?D.original:void 0;if(R?.supportSideBySide&&U&&V){if(R?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:R.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:R.filterByScheme})};D=R.supportSideBySide===i.PRIMARY?U:V}if(m(D))return;const ee=D.resource;return!ee||!R||!R.filterByScheme?ee:this.filterUri(ee,R.filterByScheme)}filterUri(D,R){if(Array.isArray(R)){if(R.some(U=>D.scheme===U))return D}else if(R===D.scheme)return D}}e.EditorResourceAccessor=new a;var h;(function(s){s[s.LEFT=0]="LEFT",s[s.RIGHT=1]="RIGHT"})(h=e.CloseDirection||(e.CloseDirection={}));class u{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(D){const R=this.instantiationService=D.get(T.IInstantiationService);for(const[U,V]of this.editorSerializerConstructors)this.createEditorSerializer(U,V,R);this.editorSerializerConstructors.clear()}createEditorSerializer(D,R,U){const V=U.createInstance(R);this.editorSerializerInstances.set(D,V)}registerFileEditorFactory(D){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=D}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(D,R){if(this.editorSerializerConstructors.has(D)||this.editorSerializerInstances.has(D))throw new Error(`A editor serializer with type ID '${D}' was already registered.`);return this.instantiationService?this.createEditorSerializer(D,R,this.instantiationService):this.editorSerializerConstructors.set(D,R),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(D),this.editorSerializerInstances.delete(D)})}getEditorSerializer(D){return this.editorSerializerInstances.get(typeof D=="string"?D:D.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new u);async function w(s,D){if(!s||!s.length)return[];const R=await Promise.all(s.map(async U=>{const V=k.URI.revive(U.fileUri);if(!V||(await D.activateProvider(V.scheme),!D.canHandleResource(V)))return;const ee=typeof U.exists=="boolean"?U.exists:await D.exists(V);if(!ee&&U.openOnlyIfExists)return;const Q=ee&&!(0,L.isUndefined)(U.selection)?{selection:U.selection,pinned:!0,override:U.editorOverrideId}:{pinned:!0,override:U.editorOverrideId};let O;return ee?O={resource:V,options:Q,forceFile:!0}:O={resource:V,options:Q,forceUntitled:!0},O}));return(0,I.coalesce)(R)}e.pathsToEditors=w;var E;(function(s){s[s.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",s[s.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(ge[208],pe([0,1,3,61,172,4,6,22,34,20,55,25,47,197]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",d.Codicon.window,(0,k.localize)(0,null));var l;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var v;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function b(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=b;class P extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(h,u,w){const E=this.get(h.id);if(E)return E;const s=h;return s.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,y.getOrSet)(this.viewContainers,u,[]).push(s),w?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:u}),s}deregisterViewContainer(h){for(const u of this.viewContainers.keys()){const w=this.viewContainers.get(u),E=w?.indexOf(h);if(E!==-1){w?.splice(E,1),w.length===0&&this.viewContainers.delete(u),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:u});return}}}get(h){return this.all.filter(u=>u.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(u=>this.getViewContainers(u).filter(w=>w?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(u=>this.getViewContainerLocation(u)===h)}}_.Registry.add(l.ViewContainersRegistry,new P);var c;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function f(a,h){const u=a.group??c.More,w=h.group??c.More;return u!==w?u.localeCompare(w):(a.order??5)-(h.order??5)}class p extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(h,u){this.registerViews2([{views:h,viewContainer:u}])}registerViews2(h){h.forEach(({views:u,viewContainer:w})=>this.addViews(u,w)),this._onViewsRegistered.fire(h)}deregisterViews(h,u){const w=this.removeViews(h,u);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:u})}moveViews(h,u){for(const w of this._views.keys())if(w!==u){const E=this.removeViews(h,w);E.length&&(this.addViews(E,u),this._onDidChangeContainer.fire({views:E,from:w,to:u}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const u of this._viewContainers){const w=(this._views.get(u)||[]).filter(E=>E.id===h)[0];if(w)return w}return null}getViewContainer(h){for(const u of this._viewContainers)if((this._views.get(u)||[]).filter(E=>E.id===h)[0])return u;return null}registerViewWelcomeContent(h,u){return this._viewWelcomeContents.add(h,u),this._onDidChangeViewWelcomeContent.fire(h),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,u),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,u){const w=new Map;for(const[E,s]of u)this._viewWelcomeContents.add(h,s),w.set(E,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,s),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),w}getViewWelcomeContent(h){const u=[];return this._viewWelcomeContents.forEach(h,w=>u.push(w)),u.sort(f)}addViews(h,u){let w=this._views.get(u);w||(w=[],this._views.set(u,w),this._viewContainers.push(u));for(const E of h){if(this.getView(E.id)!==null)throw new Error((0,k.localize)(1,null,E.id));w.push(E)}}removeViews(h,u){const w=this._views.get(u);if(!w)return[];const E=[],s=[];for(const D of w)h.includes(D)?E.push(D):s.push(D);return E.length&&(s.length?this._views.set(u,s):(this._views.delete(u),this._viewContainers.splice(this._viewContainers.indexOf(u),1))),E}}_.Registry.add(l.ViewsRegistry,new p),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var r;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(h,u){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,h),this._hasResolve=!!u,this.resolve=async w=>{if(u&&!this.resolved){const E=await u(w);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(ge[124],pe([0,1,3,17,173]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,_,I,n){const A={command:y};if(_&&Object.keys(_).length>0&&(A.arguments=_),this.internalSend("request",A),typeof n=="number"){const d=setTimeout(()=>{clearTimeout(d);const m=this.pendingRequests.get(A.seq);if(m){this.pendingRequests.delete(A.seq);const l={type:"response",seq:0,request_seq:A.seq,success:!1,command:y,message:(0,k.localize)(0,null,n,y)};m(l)}},n)}return I&&this.pendingRequests.set(A.seq,I),A.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,_){return y.type!=="event"||_.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,L.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const _=y,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}internalSend(y,_){_.type=y,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((_,I)=>y.set(I,_)),await(0,L.timeout)(500),y.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(ge[209],pe([0,1,8,2,9,25,10]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function _(r,o,i){return r.replace(y,function(a,h){return o&&h.length>0&&h[0]!=="_"?a:i&&i.hasOwnProperty(h)?i[h]:a})}e.formatPII=_;function I(r){const o={};for(const i of Object.keys(r))i.startsWith("!")||(o[i]=r[i]);return o}e.filterExceptionsFromTelemetry=I;function n(r){return r.configuration.request==="attach"&&!A(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function A(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(o,"extensionhost")||(0,g.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?A(r.parentSession):void 0}e.getExtensionHostDebugSession=A;function d(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=d;function m(r,o,i){let a,h=0,u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=u.exec(r);){let E=w.index+1,s=E+w[0].length;if(E<=o&&s>=i){a=w[0],h=E;break}}if(a){let E=/\w+/g,s=null;for(;(s=E.exec(a))&&!(s.index+1+h+s[0].length>=i););s&&(a=a.substring(0,E.lastIndex))}return a?{start:h,end:h+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(l))}e.isUri=v;function S(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return L.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function b(r){if(typeof r.path=="object"){const o=L.URI.revive(r.path);if(o)return o.scheme===T.Schemas.file?o.fsPath:o.toString()}return r.path}function P(r,o){const i=o?S:b,a=(0,C.deepClone)(r);return f(a,(h,u)=>{h&&u&&(u.path=i(u))}),a}e.convertToDAPaths=P;function c(r,o){const i=o?S:b,a=(0,C.deepClone)(r);return f(a,(h,u)=>{!h&&u&&(u.path=i(u))}),a}e.convertToVSCPaths=c;function f(r,o){switch(r.type){case"event":const i=r;switch(i.event){case"output":o(!1,i.body.source);break;case"loadedSource":o(!1,i.body.source);break;case"breakpoint":o(!1,i.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":o(!0,a.arguments.source);break;case"breakpointLocations":o(!0,a.arguments.source);break;case"source":o(!0,a.arguments.source);break;case"gotoTargets":o(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(u=>o(!1,u));break;default:break}break;case"response":const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(u=>o(!1,u.source));break;case"loadedSources":h.body.sources.forEach(u=>o(!1,u));break;case"scopes":h.body.scopes.forEach(u=>o(!1,u.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(u=>o(!1,u.source));break;case"setBreakpoints":h.body.breakpoints.forEach(u=>o(!1,u.source));break;default:break}break}}function p(r){return r.filter(o=>!o.presentation?.hidden).sort((o,i)=>o.presentation?i.presentation?o.presentation.group?i.presentation.group?o.presentation.group!==i.presentation.group?o.presentation.group.localeCompare(i.presentation.group):t(o.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(o.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}}),define(ge[210],pe([0,1,28,39,174,125,9,8,25,11,184,124]),function(J,e,g,L,k,C,T,y,_,I,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class d extends A.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(P,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,P.on("data",f=>this.handleData(f))}sendMessage(P){if(this.outputStream){const c=JSON.stringify(P);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${d.TWO_CRLF}${c}`,"utf8")}}handleData(P){for(this.rawData=Buffer.concat([this.rawData,P]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+c))}continue}}else{const c=this.rawData.indexOf(d.TWO_CRLF);if(c!==-1){const p=this.rawData.toString("utf8",0,c).split(d.HEADER_LINESEPARATOR);for(const t of p){const r=t.split(d.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(c+d.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=d,d.TWO_CRLF=`\r
\r
`,d.HEADER_LINESEPARATOR=/\r?\n/,d.HEADER_FIELDSEPARATOR=/: */;class m extends d{startSession(){return new Promise((P,c)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),P(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",p=>{f?this._onError.fire(p):c(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class l extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",P)}}e.SocketDebugAdapter=l;class v extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return C.createConnection(this.adapterServer.path,P)}}e.NamedPipeDebugAdapter=v;class S extends d{constructor(P,c,f){super();this.adapterExecutable=P,this.debugType=c,this.outputService=f}async startSession(){const P=this.adapterExecutable.command,c=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(P)if(T.isAbsolute(P)){if(!await g.Promises.exists(P))throw new Error(k.localize(0,null,P))}else P.indexOf("/")<0&&P.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let p=process.env;if(f.env&&Object.keys(f.env).length>0&&(p=_.mixin(_.deepClone(process.env),f.env)),P==="node")if(Array.isArray(c)&&c.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:p,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(o.cwd=f.cwd);const i=L.fork(c[0],c.slice(1),o);if(!i.pid)throw new Error(k.localize(2,null,c[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const r={env:p};f.cwd&&(r.cwd=f.cwd),this.serverProcess=L.spawn(P,c,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,o)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(r(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((P,c)=>{const f=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,r){if(p)return c(p)});f.on("exit",P),f.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(P,c){if(!P)return;const f=Object.create(null);P.runtime&&(P.runtime.indexOf("./")===0?f.runtime=T.join(c,P.runtime):f.runtime=P.runtime),P.runtimeArgs&&(f.runtimeArgs=P.runtimeArgs),P.program&&(T.isAbsolute(P.program)?f.program=P.program:f.program=T.join(c,P.program)),P.args&&(f.args=P.args);const p=P;return p.win&&(f.win=S.extract(p.win,c)),p.winx86&&(f.winx86=S.extract(p.winx86,c)),p.windows&&(f.windows=S.extract(p.windows,c)),p.osx&&(f.osx=S.extract(p.osx,c)),p.linux&&(f.linux=S.extract(p.linux,c)),f}static platformAdapterExecutable(P,c){let f=Object.create(null);c=c.toLowerCase();for(const a of P)if(a.contributes){const h=a.contributes.debuggers;h&&h.length>0&&h.filter(u=>typeof u.type=="string"&&y.equalsIgnoreCase(u.type,c)).forEach(u=>{const w=S.extract(u,a.extensionLocation.fsPath);f=_.mixin(f,w,a.isBuiltin)})}let p;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=f.winx86||f.win||f.windows:I.isWindows?p=f.win||f.windows:I.isMacintosh?p=f.osx:I.isLinux&&(p=f.linux),p=p||f;let t=p.program||f.program;const r=p.args||f.args;let o=p.runtime||f.runtime;const i=p.runtimeArgs||f.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=S}),define(ge[211],pe([0,1,39,11,29,187]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(d,m){return new Promise((l,v)=>{let S="";const b=g.spawn(d,m);b.pid&&b.stdout.on("data",P=>{S+=P.toString()}),b.on("error",P=>{v(P)}),b.on("close",P=>{l(S)})})}let y;function _(d,m){if(!y)if(L.isWindows)y=new C.WindowsExternalTerminalService;else if(L.isMacintosh)y=new C.MacExternalTerminalService;else if(L.isLinux)y=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=m.getConfiguration("terminal");return y.runInTerminal(d.title,d.cwd,d.args,d.env||{},l.external||{})}e.runInExternalTerminal=_;function I(d){return d?L.isWindows?new Promise(async m=>{(await new Promise((v,S)=>{J(["windows-process-tree"],v,S)})).getProcessTree(d,v=>{m(v.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(d)]).then(m=>{const l=m.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=I;var n;(function(d){d[d.cmd=0]="cmd",d[d.powershell=1]="powershell",d[d.bash=2]="bash"})(n||(n={}));function A(d,m,l,v){d=d.trim().toLowerCase();let S;d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0?S=1:d.indexOf("cmd.exe")>=0?S=0:d.indexOf("bash")>=0?S=2:L.isWindows?S=0:S=2;let b,P=" ";switch(S){case 1:if(b=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),l){const f=(0,k.getDriveLetter)(l);f&&(P+=`${f}:; `),P+=`cd ${b(l)}; `}if(v)for(let f in v){const p=v[f];p===null?P+=`Remove-Item env:${f}; `:P+=`\${env:${f}}='${p}'; `}if(m.length>0){const f=b(m.shift());P+=f[0]==="'"?`& ${f} `:`${f} `;for(let p of m)P+=`${b(p)} `}break;case 0:if(b=f=>(f=f.replace(/\"/g,'""'),f.indexOf(" ")>=0||f.indexOf('"')>=0||f.length===0?`"${f}"`:f),l){const f=(0,k.getDriveLetter)(l);f&&(P+=`${f}: && `),P+=`cd ${b(l)} && `}if(v){P+='cmd /C "';for(let f in v){let p=v[f];p===null?P+=`set "${f}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),P+=`set "${f}=${p}" && `)}}for(let f of m)P+=`${b(f)} `;v&&(P+='"');break;case 2:b=f=>(f=f.replace(/(["'\\\$])/g,"\\$1"),f.indexOf(" ")>=0||f.indexOf(";")>=0||f.length===0?`"${f}"`:f);const c=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(l&&(P+=`cd ${b(l)} ; `),v){P+="/usr/bin/env";for(let f in v){const p=v[f];p===null?P+=` -u ${c(f)}`:P+=` ${c(`${f}=${p}`)}`}P+=" "}for(let f of m)P+=`${b(f)} `;break}return P}e.prepareCommand=A}),define(ge[89],pe([0,1,30,102,10,9,11,61]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(s){s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var A;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(A=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeLanguage=5]="ChangeLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var S;(function(s){s.scheme=k.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function R(O,x){return O.with({scheme:s.scheme,fragment:`ch${x.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}s.generate=R;function U(O){if(O.scheme!==s.scheme)return;const x=D.exec(O.fragment);return x?{handle:Number(x[1]),notebook:O.with({scheme:O.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}s.parse=U;function V(O){if(O.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const x=D.exec(O.fragment);return x?{handle:Number(x[1]),notebook:O.with({scheme:O.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}s.parseCellMetadataUri=V;function ee(O,x,F){return O.with({scheme:F,fragment:`ch${x.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}s.generateCellUri=ee;function Q(O,x){if(O.scheme!==x)return;const F=D.exec(O.fragment);return F?{handle:Number(F[1]),notebook:O.with({scheme:O.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}:void 0}s.parseCellUri=Q})(S=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(s){return b.get(s)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function c(s){return b.get(s)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function f(s){return b.get(s)?.mergeable??!1}e.mimeTypeIsMergeable=f;function p(s,D){return T.isWindows&&(s=s.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),g.match(s,D)}function t(s,D,R){let U=0;for(let V=0;V<D.length;V++){if(p(D[V],s))return U;U++}for(let V=0;V<R.length;V++){if(p(R[V],s))return U;U++}return U}function r(s,D,R){return s.sort((U,V)=>t(U,D,R)-t(V,D,R))}e.sortMimeTypes=r;function o(s,D,R,U=(V,ee)=>V===ee){const V=[];function ee(x,F,z){if(F===0&&z.length===0)return;const M=V[V.length-1];M&&M.start+M.deleteCount===x?(M.deleteCount+=F,M.toInsert.push(...z)):V.push({start:x,deleteCount:F,toInsert:z})}let Q=0,O=0;for(;;){if(Q===s.length){ee(Q,0,D.slice(O));break}if(O===D.length){ee(Q,s.length-Q,[]);break}const x=s[Q],F=D[O];if(U(x,F)){Q+=1,O+=1;continue}R(F)?(ee(Q,1,[]),Q+=1):(ee(Q,0,[F]),O+=1)}return V}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(s){s.default="default",s.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(s){const D=s;return!!((typeof D.include=="string"||g.isRelativePattern(D.include))&&(typeof D.exclude=="string"||g.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=a;function h(s,D,R){if(Array.isArray(s.viewType)&&s.viewType.indexOf(D)>=0||s.viewType===D)return!0;if(s.filenamePattern){let U=a(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,V=a(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(g.match(U,(0,C.basename)(R.fsPath).toLowerCase()))return!(V&&g.match(V,(0,C.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class u{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)D[R]=this.textModel.cells[R].getHashValue();return D}}e.CellSequence=u,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(D){return`${E._prefix}${D}`}static parse(D){if(D.startsWith(E._prefix))return D.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(ge[212],pe([0,1,176,4,61]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[213],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=g;function L(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=L}),define(ge[126],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(k=e.TestItemExpandState||(e.TestItemExpandState={}));const C=(n,A)=>{A.expand!==void 0&&(n.expand=A.expand),A.item!==void 0&&(n.item=n.item?Object.assign(n.item,A.item):A.item)};e.applyTestItemUpdate=C;var T;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var y;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class _{add(A){}update(A){}remove(A,d){}complete(){}}e.IncrementalChangeCollector=_;class I{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(A){const d=this.createChangeCollector();for(const m of A)switch(m[0]){case 0:{const l=m[1];if(l.parent){if(this.items.has(l.parent)){const v=this.items.get(l.parent);v.children.add(l.item.extId);const S=this.createItem(l,v);this.items.set(l.item.extId,S),d.add(S)}}else{const v=this.createItem(l);this.roots.add(v),this.items.set(l.item.extId,v),d.add(v)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=m[1],v=this.items.get(l.extId);if(!v)break;l.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,l),d.update(v);break}case 2:{const l=this.items.get(m[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const v=[[m[1]]];for(;v.length;)for(const S of v.pop()){const b=this.items.get(S);b&&(v.push(b.children),this.items.delete(S),d.remove(b,b!==l),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m[1]);break;case 3:this.updatePendingRoots(m[1]);break}d.complete()}retireTest(A){}updatePendingRoots(A){this.pendingRootCount+=A}createChangeCollector(){return new _}}e.AbstractIncrementalTestCollection=I}),define(ge[90],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(C){C.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class k{constructor(T,y=T.length){if(this.path=T,this.viewEnd=y,T.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,y,_=T.parent){if(T.id===y)return new k([y]);let I=[T.id];for(let n=_;n&&n.id!==y;n=n.parent)I.push(n.id);return I.push(y),new k(I.reverse())}static isRoot(T){return!T.includes("\0")}static fromString(T){return new k(T.split("\0"))}static join(T,y){return new k([...T.path,y])}static joinToString(T,y){return T.toString()+"\0"+y}static compare(T,y){return T===y?0:y.startsWith(T+"\0")?2:T.startsWith(y+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new k(this.path,T)}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let y=0;y<T.viewEnd&&y<this.viewEnd;y++)if(T.path[y]!==this.path[y])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(ge[214],pe([0,1,9,38,14,25,11,77,177]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(A,d,m){this._contributedVariables=new Map,this._context=A,this._labelService=d,m&&(this._envVariablesPromise=m.then(l=>this.prepareEnv(l)))}prepareEnv(A){if(T.isWindows){const d=Object.create(null);return Object.keys(A).forEach(m=>{d[m.toLowerCase()]=A[m]}),d}return A}resolveWithEnvironment(A,d,m){return this.recursiveResolve(this.prepareEnv(A),d?d.uri:void 0,m)}async resolveAsync(A,d){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,d)}async resolveAnyBase(A,d,m,l){const v=C.deepClone(d);return T.isWindows&&v.windows?Object.keys(v.windows).forEach(S=>v[S]=v.windows[S]):T.isMacintosh&&v.osx?Object.keys(v.osx).forEach(S=>v[S]=v.osx[S]):T.isLinux&&v.linux&&Object.keys(v.linux).forEach(S=>v[S]=v.linux[S]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,v,m,l)}async resolveAnyAsync(A,d,m){return this.resolveAnyBase(A,d,m)}async resolveAnyMap(A,d,m){const l=new Map;return{newConfig:await this.resolveAnyBase(A,d,m,l),resolvedVariables:l}}resolveWithInteractionReplace(A,d,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,d,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,d){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,d)}recursiveResolve(A,d,m,l,v){if(k.isString(m))return this.resolveString(A,d,m,l,v);if(k.isArray(m))return m.map(S=>this.recursiveResolve(A,d,S,l,v));if(k.isObject(m)){let S=Object.create(null);return Object.keys(m).forEach(b=>{const P=this.resolveString(A,d,b,l,v);S[P]=this.recursiveResolve(A,d,m[b],l,v)}),S}return m}resolveString(A,d,m,l,v){return m.replace(I.VARIABLE_REGEXP,(b,P)=>{if(P.includes(I.VARIABLE_LHS))return b;let c=this.evaluateSingleVariable(A,b,P,d,l);return v&&v.set(P,c),c!==b&&k.isString(c)&&c.match(I.VARIABLE_REGEXP)&&(c=this.resolveString(A,d,c,l,v)),c})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,d,m,l,v){let S;const b=m.split(":");b.length>1&&(m=b[0],S=b[1]);const P=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,_.localize)(0,null,d))},c=()=>{const p=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,_.localize)(1,null,d,g.basename(p)))},f=()=>{if(S){const p=this._context.getFolderUri(S);if(p)return p;throw new Error((0,_.localize)(2,null,d,S))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,d)):new Error((0,_.localize)(4,null,d))};switch(m){case"env":if(S){if(A){const p=A[T.isWindows?S.toLowerCase():S];if(k.isString(p))return p}return""}throw new Error((0,_.localize)(5,null,d));case"config":if(S){const p=this._context.getConfigurationValue(l,S);if(k.isUndefinedOrNull(p))throw new Error((0,_.localize)(6,null,d,S));if(k.isObject(p))throw new Error((0,_.localize)(7,null,d,S));return p}throw new Error((0,_.localize)(8,null,d));case"command":return this.resolveFromMap(d,S,v,"command");case"input":return this.resolveFromMap(d,S,v,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return l||S?(0,y.normalizeDriveLetter)(this.fsPath(f())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(f()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,_.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,_.localize)(10,null,d));case"file":return P();case"fileWorkspaceFolder":return c();case"relativeFile":return l||S?g.relative(this.fsPath(f()),P()):P();case"relativeFileDirname":const r=g.dirname(P());if(l||S){const h=g.relative(this.fsPath(f()),r);return h.length===0?".":h}return r;case"fileDirname":return g.dirname(P());case"fileExtname":return g.extname(P());case"fileBasename":return g.basename(P());case"fileBasenameNoExtension":const o=g.basename(P());return o.slice(0,o.length-g.extname(o).length);case"fileDirnameBasename":return g.basename(g.dirname(P()));case"execPath":const i=this._context.getExecPath();return i||d;case"execInstallFolder":const a=this._context.getAppRoot();return a||d;case"pathSeparator":return g.sep;default:try{const h=S?`${m}:${S}`:m;return this.resolveFromMap(d,h,v,void 0)}catch(h){return d}}}}resolveFromMap(A,d,m,l){if(d&&m){const v=l===void 0?m[d]:m[l+":"+d];if(typeof v=="string")return v;throw new Error((0,_.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[127],pe([0,1,4,207]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var C;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function I(v){const S=v;return(0,L.isEditorInput)(S?.editor)&&(0,L.isEditorInput)(S?.replacement)}e.isEditorReplacement=I;var n;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=8]="EDITOR_PIN",v[v.EDITOR_STICKY=9]="EDITOR_STICKY",v[v.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(A=e.GroupChangeKind||(e.GroupChangeKind={}));var d;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(d=e.OpenEditorContext||(e.OpenEditorContext={}));function m(v){const S=v;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=m;function l(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(ge[215],pe([0,1,4,127]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(C){const T=C;return typeof C=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=k}),define(ge[15],pe([0,1,20,99,290,59,25,14,2,41,81,178,117,87,89,90,215,7]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(ye){function fe(G){const{selectionStartLineNumber:Re,selectionStartColumn:Ne,positionLineNumber:tt,positionColumn:Ke}=G,gt=new b.Position(Re-1,Ne-1),bt=new b.Position(tt-1,Ke-1);return new b.Selection(gt,bt)}ye.to=fe;function ue(G){const{anchor:Re,active:Ne}=G;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}ye.from=ue})(P=e.Selection||(e.Selection={}));var c;(function(ye){function fe(G){if(!G)return;const{start:Re,end:Ne}=G;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}ye.from=fe;function ue(G){if(!G)return;const{startLineNumber:Re,startColumn:Ne,endLineNumber:tt,endColumn:Ke}=G;return new b.Range(Re-1,Ne-1,tt-1,Ke-1)}ye.to=ue})(c=e.Range||(e.Range={}));var f;(function(ye){function fe(ue){switch(ue){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ye.to=fe})(f=e.TokenType||(e.TokenType={}));var p;(function(ye){function fe(G){return new b.Position(G.lineNumber-1,G.column-1)}ye.to=fe;function ue(G){return{lineNumber:G.line+1,column:G.character+1}}ye.from=ue})(p=e.Position||(e.Position={}));var t;(function(ye){function fe(G){switch(G){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ye.from=fe;function ue(G){switch(G){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ye.to=ue})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ye){function fe(G){let Re;return G.code&&((0,y.isString)(G.code)||(0,y.isNumber)(G.code)?Re=String(G.code):Re={value:String(G.code.value),target:G.code.target}),{...c.from(G.range),message:G.message,source:G.source,code:Re,severity:i.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(o.from),tags:Array.isArray(G.tags)?(0,g.coalesce)(G.tags.map(t.from)):void 0}}ye.from=fe;function ue(G){const Re=new b.Diagnostic(c.to(G),G.message,i.to(G.severity));return Re.source=G.source,Re.code=(0,y.isString)(G.code)?G.code:G.code?.value,Re.relatedInformation=G.relatedInformation&&G.relatedInformation.map(o.to),Re.tags=G.tags&&(0,g.coalesce)(G.tags.map(t.to)),Re}ye.to=ue})(r=e.Diagnostic||(e.Diagnostic={}));var o;(function(ye){function fe(G){return{...c.from(G.location.range),message:G.message,resource:G.location.uri}}ye.from=fe;function ue(G){return new b.DiagnosticRelatedInformation(new b.Location(G.resource,c.to(G)),G.message)}ye.to=ue})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ye){function fe(G){switch(G){case b.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ye.from=fe;function ue(G){switch(G){case d.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ye.to=ue})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(ye){function fe(G){return typeof G=="number"&&G>=b.ViewColumn.One?G-1:G===b.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}ye.from=fe;function ue(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=ue})(a=e.ViewColumn||(e.ViewColumn={}));function h(ye){return typeof ye.range!="undefined"}function u(ye){return ye.length===0?!0:!!h(ye[0])}e.isDecorationOptionsArr=u;var w;(function(ye){function fe(Ke){return Ke.map(ye.from)}ye.fromMany=fe;function ue(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function G(Ke){let gt;if(ue(Ke)){const{language:ut,value:mt}=Ke;gt={value:"```"+ut+`
`+mt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ke)?gt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?gt={value:Ke}:gt={value:""};const bt=Object.create(null);gt.uris=bt;const kt=ut=>{try{let mt=_.URI.parse(ut,!0);mt=mt.with({query:Re(mt.query,bt)}),bt[ut]=mt}catch(mt){}return""},ft=new k.Renderer;return ft.link=kt,ft.image=ut=>kt(L.parseHrefAndDimensions(ut).href),k(gt.value,{renderer:ft}),gt}ye.from=G;function Re(Ke,gt){if(!Ke)return Ke;let bt;try{bt=(0,C.parse)(Ke)}catch(ft){}if(!bt)return Ke;let kt=!1;return bt=(0,T.cloneAndChange)(bt,ft=>{if(_.URI.isUri(ft)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[ut]=ft,kt=!0,ut}else return}),kt?JSON.stringify(bt):Ke}function Ne(Ke){const gt=new b.MarkdownString(Ke.value,Ke.supportThemeIcons);return gt.isTrusted=Ke.isTrusted,gt}ye.to=Ne;function tt(Ke){if(!!Ke)return typeof Ke=="string"?Ke:ye.from(Ke)}ye.fromStrict=tt})(w=e.MarkdownString||(e.MarkdownString={}));function E(ye){return u(ye)?ye.map(fe=>({range:c.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?w.fromMany(fe.hoverMessage):fe.hoverMessage?w.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):ye.map(fe=>({range:c.from(fe)}))}e.fromRangeOrRangeWithMessage=E;function s(ye){return typeof ye=="undefined"?ye:typeof ye=="string"?_.URI.file(ye):ye}e.pathOrURIToURI=s;var D;(function(ye){function fe(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?s(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ye.from=fe})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(ye){function fe(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?s(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?D.from(ue.before):void 0,after:ue.after?D.from(ue.after):void 0}}ye.from=fe})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(ye){function fe(ue){if(typeof ue=="undefined")return ue;switch(ue){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=fe})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ye){function fe(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?U.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?R.from(ue.light):void 0,dark:ue.dark?R.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?s(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?D.from(ue.before):void 0,after:ue.after?D.from(ue.after):void 0}}ye.from=fe})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(ye){function fe(G){return{text:G.newText,eol:G.newEol&&me.from(G.newEol),range:c.from(G.range)}}ye.from=fe;function ue(G){const Re=new b.TextEdit(c.to(G.range),G.text);return Re.newEol=typeof G.eol=="undefined"?void 0:me.to(G.eol),Re}ye.to=ue})(ee=e.TextEdit||(e.TextEdit={}));var Q;(function(ye){function fe(G,Re,Ne){const tt={edits:[]};if(G instanceof b.WorkspaceEdit)for(let Ke of G._allEntries())if(Ke._type===1)tt.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const gt=Re?.getDocument(Ke.uri);tt.edits.push({_type:2,resource:Ke.uri,edit:ee.from(Ke.edit),modelVersionId:gt?.version,metadata:Ke.metadata})}else Ke._type===3?tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ne?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ne?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(j.from)}});return tt}ye.from=fe;function ue(G){const Re=new b.WorkspaceEdit;for(const Ne of G.edits)Ne.edit?Re.replace(_.URI.revive(Ne.resource),c.to(Ne.edit.range),Ne.edit.text):Re.renameFile(_.URI.revive(Ne.oldUri),_.URI.revive(Ne.newUri),Ne.options);return Re}ye.to=ue})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var O;(function(ye){const fe=Object.create(null);fe[b.SymbolKind.File]=0,fe[b.SymbolKind.Module]=1,fe[b.SymbolKind.Namespace]=2,fe[b.SymbolKind.Package]=3,fe[b.SymbolKind.Class]=4,fe[b.SymbolKind.Method]=5,fe[b.SymbolKind.Property]=6,fe[b.SymbolKind.Field]=7,fe[b.SymbolKind.Constructor]=8,fe[b.SymbolKind.Enum]=9,fe[b.SymbolKind.Interface]=10,fe[b.SymbolKind.Function]=11,fe[b.SymbolKind.Variable]=12,fe[b.SymbolKind.Constant]=13,fe[b.SymbolKind.String]=14,fe[b.SymbolKind.Number]=15,fe[b.SymbolKind.Boolean]=16,fe[b.SymbolKind.Array]=17,fe[b.SymbolKind.Object]=18,fe[b.SymbolKind.Key]=19,fe[b.SymbolKind.Null]=20,fe[b.SymbolKind.EnumMember]=21,fe[b.SymbolKind.Struct]=22,fe[b.SymbolKind.Event]=23,fe[b.SymbolKind.Operator]=24,fe[b.SymbolKind.TypeParameter]=25;function ue(Re){return typeof fe[Re]=="number"?fe[Re]:6}ye.from=ue;function G(Re){for(const Ne in fe)if(fe[Ne]===Re)return Number(Ne);return b.SymbolKind.Property}ye.to=G})(O=e.SymbolKind||(e.SymbolKind={}));var x;(function(ye){function fe(G){switch(G){case b.SymbolTag.Deprecated:return 1}}ye.from=fe;function ue(G){switch(G){case 1:return b.SymbolTag.Deprecated}}ye.to=ue})(x=e.SymbolTag||(e.SymbolTag={}));var F;(function(ye){function fe(G){return{name:G.name,kind:O.from(G.kind),tags:G.tags&&G.tags.map(x.from),containerName:G.containerName,location:B.from(G.location)}}ye.from=fe;function ue(G){const Re=new b.SymbolInformation(G.name,O.to(G.kind),G.containerName,B.to(G.location));return Re.tags=G.tags&&G.tags.map(x.to),Re}ye.to=ue})(F=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(ye){function fe(G){const Re={name:G.name||"!!MISSING: name!!",detail:G.detail,range:c.from(G.range),selectionRange:c.from(G.selectionRange),kind:O.from(G.kind),tags:G.tags?.map(x.from)??[]};return G.children&&(Re.children=G.children.map(fe)),Re}ye.from=fe;function ue(G){const Re=new b.DocumentSymbol(G.name,G.detail,O.to(G.kind),c.to(G.range),c.to(G.selectionRange));return(0,g.isNonEmptyArray)(G.tags)&&(Re.tags=G.tags.map(x.to)),G.children&&(Re.children=G.children.map(ue)),Re}ye.to=ue})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(ye){function fe(G){const Re=new b.CallHierarchyItem(O.to(G.kind),G.name,G.detail||"",_.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}ye.to=fe;function ue(G,Re,Ne){if(Re=Re??G._sessionId,Ne=Ne??G._itemId,Re===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ne,name:G.name,detail:G.detail,kind:O.from(G.kind),uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(x.from)}}ye.from=ue})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(ye){function fe(ue){return new b.CallHierarchyIncomingCall(M.to(ue.from),ue.fromRanges.map(G=>c.to(G)))}ye.to=fe})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(ye){function fe(ue){return new b.CallHierarchyOutgoingCall(M.to(ue.to),ue.fromRanges.map(G=>c.to(G)))}ye.to=fe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(ye){function fe(G){return{range:G.range&&c.from(G.range),uri:G.uri}}ye.from=fe;function ue(G){return new b.Location(_.URI.revive(G.uri),c.to(G.range))}ye.to=ue})(B=e.location||(e.location={}));var K;(function(ye){function fe(G){const Re=G,Ne=G;return{originSelectionRange:Re.originSelectionRange?c.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ne.uri,range:c.from(Re.targetRange?Re.targetRange:Ne.range),targetSelectionRange:Re.targetSelectionRange?c.from(Re.targetSelectionRange):void 0}}ye.from=fe;function ue(G){return{targetUri:_.URI.revive(G.uri),targetRange:c.to(G.range),targetSelectionRange:G.targetSelectionRange?c.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?c.to(G.originSelectionRange):void 0}}ye.to=ue})(K=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(ye){function fe(G){return{range:c.from(G.range),contents:w.fromMany(G.contents)}}ye.from=fe;function ue(G){return new b.Hover(G.contents.map(w.to),c.to(G.range))}ye.to=ue})(te=e.Hover||(e.Hover={}));var he;(function(ye){function fe(G){return{range:c.from(G.range),expression:G.expression}}ye.from=fe;function ue(G){return new b.EvaluatableExpression(c.to(G.range),G.expression)}ye.to=ue})(he=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(ye){function fe(G){if(G instanceof b.InlineValueText)return{type:"text",range:c.from(G.range),text:G.text};if(G instanceof b.InlineValueVariableLookup)return{type:"variable",range:c.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=fe;function ue(G){switch(G.type){case"text":return{range:c.to(G.range),text:G.text};case"variable":return{range:c.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:c.to(G.range),expression:G.expression}}}ye.to=ue})(De=e.InlineValue||(e.InlineValue={}));var Pe;(function(ye){function fe(G){return{frameId:G.frameId,stoppedLocation:c.from(G.stoppedLocation)}}ye.from=fe;function ue(G){return new b.InlineValueContext(G.frameId,c.to(G.stoppedLocation))}ye.to=ue})(Pe=e.InlineValueContext||(e.InlineValueContext={}));var Fe;(function(ye){function fe(G){return{range:c.from(G.range),kind:G.kind}}ye.from=fe;function ue(G){return new b.DocumentHighlight(c.to(G.range),G.kind)}ye.to=ue})(Fe=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(ye){function fe(ue){switch(ue){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ye.to=fe})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(ye){function fe(ue){return{triggerKind:qe.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ye.to=fe})(We=e.CompletionContext||(e.CompletionContext={}));var je;(function(ye){function fe(G){switch(G){case b.CompletionItemTag.Deprecated:return 1}}ye.from=fe;function ue(G){switch(G){case 1:return b.CompletionItemTag.Deprecated}}ye.to=ue})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(ye){const fe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ue(Ne){return fe.get(Ne)??9}ye.from=ue;const G=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Re(Ne){return G.get(Ne)??b.CompletionItemKind.Property}ye.to=Re})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(ye){function fe(ue,G){const Re=new b.CompletionItem(ue.label);return Re.insertText=ue.insertText,Re.kind=W.to(ue.kind),Re.tags=ue.tags?.map(je.to),Re.detail=ue.detail,Re.documentation=L.isMarkdownString(ue.documentation)?w.to(ue.documentation):ue.documentation,Re.sortText=ue.sortText,Re.filterText=ue.filterText,Re.preselect=ue.preselect,Re.commitCharacters=ue.commitCharacters,I.Range.isIRange(ue.range)?Re.range=c.to(ue.range):typeof ue.range=="object"&&(Re.range={inserting:c.to(ue.range.insert),replacing:c.to(ue.range.replace)}),Re.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Re.insertText=new b.SnippetString(ue.insertText):(Re.insertText=ue.insertText,Re.textEdit=Re.range instanceof b.Range?new b.TextEdit(Re.range,Re.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Re.additionalTextEdits=ue.additionalTextEdits.map(Ne=>ee.to(Ne))),Re.command=G&&ue.command?G.fromInternal(ue.command):void 0,Re}ye.to=fe})(Z=e.CompletionItem||(e.CompletionItem={}));var ne;(function(ye){function fe(G){return{label:G.label,documentation:G.documentation?w.fromStrict(G.documentation):void 0}}ye.from=fe;function ue(G){return{label:G.label,documentation:L.isMarkdownString(G.documentation)?w.to(G.documentation):G.documentation}}ye.to=ue})(ne=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(ye){function fe(G){return{label:G.label,documentation:G.documentation?w.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map(ne.from):[],activeParameter:G.activeParameter}}ye.from=fe;function ue(G){return{label:G.label,documentation:L.isMarkdownString(G.documentation)?w.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(ne.to):[],activeParameter:G.activeParameter}}ye.to=ue})(ae=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(ye){function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ae.from):[]}}ye.from=fe;function ue(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ae.to):[]}}ye.to=ue})(Y=e.SignatureHelp||(e.SignatureHelp={}));var oe;(function(ye){function fe(G){return{text:G.text,position:p.from(G.position),kind:we.from(G.kind??b.InlayHintKind.Other),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}ye.from=fe;function ue(G){const Re=new b.InlayHint(G.text,p.to(G.position),we.to(G.kind));return Re.whitespaceAfter=G.whitespaceAfter,Re.whitespaceBefore=G.whitespaceBefore,Re}ye.to=ue})(oe=e.InlayHint||(e.InlayHint={}));var we;(function(ye){function fe(G){return G}ye.from=fe;function ue(G){return G}ye.to=ue})(we=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(ye){function fe(G){return{range:c.from(G.range),url:G.target,tooltip:G.tooltip}}ye.from=fe;function ue(G){let Re;if(G.url)try{Re=typeof G.url=="string"?_.URI.parse(G.url,!0):_.URI.revive(G.url)}catch(Ne){}return new b.DocumentLink(c.to(G.range),Re)}ye.to=ue})(Me=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(ye){function fe(G){const Re=new b.ColorPresentation(G.label);return G.textEdit&&(Re.textEdit=ee.to(G.textEdit)),G.additionalTextEdits&&(Re.additionalTextEdits=G.additionalTextEdits.map(Ne=>ee.to(Ne))),Re}ye.to=fe;function ue(G){return{label:G.label,textEdit:G.textEdit?ee.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Re=>ee.from(Re)):void 0}}ye.from=ue})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var _e;(function(ye){function fe(G){return new b.Color(G[0],G[1],G[2],G[3])}ye.to=fe;function ue(G){return[G.red,G.green,G.blue,G.alpha]}ye.from=ue})(_e=e.Color||(e.Color={}));var Je;(function(ye){function fe(G){return{range:c.from(G.range)}}ye.from=fe;function ue(G){return new b.SelectionRange(c.to(G.range))}ye.to=ue})(Je=e.SelectionRange||(e.SelectionRange={}));var X;(function(ye){function fe(ue){switch(ue){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ye.to=fe})(X=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var re;(function(ye){function fe(G){switch(G){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=fe;function ue(G){switch(G){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ye.to=ue})(re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var me;(function(ye){function fe(G){if(G===b.EndOfLine.CRLF)return 1;if(G===b.EndOfLine.LF)return 0}ye.from=fe;function ue(G){if(G===1)return b.EndOfLine.CRLF;if(G===0)return b.EndOfLine.LF}ye.to=ue})(me=e.EndOfLine||(e.EndOfLine={}));var xe;(function(ye){function fe(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=fe})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(ye){function fe(ue){const G={start:ue.start+1,end:ue.end+1};return ue.kind&&(G.kind=et.from(ue.kind)),G}ye.from=fe})(Be=e.FoldingRange||(e.FoldingRange={}));var et;(function(ye){function fe(ue){if(ue)switch(ue){case b.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}ye.from=fe})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ke;(function(ye){function fe(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?c.from(ue.selection):void 0,override:typeof ue.override=="boolean"?A.EditorResolution.DISABLED:void 0}}ye.from=fe})(ke=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ce;(function(ye){function fe(G){return G instanceof b.RelativePattern||typeof G=="string"?G:ue(G)?new b.RelativePattern(G.base,G.pattern):G}ye.from=fe;function ue(G){const Re=G;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(Ce=e.GlobPattern||(e.GlobPattern={}));var Te;(function(ye){function fe(ue){if(ue){if(Array.isArray(ue))return ue.map(fe);if(typeof ue=="string")return ue;{const G=ue;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:Ce.from(G.pattern),exclusive:G.exclusive}}}else return}ye.from=fe})(Te=e.LanguageSelector||(e.LanguageSelector={}));var le;(function(ye){function fe(G){return{start:G.start,end:G.end}}ye.from=fe;function ue(G){return new b.NotebookRange(G.start,G.end)}ye.to=ue})(le=e.NotebookRange||(e.NotebookRange={}));var ce;(function(ye){function fe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ye.to=fe;function ue(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}ye.from=ue})(ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ve;(function(ye){function fe(G){switch(G){case b.NotebookCellKind.Markup:return l.CellKind.Markup;case b.NotebookCellKind.Code:default:return l.CellKind.Code}}ye.from=fe;function ue(G){switch(G){case l.CellKind.Markup:return b.NotebookCellKind.Markup;case l.CellKind.Code:default:return b.NotebookCellKind.Code}}ye.to=ue})(ve=e.NotebookCellKind||(e.NotebookCellKind={}));var Ee;(function(ye){function fe(G){const Re={metadata:G.metadata??Object.create(null),cells:[]};for(let Ne of G.cells)b.NotebookCellData.validate(Ne),Re.cells.push(j.from(Ne));return Re}ye.from=fe;function ue(G){const Re=new b.NotebookData(G.cells.map(j.to));return(0,y.isEmptyObject)(G.metadata)||(Re.metadata=G.metadata),Re}ye.to=ue})(Ee=e.NotebookData||(e.NotebookData={}));var j;(function(ye){function fe(G){return{cellKind:ve.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:ce.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Se.from):[]}}ye.from=fe;function ue(G){return new b.NotebookCellData(ve.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Se.to):void 0,G.metadata,G.internalMetadata?ce.to(G.internalMetadata):void 0)}ye.to=ue})(j=e.NotebookCellData||(e.NotebookCellData={}));var be;(function(ye){function fe(G){return{mime:G.mime,valueBytes:Array.from(G.data)}}ye.from=fe;function ue(G){return new b.NotebookCellOutputItem(new Uint8Array(G.valueBytes),G.mime)}ye.to=ue})(be=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Se;(function(ye){function fe(G){return{outputId:G.id,items:G.items.map(be.from),metadata:G.metadata}}ye.from=fe;function ue(G){const Re=G.items.map(be.to);return new b.NotebookCellOutput(Re,G.outputId,G.metadata)}ye.to=ue})(Se=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(ye){function fe(Ne){if(Ne!=null){if(Ne instanceof b.RelativePattern||typeof Ne=="string")return Ne;if(Re(Ne))return new b.RelativePattern(Ne.base,Ne.pattern);if(G(Ne))return{include:Ce.from(Ne.include)||void 0,exclude:Ce.from(Ne.exclude)||void 0}}}ye.from=fe;function ue(Ne){return typeof Ne=="string"?Ne:Re(Ne)?{base:Ne.base,pattern:Ne.pattern}:{include:Ne.include,exclude:Ne.exclude}}ye.to=ue;function G(Ne){const tt=Ne,Ke=Ce.from(tt.include);if(!(Ke&&Ke instanceof b.RelativePattern||typeof Ke=="string"))return!1;const gt=Ce.from(tt.exclude);return!!(gt&&gt instanceof b.RelativePattern||typeof gt=="string")}function Re(Ne){const tt=Ne;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ue;(function(ye){function fe(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?D.from(ue.top):void 0}}ye.from=fe})(Ue=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(ye){function fe(ue,G,Re){const Ne=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Ne,Re),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ye.from=fe})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(ye){function fe(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{}}}ye.from=fe})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Qe;(function(ye){function fe(G){return{uri:G.uri,provides:G.provides}}ye.from=fe;function ue(G){return new b.NotebookRendererScript(_.URI.revive(G.uri),G.provides)}ye.to=ue})(Qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Xe;(function(ye){function fe(G){return{message:w.fromStrict(G.message)||"",severity:b.TestMessageSeverity.Error,expectedOutput:G.expectedOutput,actualOutput:G.actualOutput,location:G.location?B.from(G.location):void 0}}ye.from=fe;function ue(G){const Re=new b.TestMessage(typeof G.message=="string"?G.message:w.to(G.message));return Re.actualOutput=G.actualOutput,Re.expectedOutput=G.expectedOutput,Re}ye.to=ue})(Xe=e.TestMessage||(e.TestMessage={}));var lt;(function(ye){let fe;(function(G){G.Delimiter="\0"})(fe||(fe={})),ye.namespace=(G,Re)=>G+"\0"+Re;function ue(G,Re){return{displayId:Re.id,id:ye.namespace(G,Re.id),label:Re.label}}ye.display=ue,ye.denamespace=G=>{const Re=G.indexOf("\0");return{ctrlId:G.slice(0,Re),tagId:G.slice(Re+1)}}})(lt=e.TestTag||(e.TestTag={}));var ht;(function(ye){function fe(Ne){const tt=(0,m.getPrivateApiFor)(Ne).controllerId;return{extId:v.TestId.fromExtHostTestItem(Ne,tt).toString(),label:Ne.label,uri:Ne.uri,tags:Ne.tags.map(Ke=>lt.namespace(tt,Ke.id)),range:c.from(Ne.range)||null,description:Ne.description||null,error:Ne.error&&w.fromStrict(Ne.error)||null}}ye.from=fe;function ue(Ne){return{id:v.TestId.fromString(Ne.extId).localId,label:Ne.label,uri:_.URI.revive(Ne.uri),tags:Ne.tags.map(tt=>{const{tagId:Ke}=lt.denamespace(tt);return new b.TestTag(Ke,Ke)}),range:c.to(Ne.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ne.description||void 0}}ye.toPlain=ue;function G(Ne){const tt=v.TestId.fromString(Ne.extId),Ke=new m.TestItemImpl(tt.controllerId,tt.localId,Ne.label,_.URI.revive(Ne.uri));return Ke.range=c.to(Ne.range||void 0),Ke.description=Ne.description||void 0,Ke}function Re(Ne){let tt;for(const Ke of Ne.tests){const gt=G(Ke.item);(0,m.getPrivateApiFor)(gt).parent=tt,tt=gt}return tt}ye.toItemFromContext=Re})(ht=e.TestItem||(e.TestItem={})),function(ye){function fe(G){return{id:G.id,label:G.label}}ye.from=fe;function ue(G){return new b.TestTag(G.id,G.label)}ye.to=ue}(lt=e.TestTag||(e.TestTag={}));var Et;(function(ye){const fe=(G,Re)=>{const Ne={...ht.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Xe.to)})),children:G.children.map(tt=>Re.get(tt)).filter(y.isDefined).map(tt=>fe(tt,Re))};for(const tt of Ne.children)tt.parent=Ne;return Ne};function ue(G){const Re=[],Ne=new Map;for(const tt of G.items)Ne.set(tt.item.extId,tt),G.request.targets.some(Ke=>Ke.controllerId===tt.controllerId&&Ke.testIds.includes(tt.item.extId))&&Re.push(tt);return{completedAt:G.completedAt,results:Re.map(tt=>fe(tt,Ne))}}ye.to=ue})(Et=e.TestResults||(e.TestResults={}));var ot;(function(ye){function fe(Ne){return{covered:Ne.covered,total:Ne.covered}}function ue(Ne){return"line"in Ne?p.from(Ne):c.from(Ne)}function G(Ne){return"branches"in Ne?{count:Ne.executionCount,location:ue(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(tt=>({count:tt.executionCount,location:tt.location&&ue(tt.location)})):void 0}:{type:0,count:Ne.executionCount,location:ue(Ne.location)}}ye.fromDetailed=G;function Re(Ne){return{uri:Ne.uri,statement:fe(Ne.statementCoverage),branch:Ne.branchCoverage&&fe(Ne.branchCoverage),function:Ne.functionCoverage&&fe(Ne.functionCoverage),details:Ne.detailedCoverage?.map(G)}}ye.fromFile=Re})(ot=e.TestCoverage||(e.TestCoverage={}));var at;(function(ye){function fe(ue){switch(ue){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ye.to=fe})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Dt;(function(ye){function fe(G){const Re=new b.TypeHierarchyItem(O.to(G.kind),G.name,G.detail||"",_.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}ye.to=fe;function ue(G,Re,Ne){if(Re=Re??G._sessionId,Ne=Ne??G._itemId,Re===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ne,kind:O.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(x.from)}}ye.from=ue})(Dt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ge[216],pe([0,1,2,16,7,15,95]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(I,n,A,d={timeout:1500,errors:3}){this._logService=I,this._documents=n,this._mainThreadBulkEdits=A,this._thresholds=d,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(n,A,d)=>{const l={dispose:this._callbacks.push([n,A,I])};return Array.isArray(d)&&d.push(l),l}}async $participateInSave(I,n){const A=g.URI.revive(I);let d=!1;const m=setTimeout(()=>d=!0,this._thresholds.timeout),l=[];try{for(let v of[...this._callbacks]){if(d)break;const S=this._documents.getDocument(A),b=await this._deliverEventAsyncAndBlameBadListeners(v,{document:S,reason:C.TextDocumentSaveReason.to(n)});l.push(b)}}finally{clearTimeout(m)}return l}_deliverEventAsyncAndBlameBadListeners([I,n,A],d){const m=this._badListeners.get(I);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,I,n,d).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const v=this._badListeners.get(I);this._badListeners.set(I,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,n,A,d){const m=[],l=Date.now(),{document:v,reason:S}=d,{version:b}=v,P=Object.freeze({document:v,reason:S,waitUntil(c){if(Object.isFrozen(m))throw(0,L.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{n.apply(A,[P])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,f)=>{const p=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(p),c(t)}).catch(t=>{clearTimeout(p),f(t)})}).then(c=>{const f={edits:[]};for(const p of c)if(Array.isArray(p)&&p.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:r,range:o}of p)f.edits.push({_type:2,resource:v.uri,edit:{range:o&&C.Range.from(o),text:t,eol:r&&C.EndOfLine.from(r)}});if(f.edits.length!==0)return b===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(ge[217],pe([0,1,3,30,2,15,7]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(n,A,d,m,l){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,d&&(this._config+=1),m&&(this._config+=2),l&&(this._config+=4);const v=(0,L.parse)(A),S=n(b=>{if(!d)for(let P of b.created){const c=k.URI.revive(P);v(c.fsPath)&&this._onDidCreate.fire(c)}if(!m)for(let P of b.changed){const c=k.URI.revive(P);v(c.fsPath)&&this._onDidChange.fire(c)}if(!l)for(let P of b.deleted){const c=k.URI.revive(P);v(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(n,A,d){this._logService=A,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,A,d,m){return new y(this._onFileSystemEvent.event,n,A,d,m)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,A){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:A.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:A.map(d=>k.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:A.map(d=>k.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,A){return(d,m,l)=>{const v=function(b){d.call(m,b)};return v.extension=n,A.event(v,void 0,l)}}async $onWillRunFileOperation(n,A,d,m){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:A.map(l=>({oldUri:k.URI.revive(l.source),newUri:k.URI.revive(l.target)}))},d,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:A.map(l=>k.URI.revive(l.target))},d,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:A.map(l=>k.URI.revive(l.target))},d,m)}}async _fireWillEvent(n,A,d,m){const l=new Set,v=[];if(await n.fireAsync(A,m,async(b,P)=>{const c=Date.now(),f=await Promise.resolve(b);f instanceof T.WorkspaceEdit&&(v.push(f),l.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-c>d&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),m.isCancellationRequested||v.length===0)return;const S={edits:[]};for(let b of v){let{edits:P}=C.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(P)}return{edit:S,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=_}),define(ge[218],pe([0,1,10,25,2,15,7,89]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(d,m,l,v){this.start=d,this.deletedCount=m,this.deletedItems=l,this.items=v}static asApiEvents(d){return d.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(l=>l.apiCell)}))}}class I{constructor(d,m,l){this.notebook=d,this._extHostDocument=m,this._cellData=l,this.handle=l.handle,this.uri=k.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=Object.freeze(l.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(l.internalMetadata??{}))}static asModelAddData(d,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return d._mime},set mime(l){d._mime=l},get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(C.NotebookCellOutput.to)}setOutputItems(d,m,l){const v=l.map(C.NotebookCellOutputItem.to),S=this._outputs.find(b=>b.id===d);S&&(m||(S.items.length=0),S.items.push(...v))}setMetadata(d){this._metadata=Object.freeze(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(d))}setMime(d){}}e.ExtHostCell=I;class n{constructor(d,m,l,v,S,b){this._proxy=d,this._textDocumentsAndEditors=m,this._textDocuments=l,this._emitter=v,this.uri=S,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get notebookType(){return d._notebookType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===g.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(m){return m=d._validateIndex(m),d._cells[m].apiCell},getCells(m){return(m?d._getCells(m):d._cells).map(v=>v.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=Object.freeze({...this._metadata,...d.metadata}))}acceptDirty(d){this._isDirty=d}acceptModelChanged(d,m){this._versionId=d.versionId,this._isDirty=m;for(const l of d.rawEvents)l.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===y.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let m=d.start|0,l=d.end|0;return m<0&&(m=0),l>this._cells.length&&(l=this._cells.length),d.with({start:m,end:l})}_getCells(d){d=this._validateRange(d);const m=[];for(let l=d.start;l<d.end;l++)m.push(this._cells[l]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,m){if(this._disposed)return;const l=[],v=[],S=[];d.reverse().forEach(b=>{const c=b[2].map(t=>{const r=new I(this,this._textDocumentsAndEditors,t);return m||v.push(I.asModelAddData(this.apiNotebook,t)),r}),f=new _(b[0],b[1],[],c),p=this._cells.splice(b[0],b[1],...c);for(const t of p)S.push(t.uri),f.deletedItems.push(t.apiCell);l.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:S}),m||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(l)}))}_moveCell(d,m){const l=this._cells.splice(d,1);this._cells.splice(m,0,...l);const v=[new _(d,1,l.map(S=>S.apiCell),[]),new _(m,0,[],l)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(v)}))}_setCellOutputs(d,m){const l=this._cells[d];l.setOutputs(m),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(d,m,l,v){const S=this._cells[d];S.setOutputItems(m,l,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(d,m){const l=this._cells[d];l.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(l.uri,m)}_changeCellMime(d,m){const l=this._cells[d];l.apiCell.mime=m}_changeCellMetadata(d,m){const l=this._cells[d],v=l.apiCell.metadata;l.setMetadata(m);const S=l.apiCell.metadata;(0,L.equals)(v,S)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(d,m){const l=this._cells[d],v=l.internalMetadata;if(l.setInternalMetadata(m),v.runState!==m.runState){const S=m.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:S}))}}getCellFromApiCell(d){return this._cells.find(m=>m.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(m=>m.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(ge[128],pe([0,1,7,15,16]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:I})}replaceCells(_,I,n){this._throwIfFinalized(),!(_===I&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:I-_,cells:n.map(L.NotebookCellData.from)})}}class T{constructor(_,I,n,A,d,m){this.id=_,this._proxy=I,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._visibleRanges=A,this._viewColumn=m}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(I){if(!Array.isArray(I)||!I.every(g.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");_._selections=I,_._trySetSelections(I)},get visibleRanges(){return _._visibleRanges},revealRange(I,n){_._proxy.$tryRevealRange(_.id,L.NotebookRange.from(I),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(I){const n=new C(this.document.version);return I(n),_._applyEdit(n.finalize())},setDecorations(I,n){return _.setDecorations(I,n)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(L.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const I=[];let n=-1;for(let A=0;A<_.cellEdits.length;A++){if(n<0){I.push(_.cellEdits[A]),n++;continue}const m=I[n],l=_.cellEdits[A];if(m.editType===1&&l.editType===1&&m.index===l.index){m.cells.push(..._.cellEdits[A].cells),m.count+=_.cellEdits[A].count;continue}I.push(_.cellEdits[A]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,I)}setDecorations(_,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return I.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(I),_.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(ge[219],pe([0,1,15,118,165,21,56]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(A){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=A}withProgress(A,d,m){const l=this._handles++,{title:v,location:S,cancellable:b}=d,P={label:(0,k.localize)(0,null,A.displayName||A.name),id:A.identifier.value};return this._proxy.$startProgress(l,{location:g.ProgressLocation.from(S),title:v,source:P,cancellable:b},A),this._withProgress(l,m,!!b)}_withProgress(A,d,m){let l;m&&(l=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(A,l));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),l&&l.dispose()};let S;try{S=d(new I(this._proxy,A),m&&l?l.token:C.CancellationToken.None)}catch(b){throw v(A),b}return S.then(b=>v(A),b=>v(A)),S}$acceptProgressCanceled(A){const d=this._mapHandleToCancellationSource.get(A);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(A))}}e.ExtHostProgress=y;function _(n,A){return n.message=A.message,typeof A.increment=="number"&&(typeof n.increment=="number"?n.increment+=A.increment:n.increment=A.increment),n}class I extends L.Progress{constructor(A,d){super(m=>this.throttledReport(m));this._proxy=A,this._handle=d}throttledReport(A){this._proxy.$progressReport(this._handle,A)}}ze([(0,T.throttle)(100,(n,A)=>_(n,A),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(ge[129],pe([0,1,54,16,73,15,7]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(d,m,l){const v=y._Keys.nextId();d.$registerTextEditorDecorationType(m.identifier,v,C.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:v,dispose(){d.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=y,y._Keys=new k.IdGenerator("TextEditorDecorationType");class _{constructor(d,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,m){this._throwIfFinalized();let l=null;if(d instanceof T.Position)l=new T.Range(d,d);else if(d instanceof T.Range)l=d;else throw new Error("Unrecognized location");this._pushEdit(l,m,!1)}insert(d,m){this._throwIfFinalized(),this._pushEdit(new T.Range(d,d),m,!0)}delete(d){this._throwIfFinalized();let m=null;if(d instanceof T.Range)m=d;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(d,m,l){const v=this._document.validateRange(d);this._collectedEdits.push({range:v,text:m,forceMoveMarkers:l})}setEndOfLine(d){if(this._throwIfFinalized(),d!==T.EndOfLine.LF&&d!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=_;class I{constructor(d,m,l,v){this._proxy=d,this._id=m,this._accept(l),this._logService=v;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(b){S._setTabSize(b)},get insertSpaces(){return S._insertSpaces},set insertSpaces(b){S._setInsertSpaces(b)},get cursorStyle(){return S._cursorStyle},set cursorStyle(b){S._setCursorStyle(b)},get lineNumbers(){return S._lineNumbers},set lineNumbers(b){S._setLineNumbers(b)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const m=Math.floor(d);return m>0?m:null}if(typeof d=="string"){const m=parseInt(d,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(d){const m=this._validateTabSize(d);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const m=this._validateInsertSpaces(d);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(d)})))}assign(d){const m={};let l=!1;if(typeof d.tabSize!="undefined"){const v=this._validateTabSize(d.tabSize);v==="auto"?(l=!0,m.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,l=!0,m.tabSize=v)}if(typeof d.insertSpaces!="undefined"){const v=this._validateInsertSpaces(d.insertSpaces);v==="auto"?(l=!0,m.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,l=!0,m.insertSpaces=v)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,l=!0,m.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,l=!0,m.lineNumbers=C.TextEditorLineNumbersStyle.from(d.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(d){d.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=I;class n{constructor(d,m,l,v,S,b,P,c){this.id=d,this._proxy=m,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new I(this._proxy,this.id,b,l),this._visibleRanges=P,this._viewColumn=c;const f=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,L.illegalArgument)("selection");f._selections=[p],f._trySetSelection()},get selections(){return f._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");f._selections=p,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return f._options.value},set options(p){f._disposed||f._options.assign(p)},get viewColumn(){return f._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new _(v.getValue(),t);return p(r),f._applyEdit(r)},insertSnippet(p,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=f._selections.map(i=>C.Range.from(i));else if(t instanceof T.Position){const{lineNumber:i,column:a}=C.Position.from(t);o=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof T.Range)o=[C.Range.from(t)];else{o=[];for(const i of t)if(i instanceof T.Range)o.push(C.Range.from(i));else{const{lineNumber:a,column:h}=C.Position.from(i);o.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return m.$tryInsertSnippet(d,p.value,o,r)},setDecorations(p,t){const r=t.length===0;r&&!f._hasDecorationsForKey.has(p.key)||(r?f._hasDecorationsForKey.delete(p.key):f._hasDecorationsForKey.add(p.key),f._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return m.$trySetDecorations(d,p.key,C.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const h=t[i];o[4*i]=h.start.line+1,o[4*i+1]=h.start.character+1,o[4*i+2]=h.end.line+1,o[4*i+3]=h.end.character+1}return m.$trySetDecorationsFast(d,p.key,o)}}))},revealRange(p,t){f._runOnProxy(()=>m.$tryRevealRange(d,C.Range.from(p),t||T.TextEditorRevealType.Default))},show(p){m.$tryShowEditor(d,C.ViewColumn.from(p))},hide(){m.$tryHideEditor(d)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,g.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,g.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,g.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,g.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const m=d.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const l=m.edits.map(S=>S.range);l.sort((S,b)=>S.end.line===b.end.line?S.end.character===b.end.character?S.start.line===b.start.line?S.start.character-b.start.character:S.start.line-b.start.line:S.end.character-b.end.character:S.end.line-b.end.line);for(let S=0,b=l.length-1;S<b;S++){const P=l[S].end;if(l[S+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=m.edits.map(S=>({range:C.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,v,{setEndOfLine:typeof m.setEndOfLine=="number"?C.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=n}),define(ge[220],pe([0,1,168,23,2,3,6,208,17,7,14,20,15,21,205]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(P,c){if((0,n.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let f;return Array.isArray(P.highlights)&&(f=P.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),f=f.length?f:void 0),{label:P.label,highlights:f}}}class S{constructor(c,f,p){this._proxy=c,this.commands=f,this.logService=p,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}f.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(o=>t(o)?this.convertArgument(o):o):r})}registerTreeDataProvider(c,f,p){const t=this.createTreeView(c,{treeDataProvider:f},p);return{dispose:()=>t.dispose()}}createTreeView(c,f,p){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=f.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:t}),o=this.createExtHostTreeView(c,f,p);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(i){o.message=i},get title(){return o.title},set title(i){o.title=i},get description(){return o.description},set description(i){o.description=i},reveal:(i,a)=>o.reveal(i,a),dispose:async()=>{await r,this.treeViews.delete(c),o.dispose()}}}$getChildren(c,f){const p=this.treeViews.get(c);return p?p.getChildren(f):Promise.reject(new Error((0,g.localize)(0,null,c)))}async $onDrop(c,f,p){const t=this.treeViews.get(c);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,c)));const r=l.TreeDataTransferConverter.toITreeDataTransfer(f);if(r.items.has(y.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(y.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(a=>t.getExtensionElement(a)).filter(a=>!!a);i.length>0?r.items.set(y.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(y.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,p)}async $hasResolve(c){const f=this.treeViews.get(c);if(!f)throw new Error((0,g.localize)(2,null,c));return f.hasResolve}$resolve(c,f,p){const t=this.treeViews.get(c);if(!t)throw new Error((0,g.localize)(3,null,c));return t.resolveTreeItem(f,p)}$setExpanded(c,f,p){const t=this.treeViews.get(c);if(!t)throw new Error((0,g.localize)(4,null,c));t.setExpanded(f,p)}$setSelection(c,f){const p=this.treeViews.get(c);if(!p)throw new Error((0,g.localize)(5,null,c));p.setSelection(f)}$setVisible(c,f){const p=this.treeViews.get(c);if(!p)throw new Error((0,g.localize)(6,null,c));p.setVisible(f)}createExtHostTreeView(c,f,p){const t=new b(c,f,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(c,t),t}convertArgument(c){const f=this.treeViews.get(c.$treeViewId);return f?f.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=S;class b extends T.Disposable{constructor(c,f,p,t,r,o){super();if(this.viewId=c,this.proxy=p,this.commands=t,this.logService=r,this.extension=o,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,o.contributes&&o.contributes.views)for(const h in o.contributes.views)for(const u of o.contributes.views[h])u.id===c&&(this._title=u.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let i,a;this._register(C.Event.debounce(this._onDidChangeData.event,(h,u)=>(h||(h={message:!1,elements:[]}),u.element!==!1&&(i||(i=new Promise(w=>a=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(u.element)?h.elements.push(...u.element):h.elements.push(u.element)),u.message&&(h.message=!0),h),200,!0)(({message:h,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=a;return i=null,this.refresh(u).then(()=>w())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,n.isUndefinedOrNull)(c))}getChildren(c){const f=c?this.getExtensionElement(c):void 0;if(c&&!f)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(c);return(p?Promise.resolve(p):this.fetchChildrenNodes(f)).then(t=>t.map(r=>r.item))}getExtensionElement(c){return this.elements.get(c)}reveal(c,f){f=f||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(f.select)?!0:f.select,t=(0,n.isUndefinedOrNull)(f.focus)?!1:f.focus,r=(0,n.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(o=>this.resolveTreeNode(c,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(a=>a.item)},{select:p,focus:t,expand:r})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:r})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,f){const p=this.getExtensionElement(c);p&&(f?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(c){(0,A.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,f){const p=this.getExtensionElement(f);if(!!p)return(0,_.asPromise)(()=>this.dndController?.onDrop(c,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,f){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(c);if(p){const t=this.nodes.get(p);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,p,f)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(f=>f?this.resolveUnknownParentChain(f).then(p=>this.resolveTreeNode(f,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(c){const f=this.nodes.get(c);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,f){const p=this.nodes.get(c);return p?Promise.resolve(p):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(t=>this.createHandle(c,t,f,!0)).then(t=>this.getChildren(f?f.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const o=this.nodes.get(r);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(c){if(c){let f;if(typeof c=="string"){const p=this.getExtensionElement(c);f=p?this.nodes.get(p):void 0}else f=c;return f&&f.children||null}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const f=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=c?this.nodes.get(c):void 0,t=await this.dataProvider.getChildren(c);if(f.token.isCancellationRequested)return[];const r=await Promise.all((0,A.coalesce)(t||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,p):null}));return f.token.isCancellationRequested?[]:(0,A.coalesce)(r)}finally{f.dispose()}}refresh(c){if(c.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(c);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const f=new Set,p=c.map(r=>this.nodes.get(r));for(const r of p)if(r&&!f.has(r.item.handle)){let o=r;for(;o&&o.parent&&p.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&f.add(r.item.handle)}const t=[];return f.forEach(r=>{const o=this.elements.get(r);if(o){const i=this.nodes.get(o);i&&(!i.parent||!f.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(c){const f={};return Promise.all(c.map(p=>this.refreshNode(p).then(t=>{t&&(f[p]=t.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(c){const f=this.getExtensionElement(c);if(f){const p=this.nodes.get(f);if(p)return this.clearChildren(f),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(t=>{if(t){const r=this.createTreeNode(f,t,p.parent);return this.updateNodeCache(f,r,p,p.parent),p.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,f,p){const t=this.createTreeNode(c,f,p);if(f.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,f.id));return this.addNodeToCache(c,t),this.addNodeToParentCache(t,p),t}getTooltip(c){return I.MarkdownString.isMarkdownString(c)?d.MarkdownString.from(c):c}getCommand(c,f){return f?this.commands.toInternal(f,c):void 0}createTreeNode(c,f,p){const t=new T.DisposableStore,r=this.createHandle(c,f,p),o=this.getLightIconPath(f);return{item:{handle:r,parentHandle:p?p.item.handle:void 0,label:v(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(t,f.command),contextValue:f.contextValue,icon:o,iconDark:this.getDarkIconPath(f)||o,themeIcon:this.getThemeIcon(f),collapsibleState:(0,n.isUndefinedOrNull)(f.collapsibleState)?I.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(c){return c.iconPath instanceof I.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:f,label:p,resourceUri:t},r,o){if(f)return`${b.ID_HANDLE_PREFIX}/${f}`;const i=v(p,this.extension),a=r?r.item.handle:b.LABEL_HANDLE_PREFIX;let h=i?i.label:t?(0,L.basename)(t):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const u=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,w=this.getChildrenNodes(r)||[];let E,s=0;do{if(E=`${a}/${s}:${h}`,o||!this.elements.has(E)||u===E)break;s++}while(s<=w.length);return E}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon))return typeof c.iconPath=="string"||k.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return k.URI.isUri(c)?c:k.URI.file(c)}addNodeToCache(c,f){this.elements.set(f.item.handle,c),this.nodes.set(c,f)}updateNodeCache(c,f,p,t){this.elements.delete(f.item.handle),this.nodes.delete(c),f.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(c,f);const r=this.getChildrenNodes(t)||[],o=r.filter(i=>i.item.handle===p.item.handle)[0];o&&r.splice(r.indexOf(o),1,f)}addNodeToParentCache(c,f){f?(f.children||(f.children=[]),f.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const f=this.nodes.get(c);if(f){if(f.children)for(const p of f.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}f.children=void 0}}else this.clearAll()}clear(c){const f=this.nodes.get(c);if(f){if(f.children)for(const p of f.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(c),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(ge[221],pe([0,1,17,3,6,14,87,15,126,90]),function(J,e,g,L,k,C,T,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends k.Disposable{constructor(d){super();this.controllerId=d,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(d){this._resolveHandler=d;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const d=this.diff;return this.diff=[],d}*tags(){const d=new Set;for(const m of this.tree.values())for(const l of m.actual.tags)d.has(l.id)||(d.add(l.id),yield l)}pushDiff(d){const m=this.diff[this.diff.length-1];if(m&&d[0]===1){if(m[0]===1&&m[1].extId===d[1].extId){(0,_.applyTestItemUpdate)(m[1],d[1]);return}if(m[0]===0&&m[1].item.extId===d[1].extId){(0,_.applyTestItemUpdate)(m[1],d[1]);return}}this.diff.push(d),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(d,m){const l=this.tree.get(d);if(!!l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const v=this.resolveChildren(l);return v.isOpen()?this.expandChildren(l,m-1):v.wait().then(()=>this.expandChildren(l,m-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,m-1)):this.expandChildren(l,m-1)}}dispose(){for(const d of this.tree.values())(0,T.getPrivateApiFor)(d.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(d,m){switch(m.op){case 2:this.pushDiff([4,d.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(d.fullId,m.id));break;case 0:this.upsertItem(m.item,d);break;case 4:for(const b of m.ops)this.onTestItemEvent(d,b);break;case 3:const{key:l,value:v}=m,S=d.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(d);break;case"tags":this.pushDiff([1,{extId:S,item:{tags:v.map(b=>b.id)}}]);break;case"range":this.pushDiff([1,{extId:S,item:{range:y.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:y.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[l]:v??null}}]);break}break;default:(0,C.assertNever)(m)}}upsertItem(d,m){if(!(d instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${d.id} did not`);const l=I.TestId.fromExtHostTestItem(d,this.root.id,m?.actual),v=(0,T.getPrivateApiFor)(d);v.parent&&v.parent!==m?.actual&&v.parent.children.delete(d.id);let S=this.tree.get(l.toString());if(!S){S={fullId:l,actual:d,parent:m?l.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},this.tree.set(S.fullId.toString(),S),this.setItemParent(d,m),this.pushDiff([0,{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:y.TestItem.from(d)}]),this.connectItemAndChildren(d,S,m);return}if(S.actual===d){this.connectItem(d,S,m);return}const b=S.actual.children,P=S.actual,c=(0,T.diffTestItems)(P,d);(0,T.getPrivateApiFor)(P).listener=void 0,S.actual=d,S.expand=0;for(const[f,p]of c)this.onTestItemEvent(S,{op:3,key:f,value:p});this.connectItemAndChildren(d,S,m);for(const f of b)d.children.get(f.id)||this.removeItem(I.TestId.joinToString(l,f.id))}setItemParent(d,m){(0,T.getPrivateApiFor)(d).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(d,m,l){this.setItemParent(d,l);const v=(0,T.getPrivateApiFor)(d);v.parent=l?.actual,v.listener=S=>this.onTestItemEvent(m,S),this.updateExpandability(m)}connectItemAndChildren(d,m,l){this.connectItem(d,m,l);for(const v of d.children)this.upsertItem(v,m)}updateExpandability(d){let m;this._resolveHandler?d.resolveBarrier?m=d.resolveBarrier.isOpen()?3:2:m=d.actual.canResolveChildren?1:0:m=0,m!==d.expand&&(d.expand=m,this.pushDiff([1,{extId:d.fullId.toString(),expand:m}]),m===1&&d.expandLevels!==void 0&&this.resolveChildren(d))}expandChildren(d,m){if(m<0)return;const l=[];for(const v of d.actual.children){const S=this.expand(I.TestId.joinToString(d.fullId,v.id),m);(0,g.isThenable)(S)&&l.push(S)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this._resolveHandler){const S=new g.Barrier;return S.open(),S}d.expand=2,this.pushExpandStateUpdate(d);const m=d.resolveBarrier=new g.Barrier,l=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),d.actual!==this.root&&(d.actual.error=S.stack||S.message||String(S))};let v;try{v=this._resolveHandler(d.actual===this.root?void 0:d.actual)}catch(S){l(S)}return(0,g.isThenable)(v)?v.catch(l).then(()=>{m.open(),this.updateExpandability(d)}):(m.open(),this.updateExpandability(d)),d.resolveBarrier}pushExpandStateUpdate(d){this.pushDiff([1,{extId:d.fullId.toString(),expand:d.expand}])}removeItem(d){const m=this.tree.get(d);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,d]);const l=[m];for(;l.length;){const v=l.pop();if(!!v){(0,T.getPrivateApiFor)(v.actual).listener=void 0,this.tree.delete(v.fullId.toString());for(const S of v.actual.children)l.push(this.tree.get(I.TestId.joinToString(v.fullId,S.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.diffOpEmitter.fire(d)}}e.SingleUseTestCollection=n}),define(ge[222],pe([0,1,4,183]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(ge[223],pe([0,1,26,3,9]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=C;class T{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let A of n.activationEvents)A==="onUri"&&(A=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(n)}}keepOnly(n){const A=new Set;n.forEach(d=>A.add(g.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>A.has(g.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,A){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const d=T._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(d.map(m=>m.identifier)),A.length>0){const m=new Set;A.forEach(l=>m.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!m.has(g.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(d)}static _findLoopingExtensions(n){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,b){this.addNode(S),this.addNode(b),this._arcs.has(S)?this._arcs.get(S).push(b):this._arcs.set(S,[b])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,b){const P=A.getArcs(S);for(let c=0;c<P.length;c++)if(!b.has(P[c]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let S of n){const b=g.ExtensionIdentifier.toKey(S.identifier);if(d.set(b,S),S.extensionDependencies)for(let P of S.extensionDependencies){const c=g.ExtensionIdentifier.toKey(P);A.addArc(b,c)}}let m=new Set;A.getNodes().filter(S=>A.getArcs(S).length===0).forEach(S=>m.add(S));let l=A.getNodes().filter(S=>!m.has(S)),v;do{v=!1;for(let S=0;S<l.length;S++){const b=l[S];A.hasOnlyGoodArcs(b,m)&&(l.splice(S,1),S--,m.add(b),v=!0)}}while(v);return l.map(S=>d.get(S))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const A=this._activationMap.get(n);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const A=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return A||void 0}}e.ExtensionDescriptionRegistry=T;var y;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(y||(y={}));function _(I,n){const A=I.isBuiltin?0:I.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(A!==d)return A-d;const m=k.posix.basename(I.extensionLocation.path),l=k.posix.basename(n.extensionLocation.path);return m<l?-1:m>l?1:0}}),define(ge[224],pe([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function C(y){const _=g.VSBuffer.alloc(1);switch(y){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=C;function T(y,_){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=T}),define(ge[35],pe([0,1,3,2,4,26,185]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class y{constructor(P){this.dependency=P}}e.MissingExtensionDependency=y;var _;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class I{constructor(P,c,f,p){this.codeLoadingTime=P,this.activateCallTime=c,this.activateResolvedTime=f,this.activationReason=p}}e.ActivationTimes=I;class n{constructor(P,c){this.description=P,this.value=c}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var A;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(A=e.ActivationKind||(e.ActivationKind={}));function d(b){b.enableProposedApi||m(b)}e.checkProposedApiEnabled=d;function m(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=m;function l(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=l;function v(b,P){return{identifier:new C.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!P,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=v;class S{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,c){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,c,f,p,t){}_onDidActivateExtensionError(P,c){}_onExtensionRuntimeError(P,c){}_onExtensionHostExit(P){}}e.NullExtensionService=S}),define(ge[225],pe([0,1,26,35,12]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class T{constructor(l,v,S,b){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=S,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class y{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,v){return l===-1||v===-1?-1:v-l}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class _{constructor(l,v,S,b,P,c){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=S,this.module=b,this.exports=P,this.subscriptions=c}}e.ActivatedExtension=_;class I extends _{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class n extends _{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class A extends _{constructor(l){super(!0,l,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=A;let d=class{constructor(l,v,S,b,P){this._logService=P,this._registry=l,this._resolvedExtensionsSet=new Set,v.forEach(c=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,S.forEach(c=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(c),c)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const v=g.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(v)}getActivatedExtension(l){const v=g.ExtensionIdentifier.toKey(l),S=this._activatedExtensions.get(v);if(!S)throw new Error("Extension `"+l.value+"` is not known or not activated");return S}activateByEvent(l,v){if(this._alreadyActivatedEvents[l])return C;const S=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(S.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,v){const S=this._registry.getExtensionDescription(l);if(!S)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:S.identifier,reason:v}])}_handleActivateRequest(l,v,S){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(l.id))){v[g.ExtensionIdentifier.toKey(l.id)]=l;return}const b=this._registry.getExtensionDescription(l.id);if(!b){const f=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,f,new L.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(l.id),new A(f));return}const P=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let c=!0;for(let f=0,p=P.length;f<p;f++){const t=P[f];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const h=b.displayName||b.identifier.value,u=this._registry.getExtensionDescription(t),w=u&&u.displayName||t,E=new Error(`Cannot activate the '${h}' extension because its dependency '${w}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new A(E));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){c=!1,v[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){c=!1,v[g.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:l.reason};continue}const i=b.displayName||b.identifier.value,a=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,a,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new A(a));return}c?v[g.ExtensionIdentifier.toKey(b.identifier)]=l:S.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(P=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(P.id))),l.length===0))return Promise.resolve(void 0);const v=Object.create(null),S=[];for(let P=0,c=l.length;P<c;P++)this._handleActivateRequest(l[P],v,S);for(let P=0,c=S.length;P<c;P++){const f=g.ExtensionIdentifier.toKey(S[P].id);v[f]&&delete v[f]}const b=Object.keys(v).map(P=>v[P]);return S.length===0?Promise.all(b.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(b).then(P=>this._activateExtensions(S))}_activateExtension(l,v){const S=g.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const b=this._activatingExtensions.get(S);if(b)return b;const P=this._host.actualActivateExtension(l,v).then(void 0,c=>{const f=new Error;return c&&c.name&&(f.name=c.name),c&&c.message?f.message=`Activating extension '${l.value}' failed: ${c.message}.`:f.message=`Activating extension '${l.value}' failed: ${c}.`,c&&c.stack&&(f.stack=c.stack),this._host.onExtensionActivationError(l,f,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(c),new A(c)}).then(c=>{this._activatedExtensions.set(S,c),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,P),P}};d=ze([$e(4,k.ILogService)],d),e.ExtensionsActivator=d}),define(ge[226],pe([0,1,12,35,27,10,116]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends g.LogService{constructor(I){if(I.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(L.ExtensionHostLogFileName,I.logFile.fsPath,!0,I.logLevel))}$setLevel(I){this.setLevel(I)}};y=ze([$e(0,k.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(ge[227],pe([0,1,16]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,T)=>{this._actualOk=C,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,g.onUnexpectedError)(C))}then(C,T){return this._ensureActual().then(C,T)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(ge[130],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(_,I){this._proxyIdentifierBrand=void 0,this.isMain=_,this.sid=I,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function k(y){const _=new g(!0,y);return L[_.nid]=_,_}e.createMainContextProxyIdentifier=k;function C(y){const _=new g(!1,y);return L[_.nid]=_,_}e.createExtHostContextProxyIdentifier=C;function T(y){return L[y].sid}e.getStringIdentifierForProxy=T}),define(ge[5],pe([0,1,59,2,130]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var T;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(c){c.name="$ident";function f(t,r){return Object.defineProperty(t,c.name,{value:r,enumerable:!0}),t}c.mixin=f;function p(t){return t[c.name]}c.of=p})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(f){return f._id=m._n++,f}}e.IdObject=m,m._n=0;var l;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(c){if(c&&c.edits)for(const f of c.edits)typeof f.resource=="object"?f.resource=L.URI.revive(f.resource):(f.newUri=L.URI.revive(f.newUri),f.oldUri=L.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,g.revive)(f.metadata));return c}e.reviveWorkspaceEditDto=b;var P;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[91],pe([0,1,5,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(y){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,_){return this._proxy.$getPassword(y,_)}store(y,_,I){return this._proxy.$setPassword(y,_,I)}delete(y,_){return this._proxy.$deletePassword(y,_)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(ge[64],pe([0,1,4,12,5,13]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(k.MainContext.MainThreadTelemetry)}report(_,I,n){const A=this.getUsageKey(_,I);this._reportedUsages.has(A)||(this._reportedUsages.add(A),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};T=ze([$e(0,C.IExtHostRpcService),$e(1,L.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(y,_,I){}})}),define(ge[228],pe([0,1,3,5,7,26]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,I,n,A={}){const d=C.ExtensionIdentifier.toKey(_.identifier),m=this._inFlightRequests.get(d)||[],l=[...n].sort().join(" ");let v=m.find(S=>S.scopes===l);if(v)return v.result;{const S=this._getSession(_,d,I,n,A);v={scopes:l,result:S},m.push(v),this._inFlightRequests.set(d,m);try{await S}finally{const b=m.findIndex(P=>P.scopes===l);b>-1&&(m.splice(b),this._inFlightRequests.set(d,m))}return S}}async _getSession(_,I,n,A,d={}){await this._proxy.$ensureProvider(n);const m=_.displayName||_.name;return this._proxy.$getSession(n,A,I,m,d)}async removeSession(_,I){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,n,A){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:n,options:A??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===_)||this._providers.push({id:_,label:I});const d=n.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(_,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,I,A?.supportsMultipleAccounts??!1),new k.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(_);const m=this._providers.findIndex(l=>l.id===_);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(ge[229],pe([0,1,5,13,15]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(y,_){this._extHostDocumentsAndEditors=_,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const _=k.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};C=ze([$e(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(ge[230],pe([0,1,5]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const T=C.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(y){return T.$writeText(y)}})}}e.ExtHostClipboard=L}),define(ge[44],pe([0,1,14,7,15,25,5,20,12,59,41,50,2,6,4,13]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=r,this.converter=new b(this,o=>{const i=this._apiCommands.get(o);return i?.result===c.Void?i:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,I.revive)(o)}},{processArgument(o){return(0,C.cloneAndChange)(o,function(i){if(n.Range.isIRange(i))return k.Range.to(i);if(A.Position.isIPosition(i))return k.Position.to(i);if(n.Range.isIRange(i.range)&&d.URI.isUri(i.uri))return k.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...o)=>{const i=t.args.map((h,u)=>{if(!h.validate(o[u]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[u]}`);return h.convert(o[u])}),a=await this.executeCommand(t.internalId,...i);return t.result.convert(a,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,o,i,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:i,description:a}),t&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,o){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,C.cloneAndChange)(r,function(a){if(a instanceof L.Position)return k.Position.from(a);if(a instanceof L.Range)return k.Range.from(a);if(a instanceof L.Location)return k.location.from(a);if(L.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,i,o);return(0,I.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:i,thisArg:a,description:h}=o;if(h)for(let u=0;u<h.args.length;u++)try{(0,g.validateConstraint)(r[u],h.args[u].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[u].name}' - ${h.args[u].description}`)}try{return await i.apply(a,r)}catch(u){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(u,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(o=>this._argumentProcessors.reduce((i,a)=>a.processArgument(i),o)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,o]of this._commands){let{description:i}=o;i&&(t[r]=i)}return Promise.resolve(t)}};S=ze([$e(0,v.IExtHostRpcService),$e(1,_.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class b{constructor(t,r,o){this._commands=t,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const i=this._lookupApiCommand(t.command);if(i)o.id=i.internalId,o.arguments=i.args.map((a,h)=>a.convert(t.arguments&&t.arguments[h]));else if((0,y.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),o.$ident=a,o.id=this.delegatingCommandId,o.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return o}fromInternal(t){const r=T.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class P{constructor(t,r,o,i){this.name=t,this.description=r,this.validate=o,this.convert=i}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new P(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",p=>d.URI.isUri(p),p=>p),P.Position=new P("position","A position in a text document",p=>L.Position.isPosition(p),k.Position.from),P.Range=new P("range","A range in a text document",p=>L.Range.isRange(p),k.Range.from),P.Selection=new P("selection","A selection in a text document",p=>L.Selection.isSelection(p),k.Selection.from),P.Number=new P("number","",p=>typeof p=="number",p=>p),P.String=new P("string","",p=>typeof p=="string",p=>p),P.CallHierarchyItem=new P("item","A call hierarchy item",p=>p instanceof L.CallHierarchyItem,k.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",p=>p instanceof L.TypeHierarchyItem,k.TypeHierarchyItem.from);class c{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=c,c.Void=new c("no result",p=>p);class f{constructor(t,r,o,i,a){this.id=t,this.internalId=r,this.description=o,this.args=i,this.result=a}}e.ApiCommand=f}),define(ge[231],pe([0,1,15,7,81,44,20,111]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,m)=>{if((0,T.isFalsyOrEmpty)(d))return;class l extends L.SymbolInformation{static to(S){const b=new l(S.name,g.SymbolKind.to(S.kind),S.containerName||"",new L.Location(m[0],g.Range.to(S.range)));return b.detail=S.detail,b.range=b.location.range,b.selectionRange=g.Range.to(S.selectionRange),b.children=S.children?S.children.map(l.to):[],b}}return d.map(l.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(m=>L.Position.isPosition(m)),d=>d.map(g.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(m=>{let l;for(const v of m.reverse())l=new L.SelectionRange(g.Range.to(v),l);return l}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>{const m=[];if(Array.isArray(d))for(let l of d)m.push(...l[1].map(g.WorkspaceSymbol.to));return m})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return g.WorkspaceEdit.to(d)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(g.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new L.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,y.decodeSemanticTokensDto)(d);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new L.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,y.decodeSemanticTokensDto)(d);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,m,l)=>{if(!d)return new L.CompletionList([]);const v=d.suggestions.map(S=>g.CompletionItem.to(S,l));return new L.CompletionList(v,d.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return g.SignatureHelp.to(d)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,m,l)=>n(v=>new L.CodeLens(g.Range.to(v.range),v.command&&l.fromInternal(v.command)))(d))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>L.Range.isRange(d),d=>L.Selection.isSelection(d)?g.Selection.from(d):g.Range.from(d)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,m,l)=>n(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const S=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=g.WorkspaceEdit.to(v.edit)),v.command&&(S.command=l.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(d))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(m=>new L.ColorInformation(g.Range.to(m.range),g.Color.to(m.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",d=>d instanceof L.Color,g.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:g.Range.from(d.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(g.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",d=>d.map(g.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(m=>g.NotebookExclusiveDocumentPattern.to(m))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(g.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to)))];class I{static register(m){_.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=I;function n(d){return m=>{if(Array.isArray(m))return m.map(d)}}function A(d){if(!Array.isArray(d))return;const m=[];for(const l of d)k.isLocationLink(l)?m.push(g.DefinitionLink.to(l)):m.push(g.location.to(l));return m}}),define(ge[232],pe([0,1,17,56,3,6,2,81,26,15,7,5]),function(J,e,g,L,k,C,T,y,_,I,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function d(m,l,v){const S=m.getProxy(A.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const a=this._commentControllers.get(i.handle);return a||i}else if(i&&i.$mid===7){const a=this._commentControllers.get(i.commentControlHandle);if(!a)return i;const h=a.getCommentThread(i.commentThreadHandle);return h||i}else if(i&&i.$mid===8){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const h=a.getCommentThread(i.thread.commentThreadHandle);return h?{thread:h,text:i.text}:i}else if(i&&i.$mid===9){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const h=a.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let u=i.commentUniqueId,w=h.getCommentByUniqueId(u);return w||i}else if(i&&i.$mid===10){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const h=a.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let u=i.text,w=i.commentUniqueId,E=h.getCommentByUniqueId(w);return E?(E.body=u,E):i}return i}})}createCommentController(i,a,h){const u=b.handlePool++,w=new c(i,u,a,h);this._commentControllers.set(w.handle,w);const E=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(i.identifier))||[];return E.push(w),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(i.identifier),E),w.value}$createCommentThreadTemplate(i,a,h){const u=this._commentControllers.get(i);!u||u.$createCommentThreadTemplate(a,h)}async $updateCommentThreadTemplate(i,a,h){const u=this._commentControllers.get(i);!u||u.$updateCommentThreadTemplate(a,h)}$deleteCommentThread(i,a){const h=this._commentControllers.get(i);h&&h.$deleteCommentThread(a)}$provideCommentingRanges(i,a,h){const u=this._commentControllers.get(i);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(T.URI.revive(a));return(0,g.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(w,h)).then(E=>E?E.map(s=>I.Range.from(s)):void 0)}$toggleReaction(i,a,h,u,w){const E=this._commentControllers.get(i);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const s=E.getCommentThread(a);if(s){const D=s.getCommentByUniqueId(u.uniqueIdInThread);if(E!==void 0&&D&&E.reactionHandler)return E.reactionHandler(D,t(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class P{constructor(i,a,h,u,w,E,s){this._commentControllerHandle=a,this._id=h,this._uri=u,this._range=w,this._comments=E,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),S.$createCommentThread(a,this.handle,this._id,this._uri,I.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(a,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(R){D.range=R},get comments(){return D.comments},set comments(R){D.comments=R},get collapsibleState(){return D.collapsibleState},set collapsibleState(R){D.collapsibleState=R},get canReply(){return D.canReply},set canReply(R){D.canReply=R},get contextValue(){return D.contextValue},set contextValue(R){D.contextValue=R},get label(){return D.label},set label(R){D.label=R},dispose:()=>{D.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const i=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),a={};i("range")&&(a.range=I.Range.from(this._range)),i("label")&&(a.label=this.label),i("contextValue")&&(a.contextValue=this.contextValue),i("comments")&&(a.comments=this._comments.map(h=>f(this,h,this._commentsMap))),i("collapsibleState")&&(a.collapseState=r(this._collapseState)),i("canReply")&&(a.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(i){for(let a of this._commentsMap){let h=a[0],u=a[1];if(i===u)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}P._handlePool=0,ze([(0,L.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(i,a,h,u){this._extension=i,this._handle=a,this._id=h,this._label=u,this._threads=new Map,S.$registerCommentController(this.handle,h,u);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,s,D){return w.createCommentThread(E,s,D).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,a,h,u){if(typeof i=="string"){const w=new P(this.id,this.handle,i,a,h,u,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new P(this.id,this.handle,void 0,i,a,h,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,a){const h=new P(this.id,this.handle,void 0,T.URI.revive(i),I.Range.to(a),[],this._extension.identifier);return h.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(i,a){let h=this._threads.get(i);h&&(h.range=I.Range.to(a))}$deleteCommentThread(i){let a=this._threads.get(i);a&&a.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function f(o,i,a){let h=a.get(i);h||(h=++o.commentHandle,a.set(i,h));const u=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:h,body:I.MarkdownString.from(i.body),userName:i.author.name,userIconPath:u,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>p(w)):void 0}}function p(o){return{label:o.label,iconPath:o.iconPath?I.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function t(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?T.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function r(o){if(o!==void 0)switch(o){case n.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=d}),define(ge[131],pe([0,1,2,5,7,4,13,12,20,8,9]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class wn{constructor(m,l){this._logService=l,this._provider=new Map,this._proxy=m.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,l){const v=wn._handlePool++;this._provider.set(v,{provider:m,extensionId:l}),this._proxy.$registerDecorationProvider(v,l.value);const S=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(v,null);return}let P=(0,_.asArray)(b);if(P.length<=wn._maxEventSize){this._proxy.$onDidChange(v,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,P.length);const c=P.map(t=>({uri:t,rank:(0,I.count)(t.path,"/")})),f=(0,_.groupBy)(c,(t,r)=>t.rank-r.rank||(0,I.compare)(t.uri.path,r.uri.path));let p=[];e:for(let t of f){let r;for(let o of t){let i=(0,n.dirname)(o.uri.path);if(r!==i&&(r=i,p.push(o.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new k.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(m,l,v){if(!this._provider.has(m))return Object.create(null);const S=Object.create(null),{provider:b,extensionId:P}=this._provider.get(m);return await Promise.all(l.map(async c=>{try{const{uri:f,id:p}=c,t=await Promise.resolve(b.provideFileDecoration(g.URI.revive(f),v));if(!t)return;try{k.FileDecoration.validate(t),S[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${P.value}': ${r}`)}}catch(f){this._logService.error(f)}})),S}};A._handlePool=0,A._maxEventSize=250,A=ze([$e(0,T.IExtHostRpcService),$e(1,y.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")}),define(ge[233],pe([0,1,163,117,2,5,7,15,3,12,22]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class A{constructor(l,v,S,b,P){this._name=l,this._owner=v,this._maxDiagnosticsPerFile=S,this._proxy=b,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,v){if(!l){this.clear();return}this._checkDisposed();let S=[];if(k.URI.isUri(l)){if(!v){this.delete(l);return}this._data.set(l,v.slice()),S=[l]}else if(Array.isArray(l)){S=[];let P;l=[...l].sort(A._compareIndexedTuplesByUri);for(const c of l){const[f,p]=c;if((!P||f.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=f,S.push(f),this._data.set(f,[])),p){const t=this._data.get(f);t&&t.push(...p)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!this._proxy)return;const b=[];for(let P of S){let c=[];const f=this._data.get(P);if(f)if(f.length>this._maxDiagnosticsPerFile){c=[];const p=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of f)if(r.severity===p[t]&&c.push(y.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;c.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=f.map(p=>y.Diagnostic.from(p));b.push([P,c])}this._proxy.$changeMany(this._owner,b)}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,v){this._checkDisposed();for(let S of this._data.keys())l.apply(v,[S,this.get(S),this])}get(l){this._checkDisposed();const v=this._data.get(l);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,v){return l[0].toString()<v[0].toString()?-1:l[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=A;let d=class Qt{constructor(l,v){this._logService=v,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=l.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(l){const v=new n.ResourceMap;for(const S of l)v.set(S,S);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(l,v){const{_collections:S,_proxy:b,_onDidChangeDiagnostics:P,_logService:c}=this,f=new class{$changeMany(r,o){b.$changeMany(r,o),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,r,o.length===0?"CLEARING":o)}$clear(r){b.$clear(r),c.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,r)}dispose(){b.dispose()}};let p;if(!v)v="_generated_diagnostic_collection_name_#"+Qt._idPool++,p=v;else if(!S.has(v))p=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do p=v+Qt._idPool++;while(S.has(p))}return new class extends A{constructor(){super(v,p,Qt._maxDiagnosticsPerFile,f,P);S.set(p,this)}dispose(){super.dispose(),S.delete(p)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const v=new Map,S=[];for(const b of this._collections.values())b.forEach((P,c)=>{let f=v.get(P.toString());typeof f=="undefined"&&(f=S.length,v.set(P.toString(),f),S.push([P,[]])),S[f][1]=S[f][1].concat(...c)});return S}}_getDiagnostics(l){let v=[];for(let S of this._collections.values())S.has(l)&&(v=v.concat(S.get(l)));return v}$acceptMarkersChange(l){if(!this._mirrorCollection){const v="_generated_mirror",S=new A(v,v,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(v,S),this._mirrorCollection=S}for(const[v,S]of l)this._mirrorCollection.set(k.URI.revive(v),S.map(y.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([$e(1,I.ILogService)],d),e.ExtHostDiagnostics=d}),define(ge[234],pe([0,1,2,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(y=>y?y.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=k}),define(ge[235],pe([0,1,16,2,7,5,10,21,8]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(A,d,m){this._documentsAndEditors=d,this._logService=m,this._documentContentProviders=new Map,this._proxy=A.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,d){if(Object.keys(T.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const m=I._handlePool++;this._documentContentProviders.set(m,d),this._proxy.$registerTextContentProvider(m,A);let l;return typeof d.onDidChange=="function"&&(l=d.onDidChange(v=>{if(v.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(m,v).then(S=>{if(!S&&typeof S!="string")return;const b=this._documentsAndEditors.getDocument(v);if(!b)return;const P=(0,_.splitLines)(S);if(!b.equalLines(P))return this._proxy.$onVirtualDocumentChange(v,S)},g.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(A,d){const m=this._documentContentProviders.get(A);return m?Promise.resolve(m.provideTextDocumentContent(L.URI.revive(d),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(ge[236],pe([0,1,3,6,2,5,123,15,14,25,7]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(m,l){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const S of v)this._onDidRemoveDocument.fire(S.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const S of v)this._onDidAddDocument.fire(S.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const l=this._documentsAndEditors.getDocument(m);if(l)return l}getDocument(m){const l=this.getDocumentData(m);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return l.document}ensureDocumentData(m){const l=this._documentsAndEditors.getDocument(m);if(l)return Promise.resolve(l);let v=this._documentLoader.get(m.toString());return v||(v=this._proxy.$tryOpenDocument(m).then(S=>{this._documentLoader.delete(m.toString());const b=k.URI.revive(S);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(b))},S=>(this._documentLoader.delete(m.toString()),Promise.reject(S))),this._documentLoader.set(m.toString(),v)),v}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(l=>k.URI.revive(l))}$acceptModelModeChanged(m,l){const v=k.URI.revive(m),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(l),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(m){const l=k.URI.revive(m),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(m,l){const v=k.URI.revive(m),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");S._acceptIsDirty(l),this._onDidChangeDocument.fire({document:S.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,l,v){const S=k.URI.revive(m),b=this._documentsAndEditors.getDocument(S);if(!b)throw new Error("unknown document");b._acceptIsDirty(v),b.onEvents(l);let P;l.isUndoing?P=n.TextDocumentChangeReason.Undo:l.isRedoing&&(P=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:b.document,contentChanges:l.changes.map(c=>({range:y.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:P}))}setWordDefinitionFor(m,l){(0,T.setWordDefinitionFor)(m,l)}}e.ExtHostDocuments=A}),define(ge[45],pe([0,1,54,3,6,2,4,5,123,13,129,15,12,22,10,74,139]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(f,p){this._extHostRpc=f,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const p=[],t=[],r=[];if(f.removedDocuments)for(const o of f.removedDocuments){const i=C.URI.revive(o),a=this._documents.get(i);a?.unref()&&(this._documents.delete(i),p.push(a.value))}if(f.addedDocuments)for(const o of f.addedDocuments){const i=C.URI.revive(o.uri);let a=this._documents.get(i);if(a&&i.scheme!==l.Schemas.vscodeNotebookCell&&i.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);a||(a=new b(new _.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(i,a),t.push(a.value)),a.ref()}if(f.removedEditors)for(const o of f.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&r.push(i)}if(f.addedEditors)for(const o of f.addedEditors){const i=C.URI.revive(o.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const a=this._documents.get(i).value,h=new n.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>a.document),o.selections.map(A.Selection.to),o.options,o.visibleRanges.map(u=>A.Range.to(u)),typeof o.editorPosition=="number"?A.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,h)}f.newActiveEditor!==void 0&&(g.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(r),f.removedDocuments&&this._onDidRemoveDocuments.fire(p),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return f?p:p?.value}allEditors(){return[...this._editors.values()]}};P=ze([$e(0,I.IExtHostRpcService),$e(1,d.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[237],pe([0,1,2,5,6,7,15,147,8,24]),function(J,e,g,L,k,C,T,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const l=this._schemes.indexOf(m);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),l=[];let v,S,b=14,P=14;for(const c of m){let f=v?(0,_.commonPrefixLength)(v,c):0;for(f===0?S=1:S=P;f<c.length;f++)f+1===c.length?(b=P,P=9):P+=1,l.push([S,c.toUpperCase().charCodeAt(f),P]),l.push([S,c.toLowerCase().charCodeAt(f),P]),S=P;v=c,P=b}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new y.StateMachine(l)}}provideDocumentLinks(m){this._initStateMachine();const l=[],v=y.LinkComputer.computeLinks({getLineContent(S){return m.lineAt(S-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const S of v){const b=T.DocumentLink.to(S);b.target&&l.push(b)}return l}}class A{constructor(m,l){this._extHostLanguageFeatures=l,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,l,v,S={},b){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(P,v),this._enableProposedApi.set(P,b??!1);let c=2;S.isCaseSensitive&&(c+=1024),S.isReadonly&&(c+=2048),typeof v.copy=="function"&&(c+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(P,l,c).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${l}`),console.error(p)});const f=v.onDidChangeFile(p=>{const t=[];for(const r of p){let{uri:o,type:i}=r;if(o.scheme!==l)continue;let a;switch(i){case C.FileChangeType.Changed:a=0;break;case C.FileChangeType.Created:a=1;break;case C.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:o,type:a})}this._proxy.$onFileSystemChange(P,t)});return(0,k.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(m,l){const{type:v,ctime:S,mtime:b,size:P,permissions:c}=m;return l?{type:v,ctime:S,mtime:b,size:P,permissions:c}:{type:v,ctime:S,mtime:b,size:P}}$stat(m,l){return Promise.resolve(this._getFsProvider(m).stat(g.URI.revive(l))).then(v=>A._asIStat(v,this._enableProposedApi.get(m)??!1))}$readdir(m,l){return Promise.resolve(this._getFsProvider(m).readDirectory(g.URI.revive(l)))}$readFile(m,l){return Promise.resolve(this._getFsProvider(m).readFile(g.URI.revive(l))).then(v=>I.VSBuffer.wrap(v))}$writeFile(m,l,v,S){return Promise.resolve(this._getFsProvider(m).writeFile(g.URI.revive(l),v.buffer,S))}$delete(m,l,v){return Promise.resolve(this._getFsProvider(m).delete(g.URI.revive(l),v))}$rename(m,l,v,S){return Promise.resolve(this._getFsProvider(m).rename(g.URI.revive(l),g.URI.revive(v),S))}$copy(m,l,v,S){const b=this._getFsProvider(m);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(l),g.URI.revive(v),S))}$mkdir(m,l){return Promise.resolve(this._getFsProvider(m).createDirectory(g.URI.revive(l)))}$watch(m,l,v,S){const b=this._getFsProvider(m).watch(g.URI.revive(v),S);this._watches.set(l,b)}$unwatch(m,l){const v=this._watches.get(l);v&&(v.dispose(),this._watches.delete(l))}$open(m,l,v){const S=this._getFsProvider(m);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(g.URI.revive(l),v))}$close(m,l){const v=this._getFsProvider(m);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(l))}$read(m,l,v,S){const b=this._getFsProvider(m);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const P=I.VSBuffer.alloc(S);return Promise.resolve(b.read(l,v,P.buffer,0,S)).then(c=>P.slice(0,c))}$write(m,l,v,S){const b=this._getFsProvider(m);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(l,v,S.buffer,0,S.byteLength))}_getFsProvider(m){const l=this._fsProvider.get(m);if(!l){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return l}}e.ExtHostFileSystem=A}),define(ge[92],pe([0,1,5,42,7,24,4,13,62]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Ut{constructor(A,d){const m=A.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return m.$stat(l).catch(Ut._handleError)},readDirectory(l){return m.$readdir(l).catch(Ut._handleError)},createDirectory(l){return m.$mkdir(l).catch(Ut._handleError)},async readFile(l){return m.$readFile(l).then(v=>v.buffer).catch(Ut._handleError)},writeFile(l,v){return m.$writeFile(l,C.VSBuffer.wrap(v)).catch(Ut._handleError)},delete(l,v){return m.$delete(l,{recursive:!1,useTrash:!1,...v}).catch(Ut._handleError)},rename(l,v,S){return m.$rename(l,v,{overwrite:!1,...S}).catch(Ut._handleError)},copy(l,v,S){return m.$copy(l,v,{overwrite:!1,...S}).catch(Ut._handleError)},isWritableFileSystem(l){const v=d.getCapabilities(l);if(typeof v=="number")return!(v&2048)}})}static _handleError(A){if(!(A instanceof Error))throw new k.FileSystemError(String(A));if(A.name==="ENOPRO")throw k.FileSystemError.Unavailable(A.message);switch(A.name){case L.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(A.message);case L.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(A.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(A.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(A.message);case L.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(A.message);case L.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(A.message);default:throw new k.FileSystemError(A.message,A.name)}}};I=ze([$e(0,y.IExtHostRpcService),$e(1,_.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[238],pe([0,1,2,44]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,y,_,I){this._extHostNotebooks=y,this._textDocumentsAndEditors=_,this._commands=I;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",A=>!0,A=>A),new L.ApiCommandArgument("resource","Interactive resource Uri",A=>!0,A=>A),new L.ApiCommandArgument("controllerId","Notebook controller Id",A=>!0,A=>A),new L.ApiCommandArgument("title","Interactive editor title",A=>!0,A=>A)],new L.ApiCommandResult("Notebook and input URI",A=>{if(A.notebookEditorId!==void 0){const d=this._extHostNotebooks.getEditorById(A.notebookEditorId);return{notebookUri:g.URI.revive(A.notebookUri),inputUri:g.URI.revive(A.inputUri),notebookEditor:d.apiEditor}}return{notebookUri:g.URI.revive(A.notebookUri),inputUri:g.URI.revive(A.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(T,y,_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:y,lines:[""],modeId:_,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(ge[239],pe([0,1,6,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=k}),define(ge[240],pe([0,1,2,25,15,7,5,8,41,20,14,144,6,111,73,86,46,16,3]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentSymbols(W,Z){const ne=this._documents.getDocument(W),ae=await this._provider.provideDocumentSymbols(ne,Z);if(!(0,I.isFalsyOrEmpty)(ae))return ae[0]instanceof C.DocumentSymbol?ae.map(k.DocumentSymbol.from):c._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((ae,Y)=>{let oe=ae.location.range.start.compareTo(Y.location.range.start);return oe===0&&(oe=Y.location.range.end.compareTo(ae.location.range.end)),oe});const Z=[],ne=[];for(const ae of W){const Y={name:ae.name||"!!MISSING: name!!",kind:k.SymbolKind.from(ae.kind),tags:ae.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:k.Range.from(ae.location.range),selectionRange:k.Range.from(ae.location.range),children:[]};for(;;){if(ne.length===0){ne.push(Y),Z.push(Y);break}const oe=ne[ne.length-1];if(_.Range.containsRange(oe.range,Y.range)&&!_.Range.equalsRange(oe.range,Y.range)){oe.children&&oe.children.push(Y),ne.push(Y);break}ne.pop()}}return Z}}class f{constructor(W,Z,ne){this._documents=W,this._commands=Z,this._provider=ne,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Z){const ne=this._documents.getDocument(W),ae=await this._provider.provideCodeLenses(ne,Z);if(!ae||Z.isCancellationRequested)return;const Y=this._cache.add(ae),oe=new d.DisposableStore;this._disposables.set(Y,oe);const we={cacheId:Y,lenses:[]};for(let Me=0;Me<ae.length;Me++)we.lenses.push({cacheId:[Y,Me],range:k.Range.from(ae[Me].range),command:this._commands.toInternal(ae[Me].command,oe)});return we}async resolveCodeLens(W,Z){const ne=W.cacheId&&this._cache.get(...W.cacheId);if(!ne)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?ae=ne:ae=await this._provider.resolveCodeLens(ne,Z),ae||(ae=ne),Z.isCancellationRequested)return;const Y=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!Y)return W.command=this._commands.toInternal(ae.command??f._badCmd,Y),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(k.DefinitionLink.from):je?[k.DefinitionLink.from(je)]:[]}class t{constructor(W,Z){this._documents=W,this._provider=Z}async provideDefinition(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideDefinition(ae,Y,ne);return p(oe)}}class r{constructor(W,Z){this._documents=W,this._provider=Z}async provideDeclaration(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideDeclaration(ae,Y,ne);return p(oe)}}class o{constructor(W,Z){this._documents=W,this._provider=Z}async provideImplementation(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideImplementation(ae,Y,ne);return p(oe)}}class i{constructor(W,Z){this._documents=W,this._provider=Z}async provideTypeDefinition(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideTypeDefinition(ae,Y,ne);return p(oe)}}class a{constructor(W,Z){this._documents=W,this._provider=Z}async provideHover(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideHover(ae,Y,ne);if(!(!oe||(0,I.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(Y)),oe.range||(oe.range=new C.Range(Y,Y)),k.Hover.from(oe)}}class h{constructor(W,Z){this._documents=W,this._provider=Z}async provideEvaluatableExpression(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideEvaluatableExpression(ae,Y,ne);if(oe)return k.EvaluatableExpression.from(oe)}}class u{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlineValues(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=await this._provider.provideInlineValues(Y,k.Range.to(Z),k.InlineValueContext.to(ne),ae);if(Array.isArray(oe))return oe.map(we=>k.InlineValue.from(we))}}class w{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentHighlights(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideDocumentHighlights(ae,Y,ne);if(Array.isArray(oe))return oe.map(k.DocumentHighlight.from)}}class E{constructor(W,Z){this._documents=W,this._provider=Z}async provideLinkedEditingRanges(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.provideLinkedEditingRanges(ae,Y,ne);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,I.coalesce)(oe.ranges.map(k.Range.from)),wordPattern:oe.wordPattern}}}class s{constructor(W,Z){this._documents=W,this._provider=Z}async provideReferences(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=k.Position.to(Z),we=await this._provider.provideReferences(Y,oe,ne,ae);if(Array.isArray(we))return we.map(k.location.from)}}class D{constructor(W,Z,ne,ae,Y,oe,we){this._documents=W,this._commands=Z,this._diagnostics=ne,this._provider=ae,this._logService=Y,this._extension=oe,this._apiDeprecation=we,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=A.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),we=[];for(const re of this._diagnostics.getDiagnostics(W))if(oe.intersection(re.range)&&we.push(re)>D._maxCodeActionsPerFile)break;const Me={diagnostics:we,only:ne.only?new C.CodeActionKind(ne.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ne.trigger)},Ve=await this._provider.provideCodeActions(Y,oe,Me,ae);if(!(0,I.isNonEmptyArray)(Ve)||ae.isCancellationRequested)return;const _e=this._cache.add(Ve),Je=new d.DisposableStore;this._disposables.set(_e,Je);const X=[];for(let re=0;re<Ve.length;re++){const me=Ve[re];!me||(D._isCommand(me)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),X.push({_isSynthetic:!0,title:me.title,command:this._commands.toInternal(me,Je)})):(Me.only&&(me.kind?Me.only.contains(me.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${me.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),X.push({cacheId:[_e,re],title:me.title,command:me.command&&this._commands.toInternal(me.command,Je),diagnostics:me.diagnostics&&me.diagnostics.map(k.Diagnostic.from),edit:me.edit&&k.WorkspaceEdit.from(me.edit),kind:me.kind&&me.kind.value,isPreferred:me.isPreferred,disabled:me.disabled?.reason})))}return{cacheId:_e,actions:X}}async resolveCodeAction(W,Z){const[ne,ae]=W,Y=this._cache.get(ne,ae);if(!Y||D._isCommand(Y)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Y,Z)??Y;return oe?.edit?k.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}D._maxCodeActionsPerFile=1e3;class R{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentFormattingEdits(W,Z,ne){const ae=this._documents.getDocument(W),Y=await this._provider.provideDocumentFormattingEdits(ae,Z,ne);if(Array.isArray(Y))return Y.map(k.TextEdit.from)}}class U{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeFormattingEdits(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=k.Range.to(Z),we=await this._provider.provideDocumentRangeFormattingEdits(Y,oe,ne,ae);if(Array.isArray(we))return we.map(k.TextEdit.from)}}class V{constructor(W,Z){this._documents=W,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Z,ne,ae,Y){const oe=this._documents.getDocument(W),we=k.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(oe,we,ne,ae,Y);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class ee{constructor(W,Z){this._provider=W,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,Z){const ne=T.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(W,Z);if((0,I.isNonEmptyArray)(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const oe=T.IdObject.mixin(k.WorkspaceSymbol.from(Y));this._symbolCache.set(oe._id,Y),ne.symbols.push(oe)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(W,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const ne=this._symbolCache.get(W._id);if(ne){const ae=await this._provider.resolveWorkspaceSymbol(ne,Z);return ae&&(0,L.mixin)(W,k.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(W){const Z=this._resultCache.get(W);if(Z){for(let[ne,ae]=Z;ne<=ae;ne++)this._symbolCache.delete(ne);this._resultCache.delete(W)}}}class Q{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=k.Position.to(Z);try{const we=await this._provider.provideRenameEdits(Y,oe,ne,ae);return we?k.WorkspaceEdit.from(we):void 0}catch(we){const Me=Q._asMessage(we);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(W,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(W),Y=k.Position.to(Z);try{const oe=await this._provider.prepareRename(ae,Y,ne);let we,Me;if(C.Range.isRange(oe)?(we=oe,Me=ae.getText(oe)):(0,n.isObject)(oe)&&(we=oe.range,Me=oe.placeholder),!we||!Me)return;if(we.start.line>Y.line||we.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(we),text:Me}}catch(oe){const we=Q._asMessage(oe);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class O{constructor(W,Z){this.resultId=W,this.tokens=Z}}class x{constructor(W,Z){this._documents=W,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,Z,ne){const ae=this._documents.getDocument(W),Y=Z!==0?this._previousResults.get(Z):null;let oe=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,ne):await this._provider.provideDocumentSemanticTokens(ae,ne);return Y&&this._previousResults.delete(Z),oe?(oe=x._fixProvidedSemanticTokens(oe),this._send(x._convertToEdits(Y,oe),oe)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return x._isSemanticTokens(W)?x._isCorrectSemanticTokens(W)?W:new C.SemanticTokens(new Uint32Array(W.data),W.resultId):x._isSemanticTokensEdits(W)?x._isCorrectSemanticTokensEdits(W)?W:new C.SemanticTokensEdits(W.edits.map(Z=>new C.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Z of W.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Z){if(!x._isSemanticTokens(Z)||!W||!W.tokens)return Z;const ne=W.tokens,ae=ne.length,Y=Z.data,oe=Y.length;let we=0;const Me=Math.min(ae,oe);for(;we<Me&&ne[we]===Y[we];)we++;if(we===ae&&we===oe)return new C.SemanticTokensEdits([],Z.resultId);let Ve=0;const _e=Me-we;for(;Ve<_e&&ne[ae-Ve-1]===Y[oe-Ve-1];)Ve++;return new C.SemanticTokensEdits([{start:we,deleteCount:ae-we-Ve,data:Y.subarray(we,oe-Ve)}],Z.resultId)}_send(W,Z){if(x._isSemanticTokens(W)){const ne=this._nextResultId++;return this._previousResults.set(ne,new O(W.resultId,W.data)),(0,m.encodeSemanticTokensDto)({id:ne,type:"full",data:W.data})}if(x._isSemanticTokensEdits(W)){const ne=this._nextResultId++;return x._isSemanticTokens(Z)?this._previousResults.set(ne,new O(Z.resultId,Z.data)):this._previousResults.set(ne,new O(W.resultId)),(0,m.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(W.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class F{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeSemanticTokens(W,Z,ne){const ae=this._documents.getDocument(W),Y=await this._provider.provideDocumentRangeSemanticTokens(ae,k.Range.to(Z),ne);return Y?this._send(Y):null}_send(W){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=F;class z{constructor(W,Z,ne,ae,Y){this._documents=W,this._commands=Z,this._provider=ne,this._apiDeprecation=ae,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=k.Position.to(Z),we=Y.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=we.with({end:oe}),Ve=new S.StopWatch(!0),_e=await this._provider.provideCompletionItems(Y,oe,ae,k.CompletionContext.to(ne));if(!_e||ae.isCancellationRequested)return;const Je=Array.isArray(_e)?new C.CompletionList(_e):_e,X=z.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),re=new d.DisposableStore;this._disposables.set(X,re);const me=[],xe={x:X,b:me,a:{replace:k.Range.from(we),insert:k.Range.from(Me)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let Be=0;Be<Je.items.length;Be++){const et=Je.items[Be],ke=this._convertCompletionItem(et,[X,Be],Me,we);me.push(ke)}return xe}async resolveCompletionItem(W,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...W);if(!ne)return;const ae=await this._provider.resolveCompletionItem(ne,Z);if(!!ae)return this._convertCompletionItem(ae,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Z,ne,ae){const Y=this._disposables.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const oe={x:Z,a:W.label,b:W.kind!==void 0?k.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(k.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(W.command,Y)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=W.textEdit.newText):typeof W.insertText=="string"?oe.h=W.insertText:W.insertText instanceof C.SnippetString&&(oe.h=W.insertText.value,oe.i|=4);let we;return W.textEdit?we=W.textEdit.range:W.range&&(we=W.range),C.Range.isRange(we)?oe.j=k.Range.from(we):we&&(!ne?.isEqual(we.inserting)||!ae?.isEqual(we.replacing))&&(oe.j={insert:k.Range.from(we.inserting),replace:k.Range.from(we.replacing)}),oe}}class M{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._commands=ne,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=k.Position.to(Z),we=await this._provider.provideInlineCompletionItems(Y,oe,ne,ae);if(!we||ae.isCancellationRequested)return;const Me=(0,n.isArray)(we)?{items:we}:we,Ve=this._cache.add(Me.items);let _e;return{pid:Ve,items:Me.items.map((Je,X)=>{let re;return Je.command&&(_e||(_e=new d.DisposableStore,this._disposables.set(Ve,_e)),re=this._commands.toInternal(Je.command,_e)),{text:Je.text,range:Je.range?k.Range.from(Je.range):void 0,command:re,idx:X}})}}disposeCompletions(W){this._cache.delete(W);const Z=this._disposables.get(W);Z&&Z.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Z){const ne=this._cache.get(W,Z);ne&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Z=N.map.get(W);return Z||(Z=new N,N.map.set(W,Z)),Z}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=N,N.map=new WeakMap;class q{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(W,Z,ne,ae){const Y=this._documents.getDocument(W),oe=k.Position.to(Z),we=this.reviveContext(ne),Me=await this._provider.provideSignatureHelp(Y,oe,ae,we);if(Me){const Ve=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:Ve}}}reviveContext(W){let Z;if(W.activeSignatureHelp){const ne=k.SignatureHelp.to(W.activeSignatureHelp),ae=this._cache.get(W.activeSignatureHelp.id,0);ae?(Z=ae,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return{...W,activeSignatureHelp:Z}}releaseSignatureHelp(W){this._cache.delete(W)}}class B{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlayHints(W,Z,ne){const ae=this._documents.getDocument(W),Y=await this._provider.provideInlayHints(ae,k.Range.to(Z),ne);return Y?{hints:Y.map(k.InlayHint.from)}:void 0}}class K{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(W,Z){const ne=this._documents.getDocument(W),ae=await this._provider.provideDocumentLinks(ne,Z);if(!(!Array.isArray(ae)||ae.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(K._validateLink).map(k.DocumentLink.from)};{const Y=this._cache.add(ae),oe={links:[],id:Y};for(let we=0;we<ae.length;we++){if(!K._validateLink(ae[we]))continue;const Me=k.DocumentLink.from(ae[we]);Me.cacheId=[Y,we],oe.links.push(Me)}return oe}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...W);if(!ne)return;const ae=await this._provider.resolveDocumentLink(ne,Z);if(!(!ae||!K._validateLink(ae)))return k.DocumentLink.from(ae)}releaseLinks(W){this._cache.delete(W)}}class te{constructor(W,Z){this._documents=W,this._provider=Z}async provideColors(W,Z){const ne=this._documents.getDocument(W),ae=await this._provider.provideDocumentColors(ne,Z);return Array.isArray(ae)?ae.map(oe=>({color:k.Color.from(oe.color),range:k.Range.from(oe.range)})):[]}async provideColorPresentations(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Range.to(Z.range),oe=k.Color.to(Z.color),we=await this._provider.provideColorPresentations(oe,{document:ae,range:Y},ne);if(!!Array.isArray(we))return we.map(k.ColorPresentation.from)}}class he{constructor(W,Z){this._documents=W,this._provider=Z}async provideFoldingRanges(W,Z,ne){const ae=this._documents.getDocument(W),Y=await this._provider.provideFoldingRanges(ae,Z,ne);if(!!Array.isArray(Y))return Y.map(k.FoldingRange.from)}}class De{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}async provideSelectionRanges(W,Z,ne){const ae=this._documents.getDocument(W),Y=Z.map(k.Position.to),oe=await this._provider.provideSelectionRanges(ae,Y,ne);if(!(0,I.isNonEmptyArray)(oe))return[];if(oe.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let Me=0;Me<Y.length;Me++){const Ve=[];we.push(Ve);let _e=Y[Me],Je=oe[Me];for(;;){if(!Je.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(k.SelectionRange.from(Je)),!Je.parent)break;_e=Je.range,Je=Je.parent}}return we}}class Pe{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.prepareCallHierarchy(ae,Y,ne);if(!oe)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,oe)]}async provideCallsTo(W,Z,ne){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,ne);if(!!Y)return Y.map(oe=>({from:this._cacheAndConvertItem(W,oe.from),fromRanges:oe.fromRanges.map(we=>k.Range.from(we))}))}async provideCallsFrom(W,Z,ne){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,ne);if(!!Y)return Y.map(oe=>({to:this._cacheAndConvertItem(W,oe.to),fromRanges:oe.fromRanges.map(we=>k.Range.from(we))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),ae=k.CallHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(ae._itemId,Z),ae}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Fe{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const ae=this._documents.getDocument(W),Y=k.Position.to(Z),oe=await this._provider.prepareTypeHierarchy(ae,Y,ne);if(!oe)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,oe)]}async provideSupertypes(W,Z,ne){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(ae,ne);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(W,oe))}async provideSubtypes(W,Z,ne){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(ae,ne);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(W,oe))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),ae=k.TypeHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(ae._itemId,Z),ae}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class qe{constructor(W,Z){this.adapter=W,this.extension=Z}}class We{constructor(W,Z,ne,ae,Y,oe,we){this._adapter=new Map,this._uriTransformer=Z,this._proxy=W.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=ae,this._diagnostics=Y,this._logService=oe,this._apiDeprecation=we}_transformDocumentSelector(W){return(0,I.coalesce)((0,I.asArray)(W).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:k.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new C.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return We._handlePool++}_withAdapter(W,Z,ne,ae,Y=!1){const oe=this._adapter.get(W);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Z){let we;oe.extension&&(we=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=ne(oe.adapter,oe.extension),Ve=oe.extension;return Ve&&Promise.resolve(Me).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-we}ms`),_e=>{Y&&_e instanceof b.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(_e))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Z){const ne=this._nextHandle();return this._adapter.set(ne,new qe(W,Z)),ne}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Z,ne,ae){const Y=this._addNewAdapter(new c(this._documents,ne),W),oe=ae&&ae.label||We._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),oe),this._createDisposable(Y)}$provideDocumentSymbols(W,Z,ne){return this._withAdapter(W,c,ae=>ae.provideDocumentSymbols(g.URI.revive(Z),ne),void 0)}registerCodeLensProvider(W,Z,ne){const ae=this._nextHandle(),Y=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new f(this._documents,this._commands.converter,ne),W)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Z),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const we=ne.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));oe=C.Disposable.from(oe,we)}return oe}$provideCodeLenses(W,Z,ne){return this._withAdapter(W,f,ae=>ae.provideCodeLenses(g.URI.revive(Z),ne),void 0)}$resolveCodeLens(W,Z,ne){return this._withAdapter(W,f,ae=>ae.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(W,Z){this._withAdapter(W,f,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(W,Z,ne){const ae=this._addNewAdapter(new t(this._documents,ne),W);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDefinition(W,Z,ne,ae){return this._withAdapter(W,t,Y=>Y.provideDefinition(g.URI.revive(Z),ne,ae),[])}registerDeclarationProvider(W,Z,ne){const ae=this._addNewAdapter(new r(this._documents,ne),W);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDeclaration(W,Z,ne,ae){return this._withAdapter(W,r,Y=>Y.provideDeclaration(g.URI.revive(Z),ne,ae),[])}registerImplementationProvider(W,Z,ne){const ae=this._addNewAdapter(new o(this._documents,ne),W);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideImplementation(W,Z,ne,ae){return this._withAdapter(W,o,Y=>Y.provideImplementation(g.URI.revive(Z),ne,ae),[])}registerTypeDefinitionProvider(W,Z,ne){const ae=this._addNewAdapter(new i(this._documents,ne),W);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideTypeDefinition(W,Z,ne,ae){return this._withAdapter(W,i,Y=>Y.provideTypeDefinition(g.URI.revive(Z),ne,ae),[])}registerHoverProvider(W,Z,ne,ae){const Y=this._addNewAdapter(new a(this._documents,ne),W);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(W,Z,ne,ae){return this._withAdapter(W,a,Y=>Y.provideHover(g.URI.revive(Z),ne,ae),void 0)}registerEvaluatableExpressionProvider(W,Z,ne,ae){const Y=this._addNewAdapter(new h(this._documents,ne),W);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(W,Z,ne,ae){return this._withAdapter(W,h,Y=>Y.provideEvaluatableExpression(g.URI.revive(Z),ne,ae),void 0)}registerInlineValuesProvider(W,Z,ne,ae){const Y=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new u(this._documents,ne),W);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Z),Y);let we=this._createDisposable(oe);if(Y!==void 0){const Me=ne.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(Y));we=C.Disposable.from(we,Me)}return we}$provideInlineValues(W,Z,ne,ae,Y){return this._withAdapter(W,u,oe=>oe.provideInlineValues(g.URI.revive(Z),ne,ae,Y),void 0)}registerDocumentHighlightProvider(W,Z,ne){const ae=this._addNewAdapter(new w(this._documents,ne),W);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentHighlights(W,Z,ne,ae){return this._withAdapter(W,w,Y=>Y.provideDocumentHighlights(g.URI.revive(Z),ne,ae),void 0)}registerLinkedEditingRangeProvider(W,Z,ne){const ae=this._addNewAdapter(new E(this._documents,ne),W);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideLinkedEditingRanges(W,Z,ne,ae){return this._withAdapter(W,E,async Y=>{const oe=await Y.provideLinkedEditingRanges(g.URI.revive(Z),ne,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?We._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Z,ne){const ae=this._addNewAdapter(new s(this._documents,ne),W);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideReferences(W,Z,ne,ae,Y){return this._withAdapter(W,s,oe=>oe.provideReferences(g.URI.revive(Z),ne,ae,Y),void 0)}registerCodeActionProvider(W,Z,ne,ae){const Y=new d.DisposableStore,oe=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Z),{providedKinds:ae?.providedCodeActionKinds?.map(we=>we.value),documentation:ae?.documentation?.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,Y)}))},We._extLabel(W),Boolean(ne.resolveCodeAction)),Y.add(this._createDisposable(oe)),Y}$provideCodeActions(W,Z,ne,ae,Y){return this._withAdapter(W,D,oe=>oe.provideCodeActions(g.URI.revive(Z),ne,ae,Y),void 0)}$resolveCodeAction(W,Z,ne){return this._withAdapter(W,D,ae=>ae.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(W,Z){this._withAdapter(W,D,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(W,Z,ne){const ae=this._addNewAdapter(new R(this._documents,ne),W);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(W,Z,ne,ae){return this._withAdapter(W,R,Y=>Y.provideDocumentFormattingEdits(g.URI.revive(Z),ne,ae),void 0)}registerDocumentRangeFormattingEditProvider(W,Z,ne){const ae=this._addNewAdapter(new U(this._documents,ne),W);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(W,Z,ne,ae,Y){return this._withAdapter(W,U,oe=>oe.provideDocumentRangeFormattingEdits(g.URI.revive(Z),ne,ae,Y),void 0)}registerOnTypeFormattingEditProvider(W,Z,ne,ae){const Y=this._addNewAdapter(new V(this._documents,ne),W);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),ae,W.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(W,Z,ne,ae,Y,oe){return this._withAdapter(W,V,we=>we.provideOnTypeFormattingEdits(g.URI.revive(Z),ne,ae,Y,oe),void 0)}registerWorkspaceSymbolProvider(W,Z){const ne=this._addNewAdapter(new ee(Z,this._logService),W);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(W,Z,ne){return this._withAdapter(W,ee,ae=>ae.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(W,Z,ne){return this._withAdapter(W,ee,ae=>ae.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(W,Z){this._withAdapter(W,ee,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(W,Z,ne){const ae=this._addNewAdapter(new Q(this._documents,ne,this._logService),W);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Z),Q.supportsResolving(ne)),this._createDisposable(ae)}$provideRenameEdits(W,Z,ne,ae,Y){return this._withAdapter(W,Q,oe=>oe.provideRenameEdits(g.URI.revive(Z),ne,ae,Y),void 0)}$resolveRenameLocation(W,Z,ne,ae){return this._withAdapter(W,Q,Y=>Y.resolveRenameLocation(g.URI.revive(Z),ne,ae),void 0)}registerDocumentSemanticTokensProvider(W,Z,ne,ae){const Y=this._nextHandle(),oe=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new qe(new x(this._documents,ne),W)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),ae,oe);let we=this._createDisposable(Y);if(oe){const Me=ne.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(oe));we=C.Disposable.from(we,Me)}return we}$provideDocumentSemanticTokens(W,Z,ne,ae){return this._withAdapter(W,x,Y=>Y.provideDocumentSemanticTokens(g.URI.revive(Z),ne,ae),null,!0)}$releaseDocumentSemanticTokens(W,Z){this._withAdapter(W,x,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(W,Z,ne,ae){const Y=this._addNewAdapter(new F(this._documents,ne),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(W,Z,ne,ae){return this._withAdapter(W,F,Y=>Y.provideDocumentRangeSemanticTokens(g.URI.revive(Z),ne,ae),null,!0)}registerCompletionItemProvider(W,Z,ne,ae){const Y=this._addNewAdapter(new z(this._documents,this._commands.converter,ne,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),ae,z.supportsResolving(ne),`${W.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(W,Z,ne,ae,Y){return this._withAdapter(W,z,oe=>oe.provideCompletionItems(g.URI.revive(Z),ne,ae,Y),void 0)}$resolveCompletionItem(W,Z,ne){return this._withAdapter(W,z,ae=>ae.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(W,Z){this._withAdapter(W,z,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(W,Z,ne){const ae=this._addNewAdapter(new M(this._documents,ne,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideInlineCompletions(W,Z,ne,ae,Y){return this._withAdapter(W,M,oe=>oe.provideInlineCompletions(g.URI.revive(Z),ne,ae,Y),void 0)}$handleInlineCompletionDidShow(W,Z,ne){this._withAdapter(W,M,async ae=>{ae.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(W,Z){this._withAdapter(W,M,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(W,Z,ne,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new q(this._documents,ne),W);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Z),Y),this._createDisposable(oe)}$provideSignatureHelp(W,Z,ne,ae,Y){return this._withAdapter(W,q,oe=>oe.provideSignatureHelp(g.URI.revive(Z),ne,ae,Y),void 0)}$releaseSignatureHelp(W,Z){this._withAdapter(W,q,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(W,Z,ne){const ae=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new B(this._documents,ne),W);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),ae);let oe=this._createDisposable(Y);if(ae!==void 0){const we=ne.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ae));oe=C.Disposable.from(oe,we)}return oe}$provideInlayHints(W,Z,ne,ae){return this._withAdapter(W,B,Y=>Y.provideInlayHints(g.URI.revive(Z),ne,ae),void 0)}registerDocumentLinkProvider(W,Z,ne){const ae=this._addNewAdapter(new K(this._documents,ne),W);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(W,Z,ne){return this._withAdapter(W,K,ae=>ae.provideLinks(g.URI.revive(Z),ne),void 0)}$resolveDocumentLink(W,Z,ne){return this._withAdapter(W,K,ae=>ae.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(W,Z){this._withAdapter(W,K,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(W,Z,ne){const ae=this._addNewAdapter(new te(this._documents,ne),W);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentColors(W,Z,ne){return this._withAdapter(W,te,ae=>ae.provideColors(g.URI.revive(Z),ne),[])}$provideColorPresentations(W,Z,ne,ae){return this._withAdapter(W,te,Y=>Y.provideColorPresentations(g.URI.revive(Z),ne,ae),void 0)}registerFoldingRangeProvider(W,Z,ne){const ae=this._nextHandle(),Y=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new he(this._documents,ne),W)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Z),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const we=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));oe=C.Disposable.from(oe,we)}return oe}$provideFoldingRanges(W,Z,ne,ae){return this._withAdapter(W,he,Y=>Y.provideFoldingRanges(g.URI.revive(Z),ne,ae),void 0)}registerSelectionRangeProvider(W,Z,ne){const ae=this._addNewAdapter(new De(this._documents,ne,this._logService),W);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideSelectionRanges(W,Z,ne,ae){return this._withAdapter(W,De,Y=>Y.provideSelectionRanges(g.URI.revive(Z),ne,ae),[])}registerCallHierarchyProvider(W,Z,ne){const ae=this._addNewAdapter(new Pe(this._documents,ne),W);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareCallHierarchy(W,Z,ne,ae){return this._withAdapter(W,Pe,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ne,ae)),void 0)}$provideCallHierarchyIncomingCalls(W,Z,ne,ae){return this._withAdapter(W,Pe,Y=>Y.provideCallsTo(Z,ne,ae),void 0)}$provideCallHierarchyOutgoingCalls(W,Z,ne,ae){return this._withAdapter(W,Pe,Y=>Y.provideCallsFrom(Z,ne,ae),void 0)}$releaseCallHierarchy(W,Z){this._withAdapter(W,Pe,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(W,Z,ne){const ae=this._addNewAdapter(new Fe(this._documents,ne),W);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareTypeHierarchy(W,Z,ne,ae){return this._withAdapter(W,Fe,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ne,ae)),void 0)}$provideTypeHierarchySupertypes(W,Z,ne,ae){return this._withAdapter(W,Fe,Y=>Y.provideSupertypes(Z,ne,ae),void 0)}$provideTypeHierarchySubtypes(W,Z,ne,ae){return this._withAdapter(W,Fe,Y=>Y.provideSubtypes(Z,ne,ae),void 0)}$releaseTypeHierarchy(W,Z){this._withAdapter(W,Fe,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,y.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:We._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?We._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?We._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:We._serializeRegExp(W.beforeText),afterText:W.afterText?We._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?We._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(We._serializeOnEnterRule)}setLanguageConfiguration(W,Z,ne){let{wordPattern:ae}=ne;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Z,ae):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const Y=this._nextHandle(),oe={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?We._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?We._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?We._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,oe),this._createDisposable(Y)}$setWordDefinitions(W){for(const Z of W)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(ge[241],pe([0,1,5,15,7,48,17]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(I,n){this._handlePool=0,this._proxy=I.getProxy(g.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,n){await this._proxy.$changeLanguage(I,n);const A=this._documents.getDocumentData(I);if(!A)throw new Error(`document '${I.toString}' NOT found`);return A.document}async tokenAtPosition(I,n){const A=I.version,d=L.Position.from(n),m=await this._proxy.$tokensAtPosition(I.uri,d),l={type:k.StandardTokenType.Other,range:I.getWordRangeAtPosition(n)??new k.Range(n.line,n.character,n.line,n.character)};if(!m)return l;const v={range:L.Range.to(m.range),type:L.TokenType.to(m.type)};return!v.range.contains(n)||A!==I.version?l:v}createLanguageStatusItem(I){const n=this._handlePool++,A=this._proxy,d={selector:I,text:"",detail:"",severity:k.LanguageStatusSeverity.Information};let m;const l=()=>{m?.dispose(),m=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:d.selector,text:d.text,message:typeof d.detail=="string"?d.detail:L.MarkdownString.from(d.detail),severity:d.severity===k.LanguageStatusSeverity.Error?C.default.Error:d.severity===k.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info})},0)},v={get selector(){return d.selector},set selector(S){d.selector=S,l()},get text(){return d.text},set text(S){d.text=S,l()},get detail(){return d.detail},set detail(S){d.detail=S,l()},get severity(){return d.severity},set severity(S){d.severity=S,l()},dispose(){m?.dispose(),A.$removeLanguageStatus(n)}};return l(),v}}e.ExtHostLanguages=y}),define(ge[242],pe([0,1,5,12,35]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(y){return y&&y.title}let T=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,I,n,A,d){const m={extension:_};let l;typeof A=="string"||C(A)?l=[A,...d]:(m.modal=A?.modal,m.useCustom=A?.useCustom,m.detail=A?.detail,l=d),m.useCustom&&(0,k.checkProposedApiEnabled)(_);const v=[];for(let S=0;S<l.length;S++){const b=l[S];if(typeof b=="string")v.push({title:b,handle:S,isCloseAffordance:!1});else if(typeof b=="object"){let{title:P,isCloseAffordance:c}=b;v.push({title:P,isCloseAffordance:!!c,handle:S})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(I,n,m,v).then(S=>{if(typeof S=="number")return l[S]})}};T=ze([$e(1,L.ILogService)],T),e.ExtHostMessageService=T}),define(ge[243],pe([0,1,24,3,58,6,22,8,14,2,86,5,15,7,218,128]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(P,c,f,p,t){this._textDocumentsAndEditors=f,this._textDocuments=p,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const o=r.notebookEditor?.notebookUri,i=r.cell.handle,h=this._documents.get(o)?.getCell(i);if(h)return h.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const c=this._editors.get(P);if(!c)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(P){for(const[c,f]of this._editors)if(f.apiEditor===P)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,c){const f=this._documents.get(P);if(!f&&!c)throw new Error(`NO notebook document for '${P}'`);return f}_getProviderData(P){const c=this._notebookContentProviders.get(P);if(!c)throw new Error(`NO provider for '${P}'`);return c}registerNotebookContentProvider(P,c,f,p,t){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:P,provider:f});let r;return f.onDidChangeNotebookContentOptions&&(r=f.onDidChangeNotebookContentOptions(()=>{const o=d.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(c,o)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},c,d.NotebookDocumentContentOptions.from(p),S._convertNotebookRegistrationData(P,t)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(P,c){if(!c)return;const f=c.filenamePattern.map(p=>d.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(c.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:c.displayName,filenamePattern:f,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,c,f){const p=S._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,t,c);let r;return t!==void 0&&(r=f.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(t))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,t),r&&r.dispose()})}async createNotebookDocument(P){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&d.NotebookData.from(P.content)});return I.URI.revive(c)}async openNotebookDocument(P){const c=this._documents.get(P);if(c)return c.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(P),p=this._documents.get(I.URI.revive(f));return(0,_.assertIsDefined)(p?.apiNotebook)}async showNotebookDocument(P,c){I.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let f;typeof c=="object"?f={position:d.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(d.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:f={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,f),t=p&&this._editors.get(p)?.apiEditor;if(t)return t;throw p?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,c,f,p){const t=this._notebookStatusBarItemProviders.get(P),r=I.URI.revive(c),o=this._documents.get(r);if(!o||!t)return;const i=o.getCellFromIndex(f);if(!i)return;const a=await t.provideCellStatusBarItems(i.apiCell,p);if(!a)return;const h=new C.DisposableStore,u=this._statusBarCache.add([h]),E=(Array.isArray(a)?a:[a]).map(s=>d.NotebookStatusBarItem.from(s,this._commandsConverter,h));return{cacheId:u,items:E}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,c,f,p,t){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,f),this._notebookProxy.$registerNotebookSerializer(r,{id:P.identifier,location:P.extensionLocation},c,d.NotebookDocumentContentOptions.from(p),S._convertNotebookRegistrationData(P,t)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(P,c,f){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.deserializeNotebook(c.buffer,f);return d.NotebookData.from(t)}async $notebookToData(P,c,f){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.serializeNotebook(d.NotebookData.to(c),f);return g.VSBuffer.wrap(t)}async $openNotebook(P,c,f,p,t){const{provider:r}=this._getProviderData(P),o=await r.openNotebook(I.URI.revive(c),{backupId:f,untitledDocumentData:p?.buffer},t);return{metadata:o.metadata??Object.create(null),cells:o.cells.map(d.NotebookCellData.from)}}async $saveNotebook(P,c,f){const p=this.getNotebookDocument(I.URI.revive(c)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(p.apiNotebook,f),!0}async $saveNotebookAs(P,c,f,p){const t=this.getNotebookDocument(I.URI.revive(c)),{provider:r}=this._getProviderData(P);return await r.saveNotebookAs(I.URI.revive(f),t.apiNotebook,p),!0}async $backupNotebook(P,c,f){const p=this.getNotebookDocument(I.URI.revive(c)),t=this._getProviderData(P),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),o=String((0,k.hash)([p.uri.toString(),this._backupIdPool++])),i=I.URI.joinPath(r,o),a=await t.provider.backupNotebook(p.apiNotebook,{destination:i},f);return p.updateBackup(a),a.id}_createExtHostEditor(P,c,f){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const p=new v.ExtHostNotebookEditor(c,this._notebookEditorsProxy,P,f.visibleRanges.map(d.NotebookRange.to),f.selections.map(d.NotebookRange.to),typeof f.viewColumn=="number"?d.ViewColumn.to(f.viewColumn):void 0);this._editors.set(c,p)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const f of P.removedDocuments){const p=I.URI.revive(f),t=this._documents.get(p);t&&(t.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===p.toString()&&this._editors.delete(r.id)}if(P.addedDocuments){const f=[];for(const p of P.addedDocuments){const t=I.URI.revive(p.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,o=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){r._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){r._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){r._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){r._onDidChangeCellExecutionState.fire(i)}},t,p);f.push(...p.cells.map(i=>l.ExtHostCell.asModelAddData(o.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(P.addedEditors)for(const f of P.addedEditors){if(this._editors.has(f.id))return;const p=I.URI.revive(f.documentUri),t=this._documents.get(p);t&&this._createExtHostEditor(t,f.id,f)}const c=[];if(P.removedEditors)for(const f of P.removedEditors){const p=this._editors.get(f);p&&(this._editors.delete(f),this._activeNotebookEditor?.id===p.id&&(this._activeNotebookEditor=void 0),c.push(p))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const f=new Set;this._visibleNotebookEditors.forEach(p=>f.add(p.id));for(const p of this._editors.values()){const t=f.has(p.id);p._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(ge[244],pe([0,1,3,73,12,5,13,15]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(A,d){const m=_._Keys.nextId();A.$registerNotebookEditorDecorationType(m,y.NotebookDecorationRenderOptions.from(d)),this.value={key:m,dispose(){A.$removeNotebookEditorDecorationType(m)}}}}_._Keys=new L.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(A,d,m){this._logService=A,this._extHostRpc=d,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(A){return new _(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),A).value}$acceptEditorPropertiesChanged(A,d){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,d);const m=this._notebooksAndEditors.getEditorById(A);d.visibleRanges&&m._acceptVisibleRanges(d.visibleRanges.ranges.map(y.NotebookRange.to)),d.selections&&m._acceptSelections(d.selections.selections.map(y.NotebookRange.to)),d.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),d.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const d in A)this._notebooksAndEditors.getEditorById(d)._acceptViewColumn(y.ViewColumn.to(A[d]))}};I=ze([$e(0,k.ILogService),$e(1,T.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(ge[245],pe([0,1,3,6,5,26,2,15,88,22,17,89,21,20,12,7,35]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,r,o,i){this._initData=r,this._extHostNotebook=o,this._logService=i,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,o,i,a,h){for(let M of this._kernelData.values())if(M.controller.id===r&&C.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const u=this._handlePool++,w=this;this._logService.trace(`NotebookController[${u}], CREATED by ${t.identifier.value}, ${r}`);const E=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${t.identifier}'`);let s=!1;const D=new L.DisposableStore,R=new g.Emitter,U=new g.Emitter,V={id:`${t.identifier.value}/${r}`,notebookType:o,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:h?h.map(y.NotebookRendererScript.from):[]};let ee=a??E,Q;this._proxy.$addKernel(u,V).catch(M=>{console.log(M),s=!0});let O=0;const x=()=>{if(s)return;const M=++O;Promise.resolve().then(()=>{M===O&&this._proxy.$updateKernel(u,V)})},F=new I.ResourceMap,z={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return V.label},set label(M){V.label=M??t.displayName??t.name,x()},get detail(){return V.detail??""},set detail(M){V.detail=M,x()},get description(){return V.description??""},set description(M){V.description=M,x()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(M){V.supportedLanguages=M,x()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(M){V.supportsExecutionOrder=M,x()},get rendererScripts(){return V.preloads?V.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(M){ee=M??E},get interruptHandler(){return Q},set interruptHandler(M){Q=M,V.supportsInterrupt=Boolean(M),x()},createNotebookCellExecution(M){if(s)throw new Error("notebook controller is DISPOSED");if(!F.has(M.notebook.uri))throw w._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(N=>N.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return w._createNotebookCellExecution(M)},dispose:()=>{s||(this._logService.trace(`NotebookController[${u}], DISPOSED`),s=!0,this._kernelData.delete(u),D.dispose(),R.dispose(),U.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(M,N){w._proxy.$updateNotebookPriority(u,M.uri,N)},onDidReceiveMessage:U.event,postMessage(M,N){return(0,S.checkProposedApiEnabled)(t),w._proxy.$postMessage(u,N&&w._extHostNotebook.getIdByEditor(N),M)},asWebviewUri(M){return(0,S.checkProposedApiEnabled)(t),(0,_.asWebviewUri)(M,w._initData.remote)}};return this._kernelData.set(u,{extensionId:t.identifier,controller:z,onDidReceiveMessage:U,onDidChangeSelection:R,associatedNotebooks:F}),z}$acceptNotebookAssociation(t,r,o){const i=this._kernelData.get(t);if(i){const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));o?i.associatedNotebooks.set(a.uri,!0):i.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),o),i.onDidChangeSelection.fire({selected:o,notebook:a.apiNotebook})}}async $executeCells(t,r,o){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r)),h=[];for(let u of o){const w=a.getCell(u);w&&h.push(w.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),h.length),await i.controller.executeHandler.call(i.controller,h,a.apiNotebook,i.controller)}catch(u){this._logService.error(`NotebookController[${t}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(t,r,o){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,a.apiNotebook);else for(let h of o){const u=a.getCell(h);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,o){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:o}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const i=new c(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,i);const a=i.onDidChangeState(()=>{i.state===P.Resolved&&(i.dispose(),a.dispose(),this._activeExecutions.delete(o.uri))});return i.asApiObject()}};b=ze([$e(3,l.ILogService)],b),e.ExtHostNotebookKernels=b;var P;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(P||(P={}));class c extends L.Disposable{constructor(t,r,o){super();this._document=t,this._cell=r,this._proxy=o,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new f(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:A.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const o=v.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return o===r.items?y.NotebookCellOutput.from(r):y.NotebookCellOutput.from({items:o,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,o){const i=this.cellIndexToHandle(r),a=this.validateAndConvertOutputs((0,m.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:o,outputs:a})}async updateOutputItems(t,r,o){return t=v.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(y.NotebookCellOutputItem.from),outputId:r.id,append:o})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(o){t._executionOrder=o,t.mixinMetadata({executionOrder:o})},start(o){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:A.NotebookCellExecutionState.Executing,runStartTime:o??null})},end(o,i){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:o??null,runEndTime:i??null})},clearOutput(o){return t.verifyStateForOutput(),t.updateOutputs([],o,!1)},appendOutput(o,i){return t.verifyStateForOutput(),t.updateOutputs(o,i,!0)},replaceOutput(o,i){return t.verifyStateForOutput(),t.updateOutputs(o,i,!1)},appendOutputItems(o,i){return t.verifyStateForOutput(),t.updateOutputItems(o,i,!0)},replaceOutputItems(o,i){return t.verifyStateForOutput(),t.updateOutputItems(o,i,!1)}})}}class f{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(ge[246],pe([0,1,3,5,128]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(y,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,_,I){const n=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(_)?.fire({editor:n.apiEditor,message:I})}createRendererMessaging(y,_){if(!y.contributes?.notebookRenderer?.some(d=>d.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const I=!!y.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(d,m,l)=>{const v=I?d:S=>{const b={};n.set(b,S.editor),d({editor:b,message:S.message})};return this.getOrCreateEmitterFor(_).event(v,m,l)},postMessage:(d,m)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(d)&&([d,m]=[m,d]);const l=I?m:n.get(m),v=l&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(l);return this.proxy.$postMessage(v?.id,_,d)}}}getOrCreateEmitterFor(y){let _=this._rendererMessageEmitters.get(y);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,_),_)}}e.ExtHostNotebookRenderers=C}),define(ge[65],pe([0,1,5,3,6,24,4,13]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends k.Disposable{constructor(l,v,S,b,P){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=P,this._id=P.$register(this.name,v,S,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?C.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(v=>this._proxy.$clear(v,l))}show(l,v){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof l=="boolean"?l:v)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class I extends _{constructor(l,v,S){super(l,!1,void 0,v,S)}append(l){super.append(l),this._id.then(v=>this._proxy.$append(v,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class n extends _{constructor(l,v,S){super(l,!0,v,void 0,S)}append(l){throw new Error("Not supported")}}class A{constructor(l,v){this.name=l,this._channel=v}append(l){this._channel.then(v=>v.append(l))}appendLine(l){this._channel.then(v=>v.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,v){this._channel.then(S=>S.show(l,v))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=A;let d=class{constructor(l){this._proxy=l.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new I(l,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new n(l,v,this._proxy)}};d=ze([$e(0,y.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(ge[247],pe([0,1,17,21,3,6,5,2,7,16,20,48]),function(J,e,g,L,k,C,T,y,_,I,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(m,l,v){const S=m.getProxy(T.MainContext.MainThreadQuickOpen);class b{constructor(i,a){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=a}showQuickPick(i,a,h,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(i),E=++this._instances,s=S.$show(E,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},u),D={},R=s.then(()=>D);return Promise.race([R,w]).then(U=>{if(U!==D)return w.then(V=>{const ee=[];for(let Q=0;Q<V.length;Q++){const O=V[Q];let x,F,z,M,N;typeof O=="string"?x=O:(x=O.label,F=O.description,z=O.detail,M=O.picked,N=O.alwaysShow),ee.push({label:x,description:F,handle:Q,detail:z,picked:M,alwaysShow:N})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{h.onDidSelectItem(V[Q])}),S.$setItems(E,ee),s.then(Q=>{if(typeof Q=="number")return V[Q];if(Array.isArray(Q))return Q.map(O=>V[O])})})}).then(void 0,U=>{if(!(0,I.isPromiseCanceledError)(U))return S.$setError(E,U),Promise.reject(U)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,a=L.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,S.$input(i,typeof this._validateInput=="function",a).then(void 0,h=>{if(!(0,I.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(i){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,a=L.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!h)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(w=>w.uri.toString()===h.uri.toString())}createQuickPick(i,a){const h=new t(i,a,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(i){const a=new r(i,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(i,a){const h=this._sessions.get(i);h&&h._fireDidChangeValue(a)}$onDidAccept(i){const a=this._sessions.get(i);a&&a._fireDidAccept()}$onDidChangeActive(i,a){const h=this._sessions.get(i);h instanceof t&&h._fireDidChangeActive(a)}$onDidChangeSelection(i,a){const h=this._sessions.get(i);h instanceof t&&h._fireDidChangeSelection(a)}$onDidTriggerButton(i,a){const h=this._sessions.get(i);h&&h._fireDidTriggerButton(a)}$onDidHide(i){const a=this._sessions.get(i);a&&a._fireDidHide()}}class P{constructor(i,a){this._extensionId=i,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((a,h)=>{const u=a===_.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(u,a)}),this.update({buttons:i.map((a,h)=>({iconPath:c(a.iconPath),tooltip:a.tooltip,handle:a===_.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const a=this._handlesToButtons.get(i);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(i){if(!this._disposed){for(const a of Object.keys(i)){const h=i[a];this._pendingUpdate[a]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}P._nextId=1;function c(o){if(o instanceof _.ThemeIcon)return{id:o.id};const i=p(o),a=f(o);return{dark:typeof i=="string"?y.URI.file(i):i,light:typeof a=="string"?y.URI.file(a):a}}function f(o){return typeof o=="object"&&"light"in o?o.light:o}function p(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends P{constructor(i,a,h){super(i,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((a,h)=>{this._handlesToItems.set(h,a),this._itemsToHandles.set(a,h)}),this.update({items:i.map((a,h)=>({label:a.label,description:a.description,handle:h,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(i){const a=(0,n.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(i){const a=(0,n.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends P{constructor(i,a){super(i,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?A.default.Error:A.default.Ignore})}}return new b(l,v)}e.createExtHostQuickOpen=d}),define(ge[248],pe([0,1,2,3,56,6,17,5,20,100,12,26,35,85,15]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(h){if(h)return typeof h.iconPath=="string"?g.URI.file(h.iconPath):g.URI.isUri(h.iconPath)||m.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function S(h,u){if(!h.iconPath&&!u.iconPath)return 0;if(h.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof h.iconPath=="string"?h.iconPath:g.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,E=typeof u.iconPath=="string"?u.iconPath:g.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,I.comparePaths)(w,E)}function b(h,u){let w=0;if(h.strikeThrough!==u.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==u.faded)return h.faded?1:-1;if(h.tooltip!==u.tooltip)return(h.tooltip||"").localeCompare(u.tooltip||"");if(w=S(h,u),w!==0)return w;if(h.light&&u.light)w=S(h.light,u.light);else{if(h.light)return 1;if(u.light)return-1}if(w!==0)return w;if(h.dark&&u.dark)w=S(h.dark,u.dark);else{if(h.dark)return 1;if(u.dark)return-1}return w}function P(h,u){if(h.command!==u.command)return h.command<u.command?-1:1;if(h.title!==u.title)return h.title<u.title?-1:1;if(h.tooltip!==u.tooltip){if(h.tooltip!==void 0&&u.tooltip!==void 0)return h.tooltip<u.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(h.arguments===u.arguments)return 0;if(h.arguments)if(u.arguments){if(h.arguments.length!==u.arguments.length)return h.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<h.arguments.length;w++){const E=h.arguments[w],s=u.arguments[w];if(E!==s)return E<s?-1:1}return 0}function c(h,u){let w=(0,I.comparePaths)(h.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(h.command&&u.command)w=P(h.command,u.command);else{if(h.command)return 1;if(u.command)return-1}if(w!==0)return w;if(h.decorations&&u.decorations)w=b(h.decorations,u.decorations);else{if(h.decorations)return 1;if(u.decorations)return-1}return w}function f(h,u){for(let w=0;w<h.length;w++)if(h[w]!==u[w])return!1;return!0}function p(h,u){return h.command===u.command&&h.title===u.title&&h.tooltip===u.tooltip&&(h.arguments&&u.arguments?f(h.arguments,u.arguments):h.arguments===u.arguments)}function t(h,u){return(0,_.equals)(h,u,p)}class r{constructor(u,w,E){this._extension=u,this._proxy=w,this._sourceControlHandle=E,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,d.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,w){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=r;class o{constructor(u,w,E,s,D){this._proxy=u,this._commands=w,this._sourceControlHandle=E,this._id=s,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const E=this._resourceStatesCommandsMap.get(u);return E?(0,T.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(c),E=(0,_.sortedDiff)(this._resourceSnapshot,u,c).map(R=>{const U=R.toInsert.map(V=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,V);const Q=V.resourceUri;let O;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const he=new C.DisposableStore;O=this._commands.converter.toInternal(V.command,he),this._resourceStatesDisposablesMap.set(ee,he)}else this._resourceStatesCommandsMap.set(ee,V.command);const x=v(V.decorations),F=V.decorations&&v(V.decorations.light)||x,z=V.decorations&&v(V.decorations.dark)||x,M=[F,z],N=V.decorations&&V.decorations.tooltip||"",q=V.decorations&&!!V.decorations.strikeThrough,B=V.decorations&&!!V.decorations.faded,K=V.contextValue||"";return{rawResource:[ee,Q,M,N,q,B,K,O],handle:ee}});return{start:R.start,deleteCount:R.deleteCount,toInsert:U}}),s=E.map(({start:R,deleteCount:U,toInsert:V})=>[R,U,V.map(ee=>ee.rawResource)]),D=E.reverse();for(const{start:R,deleteCount:U,toInsert:V}of D){const ee=V.map(O=>O.handle),Q=this._handlesSnapshot.splice(R,U,...ee);for(const O of Q)this._resourceStatesMap.delete(O),this._resourceStatesCommandsMap.delete(O),this._resourceStatesDisposablesMap.get(O)?.dispose(),this._resourceStatesDisposablesMap.delete(O)}return this._resourceSnapshot=u,s}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class i{constructor(u,w,E,s,D,R){this._proxy=w,this._commands=E,this._id=s,this._label=D,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,s,D,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&t(this._statusBarCommands,u))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(u,w){const E=new o(this._proxy,this._commands,this.handle,u,w),s=L.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,s),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const u=[],w=[];for(const[E,s]of this.createdResourceGroups){s.dispose();const D=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});L.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),D.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),u.push([E.handle,E.id,E.label,E.features]);const R=E._takeResourceStateSnapshot();R.length>0&&w.push([E.handle,R]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const E=w._takeResourceStateSnapshot();E.length!==0&&u.push([w.handle,E])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,ze([(0,k.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),ze([(0,k.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let a=class Bn{constructor(u,w,E){this._commands=w,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=u.getProxy(y.MainContext.MainThreadSCM),this._telemetry=u.getProxy(y.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===3){const D=this._sourceControls.get(s.sourceControlHandle);if(!D)return s;const R=D.getResourceGroup(s.groupHandle);return R?R.getResourceState(s.handle):s}else if(s&&s.$mid===4){const D=this._sourceControls.get(s.sourceControlHandle);return D?D.getResourceGroup(s.groupHandle):s}else if(s&&s.$mid===5){const D=this._sourceControls.get(s.handle);return D||s}return s}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,E,s){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,E,s),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const D=Bn._handlePool++,R=new i(u,this._proxy,this._commands,w,E,s);this._sourceControls.set(D,R);const U=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(u.identifier))||[];return U.push(R),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(u.identifier),U),R}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(u.identifier)),E=w&&w[w.length-1];return E&&E.inputBox}$provideOriginalResource(u,w,E){const s=g.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,s.toString());const D=this._sourceControls.get(u);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(s,E)).then(R=>R||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const E=this._sourceControls.get(u);return E&&E.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,E,s){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,E);const D=this._sourceControls.get(u);if(!D)return Promise.resolve(void 0);const R=D.getResourceGroup(w);return R?R.$executeResourceCommand(E,s):Promise.resolve(void 0)}$validateInput(u,w,E){this.logService.trace("ExtHostSCM#$validateInput",u);const s=this._sourceControls.get(u);return!s||!s.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>s.inputBox.validateInput(w,E)).then(D=>{if(!D)return Promise.resolve(void 0);const R=l.MarkdownString.fromStrict(D.message);return R?Promise.resolve([R,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};a._handlePool=0,a=ze([$e(2,n.ILogService)],a),e.ExtHostSCM=a});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[249],pe([0,1,7,5,166,6,15]),function(J,e,g,L,k,C,T){"use strict";var y,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class I{constructor(m,l,v,S,b=g.StatusBarAlignment.Left,P){y.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,it(this,y,m,"f"),it(this,_,l,"f"),this._entryId=I.ID_GEN++,this._extension=v,this._id=S,this._alignment=b,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!I.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:He(this,_,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:He(this,_,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let l;this._name?l=this._name:l=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=I.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;He(this,y,"f").$setEntry(this._entryId,m,l,this._text,S,this._command?.internal,v,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=I,y=new WeakMap,_=new WeakMap,I.ID_GEN=0,I.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const l={message:m};return this._messages.unshift(l),this._update(),new g.Disposable(()=>{const v=this._messages.indexOf(l);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(m,l){this._proxy=m.getProxy(L.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new n(this)}createStatusBarEntry(m,l,v,S){return new I(this._proxy,this._commands,m,l,v,S)}setStatusBarMessage(m,l){const v=this._statusMessage.setMessage(m);let S;return typeof l=="number"?S=setTimeout(()=>v.dispose(),l):typeof l!="undefined"&&l.then(()=>v.dispose(),()=>v.dispose()),new g.Disposable(()=>{v.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=A}),define(ge[93],pe([0,1,5,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(y){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,_){this._proxy.$registerExtensionStorageKeysToSync(y,_)}getValue(y,_,I){return this._proxy.$getValue(y,_).then(n=>n||I)}setValue(y,_,I){return this._proxy.$setValue(y,_,I)}$acceptValue(y,_,I){this._onDidChangeStorage.fire({shared:y,key:_,value:I})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(ge[66],pe([0,1,4,27,12,92,2]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let y=class{constructor(I,n,A){this._logService=n,this._extHostFileSystem=A,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getWorkspaceStorageURI(I){return T.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,n=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(A){this._logService.error("[ExtHostStorage]",A);return}}workspaceValue(I){if(this._value)return T.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return T.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=ze([$e(0,L.IExtHostInitDataService),$e(1,k.ILogService),$e(2,C.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(ge[33],pe([0,1,3,5,4,2,13,6,7,167,16,213,21,32,195,85,14]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class b{constructor(a,h,u,w){this._proxy=a,this._id=h,this._creationOptions=u,this._name=w,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(s=>this._pidPromiseComplete=s);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},sendText(s,D=!0){E._checkDisposed(),E._proxy.$sendText(E._id,s,D)},show(s){E._checkDisposed(),E._proxy.$show(E._id,s)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(a,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,S.withNullAsUndefined)(a.shellPath),shellArgs:(0,S.withNullAsUndefined)(a.shellArgs),cwd:(0,S.withNullAsUndefined)(a.cwd),env:(0,S.withNullAsUndefined)(a.env),icon:(0,S.withNullAsUndefined)(r(a.iconPath)),color:v.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,S.withNullAsUndefined)(a.message),strictEnv:(0,S.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,S.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,S.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,S.withNullAsUndefined)(h?.useShellEnvironment),isSplitTerminal:h?.isSplitTerminal,target:h?.target})}async createExtensionTerminal(a,h,u,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:u,color:v.ThemeColor.isThemeColor(w)?w.id:void 0,isSplitTerminal:a,target:h}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitCode(a){this._exitStatus=Object.freeze({code:a})}setDimensions(a,h){return a===this._cols&&h===this._rows||a===0||h===0?!1:(this._cols=a,this._rows=h,!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=b;class P{constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput&&this._pty.handleInput(a)}resize(a,h){this._pty.setDimensions&&this._pty.setDimensions({columns:a,rows:h})}async processBinary(a){}acknowledgeDataEvent(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose&&this._pty.onDidClose((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h&&{cols:h.columns,rows:h.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(h=>this._onProcessTitleChanged.fire(h)),this._pty.open(a||void 0),this._pty.setDimensions&&a&&this._pty.setDimensions(a),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let c=1,f=class extends y.Disposable{constructor(a,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=h.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[u,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,h){const u=new b(this._proxy,(0,m.generateUuid)(),a,a.name),w=new P(a.pty);return u.createExtensionTerminal(h?.isSplitTerminal,h?.target,r(a.iconPath),o(a.color)).then(E=>{const s=this._setupExtHostProcessListeners(E,w);this._terminalProcessDisposables[E]=s}),this._terminals.push(u),u.value}attachPtyToTerminal(a,h){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const w=new P(h),E=this._setupExtHostProcessListeners(a,w);this._terminalProcessDisposables[a]=E}async $acceptActiveTerminalChanged(a){const h=this._activeTerminal;if(a===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(a);u&&(this._activeTerminal=u,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,h){const u=this._getTerminalById(a);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:h})}async $acceptTerminalDimensions(a,h,u){const w=this._getTerminalById(a);w&&w.setDimensions(h,u)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(a,h,u){this._terminalProcesses.get(a)?.resize(h,u)}async $acceptTerminalTitleChange(a,h){const u=this._getTerminalById(a);u&&(u.name=h)}async $acceptTerminalClosed(a,h){const u=this._getTerminalObjectIndexById(this._terminals,a);if(u!==null){const w=this._terminals.splice(u,1)[0];w.setExitCode(h),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(a,h,u,w){if(h){const D=this._getTerminalObjectIndexById(this._terminals,h);if(D!==null){this._terminals[D]._id=a,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const E={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:C.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},s=new b(this._proxy,a,E,u);this._terminals.push(s),this._onDidOpenTerminal.fire(s.value),s.isOpen=!0}async $acceptTerminalProcessId(a,h){const u=this._getTerminalById(a);u&&u._setProcessId(h)}async $startExtensionTerminal(a,h){const u=this._getTerminalById(a);if(!u)return{message:(0,I.localize)(0,null,a)};u.isOpen||await new Promise(E=>{const s=this.onDidOpenTerminal(async D=>{D===u.value&&(s.dispose(),E())})});const w=this._terminalProcesses.get(a);w?w.startSendingEvents(h):this._extensionTerminalAwaitingStart[a]={initialDimensions:h}}_setupExtHostProcessListeners(a,h){const u=new y.DisposableStore;u.add(h.onProcessReady(E=>this._proxy.$sendProcessReady(a,E.pid,E.cwd))),u.add(h.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(a,E))),this._bufferer.startBuffering(a,h.onProcessData),u.add(h.onProcessExit(E=>this._onProcessExit(a,E))),h.onProcessOverrideDimensions&&u.add(h.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(a,E))),this._terminalProcesses.set(a,h);const w=this._extensionTerminalAwaitingStart[a];return w&&h instanceof P&&(h.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),u}$acceptProcessAckDataEvent(a,h){this._terminalProcesses.get(a)?.acknowledgeDataEvent(h)}$acceptProcessInput(a,h){this._terminalProcesses.get(a)?.input(h)}$acceptProcessResize(a,h,u){try{this._terminalProcesses.get(a)?.resize(h,u)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(a,h){this._terminalProcesses.get(a)?.shutdown(h)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(h=>this._proxy.$sendProcessInitialCwd(a,h))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(h=>this._proxy.$sendProcessCwd(a,h))}$acceptProcessRequestLatency(a){return a}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,h,u){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,u),this._proxy.$registerProfileProvider(h,a.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(a,h){const u=new d.CancellationTokenSource().token,w=await this._profileProviders.get(a)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,h);return}this.createTerminalFromOptions(w.options,h)}}async $provideLinks(a,h){const u=this._getTerminalById(a);if(!u)return[];this._terminalLinkCache.delete(a);const w=this._terminalLinkCancellationSource.get(a);w&&w.dispose(!0);const E=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,E);const s=[],D={terminal:u.value,line:h},R=[];for(const ee of this._linkProviders)R.push(new Promise(async Q=>{E.token.onCancellationRequested(()=>Q({provider:ee,links:[]}));const O=await ee.provideTerminalLinks(D,E.token)||[];E.token.isCancellationRequested||Q({provider:ee,links:O})}));const U=await Promise.all(R);if(E.token.isCancellationRequested)return[];const V=new Map;for(const ee of U)ee&&ee.links.length>0&&s.push(...ee.links.map(Q=>{const O={id:c++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return V.set(O.id,{provider:ee.provider,link:Q}),O}));return this._terminalLinkCache.set(a,V),s}$activateLink(a,h){const u=this._terminalLinkCache.get(a)?.get(h);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(a,h){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const u=this._terminalProcessDisposables[a];u&&(u.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,h)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,h){const u=this._getTerminalObjectIndexById(a,h);return u!==null?a[u]:null}_getTerminalObjectIndexById(a,h){let u=null;return a.some((w,E)=>w._id===h?(u=E,!0):!1),u}getEnvironmentVariableCollection(a){let h=this._environmentVariableCollections.get(a.identifier.value);return h||(h=new p,this._setEnvironmentVariableCollection(a.identifier.value,h)),h}_syncEnvironmentVariableCollection(a,h){const u=(0,A.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(a,h.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(a){a.forEach(h=>{const u=h[0],w=new p(h[1]);this._setEnvironmentVariableCollection(u,w)})}$acceptDefaultProfile(a,h){this._defaultProfile=a,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(a,h){this._environmentVariableCollections.set(a,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,h)})}};f=ze([$e(1,T.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class p{constructor(a){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(a)}get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(a,h){this._setIfDiffers(a,{value:h,type:_.EnvironmentVariableMutatorType.Replace})}append(a,h){this._setIfDiffers(a,{value:h,type:_.EnvironmentVariableMutatorType.Append})}prepend(a,h){this._setIfDiffers(a,{value:h,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(a,h){const u=this.map.get(a);(!u||u.value!==h.value||u.type!==h.type)&&(this.map.set(a,h),this._onDidChangeCollection.fire())}get(a){return this.map.get(a)}forEach(a,h){this.map.forEach((u,w)=>a.call(h,w,u,this))}delete(a){this.map.delete(a),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let t=class extends f{constructor(a){super(!1,a)}createTerminal(a,h,u){throw new n.NotSupportedError}createTerminalFromOptions(a,h){throw new n.NotSupportedError}};t=ze([$e(0,T.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function o(i){return v.ThemeColor.isThemeColor(i)?i:void 0}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[250],pe([0,1,24,21,3,72,58,74,6,25,14,32,5,13,87,15,7,221,126,90]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(R,U){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(d.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new r(this.proxy),U.registerArgumentProcessor({processArgument:V=>V?.$mid===13?v.TestItem.toItemFromContext(V):V})}createTestController(R,U){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const V=new _.DisposableStore,ee=V.add(new b.SingleUseTestCollection(R));ee.root.label=U;const Q=new Map,O=this.proxy,x={items:ee.root.children,get label(){return U},set label(z){U=z,ee.root.label=z,O.$updateControllerLabel(R,U)},get id(){return R},createRunProfile:(z,M,N,q,B)=>{let K=(0,T.hash)(z);for(;Q.has(K);)K++;const te=new E(this.proxy,R,K,z,M,N,q,B);return Q.set(K,te),te},createTestItem(z,M,N){return new l.TestItemImpl(R,z,M,N)},createTestRun:(z,M,N=!0)=>this.runTracker.createTestRun(R,ee,z,M,N),set resolveHandler(z){ee.resolveHandler=z},get resolveHandler(){return ee.resolveHandler},dispose:()=>{V.dispose()}};x.createRunConfiguration=x.createRunProfile,O.$registerTestController(R,U),V.add((0,_.toDisposable)(()=>O.$unregisterTestController(R)));const F={controller:x,collection:ee,profiles:Q};return this.controllers.set(R,F),V.add((0,_.toDisposable)(()=>this.controllers.delete(R))),V.add(ee.onDidGenerateDiff(z=>O.$publishDiff(R,z))),x}createTestObserver(){return this.observer.checkout()}async runTests(R,U=L.CancellationToken.None){const V=o(R);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.controllers.get(V.controllerId);if(!ee)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(Q=>Q.id)??[ee.collection.root.id],profileGroup:s[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:R.exclude?.map(Q=>Q.id)},U)}$provideFileCoverage(R,U,V){return y.Iterable.find(this.runTracker.trackers,ee=>ee.id===R)?.getCoverage(U)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(R,U,V,ee){return y.Iterable.find(this.runTracker.trackers,Q=>Q.id===R)?.getCoverage(U)?.resolveFileCoverage(V,ee)??Promise.resolve([])}$configureRunProfile(R,U){this.controllers.get(R)?.profiles.get(U)?.configureHandler?.()}$getTestTags(R){const U=this.controllers.get(R);if(!U)return Promise.resolve([]);const V=new Map;for(const ee of U.profiles.values())if(ee.tag){const Q=v.TestTag.display(R,ee.tag);V.set(Q.id,Q)}for(const ee of U.collection.tags()){const Q=v.TestTag.display(R,ee);V.set(Q.id,Q)}return Promise.resolve([...V.values()])}$publishTestResults(R){this.results=Object.freeze(R.map(U=>(0,I.deepFreeze)(v.TestResults.to(U))).concat(this.results).sort((U,V)=>V.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,U){const V=this.controllers.get(c.TestId.fromString(R).controllerId)?.collection;V&&(await V.expand(R,U<0?Infinity:U),V.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,U){const V=this.controllers.get(R.controllerId);if(!V)return;const{collection:ee,profiles:Q}=V,O=Q.get(R.profileId);if(!O)return;const x=R.testIds.map(N=>ee.tree.get(N)).filter(n.isDefined),F=R.excludeExtIds.map(N=>V.collection.tree.get(N)).filter(n.isDefined).filter(N=>x.some(q=>q.fullId.compare(N.fullId)===2));if(!x.length)return;const z=new S.TestRunRequest(x.some(N=>N.actual instanceof l.TestItemRootImpl)?void 0:x.map(N=>N.actual),F.map(N=>N.actual),O),M=this.runTracker.prepareForMainThreadTestRun(z,i.fromInternal(R,V.collection),U);try{await O.runHandler(z,U)}finally{M.isRunning&&!U.isCancellationRequested&&await k.Event.toPromise(M.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};p=ze([$e(0,m.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends _.Disposable{constructor(R,U,V){super();this.dto=R,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(V)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:ee}of this.tasks.values())ee.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const U=this.dto.id,V=this.dto.controllerId,ee=(0,A.generateUuid)(),Q=new a(this.proxy,U,ee),O=z=>(M,...N)=>{if(x){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),z(M,...N))};let x=!1;const F={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return Q.coverageProvider},set coverageProvider(z){Q.coverageProvider=z},enqueued:O(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),1)}),skipped:O(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),5)}),started:O(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),2)}),errored:O((z,M,N)=>{this.proxy.$appendTestMessagesInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),6,N)}),failed:O((z,M,N)=>{this.proxy.$appendTestMessagesInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),4,N)}),passed:O((z,M)=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,M)}),appendOutput:z=>{x||this.proxy.$appendOutputToRun(U,ee,g.VSBuffer.fromString(z))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(U,ee),this.tasks.delete(ee),this.isRunning||this.dispose())}};return this.tasks.set(ee,{run:F,coverage:Q}),this.proxy.$startedTestRunTask(U,{id:ee,name:R,running:!0}),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof l.TestItemImpl))throw new l.InvalidTestItemError(R.id);if(this.sharedTestIds.has(R.id))return;const U=[];for(;U.unshift(v.TestItem.from(R)),!(this.sharedTestIds.has(R.id)||(this.sharedTestIds.add(R.id),!R.parent));)R=R.parent;const V=this.dto.colllection.root;this.sharedTestIds.has(V.id)||(this.sharedTestIds.add(V.id),U.unshift(v.TestItem.from(V))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class r{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,U,V){return this.getTracker(R,U,V)}cancelRunById(R){for(const U of this.tracked.values())if(U.id===R){U.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,U,V,ee,Q){const O=this.tracked.get(V);if(O)return O.createRun(ee);const x=i.fromPublic(R,U,V,Q),F=o(V);this.proxy.$startedExtensionTestRun({controllerId:R,profile:F&&{group:s[F.kind],id:F.profileId},exclude:V.exclude?.map(M=>M.id)??[],id:x.id,include:V.include?.map(M=>M.id)??[U.root.id],persist:Q});const z=this.getTracker(V,x);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),z.createRun(ee)}getTracker(R,U,V){const ee=new t(U,this.proxy,V);return this.tracked.set(R,ee),ee.onEnd(()=>this.tracked.delete(R)),ee}}e.TestRunCoordinator=r;const o=D=>{if(!!D.profile){if(!(D.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class i{constructor(R,U,V,ee,Q,O){this.controllerId=R,this.id=U,this.isPersisted=Q,this.colllection=O,this.includePrefix=V.map(x=>x+"\0"),this.excludePrefix=ee.map(x=>x+"\0")}static fromPublic(R,U,V,ee){return new i(R,(0,A.generateUuid)(),V.include?.map(Q=>c.TestId.fromExtHostTestItem(Q,R).toString())??[R],V.exclude?.map(Q=>c.TestId.fromExtHostTestItem(Q,R).toString())??[],ee,U)}static fromInternal(R,U){return new i(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,U)}isIncluded(R){const U=c.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const V of this.excludePrefix)if(U===V||U.startsWith(V))return!1;for(const V of this.includePrefix)if(U===V||U.startsWith(V))return!0;return!1}}e.TestRunDto=i;class a{constructor(R,U,V){this.proxy=R,this.runId=U,this.taskId=V}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(R,U){const V=await this.fileCoverage;let ee=V?.[R];return!this._coverageProvider||!V||!ee?[]:(ee.detailedCoverage||(ee=V[R]=await this._coverageProvider.resolveFileCoverage?.(ee,U)??ee),ee.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class h extends P.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,v.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:U,removed:V}=this;return{get added(){return[...R].map(ee=>ee.revived)},get updated(){return[...U].map(ee=>ee.revived)},get removed(){return[...V].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,U){return{...R,revived:v.TestItem.toPlain(R.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=u;class w{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(U=>U.revived)},dispose:(0,C.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class E{constructor(R,U,V,ee,Q,O,x=!1,F=void 0){this.controllerId=U,this.profileId=V,this._label=ee,this.kind=Q,this.runHandler=O,this._isDefault=x,this._tag=F,f.set(this,void 0),it(this,f,R,"f");const z=s[Q];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);He(this,f,"f").$publishTestRunProfile({profileId:V,controllerId:U,tag:F?v.TestTag.namespace(this.controllerId,F.id):null,label:ee,group:z,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?v.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){He(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,f=new WeakMap;const s={[S.TestRunProfileKind.Coverage]:8,[S.TestRunProfileKind.Debug]:4,[S.TestRunProfileKind.Run]:2}}),define(ge[251],pe([0,1,3,20,5,129,15,7]),function(J,e,g,L,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const A=this._extHostDocumentsAndEditors.allEditors();return n?A:A.map(d=>d.value)}async showTextDocument(n,A,d){let m;typeof A=="number"?m={position:T.ViewColumn.from(A),preserveFocus:d}:typeof A=="object"?m={position:T.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?T.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:m={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(n.uri,m),v=l&&this._extHostDocumentsAndEditors.getEditor(l);if(v)return v.value;throw l?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,A){return new C.TextEditorDecorationType(this._proxy,n,A).value}$acceptEditorPropertiesChanged(n,A){const d=this._extHostDocumentsAndEditors.getEditor(n);if(!d)throw new Error("unknown text editor");if(A.options&&d._acceptOptions(A.options),A.selections){const m=A.selections.selections.map(T.Selection.to);d._acceptSelections(m)}if(A.visibleRanges){const m=L.coalesce(A.visibleRanges.map(T.Range.to));d._acceptVisibleRanges(m)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:{...A.options,lineNumbers:T.TextEditorLineNumbersStyle.to(A.options.lineNumbers)}}),A.selections){const m=y.TextEditorSelectionChangeKind.fromValue(A.selections.source),l=A.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:l,kind:m})}if(A.visibleRanges){const m=L.coalesce(A.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:m})}}$acceptEditorPositionData(n){for(const A in n){const d=this._extHostDocumentsAndEditors.getEditor(A);if(!d)throw new Error("Unknown text editor");const m=T.ViewColumn.to(n[A]);d.value.viewColumn!==m&&(d._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:m}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_}),define(ge[252],pe([0,1,2,4,5,6,7]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class y{constructor(n,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(k.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===11){const m=d.uri===void 0?void 0:g.URI.revive(d.uri);return this._itemsBySourceAndUriMap.get(d.source)?.get(_(m))?.get(d.handle)}return d}})}async $getTimeline(n,A,d,m,l){return this._providers.get(n)?.provideTimeline(g.URI.revive(A),d,m,l)}registerTimelineProvider(n,A,d,m){const l=new C.DisposableStore,v=this.convertTimelineItem(A.id,m,l).bind(this);let S;A.onDidChange&&(S=A.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:A.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...A,scheme:n,onDidChange:void 0,async provideTimeline(P,c,f,p){p?.resetCache&&(l.clear(),b.get(A.id)?.clear());const t=await A.provideTimeline(P,c,f);if(t==null)return;const r=v(P,p);return{...t,source:A.id,items:t.items.map(r)}},dispose(){for(const P of b.values())P.get(A.id)?.clear();S?.dispose(),l.dispose()}})}convertTimelineItem(n,A,d){return(m,l)=>{let v;if(l?.cacheResults){let S=this._itemsBySourceAndUriMap.get(n);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(n,S));const b=_(m);v=S.get(b),v===void 0&&(v=new Map,S.set(b,v))}return S=>{const{iconPath:b,...P}=S,c=`${n}|${S.id??S.timestamp}`;v?.set(c,S);let f,p,t;return S.iconPath&&(b instanceof T.ThemeIcon?t={id:b.id,color:b.color}:g.URI.isUri(b)?(f=b,p=b):{light:f,dark:p}=b),{...P,id:P.id??void 0,handle:c,source:n,command:S.command?A.toInternal(S.command,d):void 0,icon:f,iconDark:p,themeIcon:t,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,C.toDisposable)(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=y;function _(I){return I?.toString()}}),define(ge[253],pe([0,1,6,10,2,5]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(_){this._openers=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,n,A){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const d=A.schemes.find(m=>!T.supportedSchemes.has(m));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,n),this._proxy.$registerUriOpener(I,A.schemes,_,A.label),(0,g.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,n){const A=this._openers.get(_);if(!A)throw new Error(`Unknown opener with id: ${_}`);const d=k.URI.revive(I);return A.canOpenExternalUri(d,n)}async $openUri(_,I,n){const A=this._openers.get(_);if(!A)throw new Error(`Unknown opener id: '${_}'`);return A.openExternalUri(k.URI.revive(I.resolvedUri),{sourceUri:k.URI.revive(I.sourceUri)},n)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(ge[254],pe([0,1,5,2,6,16,26]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(I,n){if(this.handles.has(T.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const A=y.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(I)),this.handlers.set(A,n),this._proxy.$registerUriHandler(A,I),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(I)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(I,n){const A=this.handlers.get(I);if(!A)return Promise.resolve(void 0);try{A.handleUri(L.URI.revive(n))}catch(d){(0,C.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(I){return L.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=y,y.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[67],pe([0,1,3,2,179,204,88,5]),function(J,e,g,L,k,C,T,y){"use strict";var _,I,n,A,d,m,l,v,S,b,P,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(u,w,E,s,D,R,U){_.set(this,void 0),I.set(this,void 0),n.set(this,void 0),A.set(this,void 0),d.set(this,void 0),m.set(this,void 0),l.set(this,""),v.set(this,void 0),S.set(this,!1),b.set(this,!1),P.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new g.Emitter),this._onDidDispose=He(this,c,"f").event,it(this,_,u,"f"),it(this,I,w,"f"),it(this,v,E,"f"),it(this,A,s,"f"),it(this,d,D,"f"),it(this,m,R,"f"),it(this,P,p(R),"f"),it(this,n,U,"f")}dispose(){it(this,S,!0,"f"),He(this,c,"f").fire(),He(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return it(this,b,!0,"f"),(0,T.asWebviewUri)(u,He(this,A,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),He(this,l,"f")}set html(u){this.assertNotDisposed(),He(this,l,"f")!==u&&(it(this,l,u,"f"),!He(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(it(this,b,!0,"f"),He(this,n,"f").report("Webview vscode-resource: uris",He(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,I,"f").$setHtml(He(this,_,"f"),u))}get options(){return this.assertNotDisposed(),He(this,v,"f")}set options(u){this.assertNotDisposed(),He(this,I,"f").$setOptions(He(this,_,"f"),o(He(this,m,"f"),He(this,d,"f"),u)),it(this,v,u,"f")}async postMessage(u){if(He(this,S,"f"))return!1;const w=(0,C.serializeWebviewMessage)(u,{serializeBuffersForPostMessage:He(this,P,"f")});return He(this,I,"f").$postMessage(He(this,_,"f"),w.message,...w.buffers)}assertNotDisposed(){if(He(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,_=new WeakMap,I=new WeakMap,n=new WeakMap,A=new WeakMap,d=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap,b=new WeakMap,P=new WeakMap,c=new WeakMap;function p(h){try{const u=(0,k.normalizeVersion)((0,k.parseVersion)(h.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(u,w,E,s,D){this.initData=w,this.workspace=E,this._logService=s,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=u.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(u,w,...E){const s=this.getWebview(u);if(s){const{message:D}=(0,C.deserializeWebviewMessage)(w,E);s._onMessageEmitter.fire(D)}}$onMissingCsp(u,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,w,E){const s=new f(u,this._webviewProxy,i(w),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(u,s),s._onDidDispose(()=>{this._webviews.delete(u)}),s}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=t;function r(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=r;function o(h,u,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||a(h,u)}}e.serializeWebviewOptions=o;function i(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(u=>L.URI.from(u))}}e.reviveOptions=i;function a(h,u){return[...(u?.getWorkspaceFolders()||[]).map(w=>w.uri),h.extensionLocation]}}),define(ge[255],pe([0,1,21,58,6,10,23,2,15,67,86,5,7]),function(J,e,g,L,k,C,T,y,_,I,n,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class l{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,o){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new m(r,o);return this._documents.set(i,a),a}delete(t,r){const o=this.key(t,r.uri);this._documents.delete(o)}key(t,r){return`${t}@@@${r}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class S{constructor(){this._providers=new Map}addTextProvider(t,r,o){return this.add(0,t,r,o)}addCustomProvider(t,r,o){return this.add(1,t,r,o)}get(t){return this._providers.get(t)}add(t,r,o,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:o,provider:i}),new d.Disposable(()=>this._providers.delete(r))}}class b{constructor(t,r,o,i,a){this._extHostDocuments=r,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=a,this._editorProviders=new S,this._documents=new l,this._proxy=t.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,o,i){const a=new k.DisposableStore;return P(o)?(a.add(this._editorProviders.addTextProvider(r,t,o)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(r,t,o)),this.supportEditing(o)&&a.add(o.onDidChangeCustomDocument(h=>{const u=this.getCustomDocumentEntry(r,h.document.uri);if(c(h)){const w=u.addEdit(h);this._proxy.$onDidEdit(h.document.uri,r,w,h.label)}else this._proxy.$onContentChange(h.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(a,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,o,i,a){const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${r}'`);const u=y.URI.revive(t),w=await h.provider.openCustomDocument(u,{backupId:o,untitledDocumentData:i?.buffer},a);let E;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(r,w,E),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=y.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,o,i,a,h){const u=this._editorProviders.get(o);if(!u)throw new Error(`No provider found for '${o}'`);const w=_.ViewColumn.to(a),E=this._extHostWebview.createNewWebview(r,i.webviewOptions,u.extension),s=this._extHostWebviewPanels.createNewWebviewPanel(r,o,i.title,w,i.panelOptions,E),D=y.URI.revive(t);switch(u.type){case 1:{const{document:R}=this.getCustomDocumentEntry(o,D);return u.provider.resolveCustomEditor(R,s,h)}case 0:{const R=this._extHostDocuments.getDocument(D);return u.provider.resolveCustomTextEditor(R,s,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,o){this.getCustomDocumentEntry(r,t).disposeEdits(o)}async $onMoveCustomEditor(t,r,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const h=y.URI.revive(r),u=this._extHostDocuments.getDocument(h);await i.provider.moveCustomTextEditor(u,a,g.CancellationToken.None)}async $undo(t,r,o,i){return this.getCustomDocumentEntry(r,t).undo(o,i)}async $redo(t,r,o,i){return this.getCustomDocumentEntry(r,t).redo(o,i)}async $revert(t,r,o){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(t,r,o){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(t,r,o,i){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,y.URI.revive(o),i)}async $backup(t,r,o){const i=this.getCustomDocumentEntry(r,t),h=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(h),h.id}getCustomDocumentEntry(t,r){const o=this._documents.get(t,y.URI.revive(r));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const o=this._editorProviders.get(t)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function P(p){return typeof p.resolveCustomTextEditor=="function"}function c(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function f(p){const t=p.scheme===C.Schemas.file||p.scheme===C.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[256],pe([0,1,3,6,2,32,15,67,5,7]),function(J,e,g,L,k,C,T,y,_,I){"use strict";var n,A,d,m,l,v,S,b,P,c,f,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends L.Disposable{constructor(h,u,w,E,s,D,R){super();n.set(this,void 0),A.set(this,void 0),d.set(this,void 0),m.set(this,void 0),l.set(this,void 0),v.set(this,void 0),S.set(this,void 0),b.set(this,void 0),P.set(this,!0),c.set(this,!0),f.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,p,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,it(this,n,h,"f"),it(this,A,u,"f"),it(this,d,w,"f"),it(this,l,D,"f"),it(this,b,s,"f"),it(this,v,E,"f"),it(this,m,R,"f")}dispose(){He(this,f,"f")||(it(this,f,!0,"f"),He(this,p,"f").fire(),He(this,A,"f").$disposeWebview(He(this,n,"f")),He(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,m,"f")}get viewType(){return this.assertNotDisposed(),He(this,d,"f")}get title(){return this.assertNotDisposed(),He(this,v,"f")}set title(h){this.assertNotDisposed(),He(this,v,"f")!==h&&(it(this,v,h,"f"),He(this,A,"f").$setTitle(He(this,n,"f"),h))}get iconPath(){return this.assertNotDisposed(),He(this,S,"f")}set iconPath(h){this.assertNotDisposed(),He(this,S,"f")!==h&&(it(this,S,h,"f"),He(this,A,"f").$setIconPath(He(this,n,"f"),k.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return He(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,b,"f")=="number"&&He(this,b,"f")<0))return He(this,b,"f")}get active(){return this.assertNotDisposed(),He(this,c,"f")}get visible(){return this.assertNotDisposed(),He(this,P,"f")}_updateViewState(h){He(this,f,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(it(this,c,h.active,"f"),it(this,P,h.visible,"f"),it(this,b,h.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(h,u){this.assertNotDisposed(),He(this,A,"f").$reveal(He(this,n,"f"),{viewColumn:h?T.ViewColumn.from(h):void 0,preserveFocus:!!u})}assertNotDisposed(){if(He(this,f,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,A=new WeakMap,d=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap,b=new WeakMap,P=new WeakMap,c=new WeakMap,f=new WeakMap,p=new WeakMap,t=new WeakMap;class o{constructor(h,u,w){this.webviews=u,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(h,u,w,E,s={}){const D=typeof E=="object"?E.viewColumn:E,R={viewColumn:T.ViewColumn.from(D),preserveFocus:typeof E=="object"&&!!E.preserveFocus},U=(0,y.shouldSerializeBuffersForPostMessage)(h),V=o.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(h),V,u,{title:w,panelOptions:i(s),webviewOptions:(0,y.serializeWebviewOptions)(h,this.workspace,s),serializeBuffersForPostMessage:U},R);const ee=this.webviews.createNewWebview(V,s,h);return this.createNewWebviewPanel(V,u,w,D,s,ee)}$onDidChangeWebviewPanelViewStates(h){const u=Object.keys(h);u.sort((w,E)=>{const s=h[w],D=h[E];return s.active?1:D.active?-1:+s.visible-+D.visible});for(const w of u){const E=this.getWebviewPanel(w);if(!E)continue;const s=h[w];E._updateViewState({active:s.active,visible:s.visible,viewColumn:T.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,u,w){if(this._serializers.has(u))throw new Error(`Serializer for '${u}' already registered`);return this._serializers.set(u,{serializer:w,extension:h}),this._proxy.$registerSerializer(u,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(h)}),new I.Disposable(()=>{this._serializers.delete(u),this._proxy.$unregisterSerializer(u)})}async $deserializeWebviewPanel(h,u,w,E){const s=this._serializers.get(u);if(!s)throw new Error(`No serializer found for '${u}'`);const{serializer:D,extension:R}=s,U=this.webviews.createNewWebview(h,w.webviewOptions,R),V=this.createNewWebviewPanel(h,u,w.title,E,w.panelOptions,U);await D.deserializeWebviewPanel(V,w.state)}createNewWebviewPanel(h,u,w,E,s,D){const R=new r(h,this._proxy,u,w,E,s,D);return this._webviewPanels.set(h,R),R}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=o;function i(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[257],pe([0,1,3,6,67,5,7]),function(J,e,g,L,k,C,T){"use strict";var y,_,I,n,A,d,m,l,v,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends L.Disposable{constructor(f,p,t,r,o,i){super();y.set(this,void 0),_.set(this,void 0),I.set(this,void 0),n.set(this,void 0),A.set(this,!1),d.set(this,void 0),m.set(this,void 0),l.set(this,void 0),v.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=He(this,v,"f").event,S.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,S,"f").event,it(this,I,t,"f"),it(this,m,r,"f"),it(this,y,f,"f"),it(this,_,p,"f"),it(this,n,o,"f"),it(this,d,i,"f")}dispose(){He(this,A,"f")||(it(this,A,!0,"f"),He(this,S,"f").fire(),He(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,m,"f")}set title(f){this.assertNotDisposed(),He(this,m,"f")!==f&&(it(this,m,f,"f"),He(this,_,"f").$setWebviewViewTitle(He(this,y,"f"),f))}get description(){return this.assertNotDisposed(),He(this,l,"f")}set description(f){this.assertNotDisposed(),He(this,l,"f")!==f&&(it(this,l,f,"f"),He(this,_,"f").$setWebviewViewDescription(He(this,y,"f"),f))}get visible(){return He(this,d,"f")}get webview(){return He(this,n,"f")}get viewType(){return He(this,I,"f")}_setVisible(f){f===He(this,d,"f")||He(this,A,"f")||(it(this,d,f,"f"),He(this,v,"f").fire())}show(f){this.assertNotDisposed(),He(this,_,"f").$show(He(this,y,"f"),!!f)}assertNotDisposed(){if(He(this,A,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,_=new WeakMap,I=new WeakMap,n=new WeakMap,A=new WeakMap,d=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap;class P{constructor(f,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,p,t,r){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(f),p,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(f,p,t,r,o){const i=this._viewProviders.get(p);if(!i)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:h}=i,u=this._extHostWebview.createNewWebview(f,{},h),w=new b(f,this._proxy,p,t,u,!0);this._webviewViews.set(f,w),await a.resolveWebviewView(w,{state:r},o)}async $onDidChangeWebviewViewVisibility(f,p){this.getWebviewView(f)._setVisible(p)}async $disposeWebviewView(f){const p=this.getWebviewView(f);this._webviewViews.delete(f),p.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const p=this._webviewViews.get(f);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=P}),define(ge[132],pe([0,1,3,5,2,10,8,4,13]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class $n{constructor(A){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=A.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state={...this._state,focused:A},this._onDidChangeWindowState.fire(this._state))}openUri(A,d){let m;if(typeof A=="string"){m=A;try{A=k.URI.parse(A)}catch(l){return Promise.reject(`Invalid uri - '${A}'`)}}return(0,T.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,m,d)}async asExternalUri(A,d){if((0,T.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(A,d);return k.URI.from(m)}};I.InitialState={focused:!0},I=ze([$e(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(ge[258],pe([0,1,9,78,32,44,6,5,2,13]),function(J,e,g,L,k,C,T,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends T.Disposable{constructor(d,m){super();const l=d.getProxy(y.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async v=>{const S=_.URI.file((0,g.join)((0,L.tmpdir)(),(0,k.generateUuid)()));return await l.$download(v,S),S})}};n=ze([$e(0,I.IExtHostRpcService),$e(1,C.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(ge[259],pe([0,1,2,9,151,28,65,27,13,6,12,116,42]),function(J,e,g,L,k,C,T,y,_,I,n,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(b,P,c){this.name=b,this.file=P,this.appender=c}static async create(b,P){const c=await(0,A.createRotatingLogger)(b,P,30*d.ByteSize.MB,1);return c.clearFormatters(),new m(b,P,c)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class l extends T.AbstractExtHostOutputChannel{constructor(b,P,c,f){super(b,!1,g.URI.file(P.file),c,f);this._appender=P}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,P){this._appender.flush(),super.show(b,P)}clear(){this._appender.flush(),super.clear()}}let v=class extends T.ExtHostOutputService{constructor(b,P,c){super(b);this.logService=P,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new I.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(b){if(b){const P=this._channels.get(b);P&&(this._visibleChannelDisposable.value=P.onDidAppend(()=>P.update()))}}createOutputChannel(b,P){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const c=this._doCreateOutChannel(b,P);return c.then(f=>f._id.then(p=>this._channels.set(p,f))),new T.LazyOutputChannel(b,c)}async _doCreateOutChannel(b,P){try{const c=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(c)||await C.Promises.mkdir(c,{recursive:!0});const p=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(c,`${p}.log`)),r=await m.create(p,t.fsPath);return new l(b,r,P.identifier.value,this._proxy)}catch(c){return this.logService.error(c),new T.ExtHostPushOutputChannel(b,P.identifier.value,this._proxy)}}};v=ze([$e(0,_.IExtHostRpcService),$e(1,n.ILogService),$e(2,y.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(ge[260],pe([0,1,49,291,2,66,6,10,17]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class I extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==y.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let o=0;do{let i;o===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await n(i);const a=L.join(i,"vscode.lock"),h=await l(this._logService,a,!1);if(h)return this._workspaceStorageLock=h,process.on("exit",()=>{h.dispose()}),k.URI.file(i);o++}while(o<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=I;async function n(f){try{await g.promises.stat(f);return}catch{}try{await g.promises.mkdir(f,{recursive:!0})}catch{}}const A=1e3,d=10*60*1e3;class m extends T.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(p,t);(!r||r.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(o){p.error(o),p.info(`Lock '${t}': Could not update mtime.`)}},A)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function l(f,p,t){try{const o={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(p,JSON.stringify(o),{flag:"wx"})}catch(o){f.error(o)}const r=await v(f,p);return!r||r.pid!==process.pid?t?(f.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(f.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),P(f,p)):(f.info(`Lock '${p}': Lock acquired.`),new m(f,p))}async function v(f,p){let t;try{t=await g.promises.readFile(p)}catch(r){return f.error(r),null}try{return JSON.parse(String(t))}catch(r){return f.error(r),null}}async function S(f,p){let t;try{t=await g.promises.stat(p)}catch(r){return f.error(r),0}return t.mtime.getTime()}function b(f){try{return process.kill(f,0),!0}catch(p){return!1}}async function P(f,p){const t=await v(f,p);if(!t)return f.info(`Lock '${p}': Could not read pid of lock holder.`),c(f,p);if(t.willReleaseAt){let h=t.willReleaseAt-Date.now();if(h<5e3){for(h>0?f.info(`Lock '${p}': The lockfile is scheduled to be released in ${h} ms.`):f.info(`Lock '${p}': The lockfile is scheduled to have been released.`);h>0;){if(await(0,_.timeout)(Math.min(100,h)),await S(f,p)===0)return c(f,p);h=t.willReleaseAt-Date.now()}return c(f,p)}}if(!b(t.pid))return f.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),c(f,p);const r=await S(f,p),o=Date.now()-r;if(o<=d)return f.info(`Lock '${p}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;f.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const i=await S(f,p),a=Date.now()-i;return a<=d?(f.info(`Lock '${p}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(f.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),c(f,p))}async function c(f,p){f.info(`Lock '${p}': Deleting a stale lock.`);try{await g.promises.unlink(p)}catch(t){}return l(f,p,!0)}}),define(ge[261],pe([0,1,32,13,33]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends k.BaseExtHostTerminalService{constructor(y){super(!0,y)}createTerminal(y,_,I){return this.createTerminalFromOptions({name:y,shellPath:_,shellArgs:I})}createTerminalFromOptions(y,_){const I=new k.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),y,y.name);return this._terminals.push(I),I.create(y,_),I.value}};C=ze([$e(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(ge[262],pe([0,1,5,13,6,27,2,39,23,28,7,11,52,3,193,75,12]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(u,w,E){this.remoteAddress=u,this.localAddress=w,this._dispose=E,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function P(h){const u=h.trim().split(`
`),w=[];return u.forEach(s=>{const D=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(s);D&&D.length>=3&&w.push({pid:parseInt(D[1],10),socket:parseInt(D[2],10)})}),w.reduce((s,D)=>(s[D.socket]=D,s),{})}e.getSockets=P;function c(...h){const u=[].concat(...h.map(p));return[...new Map(u.filter(w=>w.st==="0A").map(w=>{const E=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:f(E[0]),port:parseInt(E[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=c;function f(h){let u="";if(h.length===8)for(let w=h.length-2;w>=0;w-=2)u+=parseInt(h.substr(w,2),16),w!==0&&(u+=".");else for(let w=h.length-4;w>=0;w-=4)u+=parseInt(h.substr(w,4),16).toString(16),w!==0&&(u+=":");return u}e.parseIpAddress=f;function p(h){const u=h.trim().split(`
`),w=u.shift().trim().split(/\s+/).filter(s=>s!=="rx_queue"&&s!=="tm->when");return u.map(s=>s.trim().split(/\s+/).reduce((D,R,U)=>(D[w[U]||U]=R,D),{}))}e.loadConnectionTable=p;function t(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function r(h){const u=h.trim().split(`
`),w=[];return u.forEach(E=>{const s=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);s&&s.length>=4&&w.push({pid:parseInt(s[1],10),ppid:parseInt(s[2]),cmd:s[3]})}),w}e.getRootProcesses=r;async function o(h,u,w){const E=w.reduce((D,R)=>(D[R.pid]=R,D),{}),s=[];return h.forEach(({socket:D,ip:R,port:U})=>{const V=u[D]?u[D].pid:void 0,ee=V?E[V]?.cmd:void 0;V&&ee&&!t(ee)&&s.push({host:R,port:U,detail:ee,pid:V})}),s}e.findPorts=o;function i(h,u,w){const E=new Map,s=r(u);for(const D of h){const R=w.get(D.port);if(R){E.set(D.port,R);continue}const U=s.find(V=>V.cmd.includes(`${D.port}`));if(U){let V=U,ee;do ee=s.find(Q=>Q.ppid===V.pid),ee&&(V=ee);while(ee);E.set(D.port,{host:D.ip,port:D.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else E.set(D.port,{host:D.ip,port:D.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=i;let a=class extends k.Disposable{constructor(u,w,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(g.MainContext.MainThreadTunnelService),A.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(u,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(w,u.displayName);if(E){const s=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(s),s}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,w){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:u,provider:w}),this._proxy.$registerPortsAttributesProvider(u,E),new n.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(u,w,E,s,D){const R=[];for(const V of u){const ee=this._portAttributesProviders.get(V);if(!ee)return[];R.push(...await Promise.all(w.map(async Q=>ee.provider.providePortAttributes(Q,E,s,D))))}const U=R.filter(V=>!!V);return U.length>0?U.map(V=>({autoForwardAction:V.autoForwardAction,port:V.port})):[]}async $registerCandidateFinder(u){if(u&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=u;let w=new v.MovingAverage,E;for(;this._candidateFindingEnabled;){const s=new Date().getTime(),D=(await this.findCandidatePorts()).filter(U=>(0,l.isLocalhost)(U.host)||(0,l.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${D.map(U=>U.port).join(", ")}`);const R=new Date().getTime()-s;w.update(R),(!E||JSON.stringify(E)!==JSON.stringify(D))&&(E=D,await this._proxy.$onFoundNewCandidates(E)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(u){return u?(u.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,this._proxy.$setCandidateFilter()),u.tunnelFactory&&(this._forwardPortProvider=u.tunnelFactory,this._proxy.$setTunnelProvider(u.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,w){if(this._extensionTunnels.has(u.host)){const E=this._extensionTunnels.get(u.host);E.has(u.port)&&(w&&E.get(u.port).disposeListener.dispose(),await E.get(u.port).tunnel.dispose(),E.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(u,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const s=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const D=this._register(s.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(s.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:s,disposeListener:D}),d.TunnelDto.fromApiTunnel(s)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const w=await Promise.all(u.map(s=>this._showCandidatePort(s.host,s.port,s.detail??""))),E=u.filter((s,D)=>w[D]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(s=>s.port).join(", ")} to ${E.map(s=>s.port).join(", ")}`),E}async findCandidatePorts(){let u="",w="";try{u=await I.Promises.readFile("/proc/net/tcp","utf8"),w=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const E=c(u,w),s=await new Promise(x=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,z,M)=>{x(z)})}),D=P(s),R=await I.Promises.readdir("/proc"),U=[];for(let x of R)try{const F=Number(x),z=_.joinPath(T.URI.file("/proc"),x);if((await I.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(F)){const N=await I.Promises.readlink(_.joinPath(z,"cwd").fsPath),q=await I.Promises.readFile(_.joinPath(z,"cmdline").fsPath,"utf8");U.push({pid:F,cwd:N,cmd:q})}}catch(F){}const V=[],ee=E.filter(x=>{const F=D[x.socket];return F||V.push(x),F}),Q=o(ee,D,U);let O;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const x=await new Promise(F=>{(0,y.exec)("ps -F -A -l | grep root",(z,M,N)=>{F(M)})});this._foundRootPorts=i(V,x,this._foundRootPorts),O=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${O.join(", ")}`)}return Q.then(x=>O?x.concat(O):x)}};a=ze([$e(0,L.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,S.ILogService)],a),e.ExtHostTunnelService=a}),define(ge[263],pe([0,1,17,21,16,3,6,103,227,130,24]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(i,a){try{return JSON.stringify(i,a)}catch(h){return"null"}}function m(i,a){return JSON.stringify(i,a)}function l(i){return i?(a,h)=>h&&h.$mid===1?i.transformOutgoing(h):h:null}var v;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},P=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class f extends T.Disposable{constructor(a,h=null,u=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=h,this._uriTransformer=u,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,E=I.ProxyIdentifier.count;w<E;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,y.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:h,sid:u}=a;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,u)),this._proxies[h]}_createProxy(a,h){let u={get:(w,E)=>(typeof E=="string"&&!w[E]&&E.charCodeAt(0)===36&&(w[E]=(...s)=>this._remoteCall(a,E,s)),E===c?h:w[E])};return new Proxy(Object.create(null),u)}set(a,h){return this._locals[a.nid]=h,h}assertRegistered(a){for(let h=0,u=a.length;h<u;h++){const w=a[h];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const h=a.byteLength,u=p.read(a,0),w=u.readUInt8(),E=u.readUInt32();switch(w){case 1:case 2:{let{rpcId:s,method:D,args:R}=t.deserializeRequestJSONArgs(u);this._uriTransformer&&(R=(0,y.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(h,E,s,D,R,w===2);break}case 3:case 4:{let{rpcId:s,method:D,args:R}=t.deserializeRequestMixedArgs(u);this._uriTransformer&&(R=(0,y.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(h,E,s,D,R,w===4);break}case 5:{this._logger&&this._logger.logIncoming(h,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(h,E);break}case 7:{this._receiveReply(h,E,void 0);break}case 9:{let s=t.deserializeReplyOKJSON(u);this._uriTransformer&&(s=(0,y.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReply(h,E,s);break}case 8:{let s=t.deserializeReplyOKVSBuffer(u);this._receiveReply(h,E,s);break}case 10:{let s=t.deserializeReplyErrError(u);this._uriTransformer&&(s=(0,y.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReplyErr(h,E,s);break}case 11:{this._receiveReplyErr(h,E,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,h,u,w,E,s){this._logger&&this._logger.logIncoming(a,h,1,`receiveRequest ${(0,I.getStringIdentifierForProxy)(u)}.${w}(`,E);const D=String(h);let R,U;if(s){const ee=new L.CancellationTokenSource;E.push(ee.token),R=this._invokeHandler(u,w,E),U=()=>ee.cancel()}else R=this._invokeHandler(u,w,E),U=b;this._cancelInvokedHandlers[D]=U;const V=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(V.byteLength,h,1,"ack"),this._protocol.send(V),R.then(ee=>{delete this._cancelInvokedHandlers[D];const Q=t.serializeReplyOK(h,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,h,1,"reply:",ee),this._protocol.send(Q)},ee=>{delete this._cancelInvokedHandlers[D];const Q=t.serializeReplyErr(h,ee);this._logger&&this._logger.logOutgoing(Q.byteLength,h,1,"replyErr:",ee),this._protocol.send(Q)})}_receiveCancel(a,h){this._logger&&this._logger.logIncoming(a,h,1,"receiveCancel");const u=String(h);this._cancelInvokedHandlers[u]&&this._cancelInvokedHandlers[u]()}_receiveReply(a,h,u){this._logger&&this._logger.logIncoming(a,h,0,"receiveReply:",u);const w=String(h);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],E.resolveOk(u)}_receiveReplyErr(a,h,u){this._logger&&this._logger.logIncoming(a,h,0,"receiveReplyErr:",u);const w=String(h);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let s;u&&(u.$isError?(s=new Error,s.name=u.name,s.message=u.message,s.stack=u.stack):s=u),E.resolveErr(s)}_invokeHandler(a,h,u){try{return Promise.resolve(this._doInvokeHandler(a,h,u))}catch(w){return Promise.reject(w)}}_doInvokeHandler(a,h,u){const w=this._locals[a];if(!w)throw new Error("Unknown actor "+(0,I.getStringIdentifierForProxy)(a));let E=w[h];if(typeof E!="function")throw new Error("Unknown method "+h+" on actor "+(0,I.getStringIdentifierForProxy)(a));return E.apply(w,u)}_remoteCall(a,h,u){if(this._isDisposed)return Promise.reject(k.canceled());let w=null;if(u.length>0&&L.CancellationToken.isCancellationToken(u[u.length-1])&&(w=u.pop()),w&&w.isCancellationRequested)return Promise.reject(k.canceled());const E=t.serializeRequestArguments(u,this._uriReplacer),s=++this._lastMessageId,D=String(s),R=new _.LazyPromise;w&&w.onCancellationRequested(()=>{const V=t.serializeCancel(s);this._logger&&this._logger.logOutgoing(V.byteLength,s,0,"cancel"),this._protocol.send(t.serializeCancel(s))}),this._pendingRPCReplies[D]=R,this._onWillSendRequest(s);const U=t.serializeRequest(s,a,h,E,!!w);return this._logger&&this._logger.logOutgoing(U.byteLength,s,0,`request: ${(0,I.getStringIdentifierForProxy)(a)}.${h}(`,u),this._protocol.send(U),R}}e.RPCProtocol=f,A=P,f.UNRESPONSIVE_TIME=3*1e3;class p{constructor(a,h){this._buff=a,this._offset=h}static alloc(a,h,u){let w=new p(n.VSBuffer.alloc(u+1+4),0);return w.writeUInt8(a),w.writeUInt32(h),w}static read(a,h){return new p(a,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const u=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,u}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,u}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,h}static sizeMixedArray(a,h){let u=0;u+=1;for(let w=0,E=a.length;w<E;w++){const s=a[w],D=h[w];switch(u+=1,D){case 1:u+=this.sizeLongString(s);break;case 2:u+=this.sizeVSBuffer(s);break;case 3:break}}return u}writeMixedArray(a,h){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let u=0,w=a.length;u<w;u++){const E=a[u];switch(h[u]){case 1:this.writeUInt8(1),this.writeLongString(E);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(a);for(let u=0;u<a;u++)switch(this.readUInt8()){case 1:h[u]=this.readLongString();break;case 2:h[u]=this.readVSBuffer();break;case 3:h[u]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(a){for(let h=0,u=a.length;h<u;h++)if(a[h]instanceof n.VSBuffer||typeof a[h]=="undefined")return!0;return!1}static serializeRequestArguments(a,h){if(this._arrayContainsBufferOrUndefined(a)){let u=[],w=[];for(let E=0,s=a.length;E<s;E++){const D=a[E];D instanceof n.VSBuffer?(u[E]=D,w[E]=2):typeof D=="undefined"?(u[E]=n.VSBuffer.alloc(0),w[E]=3):(u[E]=n.VSBuffer.fromString(m(D,h)),w[E]=1)}return{type:"mixed",args:u,argsType:w}}return{type:"simple",args:m(a,h)}}static serializeRequest(a,h,u,w,E){return w.type==="mixed"?this._requestMixedArgs(a,h,u,w.args,w.argsType,E):this._requestJSONArgs(a,h,u,w.args,E)}static _requestJSONArgs(a,h,u,w,E){const s=n.VSBuffer.fromString(u),D=n.VSBuffer.fromString(w);let R=0;R+=p.sizeUInt8(),R+=p.sizeShortString(s),R+=p.sizeLongString(D);let U=p.alloc(E?2:1,a,R);return U.writeUInt8(h),U.writeShortString(s),U.writeLongString(D),U.buffer}static deserializeRequestJSONArgs(a){const h=a.readUInt8(),u=a.readShortString(),w=a.readLongString();return{rpcId:h,method:u,args:JSON.parse(w)}}static _requestMixedArgs(a,h,u,w,E,s){const D=n.VSBuffer.fromString(u);let R=0;R+=p.sizeUInt8(),R+=p.sizeShortString(D),R+=p.sizeMixedArray(w,E);let U=p.alloc(s?4:3,a,R);return U.writeUInt8(h),U.writeShortString(D),U.writeMixedArray(w,E),U.buffer}static deserializeRequestMixedArgs(a){const h=a.readUInt8(),u=a.readShortString(),w=a.readMixedArray(),E=new Array(w.length);for(let s=0,D=w.length;s<D;s++){const R=w[s];typeof R=="string"?E[s]=JSON.parse(R):E[s]=R}return{rpcId:h,method:u,args:E}}static serializeAcknowledged(a){return p.alloc(5,a,0).buffer}static serializeCancel(a){return p.alloc(6,a,0).buffer}static serializeReplyOK(a,h,u){return typeof h=="undefined"?this._serializeReplyOKEmpty(a):h instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(a,h):this._serializeReplyOKJSON(a,d(h,u))}static _serializeReplyOKEmpty(a){return p.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,h){let u=0;u+=p.sizeVSBuffer(h);let w=p.alloc(8,a,u);return w.writeVSBuffer(h),w.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,h){const u=n.VSBuffer.fromString(h);let w=0;w+=p.sizeLongString(u);let E=p.alloc(9,a,w);return E.writeLongString(u),E.buffer}static deserializeReplyOKJSON(a){const h=a.readLongString();return JSON.parse(h)}static serializeReplyErr(a,h){return h?this._serializeReplyErrEror(a,h):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,h){const u=n.VSBuffer.fromString(d(k.transformErrorForSerialization(h),null));let w=0;w+=p.sizeLongString(u);let E=p.alloc(10,a,w);return E.writeLongString(u),E.buffer}static deserializeReplyErrError(a){const h=a.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(a){return p.alloc(11,a,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var o;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[264],pe([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(ge[265],pe([0,1,10,9,11,2,4,84,43,222,264]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let A=class Wn{constructor(m,l,v,S){this.localUserHome=m,this.remoteAgentService=l,this.environmentService=v,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||m})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,l){if(m.remoteAuthority)return g.Schemas.vscodeRemote;const v=(0,y.getVirtualWorkspaceScheme)(l.getWorkspace());if(v)return v;const S=l.getWorkspace().folders[0];if(S)return S.uri.scheme;const b=l.getWorkspace().configuration;return b?b.scheme:g.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?L.win32:L.posix)}async fileURI(m){let l="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const S=m.indexOf("/",2);S===-1?(l=m.substring(2),m="/"):(l=m.substring(2,S),m=m.substring(S)||"/")}return C.URI.from({scheme:g.Schemas.file,authority:l,path:m,query:"",fragment:""})}};A=ze([$e(1,n.IRemoteAgentService),$e(2,I.IWorkbenchEnvironmentService),$e(3,_.IWorkspaceContextService)],A),e.AbstractPathService=A}),define(ge[68],pe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,y){this.line=T,this.character=y}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,y){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class L{constructor(T,y,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,y),this.end=new g(_,I)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var k;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,20,30,25,29,8,4,9,16,68]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",d=" characters skipped \u27EB",m=(A.length+d.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var l;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function S(F){return!!F.preview}e.resultIsMatch=S;function b(F){return!!F.resource}e.isFileMatch=b;function P(F){return!!F.message}e.isProgressMessage=P;var c;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=f;class p{constructor(z,M,N){this.ranges=M;const q=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&t(q)){z=(0,T.getNLines)(z,N.matchLines);let B="",K=0,te=0;const he=Math.floor(N.charsPerLine/5),De=[];for(const Pe of q){const Fe=Math.max(Pe.startColumn-he,0),qe=Pe.startColumn+N.charsPerLine;if(Fe>te+he+m){const We=A+(Fe-te)+d;B+=We+z.slice(Fe,qe),K+=Fe-(te+We.length)}else B+=z.slice(te,qe);De.push(new o(0,Pe.startColumn-K,Pe.endColumn-K)),te=qe}this.preview={text:B,matches:Array.isArray(this.ranges)?De:De[0]}}else{const B=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:z,matches:(0,g.mapArrayOrNot)(M,K=>new r(K.startLineNumber-B,K.startColumn,K.endLineNumber-B,K.endColumn))}}}}e.TextSearchMatch=p;function t(F){const z=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==z||M.endLineNumber!==z)return!1;return!0}class r{constructor(z,M,N,q){this.startLineNumber=z,this.startColumn=M,this.endLineNumber=N,this.endColumn=q}}e.SearchRange=r;class o extends r{constructor(z,M,N){super(z,M,z,N)}}e.OneLineRange=o;var i;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function a(F,z=!0){const M=F&&F.files&&F.files.exclude,N=z&&F&&F.search&&F.search.exclude;if(!M&&!N)return;if(!M||!N)return M||N;let q=Object.create(null);return q=k.mixin(q,k.deepClone(M)),q=k.mixin(q,k.deepClone(N),!0),q}e.getExcludes=a;function h(F,z){return F.excludePattern&&L.match(F.excludePattern,z)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&L.match(F.includePattern,z)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(C.isEqualOrParent(z,N)){const q=_.relative(N,z);return!M.includePattern||!!L.match(M.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var u;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(z,M){super(z);this.code=M}}e.SearchError=w;function E(F){const z=F.message;if((0,I.isPromiseCanceledError)(F))return new w(z,u.canceled);try{const M=JSON.parse(z);return new w(M.message,M.code)}catch(M){return new w(z,u.other)}}e.deserializeSearchError=E;function s(F){const z={message:F.message,code:F.code};return new Error(JSON.stringify(z))}e.serializeSearchError=s;function D(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=D;function R(F){return F.type==="success"}e.isSerializedSearchSuccess=R;function U(F){return!!F.path}e.isSerializedFileMatch=U;function V(F,z){const M=F.searchPath?F.searchPath:F.relativePath;return(0,T.fuzzyContains)(M,z)}e.isFilePatternMatch=V;class ee{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function Q(F,z){const M={...F||{},...z||{}};return Object.keys(M).filter(N=>{const q=M[N];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=Q;class O{constructor(z,M){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let N=z.includePattern;M.includePattern&&(N?N={...N,...M.includePattern}:N=M.includePattern),N&&(this._parsedIncludeExpression=L.parse(N))}includedInQuerySync(z,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,M,N))}includedInQuery(z,M,N){return Promise.resolve(this._parsedExcludeExpression(z,M,N)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(z,M,N)).then(K=>!!K):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=O;function x(F){for(const z in F)if(typeof F[z]!="boolean")return!0;return!1}}),define(ge[36],pe([0,1,20,17,21,3,22,10,75,23,8,14,2,169,4,12,189,43,62,27,13,7,31,5]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c,f,p,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(D,R,U){return new I.ExtUri(V=>u(V,U)).isEqual(D,R)}function i(D,R,U){return o(D.uri,R.uri,U)?0:(0,n.compare)(D.uri.toString(),R.uri.toString())}function a(D,R,U){return D.index!==R.index?D.index<R.index?-1:1:o(D.uri,R.uri,U)?(0,n.compare)(D.name,R.name):(0,n.compare)(D.uri.toString(),R.uri.toString())}function h(D,R,U,V){const ee=D.slice(0).sort((O,x)=>U(O,x,V)),Q=R.slice(0).sort((O,x)=>U(O,x,V));return(0,g.delta)(ee,Q,(O,x)=>U(O,x,V))}function u(D,R){const U=R.getCapabilities(D.scheme);return!(U&&U&1024)}class w extends b.Workspace{constructor(R,U,V,ee,Q,O){super(R,V.map(x=>new b.WorkspaceFolder(x)),ee,O);this._name=U,this._isUntitled=Q,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(O),V.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(R,U,V,ee){if(!R)return{workspace:null,added:[],removed:[]};const{id:Q,name:O,folders:x,configuration:F,isUntitled:z}=R,M=[],N=U;U?x.forEach((te,he)=>{const De=d.URI.revive(te.uri),Pe=w._findFolder(V||U,De,ee);Pe?(Pe.name=te.name,Pe.index=te.index,M.push(Pe)):M.push({uri:De,name:te.name,index:he})}):M.push(...x.map(({uri:te,name:he,index:De})=>({uri:d.URI.revive(te),name:he,index:De}))),M.sort((te,he)=>te.index<he.index?-1:1);const q=new w(Q,O,M,F?d.URI.revive(F):null,!!z,te=>u(te,ee)),{added:B,removed:K}=h(N?N.workspaceFolders:[],q.workspaceFolders,i,ee);return{workspace:q,added:B,removed:K}}static _findFolder(R,U,V){for(let ee=0;ee<R.folders.length;ee++){const Q=R.workspaceFolders[ee];if(o(Q.uri,U,V))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,U){return U&&this._structure.get(R)&&(R=(0,I.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let E=class{constructor(R,U,V,ee){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ee,this._extHostFileSystemInfo=V,this._requestIdProvider=new _.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(r.MainContext.MainThreadMessageService);const Q=U.workspace;this._confirmedWorkspace=Q?new w(Q.id,Q.name,[],Q.configuration?d.URI.revive(Q.configuration):null,!!Q.isUntitled,O=>u(O,V)):void 0}$initializeWorkspace(R,U){this._trusted=U,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:y.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,U,V,...ee){const Q=[];if(Array.isArray(ee)&&ee.forEach(M=>{d.URI.isUri(M.uri)&&!Q.some(N=>o(N.uri,M.uri,this._extHostFileSystemInfo))&&Q.push({uri:M.uri,name:M.name||(0,I.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[U,V].some(M=>typeof M!="number"||M<0)||V===0&&Q.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+V>O.length)return!1;const x=O.slice(0);x.splice(U,V,...Q.map(M=>({uri:M.uri,name:M.name||(0,I.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const N=x[M];if(x.some((q,B)=>B!==M&&o(N.uri,q.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,N)=>M.index=N);const{added:F,removed:z}=h(O,x,a,this._extHostFileSystemInfo);if(F.length===0&&z.length===0)return!1;if(this._proxy){const M=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(M,U,V,Q).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,m.localize)(0,null,M,N.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(R,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,U)}async getWorkspaceFolder2(R,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,U)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,U){let V,ee="";if(typeof R=="string"?(V=d.URI.file(R),ee=R):typeof R!="undefined"&&(V=R,ee=R.fsPath),!V)return ee;const Q=this.getWorkspaceFolder(V,!0);if(!Q)return ee;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let O=(0,I.relativePath)(Q.uri,V);return U&&Q.name&&(O=`${Q.name}/${O}`),O}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:U,added:V,removed:ee}=w.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:V,removed:ee}))}findFiles(R,U,V,ee,Q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ee.value}, entryPoint: findFiles`);let O;if(U===null?O=!1:U&&(typeof U=="string"?O=U:O=U.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:F}=s(R);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(x),(0,A.withUndefinedAsNull)(F),(0,A.withUndefinedAsNull)(O),(0,A.withUndefinedAsNull)(V),Q).then(z=>Array.isArray(z)?z.map(M=>d.URI.revive(M)):[])}async findTextInFiles(R,U,V,ee,Q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ee.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),x=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:F,folder:z}=s(U.include),M=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,N={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:x,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:F,excludePattern:M},q=!1;if(this._activeSearchCallbacks[O]=B=>{if(q)return;const K=d.URI.revive(B.resource);B.results.forEach(te=>{(0,t.resultIsMatch)(te)?V({uri:K,preview:{text:te.preview.text,matches:(0,g.mapArrayOrNot)(te.preview.matches,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,g.mapArrayOrNot)(te.ranges,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):V({uri:K,text:te.text,lineNumber:te.lineNumber})})},Q.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(R,(0,A.withUndefinedAsNull)(z),N,O,Q);return delete this._activeSearchCallbacks[O],B||{}}catch(B){throw delete this._activeSearchCallbacks[O],B}}$handleTextSearchResult(R,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=ze([$e(0,f.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,P.IExtHostFileSystemInfo),$e(3,v.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function s(D){let R,U;return D&&(typeof D=="string"?R=D:(R=D.pattern,U=D.baseFolder||d.URI.file(D.base))),{includePattern:R,folder:U}}}),define(ge[37],pe([0,1,25,3,36,5,7,192,83,14,17,4,13,12,2]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(r,o){if(o){const i=o.split(".");let a=r;for(let h=0;a&&h<i.length;h++)a=a[i[h]];return a}}function S(r){return r instanceof l.URI}function b(r){return r&&r.uri instanceof l.URI&&r.languageId&&typeof r.languageId=="string"}function P(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&r.uri instanceof l.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function f(r){if(S(r))return{resource:r};if(b(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(P(r))return{overrideIdentifier:r.languageId};if(c(r))return{resource:r.uri};if(r===null)return{resource:null}}let p=class{constructor(o,i,a){this._proxy=o.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=a,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,i))}};p=ze([$e(0,d.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,m.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(o,i,a,h){this._onDidChangeConfiguration=new L.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=i,this._configuration=y.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,a))}getConfiguration(o,i,a){const h=f(i)||{},u=this._toReadonlyValue(o?v(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,a?.identifier);function w(s){if(s==null)return null;if(typeof s=="boolean")return s?1:4;switch(s){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(s){return typeof v(u,s)!="undefined"},get:(s,D)=>{this._validateConfigurationAccess(o?`${o}.${s}`:s,h,a?.identifier);let R=v(u,s);if(typeof R=="undefined")R=D;else{let U;const V=(ee,Q)=>{let O;const x=()=>{U=U||(0,g.deepClone)(u),O=O||v(U,Q)};return(0,I.isObject)(ee)?new Proxy(ee,{get:(F,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return x(),()=>O;if(U)return O=O||v(U,Q),O[z];const M=F[z];return typeof z=="string"?V(M,`${Q}.${z}`):M},set:(F,z,M)=>(x(),O&&(O[z]=M),!0),deleteProperty:(F,z)=>(x(),O&&delete O[z],!0),defineProperty:(F,z,M)=>(x(),O&&Object.defineProperty(O,z,M),!0)}):ee};R=V(R,s)}return R},update:(s,D,R,U)=>{s=o?`${o}.${s}`:s;const V=w(R);return D!==void 0?this._proxy.$updateConfigurationOption(V,s,D,h,U):this._proxy.$removeConfigurationOption(V,s,h,U)},inspect:s=>{s=o?`${o}.${s}`:s;const D=(0,g.deepClone)(this._configuration.inspect(s,h,this._extHostWorkspace.workspace));if(D)return{key:s,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof u=="object"&&(0,g.mixin)(E,u,!1),Object.freeze(E)}_toReadonlyValue(o){const i=a=>(0,I.isObject)(a)?new Proxy(a,{get:(h,u)=>i(h[u]),set:(h,u,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(h,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(h,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(o)}_validateConfigurationAccess(o,i,a){const h=_.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),u=a?`[${a.value}] `:"";if(h===4){typeof i?.resource=="undefined"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){i?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const a=new y.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,u)=>a.affectsConfiguration(h,f(u))})}_toMap(o){return o.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[69],pe([0,1,2,17,3,5,25,7,36,45,37,21,33,13,27,4,10,11,12,64,212,16]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c,f,p){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var o;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(o=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(O){function x(M){if(M){const N=M;return N&&!!N.process}else return!1}O.is=x;function F(M){if(M==null)return;const N={process:M.process,args:M.args};return M.options&&(N.options=i.from(M.options)),N}O.from=F;function z(M){if(M!=null)return new y.ProcessExecution(M.process,M.args,M.options)}O.to=z})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(O){function x(M){if(M){const N=M;return N&&(!!N.commandLine||!!N.command)}else return!1}O.is=x;function F(M){if(M==null)return;const N={};return M.commandLine!==void 0?N.commandLine=M.commandLine:(N.command=M.command,N.args=M.args),M.options&&(N.options=h.from(M.options)),N}O.from=F;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new y.ShellExecution(M.commandLine,M.options):new y.ShellExecution(M.command,M.args?M.args:[],M.options)}O.to=z})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(O){function x(M){if(M){let N=M;return N&&N.customExecution==="customExecution"}else return!1}O.is=x;function F(M){return{customExecution:"customExecution"}}O.from=F;function z(M,N){return N.get(M)}O.to=z})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(O){function x(F,z){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===y.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=f.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}O.from=x})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var s;(function(O){function x(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}O.from=x})(s=e.TaskGroupDTO||(e.TaskGroupDTO={}));var D;(function(O){function x(M,N){if(M==null)return[];const q=[];for(let B of M){const K=F(B,N);K&&q.push(K)}return q}O.fromMany=x;function F(M,N){if(M==null)return;let q;M.execution instanceof y.ProcessExecution?q=a.from(M.execution):M.execution instanceof y.ShellExecution?q=u.from(M.execution):M.execution&&M.execution instanceof y.CustomExecution&&(q=w.from(M.execution));const B=r.from(M.definition);let K;return M.scope?typeof M.scope=="number"?K=M.scope:K=M.scope.uri:K=y.TaskScope.Workspace,!B||!K?void 0:{_id:M._id,definition:B,name:M.name,source:{extensionId:N.identifier.value,label:M.source,scope:K},execution:q,isBackground:M.isBackground,group:s.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=F;async function z(M,N,q){if(M==null)return;let B;a.is(M.execution)?B=a.to(M.execution):u.is(M.execution)?B=u.to(M.execution):w.is(M.execution)&&(B=w.to(M._id,q));const K=r.to(M.definition);let te;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?te=M.source.scope:te=await N.resolveWorkspaceFolder(g.URI.revive(M.source.scope)):te=y.TaskScope.Workspace),!K||!te)return;const he=new y.Task(K,te,M.name,M.source.label,B,M.problemMatchers);return M.isBackground!==void 0&&(he.isBackground=M.isBackground),M.group!==void 0&&(he.group=y.TaskGroup.from(M.group._id),he.group&&(he.group=T.deepClone(he.group),M.group.isDefault&&(he.group.isDefault=M.group.isDefault))),M.presentationOptions&&(he.presentationOptions=o.to(M.presentationOptions)),M._id&&(he._id=M._id),M.detail&&(he.detail=M.detail),he}O.to=z})(D=e.TaskDTO||(e.TaskDTO={}));var R;(function(O){function x(z){return z}O.from=x;function F(z){if(!!z)return Object.assign(Object.create(null),z)}O.to=F})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(x,F,z){this._id=F,this._task=z,t.set(this,void 0),it(this,t,x,"f")}get task(){return this._task}terminate(){He(this,t,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}t=new WeakMap;var V;(function(O){function x(F){return{id:F._id,task:void 0}}O.from=x})(V=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let ee=class{constructor(x,F,z,M,N,q,B,K){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=x.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=M,this._configurationService=N,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,F,z){if(!z)return new y.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:z,extension:x}),this._proxy.$registerTaskProvider(M,F),new y.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,F){this._proxy.$registerTaskSystem(x,F)}fetchTasks(x){return this._proxy.$fetchTasks(R.from(x)).then(async F=>{const z=[];for(let M of F){const N=await D.to(M,this._workspaceProvider,this._providedCustomExecutions2);N&&z.push(N)}return z})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(F=>x.push(F)),x}terminateTask(x){if(!(x instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,F,z){const M=this._providedCustomExecutions2.get(x.id);if(M){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(z))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const F=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:F,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:x.exitCode})}$provideTasks(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));const M=[],N=(0,L.asPromise)(()=>z.provider.provideTasks(A.CancellationToken.None)).then(q=>this.provideTasksInternal(F,M,z,q));return new Promise(q=>{N.then(B=>{Promise.all(M).then(()=>{q(B)})})})}async $resolveTask(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await D.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const N=await z.provider.resolveTask(M,A.CancellationToken.None);if(!N)return;this.checkDeprecation(N,z);const q=D.from(N,z.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(q.execution)&&await this.addCustomExecution(q,N,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,F,z){const M=await this._proxy.$createTaskId(x);!z&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(x,F){if(typeof x=="string"){const N=this._taskExecutionPromises.get(x);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let z=this._taskExecutionPromises.get(x.id);if(z)return z;const M=new Promise(async(N,q)=>{const B=F||await D.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);B?N(new U(this,x.id,B)):q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,M),M.then(N=>(this._taskExecutions.set(x.id,N),N),N=>Promise.reject(N))}checkDeprecation(x,F){x._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let z=this._notProvidedCustomExecutions.values(),M=z.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=z.next()}};ee=ze([$e(0,m.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,_.IExtHostWorkspace),$e(3,I.IExtHostDocumentsAndEditors),$e(4,n.IExtHostConfiguration),$e(5,d.IExtHostTerminalService),$e(6,P.ILogService),$e(7,c.IExtHostApiDeprecationService)],ee),e.ExtHostTaskBase=ee;let Q=class extends ee{constructor(x,F,z,M,N,q,B,K){super(x,F,z,M,N,q,B,K);this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(x,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=D.from(F,x);if(z===void 0)throw new Error("Task is not valid");if(w.is(z.execution))await this.addCustomExecution(z,F,!1);else throw new p.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),F);return this._proxy.$executeTask(z).catch(N=>{throw new Error(N)}),M}provideTasksInternal(x,F,z,M){const N=[];if(M)for(let q of M){this.checkDeprecation(q,z),(!q.definition||!x[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const B=D.from(q,z.extension);B&&w.is(B.execution)?(N.push(B),F.push(this.addCustomExecution(B,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:z.extension}}async resolveTaskInternal(x){if(w.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,F,z){}};Q=ze([$e(0,m.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,_.IExtHostWorkspace),$e(3,I.IExtHostDocumentsAndEditors),$e(4,n.IExtHostConfiguration),$e(5,d.IExtHostTerminalService),$e(6,P.ILogService),$e(7,c.IExtHostApiDeprecationService)],Q),e.WorkerExtHostTask=Q,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(ge[266],pe([0,1,20,55,30,77,22,10,9,23,8,14,2,145,175,120,43,127,265,31]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(w,E,s,D){this.configurationService=w,this.workspaceContextService=E,this.editorGroupsService=s,this.pathService=D}text(w,E,s={}){w=this.getContentPattern(w,s);const D=this.configurationService.getValue(),R=E&&E.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(E?.map(S.toWorkspaceFolder),s),type:2,contentPattern:w,previewOptions:s.previewOptions,maxFileSize:s.maxFileSize,usePCRE2:D.search.usePCRE2||R||!1,beforeContext:s.beforeContext,afterContext:s.afterContext,userDisabledExcludesAndIgnoreFiles:s.disregardExcludeSettings&&s.disregardIgnoreFiles}}getContentPattern(w,E){const s=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const D={...w,wordSeparators:s.editor.wordSeparators};return this.isCaseSensitive(w,E)&&(D.isCaseSensitive=!0),this.isMultiline(w)&&(D.isMultiline=!0),D}file(w,E={}){return{...this.commonQuery(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(w,E){return w?(w=Array.isArray(w)?w.map(i):i(w),E?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],E={}){const s=this.handleIncludeExclude(E.includePattern,E.expandPatterns),D=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),R=w.length>1,U=(s.searchPaths&&s.searchPaths.length?s.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,E,D)):w.map(Q=>this.getFolderQueryForRoot(Q,E,D,R))).filter(Q=>!!Q),V={_reason:E._reason,folderQueries:U,usingSearchPaths:!!(s.searchPaths&&s.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:D.pattern,includePattern:s.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=g.coalesce(g.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(z=>z.resource)))).filter(F=>(0,c.pathIncludedInQuery)(V,F.fsPath)),x=this.commonQueryFromFileList(O);return{...V,...x}}const ee=E.extraFileResources&&E.extraFileResources.filter(Q=>(0,c.pathIncludedInQuery)(V,Q.fsPath));return V.extraFileResources=ee&&ee.length?ee:void 0,V}commonQueryFromFileList(w){const E=[],s=new T.ResourceMap,D={};let R=!1;return w.forEach(U=>{if(U.scheme===y.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(U)){const ee=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:_.dirname(U.fsPath)});let Q=s.get(ee);Q||(R=!0,Q={folder:ee,includePattern:{}},E.push(Q),s.set(ee,Q));const O=_.relative(ee.fsPath,U.fsPath);(0,A.assertIsDefined)(Q.includePattern)[O.replace(/\\/g,"/")]=!0}else U.fsPath&&(R=!0,D[U.fsPath]=!0)}),{folderQueries:E,includePattern:D,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(w,E){if(E.isSmartCase){if(w.isRegExp){if(n.containsUppercaseCharacter(w.pattern,!0))return!0}else if(n.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=x=>_.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),D=(Array.isArray(w)?w:r(w)).map(x=>{const F=this.pathService.resolvedUserHome;return F?(0,C.untildify)(x,F.scheme===y.Schemas.file?F.fsPath:F.path):x}),R=L.groupBy(D,x=>E(x)?"searchPaths":"exprSegments"),U=(R.exprSegments||[]).map(x=>n.rtrim(x,"/")).map(x=>n.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),V={},ee=this.expandSearchPathPatterns(R.searchPaths||[]);ee&&ee.length&&(V.searchPaths=ee);const Q=g.flatten(U),O=t(...Q);return O&&(V.pattern=O),V}getExcludesForFolder(w,E){return E.disregardExcludeSettings?void 0:(0,c.getExcludes)(w,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const E=g.flatten(w.map(D=>{let{pathPortion:R,globPortion:U}=p(D);U&&(U=a(U));const V=this.expandOneSearchPath(R);return g.flatten(V.map(ee=>this.resolveOneSearchPathPattern(ee,U)))})),s=new Map;return E.forEach(D=>{const R=D.searchPath.toString(),U=s.get(R);U?D.pattern&&(U.pattern=U.pattern||{},U.pattern[D.pattern]=!0):s.set(R,{searchPath:D.searchPath,pattern:D.pattern?t(D.pattern):void 0})}),Array.from(s.values())}expandOneSearchPath(w){if(_.isAbsolute(w)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==y.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:d.URI.file(_.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const D=_.posix.resolve(E.path,w);return[{searchPath:E.with({path:D})}]}const s=a(w);return[{searchPath:E,pattern:s}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(R=>{const U=E.match(new RegExp(`^${n.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return U?{match:U,folder:R}:null}).filter(A.isDefined);if(D.length)return D.map(R=>{const U=R.match[1];return{searchPath:R.folder.uri,pattern:U&&a(U)}});{const R=w.match(/\.[\/\\](.+)[\/\\]?/),U=R?R[1]:w,V=l.localize(0,null,U);throw new Error(V)}}}}resolveOneSearchPathPattern(w,E){const s=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,D=[{searchPath:w.searchPath,pattern:s}];return s&&!s.endsWith("**")&&D.push({searchPath:w.searchPath,pattern:s+"/**"}),D}getFolderQueryForSearchPath(w,E,s){const D=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(w.searchPath),E,s,!1);return D?{...D,includePattern:w.pattern}:null}getFolderQueryForRoot(w,E,s,D){let R;const U=d.URI.isUri(w)?w:w.uri;if(s.searchPaths){const x=s.searchPaths.filter(F=>(0,I.isEqual)(F.searchPath,U))[0];if(x&&!x.pattern)return null;x&&(R=x.pattern)}const V=this.configurationService.getValue({resource:U}),Q={...this.getExcludesForFolder(V,E)||{},...R||{}},O=d.URI.isUri(w)?(0,I.basename)(w):w.name;return{folder:U,folderName:D?O:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!V.search.followSymlinks}}};f=ze([$e(0,v.IConfigurationService),$e(1,S.IWorkspaceContextService),$e(2,b.IEditorGroupsService),$e(3,P.IPathService)],f),e.QueryBuilder=f;function p(u){const w=u.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,s=u.substr(0,E).match(/[/|\\][^/\\]*$/);if(s){let D=u.substr(0,s.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:u.substr((s.index||0)+1)}}}return{pathPortion:u}}function t(...u){return u.length?u.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function r(u){return k.splitGlobAware(u,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function i(u){return u.replace(/\\/g,"/")}function a(u){return i(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(u,w){u=g.distinct(u,D=>D.toString());const E=[],s=w.getWorkspace();return u&&u.forEach(D=>{let R;if(w.getWorkbenchState()===2)R=(0,I.relativePath)(s.folders[0].uri,D),R&&R!=="."&&(R="./"+R);else{const U=w.getWorkspaceFolder(D);if(U){const V=U.name;if(s.folders.filter(Q=>Q.name===V).length===1){const Q=(0,I.relativePath)(U.uri,D);Q===""?R=`./${U.name}`:R=`./${U.name}/${Q}`}else R=D.fsPath}}R&&E.push(R)}),E}e.resolveResourcesForSearchIncludes=h}),define(ge[267],pe([0,1,23,2,21,16,4,266,31,43]),function(J,e,g,L,k,C,T,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function A(v,S){const b=S.activationEvents;if(!b)return Promise.resolve(void 0);const P=[],c=[];for(const i of b)if(/^workspaceContains:/.test(i)){const a=i.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||v.forceUsingSearch?c.push(a):P.push(a)}if(P.length===0&&c.length===0)return Promise.resolve(void 0);let f;const p=new Promise((i,a)=>{f=i}),t=i=>f({activationEvent:i}),r=Promise.all(P.map(i=>d(v,i,t))).then(()=>{}),o=m(v,S.identifier,c,t);return Promise.all([r,o]).then(()=>{f(void 0)}),p}e.checkActivateWorkspaceContainsExtension=A;async function d(v,S,b){for(const P of v.folders)if(await v.exists(g.joinPath(L.URI.revive(P),S))){b(`workspaceContains:${S}`);return}}async function m(v,S,b,P){if(b.length===0)return Promise.resolve(void 0);const c=new k.CancellationTokenSource,f=v.checkExists(v.folders,b,c.token),p=setTimeout(async()=>{c.cancel(),P(`workspaceContainsTimeout:${b.join(",")}`)},n);let t=!1;try{t=await f}catch(r){C.isPromiseCanceledError(r)||C.onUnexpectedError(r)}c.dispose(),clearTimeout(p),t&&P(`workspaceContains:${b.join(",")}`)}function l(v,S,b,P){const c=v.get(T.IInstantiationService),f=v.get(_.ISearchService),t=c.createInstance(y.QueryBuilder).file(S.map(r=>(0,I.toWorkspaceFolder)(L.URI.revive(r))),{_reason:"checkExists",includePattern:b,exists:!0});return f.fileSearch(t,P).then(r=>!!r.limitHit,r=>C.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ge[40],pe([0,1,164,9,70,23,17,6,22,2,12,5,37,225,93,36,35,223,16,26,24,199,7,121,4,27,66,13,82,52,33,3,267,91,201]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c,f,p,t,r,o,i,a,h,u,w,E,s,D,R,U){"use strict";var V,ee,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let O=class Hn extends y.Disposable{constructor(M,N,q,B,K,te,he,De,Pe,Fe){super();this._onDidChangeRemoteConnectionData=this._register(new s.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=q,this._initData=he,this._extHostWorkspace=B,this._extHostConfiguration=K,this._logService=te,this._extHostTunnelService=Pe,this._extHostTerminalService=Fe,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=De,this._instaService=M.createChild(new u.ServiceCollection([l.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(We=>qe.add(c.ExtensionIdentifier.toKey(We))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(We,je,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(We,P.transformErrorForSerialization(je),W)},actualActivateExtension:async(We,je)=>{if(qe.has(c.ExtensionIdentifier.toKey(We)))return await this._mainThreadExtensionsProxy.$activateExtension(We,je),new m.HostExtension;const W=this._registry.getExtensionDescription(We);return this._activateExtension(W,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){P.onUnexpectedError(M)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(N){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,N){return this._activator.activateByEvent(M,N)}_activateById(M,N){return this._activator.activateById(M,N)}activateByIdWithErrors(M,N){return this._activateById(M,N).then(()=>{const q=this._activator.getActivatedExtension(M);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=_.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(B=>M.set(I.URI.file(B).fsPath,q))});this._extensionPathIndex=Promise.all(N).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return N;const q=this._activator.getActivatedExtension(M);if(!q)return N;try{typeof q.module.deactivate=="function"&&(N=Promise.resolve(q.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{(0,y.dispose)(q.subscriptions)}catch(B){this._logService.error(B)}return N}async _activateExtension(M,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,N).then(q=>{const B=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,N),this._logExtensionActivationTimes(M,N,"success",B),q},q=>{throw this._logExtensionActivationTimes(M,N,"failure"),q})}_logExtensionActivationTimes(M,N,q,B){const K=x(M,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...B||{},outcome:q})}_doActivateExtension(M,N){const q=x(M,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const B=this._getEntryPoint(M);if(!B)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const K=new m.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,C.joinPath)(M.extensionLocation,B),K),this._loadExtensionContext(M)]).then(te=>(k.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Hn._callActivate(this._logService,M.identifier,te[0],te[1],K))).then(te=>(k.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),te))}_loadExtensionContext(M){const N=new p.ExtensionGlobalMemento(M,this._storage),q=new p.ExtensionMemento(M.identifier.value,!1,this._storage),B=new U.ExtensionSecrets(M,this._secretState),K=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,te=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([N.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let De;return Object.freeze({globalState:N,workspaceState:q,secrets:B,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(M.extensionLocation.fsPath,Pe)},get storagePath(){return he._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(M).fsPath},get logPath(){return L.join(he._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return I.URI.joinPath(he._initData.logsLocation,M.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(M)},get globalStorageUri(){return he._storagePath.globalValue(M)},get extensionMode(){return K},get extension(){return De===void 0&&(De=new F(he,M.identifier,M,te)),De},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(M),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,N,q,B,K){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,N,q,B,K).then(te=>new m.ActivatedExtension(!1,null,K.build(),q,te,B.subscriptions))}static _callActivateOptional(M,N,q,B,K){if(typeof q.activate=="function")try{K.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${N.value}`);const te=typeof global=="object"?global:self,he=q.activate.apply(te,[B]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(he).then(De=>(K.activateResolveStop(),De))}catch(te){return Promise.reject(te)}else return Promise.resolve(q)}_activateOneStartupFinished(M,N){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:N}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const N of M.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(M,N)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(N),B=Promise.all([M,q]).then(()=>{});return Promise.race([B,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(M,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,N){if(this.isActivated(N.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:M.map(te=>te.uri),forceUsingSearch:q,exists:te=>this._hostUtils.exists(te.fsPath),checkExists:(te,he,De)=>this._mainThreadWorkspaceProxy.$checkExists(te,he,De)},K=await(0,D.checkActivateWorkspaceContainsExtension)(B,N);if(!!K)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:K.activationEvent}).then(void 0,te=>this._logService.error(te))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:N}=this._initData.environment;if(!M||!N)throw new Error(g.localize(0,null));const q=await this._loadCommonJSModule(null,N,new m.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(g.localize(1,null,N.toString()));return new Promise((B,K)=>{const te=(Pe,Fe)=>{Pe?K(Pe):B(typeof Fe=="number"&&Fe>0?1:0)},he=(0,C.originalFSPath)(N),De=q.run(he,te);De&&De.then&&De.then(()=>{B(0)}).catch(Pe=>{K(Pe.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,N){return this._resolvers[M]=N,(0,y.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const N=M.indexOf("+");if(N===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,N);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(M,N){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),k.mark(`code/extHost/willResolveAuthority/${q}`);const K=await B.resolve(M,{resolveAttempt:N});k.mark(`code/extHost/didResolveAuthorityOK/${q}`);const te={authority:M,host:K.host,port:K.port,connectionToken:K.connectionToken},he={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:te,options:he,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(k.mark(`code/extHost/didResolveAuthorityError/${q}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(M,N){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const K=I.URI.revive(N);if(typeof B.getCanonicalURI=="undefined")return K;const te=await(0,T.asPromise)(()=>B.getCanonicalURI(K));return te||K}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,N){return N===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(M,!1))}async $activate(M,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,N),!0):!1}async $deltaExtensions(M,N){M.forEach(B=>B.extensionLocation=I.URI.revive(B.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(N.map(async B=>{const K=this._registry.getExtensionDescription(B);if(!K)return;const te=await this._hostUtils.realpath(K.extensionLocation.fsPath);q.delete(I.URI.file(te).fsPath)})),await Promise.all(M.map(async B=>{const K=await this._hostUtils.realpath(B.extensionLocation.fsPath);q.set(I.URI.file(K).fsPath,B)})),this._registry.deltaExtensions(M,N),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let N=f.VSBuffer.alloc(M),q=Math.random()%256;for(let B=0;B<M;B++)N.writeUInt8(q,B);return N}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};O=ze([$e(0,o.IInstantiationService),$e(1,e.IHostUtils),$e(2,h.IExtHostRpcService),$e(3,v.IExtHostWorkspace),$e(4,d.IExtHostConfiguration),$e(5,n.ILogService),$e(6,i.IExtHostInitDataService),$e(7,a.IExtensionStoragePaths),$e(8,w.IExtHostTunnelService),$e(9,E.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function x(z,M){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class F{constructor(M,N,q,B){V.set(this,void 0),ee.set(this,void 0),Q.set(this,void 0),it(this,V,M,"f"),it(this,ee,N,"f"),it(this,Q,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=B}get isActive(){return He(this,V,"f").isActivated(He(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,V,"f").getExtensionExports(He(this,Q,"f"))}activate(){return He(this,V,"f").activateByIdWithErrors(He(this,Q,"f"),{startup:!1,extensionId:He(this,ee,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,V=new WeakMap,ee=new WeakMap,Q=new WeakMap}),define(ge[53],pe([0,1,9,2,3,17,5,7,124,36,40,45,214,37,209,13,4,14,38,51]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let f=class{constructor(u,w,E,s,D,R){this._workspaceService=w,this._extensionService=E,this._editorsService=s,this._configurationService=D,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=u.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(V=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,w){const E=u;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let s=`debug:${encodeURIComponent(E.path||"")}`,D="?";return w&&(s+=`${D}session=${encodeURIComponent(w.id)}`,D="&"),s+=`${D}ref=${E.sourceReference}`,L.URI.parse(s)}else{if(E.path)return L.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const w=[];for(const E of u.getAllExtensionDescriptions())if(E.contributes){const s=E.contributes.debuggers;if(s&&s.length>0)for(const D of s)(0,l.isDebuggerMainContribution)(D)&&w.push(D.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(w=>u.push(w)),u}addBreakpoints(u){this.startBreakpoints();const w=u.filter(D=>{const R=D.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,D),!0)});this.fireBreakpointChanges(w,[],[]);const E=[],s=new Map;for(const D of w)if(D instanceof y.SourceBreakpoint){let R=s.get(D.location.uri.toString());R||(R={type:"sourceMulti",uri:D.location.uri,lines:[]},s.set(D.location.uri.toString(),R),E.push(R)),R.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof y.FunctionBreakpoint&&E.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(u){this.startBreakpoints();const w=u.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const E=w.filter(R=>R instanceof y.SourceBreakpoint).map(R=>R.id),s=w.filter(R=>R instanceof y.FunctionBreakpoint).map(R=>R.id),D=w.filter(R=>R instanceof y.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(E,s,D)}startDebugging(u,w,E){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,w,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,w,E){if(!w)return new y.Disposable(()=>{});const s=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:s,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,E,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,s),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(u,w,E){if(!E)return new y.Disposable(()=>{});if(!this.definesDebugType(u,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:s,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,s),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(u,w){if(!w)return new y.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:E,factory:w}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(s=>s.factory!==w)})}async $runInTerminal(u,w){return Promise.resolve(void 0)}async $substituteVariables(u,w){if(!this._variableResolver){const[D,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,R)}let E;const s=await this.getFolder(u);return s&&(E={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,w)}createDebugAdapter(u,w){if(u.type==="implementation")return new i(u.implementation)}createSignService(){}async $startDASession(u,w){const E=this,s=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(s.type),s).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const R=this.convertToDto(D),U=this.createDebugAdapter(R,s);if(!U)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const V=U;return this._debugAdapters.set(u,V),this.getDebugAdapterTrackers(s).then(ee=>(ee&&this._debugAdaptersTrackers.set(u,ee),V.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const O=Q,x={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(O.arguments.value);x.body={signature:F},V.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,V.sendResponse(x)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(Q),Q=(0,l.convertToVSCPaths)(Q,!0),E._debugServiceProxy.$acceptDAMessage(u,Q)}),V.onError(Q=>{ee&&ee.onError&&ee.onError(Q),this._debugServiceProxy.$acceptDAError(u,Q.name,Q.message,Q.stack)}),V.onExit(Q=>{ee&&ee.onExit&&ee.onExit((0,b.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,b.withNullAsUndefined)(Q),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),V.startSession()))})}$sendDAMessage(u,w){w=(0,l.convertToDAPaths)(w,!1);const E=this._debugAdaptersTrackers.get(u);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(w);const s=this._debugAdapters.get(u);s&&s.sendMessage(w)}$stopDASession(u){const w=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),w&&w.onWillStopSession&&w.onWillStopSession();const E=this._debugAdapters.get(u);return this._debugAdapters.delete(u),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const w=[],E=[],s=[];if(u.added)for(const D of u.added){const R=D.id;if(R&&!this._breakpoints.has(R)){let U;if(D.type==="function")U=new y.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")U=new y.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const V=L.URI.revive(D.uri);U=new y.SourceBreakpoint(new y.Location(V,new y.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}U._id=R,this._breakpoints.set(R,U),w.push(U)}}if(u.removed)for(const D of u.removed){const R=this._breakpoints.get(D);R&&(this._breakpoints.delete(D),E.push(R))}if(u.changed){for(const D of u.changed)if(D.id){const R=this._breakpoints.get(D.id);if(R){if(R instanceof y.FunctionBreakpoint&&D.type==="function"){const U=R;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.functionName=D.functionName}else if(R instanceof y.SourceBreakpoint&&D.type==="source"){const U=R;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.location=new y.Location(L.URI.revive(D.uri),new y.Position(D.line,D.character))}s.push(R)}}}this.fireBreakpointChanges(w,E,s)}$provideDebugConfigurations(u,w,E){return(0,C.asPromise)(async()=>{const s=this.getConfigProviderByHandle(u);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(w);return s.provideDebugConfigurations(D,E)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(u,w,E,s){return(0,C.asPromise)(async()=>{const D=this.getConfigProviderByHandle(u);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return D.resolveDebugConfiguration(R,E,s)})}$resolveDebugConfigurationWithSubstitutedVariables(u,w,E,s){return(0,C.asPromise)(async()=>{const D=this.getConfigProviderByHandle(u);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return D.resolveDebugConfigurationWithSubstitutedVariables(R,E,s)})}async $provideDebugAdapter(u,w){const E=this.getAdapterDescriptorFactoryByHandle(u);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.getSession(w);return this.getAdapterDescriptor(E,s).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(u){const w=await this.getSession(u);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(u){const w=await this.getSession(u);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,w){const E=await this.getSession(u);E&&E._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(u,w){const s={session:await this.getSession(u),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(s)}convertToDto(u){if(u instanceof y.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof y.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const w=this._adapterFactories.filter(E=>E.type===u);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(u){const w=this._adapterFactories.filter(E=>E.handle===u);if(w.length>0)return w[0].factory}getConfigProviderByHandle(u){const w=this._configProviders.filter(E=>E.handle===u);if(w.length>0)return w[0].provider}definesDebugType(u,w){if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0){for(const s of E)if(s.label&&s.type&&s.type===w)return!0}}return!1}getDebugAdapterTrackers(u){const E=u.configuration.type,s=this._trackerFactories.filter(D=>D.type===E||D.type==="*").map(D=>(0,C.asPromise)(()=>D.factory.createDebugAdapterTracker(u)).then(R=>R,R=>null));return Promise.race([Promise.all(s).then(D=>{const R=D.filter(U=>!!U);if(R.length>0)return new o(R)}),new Promise((D,R)=>{const U=setTimeout(()=>{clearTimeout(U),R(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(u,w){const E=w.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new y.DebugAdapterServer(E));if(u){const D=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>u.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,D))).then(R=>{if(R)return R})}const s=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,s))}daExecutableFromPackage(u,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,w,E){(u.length>0||w.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:w,changed:E}))}async getSession(u){if(u)if(typeof u=="string"){const w=this._debugSessions.get(u);if(w)return w}else{let w=this._debugSessions.get(u.id);if(!w){const E=await this.getFolder(u.folderUri),s=u.parent?this._debugSessions.get(u.parent):void 0;w=new p(this._debugServiceProxy,u.id,u.type,u.name,E,u.configuration,s),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(u){if(u){const w=L.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};f=ze([$e(0,v.IExtHostRpcService),$e(1,I.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,A.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class p{constructor(u,w,E,s,D,R,U){this._debugServiceProxy=u,this._id=w,this._type=E,this._name=s,this._workspaceFolder=D,this._configuration=R,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}get parentSession(){return this._parentSession}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,w)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=p;class t{constructor(u){this.value=Object.freeze({append(w){u.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class r extends d.AbstractVariableResolverService{constructor(u,w,E,s,D){function R(){if(w){const U=w.activeEditor();if(U)return U.document.uri;const V=s.tabs.filter(ee=>ee.isActive);if(V.length>0)return V[0].resource}}super({getFolderUri:U=>{const V=u.filter(ee=>ee.name===U);if(V&&V.length>0)return V[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(U,V)=>E.getConfiguration(void 0,U).get(V),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=R();if(U)return g.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const U=R();if(U){const V=D.getWorkspaceFolder(U);if(V)return g.normalize(V.uri.fsPath)}}},getSelectedText:()=>{if(w){const U=w.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(w){const U=w.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=r;class o{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(w=>w.onError?w.onError(u):void 0)}onExit(u,w){this.trackers.forEach(E=>E.onExit?E.onExit(u,w):void 0)}}class i extends _.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(u,w,E,s,D,R){super(u,w,E,s,D,R)}createVariableResolver(u,w,E){return new r(u,w,E,this._editorTabs)}};a=ze([$e(0,v.IExtHostRpcService),$e(1,I.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,A.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(ge[268],pe([0,1,70,2,5,37,35,26,13,27,4,40,38,12]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(c,f,p,t,r,o,i){this._apiFactory=c,this._extensionRegistry=f,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=o,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,f,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,f,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let f of c.nodeModuleName)this._factories.set(f,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(f=>c.alternativeModuleName(f))}};l=ze([$e(2,n.IInstantiationService),$e(3,C.IExtHostConfiguration),$e(4,A.IExtHostExtensionService),$e(5,I.IExtHostInitDataService),$e(6,m.ILogService)],l),e.RequireInterceptor=l;class v{constructor(c,f,p,t,r){this._apiFactory=c,this._extensionPaths=f,this._extensionRegistry=p,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,f){const p=this._extensionPaths.findSubstr(f.fsPath);if(p){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,o)=>t+=`	${o} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(c,f){this.nodeModuleName="keytar";const{environment:p}=f,t=c.getProxy(k.MainContext.MainThreadKeytar);if(p.appRoot){let r=p.appRoot.fsPath;d.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,o)=>t.$getPassword(r,o),setPassword:(r,o,i)=>t.$setPassword(r,o,i),deletePassword:(r,o)=>t.$deletePassword(r,o),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(c,f){return this._impl}alternativeModuleName(c){const f=c.length;if(f<=7||!this.alternativeNames)return;const p=f-7;if((c.charAt(p)==="/"||c.charAt(p)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};S=ze([$e(0,_.IExtHostRpcService),$e(1,I.IExtHostInitDataService)],S);let b=class{constructor(c,f,p){this._extensionPaths=c,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(k.MainContext.MainThreadTelemetry);const t=p.getProxy(k.MainContext.MainThreadWindow);this._impl=(r,o)=>{const i=L.URI.parse(r);return o?this.callOriginal(r,o):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,o)}}load(c,f,p){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(c),this._impl}callOriginal(c,f){return this.sendNoForwardTelemetry(),this._original(c,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=ze([$e(2,_.IExtHostRpcService)],b)}),define(ge[269],pe([0,1,170,11,7,210,36,40,45,37,33,13,53,194,17,211,51]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends d.ExtHostDebugServiceBase{constructor(f,p,t,r,o,i,a){super(f,p,t,r,o,a);this._terminalService=i,this._integratedTerminalInstances=new P}createDebugAdapter(f,p){switch(f.type){case"server":return new C.SocketDebugAdapter(f);case"pipeServer":return new C.NamedPipeDebugAdapter(f);case"executable":return new C.ExecutableDebugAdapter(f,p.type)}return super.createDebugAdapter(f,p)}daExecutableFromPackage(f,p){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),f.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(f,p){if(f.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),i=f.title||g.localize(0,null),a=JSON.stringify({shell:r,shellArgs:o});let h=await this._integratedTerminalInstances.checkout(a,i),u,w=!1;if(h)u=f.cwd;else{const R={shellPath:r,shellArgs:o,cwd:f.cwd,name:i,iconPath:new k.ThemeIcon("debug")};w=!0,h=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,a)}h.show(!0);const E=await h.processId;w?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?h.sendText("cls"):r.indexOf("bash")>=0?h.sendText("clear"):L.isWindows?h.sendText("cls"):h.sendText("clear"));const s=(0,v.prepareCommand)(r,f.args,u,f.env);h.sendText(s);const D=this.onDidTerminateDebugSession(R=>{R.id===p&&(this._integratedTerminalInstances.free(h),D.dispose())});return E}else if(f.kind==="external")return(0,v.runInExternalTerminal)(f,await this._configurationService.getConfigProvider());return super.$runInTerminal(f,p)}createVariableResolver(f,p,t){return new d.ExtHostVariableResolverService(f,p,t,this._editorTabs,this._workspaceService)}};b=ze([$e(0,A.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,I.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,S.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class P{constructor(){this._terminalInstances=new Map}async checkout(f,p){const r=[...this._terminalInstances.entries()].map(([o,i])=>(0,l.createCancelablePromise)(async a=>{if(o.name!==p||i.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await o.processId))return null;const h=Date.now();return i.lastUsedAt+P.minUseDelay>h||a.isCancellationRequested||i.config!==f?null:(i.lastUsedAt=h,o)}));return await(0,l.firstParallel)(r,o=>!!o)}insert(f,p){this._terminalInstances.set(f,{lastUsedAt:Date.now(),config:p})}free(f){const p=this._terminalInstances.get(f);p&&(p.lastUsedAt=-1)}onTerminalClosed(f){this._terminalInstances.delete(f)}}P.minUseDelay=1e3}),define(ge[270],pe([0,1,9,2,113,36,53,45,37,43,33,13,27,69,10,12,64,51,23,78]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends m.ExtHostTaskBase{constructor(t,r,o,i,a,h,u,w,E){super(t,r,o,i,a,h,u,w);this.workspaceService=o,this.editorTabs=E,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(l.Schemas.file,{scheme:l.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const o=r;if(!r.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const i=m.TaskHandleDTO.from(o,this.workspaceService),a=await this._proxy.$getTaskExecution(i);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const h=await this.getTaskExecution(a,r);return this._proxy.$executeTask(i).catch(()=>{}),h}else{const i=m.TaskDTO.from(r,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,r,!1);const a=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),r);return this._proxy.$executeTask(i).catch(()=>{}),a}}provideTasksInternal(t,r,o,i){const a=[];if(i)for(let h of i){this.checkDeprecation(h,o),(!h.definition||!t[h.definition.type])&&this._logService.warn(`The task [${h.source}, ${h.name}] uses an undefined task type. The task will be ignored in the future.`);const u=m.TaskDTO.from(h,o.extension);u&&(a.push(u),m.CustomExecutionDTO.is(u.execution)&&r.push(this.addCustomExecution(u,h,!0)))}return{tasks:a,extension:o.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const r=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(t,this._editorService,r,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const o=L.URI.file((0,c.homedir)());r=new I.WorkspaceFolder({uri:o,name:P.basename(o),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const o=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(o),h=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.getVariableResolver(h),w=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(h);for(let E of r.variables)i.variables[E]=await u.resolveAsync(w,E);if(r.process!==void 0){let E;if(r.process.path!==void 0){E=r.process.path.split(g.delimiter);for(let s=0;s<E.length;s++)E[s]=await u.resolveAsync(w,E[s])}i.process=await k.win32.findExecutable(await u.resolveAsync(w,r.process.name),r.process.cwd!==void 0?await u.resolveAsync(w,r.process.cwd):void 0,E)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,o){return k.win32.findExecutable(t,r,o)}};f=ze([$e(0,A.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,_.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,v.ILogService),$e(7,S.IExtHostApiDeprecationService),$e(8,b.IExtHostEditorTabs)],f),e.ExtHostTask=f}),define(ge[271],pe([0,1,17,16,70,6,2,5,263,12,80,82,27,188,13,63,40,33]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(f,p,t,r){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(f,null,r),p=P._transform(p,this._rpcProtocol);const o=new A.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());o.set(d.IExtHostInitDataService,{_serviceBrand:void 0,...p}),o.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),o.set(v.IURITransformerService,new v.URITransformerService(r)),o.set(S.IHostUtils,t);const i=new m.InstantiationService(o,!0),a=i.invokeFunction(E=>E.get(b.IExtHostTerminalService));this._disposables.add(a),this._logService=i.invokeFunction(E=>E.get(I.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=i.invokeFunction(E=>E.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(s,D)=>{let R="",U,V;for(const ee of D)R+=`
	at ${ee.toString()}`,V=ee.getFileName(),!U&&V&&(U=E.findSubstr(V));return h.set(s,U),`${s.name||"Error"}: ${s.message||""}${R}`}});const u=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(E=>{const s=L.transformErrorForSerialization(E),D=h.get(E);D?u.$onExtensionRuntimeError(D.identifier,s):w.$onUnexpectedError(s)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,p){f.extensions.forEach(r=>r.extensionLocation=T.URI.revive(p.transformIncomingURIs(r.extensionLocation))),f.environment.appRoot=T.URI.revive(p.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(r=>T.URI.revive(p.transformIncomingURIs(r)))),f.environment.extensionTestsLocationURI=T.URI.revive(p.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=T.URI.revive(p.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=T.URI.revive(p.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=T.URI.revive(p.transformIncomingURIs(f.logsLocation)),f.logFile=T.URI.revive(p.transformIncomingURIs(f.logFile)),f.workspace=p.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=P}),define(ge[272],pe([0,1,9,21,60,30,23,46,31]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(d,m,l){this.config=d,this.provider=m,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&C.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&C.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const m=this.config.folderQueries||[];return new Promise((l,v)=>{const S=b=>{this.resultCount++,d(b)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const P=b.toString(),c=g.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,c)||this.matchFile(S,{base:b,basename:c})}),Promise.all(m.map(b=>this.searchInFolder(b,S))).then(b=>{l({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{v(new Error((0,k.toErrorMessage)(b)))})})}async searchInFolder(d,m){const l=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(d),S=this.initDirectoryTree(),b=new _.QueryGlobTester(this.config,d),P=!b.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(l),c=y.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,l.token),p=c.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(r=>{const o=g.posix.relative(d.folder.path,r.path);if(P){const i=g.basename(r.path);this.matchFile(m,{base:d.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(S,d.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,b,m),{providerTime:p,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(d){const m=(0,_.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),l=(0,_.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:l,includes:m,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},m,l,v){if(l===this.filePattern){const b=g.basename(this.filePattern);this.matchFile(v,{base:m,relativePath:this.filePattern,basename:b})}function S(b){const P=g.basename(b),c=g.dirname(b);let f=d[c];f||(f=d[c]=[],S(c)),f.push({base:m,relativePath:b,basename:P})}S(l)}matchDirectoryTree({rootEntries:d,pathToEntries:m},l,v){const S=this,b=this.filePattern;function P(c){const f=C.hasSiblingFn(()=>c.map(p=>p.basename));for(let p=0,t=c.length;p<t;p++){const r=c[p],{relativePath:o,basename:i}=r;if(!l.includedInQuerySync(o,i,b!==i?f:void 0))continue;const a=m[o];if(a)P(a);else{if(o===b)continue;S.matchFile(v,r)}if(S.isLimitHit)break}}P(d)}matchFile(d,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(m))}}class n{constructor(){this.sessions=new Map}fileSearch(d,m,l,v){const S=this.getSessionTokenSource(d.cacheKey),b=new I(d,m,S&&S.token);let P=0;const c=f=>{P+=f.length,l(f.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(b,n.BATCH_SIZE,c,v).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:f.stats}}))}clearCache(d){const m=this.getSessionTokenSource(d);m&&m.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new L.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:T.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,m,l,v){v.onCancellationRequested(()=>{d.cancel()});const S=P=>{P&&(b.push(P),m>0&&b.length>=m&&(l(b),b=[]))};let b=[];return d.search(S).then(P=>(b.length&&l(b),P),P=>(b.length&&l(b),Promise.reject(P)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(ge[133],pe([0,1,9,20,21,60,23,30,2,31,10,14]),function(J,e,g,L,k,C,T,y,_,I,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(c,f,p){this.query=c,this.provider=f,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,f){const p=this.query.folderQueries||[],t=new k.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((r,o)=>{this.collector=new l(c);let i=!1;const a=(h,u)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(h);S(h)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const E=this.resultSize(h);this.resultCount+=E,(E>0||!S(h))&&this.collector.add(h,u)}};Promise.all(p.map((h,u)=>this.searchInFolder(h,w=>a(w,u),t.token))).then(h=>{t.dispose(),this.collector.flush();const u=h.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||u,messages:(0,L.flatten)(h.map(w=>w?.message?(0,A.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:"textSearchProvider"}})},h=>{t.dispose();const u=(0,C.toErrorMessage)(h);o(new Error(u))})})}resultSize(c){return S(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,f){const p=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:p.slice(0,f),preview:{matches:t.slice(0,f),text:c.preview.text},uri:c.uri}}async searchInFolder(c,f,p){const t=new I.QueryGlobTester(this.query,c),r=[],o={report:h=>{if(!this.validateProviderResult(h))return;const u=c.folder.scheme===n.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(h.uri))):void 0,w=T.relativePath(c.folder,h.uri);w&&r.push(t.includedInQuery(w,g.basename(w),u).then(E=>{E&&f(h)}))}},i=this.getSearchOptionsForFolder(c),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,o,p);return await Promise.all(r),a}validateProviderResult(c){if(S(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const f=(0,I.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),p=(0,I.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:_.URI.from(c.folder),excludes:p,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function m(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class l{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,f=>this.sendItems(f))}add(c,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!T.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(v(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=l;function v(P){return S(P)?{preview:{matches:(0,L.mapArrayOrNot)(P.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:P.preview.text},ranges:(0,L.mapArrayOrNot)(P.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function S(P){return!!P.preview}e.extensionResultIsMatch=S;class b{constructor(c,f){this.maxBatchSize=c,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,f){!c||this.addItemToBatch(c,f)}addItems(c,f){!c||this.addItemsToBatch(c,f)}addItemToBatch(c,f){this.batch.push(c),this.batchSize+=f,this.onUpdate()}addItemsToBatch(c,f){this.batch=this.batch.concat(c),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(ge[71],pe([0,1,6,5,4,272,13,63,12,2,133]),function(J,e,g,L,k,C,T,y,_,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let A=class{constructor(v,S,b){this.extHostRpc=v,this._uriTransformer=S,this._logService=b,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,S){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const b=this._handlePool++;return this._textSearchProvider.set(b,S),this._proxy.$registerTextSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(v,S){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const b=this._handlePool++;return this._fileSearchProvider.set(b,S),this._proxy.$registerFileSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(v,S,b,P){const c=d(b),f=this._fileSearchProvider.get(v);if(f)return this._fileSearchManager.fileSearch(c,f,p=>{this._proxy.$handleFileMatch(v,S,p.map(t=>t.resource))},P);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,S,b,P){const c=this._textSearchProvider.get(v);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const f=d(b);return this.createTextSearchManager(f,c).search(t=>this._proxy.$handleTextMatch(v,S,t),P)}createTextSearchManager(v,S){return new n.TextSearchManager(v,S,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};A=ze([$e(0,T.IExtHostRpcService),$e(1,y.IURITransformerService),$e(2,_.ILogService)],A),e.ExtHostSearch=A;function d(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(m),extraFileResources:l.extraFileResources&&l.extraFileResources.map(v=>I.URI.revive(v))}}e.reviveQuery=d;function m(l){return{...l,folder:I.URI.revive(l.folder)}}}),define(ge[273],pe([0,1,21,16,3,48,2,114,109,146,79,42,5,231,230,44,232,37,233,234,235,216,236,45,40,237,217,240,241,242,65,219,247,248,249,93,33,251,220,15,7,254,67,132,36,35,55,206,239,84,131,69,53,71,12,63,13,27,243,203,52,64,228,252,202,66,92,257,255,256,229,62,250,253,91,51,122,245,68,246,10,190,244,200,238]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c,f,p,t,r,o,i,a,h,u,w,E,s,D,R,U,V,ee,Q,O,x,F,z,M,N,q,B,K,te,he,De,Pe,Fe,qe,We,je,W,Z,ne,ae,Y,oe,we,Me,Ve,_e,Je,X,re,me,xe,Be,et,ke,Ce,Te,le,ce,ve,Ee,j,be,Se,Ae,Ue,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Qe){const Xe=Qe.get(ne.IExtHostInitDataService),lt=Qe.get(et.IExtHostFileSystemInfo),ht=Qe.get(X.IExtHostConsumerFileSystem),Et=Qe.get(o.IExtHostExtensionService),ot=Qe.get(q.IExtHostWorkspace),at=Qe.get(ce.IExtHostTelemetry),Dt=Qe.get(b.IExtHostConfiguration),ye=Qe.get(W.IURITransformerService),fe=Qe.get(Z.IExtHostRpcService),ue=Qe.get(V.IExtHostStorage),G=Qe.get(Je.IExtensionStoragePaths),Re=Qe.get(je.ILogService),Ne=Qe.get(oe.IExtHostTunnelService),tt=Qe.get(we.IExtHostApiDeprecationService),Ke=Qe.get(N.IExtHostWindow),gt=Qe.get(Te.IExtHostSecretState),bt=Qe.get(le.IExtHostEditorTabs);fe.set(d.ExtHostContext.ExtHostFileSystemInfo,lt),fe.set(d.ExtHostContext.ExtHostLogService,Re),fe.set(d.ExtHostContext.ExtHostWorkspace,ot),fe.set(d.ExtHostContext.ExtHostConfiguration,Dt),fe.set(d.ExtHostContext.ExtHostExtensionService,Et),fe.set(d.ExtHostContext.ExtHostStorage,ue),fe.set(d.ExtHostContext.ExtHostTunnelService,Ne),fe.set(d.ExtHostContext.ExtHostWindow,Ke),fe.set(d.ExtHostContext.ExtHostSecretState,gt),fe.set(d.ExtHostContext.ExtHostTelemetry,at),fe.set(d.ExtHostContext.ExtHostEditorTabs,bt);const kt=fe.set(d.ExtHostContext.ExtHostDecorations,Qe.get(Pe.IExtHostDecorations)),ft=fe.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(r.IExtHostDocumentsAndEditors)),ut=fe.set(d.ExtHostContext.ExtHostCommands,Qe.get(v.IExtHostCommands)),mt=fe.set(d.ExtHostContext.ExtHostTerminalService,Qe.get(ee.IExtHostTerminalService)),_t=fe.set(d.ExtHostContext.ExtHostDebugService,Qe.get(qe.IExtHostDebugService)),Tt=fe.set(d.ExtHostContext.ExtHostSearch,Qe.get(We.IExtHostSearch)),It=fe.set(d.ExtHostContext.ExtHostTask,Qe.get(Fe.IExtHostTask)),bn=fe.set(d.ExtHostContext.ExtHostOutputService,Qe.get(E.IExtHostOutputService)),Vt=fe.set(d.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(fe)),St=fe.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(fe,ft)),Xt=fe.set(d.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(fe,ft,Re)),Yt=fe.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(Re,St,fe.getProxy(d.MainContext.MainThreadBulkEdits))),pt=fe.set(d.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(fe,ut,ft,St,G)),jt=fe.set(d.ExtHostContext.ExtHostNotebookDocuments,new Ue.ExtHostNotebookDocuments(Re,pt)),Wt=fe.set(d.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(Re,fe,pt)),Jt=fe.set(d.ExtHostContext.ExtHostNotebookKernels,new ve.ExtHostNotebookKernels(fe,Xe,pt,Re)),Zt=fe.set(d.ExtHostContext.ExtHostNotebookRenderers,new j.ExtHostNotebookRenderers(fe,pt)),Pt=fe.set(d.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(fe,ft)),dn=fe.set(d.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(fe.getProxy(d.MainContext.MainThreadTreeViews),ut,Re)),en=fe.set(d.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(fe.getProxy(d.MainContext.MainThreadEditorInsets),Pt,Xe)),xt=fe.set(d.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(fe,Re)),dt=fe.set(d.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(fe,ye,St,ut,xt,Re,tt)),tn=fe.set(d.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(fe,dt)),Mt=fe.set(d.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(fe,Re,ft)),Ot=fe.set(d.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(fe,ot,ut)),qt=fe.set(d.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(fe,ut,Re)),En=fe.set(d.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(fe,ut,St)),hn=fe.set(d.ExtHostContext.ExtHostProgress,new s.ExtHostProgress(fe.getProxy(d.MainContext.MainThreadProgress))),_n=fe.set(d.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(fe)),fn=fe.set(d.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(fe)),nn=fe.set(d.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(fe)),rn=fe.set(d.ExtHostContext.ExtHostTimeline,new Ve.ExtHostTimeline(fe,ut)),Ht=fe.set(d.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(fe,{remote:Xe.remote},ot,Re,tt)),sn=fe.set(d.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(fe,Ht,ot)),Sn=fe.set(d.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(fe,St,G,Ht,sn)),yn=fe.set(d.ExtHostContext.ExtHostWebviewViews,new re.ExtHostWebviewViews(fe,Ht)),zt=fe.set(d.ExtHostContext.ExtHostTesting,new ke.ExtHostTesting(fe,ut)),Gt=fe.set(d.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(fe));fe.set(d.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(fe,pt,ft,ut));const Dn=(0,K.values)(d.ExtHostContext);fe.assertRegistered(Dn);const Cn=new Be.ExtHostBulkEdits(fe,ft),on=new l.ExtHostClipboard(fe),an=new w.ExtHostMessageService(fe,Re),Bt=new c.ExtHostDialogs(fe),Lt=new U.ExtHostStatusBar(fe,ut.converter),Kt=new u.ExtHostLanguages(fe,St);return m.ExtHostApiCommands.register(ut),function(Oe,$t,mn){const vt=function(){let ie=!Oe.isUnderDevelopment;function de(Le){ie||(Re.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")de(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&de(rt),!Oe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,B.throwProposedApiError)(Oe)}return rt}}(),kn={getSession(ie,de,Le){return Le?.forceNewSession&&(0,B.checkProposedApiEnabled)(Oe),nn.getSession(Oe,ie,de,Le)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(ie,de,Le,rt){return nn.registerAuthenticationProvider(ie,de,Le,rt)}},In={registerCommand(ie,de,Le){return ut.registerCommand(!0,ie,de,Le)},registerTextEditorCommand(ie,de,Le){return ut.registerCommand(!0,ie,(...rt)=>{const wt=Pt.getActiveTextEditor();if(!wt){Re.warn("Cannot execute "+ie+" because there is no active text editor.");return}return wt.edit(Ct=>{de.apply(Le,[wt,Ct,...rt])}).then(Ct=>{Ct||Re.warn("Edits from command "+ie+" were not applied.")},Ct=>{Re.warn("An error occurred while running command "+ie,Ct)})})},registerDiffInformationCommand:(ie,de,Le)=>((0,B.checkProposedApiEnabled)(Oe),ut.registerCommand(!0,ie,async(...rt)=>{const wt=ft.activeEditor(!0);if(!wt){Re.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);de.apply(Le,[Ct,...rt])})),executeCommand(ie,...de){return ut.executeCommand(ie,...de)},getCommands(ie=!1){return ut.getCommands(ie)}},gn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){return Xe.environment.appRoot?.fsPath??""},get embedderIdentifier(){return Xe.environment.embedderIdentifier},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,de){return Ke.openUri(ie,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===Xe.environment.appUriScheme)return Vt.createAppUri(ie);try{return await Ke.asExternalUri(ie,{allowTunneling:!!Xe.remote.authority})}catch(de){if((0,Se.matchesScheme)(ie,be.Schemas.http)||(0,Se.matchesScheme)(ie,be.Schemas.https))return ie;throw de}},get remoteName(){return(0,De.getRemoteName)(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Xe.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Pn={createTestController(ie,de){return zt.createTestController(ie,de)},createTestObserver(){return(0,B.checkProposedApiEnabled)(Oe),zt.createTestObserver()},runTests(ie){return(0,B.checkProposedApiEnabled)(Oe),zt.runTests(ie)},get onDidChangeTestResults(){return(0,B.checkProposedApiEnabled)(Oe),zt.onResultsChanged},get testResults(){return(0,B.checkProposedApiEnabled)(Oe),zt.results}},ln={getExtension(ie){const de=$t.getExtensionDescription(ie);if(de)return new o.Extension(Et,Oe.identifier,de,pn)},get all(){return $t.getAllExtensionDescriptions().map(ie=>new o.Extension(Et,Oe.identifier,ie,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(ie){return xt.createDiagnosticCollection(Oe.identifier,ie)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:ie=>xt.getDiagnostics(ie),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(ie,de){return Kt.changeLanguage(ie.uri,de)},match(ie,de){return(0,n.score)(x.LanguageSelector.from(ie),de.uri,de.languageId,!0)},registerCodeActionsProvider(ie,de,Le){return dt.registerCodeActionProvider(Oe,vt(ie),de,Le)},registerCodeLensProvider(ie,de){return dt.registerCodeLensProvider(Oe,vt(ie),de)},registerDefinitionProvider(ie,de){return dt.registerDefinitionProvider(Oe,vt(ie),de)},registerDeclarationProvider(ie,de){return dt.registerDeclarationProvider(Oe,vt(ie),de)},registerImplementationProvider(ie,de){return dt.registerImplementationProvider(Oe,vt(ie),de)},registerTypeDefinitionProvider(ie,de){return dt.registerTypeDefinitionProvider(Oe,vt(ie),de)},registerHoverProvider(ie,de){return dt.registerHoverProvider(Oe,vt(ie),de,Oe.identifier)},registerEvaluatableExpressionProvider(ie,de){return dt.registerEvaluatableExpressionProvider(Oe,vt(ie),de,Oe.identifier)},registerInlineValuesProvider(ie,de){return dt.registerInlineValuesProvider(Oe,vt(ie),de,Oe.identifier)},registerDocumentHighlightProvider(ie,de){return dt.registerDocumentHighlightProvider(Oe,vt(ie),de)},registerLinkedEditingRangeProvider(ie,de){return dt.registerLinkedEditingRangeProvider(Oe,vt(ie),de)},registerReferenceProvider(ie,de){return dt.registerReferenceProvider(Oe,vt(ie),de)},registerRenameProvider(ie,de){return dt.registerRenameProvider(Oe,vt(ie),de)},registerDocumentSymbolProvider(ie,de,Le){return dt.registerDocumentSymbolProvider(Oe,vt(ie),de,Le)},registerWorkspaceSymbolProvider(ie){return dt.registerWorkspaceSymbolProvider(Oe,ie)},registerDocumentFormattingEditProvider(ie,de){return dt.registerDocumentFormattingEditProvider(Oe,vt(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return dt.registerDocumentRangeFormattingEditProvider(Oe,vt(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Le,...rt){return dt.registerOnTypeFormattingEditProvider(Oe,vt(ie),de,[Le].concat(rt))},registerDocumentSemanticTokensProvider(ie,de,Le){return dt.registerDocumentSemanticTokensProvider(Oe,vt(ie),de,Le)},registerDocumentRangeSemanticTokensProvider(ie,de,Le){return dt.registerDocumentRangeSemanticTokensProvider(Oe,vt(ie),de,Le)},registerSignatureHelpProvider(ie,de,Le,...rt){return typeof Le=="object"?dt.registerSignatureHelpProvider(Oe,vt(ie),de,Le):dt.registerSignatureHelpProvider(Oe,vt(ie),de,typeof Le=="undefined"?[]:[Le,...rt])},registerCompletionItemProvider(ie,de,...Le){return dt.registerCompletionItemProvider(Oe,vt(ie),de,Le)},registerInlineCompletionItemProvider(ie,de){return(0,B.checkProposedApiEnabled)(Oe),dt.registerInlineCompletionsProvider(Oe,vt(ie),de)},registerDocumentLinkProvider(ie,de){return dt.registerDocumentLinkProvider(Oe,vt(ie),de)},registerColorProvider(ie,de){return dt.registerColorProvider(Oe,vt(ie),de)},registerFoldingRangeProvider(ie,de){return dt.registerFoldingRangeProvider(Oe,vt(ie),de)},registerSelectionRangeProvider(ie,de){return dt.registerSelectionRangeProvider(Oe,ie,de)},registerCallHierarchyProvider(ie,de){return dt.registerCallHierarchyProvider(Oe,ie,de)},setLanguageConfiguration:(ie,de)=>dt.setLanguageConfiguration(Oe,ie,de),getTokenInformationAtPosition(ie,de){return(0,B.checkProposedApiEnabled)(Oe),Kt.tokenAtPosition(ie,de)},registerInlayHintsProvider(ie,de){return(0,B.checkProposedApiEnabled)(Oe),dt.registerInlayHintsProvider(Oe,ie,de)},registerTypeHierarchyProvider(ie,de){return(0,B.checkProposedApiEnabled)(Oe),dt.registerTypeHierarchyProvider(Oe,ie,de)},createLanguageStatusItem(ie){return(0,B.checkProposedApiEnabled)(Oe),Kt.createLanguageStatusItem(ie)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(ie,de,Le){const rt=await(T.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(rt,de,Le)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Oe,ie)},onDidChangeActiveTextEditor(ie,de,Le){return Pt.onDidChangeActiveTextEditor(ie,de,Le)},onDidChangeVisibleTextEditors(ie,de,Le){return Pt.onDidChangeVisibleTextEditors(ie,de,Le)},onDidChangeTextEditorSelection(ie,de,Le){return Pt.onDidChangeTextEditorSelection(ie,de,Le)},onDidChangeTextEditorOptions(ie,de,Le){return Pt.onDidChangeTextEditorOptions(ie,de,Le)},onDidChangeTextEditorVisibleRanges(ie,de,Le){return Pt.onDidChangeTextEditorVisibleRanges(ie,de,Le)},onDidChangeTextEditorViewColumn(ie,de,Le){return Pt.onDidChangeTextEditorViewColumn(ie,de,Le)},onDidCloseTerminal(ie,de,Le){return mt.onDidCloseTerminal(ie,de,Le)},onDidOpenTerminal(ie,de,Le){return mt.onDidOpenTerminal(ie,de,Le)},onDidChangeActiveTerminal(ie,de,Le){return mt.onDidChangeActiveTerminal(ie,de,Le)},onDidChangeTerminalDimensions(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),mt.onDidChangeTerminalDimensions(ie,de,Le)},onDidWriteTerminalData(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),mt.onDidWriteTerminalData(ie,de,Le)},get state(){return Ke.state},onDidChangeWindowState(ie,de,Le){return Ke.onDidChangeWindowState(ie,de,Le)},showInformationMessage(ie,...de){return an.showMessage(Oe,C.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return an.showMessage(Oe,C.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return an.showMessage(Oe,C.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Le){return Ot.showQuickPick(ie,!!Oe.enableProposedApi,de,Le)},showWorkspaceFolderPick(ie){return Ot.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return Ot.showInput(ie,de)},showOpenDialog(ie){return Bt.showOpenDialog(ie)},showSaveDialog(ie){return Bt.showSaveDialog(ie)},createStatusBarItem(ie,de,Le){let rt,wt,Ct;return typeof ie=="string"?(rt=ie,wt=de,Ct=Le):(wt=ie,Ct=de),Lt.createStatusBarEntry(Oe,rt,wt,Ct)},setStatusBarMessage(ie,de){return Lt.setStatusBarMessage(ie,de)},withScmProgress(ie){return tt.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:F.ProgressLocation.SourceControl},(de,Le)=>ie({report(rt){}}))},withProgress(ie,de){return hn.withProgress(Oe,ie,de)},createOutputChannel(ie){return bn.createOutputChannel(ie,Oe)},createWebviewPanel(ie,de,Le,rt){return sn.createWebviewPanel(Oe,ie,de,Le,rt)},createWebviewTextEditorInset(ie,de,Le,rt){return(0,B.checkProposedApiEnabled)(Oe),en.createWebviewEditorInset(ie,de,Le,rt,Oe)},createTerminal(ie,de,Le){return typeof ie=="object"?(ie.color&&(0,B.checkProposedApiEnabled)(Oe),"pty"in ie?mt.createExtensionTerminal(ie):mt.createTerminalFromOptions(ie)):mt.createTerminal(ie,de,Le)},registerTerminalLinkProvider(ie){return mt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,de){return mt.registerProfileProvider(Oe,ie,de)},registerTreeDataProvider(ie,de){return dn.registerTreeDataProvider(ie,de,Oe)},createTreeView(ie,de){return dn.createTreeView(ie,de,Oe)},registerWebviewPanelSerializer:(ie,de)=>sn.registerWebviewPanelSerializer(Oe,ie,de),registerCustomEditorProvider:(ie,de,Le={})=>Sn.registerCustomEditorProvider(Oe,ie,de,Le),registerFileDecorationProvider(ie){return kt.registerFileDecorationProvider(ie,Oe.identifier)},registerUriHandler(ie){return Vt.registerUriHandler(Oe.identifier,ie)},createQuickPick(){return Ot.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Ot.createInputBox(Oe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Le){return fn.onDidChangeActiveColorTheme(ie,de,Le)},registerWebviewViewProvider(ie,de,Le){return yn.registerWebviewViewProvider(Oe,ie,de,Le?.webviewOptions)},get activeNotebookEditor(){return(0,B.checkProposedApiEnabled)(Oe),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),pt.onDidChangeActiveNotebookEditor(ie,de,Le)},get visibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Oe),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Oe),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),Wt.onDidChangeNotebookEditorSelection(ie,de,Le)},onDidChangeNotebookEditorVisibleRanges(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),Wt.onDidChangeNotebookEditorVisibleRanges(ie,de,Le)},showNotebookDocument(ie,de){return(0,B.checkProposedApiEnabled)(Oe),pt.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),Gt.registerExternalUriOpener(Oe.identifier,ie,de,Le)},get openEditors(){return(0,B.checkProposedApiEnabled)(Oe),bt.tabs},get onDidChangeOpenEditors(){return(0,B.checkProposedApiEnabled)(Oe),bt.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,B.checkProposedApiEnabled)(Oe),h.InlineCompletionController.get(ie)}},vn={get rootPath(){return tt.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return ot.getWorkspaceFolder(ie)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(ie){throw L.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,de,...Le)=>ot.updateWorkspaceFolders(Oe,ie,de||0,...Le),onDidChangeWorkspaceFolders:function(ie,de,Le){return ot.onDidChangeWorkspace(ie,de,Le)},asRelativePath:(ie,de)=>ot.getRelativePath(ie,de),findFiles:(ie,de,Le,rt)=>ot.findFiles(x.GlobPattern.from(ie),x.GlobPattern.from(de),Le,Oe.identifier,rt),findTextInFiles:(ie,de,Le,rt)=>{let wt,Ct;return typeof de=="object"?(wt=de,Ct=Le):(wt={},Ct=de,rt=Le),ot.findTextInFiles(ie,wt||{},Ct,Oe.identifier,rt)},saveAll:ie=>ot.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,de,Le,rt)=>Mt.createFileSystemWatcher(x.GlobPattern.from(ie),de,Le,rt),get textDocuments(){return St.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let de;const Le=ie;if(typeof ie=="string")de=Promise.resolve(T.URI.file(ie));else if(T.URI.isUri(ie))de=Promise.resolve(ie);else if(!Le||typeof Le=="object")de=St.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>St.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(ie,de,Le)=>St.onDidAddDocument(ie,de,Le),onDidCloseTextDocument:(ie,de,Le)=>St.onDidRemoveDocument(ie,de,Le),onDidChangeTextDocument:(ie,de,Le)=>St.onDidChangeDocument(ie,de,Le),onDidSaveTextDocument:(ie,de,Le)=>St.onDidSaveDocument(ie,de,Le),onWillSaveTextDocument:(ie,de,Le)=>Yt.getOnWillSaveTextDocumentEvent(Oe)(ie,de,Le),get notebookDocuments(){return pt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,de){let Le;if(T.URI.isUri(ie))Le=ie,await pt.openNotebookDocument(ie);else if(typeof ie=="string")Le=T.URI.revive(await pt.createNotebookDocument({viewType:ie,content:de}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Le).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,de,Le,rt){return pt.registerNotebookSerializer(Oe,ie,de,Le,Oe.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(ie,de,Le,rt)=>((0,B.checkProposedApiEnabled)(Oe),pt.registerNotebookContentProvider(Oe,ie,de,Le,Oe.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(ie,de,Le)=>mn.onDidChangeConfiguration(ie,de,Le),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,mn.getConfiguration(ie,de,Oe)},registerTextDocumentContentProvider(ie,de){return Xt.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(tt.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Oe,ie,de)),registerFileSystemProvider(ie,de,Le){return tn.registerFileSystemProvider(Oe.identifier,ie,de,Le,Oe.enableProposedApi)},get fs(){return ht.value},registerFileSearchProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Oe),Tt.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Oe),Tt.registerTextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,B.checkProposedApiEnabled)(Oe),Et.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,B.checkProposedApiEnabled)(Oe),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,de,Le)=>Mt.onDidCreateFile(ie,de,Le),onDidDeleteFiles:(ie,de,Le)=>Mt.onDidDeleteFile(ie,de,Le),onDidRenameFiles:(ie,de,Le)=>Mt.onDidRenameFile(ie,de,Le),onWillCreateFiles:(ie,de,Le)=>Mt.getOnWillCreateFileEvent(Oe)(ie,de,Le),onWillDeleteFiles:(ie,de,Le)=>Mt.getOnWillDeleteFileEvent(Oe)(ie,de,Le),onWillRenameFiles:(ie,de,Le)=>Mt.getOnWillRenameFileEvent(Oe)(ie,de,Le),openTunnel:ie=>((0,B.checkProposedApiEnabled)(Oe),Ne.openTunnel(Oe,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,B.checkProposedApiEnabled)(Oe),Ne.getTunnels()},onDidChangeTunnels:(ie,de,Le)=>((0,B.checkProposedApiEnabled)(Oe),Ne.onDidChangeTunnels(ie,de,Le)),registerPortAttributesProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Oe),Ne.registerPortsAttributesProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Oe),rn.registerTimelineProvider(ie,de,Oe.identifier,ut.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:ie=>((0,B.checkProposedApiEnabled)(Oe),ot.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,de,Le)=>ot.onDidGrantWorkspaceTrust(ie,de,Le)},Rn={get inputBox(){return tt.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Oe)},createSourceControl(ie,de,Le){return qt.createSourceControl(Oe,ie,de,Le)}},Ln={createCommentController(ie,de){return En.createCommentController(Oe,ie,de)}},Fn={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(ie,de,Le){return _t.onDidStartDebugSession(ie,de,Le)},onDidTerminateDebugSession(ie,de,Le){return _t.onDidTerminateDebugSession(ie,de,Le)},onDidChangeActiveDebugSession(ie,de,Le){return _t.onDidChangeActiveDebugSession(ie,de,Le)},onDidReceiveDebugSessionCustomEvent(ie,de,Le){return _t.onDidReceiveDebugSessionCustomEvent(ie,de,Le)},onDidChangeBreakpoints(ie,de,Le){return _t.onDidChangeBreakpoints(ie,de,Le)},registerDebugConfigurationProvider(ie,de,Le){return _t.registerDebugConfigurationProvider(ie,de,Le||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return _t.registerDebugAdapterDescriptorFactory(Oe,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return _t.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Le){return!Le||typeof Le=="object"&&"configuration"in Le?_t.startDebugging(ie,de,{parentSession:Le}):_t.startDebugging(ie,de,Le||{})},stopDebugging(ie){return _t.stopDebugging(ie)},addBreakpoints(ie){return _t.addBreakpoints(ie)},removeBreakpoints(ie){return _t.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return _t.asDebugSourceUri(ie,de)}},Mn={registerTaskProvider:(ie,de)=>It.registerTaskProvider(Oe,ie,de),fetchTasks:ie=>It.fetchTasks(ie),executeTask:ie=>It.executeTask(Oe,ie),get taskExecutions(){return It.taskExecutions},onDidStartTask:(ie,de,Le)=>It.onDidStartTask(ie,de,Le),onDidEndTask:(ie,de,Le)=>It.onDidEndTask(ie,de,Le),onDidStartTaskProcess:(ie,de,Le)=>It.onDidStartTaskProcess(ie,de,Le),onDidEndTaskProcess:(ie,de,Le)=>It.onDidEndTaskProcess(ie,de,Le)},On={createNotebookController(ie,de,Le,rt,wt){return Jt.createNotebookController(Oe,ie,de,Le,rt,Oe.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,de)=>pt.registerNotebookCellStatusBarItemProvider(Oe,ie,de),get onDidSaveNotebookDocument(){return(0,B.checkProposedApiEnabled)(Oe),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,B.checkProposedApiEnabled)(Oe),Wt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return Zt.createRendererMessaging(Oe,ie)},onDidChangeNotebookDocumentMetadata(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),jt.onDidChangeNotebookDocumentMetadata(ie,de,Le)},onDidChangeNotebookCells(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCells(ie,de,Le)},onDidChangeNotebookCellExecutionState(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCellExecutionState(ie,de,Le)},onDidChangeCellOutputs(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),pt.onDidChangeCellOutputs(ie,de,Le)},onDidChangeCellMetadata(ie,de,Le){return(0,B.checkProposedApiEnabled)(Oe),pt.onDidChangeCellMetadata(ie,de,Le)},createConcatTextDocument(ie,de){return(0,B.checkProposedApiEnabled)(Oe),new _e.ExtHostNotebookConcatDocument(pt,St,ie,de)}};return{version:Xe.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:ln,languages:An,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:I.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,Task2:F.Task,TaskGroup:F.TaskGroup,TaskGroup2:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:d.UIKind,Uri:T.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:Ee.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(ge[274],pe([0,1,80,65,36,131,37,44,45,33,69,53,71,93,52,64,132,92,62,91,122,51]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,g.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,g.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,g.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,g.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,g.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,g.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,g.registerSingleton)(S.IExtHostWindow,S.ExtHostWindow),(0,g.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,g.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,g.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(ge[94],pe([0,1,20,12,31,68]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=T;function y(A,d,m,l){const v=(0,g.mapArrayOrNot)(m,_),S=new k.TextSearchMatch(d,v,l),b=S.preview.matches;return{ranges:(0,g.mapArrayOrNot)(v,I),uri:A,preview:{text:S.preview.text,matches:(0,g.mapArrayOrNot)(b,I)}}}e.createTextSearchResult=y;function _(A){return new k.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function I(A){return new C.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let n=class{constructor(d,m){this.prefix=d,this.logService=m}appendLine(d){this.logService.debug(`${this.prefix}#search`,d)}};n=ze([$e(1,L.ILogService)],n),e.OutputChannel=n}),define(ge[275],pe([0,1,96,24]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,T=512,y=512*8,_=512*128;class I{constructor(r){this.iconvLiteDecoder=r}static async create(r){let o;if(r!==e.UTF8)o=(await new Promise((a,h)=>{J(["iconv-lite-umd"],a,h)})).getDecoder(m(r));else{const i=new TextDecoder;o={write(a){return i.decode(a,{stream:!0})},end(){return i.decode()}}}return new I(o)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function n(t,r){const o=r.minBytesRequiredForDetection??r.guessEncoding?y:T;return new Promise((i,a)=>{const h=(0,g.newWriteableStream)(D=>D.join("")),u=[];let w=0,E;const s=async()=>{try{const D=await p({buffer:L.VSBuffer.concat(u),bytesRead:w},r.guessEncoding);D.encoding=await r.overwriteEncoding(D.encoding),E=await I.create(D.encoding);const R=E.write(L.VSBuffer.concat(u).buffer);h.write(R),u.length=0,w=0,i({stream:h,detected:D})}catch(D){a(D)}};(0,g.listenStream)(t,{onData:async D=>{E?h.write(E.write(D.buffer)):(u.push(D),w+=D.byteLength,w>=o&&(t.pause(),await s(),setTimeout(()=>t.resume())))},onError:D=>h.error(D),onEnd:async()=>{E||await s(),h.end(E?.end())}})})}e.toDecodeStream=n;async function A(t,r,o){const a=(await new Promise((w,E)=>{J(["iconv-lite-umd"],w,E)})).getEncoder(m(r),o);let h=!1,u=!1;return{read(){if(u)return null;const w=t.read();if(typeof w!="string"){if(u=!0,!h&&o?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=a.end();return E&&E.length>0?(h=!0,L.VSBuffer.wrap(E)):null}return h=!0,L.VSBuffer.wrap(a.write(w))}}}e.toEncodeReadable=A;async function d(t){return(await new Promise((o,i)=>{J(["iconv-lite-umd"],o,i)})).encodingExists(m(t))}e.encodingExists=d;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function l(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),i=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return o===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const v=["ascii","utf-16","utf-32"];async function S(t){const r=await new Promise((u,w)=>{J(["jschardet"],u,w)}),o=t.slice(0,_),i=c(o.buffer),a=r.detect(i);if(!a||!a.encoding)return null;const h=a.encoding.toLowerCase();return 0<=v.indexOf(h)?null:P(a.encoding)}const b={ibm866:"cp866",big5:"cp950"};function P(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[r]||r}function c(t){let r="";for(let o=0;o<t.length;o++)r+=String.fromCharCode(t[o]);return r}function f(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=f;function p({buffer:t,bytesRead:r},o){let i=l(t,r),a=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let h=!0,u=!0,w=!1;for(let E=0;E<r&&E<C;E++){const s=E%2==1,D=t.readUInt8(E)===0;if(D&&(w=!0),h&&(s&&!D||!s&&D)&&(h=!1),u&&(s&&D||!s&&!D)&&(u=!1),D&&!h&&!u)break}w&&(h?i=e.UTF16le:u?i=e.UTF16be:a=!0)}return o&&!a&&!i&&t?S(t.slice(0,r)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:a,encoding:i}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[134],pe([0,1,275,28,133]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends k.TextSearchManager{constructor(y,_,I=L){super(y,_,{readdir:n=>I.Promises.readdir(n.fsPath),toCanonicalName:n=>(0,g.toCanonicalName)(n)})}}e.NativeTextSearchManager=C}),define(ge[276],pe([0,1,277,292,293,2,294]),function(J,e,g,L,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function y(A,d,m,l,v,S){const b=S.environment.useHostProxy,P=typeof b=="boolean"?b:!S.remote.isRemote,c=(0,T.createProxyResolver)({resolveProxy:p=>A.resolveProxy(p),getHttpProxySetting:()=>d.getConfiguration("http").get("proxy"),log:(p,t,...r)=>{switch(p){case T.LogLevel.Trace:l.trace(t,...r);break;case T.LogLevel.Debug:l.debug(t,...r);break;case T.LogLevel.Info:l.info(t,...r);break;case T.LogLevel.Warning:l.warn(t,...r);break;case T.LogLevel.Error:l.error(t,...r);break;case T.LogLevel.Critical:l.critical(t,...r);break;case T.LogLevel.Off:break;default:o(p,t,r);break}function o(i,a,...h){l.error("Unknown log level",i),l.error(a,...h)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:P,env:process.env}),f=_(d,c);return n(m,f)}e.connectProxyResolver=y;function _(A,d){const m={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(v=>{m.config=A.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(v=>{l.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,d,{config:"off"},l,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,d,{config:"on"},l,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,d,{config:"override"},l,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,d,m,l,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,d,m,l,!1))},https:{off:Object.assign({},L,(0,T.createHttpPatch)(L,d,{config:"off"},l,!0)),on:Object.assign({},L,(0,T.createHttpPatch)(L,d,{config:"on"},l,!0)),override:Object.assign({},L,(0,T.createHttpPatch)(L,d,{config:"override"},l,!0)),onRequest:Object.assign({},L,(0,T.createHttpPatch)(L,d,m,l,!0)),default:Object.assign(L,(0,T.createHttpPatch)(L,d,m,l,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const I=new Map;function n(A,d){return A.getExtensionPathIndex().then(m=>{const l=J.__$__nodeRequire("module"),v=l._load;l._load=function(b,P,c){if(b==="tls")return d.tls;if(b!=="http"&&b!=="https")return v.apply(this,arguments);const f=d[b],p=m.findSubstr(C.URI.file(P.filename).fsPath);let t=I.get(p);if(t||I.set(p,t={}),!t[b]){let r=f.default;p&&p.enableProposedApi&&(r=f[p.proxySupport]||f.onRequest),t[b]={...r}}return t[b]}})}}),define(ge[278],pe([0,1,39,9,76,29,11,8,94,279]),function(J,e,g,L,k,C,T,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(c,f,p,t){const r=d(c,f,p,t),o=f.folder.fsPath;return{cmd:g.spawn(n,r.args,{cwd:o}),rgDiskPath:n,siblingClauses:r.siblingClauses,rgArgs:r,cwd:o}}e.spawnRipgrepCmd=A;function d(c,f,p,t){const r=["--files","--hidden","--case-sensitive"];l([f],p,!1).forEach(i=>{const a=(0,_.anchorGlob)(i);if(r.push("-g",a),T.isMacintosh){const h=(0,k.normalizeNFD)(a);h!==a&&r.push("-g",h)}});const o=m([f],t,void 0,!1);return o.globArgs.forEach(i=>{const a=`!${(0,_.anchorGlob)(i)}`;if(r.push("-g",a),T.isMacintosh){const h=(0,k.normalizeNFD)(a);h!==a&&r.push("-g",h)}}),f.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),f.ignoreSymlinks||r.push("--follow"),c.exists&&r.push("--quiet"),r.push("--no-config"),f.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:o.siblingClauses}}function m(c,f,p,t=!0){const r=[];let o={};return c.forEach(i=>{const a=Object.assign({},i.excludePattern||{},f||{}),h=v(a,t?i.folder.fsPath:void 0,p);r.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:r,siblingClauses:o}}e.foldersToRgExcludeGlobs=m;function l(c,f,p=!0){const t=[];return c.forEach(r=>{const o=Object.assign({},f||{},r.includePattern||{}),i=v(o,p?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=l;function v(c,f,p){const t=[],r={};return Object.keys(c).forEach(o=>{if(p&&p.has(o)||!o)return;const i=c[o];o=b(f?S(f,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),t.push(P(o))):i&&i.when&&(r[o]=i)}),{globArgs:t,siblingClauses:r}}function S(c,f){return L.isAbsolute(f)?f:L.join(c,f)}e.getAbsoluteGlob=S;function b(c){return c=y.rtrim(c,"\\"),y.rtrim(c,"/")}function P(c){return C.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=P}),define(ge[280],pe([0,1,39,49,9,104,20,60,30,76,29,11,46,8,14,28,31,278,101]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(o=>o())});class f{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&_.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,P.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&_.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),u=a.folder.fsPath;i.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==u).forEach(w=>{(0,n.isEqualOrParent)(w,u)&&(h[k.relative(u,w)]=!0)}),this.folderExcludePatterns.set(u,new t(h,u))})}cancel(){this.isCanceled=!0}walk(i,a,h,u,w){if(this.fileWalkSW=d.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);a.forEach(E=>{const s=k.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,s)||this.matchFile(h,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=d.StopWatch.create(!1),this.parallel(i,(E,s)=>{this.call(this.cmdTraversal,this,E,h,u,D=>{if(D){const R=(0,y.toErrorMessage)(D);console.error(R),this.errors.push(R),s(D,void 0)}else s(null,void 0)})},(E,s)=>{this.fileWalkSW.stop();const D=E?T.coalesce(E)[0]:null;w(D,this.isLimitHit)})}parallel(i,a,h){const u=new Array(i.length),w=new Array(i.length);let E=!1,s=0;if(i.length===0)return h(null,[]);i.forEach((D,R)=>{a(D,(U,V)=>{if(U?(E=!0,u[R]=null,w[R]=U):(u[R]=V,w[R]=null),++s===i.length)return h(E?w:null,u)})})}call(i,a,...h){try{i.apply(a,h)}catch(u){h[h.length-1](u)}}cmdTraversal(i,a,h,u){const w=i.folder.fsPath,E=A.isMacintosh;let s;const D=()=>s&&s.kill();c.add(D);let R=F=>{c.delete(D),R=()=>{},u(F)},U="";const V=this.initDirectoryTree();let ee;const Q=(0,b.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);s=Q.cmd,ee=!Object.keys(Q.siblingClauses).length;const O=Q.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let x=`${Q.rgDiskPath} ${O}
 - cwd: ${Q.cwd}`;Q.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(Q.rgArgs.siblingClauses)}`),h({message:x}),this.cmdResultCount=0,this.collectStdout(s,"utf8",h,(F,z,M)=>{if(F){R(F);return}if(this.isLimitHit){R();return}const q=(U+(E?I.normalizeNFC(z||""):z)).split(`
`);if(M){const B=q.length;q[B-1]=q[B-1].trim(),q[B-1]||q.pop()}else U=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,ee){for(const B of q)if(this.matchFile(a,{base:w,relativePath:B,searchPath:this.getSearchPath(i,B)}),this.isLimitHit){D();break}(M||this.isLimitHit)&&R();return}this.addDirectoryEntries(i,V,w,q,a),M&&(this.matchDirectoryTree(V,w,a),R())})}spawnFindCmd(i){const a=this.folderExcludePatterns.get(i.folder.fsPath),h=a.getBasenameTerms(),u=a.getPathTerms(),w=["-L","."];if(h.length||u.length){w.push("-not","(","(");for(const E of h)w.push("-name",E),w.push("-o");for(const E of u)w.push("-path",E),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),g.spawn("find",w,{cwd:i.folder.fsPath})}readStdout(i,a,h){let u="";this.collectStdout(i,a,()=>{},(w,E,s)=>{if(w){h(w);return}u+=E,s&&h(null,u)})}collectStdout(i,a,h,u){let w=(D,R,U)=>{(D||U)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),u(D,R,U)},E=!1;i.stdout?(this.forwardData(i.stdout,a,w),i.stdout.once("data",()=>E=!0)):h({message:"stdout is null"});let s;i.stderr?s=this.collectData(i.stderr):h({message:"stderr is null"}),i.on("error",D=>{w(D)}),i.on("close",D=>{let R;!E&&(R=this.decodeData(s,a))&&r(R)?w(new Error(`command failed with error code ${D}: ${this.decodeData(s,a)}`)):(this.exists&&D===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(i,a,h){const u=new C.StringDecoder(a);return i.on("data",w=>{h(null,u.write(w))}),u}collectData(i){const a=[];return i.on("data",h=>{a.push(h)}),a}decodeData(i,a){const h=new C.StringDecoder(a);return i.map(u=>h.write(u)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:a},h,u,w){u.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const E=s=>{const D=k.basename(s),R=k.dirname(s);let U=a[R];U||(U=a[R]=[],E(R)),U.push({base:h,relativePath:s,basename:D,searchPath:this.getSearchPath(i,s)})};u.forEach(E)}matchDirectoryTree({rootEntries:i,pathToEntries:a},h,u){const w=this,E=this.folderExcludePatterns.get(h),s=this.filePattern;function D(R){w.directoriesWalked++;const U=_.hasSiblingFn(()=>R.map(V=>V.basename));for(let V=0,ee=R.length;V<ee;V++){const Q=R[V],{relativePath:O,basename:x}=Q;if(E.test(O,x,s!==x?U:void 0))continue;const F=a[O];if(F)D(F);else{if(w.filesWalked++,O===s)continue;w.matchFile(u,Q)}if(w.isLimitHit)break}}D(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,a,h,u,w){const E=i.folder,s=_.hasSiblingFn(()=>h);this.parallel(h,(D,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const U=a?[a,D].join(k.sep):D;if(this.folderExcludePatterns.get(i.folder.fsPath).test(U,D,this.config.filePattern!==D?s:void 0))return R(null);const V=[E.fsPath,U].join(k.sep);L.lstat(V,(ee,Q)=>{if(ee||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(V,Q,(O,x)=>O||this.isCanceled||this.isLimitHit?R(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(V,Q,(F,z)=>F||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?R(null):(this.walkedPaths[z]=!0,v.Promises.readdir(V).then(M=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(i,U,M,u,N=>R(N||null))},M=>{R(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&l.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(u,{base:E.fsPath,relativePath:U,searchPath:this.getSearchPath(i,U)}),R(null,void 0)))})},D=>{const R=D&&T.coalesce(D);return w(R&&R.length>0?R[0]:void 0)})}matchFile(i,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(a))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,a,h){return a.isSymbolicLink()?L.stat(i,h):h(null,a)}realPathIfNeeded(i,a,h){return a.isSymbolicLink()?L.realpath(i,(u,w)=>u?h(u):h(null,w)):h(null,i)}getSearchPath(i,a){return i.folderName?k.join(i.folderName,a):a}}e.FileWalker=f;class p{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new f(i)}search(i,a,h){this.walker.walk(this.folderQueries,this.extraFiles,i,a,(u,w)=>{h(u,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(i,a){this.expression=i,this.root=a,this.init(i)}init(i){let a,h;Object.keys(i).filter(u=>i[u]).forEach(u=>{k.isAbsolute(u)?(a=a||_.getEmptyExpression(),a[u]=i[u]):(h=h||_.getEmptyExpression(),h[u]=i[u])}),this.absoluteParsedExpr=a&&_.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=h&&_.parse(h,{trimForExclusions:!0})}test(i,a,h){return this.relativeParsedExpr&&this.relativeParsedExpr(i,a,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),a,h)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getPathTerms(this.relativeParsedExpr)),i}}function r(o){const i=o.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=r}),define(ge[135],pe([0,1,39,295,104,20,55,30,9,8,2,31,68,296,279,94]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(E){this.outputChannel=E}provideTextSearchResults(E,s,D,R){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...s,folder:s.folder.toString()})}`),new Promise((U,V)=>{R.onCancellationRequested(()=>N());const ee=r(E,s),Q=s.folder.fsPath,O=ee.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${S} ${O}
 - cwd: ${Q}`);let x=g.spawn(S,ee,{cwd:Q});x.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),V((0,A.serializeSearchError)(new A.SearchError(he&&he.message,A.SearchErrorCode.rgProcessError)))});let F=!1;const z=new f(s.maxResults,Q,s.previewOptions);z.on("result",he=>{F=!0,B="",D.report(he)});let M=!1;const N=()=>{M=!0,x&&x.kill(),z&&z.cancel()};let q=!1;z.on("hitLimit",()=>{q=!0,N()});let B="";x.stdout.on("data",he=>{z.handleData(he),F||(B+=he)});let K=!1;x.stdout.once("data",()=>K=!0);let te="";x.stderr.on("data",he=>{const De=he.toString();this.outputChannel.appendLine(De),te+=De}),x.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),B&&this.outputChannel.appendLine(`Got data without result: ${B}`),this.outputChannel.appendLine(""),M)U({limitHit:q});else{z.flush(),x=null;let he;te&&!K&&(he=P(te))?V((0,A.serializeSearchError)(new A.SearchError(he.message,he.code))):U({limitHit:q})}})})}}e.RipgrepTextSearchEngine=b;function P(w){const E=w.split(`
`),s=E[0].trim();if(E.some(R=>R.startsWith("regex parse error")))return new A.SearchError(c(E),A.SearchErrorCode.regexParseError);const D=s.match(/grep config error: unknown encoding: (.*)/);if(D)return new A.SearchError(`Unknown encoding: ${D[1]}`,A.SearchErrorCode.unknownEncoding);if(s.startsWith("error parsing glob"))return new A.SearchError(s.charAt(0).toUpperCase()+s.substr(1),A.SearchErrorCode.globParseError);if(s.startsWith("the literal"))return new A.SearchError(s.charAt(0).toUpperCase()+s.substr(1),A.SearchErrorCode.invalidLiteral);if(s.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(s,A.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=P;function c(w){const E=["Regex parse error"],s=w.filter(D=>D.startsWith("PCRE2:"));if(s.length>=1){const D=s[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const R=D.split(":")[1];E.push(":"+R)}}return E.join("")}e.buildRegexParseError=c;class f extends L.EventEmitter{constructor(E,s,D){super();this.maxResults=E,this.rootFolder=s,this.previewOptions=D,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,s){return super.on(E,s),this}handleData(E){if(this.isDone)return;const s=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(s)}handleDecodedData(E){let s=E.indexOf(`
`);const D=this.remainder+E;if(s>=0)s+=this.remainder.length;else{this.remainder=D;return}let R=0;for(;s>=0;)this.handleLine(D.substring(R,s).trim()),R=s+1,s=D.indexOf(`
`,R);this.remainder=D.substring(R)}handleLine(E){if(this.isDone||!E)return;let s;try{s=JSON.parse(E)}catch(D){throw new Error(`malformed line from rg: ${E}`)}if(s.type==="match"){const D=p(s.data.path),R=n.URI.file(_.join(this.rootFolder,D)),U=this.createTextSearchMatch(s.data,R);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(s.type==="context"){const D=p(s.data.path),R=n.URI.file(_.join(this.rootFolder,D));this.createTextSearchContext(s.data,R).forEach(V=>this.onResult(V))}}createTextSearchMatch(E,s){const D=E.line_number-1,R=p(E.lines),U=Buffer.from(R);let V=0,ee=0,Q=D;E.submatches.length===0&&E.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const O=(0,C.coalesce)(E.submatches.map((x,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=p(x.match),M=U.slice(V,x.start).toString().length,N=ee+M,q=t(z),B=Q,K=q.numLines+B,te=q.numLines>0?q.lastLineLength:q.lastLineLength+N;return V=x.end,ee=te,Q=K,new d.Range(B,N,K,te)}));return(0,v.createTextSearchResult)(s,R,O,this.previewOptions)}createTextSearchContext(E,s){const D=p(E.lines),R=E.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((U,V)=>({text:U,uri:s,lineNumber:R+V}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=f;function p(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const E=/\n/g;let s=0,D=-1,R;for(;R=E.exec(w);)s++,D=R.index;const U=D>=0?w.length-D-1:w.length;return{numLines:s,lastLineLength:U}}function r(w,E){const s=["--hidden"];s.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:R}=(0,T.groupBy)(E.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const V=new Set;R.forEach(ee=>{V.add(ee)}),s.push("-g","!*"),V.forEach(ee=>{o(ee).map(v.anchorGlob).forEach(Q=>{s.push("-g",Q)})})}D&&D.length&&D.forEach(V=>{s.push("-g",V)}),E.excludes.map(v.anchorGlob).forEach(V=>s.push("-g",`!${V}`)),E.maxFileSize&&s.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?s.push("--no-ignore-parent"):s.push("--no-ignore"),E.followSymlinks&&s.push("--follow"),E.encoding&&E.encoding!=="utf8"&&s.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,I.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),E.usePCRE2&&s.push("--pcre2"),s.push("--crlf"),w.isRegExp&&(w.pattern=i(w.pattern),s.push("--auto-hybrid-regex"));let U;if(w.isWordMatch){const ee=(0,I.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");s.push("--regexp",ee)}else if(w.isRegExp){let V=h(w.pattern);V=u(V),s.push("--regexp",V)}else U=w.pattern,s.push("--fixed-strings");return s.push("--no-config"),E.useGlobalIgnoreFiles||s.push("--no-ignore-global"),s.push("--json"),w.isMultiline&&s.push("--multiline"),E.beforeContext&&s.push("--before-context",E.beforeContext+""),E.afterContext&&s.push("--after-context",E.afterContext+""),s.push("--"),U&&s.push(U),s.push("."),s}function o(w){const E=(0,y.splitGlobAware)(w,"/");return E.map((s,D)=>E.slice(0,D+1).join("/"))}e.spreadGlobComponents=o;function i(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const s=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(s);)w=w.replace(s,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=i;const a=w=>w.type==="Assertion"&&w.kind==="lookbehind";function h(w){let E;try{E=new m.RegExpParser().parsePattern(w)}catch{return w}let s="",D=0;const R=(ee,Q,O)=>{s+=w.slice(D,ee)+O,D=Q},U=[];return new m.RegExpVisitor({onCharacterEnter(ee){if(ee.raw!=="\\n")return;const Q=U[0];if(!Q)R(ee.start,ee.end,"\\r?\\n");else if(!U.some(a))if(Q.type==="CharacterClass")if(Q.negate){const O=w.slice(Q.start+2,ee.start)+w.slice(ee.end,Q.end-1);R(Q.start,Q.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=w.slice(Q.start+1,ee.start)+w.slice(ee.end,Q.end-1);R(Q.start,Q.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else Q.type==="Quantifier"&&R(ee.start,ee.end,"(?:\\r?\\n)")},onQuantifierEnter(ee){U.unshift(ee)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(ee){U.unshift(ee)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(ee){U.unshift(ee)},onCharacterClassLeave(){U.shift()},onAssertionEnter(ee){a(ee)&&U.push(ee)},onAssertionLeave(ee){U[0]===ee&&U.shift()}}).visit(E),s+=w.slice(D),s}e.fixRegexNewline=h;function u(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=u}),define(ge[281],pe([0,1,21,135,118,10]),function(J,e,g,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,n,A,d){const m=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===C.Schemas.userData){const l={...n,folder:n.folder.with({scheme:C.Schemas.file})},v=new k.Progress(S=>A.report({...S,uri:S.uri.with({scheme:n.folder.scheme})}));return this.withToken(d,S=>m.provideTextSearchResults(I,l,v,S))}else return this.withToken(d,l=>m.provideTextSearchResults(I,n,A,l))}async withToken(I,n){const A=y(I);this.inProgress.add(A);const d=await n(A.token);return this.inProgress.delete(A),d}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=T;function y(_){const I=new g.CancellationTokenSource;return _.onCancellationRequested(()=>I.cancel()),I}}),define(ge[282],pe([0,1,28,135,134]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(_){this.query=_}search(_,I,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(m){n({message:m})}},d=new k.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(A),g);return new Promise((m,l)=>d.search(v=>{I(v.map(T))},_).then(v=>m({limitHit:v.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=C;function T(y){return{path:y.resource&&y.resource.fsPath,results:y.results,numMatches:(y.results||[]).reduce((_,I)=>{if(I.ranges){const n=I;return _+(Array.isArray(n.ranges)?n.ranges.length:1)}else return _+1},0)}}}),define(ge[283],pe([0,1,49,297,20,17,16,3,101,9,46,2,42,31,280,282]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const o=c(t),i=new y.Emitter({onFirstListenerDidAdd:()=>{r=(0,C.createCancelablePromise)(a=>this.doFileSearchWithEngine(l.Engine,o,h=>i.fire(h),a)),r.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}textSearch(t){let r;const o=c(t),i=new y.Emitter({onFirstListenerDidAdd:()=>{r=(0,C.createCancelablePromise)(a=>this.ripgrepTextSearch(o,h=>i.fire(h),a)),r.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}ripgrepTextSearch(t,r,o){return t.maxFileSize=(0,d.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(o,r,r)}doFileSearch(t,r,o){return this.doFileSearchWithEngine(l.Engine,t,r,o)}doFileSearchWithEngine(t,r,o,i,a=S.BATCH_SIZE){let h=0;const u=E=>{Array.isArray(E)?(h+=E.length,o(E.map(s=>this.rawMatchToSearchItem(s)))):E.relativePath?(h++,o(this.rawMatchToSearchItem(E))):o(E)};if(r.sortByScore){let E=this.trySortedSearchFromCache(r,u,i);if(!E){const s=r.maxResults?Object.assign({},r,{maxResults:null}):r,D=new t(s);E=this.doSortedSearch(D,r,o,u,i)}return new Promise((s,D)=>{E.then(([R,U])=>{const V=U.map(ee=>this.rawMatchToSearchItem(ee));this.sendProgress(V,o,a),s(R)},D)})}const w=new t(r);return this.doSearch(w,u,a,i).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,I.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,o,i,a){const h=new y.Emitter;let u=(0,C.createCancelablePromise)(E=>{let s=[];const D=R=>{Array.isArray(R)?s=R:(i(R),h.fire(R))};return this.doSearch(t,D,-1,E).then(R=>[R,s])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const E={promise:u,event:h.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=E,u.then(()=>{E.resolved=!0},s=>{delete w.resultsToSearchCache[r.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([E,s])=>{const D=w?w.scorerCache:Object.create(null),R=(typeof r.maxResults!="number"||r.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(r,s,D,a).then(U=>{const V=R?R.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:V,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:U.length},messages:E.messages,limitHit:E.limitHit||typeof r.maxResults=="number"&&s.length>r.maxResults},U]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new b)}trySortedSearchFromCache(t,r,o){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const a=this.getResultsFromCache(i,t.filePattern||"",r,o);if(a)return a.then(([h,u,w])=>{const E=n.StopWatch.create(!1);return this.sortResults(t,u,i.scorerCache,o).then(s=>{const D=E.elapsed(),R={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:u.length,sortingTime:D};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&u.length>t.maxResults,stats:R},s]})})}sortResults(t,r,o,i){const a=(0,_.prepareQuery)(t.filePattern||""),h=(w,E)=>(0,_.compareItemsByFuzzyScore)(w,E,a,!0,P,o),u=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(r,h,u,1e4,i)}sendProgress(t,r,o){if(o&&o>0)for(let i=0;i<t.length;i+=o)r(t.slice(i,i+o));else r(t)}getResultsFromCache(t,r,o,i){const a=n.StopWatch.create(!1),h=r.indexOf(I.sep)>=0;let u;for(const D in t.resultsToSearchCache)if(r.startsWith(D)){if(h&&D.indexOf(I.sep)<0&&D!=="")continue;const R=t.resultsToSearchCache[D];u={promise:this.preventCancellation(R.promise),event:R.event,resolved:R.resolved};break}if(!u)return null;const w=a.elapsed(),E=n.StopWatch.create(!1),s=u.event(o);return i&&i.onCancellationRequested(()=>{s.dispose()}),u.promise.then(([D,R])=>{if(i&&i.isCancellationRequested)throw(0,T.canceled)();const U=[],V=(0,_.prepareQuery)(r).normalizedLowercase;for(const ee of R)!(0,m.isFilePatternMatch)(ee,V)||U.push(ee);return[D,U,{cacheWasResolved:u.resolved,cacheLookupTime:w,cacheFilterTime:E.elapsed(),cacheEntryCount:R.length}]})}doSearch(t,r,o,i){return new Promise((a,h)=>{let u=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(o?(u.push(w),o>0&&u.length>=o&&(r(u),u=[])):r(w))},w=>{r(w)},(w,E)=>{u.length&&r(u),w?h(w):a(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,o){return t.then(r,o)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=S,S.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const P=new class{getItemLabel(p){return(0,I.basename)(p.relativePath)}getItemDescription(p){return(0,I.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function c(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(f),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>A.URI.revive(t))}}function f(p){return{...p,folder:A.URI.revive(p.folder)}}}),define(ge[284],pe([0,1,6,2,28,12,31,283,281,94,13,63,27,71,10,134]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends m.ExtHostSearch{constructor(P,c,f,p){super(P,f,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new I.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new _.RipgrepSearchProvider(t)),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const P=new I.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new _.RipgrepSearchProvider(P)),this.registerInternalFileSearchProvider(l.Schemas.file,new y.SearchService)}registerInternalFileSearchProvider(P,c){const f=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=f,this._proxy.$registerFileSearchProvider(f,this._transformScheme(P)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(P,c,f,p){const t=(0,m.reviveQuery)(f);return P===this._internalFileSearchHandle?this.doInternalFileSearch(P,c,t,p):super.$provideFileSearchResults(P,c,f,p)}doInternalFileSearch(P,c,f,p){const t=r=>{if((0,T.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(P,c,r.map(o=>L.URI.file(o.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(f,t,p)}$clearCache(P){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(P),super.$clearCache(P)}createTextSearchManager(P,c){return new v.NativeTextSearchManager(P,c)}};S=ze([$e(0,n.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,A.IURITransformerService),$e(3,C.ILogService)],S),e.NativeExtHostSearch=S}),define(ge[136],pe([0,1,298,125,78,24,16,3,6,9,11,32,106,107,299]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(u){this.socket=u,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const w=E=>u(C.VSBuffer.wrap(E));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(u){const w=E=>{u({type:0,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((u,w)=>{if(this.socket.bufferSize===0){u();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),u()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=v;var S;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var b;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(b||(b={}));class P extends _.Disposable{constructor(u,w,E,s){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=s,w?(this._zlibInflate=l.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibInflate.on("data",D=>{this._pendingInflateData.push(D)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=l.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibDeflate.on("data",D=>{this._pendingDeflateData.push(D)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(C.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,w){let E=2;u.byteLength<126?E+=0:u.byteLength<2**16?E+=2:E+=8;const s=C.VSBuffer.alloc(E);if(w?s.writeUInt8(194,0):s.writeUInt8(130,0),u.byteLength<126)s.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){s.writeUInt8(126,1);let D=1;s.writeUInt8(u.byteLength>>>8&255,++D),s.writeUInt8(u.byteLength>>>0&255,++D)}else{s.writeUInt8(127,1);let D=1;s.writeUInt8(0,++D),s.writeUInt8(0,++D),s.writeUInt8(0,++D),s.writeUInt8(0,++D),s.writeUInt8(u.byteLength>>>24&255,++D),s.writeUInt8(u.byteLength>>>16&255,++D),s.writeUInt8(u.byteLength>>>8&255,++D),s.writeUInt8(u.byteLength>>>0&255,++D)}this._totalOutgoingWireBytes+=s.byteLength+u.byteLength,this.socket.write(C.VSBuffer.concat([s,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),s=(w.readUInt8(0)&128)>>>7,D=w.readUInt8(1),R=(D&128)>>>7,U=D&127;this._state.state=2,this._state.readLen=2+(R?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=s,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),E=w.readUInt8(1),s=(E&128)>>>7;let D=E&127,R=1;D===126?D=w.readUInt8(++R)*2**8+w.readUInt8(++R):D===127&&(D=w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R));let U=0;s&&(U=w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R)),this._state.state=3,this._state.readLen=D,this._state.mask=U}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);c(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(C.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function c(h,u){if(u===0)return;let w=h.byteLength>>>2;for(let V=0;V<w;V++){const ee=h.readUInt32BE(V*4);h.writeUInt32BE(ee^u,V*4)}let E=w*4,s=h.byteLength-E;const D=u>>>24&255,R=u>>>16&255,U=u>>>8&255;s>=1&&h.writeUInt8(h.readUInt8(E)^D,E),s>=2&&h.writeUInt8(h.readUInt8(E+1)^R,E+1),s>=3&&h.writeUInt8(h.readUInt8(E+2)^U,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function p(){const h=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):u=(0,I.join)((0,k.tmpdir)(),`vscode-ipc-${h}.sock`),r(u),u}e.createRandomIPCHandle=p;function t(h,u,w){const E=(0,g.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${w}-${u}-sock`;let s;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?s=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${w}-${u}.sock`):s=(0,I.join)(h,`${w}-${u}.sock`),r(s),s}e.createStaticIPCHandle=t;function r(h){const u=f[n.platform];typeof u=="number"&&h.length>=u&&console.warn(`WARNING: IPC handle "${h}" is longer than ${u} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{constructor(u){super(o.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const w=y.Event.fromNodeEventEmitter(u,"connection");return y.Event.map(w,E=>({protocol:new m.Protocol(new v(E)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function i(h){return new Promise((u,w)=>{const E=(0,L.createServer)();E.on("error",w),E.listen(h,()=>{E.removeListener("error",w),u(new o(E))})})}e.serve=i;function a(h,u){return new Promise((w,E)=>{const s=(0,L.createConnection)(h,()=>{s.removeListener("error",E),w(m.Client.fromSocket(new v(s),u))});s.once("error",E)})}e.connect=a}),define(ge[285],pe([0,1,136,277,49,44,2,198,12]),function(J,e,g,L,k,C,T,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(d,m,l){this._commands=d,this.logService=m,this._ipcHandlePath=l,this._server=L.createServer((v,S)=>this.onRequest(v,S)),this.setup().catch(v=>(m.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch(d){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,m){const l=[];d.setEncoding("utf8"),d.on("data",v=>l.push(v)),d.on("end",()=>{const v=JSON.parse(l.join(""));switch(v.type){case"open":this.open(v,m);break;case"openExternal":this.openExternal(v,m);break;case"status":this.getStatus(v,m);break;case"extensionManagement":this.manageExtensions(v,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${v.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(d,m){let{fileURIs:l,folderURIs:v,forceNewWindow:S,diffMode:b,addMode:P,forceReuseWindow:c,gotoLineMode:f,waitMarkerFilePath:p}=d;const t=[];if(Array.isArray(v))for(const r of v)try{t.push({folderUri:T.URI.parse(r)})}catch(o){}if(Array.isArray(l))for(const r of l)try{(0,y.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:T.URI.parse(r)}):t.push({fileUri:T.URI.parse(r)})}catch(o){}if(t.length){const r=p?T.URI.file(p):void 0,i={forceNewWindow:S,diffMode:b,addMode:P,gotoLineMode:f,forceReuseWindow:c,preferNewWindow:!c&&!r&&!P,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(d,m){for(const l of d.uris){const v=T.URI.parse(l),S=v.scheme==="file"?v:l;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(d,m){try{const l=b=>b?.map(P=>/\.vsix$/i.test(P)?T.URI.parse(P):P),v={list:d.list,install:l(d.install),uninstall:l(d.uninstall),force:d.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);m.writeHead(200),m.write(S)}catch(l){m.writeHead(500),m.write(String(l),v=>{v&&this.logService.error(v)})}m.end()}async getStatus(d,m){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(l),m.end()}catch(l){m.writeHead(500),m.write(String(l),v=>{v&&this.logService.error(v)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let n=class extends I{constructor(d,m){super(d,m,(0,g.createRandomIPCHandle)())}};n=ze([$e(0,C.IExtHostCommands),$e(1,_.ILogService)],n),e.CLIServer=n}),define(ge[286],pe([0,1,70,273,268,5,276,40,258,2,10,7,285,105]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends k.RequireInterceptor{_installInterceptor(){const b=this,P=J.__$__nodeRequire("module"),c=P._load;P._load=function(p,t,r){for(let o of b._alternatives){let i=o(p);if(i){p=i;break}}return b._factories.has(p)?b._factories.get(p).load(p,I.URI.file((0,m.realpathSync)(t.filename)),o=>c.apply(this,[o,t,r])):c.apply(this,arguments)}}}class v extends y.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(d.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,b,this._registry).install(),g.mark("code/extHost/didInitAPI");const c=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,c,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const f=process.send,p=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?f.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,P,c){if(P.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${P}', must be of file-scheme`);let f=null;c.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${P.toString(!0)}`),this._logService.flush();try{b&&g.mark(`code/extHost/willLoadExtensionCode/${b.value}`),f=J.__$__nodeRequire(P.fsPath)}catch(p){return Promise.reject(p)}finally{b&&g.mark(`code/extHost/didLoadExtensionCode/${b.value}`),c.codeLoadingStop()}return Promise.resolve(f)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const P in b){const c=b[P];c===null?delete process.env[P]:process.env[P]=c}}}e.ExtHostExtensionService=v}),define(ge[287],pe([0,1,80,259,261,270,269,284,286,226,262,53,40,65,71,69,33,52,12,66,260]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S,b,P,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(d.IExtHostExtensionService,_.ExtHostExtensionService),(0,g.registerSingleton)(P.ILogService,I.ExtHostLogService),(0,g.registerSingleton)(c.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,g.registerSingleton)(A.IExtHostDebugService,T.ExtHostDebugService),(0,g.registerSingleton)(m.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(l.IExtHostSearch,y.NativeExtHostSearch),(0,g.registerSingleton)(v.IExtHostTask,C.ExtHostTask),(0,g.registerSingleton)(S.IExtHostTerminalService,k.ExtHostTerminalService),(0,g.registerSingleton)(b.IExtHostTunnelService,n.ExtHostTunnelService)}),define(ge[288],pe([0,1,125,300,70,16,107,136,191,224,271,24,103,28,105,17,114,274,287]),function(J,e,g,L,k,C,T,y,_,I,n,A,d,m,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=J.__$__nodeRequire("module"),a=i._load;i._load=function(h){if(h==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return a.apply(this,arguments)}})();const P=process.exit.bind(process);function c(i){process.exit=function(a){if(i)P(a);else{const h=new Error("An extension called process.exit() and this was prevented.");console.warn(h.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)}}let f=function(i){P()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,a)=>{let h=null,u=setTimeout(()=>{f("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,E=3e5,s=new v.RunOnceScheduler(()=>f("renderer disconnected for too long (1)"),w),D=new v.RunOnceScheduler(()=>f("renderer disconnected for too long (2)"),E);process.on("message",(U,V)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=A.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let Q;if(U.skipWebSocketFrames)Q=new y.NodeSocket(V);else{const O=A.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));Q=new y.WebSocketNodeSocket(new y.NodeSocket(V),U.permessageDeflate,O,!1)}h?(s.cancel(),D.cancel(),h.beginAcceptReconnection(Q,ee),h.endAcceptReconnection()):(clearTimeout(u),h=new T.PersistentProtocol(Q,ee),h.onDidDispose(()=>f("renderer disconnected")),i(h),h.onSocketClose(()=>{s.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(D.isScheduled())return;s.isScheduled()&&D.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((a,h)=>{const u=g.createConnection(i,()=>{u.removeListener("error",h),a(new T.PersistentProtocol(new y.NodeSocket(u)))});u.once("error",h),u.on("close",()=>{f("renderer closed the socket")})})}}async function t(){const i=await p();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(a=>{(0,I.isMessageOfType)(a,2)?(this._terminating=!0,f("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||i.send(a)}drain(){return i.drain()}}}function r(i){return new Promise(a=>{const h=i.onMessage(u=>{h.dispose();const w=JSON.parse(u.toString()),E=w.commit,s=_.default.commit;E&&s&&E!==s&&P(55);const D=[];process.on("unhandledRejection",(V,ee)=>{D.push(ee),setTimeout(()=>{const Q=D.indexOf(ee);Q>=0&&ee.catch(O=>{D.splice(Q,1),(0,C.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),(0,C.onUnexpectedError)(V))})},1e3)}),process.on("rejectionHandled",V=>{const ee=D.indexOf(V);ee>=0&&D.splice(ee,1)}),process.on("uncaughtException",function(V){(0,C.onUnexpectedError)(V)});let R=0;setInterval(function(){try{process.kill(w.parentPid,0),R=0}catch(V){V&&V.code==="EPERM"?(R++,R>=3&&f(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):f(`parent process ${w.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let U;try{U=J.__$__nodeRequire("native-watchdog"),U.start(w.parentPid)}catch(V){(0,C.onUnexpectedError)(V)}i.send((0,I.createMessageOfType)(0)),a({protocol:i,initData:w})});i.send((0,I.createMessageOfType)(1))})}async function o(){k.mark("code/extHost/willConnectToRenderer");const i=await t();k.mark("code/extHost/didConnectToRenderer");const a=await r(i);k.mark("code/extHost/didWaitForInitData");const{initData:h}=a;c(!!h.environment.extensionTestsLocationURI),h.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,h.environment.skipWorkspaceStorageLock=(0,S.boolean)(b.skipWorkspaceStorageLock,!1);const u=new class{exit(D){P(D)}exists(D){return m.Promises.exists(D)}realpath(D){return(0,l.realpath)(D)}};let w=null;if(h.remote.authority&&b.uriTransformerPath)try{const D=J.__$__nodeRequire(b.uriTransformerPath)(h.remote.authority);w=new d.URITransformer(D)}catch(s){console.error(s)}const E=new n.ExtensionHostMain(a.protocol,h,u,w);f=s=>E.terminate(s)}e.startExtensionHostProcess=o}),define(ge[301],pe([0,1,288]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/71b299184f7908491345aec5e231599c3ae8753b/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
