/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Z){for(var e=[],f=0,R=Z.length;f<R;f++)e[f]=Ee[Z[f]];return e};define(Ee[41],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(R,S){if(!R)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=f}),define(Ee[51],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function R(n){const T=[];for(let l in n)f.call(n,l)&&T.push(n[l]);return T}e.values=R;function S(n,T){for(let l in n)if(f.call(n,l)&&T({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=S;function y(n,T){const l=Object.create(null);for(const h of n){const u=T(h);let g=l[u];g||(g=l[u]=[]),g.push(h)}return l}e.groupBy=y;function P(n){const T=Object.create(null);return n&&n.forEach((l,h)=>{T[h]=l}),T}e.fromMap=P;function E(n,T){const l=[],h=[];for(let u of n)T.has(u)||l.push(u);for(let u of T)n.has(u)||h.push(u);return{removed:l,added:h}}e.diffSets=E;function _(n,T){const l=[],h=[];for(let[u,g]of n)T.has(u)||l.push(g);for(let[u,g]of T)n.has(u)||h.push(g);return{removed:l,added:h}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(T,l){let h=this.map.get(T);h||(h=new Set,this.map.set(T,h)),h.add(l)}delete(T,l){const h=this.map.get(T);!h||(h.delete(l),h.size===0&&this.map.delete(T))}forEach(T,l){const h=this.map.get(T);!h||h.forEach(l)}}e.SetMap=C}),define(Ee[52],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(P){return(E,_,C)=>{let n=null,T=null;if(typeof C.value=="function"?(n="value",T=C.value):typeof C.get=="function"&&(n="get",T=C.get),!T)throw new Error("not supported");C[n]=P(T,_)}}e.createDecorator=f;function R(P,E,_){let C=null,n=null;if(typeof _.value=="function"?(C="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",n=_.get),!n)throw new Error("not supported");const T=`$memoize$${E}`;_[C]=function(...l){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[T]}}e.memoize=R;function S(P,E,_){return f((C,n)=>{const T=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...h){this[l]||(this[l]=_?_():void 0),clearTimeout(this[T]),E&&(this[l]=E(this[l],...h),h=[this[l]]),this[T]=setTimeout(()=>{C.apply(this,h),this[l]=_?_():void 0},P)}})}e.debounce=S;function y(P,E,_){return f((C,n)=>{const T=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...g){if(this[l]||(this[l]=_?_():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),E&&(this[l]=E(this[l],...g)),this[u])return;const b=this[h]+P;b<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0):(this[u]=!0,this[T]=setTimeout(()=>{this[u]=!1,this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0},b-Date.now()))}})}e.throttle=y}),define(Ee[12],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=f,e.errorHandler=new f;function R(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=R;function S(v){_(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=S;function y(v){_(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=y;function P(v){if(v instanceof Error){let{name:t,message:r}=v;const a=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:a}}return v}e.transformErrorForSerialization=P;const E="Canceled";function _(v){return v instanceof Error&&v.name===E&&v.message===E}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=C;function n(){const v=new Error(E);return v.name=v.message,v}e.canceled=n;function T(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=T;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function h(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function u(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class A extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=A;function o(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=o;function m(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=m}),define(Ee[17],_e([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(W,te=0){return W[W.length-(1+te)]}e.tail=R;function S(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=S;function y(W,te,he=(Se,Le)=>Se===Le){if(W===te)return!0;if(!W||!te||W.length!==te.length)return!1;for(let Se=0,Le=W.length;Se<Le;Se++)if(!he(W[Se],te[Se]))return!1;return!0}e.equals=y;function P(W,te,he){let Se=0,Le=W.length-1;for(;Se<=Le;){const Me=(Se+Le)/2|0,$e=he(W[Me],te);if($e<0)Se=Me+1;else if($e>0)Le=Me-1;else return Me}return-(Se+1)}e.binarySearch=P;function E(W,te){let he=0,Se=W.length;if(Se===0)return 0;for(;he<Se;){const Le=Math.floor((he+Se)/2);te(W[Le])?Se=Le:he=Le+1}return he}e.findFirstInSorted=E;function _(W,te,he){if(W=W|0,W>=te.length)throw new TypeError("invalid index");let Se=te[Math.floor(te.length*Math.random())],Le=[],Me=[],$e=[];for(let Xe of te){const qe=he(Xe,Se);qe<0?Le.push(Xe):qe>0?Me.push(Xe):$e.push(Xe)}return W<Le.length?_(W,Le,he):W<Le.length+$e.length?$e[0]:_(W-(Le.length+$e.length),Me,he)}e.quickSelect=_;function C(W,te){const he=[];let Se;for(const Le of W.slice(0).sort(te))!Se||te(Se[0],Le)!==0?(Se=[Le],he.push(Se)):Se.push(Le);return he}e.groupBy=C;function n(W,te,he){const Se=[];function Le(Xe,qe,Ge){if(qe===0&&Ge.length===0)return;const U=Se[Se.length-1];U&&U.start+U.deleteCount===Xe?(U.deleteCount+=qe,U.toInsert.push(...Ge)):Se.push({start:Xe,deleteCount:qe,toInsert:Ge})}let Me=0,$e=0;for(;;){if(Me===W.length){Le(Me,0,te.slice($e));break}if($e===te.length){Le(Me,W.length-Me,[]);break}const Xe=W[Me],qe=te[$e],Ge=he(Xe,qe);Ge===0?(Me+=1,$e+=1):Ge<0?(Le(Me,1,[]),Me+=1):Ge>0&&(Le(Me,0,[qe]),$e+=1)}return Se}e.sortedDiff=n;function T(W,te,he){const Se=n(W,te,he),Le=[],Me=[];for(const $e of Se)Le.push(...W.slice($e.start,$e.start+$e.deleteCount)),Me.push(...$e.toInsert);return{removed:Le,added:Me}}e.delta=T;function l(W,te,he){if(he===0)return[];const Se=W.slice(0,he).sort(te);return u(W,te,Se,he,W.length),Se}e.top=l;function h(W,te,he,Se,Le){return he===0?Promise.resolve([]):new Promise((Me,$e)=>{(async()=>{const Xe=W.length,qe=W.slice(0,he).sort(te);for(let Ge=he,U=Math.min(he+Se,Xe);Ge<Xe;Ge=U,U=Math.min(U+Se,Xe)){if(Ge>he&&await new Promise(K=>setTimeout(K)),Le&&Le.isCancellationRequested)throw(0,f.canceled)();u(W,te,qe,Ge,U)}return qe})().then(Me,$e)})}e.topAsync=h;function u(W,te,he,Se,Le){for(const Me=he.length;Se<Le;Se++){const $e=W[Se];if(te($e,he[Me-1])<0){he.pop();const Xe=E(he,qe=>te($e,qe)<0);he.splice(Xe,0,$e)}}}function g(W){return W.filter(te=>!!te)}e.coalesce=g;function b(W){let te=0;for(let he=0;he<W.length;he++)W[he]&&(W[te]=W[he],te+=1);W.length=te}e.coalesceInPlace=b;function w(W,te,he){W.splice(he,0,W.splice(te,1)[0])}e.move=w;function A(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=A;function o(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=o;function m(W,te){if(!te)return W.filter((Se,Le)=>W.indexOf(Se)===Le);const he=Object.create(null);return W.filter(Se=>{const Le=te(Se);return he[Le]?!1:(he[Le]=!0,!0)})}e.distinct=m;function v(W){const te=new Set;return W.filter(he=>te.has(he)?!1:(te.add(he),!0))}e.distinctES6=v;function t(W){const te=Object.create(null);return he=>{const Se=W(he);return te[Se]?!1:(te[Se]=!0,!0)}}e.uniqueFilter=t;function r(W,te){for(let he=W.length-1;he>=0;he--){const Se=W[he];if(te(Se))return he}return-1}e.lastIndex=r;function a(W,te){return W.length>0?W[0]:te}e.firstOrDefault=a;function i(W,te,he=(Se,Le)=>Se===Le){let Se=0;for(let Le=0,Me=Math.min(W.length,te.length);Le<Me&&he(W[Le],te[Le]);Le++)Se++;return Se}e.commonPrefixLength=i;function c(W){return[].concat(...W)}e.flatten=c;function p(W,te){let he=typeof te=="number"?W:0;typeof te=="number"?he=W:(he=0,te=W);const Se=[];if(he<=te)for(let Le=he;Le<te;Le++)Se.push(Le);else for(let Le=he;Le>te;Le--)Se.push(Le);return Se}e.range=p;function d(W,te,he){return W.reduce((Se,Le)=>(Se[te(Le)]=he?he(Le):Le,Se),Object.create(null))}e.index=d;function D(W,te){return W.push(te),()=>I(W,te)}e.insert=D;function I(W,te){const he=W.indexOf(te);if(he>-1)return W.splice(he,1),te}e.remove=I;function s(W,te,he){const Se=W.slice(0,te),Le=W.slice(te);return Se.concat(he,Le)}e.arrayInsert=s;function k(W,te){let he;if(typeof te=="number"){let Se=te;he=()=>{const Le=Math.sin(Se++)*179426549;return Le-Math.floor(Le)}}else he=Math.random;for(let Se=W.length-1;Se>0;Se-=1){const Le=Math.floor(he()*(Se+1)),Me=W[Se];W[Se]=W[Le],W[Le]=Me}}e.shuffle=k;function F(W,te){const he=W.indexOf(te);he>-1&&(W.splice(he,1),W.unshift(te))}e.pushToStart=F;function x(W,te){const he=W.indexOf(te);he>-1&&(W.splice(he,1),W.push(te))}e.pushToEnd=x;function j(W,te){return Array.isArray(W)?W.map(te):te(W)}e.mapArrayOrNot=j;function oe(W){return Array.isArray(W)?W:[W]}e.asArray=oe;function se(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=se;function V(W,te){for(const he of W){const Se=te(he);if(Se!==void 0)return Se}}e.mapFind=V;function H(W,te,he){const Se=Q(W,te),Le=W.length,Me=he.length;W.length=Le+Me;for(let $e=Le-1;$e>=Se;$e--)W[$e+Me]=W[$e];for(let $e=0;$e<Me;$e++)W[$e+Se]=he[$e]}e.insertInto=H;function M(W,te,he,Se){const Le=Q(W,te),Me=W.splice(Le,he);return H(W,Le,Se),Me}e.splice=M;function Q(W,te){return te<0?Math.max(te+W.length,0):Math.min(te,W.length)}function O(W,te){let he=Number.MAX_SAFE_INTEGER,Se=0;return W.forEach((Le,Me)=>{const $e=te(Le);$e<he&&(he=$e,Se=Me)}),Se}e.minIndex=O;function G(W,te){let he=Number.MIN_SAFE_INTEGER,Se=0;return W.forEach((Le,Me)=>{const $e=te(Le);$e>he&&(he=$e,Se=Me)}),Se}e.maxIndex=G;class fe{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let he=this.firstIdx;for(;he<this.items.length&&te(this.items[he]);)he++;const Se=he===this.firstIdx?null:this.items.slice(this.firstIdx,he);return this.firstIdx=he,Se}takeFromEndWhile(te){let he=this.lastIdx;for(;he>=0&&te(this.items[he]);)he--;const Se=he===this.lastIdx?null:this.items.slice(he+1,this.lastIdx+1);return this.lastIdx=he,Se}}e.ArrayQueue=fe}),define(Ee[53],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(R){const S=this;let y=!1,P;return function(){return y||(y=!0,P=R.apply(S,arguments)),P}}e.once=f}),define(Ee[54],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(Ee[55],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(R){function S(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}R.is=S;const y=Object.freeze([]);function P(){return y}R.empty=P;function*E(v){yield v}R.single=E;function _(v){return v||y}R.from=_;function C(v){return!v||v[Symbol.iterator]().next().done===!0}R.isEmpty=C;function n(v){return v[Symbol.iterator]().next().value}R.first=n;function T(v,t){for(const r of v)if(t(r))return!0;return!1}R.some=T;function l(v,t){for(const r of v)if(t(r))return r}R.find=l;function*h(v,t){for(const r of v)t(r)&&(yield r)}R.filter=h;function*u(v,t){let r=0;for(const a of v)yield t(a,r++)}R.map=u;function*g(...v){for(const t of v)for(const r of t)yield r}R.concat=g;function*b(v){for(const t of v)for(const r of t)yield r}R.concatNested=b;function w(v,t,r){let a=r;for(const i of v)a=t(a,i);return a}R.reduce=w;function*A(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}R.slice=A;function o(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const a=v[Symbol.iterator]();for(let i=0;i<t;i++){const c=a.next();if(c.done)return[r,R.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return a}}]}R.consume=o;function m(v,t,r=(a,i)=>a===i){const a=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=a.next(),p=i.next();if(c.done!==p.done)return!1;if(c.done)return!0;if(!r(c.value,p.value))return!1}}R.equals=m})(f=e.Iterable||(e.Iterable={}))}),define(Ee[111],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function P(t,r=!1){let a=0,i=t.length,c="",p=0,d=16,D=0;function I(se){let V=0,H=0;for(;V<se;){const M=t.charCodeAt(a);if(M>=48&&M<=57)H=H*16+M-48;else if(M>=65&&M<=70)H=H*16+M-65+10;else if(M>=97&&M<=102)H=H*16+M-97+10;else break;a++,V++}return V<se&&(H=-1),H}function s(se){a=se,c="",p=0,d=16,D=0}function k(){const se=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&C(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&C(t.charCodeAt(a)))for(a++;a<t.length&&C(t.charCodeAt(a));)a++;else return D=3,t.substring(se,a);let V=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&C(t.charCodeAt(a))){for(a++;a<t.length&&C(t.charCodeAt(a));)a++;V=a}else D=3;return t.substring(se,V)}function F(){let se="",V=a;for(;;){if(a>=i){se+=t.substring(V,a),D=2;break}const H=t.charCodeAt(a);if(H===34){se+=t.substring(V,a),a++;break}if(H===92){if(se+=t.substring(V,a),a++,a>=i){D=2;break}switch(t.charCodeAt(a++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:const Q=I(4);Q>=0?se+=String.fromCharCode(Q):D=4;break;default:D=5}V=a;continue}if(H>=0&&H<=31)if(_(H)){se+=t.substring(V,a),D=2;break}else D=6;a++}return se}function x(){if(c="",D=0,p=a,a>=i)return p=i,d=17;let se=t.charCodeAt(a);if(E(se)){do a++,c+=String.fromCharCode(se),se=t.charCodeAt(a);while(E(se));return d=15}if(_(se))return a++,c+=String.fromCharCode(se),se===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),d=14;switch(se){case 123:return a++,d=1;case 125:return a++,d=2;case 91:return a++,d=3;case 93:return a++,d=4;case 58:return a++,d=6;case 44:return a++,d=5;case 34:return a++,c=F(),d=10;case 47:const V=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<i&&!_(t.charCodeAt(a));)a++;return c=t.substring(V,a),d=12}if(t.charCodeAt(a+1)===42){a+=2;const H=i-1;let M=!1;for(;a<H;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,M=!0;break}a++}return M||(a++,D=1),c=t.substring(V,a),d=13}return c+=String.fromCharCode(se),a++,d=16;case 45:if(c+=String.fromCharCode(se),a++,a===i||!C(t.charCodeAt(a)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),d=11;default:for(;a<i&&j(se);)a++,se=t.charCodeAt(a);if(p!==a){switch(c=t.substring(p,a),c){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return c+=String.fromCharCode(se),a++,d=16}}function j(se){if(E(se)||_(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let se;do se=x();while(se>=12&&se<=15);return se}return{setPosition:s,getPosition:()=>a,scan:r?oe:x,getToken:()=>d,getTokenValue:()=>c,getTokenOffset:()=>p,getTokenLength:()=>a-p,getTokenError:()=>D}}e.createScanner=P;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function T(t,r){const a=[],i=new Object;let c;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function D(I,s,k,F){p.value=I,p.offset=s,p.length=k,p.type=F,p.colonOffset=void 0,c=p}try{o(t,{onObjectBegin:(I,s)=>{if(r<=I)throw i;c=void 0,d=r>I,a.push("")},onObjectProperty:(I,s,k)=>{if(r<s||(D(I,s,k,"property"),a[a.length-1]=I,r<=s+k))throw i},onObjectEnd:(I,s)=>{if(r<=I)throw i;c=void 0,a.pop()},onArrayBegin:(I,s)=>{if(r<=I)throw i;c=void 0,a.push(0)},onArrayEnd:(I,s)=>{if(r<=I)throw i;c=void 0,a.pop()},onLiteralValue:(I,s,k)=>{if(r<s||(D(I,s,k,v(I)),r<=s+k))throw i},onSeparator:(I,s,k)=>{if(r<=s)throw i;if(I===":"&&c&&c.type==="property")c.colonOffset=s,d=!1,c=void 0;else if(I===","){const F=a[a.length-1];typeof F=="number"?a[a.length-1]=F+1:(d=!0,a[a.length-1]=""),c=void 0}}})}catch(I){if(I!==i)throw I}return{path:a,previousNode:c,isAtPropertyKey:d,matches:I=>{let s=0;for(let k=0;s<I.length&&k<a.length;k++)if(I[s]===a[k]||I[s]==="*")s++;else if(I[s]!=="**")return!1;return s===I.length}}}e.getLocation=T;function l(t,r=[],a=y.DEFAULT){let i=null,c=[];const p=[];function d(I){Array.isArray(c)?c.push(I):i!==null&&(c[i]=I)}return o(t,{onObjectBegin:()=>{const I={};d(I),p.push(c),c=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const I=[];d(I),p.push(c),c=I,i=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:d,onError:(I,s,k)=>{r.push({error:I,offset:s,length:k})}},a),c[0]}e.parse=l;function h(t,r=[],a=y.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function p(I){return i.children.push(I),I}o(t,{onObjectBegin:I=>{i=p({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,s,k)=>{i=p({type:"property",offset:s,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:s,length:k,parent:i})},onObjectEnd:(I,s)=>{i.length=I+s-i.offset,i=i.parent,c(I+s)},onArrayBegin:(I,s)=>{i=p({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,s)=>{i.length=I+s-i.offset,i=i.parent,c(I+s)},onLiteralValue:(I,s,k)=>{p({type:v(I),offset:s,length:k,parent:i,value:I}),c(s+k)},onSeparator:(I,s,k)=>{i.type==="property"&&(I===":"?i.colonOffset=s:I===","&&c(s))},onError:(I,s,k)=>{r.push({error:I,offset:s,length:k})}},a);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=h;function u(t,r){if(!t)return;let a=t;for(let i of r)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const p of a.children)if(Array.isArray(p.children)&&p.children[0].value===i){a=p.children[1],c=!0;break}if(!c)return}else{const c=i;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=u;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;r.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&r.push(a)}return r}e.getNodePath=g;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let a of t.children){const i=a.children[1];i&&(r[a.children[0].value]=b(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function w(t,r,a=!1){return r>=t.offset&&r<t.offset+t.length||a&&r===t.offset+t.length}e.contains=w;function A(t,r,a=!1){if(w(t,r,a)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const p=A(i[c],r,a);if(p)return p}return t}}e.findNodeAtOffset=A;function o(t,r,a=y.DEFAULT){const i=P(t,!1);function c(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function p(he){return he?Se=>he(Se,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=c(r.onObjectBegin),D=p(r.onObjectProperty),I=c(r.onObjectEnd),s=c(r.onArrayBegin),k=c(r.onArrayEnd),F=p(r.onLiteralValue),x=p(r.onSeparator),j=c(r.onComment),oe=p(r.onError),se=a&&a.disallowComments,V=a&&a.allowTrailingComma;function H(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:se||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(he){case 12:case 13:se?M(10):j();break;case 16:M(1);break;case 15:case 14:break;default:return he}}}function M(he,Se=[],Le=[]){if(oe(he),Se.length+Le.length>0){let Me=i.getToken();for(;Me!==17;){if(Se.indexOf(Me)!==-1){H();break}else if(Le.indexOf(Me)!==-1)break;Me=H()}}}function Q(he){const Se=i.getTokenValue();return he?F(Se):D(Se),H(),!0}function O(){switch(i.getToken()){case 11:let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(M(2),he=0)}catch(Se){M(2)}F(he);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return H(),!0}function G(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(x(":"),H(),te()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function fe(){d(),H();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),x(","),H(),i.getToken()===2&&V)break}else he&&M(6,[],[]);G()||M(4,[],[2,5]),he=!0}return I(),i.getToken()!==2?M(7,[2],[]):H(),!0}function W(){s(),H();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),x(","),H(),i.getToken()===4&&V)break}else he&&M(6,[],[]);te()||M(4,[],[4,5]),he=!0}return k(),i.getToken()!==4?M(8,[4],[]):H(),!0}function te(){switch(i.getToken()){case 3:return W();case 1:return fe();case 10:return Q(!0);default:return O()}}return H(),i.getToken()===17?a.allowEmptyContent?!0:(M(4,[],[]),!1):te()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=o;function m(t,r){let a=P(t),i=[],c,p=0,d;do switch(d=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:p!==d&&i.push(t.substring(p,d)),r!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,r)),p=a.getPosition();break}while(c!==17);return i.join("")}e.stripComments=m;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ee[112],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new f(()=>S(this.getValue()))}}e.Lazy=f}),define(Ee[6],_e([0,1,53,55]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const S=!1;let y=null;function P(a){y=a}if(e.setDisposableTracker=P,S){const a="__is_disposable_tracked__";P(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[a]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==A.None)try{i[a]=!0}catch{}}markAsDisposed(i){if(i&&i!==A.None)try{i[a]=!0}catch{}}markAsSingleton(i){}})}function E(a){return y?.trackDisposable(a),a}function _(a){y?.markAsDisposed(a)}function C(a,i){y?.setParent(a,i)}function n(a,i){if(!!y)for(const c of a)y.setParent(c,i)}function T(a){return y?.markAsSingleton(a),a}e.markAsSingleton=T;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function h(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=h;function u(a){if(R.Iterable.is(a)){let i=[];for(const c of a)if(c)try{c.dispose()}catch(p){i.push(p)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=u;function g(...a){const i=b(()=>u(a));return n(a,i),i}e.combinedDisposable=g;function b(a){const i=E({dispose:(0,f.once)(()=>{_(i),a()})});return i}e.toDisposable=b;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return C(i,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class A{constructor(){this._store=new w,E(this),C(this._store,this)}dispose(){_(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=A,A.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&C(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&C(i,null),i}}e.MutableDisposable=o;class m{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=m;class v{constructor(){this.references=new Map}acquire(i,...c){let p=this.references.get(i);p||(p={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,p));const{object:d}=p,D=(0,f.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(i,p.object),this.references.delete(i))});return p.counter++,{object:d,dispose:D}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const p=this.referenceCollection.acquire(i,...c);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(d){throw p.dispose(),d}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(Ee[80],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(y){this.element=y,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class R{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let y=this._first;for(;y!==f.Undefined;){const P=y.next;y.prev=f.Undefined,y.next=f.Undefined,y=P}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,P){const E=new f(y);if(this._first===f.Undefined)this._first=E,this._last=E;else if(P){const C=this._last;this._last=E,E.prev=C,C.next=E}else{const C=this._first;this._first=E,E.next=C,C.prev=E}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(E))}}shift(){if(this._first!==f.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==f.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==f.Undefined&&y.next!==f.Undefined){const P=y.prev;P.next=y.next,y.next.prev=P}else y.prev===f.Undefined&&y.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):y.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):y.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==f.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ce,De){for(var Pe=0;Pe<De.length;Pe++){var re=De[Pe];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Ce,re.key,re)}}function e(Ce,De,Pe){return De&&Z(Ce.prototype,De),Pe&&Z(Ce,Pe),Ce}function f(Ce,De){if(!!Ce){if(typeof Ce=="string")return R(Ce,De);var Pe=Object.prototype.toString.call(Ce).slice(8,-1);if(Pe==="Object"&&Ce.constructor&&(Pe=Ce.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(Ce);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(Ce,De)}}function R(Ce,De){(De==null||De>Ce.length)&&(De=Ce.length);for(var Pe=0,re=new Array(De);Pe<De;Pe++)re[Pe]=Ce[Pe];return re}function S(Ce,De){var Pe;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Pe=f(Ce))||De&&Ce&&typeof Ce.length=="number"){Pe&&(Ce=Pe);var re=0;return function(){return re>=Ce.length?{done:!0}:{done:!1,value:Ce[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=Ce[Symbol.iterator](),Pe.next.bind(Pe)}function y(Ce){var De={exports:{}};return Ce(De,De.exports),De.exports}var P=y(function(Ce){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(re){Ce.exports.defaults=re}Ce.exports={defaults:De(),getDefaults:De,changeDefaults:Pe}}),E=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,T={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(De){return T[De]};function h(Ce,De){if(De){if(E.test(Ce))return Ce.replace(_,l)}else if(C.test(Ce))return Ce.replace(n,l);return Ce}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Ce){return Ce.replace(u,function(De,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var b=/(^|[^\[])\^/g;function w(Ce,De){Ce=Ce.source||Ce,De=De||"";var Pe={replace:function(ae,me){return me=me.source||me,me=me.replace(b,"$1"),Ce=Ce.replace(ae,me),Pe},getRegex:function(){return new RegExp(Ce,De)}};return Pe}var A=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Ce,De,Pe){if(Ce){var re;try{re=decodeURIComponent(g(Pe)).replace(A,"").toLowerCase()}catch(ae){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}De&&!o.test(Pe)&&(Pe=i(De,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ae){return null}return Pe}var v={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Ce,De){v[" "+Ce]||(t.test(Ce)?v[" "+Ce]=Ce+"/":v[" "+Ce]=D(Ce,"/",!0)),Ce=v[" "+Ce];var Pe=Ce.indexOf(":")===-1;return De.substring(0,2)==="//"?Pe?De:Ce.replace(r,"$1")+De:De.charAt(0)==="/"?Pe?De:Ce.replace(a,"$1")+De:Ce+De}var c={exec:function(){}};function p(Ce){for(var De=1,Pe,re;De<arguments.length;De++){Pe=arguments[De];for(re in Pe)Object.prototype.hasOwnProperty.call(Pe,re)&&(Ce[re]=Pe[re])}return Ce}function d(Ce,De){var Pe=Ce.replace(/\|/g,function(me,ve,B){for(var ge=!1,be=ve;--be>=0&&B[be]==="\\";)ge=!ge;return ge?"|":" |"}),re=Pe.split(/ \|/),ae=0;if(re.length>De)re.splice(De);else for(;re.length<De;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function D(Ce,De,Pe){var re=Ce.length;if(re===0)return"";for(var ae=0;ae<re;){var me=Ce.charAt(re-ae-1);if(me===De&&!Pe)ae++;else if(me!==De&&Pe)ae++;else break}return Ce.substr(0,re-ae)}function I(Ce,De){if(Ce.indexOf(De[1])===-1)return-1;for(var Pe=Ce.length,re=0,ae=0;ae<Pe;ae++)if(Ce[ae]==="\\")ae++;else if(Ce[ae]===De[0])re++;else if(Ce[ae]===De[1]&&(re--,re<0))return ae;return-1}function s(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Ce,De){if(De<1)return"";for(var Pe="";De>1;)De&1&&(Pe+=Ce),De>>=1,Ce+=Ce;return Pe+Ce}var F={escape:h,unescape:g,edit:w,cleanUrl:m,resolveUrl:i,noopTest:c,merge:p,splitCells:d,rtrim:D,findClosingBracket:I,checkSanitizeDeprecation:s,repeatString:k},x=P.defaults,j=F.rtrim,oe=F.splitCells,se=F.escape,V=F.findClosingBracket;function H(Ce,De,Pe){var re=De.href,ae=De.title?se(De.title):null,me=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:re,title:ae,text:me}:{type:"image",raw:Pe,href:re,title:ae,text:se(me)}}function M(Ce,De){var Pe=Ce.match(/^(\s+)(?:```)/);if(Pe===null)return De;var re=Pe[1];return De.split(`
`).map(function(ae){var me=ae.match(/^\s+/);if(me===null)return ae;var ve=me[0];return ve.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var Q=function(){function Ce(Pe){this.options=Pe||x}var De=Ce.prototype;return De.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},De.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var me=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?me:j(me,`
`)}}},De.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var me=ae[0],ve=M(me,ae[3]||"");return{type:"code",raw:me,lang:ae[2]?ae[2].trim():ae[2],text:ve}}},De.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var me=ae[2].trim();if(/#$/.test(me)){var ve=j(me,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(me=ve.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:me}}},De.nptable=function(re){var ae=this.rules.block.nptable.exec(re);if(ae){var me={type:"table",header:oe(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(me.header.length===me.align.length){var ve=me.align.length,B;for(B=0;B<ve;B++)/^ *-+: *$/.test(me.align[B])?me.align[B]="right":/^ *:-+: *$/.test(me.align[B])?me.align[B]="center":/^ *:-+ *$/.test(me.align[B])?me.align[B]="left":me.align[B]=null;for(ve=me.cells.length,B=0;B<ve;B++)me.cells[B]=oe(me.cells[B],me.header.length);return me}}},De.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},De.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var me=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:me}}},De.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var me=ae[0],ve=ae[2],B=ve.length>1,ge={type:"list",raw:me,ordered:B,start:B?+ve.slice(0,-1):"",loose:!1,items:[]},be=ae[0].match(this.rules.block.item),Ie=!1,Oe,He,Ze,Ke,Qe,lt,ht,Et,ot=be.length;Ze=this.rules.block.listItemStart.exec(be[0]);for(var at=0;at<ot;at++){if(Oe=be[at],me=Oe,at!==ot-1){if(Ke=this.rules.block.listItemStart.exec(be[at+1]),this.options.pedantic?Ke[1].length>Ze[1].length:Ke[1].length>Ze[0].length||Ke[1].length>3){be.splice(at,2,be[at]+`
`+be[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==ve[ve.length-1]:B===(Ke[2].length===1))&&(Qe=be.slice(at+1).join(`
`),ge.raw=ge.raw.substring(0,ge.raw.length-Qe.length),at=ot-1);Ze=Ke}He=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(He-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+He+"}","gm"),"")),lt=Ie||/\n\n(?!\s*$)/.test(Oe),at!==ot-1&&(Ie=Oe.charAt(Oe.length-1)===`
`,lt||(lt=Ie)),lt&&(ge.loose=!0),this.options.gfm&&(ht=/^\[[ xX]\] /.test(Oe),Et=void 0,ht&&(Et=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),ge.items.push({type:"list_item",raw:me,task:ht,checked:Et,loose:lt,text:Oe})}return ge}},De.html=function(re){var ae=this.rules.block.html.exec(re);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):se(ae[0]):ae[0]}},De.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var me=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:me,raw:ae[0],href:ae[2],title:ae[3]}}},De.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var me={type:"table",header:oe(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ae[0];var ve=me.align.length,B;for(B=0;B<ve;B++)/^ *-+: *$/.test(me.align[B])?me.align[B]="right":/^ *:-+: *$/.test(me.align[B])?me.align[B]="center":/^ *:-+ *$/.test(me.align[B])?me.align[B]="left":me.align[B]=null;for(ve=me.cells.length,B=0;B<ve;B++)me.cells[B]=oe(me.cells[B].replace(/^ *\| *| *\| *$/g,""),me.header.length);return me}}},De.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},De.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},De.text=function(re){var ae=this.rules.block.text.exec(re);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},De.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:se(ae[1])}},De.tag=function(re,ae,me){var ve=this.rules.inline.tag.exec(re);if(ve)return!ae&&/^<a /i.test(ve[0])?ae=!0:ae&&/^<\/a>/i.test(ve[0])&&(ae=!1),!me&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?me=!0:me&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(me=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:ae,inRawBlock:me,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):se(ve[0]):ve[0]}},De.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var me=ae[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var ve=j(me.slice(0,-1),"\\");if((me.length-ve.length)%2==0)return}else{var B=V(ae[2],"()");if(B>-1){var ge=ae[0].indexOf("!")===0?5:4,be=ge+ae[1].length+B;ae[2]=ae[2].substring(0,B),ae[0]=ae[0].substring(0,be).trim(),ae[3]=""}}var Ie=ae[2],Oe="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);He&&(Ie=He[1],Oe=He[3])}else Oe=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(me)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),H(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ae[0])}},De.reflink=function(re,ae){var me;if((me=this.rules.inline.reflink.exec(re))||(me=this.rules.inline.nolink.exec(re))){var ve=(me[2]||me[1]).replace(/\s+/g," ");if(ve=ae[ve.toLowerCase()],!ve||!ve.href){var B=me[0].charAt(0);return{type:"text",raw:B,text:B}}return H(me,ve,me[0])}},De.emStrong=function(re,ae,me){me===void 0&&(me="");var ve=this.rules.inline.emStrong.lDelim.exec(re);if(!!ve&&!(ve[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=ve[1]||ve[2]||"";if(!B||B&&(me===""||this.rules.inline.punctuation.exec(me))){var ge=ve[0].length-1,be,Ie,Oe=ge,He=0,Ze=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,ae=ae.slice(-1*re.length+ge);(ve=Ze.exec(ae))!=null;)if(be=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!be){if(Ie=be.length,ve[3]||ve[4]){Oe+=Ie;continue}else if((ve[5]||ve[6])&&ge%3&&!((ge+Ie)%3)){He+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Oe+He-Ie<=0&&!ae.slice(Ze.lastIndex).match(Ze)&&(Ie=Math.min(Ie,Ie+Oe+He)),Math.min(ge,Ie)%2)return{type:"em",raw:re.slice(0,ge+ve.index+Ie+1),text:re.slice(1,ge+ve.index+Ie)};if(Math.min(ge,Ie)%2==0)return{type:"strong",raw:re.slice(0,ge+ve.index+Ie+1),text:re.slice(2,ge+ve.index+Ie-1)}}}}}},De.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var me=ae[2].replace(/\n/g," "),ve=/[^ ]/.test(me),B=/^ /.test(me)&&/ $/.test(me);return ve&&B&&(me=me.substring(1,me.length-1)),me=se(me,!0),{type:"codespan",raw:ae[0],text:me}}},De.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},De.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},De.autolink=function(re,ae){var me=this.rules.inline.autolink.exec(re);if(me){var ve,B;return me[2]==="@"?(ve=se(this.options.mangle?ae(me[1]):me[1]),B="mailto:"+ve):(ve=se(me[1]),B=ve),{type:"link",raw:me[0],text:ve,href:B,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(re,ae){var me;if(me=this.rules.inline.url.exec(re)){var ve,B;if(me[2]==="@")ve=se(this.options.mangle?ae(me[0]):me[0]),B="mailto:"+ve;else{var ge;do ge=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ge!==me[0]);ve=se(me[0]),me[1]==="www."?B="http://"+ve:B=ve}return{type:"link",raw:me[0],text:ve,href:B,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(re,ae,me){var ve=this.rules.inline.text.exec(re);if(ve){var B;return ae?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):se(ve[0]):ve[0]:B=se(this.options.smartypants?me(ve[0]):ve[0]),{type:"text",raw:ve[0],text:B}}},Ce}(),O=F.noopTest,G=F.edit,fe=F.merge,W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=G(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,W.item=G(W.item,"gm").replace(/bull/g,W.bullet).getRegex(),W.listItemStart=G(/^( *)(bull)/).replace("bull",W.bullet).getRegex(),W.list=G(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=G(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=G(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.blockquote=G(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=fe({},W),W.gfm=fe({},W.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.nptable=G(W.gfm.nptable).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.gfm.table=G(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.pedantic=fe({},W.normal,{html:G(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:G(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=G(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=G(W._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=G(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=G(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=G(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=G(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=G(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=G(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=G(te.reflink).replace("label",te._label).getRegex(),te.reflinkSearch=G(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=fe({},te),te.pedantic=fe({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:G(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:G(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=fe({},te.normal,{escape:G(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),te.gfm.url=G(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=fe({},te.gfm,{br:G(te.br).replace("{2,}","*").getRegex(),text:G(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:W,inline:te},Se=P.defaults,Le=he.block,Me=he.inline,$e=F.repeatString;function Xe(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Ce){var De="",Pe,re,ae=Ce.length;for(Pe=0;Pe<ae;Pe++)re=Ce.charCodeAt(Pe),Math.random()>.5&&(re="x"+re.toString(16)),De+="&#"+re+";";return De}var Ge=function(){function Ce(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||Se,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var re={block:Le.normal,inline:Me.normal};this.options.pedantic?(re.block=Le.pedantic,re.inline=Me.pedantic):this.options.gfm&&(re.block=Le.gfm,this.options.breaks?re.inline=Me.breaks:re.inline=Me.gfm),this.tokenizer.rules=re}Ce.lex=function(re,ae){var me=new Ce(ae);return me.lex(re)},Ce.lexInline=function(re,ae){var me=new Ce(ae);return me.inlineTokens(re)};var De=Ce.prototype;return De.lex=function(re){return re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(re,ae,me){ae===void 0&&(ae=[]),me===void 0&&(me=!0),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var ve,B,ge,be;re;){if(ve=this.tokenizer.space(re)){re=re.substring(ve.raw.length),ve.type&&ae.push(ve);continue}if(ve=this.tokenizer.code(re)){re=re.substring(ve.raw.length),be=ae[ae.length-1],be&&be.type==="paragraph"?(be.raw+=`
`+ve.raw,be.text+=`
`+ve.text):ae.push(ve);continue}if(ve=this.tokenizer.fences(re)){re=re.substring(ve.raw.length),ae.push(ve);continue}if(ve=this.tokenizer.heading(re)){re=re.substring(ve.raw.length),ae.push(ve);continue}if(ve=this.tokenizer.nptable(re)){re=re.substring(ve.raw.length),ae.push(ve);continue}if(ve=this.tokenizer.hr(re)){re=re.substring(ve.raw.length),ae.push(ve);continue}if(ve=this.tokenizer.blockquote(re)){re=re.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],me),ae.push(ve);continue}if(ve=this.tokenizer.list(re)){for(re=re.substring(ve.raw.length),ge=ve.items.length,B=0;B<ge;B++)ve.items[B].tokens=this.blockTokens(ve.items[B].text,[],!1);ae.push(ve);continue}if(ve=this.tokenizer.html(re)){re=re.substring(ve.raw.length),ae.push(ve);continue}if(me&&(ve=this.tokenizer.def(re))){re=re.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(re)){re=re.substring(ve.raw.length),ae.push(ve);continue}if(ve=this.tokenizer.lheading(re)){re=re.substring(ve.raw.length),ae.push(ve);continue}if(me&&(ve=this.tokenizer.paragraph(re))){re=re.substring(ve.raw.length),ae.push(ve);continue}if(ve=this.tokenizer.text(re)){re=re.substring(ve.raw.length),be=ae[ae.length-1],be&&be.type==="text"?(be.raw+=`
`+ve.raw,be.text+=`
`+ve.text):ae.push(ve);continue}if(re){var Ie="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ae},De.inline=function(re){var ae,me,ve,B,ge,be,Ie=re.length;for(ae=0;ae<Ie;ae++)switch(be=re[ae],be.type){case"paragraph":case"text":case"heading":{be.tokens=[],this.inlineTokens(be.text,be.tokens);break}case"table":{for(be.tokens={header:[],cells:[]},B=be.header.length,me=0;me<B;me++)be.tokens.header[me]=[],this.inlineTokens(be.header[me],be.tokens.header[me]);for(B=be.cells.length,me=0;me<B;me++)for(ge=be.cells[me],be.tokens.cells[me]=[],ve=0;ve<ge.length;ve++)be.tokens.cells[me][ve]=[],this.inlineTokens(ge[ve],be.tokens.cells[me][ve]);break}case"blockquote":{this.inline(be.tokens);break}case"list":{for(B=be.items.length,me=0;me<B;me++)this.inline(be.items[me].tokens);break}}return re},De.inlineTokens=function(re,ae,me,ve){ae===void 0&&(ae=[]),me===void 0&&(me=!1),ve===void 0&&(ve=!1);var B,ge,be=re,Ie,Oe,He;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(be))!=null;)Ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(be=be.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(be))!=null;)be=be.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(be))!=null;)be=be.slice(0,Ie.index)+"++"+be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;){if(Oe||(He=""),Oe=!1,B=this.tokenizer.escape(re)){re=re.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.tag(re,me,ve)){re=re.substring(B.raw.length),me=B.inLink,ve=B.inRawBlock;var Ke=ae[ae.length-1];Ke&&B.type==="text"&&Ke.type==="text"?(Ke.raw+=B.raw,Ke.text+=B.text):ae.push(B);continue}if(B=this.tokenizer.link(re)){re=re.substring(B.raw.length),B.type==="link"&&(B.tokens=this.inlineTokens(B.text,[],!0,ve)),ae.push(B);continue}if(B=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(B.raw.length);var Qe=ae[ae.length-1];B.type==="link"?(B.tokens=this.inlineTokens(B.text,[],!0,ve),ae.push(B)):Qe&&B.type==="text"&&Qe.type==="text"?(Qe.raw+=B.raw,Qe.text+=B.text):ae.push(B);continue}if(B=this.tokenizer.emStrong(re,be,He)){re=re.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],me,ve),ae.push(B);continue}if(B=this.tokenizer.codespan(re)){re=re.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.br(re)){re=re.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.del(re)){re=re.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],me,ve),ae.push(B);continue}if(B=this.tokenizer.autolink(re,qe)){re=re.substring(B.raw.length),ae.push(B);continue}if(!me&&(B=this.tokenizer.url(re,qe))){re=re.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.inlineText(re,ve,Xe)){re=re.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(He=B.raw.slice(-1)),Oe=!0,ge=ae[ae.length-1],ge&&ge.type==="text"?(ge.raw+=B.raw,ge.text+=B.text):ae.push(B);continue}if(re){var lt="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return ae},e(Ce,null,[{key:"rules",get:function(){return{block:Le,inline:Me}}}]),Ce}(),U=P.defaults,K=F.cleanUrl,J=F.escape,ie=function(){function Ce(Pe){this.options=Pe||U}var De=Ce.prototype;return De.code=function(re,ae,me){var ve=(ae||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(re,ve);B!=null&&B!==re&&(me=!0,re=B)}return re=re.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+J(ve,!0)+'">'+(me?re:J(re,!0))+`</code></pre>
`:"<pre><code>"+(me?re:J(re,!0))+`</code></pre>
`},De.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},De.html=function(re){return re},De.heading=function(re,ae,me,ve){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+ve.slug(me)+'">'+re+"</h"+ae+`>
`:"<h"+ae+">"+re+"</h"+ae+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(re,ae,me){var ve=ae?"ol":"ul",B=ae&&me!==1?' start="'+me+'"':"";return"<"+ve+B+`>
`+re+"</"+ve+`>
`},De.listitem=function(re){return"<li>"+re+`</li>
`},De.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(re){return"<p>"+re+`</p>
`},De.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},De.tablerow=function(re){return`<tr>
`+re+`</tr>
`},De.tablecell=function(re,ae){var me=ae.header?"th":"td",ve=ae.align?"<"+me+' align="'+ae.align+'">':"<"+me+">";return ve+re+"</"+me+`>
`},De.strong=function(re){return"<strong>"+re+"</strong>"},De.em=function(re){return"<em>"+re+"</em>"},De.codespan=function(re){return"<code>"+re+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(re){return"<del>"+re+"</del>"},De.link=function(re,ae,me){if(re=K(this.options.sanitize,this.options.baseUrl,re),re===null)return me;var ve='<a href="'+J(re)+'"';return ae&&(ve+=' title="'+ae+'"'),ve+=">"+me+"</a>",ve},De.image=function(re,ae,me){if(re=K(this.options.sanitize,this.options.baseUrl,re),re===null)return me;var ve='<img src="'+re+'" alt="'+me+'"';return ae&&(ve+=' title="'+ae+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(re){return re},Ce}(),q=function(){function Ce(){}var De=Ce.prototype;return De.strong=function(re){return re},De.em=function(re){return re},De.codespan=function(re){return re},De.del=function(re){return re},De.html=function(re){return re},De.text=function(re){return re},De.link=function(re,ae,me){return""+me},De.image=function(re,ae,me){return""+me},De.br=function(){return""},Ce}(),ne=function(){function Ce(){this.seen={}}var De=Ce.prototype;return De.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(re,ae){var me=re,ve=0;if(this.seen.hasOwnProperty(me)){ve=this.seen[re];do ve++,me=re+"-"+ve;while(this.seen.hasOwnProperty(me))}return ae||(this.seen[re]=ve,this.seen[me]=0),me},De.slug=function(re,ae){ae===void 0&&(ae={});var me=this.serialize(re);return this.getNextSafeSlug(me,ae.dryrun)},Ce}(),pe=P.defaults,Re=F.unescape,We=function(){function Ce(Pe){this.options=Pe||pe,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ne}Ce.parse=function(re,ae){var me=new Ce(ae);return me.parse(re)},Ce.parseInline=function(re,ae){var me=new Ce(ae);return me.parseInline(re)};var De=Ce.prototype;return De.parse=function(re,ae){ae===void 0&&(ae=!0);var me="",ve,B,ge,be,Ie,Oe,He,Ze,Ke,Qe,lt,ht,Et,ot,at,Dt,ye,ce,le=re.length;for(ve=0;ve<le;ve++)switch(Qe=re[ve],Qe.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,Re(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(Ze="",He="",be=Qe.header.length,B=0;B<be;B++)He+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[B]),{header:!0,align:Qe.align[B]});for(Ze+=this.renderer.tablerow(He),Ke="",be=Qe.cells.length,B=0;B<be;B++){for(Oe=Qe.tokens.cells[B],He="",Ie=Oe.length,ge=0;ge<Ie;ge++)He+=this.renderer.tablecell(this.parseInline(Oe[ge]),{header:!1,align:Qe.align[ge]});Ke+=this.renderer.tablerow(He)}me+=this.renderer.table(Ze,Ke);continue}case"blockquote":{Ke=this.parse(Qe.tokens),me+=this.renderer.blockquote(Ke);continue}case"list":{for(lt=Qe.ordered,ht=Qe.start,Et=Qe.loose,be=Qe.items.length,Ke="",B=0;B<be;B++)at=Qe.items[B],Dt=at.checked,ye=at.task,ot="",at.task&&(ce=this.renderer.checkbox(Dt),Et?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=ce+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=ce+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:ce}):ot+=ce),ot+=this.parse(at.tokens,Et),Ke+=this.renderer.listitem(ot,ye,Dt);me+=this.renderer.list(Ke,lt,ht);continue}case"html":{me+=this.renderer.html(Qe.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(Ke=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;ve+1<le&&re[ve+1].type==="text";)Qe=re[++ve],Ke+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);me+=ae?this.renderer.paragraph(Ke):Ke;continue}default:{var $='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}return me},De.parseInline=function(re,ae){ae=ae||this.renderer;var me="",ve,B,ge=re.length;for(ve=0;ve<ge;ve++)switch(B=re[ve],B.type){case"escape":{me+=ae.text(B.text);break}case"html":{me+=ae.html(B.text);break}case"link":{me+=ae.link(B.href,B.title,this.parseInline(B.tokens,ae));break}case"image":{me+=ae.image(B.href,B.title,B.text);break}case"strong":{me+=ae.strong(this.parseInline(B.tokens,ae));break}case"em":{me+=ae.em(this.parseInline(B.tokens,ae));break}case"codespan":{me+=ae.codespan(B.text);break}case"br":{me+=ae.br();break}case"del":{me+=ae.del(this.parseInline(B.tokens,ae));break}case"text":{me+=ae.text(B.text);break}default:{var be='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}return me},Ce}(),we=F.merge,Je=F.checkSanitizeDeprecation,z=F.escape,X=P.getDefaults,de=P.changeDefaults,Ue=P.defaults;function xe(Ce,De,Pe){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof De=="function"&&(Pe=De,De=null),De=we({},xe.defaults,De||{}),Je(De),Pe){var re=De.highlight,ae;try{ae=Ge.lex(Ce,De)}catch(ge){return Pe(ge)}var me=function(be){var Ie;if(!be)try{Ie=We.parse(ae,De)}catch(Oe){be=Oe}return De.highlight=re,be?Pe(be):Pe(null,Ie)};if(!re||re.length<3||(delete De.highlight,!ae.length))return me();var ve=0;xe.walkTokens(ae,function(ge){ge.type==="code"&&(ve++,setTimeout(function(){re(ge.text,ge.lang,function(be,Ie){if(be)return me(be);Ie!=null&&Ie!==ge.text&&(ge.text=Ie,ge.escaped=!0),ve--,ve===0&&me()})},0))}),ve===0&&me();return}try{var B=Ge.lex(Ce,De);return De.walkTokens&&xe.walkTokens(B,De.walkTokens),We.parse(B,De)}catch(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+z(ge.message+"",!0)+"</pre>";throw ge}}xe.options=xe.setOptions=function(Ce){return we(xe.defaults,Ce),de(xe.defaults),xe},xe.getDefaults=X,xe.defaults=Ue,xe.use=function(Ce){var De=we({},Ce);if(Ce.renderer&&function(){var re=xe.defaults.renderer||new ie,ae=function(B){var ge=re[B];re[B]=function(){for(var be=arguments.length,Ie=new Array(be),Oe=0;Oe<be;Oe++)Ie[Oe]=arguments[Oe];var He=Ce.renderer[B].apply(re,Ie);return He===!1&&(He=ge.apply(re,Ie)),He}};for(var me in Ce.renderer)ae(me);De.renderer=re}(),Ce.tokenizer&&function(){var re=xe.defaults.tokenizer||new Q,ae=function(B){var ge=re[B];re[B]=function(){for(var be=arguments.length,Ie=new Array(be),Oe=0;Oe<be;Oe++)Ie[Oe]=arguments[Oe];var He=Ce.tokenizer[B].apply(re,Ie);return He===!1&&(He=ge.apply(re,Ie)),He}};for(var me in Ce.tokenizer)ae(me);De.tokenizer=re}(),Ce.walkTokens){var Pe=xe.defaults.walkTokens;De.walkTokens=function(re){Ce.walkTokens(re),Pe&&Pe(re)}}xe.setOptions(De)},xe.walkTokens=function(Ce,De){for(var Pe=S(Ce),re;!(re=Pe()).done;){var ae=re.value;switch(De(ae),ae.type){case"table":{for(var me=S(ae.tokens.header),ve;!(ve=me()).done;){var B=ve.value;xe.walkTokens(B,De)}for(var ge=S(ae.tokens.cells),be;!(be=ge()).done;)for(var Ie=be.value,Oe=S(Ie),He;!(He=Oe()).done;){var Ze=He.value;xe.walkTokens(Ze,De)}break}case"list":{xe.walkTokens(ae.items,De);break}default:ae.tokens&&xe.walkTokens(ae.tokens,De)}}},xe.parseInline=function(Ce,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");De=we({},xe.defaults,De||{}),Je(De);try{var Pe=Ge.lexInline(Ce,De);return De.walkTokens&&xe.walkTokens(Pe,De.walkTokens),We.parseInline(Pe,De)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+z(re.message+"",!0)+"</pre>";throw re}},xe.Parser=We,xe.parser=We.parse,xe.Renderer=ie,xe.TextRenderer=q,xe.Lexer=Ge,xe.lexer=Ge.lex,xe.Tokenizer=Q,xe.Slugger=ne,xe.parse=xe;var et=xe;return et}),define(Ee[81],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(P,E,_){return Math.min(Math.max(P,E),_)}e.clamp=f;function R(P,E){return(E+P%E)%E}e.rot=R;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class y{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function Z(S){const y=[];typeof S=="number"&&y.push("code/timeOrigin",S);function P(_){y.push(_,Date.now())}function E(){const _=[];for(let C=0;C<y.length;C+=2)_.push({name:y[C],startTime:y[C+1]});return _}return{mark:P,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const P of performance.getEntriesByType("mark"))y.push({name:P.name,startTime:Math.round(S+P.startTime)});return y}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function f(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=f(R))}(),define(Ee[22],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let R=!1,S=!1,y=!1,P=!1,E=!1,_=!1,C=!1,n,T=f,l,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const g=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=g&&u?.sandboxed,typeof navigator=="object"&&!g)h=navigator.userAgent,R=h.indexOf("Windows")>=0,S=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=h.indexOf("Linux")>=0,_=!0,n=navigator.language,T=n;else if(typeof u=="object"){R=u.platform==="win32",S=u.platform==="darwin",y=u.platform==="linux",P=y&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=f,T=f;const a=u.env.VSCODE_NLS_CONFIG;if(a)try{const i=JSON.parse(a),c=i.availableLanguages["*"];n=i.locale,T=c||f,l=i._translationsConfigFile}catch(i){}E=!0}else console.error("Unable to resolve platform.");var b;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function w(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let A=0;S?A=1:R?A=3:y&&(A=2),e.isWindows=R,e.isMacintosh=S,e.isLinux=y,e.isLinuxSnap=P,e.isNative=E,e.isWeb=_,e.isIOS=C,e.platform=A,e.userAgent=h,e.language=T;var o;(function(a){function i(){return e.language}a.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=c;function p(){return e.language==="en"}a.isDefault=p})(o=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let D=0,I=c.length;D<I;D++){const s=c[D];if(s.id===d.data.vscodeSetImmediateId){c.splice(D,1),s.callback();return}}});let p=0;return d=>{const D=++p;c.push({id:D,callback:d}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return c=>i.then(c)}();var m;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||C?2:R?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,v=new Uint16Array(a.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(Ee[42],_e([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const S=f.globals.vscode.process;R={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(y){return(0,f.setImmediate)(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:R={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},nextTick(S){return(0,f.setImmediate)(S)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Ee[14],_e([0,1,42]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,S=97,y=90,P=122,E=46,_=47,C=92,n=58,T=63;class l extends Error{constructor(m,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const a=m.indexOf(".")!==-1?"property":"argument";let i=`The "${m}" ${a} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(o,m){if(typeof o!="string")throw new l(m,"string",o)}function u(o){return o===_||o===C}function g(o){return o===_}function b(o){return o>=R&&o<=y||o>=S&&o<=P}function w(o,m,v,t){let r="",a=0,i=-1,c=0,p=0;for(let d=0;d<=o.length;++d){if(d<o.length)p=o.charCodeAt(d);else{if(t(p))break;p=_}if(t(p)){if(!(i===d-1||c===1))if(c===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==E||r.charCodeAt(r.length-2)!==E){if(r.length>2){const D=r.lastIndexOf(v);D===-1?(r="",a=0):(r=r.slice(0,D),a=r.length-1-r.lastIndexOf(v)),i=d,c=0;continue}else if(r.length!==0){r="",a=0,i=d,c=0;continue}}m&&(r+=r.length>0?`${v}..`:"..",a=2)}else r.length>0?r+=`${v}${o.slice(i+1,d)}`:r=o.slice(i+1,d),a=d-i-1;i=d,c=0}else p===E&&c!==-1?++c:c=-1}return r}function A(o,m){if(m===null||typeof m!="object")throw new l("pathObject","Object",m);const v=m.dir||m.root,t=m.base||`${m.name||""}${m.ext||""}`;return v?v===m.root?`${v}${t}`:`${v}${o}${t}`:t}e.win32={resolve(...o){let m="",v="",t=!1;for(let r=o.length-1;r>=-1;r--){let a;if(r>=0){if(a=o[r],h(a,"path"),a.length===0)continue}else m.length===0?a=f.cwd():(a=f.env[`=${m}`]||f.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==m.toLowerCase()&&a.charCodeAt(2)===C)&&(a=`${m}\\`));const i=a.length;let c=0,p="",d=!1;const D=a.charCodeAt(0);if(i===1)u(D)&&(c=1,d=!0);else if(u(D))if(d=!0,u(a.charCodeAt(1))){let I=2,s=I;for(;I<i&&!u(a.charCodeAt(I));)I++;if(I<i&&I!==s){const k=a.slice(s,I);for(s=I;I<i&&u(a.charCodeAt(I));)I++;if(I<i&&I!==s){for(s=I;I<i&&!u(a.charCodeAt(I));)I++;(I===i||I!==s)&&(p=`\\\\${k}\\${a.slice(s,I)}`,c=I)}}}else c=1;else b(D)&&a.charCodeAt(1)===n&&(p=a.slice(0,2),c=2,i>2&&u(a.charCodeAt(2))&&(d=!0,c=3));if(p.length>0)if(m.length>0){if(p.toLowerCase()!==m.toLowerCase())continue}else m=p;if(t){if(m.length>0)break}else if(v=`${a.slice(c)}\\${v}`,t=d,d&&m.length>0)break}return v=w(v,!t,"\\",u),t?`${m}\\${v}`:`${m}${v}`||"."},normalize(o){h(o,"path");const m=o.length;if(m===0)return".";let v=0,t,r=!1;const a=o.charCodeAt(0);if(m===1)return g(a)?"\\":o;if(u(a))if(r=!0,u(o.charCodeAt(1))){let c=2,p=c;for(;c<m&&!u(o.charCodeAt(c));)c++;if(c<m&&c!==p){const d=o.slice(p,c);for(p=c;c<m&&u(o.charCodeAt(c));)c++;if(c<m&&c!==p){for(p=c;c<m&&!u(o.charCodeAt(c));)c++;if(c===m)return`\\\\${d}\\${o.slice(p)}\\`;c!==p&&(t=`\\\\${d}\\${o.slice(p,c)}`,v=c)}}}else v=1;else b(a)&&o.charCodeAt(1)===n&&(t=o.slice(0,2),v=2,m>2&&u(o.charCodeAt(2))&&(r=!0,v=3));let i=v<m?w(o.slice(v),!r,"\\",u):"";return i.length===0&&!r&&(i="."),i.length>0&&u(o.charCodeAt(m-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(o){h(o,"path");const m=o.length;if(m===0)return!1;const v=o.charCodeAt(0);return u(v)||m>2&&b(v)&&o.charCodeAt(1)===n&&u(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let m,v;for(let a=0;a<o.length;++a){const i=o[a];h(i,"path"),i.length>0&&(m===void 0?m=v=i:m+=`\\${i}`)}if(m===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&u(v.charCodeAt(0))){++r;const a=v.length;a>1&&u(v.charCodeAt(1))&&(++r,a>2&&(u(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<m.length&&u(m.charCodeAt(r));)r++;r>=2&&(m=`\\${m.slice(r)}`)}return e.win32.normalize(m)},relative(o,m){if(h(o,"from"),h(m,"to"),o===m)return"";const v=e.win32.resolve(o),t=e.win32.resolve(m);if(v===t||(o=v.toLowerCase(),m=t.toLowerCase(),o===m))return"";let r=0;for(;r<o.length&&o.charCodeAt(r)===C;)r++;let a=o.length;for(;a-1>r&&o.charCodeAt(a-1)===C;)a--;const i=a-r;let c=0;for(;c<m.length&&m.charCodeAt(c)===C;)c++;let p=m.length;for(;p-1>c&&m.charCodeAt(p-1)===C;)p--;const d=p-c,D=i<d?i:d;let I=-1,s=0;for(;s<D;s++){const F=o.charCodeAt(r+s);if(F!==m.charCodeAt(c+s))break;F===C&&(I=s)}if(s!==D){if(I===-1)return t}else{if(d>D){if(m.charCodeAt(c+s)===C)return t.slice(c+s+1);if(s===2)return t.slice(c+s)}i>D&&(o.charCodeAt(r+s)===C?I=s:s===2&&(I=3)),I===-1&&(I=0)}let k="";for(s=r+I+1;s<=a;++s)(s===a||o.charCodeAt(s)===C)&&(k+=k.length===0?"..":"\\..");return c+=I,k.length>0?`${k}${t.slice(c,p)}`:(t.charCodeAt(c)===C&&++c,t.slice(c,p))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const m=e.win32.resolve(o);if(m.length<=2)return o;if(m.charCodeAt(0)===C){if(m.charCodeAt(1)===C){const v=m.charCodeAt(2);if(v!==T&&v!==E)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(b(m.charCodeAt(0))&&m.charCodeAt(1)===n&&m.charCodeAt(2)===C)return`\\\\?\\${m}`;return o},dirname(o){h(o,"path");const m=o.length;if(m===0)return".";let v=-1,t=0;const r=o.charCodeAt(0);if(m===1)return u(r)?o:".";if(u(r)){if(v=t=1,u(o.charCodeAt(1))){let c=2,p=c;for(;c<m&&!u(o.charCodeAt(c));)c++;if(c<m&&c!==p){for(p=c;c<m&&u(o.charCodeAt(c));)c++;if(c<m&&c!==p){for(p=c;c<m&&!u(o.charCodeAt(c));)c++;if(c===m)return o;c!==p&&(v=t=c+1)}}}}else b(r)&&o.charCodeAt(1)===n&&(v=m>2&&u(o.charCodeAt(2))?3:2,t=v);let a=-1,i=!0;for(let c=m-1;c>=t;--c)if(u(o.charCodeAt(c))){if(!i){a=c;break}}else i=!1;if(a===-1){if(v===-1)return".";a=v}return o.slice(0,a)},basename(o,m){m!==void 0&&h(m,"ext"),h(o,"path");let v=0,t=-1,r=!0,a;if(o.length>=2&&b(o.charCodeAt(0))&&o.charCodeAt(1)===n&&(v=2),m!==void 0&&m.length>0&&m.length<=o.length){if(m===o)return"";let i=m.length-1,c=-1;for(a=o.length-1;a>=v;--a){const p=o.charCodeAt(a);if(u(p)){if(!r){v=a+1;break}}else c===-1&&(r=!1,c=a+1),i>=0&&(p===m.charCodeAt(i)?--i==-1&&(t=a):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=o.length),o.slice(v,t)}for(a=o.length-1;a>=v;--a)if(u(o.charCodeAt(a))){if(!r){v=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":o.slice(v,t)},extname(o){h(o,"path");let m=0,v=-1,t=0,r=-1,a=!0,i=0;o.length>=2&&o.charCodeAt(1)===n&&b(o.charCodeAt(0))&&(m=t=2);for(let c=o.length-1;c>=m;--c){const p=o.charCodeAt(c);if(u(p)){if(!a){t=c+1;break}continue}r===-1&&(a=!1,r=c+1),p===E?v===-1?v=c:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":o.slice(v,r)},format:A.bind(null,"\\"),parse(o){h(o,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return m;const v=o.length;let t=0,r=o.charCodeAt(0);if(v===1)return u(r)?(m.root=m.dir=o,m):(m.base=m.name=o,m);if(u(r)){if(t=1,u(o.charCodeAt(1))){let I=2,s=I;for(;I<v&&!u(o.charCodeAt(I));)I++;if(I<v&&I!==s){for(s=I;I<v&&u(o.charCodeAt(I));)I++;if(I<v&&I!==s){for(s=I;I<v&&!u(o.charCodeAt(I));)I++;I===v?t=I:I!==s&&(t=I+1)}}}}else if(b(r)&&o.charCodeAt(1)===n){if(v<=2)return m.root=m.dir=o,m;if(t=2,u(o.charCodeAt(2))){if(v===3)return m.root=m.dir=o,m;t=3}}t>0&&(m.root=o.slice(0,t));let a=-1,i=t,c=-1,p=!0,d=o.length-1,D=0;for(;d>=t;--d){if(r=o.charCodeAt(d),u(r)){if(!p){i=d+1;break}continue}c===-1&&(p=!1,c=d+1),r===E?a===-1?a=d:D!==1&&(D=1):a!==-1&&(D=-1)}return c!==-1&&(a===-1||D===0||D===1&&a===c-1&&a===i+1?m.base=m.name=o.slice(i,c):(m.name=o.slice(i,a),m.base=o.slice(i,c),m.ext=o.slice(a,c))),i>0&&i!==t?m.dir=o.slice(0,i-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let m="",v=!1;for(let t=o.length-1;t>=-1&&!v;t--){const r=t>=0?o[t]:f.cwd();h(r,"path"),r.length!==0&&(m=`${r}/${m}`,v=r.charCodeAt(0)===_)}return m=w(m,!v,"/",g),v?`/${m}`:m.length>0?m:"."},normalize(o){if(h(o,"path"),o.length===0)return".";const m=o.charCodeAt(0)===_,v=o.charCodeAt(o.length-1)===_;return o=w(o,!m,"/",g),o.length===0?m?"/":v?"./":".":(v&&(o+="/"),m?`/${o}`:o)},isAbsolute(o){return h(o,"path"),o.length>0&&o.charCodeAt(0)===_},join(...o){if(o.length===0)return".";let m;for(let v=0;v<o.length;++v){const t=o[v];h(t,"path"),t.length>0&&(m===void 0?m=t:m+=`/${t}`)}return m===void 0?".":e.posix.normalize(m)},relative(o,m){if(h(o,"from"),h(m,"to"),o===m||(o=e.posix.resolve(o),m=e.posix.resolve(m),o===m))return"";const v=1,t=o.length,r=t-v,a=1,i=m.length-a,c=r<i?r:i;let p=-1,d=0;for(;d<c;d++){const I=o.charCodeAt(v+d);if(I!==m.charCodeAt(a+d))break;I===_&&(p=d)}if(d===c)if(i>c){if(m.charCodeAt(a+d)===_)return m.slice(a+d+1);if(d===0)return m.slice(a+d)}else r>c&&(o.charCodeAt(v+d)===_?p=d:d===0&&(p=0));let D="";for(d=v+p+1;d<=t;++d)(d===t||o.charCodeAt(d)===_)&&(D+=D.length===0?"..":"/..");return`${D}${m.slice(a+p)}`},toNamespacedPath(o){return o},dirname(o){if(h(o,"path"),o.length===0)return".";const m=o.charCodeAt(0)===_;let v=-1,t=!0;for(let r=o.length-1;r>=1;--r)if(o.charCodeAt(r)===_){if(!t){v=r;break}}else t=!1;return v===-1?m?"/":".":m&&v===1?"//":o.slice(0,v)},basename(o,m){m!==void 0&&h(m,"ext"),h(o,"path");let v=0,t=-1,r=!0,a;if(m!==void 0&&m.length>0&&m.length<=o.length){if(m===o)return"";let i=m.length-1,c=-1;for(a=o.length-1;a>=0;--a){const p=o.charCodeAt(a);if(p===_){if(!r){v=a+1;break}}else c===-1&&(r=!1,c=a+1),i>=0&&(p===m.charCodeAt(i)?--i==-1&&(t=a):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=o.length),o.slice(v,t)}for(a=o.length-1;a>=0;--a)if(o.charCodeAt(a)===_){if(!r){v=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":o.slice(v,t)},extname(o){h(o,"path");let m=-1,v=0,t=-1,r=!0,a=0;for(let i=o.length-1;i>=0;--i){const c=o.charCodeAt(i);if(c===_){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),c===E?m===-1?m=i:a!==1&&(a=1):m!==-1&&(a=-1)}return m===-1||t===-1||a===0||a===1&&m===t-1&&m===v+1?"":o.slice(m,t)},format:A.bind(null,"/"),parse(o){h(o,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return m;const v=o.charCodeAt(0)===_;let t;v?(m.root="/",t=1):t=0;let r=-1,a=0,i=-1,c=!0,p=o.length-1,d=0;for(;p>=t;--p){const D=o.charCodeAt(p);if(D===_){if(!c){a=p+1;break}continue}i===-1&&(c=!1,i=p+1),D===E?r===-1?r=p:d!==1&&(d=1):r!==-1&&(d=-1)}if(i!==-1){const D=a===0&&v?1:a;r===-1||d===0||d===1&&r===i-1&&r===a+1?m.base=m.name=o.slice(D,i):(m.name=o.slice(D,r),m.base=o.slice(D,i),m.ext=o.slice(r,i))}return a>0?m.dir=o.slice(0,a-1):v&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ee[56],_e([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=f.globals.performance&&typeof f.globals.performance.now=="function";class S{constructor(P){this._highResolution=R&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new S(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=S}),define(Ee[3],_e([0,1,12,53,6,80,56]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(o){o.None=()=>S.Disposable.None;function m(se){return(V,H=null,M)=>{let Q=!1,O;return O=se(G=>{if(!Q)return O?O.dispose():Q=!0,V.call(H,G)},null,M),Q&&O.dispose(),O}}o.once=m;function v(se,V){return p((H,M=null,Q)=>se(O=>H.call(M,V(O)),null,Q))}o.map=v;function t(se,V){return p((H,M=null,Q)=>se(O=>{V(O),H.call(M,O)},null,Q))}o.forEach=t;function r(se,V){return p((H,M=null,Q)=>se(O=>V(O)&&H.call(M,O),null,Q))}o.filter=r;function a(se){return se}o.signal=a;function i(...se){return(V,H=null,M)=>(0,S.combinedDisposable)(...se.map(Q=>Q(O=>V.call(H,O),null,M)))}o.any=i;function c(se,V,H){let M=H;return v(se,Q=>(M=V(M,Q),M))}o.reduce=c;function p(se){let V;const H=new l({onFirstListenerAdd(){V=se(H.fire,H)},onLastListenerRemove(){V.dispose()}});return H.event}function d(se,V,H=100,M=!1,Q){let O,G,fe,W=0;const te=new l({leakWarningThreshold:Q,onFirstListenerAdd(){O=se(he=>{W++,G=V(G,he),M&&!fe&&(te.fire(G),G=void 0),clearTimeout(fe),fe=setTimeout(()=>{const Se=G;G=void 0,fe=void 0,(!M||W>1)&&te.fire(Se),W=0},H)})},onLastListenerRemove(){O.dispose()}});return te.event}o.debounce=d;function D(se,V=(H,M)=>H===M){let H=!0,M;return r(se,Q=>{const O=H||!V(Q,M);return H=!1,M=Q,O})}o.latch=D;function I(se,V){return[o.filter(se,V),o.filter(se,H=>!V(H))]}o.split=I;function s(se,V=!1,H=[]){let M=H.slice(),Q=se(fe=>{M?M.push(fe):G.fire(fe)});const O=()=>{M&&M.forEach(fe=>G.fire(fe)),M=null},G=new l({onFirstListenerAdd(){Q||(Q=se(fe=>G.fire(fe)))},onFirstListenerDidAdd(){M&&(V?setTimeout(O):O())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return G.event}o.buffer=s;class k{constructor(V){this.event=V}map(V){return new k(v(this.event,V))}forEach(V){return new k(t(this.event,V))}filter(V){return new k(r(this.event,V))}reduce(V,H){return new k(c(this.event,V,H))}latch(){return new k(D(this.event))}debounce(V,H=100,M=!1,Q){return new k(d(this.event,V,H,M,Q))}on(V,H,M){return this.event(V,H,M)}once(V,H,M){return m(this.event)(V,H,M)}}function F(se){return new k(se)}o.chain=F;function x(se,V,H=M=>M){const M=(...fe)=>G.fire(H(...fe)),Q=()=>se.on(V,M),O=()=>se.removeListener(V,M),G=new l({onFirstListenerAdd:Q,onLastListenerRemove:O});return G.event}o.fromNodeEventEmitter=x;function j(se,V,H=M=>M){const M=(...fe)=>G.fire(H(...fe)),Q=()=>se.addEventListener(V,M),O=()=>se.removeEventListener(V,M),G=new l({onFirstListenerAdd:Q,onLastListenerRemove:O});return G.event}o.fromDOMEventEmitter=j;function oe(se){return new Promise(V=>m(se)(V))}o.toPromise=oe})(E=e.Event||(e.Event={}));class _{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${_._idPool++}`}start(m){this._stopWatch=new P.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function n(o){const m=C;return C=o,{dispose(){C=m}}}e.setGlobalLeakWarningThreshold=n;class T{constructor(m,v=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let v=C;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||m<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let a,i=0;for(const[c,p]of this._stacks)(!a||i<p)&&(a=c,i=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${i}):`),console.warn(a)}return()=>{const a=this._stacks.get(t)||0;this._stacks.set(t,a-1)}}}class l{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=C>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(m,v,t)=>{this._listeners||(this._listeners=new y.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const a=this._listeners.push(v?[m,v]:m);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,v);const i=this._leakageMon?.check(this._listeners.size),c=(0,S.toDisposable)(()=>{i&&i(),this._disposed||(a(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof S.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,m]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,f.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class h extends l{async fireAsync(m,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,m]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,a]=this._asyncDeliveryQueue.shift(),i=[],c={...a,waitUntil:p=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(p=t(p,typeof r=="function"?r:r[0])),i.push(p)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(p){(0,f.onUnexpectedError)(p);continue}Object.freeze(i),await Promise.allSettled(i).then(p=>{for(const d of p)d.status==="rejected"&&(0,f.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=h;class u extends l{constructor(m){super(m);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=u;class g extends u{constructor(m){super(m);this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const v={event:m,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,S.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(v=>this.emitter.fire(v))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class w{constructor(){this.buffers=[]}wrapEvent(m){return(v,t,r)=>m(a=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,a)):v.call(t,a)},void 0,r)}bufferEvents(m){const v=[];this.buffers.push(v);const t=m();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=w;class A{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=S.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=A}),define(Ee[20],_e([0,1,3]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(E,_){const C=setTimeout(E.bind(_),0);return{dispose(){clearTimeout(C)}}});var S;(function(E){function _(C){return C===E.None||C===E.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}E.isCancellationToken=_,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(S=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=S.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=P}),define(Ee[35],_e([0,1,3]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new f.Emitter}add(T){const l=this._icons.get(T.id);l?T.description?l.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new R;e.iconRegistry=S;function y(n,T){return new E(n,T)}e.registerCodicon=y;function P(n){return n?n.replace(/\$\((.*?)\)/g,(T,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=P;class E{constructor(T,l,h){this.id=T,this.definition=l,this.description=h,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function _(n,T){const l=["codicon","codicon-"+n];return T&&l.push("codicon-modifier-"+T),l}e.getClassNamesArray=_;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(g){if(g instanceof E)return["codicon","codicon-"+g.id];const b=T.exec(g.id);if(!b)return l(E.error);let[,w,A]=b;const o=["codicon","codicon-"+w];return A&&o.push("codicon-modifier-"+A.substr(1)),o}n.asClassNameArray=l;function h(g){return l(g).join(" ")}n.asClassName=h;function u(g){return"."+l(g).join(".")}n.asCSSSelector=u})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(E=e.Codicon||(e.Codicon={}))}),define(Ee[113],_e([0,1,12,6]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(o){const m=o;return m?[m.on,m.pause,m.resume,m.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=S;function y(o){const m=o;return m?S(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=y;function P(o,m){return new E(o,m)}e.newWriteableStream=P;class E{constructor(m,v){this.reducer=m,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(v=>v(m))}emitError(m){this.listeners.error.length===0?(0,f.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(v=>v(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,v){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(m,v){if(this.state.destroyed)return;let t;switch(m){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(o,m){const v=[];let t;for(;(t=o.read())!==null;)v.push(t);return m(v)}e.consumeReadable=_;function C(o,m,v){const t=[];let r;for(;(r=o.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?m(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const a=r;return r=void 0,a}return o.read()}}}e.peekReadable=C;function n(o,m){return new Promise((v,t)=>{const r=[];T(o,{onData:a=>{m&&r.push(a)},onError:a=>{m?t(a):v(void 0)},onEnd:()=>{v(m?m(r):void 0)}})})}e.consumeStream=n;function T(o,m){o.on("error",v=>m.onError(v)),o.on("end",()=>m.onEnd()),o.on("data",v=>m.onData(v))}e.listenStream=T;function l(o,m){return new Promise((v,t)=>{const r=new R.DisposableStore,a=[],i=d=>{if(a.push(d),a.length>m)return r.dispose(),o.pause(),v({stream:o,buffer:a,ended:!1})},c=d=>t(d),p=()=>v({stream:o,buffer:a,ended:!0});r.add((0,R.toDisposable)(()=>o.removeListener("error",c))),o.on("error",c),r.add((0,R.toDisposable)(()=>o.removeListener("end",p))),o.on("end",p),r.add((0,R.toDisposable)(()=>o.removeListener("data",i))),o.on("data",i)})}e.peekStream=l;function h(o,m){const v=P(m);return v.end(o),v}e.toStream=h;function u(){const o=P(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=u;function g(o){let m=!1;return{read:()=>m?null:(m=!0,o)}}e.toReadable=g;function b(o,m,v){const t=P(v);return T(o,{onData:r=>t.write(m.data(r)),onError:r=>t.error(m.error?m.error(r):r),onEnd:()=>t.end()}),t}e.transform=b;function w(o,m,v){let t=!1;return{read:()=>{const r=m.read();return t?r:(t=!0,r!==null?v([o,r]):o)}}}e.prefixedReadable=w;function A(o,m,v){let t=!1;const r=P(v);return T(m,{onData:a=>t?r.write(a):(t=!0,r.write(v([o,a]))),onError:a=>r.error(a),onEnd:()=>{t||(t=!0,r.write(o)),r.end()}}),r}e.prefixedStream=A}),define(Ee[8],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function f(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=f;const R=/{(\d+)}/g;function S(B,...ge){return ge.length===0?B:B.replace(R,function(be,Ie){const Oe=parseInt(Ie,10);return isNaN(Oe)||Oe<0||Oe>=ge.length?be:ge[Oe]})}e.format=S;const y=/{([^}]+)}/g;function P(B,ge){return B.replace(y,(be,Ie)=>ge[Ie]??be)}e.format2=P;function E(B){return B.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=E;function _(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function C(B,ge){let be=0;const Ie=ge.charCodeAt(0);for(let Oe=B.length-1;Oe>=0;Oe--)B.charCodeAt(Oe)===Ie&&be++;return be}e.count=C;function n(B,ge,be="\u2026"){return B.length<=ge?B:`${B.substr(0,ge)}${be}`}e.truncate=n;function T(B,ge=" "){const be=l(B,ge);return h(be,ge)}e.trim=T;function l(B,ge){if(!B||!ge)return B;const be=ge.length;if(be===0||B.length===0)return B;let Ie=0;for(;B.indexOf(ge,Ie)===Ie;)Ie=Ie+be;return B.substring(Ie)}e.ltrim=l;function h(B,ge){if(!B||!ge)return B;const be=ge.length,Ie=B.length;if(be===0||Ie===0)return B;let Oe=Ie,He=-1;for(;He=B.lastIndexOf(ge,Oe-1),!(He===-1||He+be!==Oe);){if(He===0)return"";Oe=He}return B.substring(0,Oe)}e.rtrim=h;function u(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(B){return B.replace(/\*/g,"")}e.stripWildcards=g;function b(B,ge,be={}){if(!B)throw new Error("Cannot create regex from empty string");ge||(B=_(B)),be.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let Ie="";return be.global&&(Ie+="g"),be.matchCase||(Ie+="i"),be.multiline&&(Ie+="m"),be.unicode&&(Ie+="u"),new RegExp(B,Ie)}e.createRegExp=b;function w(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function A(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=A;function o(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=o;function m(B){return B.split(/\r\n|\r|\n/)}e.splitLines=m;function v(B){for(let ge=0,be=B.length;ge<be;ge++){const Ie=B.charCodeAt(ge);if(Ie!==32&&Ie!==9)return ge}return-1}e.firstNonWhitespaceIndex=v;function t(B,ge=0,be=B.length){for(let Ie=ge;Ie<be;Ie++){const Oe=B.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return B.substring(ge,Ie)}return B.substring(ge,be)}e.getLeadingWhitespace=t;function r(B,ge=B.length-1){for(let be=ge;be>=0;be--){const Ie=B.charCodeAt(be);if(Ie!==32&&Ie!==9)return be}return-1}e.lastNonWhitespaceIndex=r;function a(B,ge){return B<ge?-1:B>ge?1:0}e.compare=a;function i(B,ge,be=0,Ie=B.length,Oe=0,He=ge.length){for(;be<Ie&&Oe<He;be++,Oe++){let Qe=B.charCodeAt(be),lt=ge.charCodeAt(Oe);if(Qe<lt)return-1;if(Qe>lt)return 1}const Ze=Ie-be,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstring=i;function c(B,ge){return p(B,ge,0,B.length,0,ge.length)}e.compareIgnoreCase=c;function p(B,ge,be=0,Ie=B.length,Oe=0,He=ge.length){for(;be<Ie&&Oe<He;be++,Oe++){let Qe=B.charCodeAt(be),lt=ge.charCodeAt(Oe);if(Qe===lt)continue;const ht=Qe-lt;if(!(ht===32&&D(lt))&&!(ht===-32&&D(Qe)))return d(Qe)&&d(lt)?ht:i(B.toLowerCase(),ge.toLowerCase(),be,Ie,Oe,He)}const Ze=Ie-be,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstringIgnoreCase=p;function d(B){return B>=97&&B<=122}e.isLowerAsciiLetter=d;function D(B){return B>=65&&B<=90}e.isUpperAsciiLetter=D;function I(B){return d(B)||D(B)}function s(B,ge){return B.length===ge.length&&k(B,ge)}e.equalsIgnoreCase=s;function k(B,ge,be=B.length){for(let Ie=0;Ie<be;Ie++){const Oe=B.charCodeAt(Ie),He=ge.charCodeAt(Ie);if(Oe!==He){if(I(Oe)&&I(He)){const Ze=Math.abs(Oe-He);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function F(B,ge){const be=ge.length;return ge.length>B.length?!1:k(B,ge,be)}e.startsWithIgnoreCase=F;function x(B,ge){let be,Ie=Math.min(B.length,ge.length);for(be=0;be<Ie;be++)if(B.charCodeAt(be)!==ge.charCodeAt(be))return be;return Ie}e.commonPrefixLength=x;function j(B,ge){let be,Ie=Math.min(B.length,ge.length);const Oe=B.length-1,He=ge.length-1;for(be=0;be<Ie;be++)if(B.charCodeAt(Oe-be)!==ge.charCodeAt(He-be))return be;return Ie}e.commonSuffixLength=j;function oe(B){return 55296<=B&&B<=56319}e.isHighSurrogate=oe;function se(B){return 56320<=B&&B<=57343}e.isLowSurrogate=se;function V(B,ge){return(B-55296<<10)+(ge-56320)+65536}e.computeCodePoint=V;function H(B,ge,be){const Ie=B.charCodeAt(be);if(oe(Ie)&&be+1<ge){const Oe=B.charCodeAt(be+1);if(se(Oe))return V(Ie,Oe)}return Ie}e.getNextCodePoint=H;function M(B,ge){const be=B.charCodeAt(ge-1);if(se(be)&&ge>1){const Ie=B.charCodeAt(ge-2);if(oe(Ie))return V(Ie,be)}return be}function Q(B,ge){const be=Ce.getInstance(),Ie=ge,Oe=B.length,He=H(B,Oe,ge);ge+=He>=65536?2:1;let Ze=be.getGraphemeBreakType(He);for(;ge<Oe;){const Ke=H(B,Oe,ge),Qe=be.getGraphemeBreakType(Ke);if(xe(Ze,Qe))break;ge+=Ke>=65536?2:1,Ze=Qe}return ge-Ie}e.nextCharLength=Q;function O(B,ge){const be=Ce.getInstance(),Ie=ge,Oe=M(B,ge);ge-=Oe>=65536?2:1;let He=be.getGraphemeBreakType(Oe);for(;ge>0;){const Ze=M(B,ge),Ke=be.getGraphemeBreakType(Ze);if(xe(Ke,He))break;ge-=Ze>=65536?2:1,He=Ke}return Ie-ge}e.prevCharLength=O;function G(B,ge){const be=Ce.getInstance(),Ie=B.length,Oe=ge,He=H(B,Ie,ge),Ze=be.getGraphemeBreakType(He);ge+=He>=65536?2:1;let Ke=Ze;for(;ge<Ie;){const lt=H(B,Ie,ge),ht=be.getGraphemeBreakType(lt);if(xe(Ke,ht))break;ge+=lt>=65536?2:1,Ke=ht}const Qe=ge;for(ge=Oe,Ke=Ze;ge>0;){const lt=M(B,ge),ht=be.getGraphemeBreakType(lt);if(xe(ht,Ke))break;ge-=lt>=65536?2:1,Ke=ht}return[ge,Qe]}function fe(B,ge){return ge>0&&se(B.charCodeAt(ge))?G(B,ge-1):G(B,ge)}e.getCharContainingOffset=fe;function W(B){const ge=B.length;let be=0,Ie=0;for(;Ie<ge;){const Ze=H(B,ge,Ie);Ie+=Ze>=65536?2:1,Ze<128?be+=1:Ze<2048?be+=2:Ze<65536?be+=3:be+=4}const Oe=new Uint8Array(be);Ie=0;let He=0;for(;Ie<ge;){const Ze=H(B,ge,Ie);Ie+=Ze>=65536?2:1,Ze<128?Oe[He++]=Ze:Ze<2048?(Oe[He++]=192|(Ze&1984)>>>6,Oe[He++]=128|(Ze&63)>>>0):Ze<65536?(Oe[He++]=224|(Ze&61440)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0):(Oe[He++]=240|(Ze&1835008)>>>18,Oe[He++]=128|(Ze&258048)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0)}return Oe}e.encodeUTF8=W;function te(B){const ge=B.byteLength,be=[];let Ie=0;for(;Ie<ge;){const Oe=B[Ie];let He;if(Oe>=240&&Ie+3<ge?He=(B[Ie++]&7)<<18>>>0|(B[Ie++]&63)<<12>>>0|(B[Ie++]&63)<<6>>>0|(B[Ie++]&63)<<0>>>0:Oe>=224&&Ie+2<ge?He=(B[Ie++]&15)<<12>>>0|(B[Ie++]&63)<<6>>>0|(B[Ie++]&63)<<0>>>0:Oe>=192&&Ie+1<ge?He=(B[Ie++]&31)<<6>>>0|(B[Ie++]&63)<<0>>>0:He=B[Ie++],He>=0&&He<=55295||He>=57344&&He<=65535)be.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const Ze=He-65536,Ke=55296+((Ze&1047552)>>>10),Qe=56320+((Ze&1023)>>>0);be.push(String.fromCharCode(Ke)),be.push(String.fromCharCode(Qe))}else be.push(String.fromCharCode(65533))}return be.join("")}e.decodeUTF8=te;const he=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Se(B){return he.test(B)}e.containsRTL=Se;const Le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Me(B){return Le.test(B)}e.containsEmoji=Me;const $e=/^[\t\n\r\x20-\x7E]*$/;function Xe(B){return $e.test(B)}e.isBasicASCII=Xe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function qe(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=qe;function Ge(B){for(let ge=0,be=B.length;ge<be;ge++)if(U(B.charCodeAt(ge)))return!0;return!1}e.containsFullWidthCharacter=Ge;function U(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=U;function K(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=K;function J(B,ge){if(B.length<ge)return B;const be=/\b/g;let Ie=0;for(;be.test(B)&&!(B.length-be.lastIndex<ge);)Ie=be.lastIndex,be.lastIndex+=1;return B.substring(Ie).replace(/^\s/,"")}e.lcut=J;const ie=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ne=/\x1b\[0?m/g;function pe(B){return B&&(B=B.replace(ie,""),B=B.replace(q,""),B=B.replace(ne,"")),B}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function We(B){return Re(B)?B.substr(1):B}e.stripUTF8BOM=We;function we(B,ge){if(!B||!ge||B.length<ge.length)return!1;const be=ge.length,Ie=B.toLowerCase();let Oe=0,He=-1;for(;Oe<be;){const Ze=Ie.indexOf(ge[Oe],He+1);if(Ze<0)return!1;He=Ze,Oe++}return!0}e.fuzzyContains=we;function Je(B,ge=!1){return B?(ge&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Je;function z(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=z;function X(B,ge=1){if(ge===0)return"";let be=-1;do be=B.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?B:(B[be-1]==="\r"&&be--,B.substr(0,be))}e.getNLines=X;function de(B){const ge=90-65+1;return B=B%(2*ge),B<ge?String.fromCharCode(97+B):String.fromCharCode(65+B-ge)}e.singleLetterHash=de;function Ue(B){return Ce.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=Ue;function xe(B,ge){return B===0?ge!==5&&ge!==7:B===2&&ge===3?!1:B===4||B===2||B===3||ge===4||ge===2||ge===3?!0:!(B===8&&(ge===8||ge===9||ge===11||ge===12)||(B===11||B===9)&&(ge===9||ge===10)||(B===12||B===10)&&ge===10||ge===5||ge===13||ge===7||B===1||B===13&&ge===14||B===6&&ge===6)}e.breakBetweenGraphemeBreakType=xe;var et;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=De()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const be=this._data,Ie=be.length/3;let Oe=1;for(;Oe<=Ie;)if(ge<be[3*Oe])Oe=2*Oe;else if(ge>be[3*Oe+1])Oe=2*Oe+1;else return be[3*Oe+2];return 0}}Ce._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(B,ge){if(B===0)return 0;const be=re(B,ge);if(be!==void 0)return be;const Ie=M(ge,B);return B-=ae(Ie),B}e.getLeftDeleteOffset=Pe;function re(B,ge){let be=M(ge,B);for(B-=ae(be);me(be)||be===65039||be===8419;){if(B===0)return;be=M(ge,B),B-=ae(be)}if(!!K(be)){if(B>=0){const Ie=M(ge,B);Ie===8205&&(B-=ae(Ie))}return B}}function ae(B){return B>=65536?2:1}function me(B){return 127995<=B&&B<=127999}var ve;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(ve||(ve={}))}),define(Ee[24],_e([0,1,113,8]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let E,_;class C{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return S?new C(Buffer.allocUnsafe(d)):new C(new Uint8Array(d))}static wrap(d){return S&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new C(d)}static fromString(d,D){return!(D?.dontUseNodeBuffer||!1)&&S?new C(Buffer.from(d)):y?(E||(E=new TextEncoder),new C(E.encode(d))):new C(R.encodeUTF8(d))}static concat(d,D){if(typeof D=="undefined"){D=0;for(let k=0,F=d.length;k<F;k++)D+=d[k].byteLength}const I=C.alloc(D);let s=0;for(let k=0,F=d.length;k<F;k++){const x=d[k];I.set(x,s),s+=x.byteLength}return I}toString(){return S?this.buffer.toString():P?(_||(_=new TextDecoder),_.decode(this.buffer)):R.decodeUTF8(this.buffer)}slice(d,D){return new C(this.buffer.subarray(d,D))}set(d,D){d instanceof C?this.buffer.set(d.buffer,D):this.buffer.set(d,D)}readUInt32BE(d){return l(this.buffer,d)}writeUInt32BE(d,D){h(this.buffer,d,D)}readUInt32LE(d){return u(this.buffer,d)}writeUInt32LE(d,D){g(this.buffer,d,D)}readUInt8(d){return b(this.buffer,d)}writeUInt8(d,D){w(this.buffer,d,D)}}e.VSBuffer=C;function n(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0}e.readUInt16LE=n;function T(p,d,D){p[D+0]=d&255,d=d>>>8,p[D+1]=d&255}e.writeUInt16LE=T;function l(p,d){return p[d]*2**24+p[d+1]*2**16+p[d+2]*2**8+p[d+3]}e.readUInt32BE=l;function h(p,d,D){p[D+3]=d,d=d>>>8,p[D+2]=d,d=d>>>8,p[D+1]=d,d=d>>>8,p[D]=d}e.writeUInt32BE=h;function u(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0|p[d+2]<<16>>>0|p[d+3]<<24>>>0}e.readUInt32LE=u;function g(p,d,D){p[D+0]=d&255,d=d>>>8,p[D+1]=d&255,d=d>>>8,p[D+2]=d&255,d=d>>>8,p[D+3]=d&255}e.writeUInt32LE=g;function b(p,d){return p[d]}e.readUInt8=b;function w(p,d,D){p[D]=d}e.writeUInt8=w;function A(p){return f.consumeReadable(p,d=>C.concat(d))}e.readableToBuffer=A;function o(p){return f.toReadable(p)}e.bufferToReadable=o;function m(p){return f.consumeStream(p,d=>C.concat(d))}e.streamToBuffer=m;async function v(p){return p.ended?C.concat(p.buffer):C.concat([...p.buffer,await m(p.stream)])}e.bufferedStreamToBuffer=v;function t(p){return f.toStream(p,d=>C.concat(d))}e.bufferToStream=t;function r(p){return f.transform(p,{data:d=>typeof d=="string"?C.fromString(d):C.wrap(d)},d=>C.concat(d))}e.streamToBufferReadableStream=r;function a(p){return f.newWriteableStream(d=>C.concat(d),p)}e.newWriteableBufferStream=a;function i(p,d){return f.prefixedReadable(p,d,D=>C.concat(D))}e.prefixedBufferReadable=i;function c(p,d){return f.prefixedStream(p,d,D=>C.concat(D))}e.prefixedBufferStream=c}),define(Ee[43],_e([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return S(w,0)}e.hash=R;function S(w,A){switch(typeof w){case"object":return w===null?y(349,A):Array.isArray(w)?_(w,A):C(w,A);case"string":return E(w,A);case"boolean":return P(w,A);case"number":return y(w,A);case"undefined":return y(937,A);default:return y(617,A)}}e.doHash=S;function y(w,A){return(A<<5)-A+w|0}function P(w,A){return y(w?433:863,A)}function E(w,A){A=y(149417,A);for(let o=0,m=w.length;o<m;o++)A=y(w.charCodeAt(o),A);return A}e.stringHash=E;function _(w,A){return A=y(104579,A),w.reduce((o,m)=>S(m,o),A)}function C(w,A){return A=y(181387,A),Object.keys(w).sort().reduce((o,m)=>(o=E(m,o),S(w[m],o)),A)}class n{constructor(){this._value=0}get value(){return this._value}hash(A){return this._value=S(A,this._value),this._value}}e.Hasher=n;var T;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function l(w,A,o=32){const m=o-A,v=~((1<<m)-1);return(w<<A|(v&w)>>>m)>>>0}function h(w,A=0,o=w.byteLength,m=0){for(let v=0;v<o;v++)w[A+v]=m}function u(w,A,o="0"){for(;w.length<A;)w=o+w;return w}function g(w,A=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(o=>o.toString(16).padStart(2,"0")).join(""):u((w>>>0).toString(16),A/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(A){const o=A.length;if(o===0)return;const m=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,a;for(t!==0?(r=t,a=-1,t=0):(r=A.charCodeAt(0),a=0);;){let i=r;if(f.isHighSurrogate(r))if(a+1<o){const c=A.charCodeAt(a+1);f.isLowSurrogate(c)?(a++,i=f.computeCodePoint(r,c)):i=65533}else{t=r;break}else f.isLowSurrogate(r)&&(i=65533);if(v=this._push(m,v,i),a++,a<o)r=A.charCodeAt(a);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(A,o,m){return m<128?A[o++]=m:m<2048?(A[o++]=192|(m&1984)>>>6,A[o++]=128|(m&63)>>>0):m<65536?(A[o++]=224|(m&61440)>>>12,A[o++]=128|(m&4032)>>>6,A[o++]=128|(m&63)>>>0):(A[o++]=240|(m&1835008)>>>18,A[o++]=128|(m&258048)>>>12,A[o++]=128|(m&4032)>>>6,A[o++]=128|(m&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,A[0]=A[64+0],A[1]=A[64+1],A[2]=A[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const A=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(A/4294967296),!1),this._buffDV.setUint32(60,A%4294967296,!1),this._step()}_step(){const A=b._bigBlock32,o=this._buffDV;for(let d=0;d<64;d+=4)A.setUint32(d,o.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)A.setUint32(d,l(A.getUint32(d-12,!1)^A.getUint32(d-32,!1)^A.getUint32(d-56,!1)^A.getUint32(d-64,!1),1),!1);let m=this._h0,v=this._h1,t=this._h2,r=this._h3,a=this._h4,i,c,p;for(let d=0;d<80;d++)d<20?(i=v&t|~v&r,c=1518500249):d<40?(i=v^t^r,c=1859775393):d<60?(i=v&t|v&r|t&r,c=2400959708):(i=v^t^r,c=3395469782),p=l(m,5)+i+a+c+A.getUint32(d*4,!1)&4294967295,a=r,r=t,t=l(v,30),v=m,m=p;this._h0=this._h0+m&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Ee[36],_e([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(R||(R={})),function(S){const y="error",P="warning",E="warn",_="info",C="ignore";function n(l){return l?f.equalsIgnoreCase(y,l)?S.Error:f.equalsIgnoreCase(P,l)||f.equalsIgnoreCase(E,l)?S.Warning:f.equalsIgnoreCase(_,l)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function T(l){switch(l){case S.Error:return y;case S.Warning:return P;case S.Info:return _;default:return C}}S.toString=T}(R||(R={})),e.default=R}),define(Ee[10],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(d){return Array.isArray(d)}e.isArray=f;function R(d){return typeof d=="string"}e.isString=R;function S(d){return Array.isArray(d)&&d.every(D=>R(D))}e.isStringArray=S;function y(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=y;function P(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=P;function E(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=E;function _(d){return d===!0||d===!1}e.isBoolean=_;function C(d){return typeof d=="undefined"}e.isUndefined=C;function n(d){return!T(d)}e.isDefined=n;function T(d){return C(d)||d===null}e.isUndefinedOrNull=T;function l(d,D){if(!d)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=l;function h(d){if(T(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=h;function u(...d){const D=[];for(let I=0;I<d.length;I++){const s=d[I];if(T(s))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);D.push(s)}return D}e.assertAllDefined=u;const g=Object.prototype.hasOwnProperty;function b(d){if(!y(d))return!1;for(let D in d)if(g.call(d,D))return!1;return!0}e.isEmptyObject=b;function w(d){return typeof d=="function"}e.isFunction=w;function A(...d){return d.length>0&&d.every(w)}e.areFunctions=A;function o(d,D){const I=Math.min(d.length,D.length);for(let s=0;s<I;s++)m(d[s],D[s])}e.validateConstraints=o;function m(d,D){if(R(D)){if(typeof d!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(w(D)){try{if(d instanceof D)return}catch{}if(!T(d)&&d.constructor===D||D.length===1&&D.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function v(d){let D=[],I=Object.getPrototypeOf(d);for(;Object.prototype!==I;)D=D.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return D}e.getAllPropertyNames=v;function t(d){const D=[];for(const I of v(d))typeof d[I]=="function"&&D.push(I);return D}e.getAllMethodNames=t;function r(d,D){const I=k=>function(){const F=Array.prototype.slice.call(arguments,0);return D(k,F)};let s={};for(const k of d)s[k]=I(k);return s}e.createProxyObject=r;function a(d){return d===null?void 0:d}e.withNullAsUndefined=a;function i(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=i;function c(d){return class{constructor(){return new Proxy({},{get(D,I){if(D[I])return D[I];throw new Error(`Not Implemented: ${d}->${String(I)}`)}})}}}e.NotImplementedProxy=c;function p(d,D="Unreachable"){throw new Error(D)}e.assertNever=p}),define(Ee[44],_e([0,1,14,22,8,10]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(a){return a===47||a===92}e.isPathSeparator=P;function E(a){return a.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=E;function _(a){return a.indexOf("/")===-1&&(a=E(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=_;function C(a,i=f.posix.sep){if(!a)return"";const c=a.length,p=a.charCodeAt(0);if(P(p)){if(P(a.charCodeAt(1))&&!P(a.charCodeAt(2))){let D=3;const I=D;for(;D<c&&!P(a.charCodeAt(D));D++);if(I!==D&&!P(a.charCodeAt(D+1))){for(D+=1;D<c;D++)if(P(a.charCodeAt(D)))return a.slice(0,D+1).replace(/[\\/]/g,i)}}return i}else if(w(p)&&a.charCodeAt(1)===58)return P(a.charCodeAt(2))?a.slice(0,2)+i:a.slice(0,2);let d=a.indexOf("://");if(d!==-1){for(d+=3;d<c;d++)if(P(a.charCodeAt(d)))return a.slice(0,d+1)}return""}e.getRoot=C;function n(a){if(!R.isWindows||!a||a.length<5)return!1;let i=a.charCodeAt(0);if(i!==92||(i=a.charCodeAt(1),i!==92))return!1;let c=2;const p=c;for(;c<a.length&&(i=a.charCodeAt(c),i!==92);c++);return!(p===c||(i=a.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(a,i=R.isWindows){const c=i?T:l;return!(!a||a.length===0||/^\s+$/.test(a)||(c.lastIndex=0,c.test(a))||i&&h.test(a)||a==="."||a===".."||i&&a[a.length-1]==="."||i&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=u;function g(a,i,c){const p=a===i;return!c||p?p:!a||!i?!1:(0,S.equalsIgnoreCase)(a,i)}e.isEqual=g;function b(a,i,c,p=f.sep){if(a===i)return!0;if(!a||!i||i.length>a.length)return!1;if(c){if(!(0,S.startsWithIgnoreCase)(a,i))return!1;if(i.length===a.length)return!0;let D=i.length;return i.charAt(i.length-1)===p&&D--,a.charAt(D)===p}return i.charAt(i.length-1)!==p&&(i+=p),a.indexOf(i)===0}e.isEqualOrParent=b;function w(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=w;function A(a,i){return R.isWindows&&a.endsWith(":")&&(a+=f.sep),(0,f.isAbsolute)(a)||(a=(0,f.join)(i,a)),a=(0,f.normalize)(a),R.isWindows?(a=(0,S.rtrim)(a,f.sep),a.endsWith(":")&&(a+=f.sep)):(a=(0,S.rtrim)(a,f.sep),a||(a=f.sep)),a}e.sanitizeFilePath=A;function o(a){const i=(0,f.normalize)(a);return R.isWindows?a.length>3?!1:m(i)&&(a.length===2||i.charCodeAt(2)===92):i===f.posix.sep}e.isRootOrDriveLetter=o;function m(a){return R.isWindows?w(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function v(a){return m(a)?a[0]:void 0}e.getDriveLetter=v;function t(a,i,c){return i.length>a.length?-1:a===i?0:(c&&(a=a.toLowerCase(),i=i.toLowerCase()),a.indexOf(i))}e.indexOfPath=t;function r(a){const i=a.split(":");let c,p,d;if(i.forEach(D=>{const I=Number(D);(0,y.isNumber)(I)?p===void 0?p=I:d===void 0&&(d=I):c=c?[c,D].join(":"):D}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:p!==void 0?p:void 0,column:d!==void 0?d:p!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Ee[23],_e([0,1,10]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.keys(g).forEach(w=>{g[w]&&typeof g[w]=="object"?b[w]=R(g[w]):b[w]=g[w]}),b}e.deepClone=R;function S(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const A in w)if(y.call(w,A)){const o=w[A];typeof o=="object"&&!Object.isFrozen(o)&&b.push(o)}}return g}e.deepFreeze=S;const y=Object.prototype.hasOwnProperty;function P(g,b){return E(g,b,new Set)}e.cloneAndChange=P;function E(g,b,w){if((0,f.isUndefinedOrNull)(g))return g;const A=b(g);if(typeof A!="undefined")return A;if((0,f.isArray)(g)){const o=[];for(const m of g)o.push(E(m,b,w));return o}if((0,f.isObject)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const o={};for(let m in g)y.call(g,m)&&(o[m]=E(g[m],b,w));return w.delete(g),o}return g}function _(g,b,w=!0){return(0,f.isObject)(g)?((0,f.isObject)(b)&&Object.keys(b).forEach(A=>{A in g?w&&((0,f.isObject)(g[A])&&(0,f.isObject)(b[A])?_(g[A],b[A],w):g[A]=b[A]):g[A]=b[A]}),g):b}e.mixin=_;function C(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let w,A;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(w=0;w<g.length;w++)if(!C(g[w],b[w]))return!1}else{const o=[];for(A in g)o.push(A);o.sort();const m=[];for(A in b)m.push(A);if(m.sort(),!C(o,m))return!1;for(w=0;w<o.length;w++)if(!C(g[o[w]],b[o[w]]))return!1}return!0}e.equals=C;function n(g){const b=new Set;return JSON.stringify(g,(w,A)=>{if((0,f.isObject)(A)||Array.isArray(A)){if(b.has(A))return"[Circular]";b.add(A)}return A})}e.safeStringify=n;function T(g,b,w){const A=b(g);return typeof A=="undefined"?w:A}e.getOrDefault=T;function l(g,b){const w=Object.create(null);return!g||!b||Object.keys(b).forEach(o=>{const m=g[o],v=b[o];C(m,v)||(w[o]=v)}),w}e.distinct=l;function h(g,b){const w=b.toLowerCase(),A=Object.keys(g).find(o=>o.toLowerCase()===w);return A?g[A]:g[b]}e.getCaseInsensitive=h;function u(g,b){const w=Object.create(null);for(const A of Object.keys(g))b(A,g[A])&&(w[A]=g[A]);return w}e.filter=u}),define(Ee[82],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function S(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=S}),define(Ee[2],_e([0,1,14,22]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,y=/^\//,P=/^\/\//;function E(a,i){if(!a.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!S.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!y.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(a,i){return!a&&!i?"file":a}function C(a,i){switch(a){case"https":case"http":case"file":i?i[0]!==T&&(i=T+i):i=T;break}return i}const n="",T="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,c,p,d,D,I=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=_(i,I),this.authority=c||n,this.path=C(this.scheme,p||n),this.query=d||n,this.fragment=D||n,E(this,I))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return o(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:p,path:d,query:D,fragment:I}=i;return c===void 0?c=this.scheme:c===null&&(c=n),p===void 0?p=this.authority:p===null&&(p=n),d===void 0?d=this.path:d===null&&(d=n),D===void 0?D=this.query:D===null&&(D=n),I===void 0?I=this.fragment:I===null&&(I=n),c===this.scheme&&p===this.authority&&d===this.path&&D===this.query&&I===this.fragment?this:new g(c,p,d,D,I)}static parse(i,c=!1){const p=l.exec(i);return p?new g(p[2]||n,r(p[4]||n),r(p[5]||n),r(p[7]||n),r(p[9]||n),c):new g(n,n,n,n,n)}static file(i){let c=n;if(R.isWindows&&(i=i.replace(/\\/g,T)),i[0]===T&&i[1]===T){const p=i.indexOf(T,2);p===-1?(c=i.substring(2),i=T):(c=i.substring(2,p),i=i.substring(p)||T)}return new g("file",c,i,n,n)}static from(i){const c=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return E(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.isWindows&&i.scheme==="file"?p=h.file(f.win32.join(o(i,!0),...c)).path:p=f.posix.join(i.path,...c),i.with({path:p})}toString(i=!1){return m(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const c=new g(i);return c._formatted=i.external,c._fsPath=i._sep===u?i.fsPath:null,c}}else return i}}e.URI=h;const u=R.isWindows?1:void 0;class g extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(i=!1){return i?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(a,i){let c,p=-1;for(let d=0;d<a.length;d++){const D=a.charCodeAt(d);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47)p!==-1&&(c+=encodeURIComponent(a.substring(p,d)),p=-1),c!==void 0&&(c+=a.charAt(d));else{c===void 0&&(c=a.substr(0,d));const I=b[D];I!==void 0?(p!==-1&&(c+=encodeURIComponent(a.substring(p,d)),p=-1),c+=I):p===-1&&(p=d)}}return p!==-1&&(c+=encodeURIComponent(a.substring(p))),c!==void 0?c:a}function A(a){let i;for(let c=0;c<a.length;c++){const p=a.charCodeAt(c);p===35||p===63?(i===void 0&&(i=a.substr(0,c)),i+=b[p]):i!==void 0&&(i+=a[c])}return i!==void 0?i:a}function o(a,i){let c;return a.authority&&a.path.length>1&&a.scheme==="file"?c=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?i?c=a.path.substr(1):c=a.path[1].toLowerCase()+a.path.substr(2):c=a.path,R.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=o;function m(a,i){const c=i?A:w;let p="",{scheme:d,authority:D,path:I,query:s,fragment:k}=a;if(d&&(p+=d,p+=":"),(D||d==="file")&&(p+=T,p+=T),D){let F=D.indexOf("@");if(F!==-1){const x=D.substr(0,F);D=D.substr(F+1),F=x.indexOf(":"),F===-1?p+=c(x,!1):(p+=c(x.substr(0,F),!1),p+=":",p+=c(x.substr(F+1),!1)),p+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?p+=c(D,!1):(p+=c(D.substr(0,F),!1),p+=D.substr(F))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const F=I.charCodeAt(1);F>=65&&F<=90&&(I=`/${String.fromCharCode(F+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const F=I.charCodeAt(0);F>=65&&F<=90&&(I=`${String.fromCharCode(F+32)}:${I.substr(2)}`)}p+=c(I,!0)}return s&&(p+="?",p+=c(s,!1)),k&&(p+="#",p+=i?k:w(k,!1)),p}function v(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+v(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(a){return a.match(t)?a.replace(t,i=>v(i)):a}});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[21],_e([0,1,8,2]),function(Z,e,f,R){"use strict";var S,y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(t,r,a){let i=t.get(r);return i===void 0&&(i=a,t.set(r,i)),i}e.getOrSet=E;function _(t){const r=[];return t.forEach((a,i)=>{r.push(`${i} => ${a}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=_;function C(t){const r=[];return t.forEach(a=>{r.push(a)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return a-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,f.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,f.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class l{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,f.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,f.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,f.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,f.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,f.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,f.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(r){this._iter=r}static forUris(r=()=>!1){return new b(new u(r))}static forPaths(){return new b(new l)}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new T)}clear(){this._root=void 0}set(r,a){const i=this._iter.reset(r);let c;for(this._root||(this._root=new g,this._root.segment=i.value()),c=this._root;;){const d=i.cmp(c.segment);if(d>0)c.left||(c.left=new g,c.left.segment=i.value()),c=c.left;else if(d<0)c.right||(c.right=new g,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new g,c.mid.segment=i.value()),c=c.mid;else break}const p=c.value;return c.value=a,c.key=r,p}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let i=this._root;for(;i;){const c=a.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(a.hasNext())a.next(),i=i.mid;else break}return i}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const i=this._iter.reset(r),c=[];let p=this._root;for(;p;){const d=i.cmp(p.segment);if(d>0)c.push([1,p]),p=p.left;else if(d<0)c.push([-1,p]),p=p.right;else if(i.hasNext())i.next(),c.push([0,p]),p=p.mid;else{for(a?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;c.length>0&&p.isEmpty();){let[D,I]=c.pop();switch(D){case 1:I.left=void 0;break;case 0:I.mid=void 0;break;case-1:I.right=void 0;break}p=I}break}}}findSubstr(r){const a=this._iter.reset(r);let i=this._root,c;for(;i;){const p=a.cmp(i.segment);if(p>0)i=i.left;else if(p<0)i=i.right;else if(a.hasNext())a.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(r){const a=this._iter.reset(r);let i=this._root;for(;i;){const c=a.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(a.hasNext())a.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[a,i]of this)r(i,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const a=[r];for(;a.length>0;){const i=a.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&a.push(i.left),i.mid&&a.push(i.mid),i.right&&a.push(i.right))}}}e.TernarySearchTree=b;class w{constructor(r,a){this[S]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=a??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),a),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[i,c]of this.map)r(c,R.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield R.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[R.URI.parse(r[0]),r[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[R.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var A;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(A=e.Touch||(e.Touch={}));class o{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const i=this._map.get(r);if(!!i)return a!==0&&this.touch(i,a),i.value}set(r,a,i=0){let c=this._map.get(r);if(c)c.value=a,i!==0&&this.touch(c,i);else{switch(c={key:r,value:a,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const i=this._state;let c=this._head;for(;c;){if(a?r.bind(a)(c.value,c.key,this):r(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,a=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.key,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return c}values(){const r=this,a=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.value,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return c}entries(){const r=this,a=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:[i.key,i.value],done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return c}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,i=this.size;for(;a&&i>r;)this._map.delete(a.key),a=a.next,i--;this._head=a,this._size=i,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,i=r.previous;if(!a||!i)throw new Error("Invalid list");a.previous=i,i.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const i=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const i=r.next,c=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,i)=>{r.push([i,a])}),r}fromJSON(r){this.clear();for(const[a,i]of r)this.set(a,i)}}e.LinkedMap=o;class m extends o{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class v{constructor(r){P.set(this,void 0),it(this,P,r,"f")}get size(){return Be(this,P,"f").size}forEach(r,a){Be(this,P,"f").forEach(r,a)}get(r){return Be(this,P,"f").get(r)}has(r){return Be(this,P,"f").has(r)}entries(){return Be(this,P,"f").entries()}keys(){return Be(this,P,"f").keys()}values(){return Be(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Be(this,P,"f").entries()}}e.ReadonlyMapView=v}),define(Ee[114],_e([0,1,21,8]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(ne,pe){for(let Re=0,We=q.length;Re<We;Re++){const we=q[Re](ne,pe);if(we)return we}return null}}e.or=S,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(q,ne,pe){if(!pe||pe.length<ne.length)return null;let Re;return q?Re=R.startsWithIgnoreCase(pe,ne):Re=pe.indexOf(ne)===0,Re?ne.length>0?[{start:0,end:ne.length}]:[]:null}function P(q,ne){const pe=ne.toLowerCase().indexOf(q.toLowerCase());return pe===-1?null:[{start:pe,end:pe+q.length}]}e.matchesContiguousSubString=P;function E(q,ne){return _(q.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=E;function _(q,ne,pe,Re){if(pe===q.length)return[];if(Re===ne.length)return null;if(q[pe]===ne[Re]){let We=null;return(We=_(q,ne,pe+1,Re+1))?w({start:Re,end:Re+1},We):null}return _(q,ne,pe,Re+1)}function C(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function T(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>h.add(q.charCodeAt(0)));function u(q){return l(q)||h.has(q)}function g(q,ne){return q===ne||u(q)&&u(ne)}function b(q){return C(q)||n(q)||T(q)}function w(q,ne){return ne.length===0?ne=[q]:q.end===ne[0].start?ne[0].start=q.start:ne.unshift(q),ne}function A(q,ne){for(let pe=ne;pe<q.length;pe++){const Re=q.charCodeAt(pe);if(n(Re)||T(Re)||pe>0&&!b(q.charCodeAt(pe-1)))return pe}return q.length}function o(q,ne,pe,Re){if(pe===q.length)return[];if(Re===ne.length)return null;if(q[pe]!==ne[Re].toLowerCase())return null;{let We=null,we=Re+1;for(We=o(q,ne,pe+1,Re+1);!We&&(we=A(ne,we))<ne.length;)We=o(q,ne,pe+1,we),we++;return We===null?null:w({start:Re,end:Re+1},We)}}function m(q){let ne=0,pe=0,Re=0,We=0,we=0;for(let Ue=0;Ue<q.length;Ue++)we=q.charCodeAt(Ue),n(we)&&ne++,C(we)&&pe++,b(we)&&Re++,T(we)&&We++;const Je=ne/q.length,z=pe/q.length,X=Re/q.length,de=We/q.length;return{upperPercent:Je,lowerPercent:z,alphaPercent:X,numericPercent:de}}function v(q){const{upperPercent:ne,lowerPercent:pe}=q;return pe===0&&ne>.6}function t(q){const{upperPercent:ne,lowerPercent:pe,alphaPercent:Re,numericPercent:We}=q;return pe>.2&&ne<.8&&Re>.6&&We<.2}function r(q){let ne=0,pe=0,Re=0,We=0;for(let we=0;we<q.length;we++)Re=q.charCodeAt(we),n(Re)&&ne++,C(Re)&&pe++,l(Re)&&We++;return(ne===0||pe===0)&&We===0?q.length<=30:ne<=5}function a(q,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!r(q)||ne.length>60)return null;const pe=m(ne);if(!t(pe)){if(!v(pe))return null;ne=ne.toLowerCase()}let Re=null,We=0;for(q=q.toLowerCase();We<ne.length&&(Re=o(q,ne,0,We))===null;)We=A(ne,We+1);return Re}e.matchesCamelCase=a;function i(q,ne,pe=!1){if(!ne||ne.length===0)return null;let Re=null,We=0;for(q=q.toLowerCase(),ne=ne.toLowerCase();We<ne.length&&(Re=c(q,ne,0,We,pe))===null;)We=p(ne,We+1);return Re}e.matchesWords=i;function c(q,ne,pe,Re,We){if(pe===q.length)return[];if(Re===ne.length)return null;if(g(q.charCodeAt(pe),ne.charCodeAt(Re))){let we=null,Je=Re+1;if(we=c(q,ne,pe+1,Re+1,We),!We)for(;!we&&(Je=p(ne,Je))<ne.length;)we=c(q,ne,pe+1,Je,We),Je++;return we===null?null:w({start:Re,end:Re+1},we)}else return null}function p(q,ne){for(let pe=ne;pe<q.length;pe++)if(u(q.charCodeAt(pe))||pe>0&&u(q.charCodeAt(pe-1)))return pe;return q.length}const d=S(e.matchesPrefix,a,P),D=S(e.matchesPrefix,a,E),I=new f.LRUCache(1e4);function s(q,ne,pe=!1){if(typeof q!="string"||typeof ne!="string")return null;let Re=I.get(q);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(q),"i"),I.set(q,Re));const We=Re.exec(ne);return We?[{start:We.index,end:We.index+We[0].length}]:pe?D(q,ne):d(q,ne)}e.matchesFuzzy=s;function k(q,ne){const pe=Xe(q,q.toLowerCase(),0,ne,ne.toLowerCase(),0,!0);return pe?x(pe):null}e.matchesFuzzy2=k;function F(q,ne,pe,Re,We,we){const Je=Math.min(13,q.length);for(;pe<Je;pe++){const z=Xe(q,ne,pe,Re,We,we,!1);if(z)return z}return[0,we]}e.anyScore=F;function x(q){if(typeof q=="undefined")return[];const ne=[],pe=q[1];for(let Re=q.length-1;Re>1;Re--){const We=q[Re]+pe,we=ne[ne.length-1];we&&we.end===We?we.end=We+1:ne.push({start:We,end:We+1})}return ne}e.createMatches=x;const j=128;function oe(){const q=[],ne=[];for(let pe=0;pe<=j;pe++)ne[pe]=0;for(let pe=0;pe<=j;pe++)q.push(ne.slice(0));return q}function se(q){const ne=[];for(let pe=0;pe<=q;pe++)ne[pe]=0;return ne}const V=se(2*j),H=se(2*j),M=oe(),Q=oe(),O=oe(),G=!1;function fe(q,ne,pe,Re,We){function we(z,X,de=" "){for(;z.length<X;)z=de+z;return z}let Je=` |   |${Re.split("").map(z=>we(z,3)).join("|")}
`;for(let z=0;z<=pe;z++)z===0?Je+=" |":Je+=`${ne[z-1]}|`,Je+=q[z].slice(0,We+1).map(X=>we(X.toString(),3)).join("|")+`
`;return Je}function W(q,ne,pe,Re){q=q.substr(ne),pe=pe.substr(Re),console.log(fe(Q,q,q.length,pe,pe.length)),console.log(fe(O,q,q.length,pe,pe.length)),console.log(fe(M,q,q.length,pe,pe.length))}function te(q,ne){if(ne<0||ne>=q.length)return!1;const pe=q.codePointAt(ne);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(pe)}}function he(q,ne){if(ne<0||ne>=q.length)return!1;switch(q.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function Se(q,ne,pe){return ne[q]!==pe[q]}function Le(q,ne,pe,Re,We,we,Je=!1){for(;ne<pe&&We<we;)q[ne]===Re[We]&&(Je&&(V[ne]=We),ne+=1),We+=1;return ne===pe}e.isPatternInWord=Le;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var $e;(function(q){q.Default=[-100,0];function ne(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}q.isDefault=ne})($e=e.FuzzyScore||(e.FuzzyScore={}));function Xe(q,ne,pe,Re,We,we,Je){const z=q.length>j?j:q.length,X=Re.length>j?j:Re.length;if(pe>=z||we>=X||z-pe>X-we||!Le(ne,pe,z,We,we,X,!0))return;qe(z,X,pe,we,ne,We);let de=1,Ue=1,xe=pe,et=we;const Ce=[!1];for(de=1,xe=pe;xe<z;de++,xe++){const me=V[xe],ve=H[xe],B=xe+1<z?H[xe+1]:X;for(Ue=me-we+1,et=me;et<B;Ue++,et++){let ge=Number.MIN_SAFE_INTEGER,be=!1;et<=ve&&(ge=Ge(q,ne,xe,pe,Re,We,et,X,we,M[de-1][Ue-1]===0,Ce));let Ie=0;ge!==Number.MAX_SAFE_INTEGER&&(be=!0,Ie=ge+Q[de-1][Ue-1]);const Oe=et>me,He=Oe?Q[de][Ue-1]+(M[de][Ue-1]>0?-5:0):0,Ze=et>me+1&&M[de][Ue-1]>0,Ke=Ze?Q[de][Ue-2]+(M[de][Ue-2]>0?-5:0):0;if(Ze&&(!Oe||Ke>=He)&&(!be||Ke>=Ie))Q[de][Ue]=Ke,O[de][Ue]=3,M[de][Ue]=0;else if(Oe&&(!be||He>=Ie))Q[de][Ue]=He,O[de][Ue]=2,M[de][Ue]=0;else if(be)Q[de][Ue]=Ie,O[de][Ue]=1,M[de][Ue]=M[de-1][Ue-1]+1;else throw new Error("not possible")}}if(G&&W(q,pe,Re,we),!Ce[0]&&!Je)return;de--,Ue--;const De=[Q[de][Ue],we];let Pe=0,re=0;for(;de>=1;){let me=Ue;do{const ve=O[de][me];if(ve===3)me=me-2;else if(ve===2)me=me-1;else break}while(me>=1);Pe>1&&ne[pe+de-1]===We[we+Ue-1]&&!Se(me+we-1,Re,We)&&Pe+1>M[de][me]&&(me=Ue),me===Ue?Pe++:Pe=1,re||(re=me),de--,Ue=me-1,De.push(Ue)}X===z&&(De[0]+=2);const ae=re-z;return De[0]-=ae,De}e.fuzzyScore=Xe;function qe(q,ne,pe,Re,We,we){let Je=q-1,z=ne-1;for(;Je>=pe&&z>=Re;)We[Je]===we[z]&&(H[Je]=z,Je--),z--}function Ge(q,ne,pe,Re,We,we,Je,z,X,de,Ue){if(ne[pe]!==we[Je])return Number.MIN_SAFE_INTEGER;let xe=1,et=!1;return Je===pe-Re?xe=q[pe]===We[Je]?7:5:Se(Je,We,we)&&(Je===0||!Se(Je-1,We,we))?(xe=q[pe]===We[Je]?7:5,et=!0):te(we,Je)&&(Je===0||!te(we,Je-1))?xe=5:(te(we,Je-1)||he(we,Je-1))&&(xe=5,et=!0),xe>1&&pe===Re&&(Ue[0]=!0),et||(et=Se(Je,We,we)||te(we,Je-1)||he(we,Je-1)),pe===Re?Je>X&&(xe-=et?3:5):de?xe+=et?2:0:xe+=et?0:1,Je+1===z&&(xe-=et?3:5),xe}function U(q,ne,pe,Re,We,we,Je){return J(q,ne,pe,Re,We,we,!0,Je)}e.fuzzyScoreGracefulAggressive=U;function K(q,ne,pe,Re,We,we,Je){return J(q,ne,pe,Re,We,we,!1,Je)}e.fuzzyScoreGraceful=K;function J(q,ne,pe,Re,We,we,Je,z){let X=Xe(q,ne,pe,Re,We,we,z);if(X&&!Je)return X;if(q.length>=3){const de=Math.min(7,q.length-1);for(let Ue=pe+1;Ue<de;Ue++){const xe=ie(q,Ue);if(xe){const et=Xe(xe,xe.toLowerCase(),pe,Re,We,we,z);et&&(et[0]-=3,(!X||et[0]>X[0])&&(X=et))}}}return X}function ie(q,ne){if(ne+1>=q.length)return;const pe=q[ne],Re=q[ne+1];if(pe!==Re)return q.slice(0,ne)+Re+pe+q.slice(ne+2)}}),define(Ee[115],_e([0,1,35,114,8]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${y.source}`,"g");function E(g){return g.replace(P,(b,w)=>w?b:`\\${b}`)}e.escapeIcons=E;const _=new RegExp(`\\\\${y.source}`,"g");function C(g){return g.replace(_,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function T(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(n,(b,w,A,o)=>A?b:w||o||"")}e.stripIcons=T;function l(g){const b=g.indexOf(e.iconStartMarker);return b===-1?{text:g}:h(g,b)}e.parseLabelWithIcons=l;function h(g,b){const w=[];let A="";function o(p){if(p){A+=p;for(const d of p)w.push(t)}}let m=-1,v="",t=0,r,a,i=b;const c=g.length;for(o(g.substr(0,b));i<c;)r=g[i],a=g[i+1],r===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(m=i,o(v),v=e.iconStartMarker,i++):r===")"&&m!==-1?(t+=i-m+1,m=-1,v=""):m!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(o(v),m=-1,v=""):o(r),i++;return o(v),{text:A,iconOffsets:w}}function u(g,b,w=!1){const{text:A,iconOffsets:o}=b;if(!o||o.length===0)return(0,R.matchesFuzzy)(g,A,w);const m=(0,S.ltrim)(A," "),v=A.length-m.length,t=(0,R.matchesFuzzy)(g,m,w);if(t)for(const r of t){const a=o[r.start+v]+v;r.start+=a,r.end+=a}return t}e.matchesFuzzyIconAware=u}),define(Ee[83],_e([0,1,12,115]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",u=!1){if(this.value=h,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(h,u=0){return this.value+=C(this.supportThemeIcons?(0,R.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,u){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=y;function P(l){return E(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function E(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=E;function _(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=_;function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function T(l){const h=[],u=l.split("|").map(b=>b.trim());l=u[0];const g=u[1];if(g){const b=/height=(\d+)/.exec(g),w=/width=(\d+)/.exec(g),A=b?b[1]:"",o=w?w[1]:"",m=isFinite(parseInt(o)),v=isFinite(parseInt(A));m&&h.push(`width="${o}"`),v&&h.push(`height="${A}"`)}return{href:l,dimensions:h}}e.parseHrefAndDimensions=T}),define(Ee[57],_e([0,1,24,8,2]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,_)}e.stringify=y;function P(n){let T=JSON.parse(n);return T=C(T),T}e.parse=P;var E;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(E=e.MarshalledId||(e.MarshalledId={}));function _(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,R.regExpFlags)(T)}:T}function C(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof f.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=C(n[l],T+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=C(n[l],T+1))}return n}e.revive=C}),define(Ee[11],_e([0,1,22,2]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,n){this._hosts[_]=C,this._ports[_]=n}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const T=this._ports[C],l=this._connectionTokens[C];let h=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(h+=`&tkn=${encodeURIComponent(l)}`),R.URI.from({scheme:f.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${T}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new y;class P{asBrowserUri(_,C){const n=this.toUri(_,C);return n.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===S.file&&(f.isNative||typeof f.globals.importScripts=="function"&&f.globals.origin===`${S.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?n.with({scheme:S.vscodeFileResource,authority:n.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(_,C){const n=this.toUri(_,C);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==P.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,C){return R.URI.isUri(_)?_:R.URI.parse(C.toUrl(_))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Ee[25],_e([0,1,44,11,14,22,8,2]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(h){return(0,E.uriToFsPath)(h,!0)}e.originalFSPath=_;class C{constructor(u){this._ignorePathCasing=u}compare(u,g,b=!1){return u===g?0:(0,P.compare)(this.getComparisonKey(u,b),this.getComparisonKey(g,b))}isEqual(u,g,b=!1){return u===g?!0:!u||!g?!1:this.getComparisonKey(u,b)===this.getComparisonKey(g,b)}getComparisonKey(u,g=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,g,b=!1){if(u.scheme===g.scheme){if(u.scheme===R.Schemas.file)return f.isEqualOrParent(_(u),_(g),this._ignorePathCasing(u))&&u.query===g.query&&(b||u.fragment===g.fragment);if((0,e.isEqualAuthority)(u.authority,g.authority))return f.isEqualOrParent(u.path,g.path,this._ignorePathCasing(u),"/")&&u.query===g.query&&(b||u.fragment===g.fragment)}return!1}joinPath(u,...g){return E.URI.joinPath(u,...g)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return S.posix.basename(u.path)}extname(u){const g=S.posix.extname(u.path),b=g.indexOf("?");return b!==-1?g.substr(0,b):g}dirname(u){if(u.path.length===0)return u;let g;return u.scheme===R.Schemas.file?g=E.URI.file(S.dirname(_(u))).path:(g=S.posix.dirname(u.path),u.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),g="/")),u.with({path:g})}normalizePath(u){if(!u.path.length)return u;let g;return u.scheme===R.Schemas.file?g=E.URI.file(S.normalize(_(u))).path:g=S.posix.normalize(u.path),u.with({path:g})}relativePath(u,g){if(u.scheme!==g.scheme||!(0,e.isEqualAuthority)(u.authority,g.authority))return;if(u.scheme===R.Schemas.file){const A=S.relative(_(u),_(g));return y.isWindows?f.toSlashes(A):A}let b=u.path||"/",w=g.path||"/";if(this._ignorePathCasing(u)){let A=0;for(const o=Math.min(b.length,w.length);A<o&&!(b.charCodeAt(A)!==w.charCodeAt(A)&&b.charAt(A).toLowerCase()!==w.charAt(A).toLowerCase());A++);b=w.substr(0,A)+b.substr(A)}return S.posix.relative(b,w)}resolvePath(u,g){if(u.scheme===R.Schemas.file){const b=E.URI.file(S.resolve(_(u),g));return u.with({authority:b.authority,path:b.path})}return g=f.toPosixPath(g),u.with({path:S.posix.resolve(u.path,g)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,g){return u===g||(0,P.equalsIgnoreCase)(u,g)}hasTrailingPathSeparator(u,g=S.sep){if(u.scheme===R.Schemas.file){const b=_(u);return b.length>f.getRoot(b).length&&b[b.length-1]===g}else{const b=u.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,g=S.sep){return(0,e.hasTrailingPathSeparator)(u,g)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,g=S.sep){let b=!1;if(u.scheme===R.Schemas.file){const w=_(u);b=w!==void 0&&w.length===f.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=u.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(u,g)?u.with({path:u.path+"/"}):u}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===R.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,u){const g=[];for(let b=0;b<h.length;b++){const w=u(h[b]);h.some((A,o)=>o===b?!1:(0,e.isEqualOrParent)(w,u(A)))||g.push(h[b])}return g}e.distinctParents=n;var T;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function u(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[m,v]=o.split(":");m&&v&&b.set(m,v)});const A=g.path.substring(0,g.path.indexOf(";"));return A&&b.set(h.META_DATA_MIME,A),b}h.parseMetaData=u})(T=e.DataUri||(e.DataUri={}));function l(h,u,g){if(u){let b=h.path;return b&&b[0]!==S.posix.sep&&(b=S.posix.sep+b),h.with({scheme:g,authority:u,path:b})}return h.with({scheme:g})}e.toLocalResource=l}),define(Ee[15],_e([0,1,20,12,3,6,25]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(H){return!!H&&typeof H.then=="function"}e.isThenable=E;function _(H){const M=new f.CancellationTokenSource,Q=H(M.token),O=new Promise((G,fe)=>{const W=M.token.onCancellationRequested(()=>{W.dispose(),M.dispose(),fe((0,R.canceled)())});Promise.resolve(Q).then(te=>{W.dispose(),M.dispose(),G(te)},te=>{W.dispose(),M.dispose(),fe(te)})});return new class{cancel(){M.cancel()}then(G,fe){return O.then(G,fe)}catch(G){return this.then(void 0,G)}finally(G){return O.finally(G)}}}e.createCancelablePromise=_;function C(H,M,Q){return Promise.race([H,new Promise(O=>M.onCancellationRequested(()=>O(Q)))])}e.raceCancellation=C;async function n(H){let M=-1;const Q=H.map((G,fe)=>G.then(W=>(M=fe,W))),O=await Promise.race(Q);return H.forEach((G,fe)=>{fe!==M&&G.cancel()}),O}e.raceCancellablePromises=n;function T(H,M,Q){let O;const G=setTimeout(()=>{O?.(void 0),Q?.()},M);return Promise.race([H.finally(()=>clearTimeout(G)),new Promise(fe=>O=fe)])}e.raceTimeout=T;function l(H){return new Promise((M,Q)=>{const O=H();E(O)?O.then(M,Q):M(O)})}e.asPromise=l;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const Q=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(Q,Q).then(O)})}return new Promise((Q,O)=>{this.queuedPromise.then(Q,O)})}return this.activePromise=M(),new Promise((Q,O)=>{this.activePromise.then(G=>{this.activePromise=null,Q(G)},G=>{this.activePromise=null,O(G)})})}}e.Throttler=h;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class g{constructor(){this.promiseMap=new Map}queue(M,Q){const G=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.promiseMap.get(M)===G&&this.promiseMap.delete(M)});return this.promiseMap.set(M,G),G}}e.SequencerByKey=g;class b{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,Q=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,G)=>{this.doResolve=O,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(M){this.delayer=new b(M),this.throttler=new h}trigger(M,Q){return this.delayer.trigger(()=>this.throttler.queue(M),Q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class A{constructor(){this._isOpen=!1,this._promise=new Promise((M,Q)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=A;class o extends A{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function m(H,M){return M?new Promise((Q,O)=>{const G=setTimeout(()=>{fe.dispose(),Q()},H),fe=M.onCancellationRequested(()=>{clearTimeout(G),fe.dispose(),O((0,R.canceled)())})}):_(Q=>m(H,Q))}e.timeout=m;function v(H,M=0){const Q=setTimeout(H,M);return(0,y.toDisposable)(()=>clearTimeout(Q))}e.disposableTimeout=v;function t(H){const M=[];let Q=0;const O=H.length;function G(){return Q<O?H[Q++]():null}function fe(W){W!=null&&M.push(W);const te=G();return te?te.then(fe):Promise.resolve(M)}return Promise.resolve(null).then(fe)}e.sequence=t;function r(H,M=O=>!!O,Q=null){let O=0;const G=H.length,fe=()=>{if(O>=G)return Promise.resolve(Q);const W=H[O++];return Promise.resolve(W()).then(he=>M(he)?Promise.resolve(he):fe())};return fe()}e.first=r;function a(H,M=O=>!!O,Q=null){if(H.length===0)return Promise.resolve(Q);let O=H.length;const G=()=>{O=-1;for(const fe of H)fe.cancel?.()};return new Promise((fe,W)=>{for(const te of H)te.then(he=>{--O>=0&&M(he)?(G(),fe(he)):O===0&&fe(Q)}).catch(he=>{--O>=0&&(G(),W(he))})})}e.firstParallel=a;class i{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((Q,O)=>{this.outstandingPromises.push({factory:M,c:Q,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const Q=M.factory();Q.then(M.c,M.e),Q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class p{constructor(){this.queues=new Map}queueFor(M,Q=P.extUri){const O=Q.getComparisonKey(M);let G=this.queues.get(O);return G||(G=new c,S.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(O)}),this.queues.set(O,G)),G}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=p;class d{constructor(M,Q){this._token=-1,typeof M=="function"&&typeof Q=="number"&&this.setIfNotSet(M,Q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,Q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},Q)}setIfNotSet(M,Q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},Q))}}e.TimeoutTimer=d;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,Q){this.cancel(),this._token=setInterval(()=>{M()},Q)}}e.IntervalTimer=D;class I{constructor(M,Q){this.timeoutToken=-1,this.runner=M,this.timeout=Q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class s extends I{constructor(M,Q){super(M,Q);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=s;class k extends y.Disposable{constructor(M,Q,O,G){super();this.maxWorkChunkSize=M,this.maxPendingWork=Q,this.throttleDelay=O,this.handler=G,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new I(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const Q=setTimeout(()=>M(H));let O=!1;return{dispose(){O||(O=!0,clearTimeout(Q))}}}}else e.runWhenIdle=(H,M)=>{const Q=requestIdleCallback(H,typeof M=="number"?{timeout:M}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(Q))}}}}();class F{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=F;async function x(H,M,Q){let O;for(let G=0;G<Q;G++)try{return await H()}catch(fe){O=fe,await m(M)}throw O}e.retry=x;class j{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,Q,O){return this._pending={taskId:M,cancel:()=>O?.(),promise:Q},Q.then(()=>this.donePending(M),()=>this.donePending(M)),Q}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let Q,O;const G=new Promise((fe,W)=>{Q=fe,O=W});this._next={run:M,promise:G,promiseResolve:Q,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=j;class oe{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=oe;class se{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,Q)=>{this.completeCallback=M,this.errorCallback=Q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(Q=>{this.completeCallback(M),this.resolved=!0,Q()})}error(M){return new Promise(Q=>{this.errorCallback(M),this.rejected=!0,Q()})}cancel(){new Promise(M=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=se;var V;(function(H){async function M(Q){let O;const G=await Promise.all(Q.map(fe=>fe.then(W=>W,W=>{O||(O=W)})));if(typeof O!="undefined")throw O;return G}H.settled=M})(V=e.Promises||(e.Promises={}))}),define(Ee[116],_e([0,1,15,14]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new f.IdleValue(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),y=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function E(I,s,k=!1){const F=I||"",x=s||"",j=S.value.collator.compare(F,x);return S.value.collatorIsNumeric&&j===0&&F!==x?F<x?-1:1:j}e.compareFileNames=E;function _(I,s){const k=y.value.collator;return I=I||"",s=s||"",v(k,I,s)}e.compareFileNamesDefault=_;function C(I,s){const k=y.value.collator;return I=I||"",s=s||"",i(I,s)||v(k,I,s)}e.compareFileNamesUpper=C;function n(I,s){const k=y.value.collator;return I=I||"",s=s||"",a(I,s)||v(k,I,s)}e.compareFileNamesLower=n;function T(I,s){return I=I||"",s=s||"",I===s?0:I<s?-1:1}e.compareFileNamesUnicode=T;function l(I,s,k=!1){k||(I=I&&I.toLowerCase(),s=s&&s.toLowerCase());const[F,x]=o(I),[j,oe]=o(s);return F!==j?F<j?-1:1:x===oe?0:x<oe?-1:1}e.noIntlCompareFileNames=l;function h(I,s){const[k,F]=o(I),[x,j]=o(s);let oe=S.value.collator.compare(F,j);if(oe===0){if(S.value.collatorIsNumeric&&F!==j)return F<j?-1:1;if(oe=S.value.collator.compare(k,x),S.value.collatorIsNumeric&&oe===0&&k!==x)return k<x?-1:1}return oe}e.compareFileExtensions=h;function u(I,s){I=I||"",s=s||"";const k=m(I),F=m(s),x=y.value.collator,j=P.value.collator;return v(j,k,F)||v(x,I,s)}e.compareFileExtensionsDefault=u;function g(I,s){I=I||"",s=s||"";const k=m(I),F=m(s),x=y.value.collator,j=P.value.collator;return v(j,k,F)||i(I,s)||v(x,I,s)}e.compareFileExtensionsUpper=g;function b(I,s){I=I||"",s=s||"";const k=m(I),F=m(s),x=y.value.collator,j=P.value.collator;return v(j,k,F)||a(I,s)||v(x,I,s)}e.compareFileExtensionsLower=b;function w(I,s){I=I||"",s=s||"";const k=m(I).toLowerCase(),F=m(s).toLowerCase();return k!==F?k<F?-1:1:I!==s?I<s?-1:1:0}e.compareFileExtensionsUnicode=w;const A=/^(.*?)(\.([^.]*))?$/;function o(I,s=!1){const k=I?A.exec(I):[];let F=[k&&k[1]||"",k&&k[3]||""];return s&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function m(I){const s=I?A.exec(I):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function v(I,s,k){let F=I.compare(s,k);return F!==0?F:s.length!==k.length?s.length<k.length?-1:1:0}function t(I){const s=I.charAt(0);return s.toLocaleUpperCase()!==s}function r(I){const s=I.charAt(0);return s.toLocaleLowerCase()!==s}function a(I,s){return t(I)&&r(s)?-1:r(I)&&t(s)?1:0}function i(I,s){return r(I)&&t(s)?-1:t(I)&&r(s)?1:0}function c(I,s,k=!1){return k||(I=I&&I.toLowerCase(),s=s&&s.toLowerCase()),I===s?0:I<s?-1:1}function p(I,s,k=!1){const F=I.split(R.sep),x=s.split(R.sep),j=F.length-1,oe=x.length-1;let se,V;for(let H=0;;H++){if(se=j===H,V=oe===H,se&&V)return E(F[H],x[H],k);if(se)return-1;if(V)return 1;const M=c(F[H],x[H],k);if(M!==0)return M}}e.comparePaths=p;function d(I,s,k){const F=I.toLowerCase(),x=s.toLowerCase(),j=D(I,s,k);if(j)return j;const oe=F.endsWith(k),se=x.endsWith(k);if(oe!==se)return oe?-1:1;const V=E(F,x);return V!==0?V:F.localeCompare(x)}e.compareAnything=d;function D(I,s,k){const F=I.toLowerCase(),x=s.toLowerCase(),j=F.startsWith(k),oe=x.startsWith(k);if(j!==oe)return j?-1:1;if(j&&oe){if(F.length<x.length)return-1;if(F.length>x.length)return 1}return 0}e.compareByPrefix=D}),define(Ee[27],_e([0,1,15,44,21,14,8]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E;const _="**",C="/",n="[/\\\\]",T="[^/\\\\]",l=/\//g;function h(G){switch(G){case 0:return"";case 1:return`${T}*?`;default:return`(?:${n}|${T}+${n}|${n}${T}+)*?`}}function u(G,fe){if(!G)return[];const W=[];let te=!1,he=!1,Se="";for(const Le of G){switch(Le){case fe:if(!te&&!he){W.push(Se),Se="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":he=!0;break;case"]":he=!1;break}Se+=Le}return Se&&W.push(Se),W}e.splitGlobAware=u;function g(G){if(!G)return"";let fe="";const W=u(G,C);if(W.every(te=>te===_))fe=".*";else{let te=!1;W.forEach((he,Se)=>{if(he===_){te||(fe+=h(2),te=!0);return}let Le=!1,Me="",$e=!1,Xe="";for(const qe of he){if(qe!=="}"&&Le){Me+=qe;continue}if($e&&(qe!=="]"||!Xe)){let Ge;qe==="-"?Ge=qe:(qe==="^"||qe==="!")&&!Xe?Ge="^":qe===C?Ge="":Ge=P.escapeRegExpCharacters(qe),Xe+=Ge;continue}switch(qe){case"{":Le=!0;continue;case"[":$e=!0;continue;case"}":fe+=`(?:${u(Me,",").map(K=>g(K)).join("|")})`,Le=!1,Me="";break;case"]":fe+="["+Xe+"]",$e=!1,Xe="";break;case"?":fe+=T;continue;case"*":fe+=h(1);continue;default:fe+=P.escapeRegExpCharacters(qe)}}Se<W.length-1&&(W[Se+1]!==_||Se+2<W.length)&&(fe+=n),te=!1})}return fe}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,A=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},a=function(){return null};function i(G,fe){if(!G)return a;let W;typeof G!="string"?W=G.pattern:W=G,W=W.trim();const te=`${W}_${!!fe.trimForExclusions}`;let he=t.get(te);if(he)return c(he,G);let Se;if(b.test(W)){const Le=W.substr(4);he=function(Me,$e){return typeof Me=="string"&&Me.endsWith(Le)?W:null}}else(Se=w.exec(p(W,fe)))?he=d(Se[1],W):(fe.trimForExclusions?o:A).test(W)?he=D(W,fe):(Se=m.exec(p(W,fe)))?he=I(Se[1].substr(1),W,!0):(Se=v.exec(p(W,fe)))?he=I(Se[1],W,!1):he=s(W);return t.set(te,he),c(he,G)}function c(G,fe){return typeof fe=="string"?G:function(W,te){return R.isEqualOrParent(W,fe.base)?G(y.relative(fe.base,W),te):null}}function p(G,fe){return fe.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function d(G,fe){const W=`/${G}`,te=`\\${G}`,he=function(Le,Me){return typeof Le!="string"?null:Me?Me===G?fe:null:Le===G||Le.endsWith(W)||Le.endsWith(te)?fe:null},Se=[G];return he.basenames=Se,he.patterns=[fe],he.allBasenames=Se,he}function D(G,fe){const W=O(G.slice(1,-1).split(",").map(Me=>i(Me,fe)).filter(Me=>Me!==a),G),te=W.length;if(!te)return a;if(te===1)return W[0];const he=function(Me,$e){for(let Xe=0,qe=W.length;Xe<qe;Xe++)if(W[Xe](Me,$e))return G;return null},Se=W.find(Me=>!!Me.allBasenames);Se&&(he.allBasenames=Se.allBasenames);const Le=W.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Le.length&&(he.allPaths=Le),he}function I(G,fe,W){const te=y.sep===y.posix.sep,he=te?G:G.replace(l,y.sep),Se=y.sep+he,Le=y.posix.sep+G,Me=W?function($e,Xe){return typeof $e=="string"&&($e===he||$e.endsWith(Se)||!te&&($e===G||$e.endsWith(Le)))?fe:null}:function($e,Xe){return typeof $e=="string"&&($e===he||!te&&$e===G)?fe:null};return Me.allPaths=[(W?"*/":"./")+G],Me}function s(G){try{const fe=new RegExp(`^${g(G)}$`);return function(W){return fe.lastIndex=0,typeof W=="string"&&fe.test(W)?G:null}}catch(fe){return a}}function k(G,fe,W){return!G||typeof fe!="string"?!1:F(G)(fe,void 0,W)}e.match=k;function F(G,fe={}){if(!G)return r;if(typeof G=="string"||se(G)){const W=i(G,fe);if(W===a)return r;const te=function(he,Se){return!!W(he,Se)};return W.allBasenames&&(te.allBasenames=W.allBasenames),W.allPaths&&(te.allPaths=W.allPaths),te}return M(G,fe)}e.parse=F;function x(G){if(!G)return;let fe;return W=>(fe||(fe=(G()||Promise.resolve([])).then(te=>te?oe(te):{})),fe.then(te=>!!te[W]))}e.hasSiblingPromiseFn=x;function j(G){if(!G)return;let fe;return W=>{if(!fe){const te=G();fe=te?oe(te):{}}return!!fe[W]}}e.hasSiblingFn=j;function oe(G){const fe={};for(const W of G)fe[W]=!0;return fe}function se(G){const fe=G;return fe&&typeof fe.base=="string"&&typeof fe.pattern=="string"}e.isRelativePattern=se;function V(G){return G.allBasenames||[]}e.getBasenameTerms=V;function H(G){return G.allPaths||[]}e.getPathTerms=H;function M(G,fe){const W=O(Object.getOwnPropertyNames(G).map(Me=>Q(Me,G[Me],fe)).filter(Me=>Me!==a)),te=W.length;if(!te)return a;if(!W.some(Me=>!!Me.requiresSiblings)){if(te===1)return W[0];const Me=function(qe,Ge){for(let U=0,K=W.length;U<K;U++){const J=W[U](qe,Ge);if(J)return J}return null},$e=W.find(qe=>!!qe.allBasenames);$e&&(Me.allBasenames=$e.allBasenames);const Xe=W.reduce((qe,Ge)=>Ge.allPaths?qe.concat(Ge.allPaths):qe,[]);return Xe.length&&(Me.allPaths=Xe),Me}const he=function(Me,$e,Xe){let qe;for(let Ge=0,U=W.length;Ge<U;Ge++){const K=W[Ge];K.requiresSiblings&&Xe&&($e||($e=y.basename(Me)),qe||(qe=$e.substr(0,$e.length-y.extname(Me).length)));const J=K(Me,$e,qe,Xe);if(J)return J}return null},Se=W.find(Me=>!!Me.allBasenames);Se&&(he.allBasenames=Se.allBasenames);const Le=W.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Le.length&&(he.allPaths=Le),he}function Q(G,fe,W){if(fe===!1)return a;const te=i(G,W);if(te===a)return a;if(typeof fe=="boolean")return te;if(fe){const he=fe.when;if(typeof he=="string"){const Se=(Le,Me,$e,Xe)=>{if(!Xe||!te(Le,Me))return null;const qe=he.replace("$(basename)",$e),Ge=Xe(qe);return(0,f.isThenable)(Ge)?Ge.then(U=>U?G:null):Ge?G:null};return Se.requiresSiblings=!0,Se}}return te}function O(G,fe){const W=G.filter(Me=>!!Me.basenames);if(W.length<2)return G;const te=W.reduce((Me,$e)=>{const Xe=$e.basenames;return Xe?Me.concat(Xe):Me},[]);let he;if(fe){he=[];for(let Me=0,$e=te.length;Me<$e;Me++)he.push(fe)}else he=W.reduce((Me,$e)=>{const Xe=$e.patterns;return Xe?Me.concat(Xe):Me},[]);const Se=function(Me,$e){if(typeof Me!="string")return null;if(!$e){let qe;for(qe=Me.length;qe>0;qe--){const Ge=Me.charCodeAt(qe-1);if(Ge===47||Ge===92)break}$e=Me.substr(qe)}const Xe=te.indexOf($e);return Xe!==-1?he[Xe]:null};Se.basenames=te,Se.patterns=he,Se.allBasenames=te;const Le=G.filter(Me=>!Me.basenames);return Le.push(Se),Le}}),define(Ee[84],_e([0,1,44,11,14,22,25,8,2]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(i,c,p){if(typeof i=="string"&&(i=_.URI.file(i)),p){const D=p.getWorkspaceFolder(i);if(D){const I=p.getWorkspace().folders.length>1;let s;if((0,P.isEqual)(D.uri,i)?s="":s=(0,P.relativePath)(D.uri,i),I){const k=D.name?D.name:(0,P.basename)(D.uri);s=s?k+" \u2022 "+s:k}return s}}if(i.scheme!==R.Schemas.file&&i.scheme!==R.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(i.fsPath))return(0,S.normalize)(T(i.fsPath));let d=(0,S.normalize)(i.fsPath);return!y.isWindows&&c?.userHome&&(d=h(d,c.userHome.fsPath)),d}e.getPathLabel=C;function n(i){if(!i)return;typeof i=="string"&&(i=_.URI.file(i));const c=(0,P.basename)(i)||(i.scheme===R.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,f.isRootOrDriveLetter)(c)?T(c):c}e.getBaseLabel=n;function T(i){return(0,f.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=T;let l=Object.create(null);function h(i,c){if(y.isWindows||!i||!c)return i;let p=l.original===c?l.normalized:void 0;return p||(p=`${(0,E.rtrim)(c,S.posix.sep)}${S.posix.sep}`,l={original:c,normalized:p}),(y.isLinux?i.startsWith(p):(0,E.startsWithIgnoreCase)(i,p))&&(i=`~/${i.substr(p.length)}`),i}e.tildify=h;function u(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const g="\u2026",b="\\\\",w="~";function A(i,c=S.sep){const p=new Array(i.length);let d=!1;for(let D=0;D<i.length;D++){let I=i[D];if(I===""){p[D]=`.${c}`;continue}if(!I){p[D]=I;continue}d=!0;let s="";I.indexOf(b)===0?(s=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length)):I.indexOf(c)===0?(s=I.substr(0,I.indexOf(c)+c.length),I=I.substr(I.indexOf(c)+c.length)):I.indexOf(w)===0&&(s=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length));const k=I.split(c);for(let F=1;d&&F<=k.length;F++)for(let x=k.length-F;d&&x>=0;x--){d=!1;let j=k.slice(x,x+F).join(c);for(let oe=0;!d&&oe<i.length;oe++)if(oe!==D&&i[oe]&&i[oe].indexOf(j)>-1){const se=x+F===k.length,V=x>0&&i[oe].indexOf(c)>-1?c+j:j,H=i[oe].endsWith(V);d=!se||H}if(!d){let oe="";(k[0].endsWith(":")||s!=="")&&(x===1&&(x=0,F++,j=k[0]+c+j),x>0&&(oe=k[0]+c),oe=s+oe),x>0&&(oe=oe+g+c),oe=oe+j,x+F<k.length&&(oe=oe+c+g),p[D]=oe}}d&&(p[D]=I)}return p}e.shorten=A;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function m(i,c=Object.create(null)){const p=[];let d=!1,D="";for(const I of i)if(I==="$"||d&&I==="{")D&&p.push({value:D,type:o.TEXT}),D="",d=!0;else if(I==="}"&&d){const s=c[D];if(typeof s=="string")s.length&&p.push({value:s,type:o.VARIABLE});else if(s){const k=p[p.length-1];(!k||k.type!==o.SEPARATOR)&&p.push({value:s.label,type:o.SEPARATOR})}D="",d=!1}else D+=I;return D&&!d&&p.push({value:D,type:o.TEXT}),p.filter((I,s)=>{if(I.type===o.SEPARATOR){const k=p[s-1],F=p[s+1];return[k,F].every(x=>x&&(x.type===o.VARIABLE||x.type===o.TEXT)&&x.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=m;function v(i,c){return y.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,c){return y.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,p=>p==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function a(i){const c=i.indexOf("/")!==-1?S.posix:S.win32,p=c.basename(i),d=c.dirname(i);return p.length?{name:p,parentPath:d}:{name:d,parentPath:""}}e.splitName=a}),define(Ee[85],_e([0,1,27,11,14,25,8]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var E;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(E=e.Mimes||(e.Mimes={}));let _=[],C=[],n=[];function T(i,c=!1){const p=l(i);_.push(p),p.userConfigured?n.push(p):C.push(p),c&&!p.userConfigured&&_.forEach(d=>{d.mime===p.mime||d.userConfigured||(p.extension&&d.extension===p.extension&&console.warn(`Overwriting extension <<${p.extension}>> to now point to mime <<${p.mime}>>`),p.filename&&d.filename===p.filename&&console.warn(`Overwriting filename <<${p.filename}>> to now point to mime <<${p.mime}>>`),p.filepattern&&d.filepattern===p.filepattern&&console.warn(`Overwriting filepattern <<${p.filepattern}>> to now point to mime <<${p.mime}>>`),p.firstline&&d.firstline===p.firstline&&console.warn(`Overwriting firstline <<${p.firstline}>> to now point to mime <<${p.mime}>>`))})}e.registerTextMime=T;function l(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(S.posix.sep)>=0:!1}}function h(i){i?(_=_.filter(c=>!c.userConfigured),n=[]):(_=[],C=[],n=[])}e.clearTextMimes=h;function u(i,c){let p;if(i)switch(i.scheme){case R.Schemas.file:p=i.fsPath;break;case R.Schemas.data:p=y.DataUri.parseMetaData(i).get(y.DataUri.META_DATA_LABEL);break;default:p=i.path}if(!p)return[E.unknown];p=p.toLowerCase();const d=(0,S.basename)(p),D=g(p,d,n);if(D)return[D,E.text];const I=g(p,d,C);if(I)return[I,E.text];if(c){const s=b(c);if(s)return[s,E.text]}return[E.unknown]}e.guessMimeTypes=u;function g(i,c,p){let d=null,D=null,I=null;for(let s=p.length-1;s>=0;s--){const k=p[s];if(c===k.filenameLowercase){d=k;break}if(k.filepattern&&(!D||k.filepattern.length>D.filepattern.length)){const F=k.filepatternOnPath?i:c;(0,f.match)(k.filepatternLowercase,F)&&(D=k)}k.extension&&(!I||k.extension.length>I.extension.length)&&c.endsWith(k.extensionLowercase)&&(I=k)}return d?d.mime:D?D.mime:I?I.mime:null}function b(i){if((0,P.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let c=_.length-1;c>=0;c--){const p=_[c];if(!p.firstline)continue;const d=i.match(p.firstline);if(d&&d.length>0)return p.mime}return null}function w(i){return i?typeof i=="string"?i===E.binary||i===E.text||i===E.unknown:i.length===1&&w(i[0]):!0}e.isUnspecific=w;const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function m(i){const c=(0,S.extname)(i),p=A[c.toLowerCase()];return p!==void 0?p:v(i)}e.getMediaOrTextMime=m;function v(i){const c=(0,S.extname)(i);return o[c.toLowerCase()]}e.getMediaMime=v;function t(i){for(const c in o)if(o[c]===i)return c}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function a(i,c){const p=r.exec(i);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:c?void 0:i}e.normalizeMimeType=a}),define(Ee[117],_e([0,1,2]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class S{constructor(T){this._uriTransformer=T}transformIncoming(T){const l=this._uriTransformer.transformIncoming(T);return l===T?T:R(f.URI.from(l))}transformOutgoing(T){const l=this._uriTransformer.transformOutgoing(T);return l===T?T:R(f.URI.from(l))}transformOutgoingURI(T){const l=this._uriTransformer.transformOutgoing(T);return l===T?T:f.URI.from(l)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,T,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof f.URI)return T.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const u=y(n[h],T,l+1);u!==null&&(n[h]=u)}}return null}function P(n,T){const l=y(n,T,0);return l===null?n:l}e.transformOutgoingURIs=P;function E(n,T,l,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?f.URI.revive(T.transformIncoming(n)):T.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const g=E(n[u],T,l,h+1);g!==null&&(n[u]=g)}}return null}function _(n,T){const l=E(n,T,!1,0);return l===null?n:l}e.transformIncomingURIs=_;function C(n,T){const l=E(n,T,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=C}),define(Ee[37],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(_){return f.test(_)}e.isUUID=R;const S=new Uint8Array(16),y=[];for(let _=0;_<256;_++)y.push(_.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function E(){P(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let _=0,C="";return C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+="-",C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C+=y[S[_++]],C}e.generateUuid=E}),define(Ee[86],_e([0,1,82]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(E){let _=(0,f.toUint8)(E);this._defaultValue=_,this._asciiMap=R._createAsciiMap(_),this._map=new Map}static _createAsciiMap(E){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=E;return _}set(E,_){let C=(0,f.toUint8)(_);E>=0&&E<256?this._asciiMap[E]=C:this._map.set(E,C)}get(E){return E>=0&&E<256?this._asciiMap[E]:this._map.get(E)||this._defaultValue}}e.CharacterClassifier=R;var S;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(S||(S={}));class y{constructor(){this._actual=new R(0)}add(E){this._actual.set(E,1)}has(E){return this._actual.get(E)===1}}e.CharacterSet=y}),define(Ee[118],_e([0,1,86]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends f.CharacterClassifier{constructor(E){super(0);for(let _=0,C=E.length;_<C;_++)this.set(E.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function y(P){let E={};return _=>(E.hasOwnProperty(_)||(E[_]=P(_)),E[_])}e.getMapForWordSeparators=y(P=>new S(P))}),define(Ee[38],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(S,y){this.lineNumber=S,this.column=y}with(S=this.lineNumber,y=this.column){return S===this.lineNumber&&y===this.column?this:new f(S,y)}delta(S=0,y=0){return this.with(this.lineNumber+S,this.column+y)}equals(S){return f.equals(this,S)}static equals(S,y){return!S&&!y?!0:!!S&&!!y&&S.lineNumber===y.lineNumber&&S.column===y.column}isBefore(S){return f.isBefore(this,S)}static isBefore(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<y.column}isBeforeOrEqual(S){return f.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<=y.column}static compare(S,y){let P=S.lineNumber|0,E=y.lineNumber|0;if(P===E){let _=S.column|0,C=y.column|0;return _-C}return P-E}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new f(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=f}),define(Ee[31],_e([0,1,38]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,P,E,_){y>E||y===E&&P>_?(this.startLineNumber=E,this.startColumn=_,this.endLineNumber=y,this.endColumn=P):(this.startLineNumber=y,this.startColumn=P,this.endLineNumber=E,this.endColumn=_)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,P){return!(P.lineNumber<y.startLineNumber||P.lineNumber>y.endLineNumber||P.lineNumber===y.startLineNumber&&P.column<y.startColumn||P.lineNumber===y.endLineNumber&&P.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,P){return!(P.startLineNumber<y.startLineNumber||P.endLineNumber<y.startLineNumber||P.startLineNumber>y.endLineNumber||P.endLineNumber>y.endLineNumber||P.startLineNumber===y.startLineNumber&&P.startColumn<y.startColumn||P.endLineNumber===y.endLineNumber&&P.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,P){return!(P.startLineNumber<y.startLineNumber||P.endLineNumber<y.startLineNumber||P.startLineNumber>y.endLineNumber||P.endLineNumber>y.endLineNumber||P.startLineNumber===y.startLineNumber&&P.startColumn<=y.startColumn||P.endLineNumber===y.endLineNumber&&P.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,P){let E,_,C,n;return P.startLineNumber<y.startLineNumber?(E=P.startLineNumber,_=P.startColumn):P.startLineNumber===y.startLineNumber?(E=P.startLineNumber,_=Math.min(P.startColumn,y.startColumn)):(E=y.startLineNumber,_=y.startColumn),P.endLineNumber>y.endLineNumber?(C=P.endLineNumber,n=P.endColumn):P.endLineNumber===y.endLineNumber?(C=P.endLineNumber,n=Math.max(P.endColumn,y.endColumn)):(C=y.endLineNumber,n=y.endColumn),new R(E,_,C,n)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,P){let E=y.startLineNumber,_=y.startColumn,C=y.endLineNumber,n=y.endColumn,T=P.startLineNumber,l=P.startColumn,h=P.endLineNumber,u=P.endColumn;return E<T?(E=T,_=l):E===T&&(_=Math.max(_,l)),C>h?(C=h,n=u):C===h&&(n=Math.min(n,u)),E>C||E===C&&_>n?null:new R(E,_,C,n)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,P){return!!y&&!!P&&y.startLineNumber===P.startLineNumber&&y.startColumn===P.startColumn&&y.endLineNumber===P.endLineNumber&&y.endColumn===P.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new f.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new f.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,P){return new R(this.startLineNumber,this.startColumn,y,P)}setStartPosition(y,P){return new R(y,P,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,P=y){return new R(y.lineNumber,y.column,P.lineNumber,P.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,P){return!(y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn||P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn)}static areIntersecting(y,P){return!(y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn||P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,P){if(y&&P){const C=y.startLineNumber|0,n=P.startLineNumber|0;if(C===n){const T=y.startColumn|0,l=P.startColumn|0;if(T===l){const h=y.endLineNumber|0,u=P.endLineNumber|0;if(h===u){const g=y.endColumn|0,b=P.endColumn|0;return g-b}return h-u}return T-l}return C-n}return(y?1:0)-(P?1:0)}static compareRangesUsingEnds(y,P){return y.endLineNumber===P.endLineNumber?y.endColumn===P.endColumn?y.startLineNumber===P.startLineNumber?y.startColumn-P.startColumn:y.startLineNumber-P.startLineNumber:y.endColumn-P.endColumn:y.endLineNumber-P.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(Ee[119],_e([0,1,38,31]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(E,_,C,n){super(E,_,C,n);this.selectionStartLineNumber=E,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(E){return y.selectionsEqual(this,E)}static selectionsEqual(E,_){return E.selectionStartLineNumber===_.selectionStartLineNumber&&E.selectionStartColumn===_.selectionStartColumn&&E.positionLineNumber===_.positionLineNumber&&E.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(E,_){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,E,_):new y(E,_,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(E,_){return this.getDirection()===0?new y(E,_,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,E,_)}static fromPositions(E,_=E){return new y(E.lineNumber,E.column,_.lineNumber,_.column)}static liftSelection(E){return new y(E.selectionStartLineNumber,E.selectionStartColumn,E.positionLineNumber,E.positionColumn)}static selectionsArrEqual(E,_){if(E&&!_||!E&&_)return!1;if(!E&&!_)return!0;if(E.length!==_.length)return!1;for(let C=0,n=E.length;C<n;C++)if(!this.selectionsEqual(E[C],_[C]))return!1;return!0}static isISelection(E){return E&&typeof E.selectionStartLineNumber=="number"&&typeof E.selectionStartColumn=="number"&&typeof E.positionLineNumber=="number"&&typeof E.positionColumn=="number"}static createWithDirection(E,_,C,n,T){return T===0?new y(E,_,C,n):new y(C,n,E,_)}}e.Selection=y}),define(Ee[87],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var f;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(f=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var P;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(P=e.EndOfLineSequence||(e.EndOfLineSequence={}));class E{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace)}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=E;class _{constructor(g,b){this._findMatchBrand=void 0,this.range=g,this.matches=b}}e.FindMatch=_;var C;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var T;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class l{constructor(g,b,w,A,o,m){this.identifier=g,this.range=b,this.text=w,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=o,this._isTracked=m}}e.ValidAnnotatedEditOperation=l;class h{constructor(g,b,w){this.reverseEdits=g,this.changes=b,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=h}),define(Ee[120],_e([0,1,8,118,38,31,87]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const E=999;class _{constructor(o,m,v,t){this.searchString=o,this.isRegex=m,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=C(this.searchString):o=this.searchString.indexOf(`
`)>=0;let m=null;try{m=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(t){return null}if(!m)return null;let v=!this.isRegex&&!o;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(m,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=_;function C(A){if(!A||A.length===0)return!1;for(let o=0,m=A.length;o<m;o++)if(A.charCodeAt(o)===92){if(o++,o>=m)break;const t=A.charCodeAt(o);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(o,m,v){this.regex=o,this.wordSeparators=m,this.simpleSearch=v}}e.SearchData=n;function T(A,o,m){if(!m)return new P.FindMatch(A,null);let v=[];for(let t=0,r=o.length;t<r;t++)v[t]=o[t];return new P.FindMatch(A,v)}e.createFindMatch=T;class l{constructor(o){let m=[],v=0;for(let t=0,r=o.length;t<r;t++)o.charCodeAt(t)===10&&(m[v++]=t);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(o){const m=this._lineFeedsOffsets;let v=0,t=m.length-1;if(t===-1||o<=m[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);m[r]>=o?t=r-1:m[r+1]>=o?(v=r,t=r):v=r+1}return v+1}}class h{static findMatches(o,m,v,t,r){const a=m.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(o,v,new w(a.wordSeparators,a.regex),t,r):this._doFindMatchesLineByLine(o,v,a,t,r):[]}static _getMultilineMatchRange(o,m,v,t,r,a){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(r),i=m+r+c):i=m+r;let p;if(t){let s=t.findLineFeedCountBeforeOffset(r+a.length)-c;p=i+a.length+s}else p=i+a.length;const d=o.getPositionAt(i),D=o.getPositionAt(p);return new y.Range(d.lineNumber,d.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(o,m,v,t,r){const a=o.getOffsetAt(m.getStartPosition()),i=o.getValueInRange(m,1),c=o.getEOL()===`\r
`?new l(i):null,p=[];let d=0,D;for(v.reset(0);D=v.next(i);)if(p[d++]=T(this._getMultilineMatchRange(o,a,i,c,D.index,D[0]),D,t),d>=r)return p;return p}static _doFindMatchesLineByLine(o,m,v,t,r){const a=[];let i=0;if(m.startLineNumber===m.endLineNumber){const p=o.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return i=this._findMatchesInLine(v,p,m.startLineNumber,m.startColumn-1,i,a,t,r),a}const c=o.getLineContent(m.startLineNumber).substring(m.startColumn-1);i=this._findMatchesInLine(v,c,m.startLineNumber,m.startColumn-1,i,a,t,r);for(let p=m.startLineNumber+1;p<m.endLineNumber&&i<r;p++)i=this._findMatchesInLine(v,o.getLineContent(p),p,0,i,a,t,r);if(i<r){const p=o.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);i=this._findMatchesInLine(v,p,m.endLineNumber,0,i,a,t,r)}return a}static _findMatchesInLine(o,m,v,t,r,a,i,c){const p=o.wordSeparators;if(!i&&o.simpleSearch){const I=o.simpleSearch,s=I.length,k=m.length;let F=-s;for(;(F=m.indexOf(I,F+s))!==-1;)if((!p||b(p,m,k,F,s))&&(a[r++]=new P.FindMatch(new y.Range(v,F+1+t,v,F+1+s+t),null),r>=c))return r;return r}const d=new w(o.wordSeparators,o.regex);let D;d.reset(0);do if(D=d.next(m),D&&(a[r++]=T(new y.Range(v,D.index+1+t,v,D.index+1+D[0].length+t),D,i),r>=c))return r;while(D);return r}static findNextMatch(o,m,v,t){const r=m.parseSearchRequest();if(!r)return null;const a=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(o,v,a,t):this._doFindNextMatchLineByLine(o,v,a,t)}static _doFindNextMatchMultiline(o,m,v,t){const r=new S.Position(m.lineNumber,1),a=o.getOffsetAt(r),i=o.getLineCount(),c=o.getValueInRange(new y.Range(r.lineNumber,r.column,i,o.getLineMaxColumn(i)),1),p=o.getEOL()===`\r
`?new l(c):null;v.reset(m.column-1);let d=v.next(c);return d?T(this._getMultilineMatchRange(o,a,c,p,d.index,d[0]),d,t):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(o,new S.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(o,m,v,t){const r=o.getLineCount(),a=m.lineNumber,i=o.getLineContent(a),c=this._findFirstMatchInLine(v,i,a,m.column,t);if(c)return c;for(let p=1;p<=r;p++){const d=(a+p-1)%r,D=o.getLineContent(d+1),I=this._findFirstMatchInLine(v,D,d+1,1,t);if(I)return I}return null}static _findFirstMatchInLine(o,m,v,t,r){o.reset(t-1);const a=o.next(m);return a?T(new y.Range(v,a.index+1,v,a.index+1+a[0].length),a,r):null}static findPreviousMatch(o,m,v,t){const r=m.parseSearchRequest();if(!r)return null;const a=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(o,v,a,t):this._doFindPreviousMatchLineByLine(o,v,a,t)}static _doFindPreviousMatchMultiline(o,m,v,t){const r=this._doFindMatchesMultiline(o,new y.Range(1,1,m.lineNumber,m.column),v,t,10*E);if(r.length>0)return r[r.length-1];const a=o.getLineCount();return m.lineNumber!==a||m.column!==o.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(o,new S.Position(a,o.getLineMaxColumn(a)),v,t):null}static _doFindPreviousMatchLineByLine(o,m,v,t){const r=o.getLineCount(),a=m.lineNumber,i=o.getLineContent(a).substring(0,m.column-1),c=this._findLastMatchInLine(v,i,a,t);if(c)return c;for(let p=1;p<=r;p++){const d=(r+a-p-1)%r,D=o.getLineContent(d+1),I=this._findLastMatchInLine(v,D,d+1,t);if(I)return I}return null}static _findLastMatchInLine(o,m,v,t){let r=null,a;for(o.reset(0);a=o.next(m);)r=T(new y.Range(v,a.index+1,v,a.index+1+a[0].length),a,t);return r}}e.TextModelSearch=h;function u(A,o,m,v,t){if(v===0)return!0;const r=o.charCodeAt(v-1);if(A.get(r)!==0||r===13||r===10)return!0;if(t>0){const a=o.charCodeAt(v);if(A.get(a)!==0)return!0}return!1}function g(A,o,m,v,t){if(v+t===m)return!0;const r=o.charCodeAt(v+t);if(A.get(r)!==0||r===13||r===10)return!0;if(t>0){const a=o.charCodeAt(v+t-1);if(A.get(a)!==0)return!0}return!1}function b(A,o,m,v,t){return u(A,o,m,v,t)&&g(A,o,m,v,t)}e.isValidMatch=b;class w{constructor(o,m){this._wordSeparators=o,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const m=o.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(v=this._searchRegex.exec(o),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){f.getNextCodePoint(o,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||b(this._wordSeparators,o,m,t,r))return v}while(v);return null}}e.Searcher=w}),define(Ee[88],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(E=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)E.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=f();function R(E){let _=e.DEFAULT_WORD_REGEXP;if(E&&E instanceof RegExp)if(E.global)_=E;else{let C="g";E.ignoreCase&&(C+="i"),E.multiline&&(C+="m"),E.unicode&&(C+="u"),_=new RegExp(E.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=R;const S={maxLen:1e3,windowSize:15,timeBudget:150};function y(E,_,C,n,T=S){if(C.length>T.maxLen){let b=E-T.maxLen/2;return b<0?b=0:n+=b,C=C.substring(b,E+T.maxLen/2),y(E,_,C,n,T)}const l=Date.now(),h=E-1-n;let u=-1,g=null;for(let b=1;!(Date.now()-l>=T.timeBudget);b++){const w=h-T.windowSize*b;_.lastIndex=Math.max(0,w);const A=P(_,C,h,u);if(!A&&g||(g=A,w<=0))break;u=w}if(g){let b={word:g[0],startColumn:n+1+g.index,endColumn:n+1+g.index+g[0].length};return _.lastIndex=0,b}return null}e.getWordAtText=y;function P(E,_,C,n){let T;for(;T=E.exec(_);){const l=T.index||0;if(l<=C&&E.lastIndex>=C)return T;if(n>0&&l>n)return null}return null}}),define(Ee[121],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class R{constructor(E){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=E.open,this.close=E.close,this._standardTokenMask=0,Array.isArray(E.notIn))for(let _=0,C=E.notIn.length;_<C;_++)switch(E.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(E){return(this._standardTokenMask&E)==0}}e.StandardAutoClosingPairConditional=R;class S{constructor(E){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of E)y(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),y(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),y(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),y(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&y(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=S;function y(P,E,_){P.has(E)?P.get(E).push(_):P.set(E,[_])}}),define(Ee[58],_e([0,1,27,14]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(y,P,E,_){if(Array.isArray(y)){let C=0;for(const n of y){const T=S(n,P,E,_);if(T===10)return T;T>C&&(C=T)}return C}else{if(typeof y=="string")return _?y==="*"?5:y===E?10:0:0;if(y){const{language:C,pattern:n,scheme:T,hasAccessToAllModels:l}=y;if(!_&&!l)return 0;let h=0;if(T)if(T===P.scheme)h=10;else if(T==="*")h=5;else return 0;if(C)if(C===E)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,R.normalize)(n.base)},u===P.fsPath||(0,f.match)(u,P.fsPath))h=10;else return 0}return h}else return 0}}e.score=S}),define(Ee[122],_e([0,1,86]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class S{constructor(u,g,b){const w=new Uint8Array(u*g);for(let A=0,o=u*g;A<o;A++)w[A]=b;this._data=w,this.rows=u,this.cols=g}get(u,g){return this._data[u*this.cols+g]}set(u,g,b){this._data[u*this.cols+g]=b}}e.Uint8Matrix=S;class y{constructor(u){let g=0,b=0;for(let A=0,o=u.length;A<o;A++){let[m,v,t]=u[A];v>g&&(g=v),m>b&&(b=m),t>b&&(b=t)}g++,b++;let w=new S(b,g,0);for(let A=0,o=u.length;A<o;A++){let[m,v,t]=u[A];w.set(m,v,t)}this._states=w,this._maxCharCode=g}nextState(u,g){return g<0||g>=this._maxCharCode?0:this._states.get(u,g)}}e.StateMachine=y;let P=null;function E(){return P===null&&(P=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var _;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function n(){if(C===null){C=new f.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<h.length;g++)C.set(h.charCodeAt(g),1);const u=".,;";for(let g=0;g<u.length;g++)C.set(u.charCodeAt(g),2)}return C}class T{static _createLink(u,g,b,w,A){let o=A-1;do{const m=g.charCodeAt(o);if(u.get(m)!==2)break;o--}while(o>w);if(w>0){const m=g.charCodeAt(w-1),v=g.charCodeAt(o);(m===40&&v===41||m===91&&v===93||m===123&&v===125)&&o--}return{range:{startLineNumber:b,startColumn:w+1,endLineNumber:b,endColumn:o+2},url:g.substring(w,o+1)}}static computeLinks(u,g=E()){const b=n();let w=[];for(let A=1,o=u.getLineCount();A<=o;A++){const m=u.getLineContent(A),v=m.length;let t=0,r=0,a=0,i=1,c=!1,p=!1,d=!1,D=!1;for(;t<v;){let I=!1;const s=m.charCodeAt(t);if(i===13){let k;switch(s){case 40:c=!0,k=0;break;case 41:k=c?0:1;break;case 91:d=!0,p=!0,k=0;break;case 93:d=!1,k=p?0:1;break;case 123:D=!0,k=0;break;case 125:k=D?0:1;break;case 39:k=a===34||a===96?0:1;break;case 34:k=a===39||a===96?0:1;break;case 96:k=a===39||a===34?0:1;break;case 42:k=a===42?1:0;break;case 124:k=a===124?1:0;break;case 32:k=d?0:1;break;default:k=b.get(s)}k===1&&(w.push(T._createLink(b,m,A,r,t)),I=!0)}else if(i===12){let k;s===91?(p=!0,k=0):k=b.get(s),k===1?I=!0:i=13}else i=g.nextState(i,s),i===0&&(I=!0);I&&(i=1,c=!1,p=!1,D=!1,r=t+1,a=s),t++}i===13&&w.push(T._createLink(b,m,A,r,v))}return w}}e.LinkComputer=T;function l(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:T.computeLinks(h)}e.computeLinks=l}),define(Ee[123],_e([0,1,3,6]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,E){return this._map.set(P,E),this.fire([P]),(0,R.toDisposable)(()=>{this._map.get(P)===E&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,E){let _=null,C=!1;return this._promises.set(P,E.then(n=>{this._promises.delete(P),!(C||!n)&&(_=this.register(P,n))})),(0,R.toDisposable)(()=>{C=!0,_&&_.dispose()})}getPromise(P){const E=this.get(P);if(E)return Promise.resolve(E);const _=this._promises.get(P);return _?_.then(C=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(Ee[89],_e([0,1,24,22]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(S||(S={}));function y(T){for(let l=0,h=T.length;l<h;l+=4){const u=T[l+0],g=T[l+1],b=T[l+2],w=T[l+3];T[l+0]=w,T[l+1]=b,T[l+2]=g,T[l+3]=u}}function P(T){const l=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return R.isLittleEndian()||y(l),f.VSBuffer.wrap(l)}function E(T){const l=T.buffer;if(R.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const h=new Uint8Array(l.byteLength);return h.set(l),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function _(T){const l=new Uint32Array(C(T));let h=0;if(l[h++]=T.id,T.type==="full")l[h++]=1,l[h++]=T.data.length,l.set(T.data,h),h+=T.data.length;else{l[h++]=2,l[h++]=T.deltas.length;for(const u of T.deltas)l[h++]=u.start,l[h++]=u.deleteCount,u.data?(l[h++]=u.data.length,l.set(u.data,h),h+=u.data.length):l[h++]=0}return P(l)}e.encodeSemanticTokensDto=_;function C(T){let l=0;if(l+=1+1,T.type==="full")l+=1+T.data.length;else{l+=1,l+=(1+1+1)*T.deltas.length;for(const h of T.deltas)h.data&&(l+=h.data.length)}return l}function n(T){const l=E(T);let h=0;const u=l[h++];if(l[h++]===1){const A=l[h++],o=l.subarray(h,h+A);return h+=A,{id:u,type:"full",data:o}}const b=l[h++];let w=[];for(let A=0;A<b;A++){const o=l[h++],m=l[h++],v=l[h++];let t;v>0&&(t=l.subarray(h,h+v),h+=v),w[A]={start:o,deleteCount:m,data:t}}return{id:u,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(Ee[90],_e([0,1,82]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(P,E){this._prefixSumIndexOfResultBrand=void 0,this.index=P,this.remainder=E}}e.PrefixSumIndexOfResult=R;class S{constructor(P){this.values=P,this.prefixSum=new Uint32Array(P.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(P,E){P=(0,f.toUint32)(P);const _=this.values,C=this.prefixSum,n=E.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,P),0),this.values.set(_.subarray(P),P+n),this.values.set(E,P),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(P,E){return P=(0,f.toUint32)(P),E=(0,f.toUint32)(E),this.values[P]===E?!1:(this.values[P]=E,P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),!0)}removeValues(P,E){P=(0,f.toUint32)(P),E=(0,f.toUint32)(E);const _=this.values,C=this.prefixSum;if(P>=_.length)return!1;let n=_.length-P;return E>=n&&(E=n),E===0?!1:(this.values=new Uint32Array(_.length-E),this.values.set(_.subarray(0,P),0),this.values.set(_.subarray(P+E),P),this.prefixSum=new Uint32Array(this.values.length),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(P){return P<0?0:(P=(0,f.toUint32)(P),this._getPrefixSum(P))}_getPrefixSum(P){if(P<=this.prefixSumValidIndex[0])return this.prefixSum[P];let E=this.prefixSumValidIndex[0]+1;E===0&&(this.prefixSum[0]=this.values[0],E++),P>=this.values.length&&(P=this.values.length-1);for(let _=E;_<=P;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],P),this.prefixSum[P]}getIndexOf(P){P=Math.floor(P),this.getTotalSum();let E=0,_=this.values.length-1,C=0,n=0,T=0;for(;E<=_;)if(C=E+(_-E)/2|0,n=this.prefixSum[C],T=n-this.values[C],P<T)_=C-1;else if(P>=n)E=C+1;else break;return new R(C,P-T)}}e.PrefixSumComputer=S}),define(Ee[124],_e([0,1,8,38,90]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(E,_,C,n){this._uri=E,this._lines=_,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(E){E.eol&&E.eol!==this._eol&&(this._eol=E.eol,this._lineStarts=null);const _=E.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new R.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=E.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const E=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let n=0;n<_;n++)C[n]=this._lines[n].length+E;this._lineStarts=new S.PrefixSumComputer(C)}}_setLineText(E,_){this._lines[E]=_,this._lineStarts&&this._lineStarts.changeValue(E,this._lines[E].length+this._eol.length)}_acceptDeleteRange(E){if(E.startLineNumber===E.endLineNumber){if(E.startColumn===E.endColumn)return;this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.startLineNumber-1].substring(E.endColumn-1));return}this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.endLineNumber-1].substring(E.endColumn-1)),this._lines.splice(E.startLineNumber,E.endLineNumber-E.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(E.startLineNumber,E.endLineNumber-E.startLineNumber)}_acceptInsertText(E,_){if(_.length===0)return;let C=(0,f.splitLines)(_);if(C.length===1){this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+C[0]+this._lines[E.lineNumber-1].substring(E.column-1));return}C[C.length-1]+=this._lines[E.lineNumber-1].substring(E.column-1),this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let T=1;T<C.length;T++)this._lines.splice(E.lineNumber+T-1,0,C[T]),n[T-1]=C[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(E.lineNumber,n)}}e.MirrorTextModel=y}),define(Ee[125],_e([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(Ee[59],_e([0,1,17,10,125]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,n){return n&&(C.stack||C.stacktrace)?S.localize(0,null,E(C),P(C.stack)||P(C.stacktrace)):E(C)}function P(C){return Array.isArray(C)?C.join(`
`):C}function E(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?S.localize(1,null,C.message):C.message||S.localize(2,null)}function _(C=null,n=!1){if(!C)return S.localize(3,null);if(Array.isArray(C)){const T=f.coalesce(C),l=_(T[0],n);return T.length>1?S.localize(4,null,l,T.length):l}if(R.isString(C))return C;if(C.detail){const T=C.detail;if(T.error)return y(T.error,n);if(T.exception)return y(T.exception,n)}return C.stack?y(C,n):C.message?C.message:S.localize(5,null)}e.toErrorMessage=_}),define(Ee[126],_e([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(Ee[127],_e([0,1,126,22,88]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=P;class E{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,de){this._values[X]=de}}e.ValidatedEditorOptions=E;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(X,de,Ue,xe){this.id=X,this.name=de,this.defaultValue=Ue,this.schema=xe}compute(X,de,Ue){return Ue}}class n{constructor(X,de=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=de}validate(X){return this.defaultValue}}class T{constructor(X,de,Ue,xe){this.id=X,this.name=de,this.defaultValue=Ue,this.schema=xe}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,de,Ue){return Ue}}function l(z,X){return typeof z=="undefined"?X:z==="false"?!1:Boolean(z)}e.boolean=l;class h extends T{constructor(X,de,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Ue),super(X,de,Ue,xe)}validate(X){return l(X,this.defaultValue)}}class u extends T{constructor(X,de,Ue,xe,et,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=Ue,Ce.minimum=xe,Ce.maximum=et),super(X,de,Ue,Ce),this.minimum=xe,this.maximum=et}static clampedInt(X,de,Ue,xe){if(typeof X=="undefined")return de;let et=parseInt(X,10);return isNaN(et)?de:(et=Math.max(Ue,et),et=Math.min(xe,et),et|0)}validate(X){return u.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class g extends T{constructor(X,de,Ue,xe,et){typeof et!="undefined"&&(et.type="number",et.default=Ue),super(X,de,Ue,et),this.validationFn=xe}static clamp(X,de,Ue){return X<de?de:X>Ue?Ue:X}static float(X,de){if(typeof X=="number")return X;if(typeof X=="undefined")return de;const Ue=parseFloat(X);return isNaN(Ue)?de:Ue}validate(X){return this.validationFn(g.float(X,this.defaultValue))}}class b extends T{static string(X,de){return typeof X!="string"?de:X}constructor(X,de,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Ue),super(X,de,Ue,xe)}validate(X){return b.string(X,this.defaultValue)}}function w(z,X,de){return typeof z!="string"||de.indexOf(z)===-1?X:z}e.stringSet=w;class A extends T{constructor(X,de,Ue,xe,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=xe,et.default=Ue),super(X,de,Ue,et),this._allowedValues=xe}validate(X){return w(X,this.defaultValue,this._allowedValues)}}class o extends C{constructor(X,de,Ue,xe,et,Ce,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=et,De.default=xe),super(X,de,Ue,De),this._allowedValues=et,this._convert=Ce}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function m(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,de,Ue){return Ue===0?X.accessibilitySupport:Ue}}class t extends C{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:f.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{insertSpace:l(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(z){switch(z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function p(z){switch(z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class d extends n{constructor(){super(126,[64,31])}compute(X,de,Ue){const xe=["monaco-editor"];return de.get(31)&&xe.push(de.get(31)),X.extraEditorClassName&&xe.push(X.extraEditorClassName),de.get(64)==="default"?xe.push("mouse-default"):de.get(64)==="copy"&&xe.push("mouse-copy"),de.get(99)&&xe.push("showUnused"),de.get(124)&&xe.push("showDeprecated"),xe.join(" ")}}class D extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(X,de,Ue){return Ue&&X.emptySelectionClipboard}}class I extends C{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:f.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:f.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{cursorMoveOnType:l(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":w(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":w(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(de.loop,this.defaultValue.loop)}}}class s extends C{constructor(){super(42,"fontLigatures",s.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?s.OFF:X==="true"?s.ON:X:Boolean(X)?s.ON:s.OFF}}e.EditorFontLigatures=s,s.OFF='"liga" off, "calt" off',s.ON='"liga" on, "calt" on';class k extends n{constructor(){super(41)}compute(X,de,Ue){return X.fontInfo}}class F extends T{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(X){let de=g.float(X,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(de,6,100)}compute(X,de,Ue){return X.fontInfo.fontSize}}class x extends C{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(u.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class j extends C{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...de},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...de},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...de},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:f.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{multiple:w(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??w(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??w(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??w(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??w(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??w(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class oe extends C{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(51,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:f.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),delay:u.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:l(de.sticky,this.defaultValue.sticky)}}}var se;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(se=e.RenderMinimap||(e.RenderMinimap={}));class V extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(X,de,Ue){return V.computeLayout(de,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const de=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?de-1:0,xe=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),et=Math.floor(X.viewLineCount/xe);return{typicalViewportLineCount:de,extraLinesBeyondLastLine:Ue,desiredRatio:xe,minimapLineCount:et}}static _computeMinimapLayout(X,de){const Ue=X.outerWidth,xe=X.outerHeight,et=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Ce=de.stableMinimapLayoutInput,De=Ce&&X.outerHeight===Ce.outerHeight&&X.lineHeight===Ce.lineHeight&&X.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ce.pixelRatio&&X.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&X.minimap.enabled===Ce.minimap.enabled&&X.minimap.side===Ce.minimap.side&&X.minimap.size===Ce.minimap.size&&X.minimap.showSlider===Ce.minimap.showSlider&&X.minimap.renderCharacters===Ce.minimap.renderCharacters&&X.minimap.maxColumn===Ce.minimap.maxColumn&&X.minimap.scale===Ce.minimap.scale&&X.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&X.isViewportWrapping===Ce.isViewportWrapping,Pe=X.lineHeight,re=X.typicalHalfwidthCharacterWidth,ae=X.scrollBeyondLastLine,me=X.minimap.renderCharacters;let ve=et>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const B=X.minimap.maxColumn,ge=X.minimap.size,be=X.minimap.side,Ie=X.verticalScrollbarWidth,Oe=X.viewLineCount,He=X.remainingWidth,Ze=X.isViewportWrapping,Ke=me?2:3;let Qe=Math.floor(et*xe);const lt=Qe/et;let ht=!1,Et=!1,ot=Ke*ve,at=ve/et,Dt=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:je,desiredRatio:gt,minimapLineCount:bt}=V.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ae,height:xe,lineHeight:Pe,pixelRatio:et});if(Oe/bt>1)ht=!0,Et=!0,ve=1,ot=1,at=ve/et;else{let ft=!1,ct=ve+1;if(ge==="fit"){const mt=Math.ceil((Oe+je)*ot);Ze&&De&&He<=de.stableFitRemainingWidth?(ft=!0,ct=de.stableFitMaxMinimapScale):ft=mt>Qe}if(ge==="fill"||ft){ht=!0;const mt=ve;ot=Math.min(Pe*et,Math.max(1,Math.floor(1/gt))),Ze&&De&&He<=de.stableFitRemainingWidth&&(ct=de.stableFitMaxMinimapScale),ve=Math.min(ct,Math.max(1,Math.floor(ot/Ke))),ve>mt&&(Dt=Math.min(2,ve/mt)),at=ve/et/Dt,Qe=Math.ceil(Math.max(tt,Oe+je)*ot),Ze?(de.stableMinimapLayoutInput=X,de.stableFitRemainingWidth=He,de.stableFitMaxMinimapScale=ve):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const ye=Math.floor(B*at),ce=Math.min(ye,Math.max(0,Math.floor((He-Ie-2)*at/(re+at)))+e.MINIMAP_GUTTER_WIDTH);let le=Math.floor(et*ce);const $=le/et;le=Math.floor(le*Dt);const Ae=me?1:2,Ne=be==="left"?0:Ue-ce-Ie;return{renderMinimap:Ae,minimapLeft:Ne,minimapWidth:ce,minimapHeightIsEditorHeight:ht,minimapIsSampling:Et,minimapScale:ve,minimapLineHeight:ot,minimapCanvasInnerWidth:le,minimapCanvasInnerHeight:Qe,minimapCanvasOuterWidth:$,minimapCanvasOuterHeight:lt}}static computeLayout(X,de){const Ue=de.outerWidth|0,xe=de.outerHeight|0,et=de.lineHeight|0,Ce=de.lineNumbersDigitCount|0,De=de.typicalHalfwidthCharacterWidth,Pe=de.maxDigitWidth,re=de.pixelRatio,ae=de.viewLineCount,me=X.get(121),ve=me==="inherit"?X.get(120):me,B=ve==="inherit"?X.get(116):ve,ge=X.get(119),be=X.get(2),Ie=de.isDominatedByLongLines,Oe=X.get(47),He=X.get(58).renderType!==0,Ze=X.get(59),Ke=X.get(93),Qe=X.get(63),lt=X.get(91),ht=lt.verticalScrollbarSize,Et=lt.verticalHasArrows,ot=lt.arrowSize,at=lt.horizontalScrollbarSize,Dt=X.get(56),ye=X.get(35);let ce;if(typeof Dt=="string"&&/^\d+(\.\d+)?ch$/.test(Dt)){const It=parseFloat(Dt.substr(0,Dt.length-2));ce=u.clampedInt(It*De,0,0,1e3)}else ce=u.clampedInt(Dt,0,0,1e3);ye&&(ce+=16);let le=0;if(He){const It=Math.max(Ce,Ze);le=Math.round(It*Pe)}let $=0;Oe&&($=et);let Ae=0,Ne=Ae+$,tt=Ne+le,je=tt+ce;const gt=Ue-$-le-ce;let bt=!1,kt=!1,ft=-1;be!==2&&(ve==="inherit"&&Ie?(bt=!0,kt=!0):B==="on"||B==="bounded"?kt=!0:B==="wordWrapColumn"&&(ft=ge));const ct=V._computeMinimapLayout({outerWidth:Ue,outerHeight:xe,lineHeight:et,typicalHalfwidthCharacterWidth:De,pixelRatio:re,scrollBeyondLastLine:Ke,minimap:Qe,verticalScrollbarWidth:ht,viewLineCount:ae,remainingWidth:gt,isViewportWrapping:kt},de.memory||new _);ct.renderMinimap!==0&&ct.minimapLeft===0&&(Ae+=ct.minimapWidth,Ne+=ct.minimapWidth,tt+=ct.minimapWidth,je+=ct.minimapWidth);const mt=gt-ct.minimapWidth,_t=Math.max(1,Math.floor((mt-ht-2)/De)),Tt=Et?ot:0;return kt&&(ft=Math.max(1,_t),B==="bounded"&&(ft=Math.min(ft,ge))),{width:Ue,height:xe,glyphMarginLeft:Ae,glyphMarginWidth:$,lineNumbersLeft:Ne,lineNumbersWidth:le,decorationsLeft:tt,decorationsWidth:ce,contentLeft:je,contentWidth:mt,minimap:ct,viewportColumn:_t,isWordWrapMinified:bt,isViewportWrapping:kt,wrappingColumn:ft,verticalScrollbarWidth:ht,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:ht,height:xe-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=V;class H extends C{constructor(){const X={enabled:!0};super(55,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:f.localize(42,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:l(X.enabled,this.defaultValue.enabled)}}}class M extends C{constructor(){const X={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",X,{"editor.inlayHints.enabled":{type:"boolean",default:X.enabled,description:f.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:f.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,description:f.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(de.fontFamily,this.defaultValue.fontFamily)}}}class Q extends g{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>g.clamp(X,0,150),{markdownDescription:f.localize(46,null)})}compute(X,de,Ue){return X.fontInfo.lineHeight}}class O extends C{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:f.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(48,null),f.localize(49,null),f.localize(50,null)],default:X.size,description:f.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:f.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:f.localize(53,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:f.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:f.localize(56,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),size:w(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(de.side,this.defaultValue.side,["right","left"]),showSlider:w(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(de.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(de.scale,1,1,3),maxColumn:u.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(z){return z==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends C{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{top:u.clampedInt(de.top,0,0,1e3),bottom:u.clampedInt(de.bottom,0,0,1e3)}}}class W extends C{constructor(){const X={enabled:!0,cycle:!1};super(74,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:f.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:f.localize(60,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),cycle:l(de.cycle,this.defaultValue.cycle)}}}class te extends n{constructor(){super(127)}compute(X,de,Ue){return X.pixelRatio}}class he extends C{constructor(){const X={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:f.localize(61,null)},comments:{type:"boolean",default:X.comments,description:f.localize(62,null)},other:{type:"boolean",default:X.other,description:f.localize(63,null)}}}],default:X,description:f.localize(64,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const de=X,Ue={other:l(de.other,this.defaultValue.other),comments:l(de.comments,this.defaultValue.comments),strings:l(de.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Se;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Le extends C{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(65,null),f.localize(66,null),f.localize(67,null),f.localize(68,null)],default:"on",description:f.localize(69,null)})}validate(X){let de=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(de=4,Ue=X):X==="interval"?de=3:X==="relative"?de=2:X==="on"?de=1:de=0),{renderType:de,renderFn:Ue}}}function Me(z){const X=z.get(86);return X==="editable"?z.get(79):X!=="on"}e.filterValidationDecorations=Me;class $e extends C{constructor(){const X=[],de={type:"number",description:f.localize(70,null)};super(90,"rulers",X,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:f.localize(71,null),format:"color-hex"}}}]},default:X,description:f.localize(72,null)})}validate(X){if(Array.isArray(X)){let de=[];for(let Ue of X)if(typeof Ue=="number")de.push({column:u.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const xe=Ue;de.push({column:u.clampedInt(xe.column,0,0,1e4),color:xe.color})}return de.sort((Ue,xe)=>Ue.column-xe.column),de}return this.defaultValue}}function Xe(z,X){if(typeof z!="string")return X;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends C{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(73,null),f.localize(74,null),f.localize(75,null)],default:"auto",description:f.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(77,null),f.localize(78,null),f.localize(79,null)],default:"auto",description:f.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:f.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:f.localize(83,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X,Ue=u.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=u.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Xe(de.vertical,this.defaultValue.vertical),horizontal:Xe(de.horizontal,this.defaultValue.horizontal),useShadows:l(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:u.clampedInt(de.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:u.clampedInt(de.verticalSliderSize,xe,0,1e3),scrollByPage:l(de.scrollByPage,this.defaultValue.scrollByPage)}}}class Ge extends C{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(53,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:f.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[f.localize(85,null),f.localize(86,null),f.localize(87,null)],default:X.mode,description:f.localize(88,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),mode:w(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class U extends C{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(89,null),f.localize(90,null)],default:X.insertMode,description:f.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:f.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:f.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:f.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:f.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:f.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:f.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:f.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[f.localize(99,null),f.localize(100,null),f.localize(101,null)],default:X.previewMode,description:f.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:f.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{insertMode:w(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(de.showIcons,this.defaultValue.showIcons),showStatusBar:l(de.showStatusBar,this.defaultValue.showStatusBar),preview:l(de.preview,this.defaultValue.preview),previewMode:w(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(de.showMethods,this.defaultValue.showMethods),showFunctions:l(de.showFunctions,this.defaultValue.showFunctions),showConstructors:l(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(de.showDeprecated,this.defaultValue.showDeprecated),showFields:l(de.showFields,this.defaultValue.showFields),showVariables:l(de.showVariables,this.defaultValue.showVariables),showClasses:l(de.showClasses,this.defaultValue.showClasses),showStructs:l(de.showStructs,this.defaultValue.showStructs),showInterfaces:l(de.showInterfaces,this.defaultValue.showInterfaces),showModules:l(de.showModules,this.defaultValue.showModules),showProperties:l(de.showProperties,this.defaultValue.showProperties),showEvents:l(de.showEvents,this.defaultValue.showEvents),showOperators:l(de.showOperators,this.defaultValue.showOperators),showUnits:l(de.showUnits,this.defaultValue.showUnits),showValues:l(de.showValues,this.defaultValue.showValues),showConstants:l(de.showConstants,this.defaultValue.showConstants),showEnums:l(de.showEnums,this.defaultValue.showEnums),showEnumMembers:l(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(de.showKeywords,this.defaultValue.showKeywords),showWords:l(de.showWords,this.defaultValue.showWords),showColors:l(de.showColors,this.defaultValue.showColors),showFiles:l(de.showFiles,this.defaultValue.showFiles),showReferences:l(de.showReferences,this.defaultValue.showReferences),showFolders:l(de.showFolders,this.defaultValue.showFolders),showTypeParameters:l(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(de.showSnippets,this.defaultValue.showSnippets),showUsers:l(de.showUsers,this.defaultValue.showUsers),showIssues:l(de.showIssues,this.defaultValue.showIssues)}}}class K extends C{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(135,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class J extends n{constructor(){super(128,[79])}compute(X,de,Ue){return de.get(79)?!0:X.tabFocusMode}}var ie;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(ie=e.WrappingIndent||(e.WrappingIndent={}));function q(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ne extends n{constructor(){super(130,[129])}compute(X,de,Ue){const xe=de.get(129);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const pe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?We:pe,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function we(z){return e.editorOptionsRegistry[z.id]=z,z}var Je;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.foldingImportsByDefault=38]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=40]="fontFamily",z[z.fontInfo=41]="fontInfo",z[z.fontLigatures=42]="fontLigatures",z[z.fontSize=43]="fontSize",z[z.fontWeight=44]="fontWeight",z[z.formatOnPaste=45]="formatOnPaste",z[z.formatOnType=46]="formatOnType",z[z.glyphMargin=47]="glyphMargin",z[z.gotoLocation=48]="gotoLocation",z[z.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",z[z.hover=51]="hover",z[z.inDiffEditor=52]="inDiffEditor",z[z.inlineSuggest=53]="inlineSuggest",z[z.letterSpacing=54]="letterSpacing",z[z.lightbulb=55]="lightbulb",z[z.lineDecorationsWidth=56]="lineDecorationsWidth",z[z.lineHeight=57]="lineHeight",z[z.lineNumbers=58]="lineNumbers",z[z.lineNumbersMinChars=59]="lineNumbersMinChars",z[z.linkedEditing=60]="linkedEditing",z[z.links=61]="links",z[z.matchBrackets=62]="matchBrackets",z[z.minimap=63]="minimap",z[z.mouseStyle=64]="mouseStyle",z[z.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=66]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",z[z.multiCursorModifier=68]="multiCursorModifier",z[z.multiCursorPaste=69]="multiCursorPaste",z[z.occurrencesHighlight=70]="occurrencesHighlight",z[z.overviewRulerBorder=71]="overviewRulerBorder",z[z.overviewRulerLanes=72]="overviewRulerLanes",z[z.padding=73]="padding",z[z.parameterHints=74]="parameterHints",z[z.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",z[z.quickSuggestions=77]="quickSuggestions",z[z.quickSuggestionsDelay=78]="quickSuggestionsDelay",z[z.readOnly=79]="readOnly",z[z.renameOnType=80]="renameOnType",z[z.renderControlCharacters=81]="renderControlCharacters",z[z.renderIndentGuides=82]="renderIndentGuides",z[z.renderFinalNewline=83]="renderFinalNewline",z[z.renderLineHighlight=84]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=86]="renderValidationDecorations",z[z.renderWhitespace=87]="renderWhitespace",z[z.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",z[z.roundedSelection=89]="roundedSelection",z[z.rulers=90]="rulers",z[z.scrollbar=91]="scrollbar",z[z.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=93]="scrollBeyondLastLine",z[z.scrollPredominantAxis=94]="scrollPredominantAxis",z[z.selectionClipboard=95]="selectionClipboard",z[z.selectionHighlight=96]="selectionHighlight",z[z.selectOnLineNumbers=97]="selectOnLineNumbers",z[z.showFoldingControls=98]="showFoldingControls",z[z.showUnused=99]="showUnused",z[z.snippetSuggestions=100]="snippetSuggestions",z[z.smartSelect=101]="smartSelect",z[z.smoothScrolling=102]="smoothScrolling",z[z.stickyTabStops=103]="stickyTabStops",z[z.stopRenderingLineAfter=104]="stopRenderingLineAfter",z[z.suggest=105]="suggest",z[z.suggestFontSize=106]="suggestFontSize",z[z.suggestLineHeight=107]="suggestLineHeight",z[z.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",z[z.suggestSelection=109]="suggestSelection",z[z.tabCompletion=110]="tabCompletion",z[z.tabIndex=111]="tabIndex",z[z.unusualLineTerminators=112]="unusualLineTerminators",z[z.useShadowDOM=113]="useShadowDOM",z[z.useTabStops=114]="useTabStops",z[z.wordSeparators=115]="wordSeparators",z[z.wordWrap=116]="wordWrap",z[z.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=119]="wordWrapColumn",z[z.wordWrapOverride1=120]="wordWrapOverride1",z[z.wordWrapOverride2=121]="wordWrapOverride2",z[z.wrappingIndent=122]="wrappingIndent",z[z.wrappingStrategy=123]="wrappingStrategy",z[z.showDeprecated=124]="showDeprecated",z[z.inlayHints=125]="inlayHints",z[z.editorClassName=126]="editorClassName",z[z.pixelRatio=127]="pixelRatio",z[z.tabFocusMode=128]="tabFocusMode",z[z.layoutInfo=129]="layoutInfo",z[z.wrappingInfo=130]="wrappingInfo"})(Je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(136,null)})),acceptSuggestionOnEnter:we(new A(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(137,null),""],markdownDescription:f.localize(138,null)})),accessibilitySupport:we(new v),accessibilityPageSize:we(new u(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(139,null)})),ariaLabel:we(new b(4,"ariaLabel",f.localize(140,null))),autoClosingBrackets:we(new A(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(141,null),f.localize(142,null),""],description:f.localize(143,null)})),autoClosingDelete:we(new A(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(144,null),""],description:f.localize(145,null)})),autoClosingOvertype:we(new A(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(146,null),""],description:f.localize(147,null)})),autoClosingQuotes:we(new A(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(148,null),f.localize(149,null),""],description:f.localize(150,null)})),autoIndent:we(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[f.localize(151,null),f.localize(152,null),f.localize(153,null),f.localize(154,null),f.localize(155,null)],description:f.localize(156,null)})),automaticLayout:we(new h(10,"automaticLayout",!1)),autoSurround:we(new A(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(157,null),f.localize(158,null),f.localize(159,null),""],description:f.localize(160,null)})),stickyTabStops:we(new h(103,"stickyTabStops",!1,{description:f.localize(161,null)})),codeLens:we(new h(12,"codeLens",!0,{description:f.localize(162,null)})),codeLensFontFamily:we(new b(13,"codeLensFontFamily","",{description:f.localize(163,null)})),codeLensFontSize:we(new u(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(164,null)})),colorDecorators:we(new h(15,"colorDecorators",!0,{description:f.localize(165,null)})),columnSelection:we(new h(16,"columnSelection",!1,{description:f.localize(166,null)})),comments:we(new t),contextmenu:we(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new h(19,"copyWithSyntaxHighlighting",!0,{description:f.localize(167,null)})),cursorBlinking:we(new o(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:f.localize(168,null)})),cursorSmoothCaretAnimation:we(new h(21,"cursorSmoothCaretAnimation",!1,{description:f.localize(169,null)})),cursorStyle:we(new o(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:f.localize(170,null)})),cursorSurroundingLines:we(new u(23,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(171,null)})),cursorSurroundingLinesStyle:we(new A(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(172,null),f.localize(173,null)],description:f.localize(174,null)})),cursorWidth:we(new u(25,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(175,null)})),disableLayerHinting:we(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:we(new h(28,"domReadOnly",!1)),dragAndDrop:we(new h(29,"dragAndDrop",!0,{description:f.localize(176,null)})),emptySelectionClipboard:we(new D),extraEditorClassName:we(new b(31,"extraEditorClassName","")),fastScrollSensitivity:we(new g(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:f.localize(177,null)})),find:we(new I),fixedOverflowWidgets:we(new h(34,"fixedOverflowWidgets",!1)),folding:we(new h(35,"folding",!0,{description:f.localize(178,null)})),foldingStrategy:we(new A(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(179,null),f.localize(180,null)],description:f.localize(181,null)})),foldingHighlight:we(new h(37,"foldingHighlight",!0,{description:f.localize(182,null)})),foldingImportsByDefault:we(new h(38,"foldingImportsByDefault",!1,{description:f.localize(183,null)})),unfoldOnClickAfterEndOfLine:we(new h(39,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(184,null)})),fontFamily:we(new b(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(185,null)})),fontInfo:we(new k),fontLigatures2:we(new s),fontSize:we(new F),fontWeight:we(new x),formatOnPaste:we(new h(45,"formatOnPaste",!1,{description:f.localize(186,null)})),formatOnType:we(new h(46,"formatOnType",!1,{description:f.localize(187,null)})),glyphMargin:we(new h(47,"glyphMargin",!0,{description:f.localize(188,null)})),gotoLocation:we(new j),hideCursorInOverviewRuler:we(new h(49,"hideCursorInOverviewRuler",!1,{description:f.localize(189,null)})),highlightActiveIndentGuide:we(new h(50,"highlightActiveIndentGuide",!0,{description:f.localize(190,null)})),hover:we(new oe),inDiffEditor:we(new h(52,"inDiffEditor",!1)),letterSpacing:we(new g(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>g.clamp(z,-5,20),{description:f.localize(191,null)})),lightbulb:we(new H),lineDecorationsWidth:we(new T(56,"lineDecorationsWidth",10)),lineHeight:we(new Q),lineNumbers:we(new Le),lineNumbersMinChars:we(new u(59,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new h(60,"linkedEditing",!1,{description:f.localize(192,null)})),links:we(new h(61,"links",!0,{description:f.localize(193,null)})),matchBrackets:we(new A(62,"matchBrackets","always",["always","near","never"],{description:f.localize(194,null)})),minimap:we(new O),mouseStyle:we(new A(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new g(65,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:f.localize(195,null)})),mouseWheelZoom:we(new h(66,"mouseWheelZoom",!1,{markdownDescription:f.localize(196,null)})),multiCursorMergeOverlapping:we(new h(67,"multiCursorMergeOverlapping",!0,{description:f.localize(197,null)})),multiCursorModifier:we(new o(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[f.localize(198,null),f.localize(199,null)],markdownDescription:f.localize(200,null)})),multiCursorPaste:we(new A(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(201,null),f.localize(202,null)],markdownDescription:f.localize(203,null)})),occurrencesHighlight:we(new h(70,"occurrencesHighlight",!0,{description:f.localize(204,null)})),overviewRulerBorder:we(new h(71,"overviewRulerBorder",!0,{description:f.localize(205,null)})),overviewRulerLanes:we(new u(72,"overviewRulerLanes",3,0,3)),padding:we(new fe),parameterHints:we(new W),peekWidgetDefaultFocus:we(new A(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(206,null),f.localize(207,null)],description:f.localize(208,null)})),definitionLinkOpensInPeek:we(new h(76,"definitionLinkOpensInPeek",!1,{description:f.localize(209,null)})),quickSuggestions:we(new he),quickSuggestionsDelay:we(new u(78,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(210,null)})),readOnly:we(new h(79,"readOnly",!1)),renameOnType:we(new h(80,"renameOnType",!1,{description:f.localize(211,null),markdownDeprecationMessage:f.localize(212,null)})),renderControlCharacters:we(new h(81,"renderControlCharacters",!1,{description:f.localize(213,null)})),renderIndentGuides:we(new h(82,"renderIndentGuides",!0,{description:f.localize(214,null)})),renderFinalNewline:we(new h(83,"renderFinalNewline",!0,{description:f.localize(215,null)})),renderLineHighlight:we(new A(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(216,null)],description:f.localize(217,null)})),renderLineHighlightOnlyWhenFocus:we(new h(85,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(218,null)})),renderValidationDecorations:we(new A(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new A(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(219,null),f.localize(220,null),f.localize(221,null),""],description:f.localize(222,null)})),revealHorizontalRightPadding:we(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new h(89,"roundedSelection",!0,{description:f.localize(223,null)})),rulers:we(new $e),scrollbar:we(new qe),scrollBeyondLastColumn:we(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(224,null)})),scrollBeyondLastLine:we(new h(93,"scrollBeyondLastLine",!0,{description:f.localize(225,null)})),scrollPredominantAxis:we(new h(94,"scrollPredominantAxis",!0,{description:f.localize(226,null)})),selectionClipboard:we(new h(95,"selectionClipboard",!0,{description:f.localize(227,null),included:R.isLinux})),selectionHighlight:we(new h(96,"selectionHighlight",!0,{description:f.localize(228,null)})),selectOnLineNumbers:we(new h(97,"selectOnLineNumbers",!0)),showFoldingControls:we(new A(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(229,null),f.localize(230,null)],description:f.localize(231,null)})),showUnused:we(new h(99,"showUnused",!0,{description:f.localize(232,null)})),showDeprecated:we(new h(124,"showDeprecated",!0,{description:f.localize(233,null)})),inlayHints:we(new M),snippetSuggestions:we(new A(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(234,null),f.localize(235,null),f.localize(236,null),f.localize(237,null)],description:f.localize(238,null)})),smartSelect:we(new K),smoothScrolling:we(new h(102,"smoothScrolling",!1,{description:f.localize(239,null)})),stopRenderingLineAfter:we(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new U),inlineSuggest:we(new Ge),suggestFontSize:we(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(240,null)})),suggestLineHeight:we(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(241,null)})),suggestOnTriggerCharacters:we(new h(108,"suggestOnTriggerCharacters",!0,{description:f.localize(242,null)})),suggestSelection:we(new A(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(243,null),f.localize(244,null),f.localize(245,null)],description:f.localize(246,null)})),tabCompletion:we(new A(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(247,null),f.localize(248,null),f.localize(249,null)],description:f.localize(250,null)})),tabIndex:we(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new A(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(251,null),f.localize(252,null),f.localize(253,null)],description:f.localize(254,null)})),useShadowDOM:we(new h(113,"useShadowDOM",!0)),useTabStops:we(new h(114,"useTabStops",!0,{description:f.localize(255,null)})),wordSeparators:we(new b(115,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:f.localize(256,null)})),wordWrap:we(new A(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(257,null),f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),wordWrapBreakAfterCharacters:we(new b(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new b(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(262,null)})),wordWrapOverride1:we(new A(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new A(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[f.localize(263,null),f.localize(264,null),f.localize(265,null),f.localize(266,null)],description:f.localize(267,null)})),wrappingStrategy:we(new A(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(268,null),f.localize(269,null)],description:f.localize(270,null)})),editorClassName:we(new d),pixelRatio:we(new te),tabFocusMode:we(new J),layoutInfo:we(new V),wrappingInfo:we(new ne)}}),define(Ee[128],_e([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[129],_e([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[130],_e([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(Ee[131],_e([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(Ee[132],_e([18,19]),function(Z,e){return Z.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[133],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[134],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[135],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[136],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[137],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[138],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[139],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[140],_e([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(Ee[141],_e([18,19]),function(Z,e){return Z.create("vs/workbench/common/views",e)}),define(Ee[142],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[143],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[144],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[145],_e([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[146],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var f;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var R;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var S;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[147],_e([0,1,129]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=y;function P(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=l.match(R);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=P;function E(l){if(!l)return null;let h=l.majorBase,u=l.majorMustEqual,g=l.minorBase,b=l.minorMustEqual,w=l.patchBase,A=l.patchMustEqual;l.hasCaret&&(h===0||(b=!1),A=!1);let o=0;if(l.preRelease){const m=S.exec(l.preRelease);if(m){const[,v,t,r]=m;o=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:h,majorMustEqual:u,minorBase:g,minorMustEqual:b,patchBase:w,patchMustEqual:A,isMinimum:l.hasGreaterEquals,notBefore:o}}e.normalizeVersion=E;function _(l,h,u){let g;typeof l=="string"?g=E(P(l)):g=l;let b;h instanceof Date?b=h.getTime():typeof h=="string"&&(b=new Date(h).getTime());let w;if(typeof u=="string"?w=E(P(u)):w=u,!g||!w)return!1;let A=g.majorBase,o=g.minorBase,m=g.patchBase,v=w.majorBase,t=w.minorBase,r=w.patchBase,a=w.notBefore,i=w.majorMustEqual,c=w.minorMustEqual,p=w.patchMustEqual;return w.isMinimum?A>v?!0:A<v?!1:o>t?!0:o<t||b&&b<a?!1:m>=r:(A===1&&v===0&&(!i||!c||!p)&&(v=1,t=0,r=0,i=!0,c=!1,p=!1),A<v?!1:A>v?!i:o<t?!1:o>t?!c:m<r?!1:m>r?!p:!(b&&b<a))}e.isValidVersion=_;function C(l,h,u,g){return u.isBuiltin||typeof u.main=="undefined"?!0:T(l,h,u.engines.vscode,g)}e.isValidExtensionVersion=C;function n(l,h,u){return l==="*"||T(h,u,l)}e.isEngineValid=n;function T(l,h,u,g=[]){let b=E(P(u));if(!b)return g.push(f.localize(0,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(f.localize(1,null,u)),!1}else if(!b.majorMustEqual)return g.push(f.localize(2,null,u)),!1;return _(l,h,b)?!0:(g.push(f.localize(3,null,l,u)),!1)}}),define(Ee[91],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(S,y=[],P=!1){this.ctor=S,this.staticArguments=y,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=f}),define(Ee[60],_e([0,1,91]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function S(P,E,_){E instanceof f.SyncDescriptor||(E=new f.SyncDescriptor(E,[],_)),R.push([P,E])}e.registerSingleton=S;function y(){return R}e.getSingletonServiceDescriptors=y}),define(Ee[148],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=f;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let P of this._nodes.values())P.outgoing.size===0&&y.push(P);return y}insertEdge(y,P){const E=this.lookupOrInsertNode(y),_=this.lookupOrInsertNode(P);E.outgoing.set(this._hashFn(P),_),_.incoming.set(this._hashFn(y),E)}removeNode(y){const P=this._hashFn(y);this._nodes.delete(P);for(let E of this._nodes.values())E.outgoing.delete(P),E.incoming.delete(P)}lookupOrInsertNode(y){const P=this._hashFn(y);let E=this._nodes.get(P);return E||(E=new f(y),this._nodes.set(P,E)),E}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[P,E]of this._nodes)y.push(`${P}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,P]of this._nodes){const E=new Set([y]),_=this._findCycle(P,E);if(_)return _}}_findCycle(y,P){for(let[E,_]of y.outgoing){if(P.has(E))return[...P,E].join(" -> ");P.add(E);const C=this._findCycle(_,P);if(C)return C;P.delete(E)}}}e.Graph=R}),define(Ee[4],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=_})(f=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function R(E,_,C,n){_[f.DI_TARGET]===_?_[f.DI_DEPENDENCIES].push({id:E,index:C,optional:n}):(_[f.DI_DEPENDENCIES]=[{id:E,index:C,optional:n}],_[f.DI_TARGET]=_)}function S(E){if(f.serviceIds.has(E))return f.serviceIds.get(E);const _=function(C,n,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(_,C,T,!1)};return _.toString=()=>E,f.serviceIds.set(E,_),_}e.createDecorator=S;function y(E){return E}e.refineServiceDecorator=y;function P(E){return function(_,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(E,_,n,!0)}}e.optional=P}),define(Ee[149],_e([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,f.createDecorator)("modelService");function R(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(Ee[150],_e([0,1,3,43,6,21,81,58,149]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(C):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new f.Emitter}get onDidChange(){return this._onDidChange.event}register(h,u){let g={selector:h,provider:u,_score:-1,_time:this._clock++};return this._entries.push(g),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,S.toDisposable)(()=>{if(g){let b=this._entries.indexOf(g);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),g=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const u=[];for(let g of this._entries)g._score>0&&u.push(g.provider);return u}ordered(h){const u=[];return this._orderedForEach(h,g=>u.push(g.provider)),u}orderedGroups(h){const u=[];let g,b;return this._orderedForEach(h,w=>{g&&b===w._score?g.push(w.provider):(b=w._score,g=[w.provider],u.push(g))}),u}_orderedForEach(h,u){if(!!h){this._updateScores(h);for(const g of this._entries)g._score>0&&u(g)}}_updateScores(h){let u={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let g of this._entries)if(g._score=(0,E.score)(g.selector,h.uri,h.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(h)),C(g.selector)&&g._score>0){for(let b of this._entries)b._score=0;g._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,u){return h._score<u._score?1:h._score>u._score?-1:h._time<u._time?1:h._time>u._time?-1:0}}e.LanguageFeatureRegistry=n;class T{constructor(h,u,g=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=u,this.max=g,this._cache=new y.LRUCache(50,.7)}_key(h){return h.id+(0,R.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const u=this._key(h),g=this._cache.get(u);return this._clamp(g?.value)}update(h,u){const g=this._key(h);let b=this._cache.get(g);return b||(b=new P.MovingAverage,this._cache.set(g,b)),b.update(u),this.get(h)}}e.LanguageFeatureRequestDelays=T}),define(Ee[61],_e([0,1,2,31,150,123,35]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var E;(function(s){s[s.Null=0]="Null",s[s.PlainText=1]="PlainText"})(E=e.LanguageId||(e.LanguageId={}));class _{constructor(k,F){this.language=k,this.id=F}}e.LanguageIdentifier=_;var C;(function(s){s[s.NotSet=-1]="NotSet",s[s.None=0]="None",s[s.Italic=1]="Italic",s[s.Bold=2]="Bold",s[s.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(s){s[s.None=0]="None",s[s.DefaultForeground=1]="DefaultForeground",s[s.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var T;(function(s){s[s.Other=0]="Other",s[s.Comment=1]="Comment",s[s.String=2]="String",s[s.RegEx=4]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(s){s[s.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",s[s.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",s[s.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",s[s.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",s[s.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",s[s.ITALIC_MASK=2048]="ITALIC_MASK",s[s.BOLD_MASK=4096]="BOLD_MASK",s[s.UNDERLINE_MASK=8192]="UNDERLINE_MASK",s[s.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",s[s.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",s[s.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",s[s.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",s[s.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",s[s.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",s[s.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",s[s.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",s[s.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",s[s.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let F=this.getForeground(k),x="mtk"+F,j=this.getFontStyle(k);return j&1&&(x+=" mtki"),j&2&&(x+=" mtkb"),j&4&&(x+=" mtku"),x}static getInlineStyleFromMetadata(k,F){const x=this.getForeground(k),j=this.getFontStyle(k);let oe=`color: ${F[x]};`;return j&1&&(oe+="font-style: italic;"),j&2&&(oe+="font-weight: bold;"),j&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=h;var u;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let s=Object.create(null);return s[0]="symbol-method",s[1]="symbol-function",s[2]="symbol-constructor",s[3]="symbol-field",s[4]="symbol-variable",s[5]="symbol-class",s[6]="symbol-struct",s[7]="symbol-interface",s[8]="symbol-module",s[9]="symbol-property",s[10]="symbol-event",s[11]="symbol-operator",s[12]="symbol-unit",s[13]="symbol-value",s[14]="symbol-constant",s[15]="symbol-enum",s[16]="symbol-enum-member",s[17]="symbol-keyword",s[27]="symbol-snippet",s[18]="symbol-text",s[19]="symbol-color",s[20]="symbol-file",s[21]="symbol-reference",s[22]="symbol-customcolor",s[23]="symbol-folder",s[24]="symbol-type-parameter",s[25]="account",s[26]="issues",function(k){const F=s[k];let x=F&&P.iconRegistry.get(F);return x||(console.info("No codicon found for CompletionItemKind "+k),x=P.Codicon.symbolProperty),x.classNames}}(),e.completionKindFromString=function(){let s=Object.create(null);return s.method=0,s.function=1,s.constructor=2,s.field=3,s.variable=4,s.class=5,s.struct=6,s.interface=7,s.module=8,s.property=9,s.event=10,s.operator=11,s.unit=12,s.value=13,s.constant=14,s.enum=15,s["enum-member"]=16,s.enumMember=16,s.keyword=17,s.snippet=27,s.text=18,s.color=19,s.file=20,s.reference=21,s.customcolor=22,s.folder=23,s["type-parameter"]=24,s.typeParameter=24,s.account=25,s.issue=26,function(k,F){let x=s[k];return typeof x=="undefined"&&!F&&(x=9),x}}();var g;(function(s){s[s.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(s){s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var A;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(A=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(s){return s&&f.URI.isUri(s.uri)&&R.Range.isIRange(s.range)&&(R.Range.isIRange(s.originSelectionRange)||R.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=t;var r;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var a;(function(s){s[s.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var i;(function(s){const k=new Map;k.set("file",0),k.set("module",1),k.set("namespace",2),k.set("package",3),k.set("class",4),k.set("method",5),k.set("property",6),k.set("field",7),k.set("constructor",8),k.set("enum",9),k.set("interface",10),k.set("function",11),k.set("variable",12),k.set("constant",13),k.set("string",14),k.set("number",15),k.set("boolean",16),k.set("array",17),k.set("object",18),k.set("key",19),k.set("null",20),k.set("enum-member",21),k.set("struct",22),k.set("event",23),k.set("operator",24),k.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function x(se){return k.get(se)}s.fromString=x;function j(se){return F.get(se)}s.toString=j;function oe(se,V){const H=F.get(se);let M=H&&P.iconRegistry.get("symbol-"+H);return M||(console.info("No codicon found for SymbolKind "+se),M=P.Codicon.symbolProperty),`${V?"inline":"block"} ${M.classNames}`}s.toCssClassName=oe})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(k){this.value=k}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var p;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var D;(function(s){s[s.Other=0]="Other",s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var I;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[45],_e([0,1,22,8,4]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=f.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",f.isMacintosh),P.set("isLinux",f.isLinux),P.set("isWindows",f.isWindows),P.set("isWeb",f.isWeb),P.set("isMacNative",f.isMacintosh&&!f.isWeb),P.set("isEdge",y.indexOf("Edg/")>=0),P.set("isFirefox",y.indexOf("Firefox")>=0),P.set("isChrome",y.indexOf("Chrome")>=0),P.set("isSafari",y.indexOf("Safari")>=0);const E=Object.prototype.hasOwnProperty;var _;(function(I){I[I.False=0]="False",I[I.True=1]="True",I[I.Defined=2]="Defined",I[I.Not=3]="Not",I[I.Equals=4]="Equals",I[I.NotEquals=5]="NotEquals",I[I.And=6]="And",I[I.Regex=7]="Regex",I[I.NotRegex=8]="NotRegex",I[I.Or=9]="Or",I[I.In=10]="In",I[I.NotIn=11]="NotIn",I[I.Greater=12]="Greater",I[I.GreaterEquals=13]="GreaterEquals",I[I.Smaller=14]="Smaller",I[I.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return T.INSTANCE}static true(){return l.INSTANCE}static has(s){return h.create(s)}static equals(s,k){return u.create(s,k)}static notEquals(s,k){return w.create(s,k)}static regex(s,k){return r.create(s,k)}static in(s,k){return g.create(s,k)}static not(s){return A.create(s)}static and(...s){return i.create(s)}static or(...s){return c.create(s)}static greater(s,k){return o.create(s,k)}static less(s,k){return v.create(s,k)}static deserialize(s,k=!1){if(!!s)return this._deserializeOrExpression(s,k)}static _deserializeOrExpression(s,k){let F=s.split("||");return c.create(F.map(x=>this._deserializeAndExpression(x,k)))}static _deserializeAndExpression(s,k){let F=s.split("&&");return i.create(F.map(x=>this._deserializeOne(x,k)))}static _deserializeOne(s,k){if(s=s.trim(),s.indexOf("!=")>=0){let F=s.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],k))}if(s.indexOf("==")>=0){let F=s.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],k))}if(s.indexOf("=~")>=0){let F=s.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],k))}if(s.indexOf(" in ")>=0){let F=s.split(" in ");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(s)){const F=s.split(">=");return m.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(s)){const F=s.split(">");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(s)){const F=s.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(s)){const F=s.split("<");return v.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(s)?A.create(s.substr(1).trim()):h.create(s)}static _deserializeValue(s,k){if(s=s.trim(),s==="true")return!0;if(s==="false")return!1;let F=/^'([^']*)'$/.exec(s);return F?F[1].trim():s}static _deserializeRegexValue(s,k){if((0,R.isFalsyOrWhitespace)(s)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=s.indexOf("/"),x=s.lastIndexOf("/");if(F===x||F<0){if(k)throw new Error(`bad regexp-value '${s}', missing /-enclosure`);return console.warn(`bad regexp-value '${s}', missing /-enclosure`),null}let j=s.slice(F+1,x),oe=s[x+1]==="i"?"i":"";try{return new RegExp(j,oe)}catch(se){if(k)throw new Error(`bad regexp-value '${s}', parse error: ${se}`);return console.warn(`bad regexp-value '${s}', parse error: ${se}`),null}}}e.ContextKeyExpr=C;function n(I,s){return I.cmp(s)}class T{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class l{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{constructor(s){this.key=s,this.type=2}static create(s){const k=P.get(s);return typeof k=="boolean"?k?l.INSTANCE:T.INSTANCE:new h(s)}cmp(s){return s.type!==this.type?this.type-s.type:d(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return A.create(this.key)}}e.ContextKeyDefinedExpr=h;class u{constructor(s,k){this.key=s,this.value=k,this.type=4}static create(s,k){if(typeof k=="boolean")return k?h.create(s):A.create(s);const F=P.get(s);return typeof F=="boolean"?k===(F?"true":"false")?l.INSTANCE:T.INSTANCE:new u(s,k)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class g{constructor(s,k){this.key=s,this.valueKey=k,this.type=10}static create(s,k){return new g(s,k)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}evaluate(s){const k=s.getValue(this.valueKey),F=s.getValue(this.key);return Array.isArray(k)?k.indexOf(F)>=0:typeof F=="string"&&typeof k=="object"&&k!==null?E.call(k,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=g;class b{constructor(s){this._actual=s,this.type=11}static create(s){return new b(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new b(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class w{constructor(s,k){this.key=s,this.value=k,this.type=5}static create(s,k){if(typeof k=="boolean")return k?A.create(s):h.create(s);const F=P.get(s);return typeof F=="boolean"?k===(F?"true":"false")?T.INSTANCE:l.INSTANCE:new w(s,k)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class A{constructor(s){this.key=s,this.type=3}static create(s){const k=P.get(s);return typeof k=="boolean"?k?T.INSTANCE:l.INSTANCE:new A(s)}cmp(s){return s.type!==this.type?this.type-s.type:d(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=A;class o{constructor(s,k){this.key=s,this.value=k,this.type=12}static create(s,k){return new o(s,k)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=o;class m{constructor(s,k){this.key=s,this.value=k,this.type=13}static create(s,k){return new m(s,k)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=m;class v{constructor(s,k){this.key=s,this.value=k,this.type=14}static create(s,k){return new v(s,k)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(s,k){this.key=s,this.value=k,this.type=15}static create(s,k){return new t(s,k)}cmp(s){return s.type!==this.type?this.type-s.type:D(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(s,k){this.key=s,this.regexp=k,this.type=7}static create(s,k){return new r(s,k)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const k=this.regexp?this.regexp.source:"",F=s.regexp?s.regexp.source:"";return k<F?-1:k>F?1:0}equals(s){if(s.type===this.type){const k=this.regexp?this.regexp.source:"",F=s.regexp?s.regexp.source:"";return this.key===s.key&&k===F}return!1}evaluate(s){let k=s.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return a.create(this)}}e.ContextKeyRegexExpr=r;class a{constructor(s){this._actual=s,this.type=8}static create(s){return new a(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new a(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class i{constructor(s){this.expr=s,this.type=6}static create(s){return i._normalizeArr(s)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let k=0,F=this.expr.length;k<F;k++){const x=n(this.expr[k],s.expr[k]);if(x!==0)return x}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let k=0,F=this.expr.length;k<F;k++)if(!this.expr[k].equals(s.expr[k]))return!1;return!0}return!1}evaluate(s){for(let k=0,F=this.expr.length;k<F;k++)if(!this.expr[k].evaluate(s))return!1;return!0}static _normalizeArr(s){const k=[];let F=!1;for(const x of s)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return T.INSTANCE;if(x.type===6){k.push(...x.expr);continue}k.push(x)}if(k.length===0&&F)return l.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(n);k.length>1;){const x=k[k.length-1];if(x.type!==9)break;k.pop();const j=k.pop(),oe=c.create(x.expr.map(se=>i.create([se,j])));oe&&(k.push(oe),k.sort(n))}return k.length===1?k[0]:new i(k)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(let k of this.expr)s.push(...k.keys());return s}map(s){return new i(this.expr.map(k=>k.map(s)))}negate(){let s=[];for(let k of this.expr)s.push(k.negate());return c.create(s)}}e.ContextKeyAndExpr=i;class c{constructor(s){this.expr=s,this.type=9}static create(s){const k=c._normalizeArr(s);if(k.length!==0)return k.length===1?k[0]:new c(k)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let k=0,F=this.expr.length;k<F;k++){const x=n(this.expr[k],s.expr[k]);if(x!==0)return x}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let k=0,F=this.expr.length;k<F;k++)if(!this.expr[k].equals(s.expr[k]))return!1;return!0}return!1}evaluate(s){for(let k=0,F=this.expr.length;k<F;k++)if(this.expr[k].evaluate(s))return!0;return!1}static _normalizeArr(s){let k=[],F=!1;if(s){for(let x=0,j=s.length;x<j;x++){const oe=s[x];if(!!oe){if(oe.type===0){F=!0;continue}if(oe.type===1)return[l.INSTANCE];if(oe.type===9){k=k.concat(oe.expr);continue}k.push(oe)}}if(k.length===0&&F)return[T.INSTANCE];k.sort(n)}return k}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(let k of this.expr)s.push(...k.keys());return s}map(s){return new c(this.expr.map(k=>k.map(s)))}negate(){let s=[];for(let F of this.expr)s.push(F.negate());const k=F=>F.type===9?F.expr:[F];for(;s.length>1;){const F=s.shift(),x=s.shift(),j=[];for(const oe of k(F))for(const se of k(x))j.push(C.and(oe,se));s.unshift(C.or(...j))}return s[0]}}e.ContextKeyOrExpr=c;class p extends h{constructor(s,k,F){super(s);this._defaultValue=k,typeof F=="object"?p._info.push({...F,key:s}):F!==!0&&p._info.push({key:s,description:F,type:k!=null?typeof k:void 0})}static all(){return p._info.values()}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(s){return C.equals(this.key,s)}notEqualsTo(s){return C.notEquals(this.key,s)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(I,s){return I<s?-1:I>s?1:0}function D(I,s,k,F){return I<k?-1:I>k?1:s<F?-1:s>F?1:0}}),define(Ee[151],_e([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[26],_e([0,1,8,4]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=S;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class E{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,l){if(typeof T=="undefined"||T===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof T=="string"||typeof l=="string"){let h=typeof T=="string"?T:T.value,u=typeof l=="string"?l:l.value;return f.equalsIgnoreCase(h,u)}return T._lower===l._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=E;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[152],_e([0,1,8,26]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(u,g){return u.uuid&&g.uuid?u.uuid===g.uuid:u.id===g.id?!0:(0,f.compareIgnoreCase)(u.id,g.id)===0}e.areSameExtensions=S;class y{constructor(g,b){this.version=b,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof y?S(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=y;function P(u,g){return`${u}.${g}`}e.getExtensionId=P;function E(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function _(u,g){return E(P(u,g))}e.getGalleryExtensionId=_;function C(u,g){const b=[],w=A=>{for(const o of b)if(o.some(m=>S(g(m),g(A))))return o;return null};for(const A of u){const o=w(A);o?o.push(A):b.push([A])}return b}e.groupByExtension=C;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function T(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(u){const g=new Set;for(const b of u)b.malicious&&g.add(b.id.id);return g}e.getMaliciousExtensionsSet=l;function h(u,g){const b=[],w=g.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const A=w.shift();if(A&&b.every(o=>!S(o.identifier,{id:A}))){const o=u.filter(m=>S(m.identifier,{id:A}));o.length===1&&(b.push(o[0]),w.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=h}),define(Ee[62],_e([0,1,21,14,8,10,2,130,4]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function C(V){return V.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var T;(function(V){V[V.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var l;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=h;function u(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=u;function g(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=b;var w;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class A extends Error{constructor(H,M){super(H);this.code=M}}e.FileSystemProviderError=A;function o(V,H){const M=new A(V.toString(),H);return v(M,H),M}e.createFileSystemProviderError=o;function m(V){return V||o((0,E.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=m;function v(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=v;function t(V){if(!V)return w.Unknown;if(V instanceof A)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return w.Unknown;switch(H[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(V){if(V instanceof D)return V.fileOperationResult;switch(t(V)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var a;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class i{constructor(H,M,Q){this.resource=H,this.operation=M,this.target=Q}isOperation(H){return this.operation===H}}e.FileOperationEvent=i;var c;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class p{constructor(H,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const Q of H)switch(Q.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>M)),this.added.set(Q.resource,Q);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>M)),this.updated.set(Q.resource,Q);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>M)),this.deleted.set(Q.resource,Q);break}}contains(H,...M){return this.doContains(H,{includeChildren:!1},...M)}affects(H,...M){return this.doContains(H,{includeChildren:!0},...M)}doContains(H,M,...Q){if(!H)return!1;const O=Q.length>0;return!!((!O||Q.includes(1))&&(this.added?.get(H)||M.includeChildren&&this.added?.findSuperstr(H))||(!O||Q.includes(0))&&(this.updated?.get(H)||M.includeChildren&&this.updated?.findSuperstr(H))||(!O||Q.includes(2))&&(this.deleted?.findSubstr(H)||M.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function d(V,H,M){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==R.sep&&(H+=R.sep),M?(0,S.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=d;class D extends Error{constructor(H,M,Q){super(H);this.fileOperationResult=M,this.options=Q}}e.FileOperationError=D;class I extends D{constructor(H,M,Q){super(H,2,Q);this.stat=M}}e.NotModifiedSinceFileOperationError=I;var s;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(s=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=F;async function x(V,H){if(!H.canHandleResource(P.URI.from({scheme:V.scheme})))return new Promise(M=>{const Q=H.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===V.scheme&&O.added&&(Q.dispose(),M())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(H){return(0,y.isNumber)(H)||(H=0),H<j.KB?(0,E.localize)(1,null,H.toFixed(0)):H<j.MB?(0,E.localize)(2,null,(H/j.KB).toFixed(2)):H<j.GB?(0,E.localize)(3,null,(H/j.MB).toFixed(2)):H<j.TB?(0,E.localize)(4,null,(H/j.GB).toFixed(2)):(0,E.localize)(5,null,(H/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var oe;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function se(V){return{maxFileSize:V===0?300*j.MB:16*j.GB,maxHeapSize:V===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=se}),define(Ee[63],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...S){this._entries=new Map;for(let[y,P]of S)this.set(y,P)}set(S,y){const P=this._entries.get(S);return this._entries.set(S,y),P}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=f}),define(Ee[153],_e([0,1,15,12,91,148,4,63]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new E.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=u,this._strict=g,this._parent=b,this._services.set(P.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...g){let b=l.traceInvocation(u),w=!1;try{return u({get:(o,m)=>{if(w)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(o,b);if(!v&&m!==P.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return v}},...g)}finally{w=!0,b.stop()}}createInstance(u,...g){let b,w;return u instanceof S.SyncDescriptor?(b=l.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(g),b)):(b=l.traceCreation(u),w=this._createInstance(u,g,b)),b.stop(),w}_createInstance(u,g=[],b){let w=P._util.getServiceDependencies(u).sort((m,v)=>m.index-v.index),A=[];for(const m of w){let v=this._getOrCreateServiceInstance(m.id,b);if(!v&&this._strict&&!m.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${m.id}.`);A.push(v)}let o=w.length>0?w[0].index:g.length;if(g.length!==o){console.warn(`[createInstance] First service dependency of ${u.name} at position ${o+1} conflicts with ${g.length} static arguments`);let m=o-g.length;m>0?g=g.concat(new Array(m)):g=g.slice(0,o)}return new u(...[...g,...A])}_setServiceInstance(u,g){if(this._services.get(u)instanceof S.SyncDescriptor)this._services.set(u,g);else if(this._parent)this._parent._setServiceInstance(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let g=this._services.get(u);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):g}_getOrCreateServiceInstance(u,g){let b=this._getServiceInstanceOrDescriptor(u);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,b,g.branch(u,!0)):(g.branch(u,!1),b)}_safeCreateAndCacheServiceInstance(u,g,b){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,g,b)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,g,b){const w=new y.Graph(m=>m.id.toString());let A=0;const o=[{id:u,desc:g,_trace:b}];for(;o.length;){const m=o.pop();if(w.lookupOrInsertNode(m),A++>1e3)throw new C(w);for(let v of P._util.getServiceDependencies(m.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${u} depends on ${v.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const r={id:v.id,desc:t,_trace:m._trace.branch(v.id,!0)};w.insertEdge(m,r),o.push(r)}}}for(;;){const m=w.roots();if(m.length===0){if(!w.isEmpty())throw new C(w);break}for(const{data:v}of m){if(this._getServiceInstanceOrDescriptor(v.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,g,b=[],w,A){if(this._services.get(u)instanceof S.SyncDescriptor)return this._createServiceInstance(g,b,w,A);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,g,b,w,A);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(u,g=[],b,w){if(b){const A=new f.IdleValue(()=>this._createInstance(u,g,w));return new Proxy(Object.create(null),{get(o,m){if(m in o)return o[m];let v=A.value,t=v[m];return typeof t!="function"||(t=t.bind(v),o[m]=t),t},set(o,m,v){return A.value[m]=v,!0}})}else return this._createInstance(u,g,w)}}e.InstantiationService=n;var T;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(T||(T={}));class l{constructor(u,g){this.type=u,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return _?new l(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(u){return _?new l(0,u.name):l._None}branch(u,g){let b=new l(2,u.toString());return this._dep.push([u,g,b]),b}stop(){let u=Date.now()-this._start;l._totals+=u;let g=!1;function b(A,o){let m=[],v=new Array(A+1).join("	");for(const[t,r,a]of o._dep)if(r&&a){g=!0,m.push(`${v}CREATES -> ${t}`);let i=b(A+1,a);i&&m.push(i)}else m.push(`${v}uses -> ${t}`);return m.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(u>2||g)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(Ee[16],_e([0,1,59,3,6,22,4]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function E(){return new Date().toISOString()}var _;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(_.Error))if(t instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=t.stack,this.log(_.Error,this.format(a))}else this.log(_.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let a=0;a<t.length;a++){let i=t[a];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}r+=(a>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class T extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!y.isWindows}trace(t,...r){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...r):console.log(`[main ${E()}]`,t,...r))}debug(t,...r){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...r):console.log(`[main ${E()}]`,t,...r))}info(t,...r){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...r):console.log(`[main ${E()}]`,t,...r))}warn(t,...r){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,t,...r):console.warn(`[main ${E()}]`,t,...r))}error(t,...r){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,t,...r):console.error(`[main ${E()}]`,t,...r))}critical(t,...r){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,t,...r):console.error(`[main ${E()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class l extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class h extends C{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,f.toErrorMessage)(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class u extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const a of this.logServices)a.trace(t,...r)}debug(t,...r){for(const a of this.logServices)a.debug(t,...r)}info(t,...r){for(const a of this.logServices)a.info(t,...r)}warn(t,...r){for(const a of this.logServices)a.warn(t,...r)}error(t,...r){for(const a of this.logServices)a.error(t,...r)}critical(t,...r){for(const a of this.logServices)a.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class g extends S.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=g;class b extends S.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(a))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let a=this.loggers.get(t.toString());return a||(a=this.doCreateLogger(t,r?.always?_.Trace:this.logLevel,r),this.loggers.set(t.toString(),a),r?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class w{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function A(v){if(v.verbose)return _.Trace;if(typeof v.logLevel=="string"){const t=o(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=A;function o(v){switch(v){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=o;function m(v){switch(v){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=m}),define(Ee[92],_e([0,1,36,131,4]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var P;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(u,g){return g-u}_.compare=C;const n=Object.create(null);n[_.Error]=(0,R.localize)(0,null),n[_.Warning]=(0,R.localize)(1,null),n[_.Info]=(0,R.localize)(2,null);function T(u){return n[u]||""}_.toString=T;function l(u){switch(u){case f.default.Error:return _.Error;case f.default.Warning:return _.Warning;case f.default.Info:return _.Info;case f.default.Ignore:return _.Hint}}_.fromSeverity=l;function h(u){switch(u){case _.Error:return f.default.Error;case _.Warning:return f.default.Warning;case _.Info:return f.default.Info;case _.Hint:return f.default.Ignore}}_.toSeverity=h}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var E;(function(_){const C="";function n(l){return T(l,!0)}_.makeKey=n;function T(l,h){let u=[C];return l.source?u.push(l.source.replace("\xA6","\\\xA6")):u.push(C),l.code?typeof l.code=="string"?u.push(l.code.replace("\xA6","\\\xA6")):u.push(l.code.value.replace("\xA6","\\\xA6")):u.push(C),l.severity!==void 0&&l.severity!==null?u.push(P.toString(l.severity)):u.push(C),l.message&&h?u.push(l.message.replace("\xA6","\\\xA6")):u.push(C),l.startLineNumber!==void 0&&l.startLineNumber!==null?u.push(l.startLineNumber.toString()):u.push(C),l.startColumn!==void 0&&l.startColumn!==null?u.push(l.startColumn.toString()):u.push(C),l.endLineNumber!==void 0&&l.endLineNumber!==null?u.push(l.endLineNumber.toString()):u.push(C),l.endColumn!==void 0&&l.endColumn!==null?u.push(l.endColumn.toString()):u.push(C),u.push(C),u.join("\xA6")}_.makeKeyOptionalMessage=T})(E=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ee[154],_e([0,1,3,36,4]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,S.createDecorator)("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class E{constructor(){this.progress=new _,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=E;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(Ee[155],_e([0,1,6,8,2,4]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(E){return{resolved:E,dispose(){}}}});function P(E,_){return S.URI.isUri(E)?(0,R.equalsIgnoreCase)(E.scheme,_):(0,R.startsWithIgnoreCase)(E,_+":")}e.matchesScheme=P});var ze=this&&this.__decorate||function(Z,e,f,R){var S=arguments.length,y=S<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,f):R,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Z,e,f,R);else for(var E=Z.length-1;E>=0;E--)(P=Z[E])&&(y=(S<3?P(y):S>3?P(e,f,y):P(e,f))||y);return S>3&&y&&Object.defineProperty(e,f,y),y},Ve=this&&this.__param||function(Z,e){return function(f,R){e(f,R,Z)}};define(Ee[156],_e([0,1,15,20,6,4]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,y.createDecorator)("progressService");var P;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{constructor(T){this.callback=T}get value(){return this._value}report(T){this._value=T,this.callback(this._value)}}e.Progress=E,E.None=Object.freeze({report(){}});let _=class extends S.Disposable{constructor(T,l){super();this.deferred=new f.DeferredPromise,l.withProgress(T,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};_=ze([Ve(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends S.Disposable{constructor(T){super();this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(T){this.stop();const l=++this.currentOperationId,h=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:h.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,y.createDecorator)("editorProgressService")}),define(Ee[28],_e([0,1,41,10]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(P,E){f.ok(R.isString(P)),f.ok(R.isObject(E)),f.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,E)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new S}),define(Ee[93],_e([0,1,3,28]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class y{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[S(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new y;R.Registry.add(e.Extensions.JSONContribution,P)}),define(Ee[64],_e([0,1,3,10,128,93,28]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=P.Registry.as(y.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new f.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new f.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(A,o=!0){this.registerConfigurations([A],o)}registerConfigurations(A,o=!0){const m=[];A.forEach(v=>{m.push(...this.validateAndRegisterProperties(v,o,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(A){const o=[],m=v=>{if(v.properties)for(const t in v.properties)o.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>m(t))};for(const v of A){m(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(A){const o=[],m=[];for(const v of A)for(const t in v)if(o.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:S.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};m.push(l(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(A){const o=[];for(const m of A)for(const v in m)if(o.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...A){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(A){for(const o of A)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(A,o=!0,m,v=3){v=R.isUndefinedOrNull(A.scope)?v:A.scope;let t=[],r=A.properties;if(r)for(let i in r){if(o&&g(i)){delete r[i];continue}const c=r[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=R.isUndefinedOrNull(c.scope)?v:c.scope,c.restricted=R.isUndefinedOrNull(c.restricted)?!!m?.restrictedConfigurations?.includes(i):c.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let a=A.allOf;if(a)for(let i of a)t.push(...this.validateAndRegisterProperties(i,o,m,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(A){const o=m=>{let v=m.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=m.allOf;t&&t.forEach(o)};o(A)}updateSchema(A,o){switch(e.allSettings.properties[A]=o,o.scope){case 1:e.applicationSettings.properties[A]=o;break;case 2:e.machineSettings.properties[A]=o;break;case 6:e.machineOverridableSettings.properties[A]=o;break;case 3:e.windowSettings.properties[A]=o;break;case 4:e.resourceSettings.properties[A]=o;break;case 5:e.resourceSettings.properties[A]=o,this.resourceLanguageSettingsSchema.properties[A]=o;break}}removeFromSchema(A,o){switch(delete e.allSettings.properties[A],o.scope){case 1:delete e.applicationSettings.properties[A];break;case 2:delete e.machineSettings.properties[A];break;case 6:delete e.machineOverridableSettings.properties[A];break;case 3:delete e.windowSettings.properties[A];break;case 4:case 5:delete e.resourceSettings.properties[A];break}}updateOverridePropertyPatternKey(){for(const A of this.overrideIdentifiers.values()){const o=`[${A}]`,m={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,m),e.allSettings.properties[o]=m,e.applicationSettings.properties[o]=m,e.machineSettings.properties[o]=m,e.machineOverridableSettings.properties[o]=m,e.windowSettings.properties[o]=m,e.resourceSettings.properties[o]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(A,o){let m=this.defaultValues[A];R.isUndefined(m)&&(m=o.default),R.isUndefined(m)&&(m=h(o.type)),o.default=m}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function l(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=l;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new n;P.Registry.add(e.Extensions.Configuration,u);function g(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?S.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?S.localize(6,null,w):null:S.localize(4,null)}e.validateProperty=g;function b(){const w=[],A=u.getConfigurationProperties();for(const o of Object.keys(A))w.push([o,A[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=b}),define(Ee[94],_e([0,1,23,10,2,64,4,28]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function _(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof S.URI)}e.isConfigurationOverrides=_;var C;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function T(r,a){const i=a?r?a.keys.filter(k=>r.keys.indexOf(k)===-1):[...a.keys]:[],c=r?a?r.keys.filter(k=>a.keys.indexOf(k)===-1):[...r.keys]:[],p=[];if(a&&r){for(const k of r.keys)if(a.keys.indexOf(k)!==-1){const F=w(r.contents,k),x=w(a.contents,k);f.equals(F,x)||p.push(k)}}const d=[],D=k=>{const F={};for(const x of k)for(const j of x.identifiers)F[v(j)]=x;return F},I=a?D(a.overrides):{},s=r?D(r.overrides):{};if(Object.keys(I).length)for(const k of i){const F=I[k];F&&d.push([(0,y.overrideIdentifierFromKey)(k),F.keys])}if(Object.keys(s).length)for(const k of c){const F=s[k];F&&d.push([(0,y.overrideIdentifierFromKey)(k),F.keys])}if(Object.keys(I).length&&Object.keys(s).length)for(const k of p){const F=s[k],x=I[k];if(F&&x){const j=T({contents:F.contents,keys:F.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});d.push([(0,y.overrideIdentifierFromKey)(k),[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:c,updated:p,overrides:d}}e.compare=T;function l(r,a){const i=[];for(const c of Object.keys(r))if(y.OVERRIDE_PROPERTY_PATTERN.test(c)){const p={};for(const d in r[c])p[d]=r[c][d];i.push({identifiers:[(0,y.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(p),contents:h(p,a)})}return i}e.toOverrides=l;function h(r,a){const i=Object.create(null);for(let c in r)u(i,c,r[c],a);return i}e.toValuesTree=h;function u(r,a,i,c){const p=a.split("."),d=p.pop();let D=r;for(let I=0;I<p.length;I++){let s=p[I],k=D[s];switch(typeof k){case"undefined":k=D[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${a} as ${p.slice(0,I+1).join(".")} is ${JSON.stringify(k)}`);return}D=k}if(typeof D=="object"&&D!==null)try{D[d]=i}catch(I){c(`Ignoring ${a} as ${p.join(".")} is ${JSON.stringify(D)}`)}else c(`Ignoring ${a} as ${p.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=u;function g(r,a){const i=a.split(".");b(r,i)}e.removeFromValueTree=g;function b(r,a){const i=a.shift();if(a.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const c=r[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,a),Object.keys(c).length===0&&delete r[i])}}function w(r,a,i){function c(D,I){let s=D;for(const k of I){if(typeof s!="object"||s===null)return;s=s[k]}return s}const p=a.split("."),d=c(r,p);return typeof d=="undefined"?i:d}e.getConfigurationValue=w;function A(r,a,i){Object.keys(a).forEach(c=>{c!=="__proto__"&&(c in r?R.isObject(r[c])&&R.isObject(a[c])?A(r[c],a[c],i):i&&(r[c]=a[c]):r[c]=a[c])})}e.merge=A;function o(){const r=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=o;function m(){const r=Object.create(null),a=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let i in a){let c=a[i].default;u(r,i,c,p=>console.error(`Conflict in default settings: ${p}`))}return r}e.getDefaultValues=m;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,a,i){const c=r.inspect(a),p=r.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Ee[157],_e([0,1,17,3,111,6,21,23,10,2,94,64,28]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},r=[],a=[]){this._contents=t,this._keys=r,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const a=this.getContentsForOverrideIdentifer(r);return a?t?(0,n.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let a={};for(const i of f.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[i],p=r[i];p&&(typeof c=="object"&&typeof p=="object"?(c=E.deepClone(c),this.mergeContents(c,p)):c=p),a[i]=c}return new h(a,this.keys,this.overrides)}merge(...t){const r=E.deepClone(this.contents),a=E.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const p of c.overrides){const[d]=a.filter(D=>f.equals(D.identifiers,p.identifiers));d?this.mergeContents(d.contents,p.contents):a.push(E.deepClone(p))}for(const p of c.keys)i.indexOf(p)===-1&&i.push(p)}return new h(r,i,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const a of Object.keys(r)){if(a in t&&_.isObject(t[a])&&_.isObject(r[a])){this.mergeContents(t[a],r[a]);continue}t[a]=E.deepClone(r[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let a=0;a<r;a++)t.indexOf(this.keys[a])===0&&(r=a);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=h;class u extends h{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),a=[];for(const i of Object.keys(t))T.OVERRIDE_PROPERTY_PATTERN.test(i)&&a.push({identifiers:[(0,T.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,a)}}e.DefaultConfigurationModel=u;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!_.isUndefinedOrNull(t)){const a=this.doParseContent(t);this.parseRaw(a,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:a,keys:i,overrides:c,restricted:p}=this.doParseRaw(t,r);this._configurationModel=new h(a,i,c),this._restrictedConfigurations=p||[]}doParseContent(t){let r={},a=null,i=[],c=[],p=[];function d(I){Array.isArray(i)?i.push(I):a!==null&&(i[a]=I)}let D={onObjectBegin:()=>{let I={};d(I),c.push(i),i=I,a=null},onObjectProperty:I=>{a=I},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let I=[];d(I),c.push(i),i=I,a=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:d,onError:(I,s,k)=>{p.push({error:I,offset:s,length:k})}};if(t)try{S.visit(t,D),r=i[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return r}doParseRaw(t,r){const a=l.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,a,!0,r);t=i.raw;const c=(0,n.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),p=Object.keys(t),d=(0,n.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:c,keys:p,overrides:d,restricted:i.restricted}}filter(t,r,a,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},p=[];for(let d in t)if(T.OVERRIDE_PROPERTY_PATTERN.test(d)&&a){const D=this.filter(t[d],r,!1,i);c[d]=D.raw,p.push(...D.restricted)}else{const D=r[d],I=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&p.push(d),(I===void 0||i.scopes===void 0||i.scopes.includes(I))&&(i.skipRestricted&&D?.restricted||(c[d]=t[d]))}return{raw:c,restricted:p}}}e.ConfigurationModelParser=g;class b extends y.Disposable{constructor(t,r,a,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(t,r,a=new h,i=new h,c=new P.ResourceMap,p=new h,d=new P.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=p,this._memoryConfigurationByResource=d,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,r,a){return this.getConsolidateConfigurationModel(r,a).getValue(t)}updateValue(t,r,a={}){let i;a.resource?(i=this._memoryConfigurationByResource.get(a.resource),i||(i=new h,this._memoryConfigurationByResource.set(a.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,a){const i=this.getConsolidateConfigurationModel(r,a),c=this.getFolderConfigurationModelForResource(r.resource,a),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),I=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),s=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=a?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,x=r.overrideIdentifier?p.override(r.overrideIdentifier).getValue(t):p.getValue(t),j=i.getValue(t),oe=f.distinct(f.flatten(i.overrides.map(se=>se.identifiers))).filter(se=>i.getOverrideValue(t,se)!==void 0);return{defaultValue:d,userValue:D,userLocalValue:I,userRemoteValue:s,workspaceValue:k,workspaceFolderValue:F,memoryValue:x,value:j,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:s!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:p.getValue(t),override:r.overrideIdentifier?p.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const a=r.filter(i=>T.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,T.overrideIdentifierFromKey)(i),p=this._defaultConfiguration.getKeysForOverrideIdentifier(c),d=t.getKeysForOverrideIdentifier(c),D=[...d.filter(I=>p.indexOf(I)===-1),...p.filter(I=>d.indexOf(I)===-1),...p.filter(I=>!E.equals(this._defaultConfiguration.override(c).getValue(I),t.override(c).getValue(I)))];return[c,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:a,removed:i,overrides:c}=(0,n.compare)(this.localUserConfiguration,t),p=[...r,...a,...i];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:a,removed:i,overrides:c}=(0,n.compare)(this.remoteUserConfiguration,t);let p=[...r,...a,...i];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:a,removed:i,overrides:c}=(0,n.compare)(this.workspaceConfiguration,t);let p=[...r,...a,...i];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const a=this.folderConfigurations.get(t),{added:i,updated:c,removed:p,overrides:d}=(0,n.compare)(a,r);let D=[...i,...c,...p];return(D.length||!a)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:i,removed:c,overrides:p}=(0,n.compare)(r,void 0);return{keys:[...a,...i,...c],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let a=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},r){let a=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(a=this.getFolderConsolidatedConfiguration(i.uri)||a);const c=this._memoryConfigurationByResource.get(t);c&&(a=a.merge(c))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const a=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=a.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=a}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const a=r.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:a,overrides:i,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:a,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((p,d)=>(p.set(C.URI.revive(d[0]),this.parseConfigurationModel(d[1])),p),new P.ResourceMap);return new w(r,a,new h,i,c,new h,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function A(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,p])=>{const d=(0,P.getOrSet)(r,c,new Set);p.forEach(D=>d.add(D))});const a=[];return r.forEach((i,c)=>a.push([c,[...i.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=A;class o{constructor(t,r,a,i){this.change=t,this.previous=r,this.currentConfiguraiton=a,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(d=>c.add(d)),t.overrides.forEach(([,d])=>d.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const p=new h;this.affectedKeys.forEach(d=>p.setValue(d,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!E.equals(a,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let a=(0,n.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof a=="object"&&(i=Object.keys(a)[0]);){if(t=t[i],!t)return!1;a=a[i]}return!0}}e.ConfigurationChangeEvent=o;class m extends o{constructor(t,r,a,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=a,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=m}),define(Ee[95],_e([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(P,E=R.Unknown,_){super(P);this._message=P,this._code=E,this._detail=_,this.isHandled=E===R.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(P){return P instanceof S&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof S&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof S&&P.isHandled}}e.RemoteAuthorityResolverError=S}),define(Ee[96],_e([0,1,11]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(C){return C.scheme===f.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=R;function S(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=S;function y(C){return C.scheme!==f.Schemas.file&&C.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=y;function P(C){if(C.folders.length)return C.folders.every(n=>y(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=P;function E(C){return P(C)?.scheme}e.getVirtualWorkspaceScheme=E;function _(C){return P(C)!==void 0}e.isVirtualWorkspace=_}),define(Ee[158],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,y,P=5){let E;return E=y(_=>{const C=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(C);return}const T=setTimeout(()=>this.flushBuffer(S),P);n={data:[C],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(S),E.dispose()}},this._terminalBufferMap.set(S,n)}),E}stopBuffering(S){const y=this._terminalBufferMap.get(S);y&&y.dispose()}flushBuffer(S){const y=this._terminalBufferMap.get(S);y&&(this._terminalBufferMap.delete(S),this._callback(S,y.data.join("")))}}e.TerminalDataBufferer=f}),define(Ee[159],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[65],_e([0,1,35,3,6,4,28,159]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,y.createDecorator)("themeService");var _;(function(b){function w(A){return A&&typeof A=="object"&&typeof A.id=="string"}b.isThemeColor=w})(_=e.ThemeColor||(e.ThemeColor={}));function C(b){return{id:b}}e.themeColorFromId=C;var n;(function(b){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||_.isThemeColor(r.color))}b.isThemeIcon=w;const A=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function o(r){const a=A.exec(r);if(!a)return;let[,i]=a;return{id:i}}b.fromString=o;function m(r,a){let i=r.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),a&&(i=`${i}~${a}`),{id:i}}b.modify=m;function v(r,a){return r.id===a.id&&r.color?.id===a.color?.id}b.isEqual=v;function t(r,a){return{id:r.id,color:a?C(a):void 0}}b.asThemeIcon=t,b.asClassNameArray=f.CSSIcon.asClassNameArray,b.asClassName=f.CSSIcon.asClassName,b.asCSSSelector=f.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function T(b){switch(b){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,S.toDisposable)(()=>{const A=this.themingParticipants.indexOf(w);this.themingParticipants.splice(A,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new l;P.Registry.add(e.Extensions.ThemingContribution,h);function u(b){return h.onColorThemeChange(b)}e.registerThemingParticipant=u;class g extends S.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(A=>this.onThemeChange(A)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,A){let o=this.theme.getColor(w);return o&&A&&(o=A(o,this.theme)),o?o.toString():null}}e.Themable=g}),define(Ee[160],_e([0,1,15,35,3,132,93,28,65]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${R.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,A,o,m){const v=this.iconsById[w];if(v){if(o&&!v.description){v.description=o,this.iconSchema.properties[w].markdownDescription=`${o} $(${w})`;const a=this.iconReferenceSchema.enum.indexOf(w);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=o),this._onDidChange.fire()}return v}let t={id:w,description:o,defaults:A,deprecationMessage:m};this.iconsById[w]=t;let r={$ref:"#/definitions/icons"};return m&&(r.deprecationMessage=m),o&&(r.markdownDescription=`${o}: $(${w})`),this.iconSchema.properties[w]=r,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const A=this.iconReferenceSchema.enum.indexOf(w);A!==-1&&(this.iconReferenceSchema.enum.splice(A,1),this.iconReferenceSchema.enumDescriptions.splice(A,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,A){const o=this.iconFontsById[w];if(o)return o;let m={id:w,definition:A};return this.iconFontsById[w]=m,this._onDidChange.fire(),m}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),A=v=>{for(;_.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of m.filter(t=>!!t.description).sort(w))o.push(`|<i class="${A(v)}"></i>|${v.id}|${_.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const v of m.filter(t=>!_.ThemeIcon.isThemeIcon(t.defaults)).sort(w))o.push(`|<i class="${A(v)}"></i>|${v.id}|`);return o.join(`
`)}}const n=new C;E.Registry.add(e.Extensions.IconContribution,n);function T(b,w,A,o){return n.registerIcon(b,w,A,o)}e.registerIcon=T;function l(){return n}e.getIconRegistry=l;function h(){for(const b of R.iconRegistry.all)n.registerIcon(b.id,b.definition,b.description);R.iconRegistry.onDidRegister(b=>n.registerIcon(b.id,b.definition,b.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let u=E.Registry.as(P.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const g=new f.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=T("widget-close",R.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=T("goto-previous-location",R.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=T("goto-next-location",R.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=_.ThemeIcon.modify(R.Codicon.sync,"spin")}),define(Ee[46],_e([0,1,21,25,2,4]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");var P;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function E(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=E;function _(l){const h=l;return!!(h&&typeof h=="object"&&S.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(h,u,g,b){this._id=h,this._configuration=g,this._ignorePathCasing=b,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(h,u){this.raw=u,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,R.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function T(l){return new n({uri:l,index:0,name:(0,R.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=T}),define(Ee[66],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const y=this._idPool++;return this._data.set(y,S),this.logDebugInfo(),y}get(S,y){return this._data.has(S)?this._data.get(S)[y]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(Ee[67],_e([0,1,2,3,4]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(E){this._tabs=E.map(_=>({name:_.name,group:_.group,resource:f.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(Ee[47],_e([0,1,11,4]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(P,E){E===null?this._providerInfo.delete(P):this._providerInfo.set(P,E)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[29],_e([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(Ee[161],_e([0,1,15]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(P,E,_){this._deferredPromises=new Map,this._id=P,this._shared=E,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const T of C.values())T.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,E){let _=this._value[P];return typeof _=="undefined"&&(_=E),_}update(P,E){this._value[P]=E;let _=this._deferredPromises.get(P);if(_!==void 0)return _.p;const C=new f.DeferredPromise;return this._deferredPromises.set(P,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class S extends R{constructor(P,E){super(P.identifier.value,!0,E);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=S}),define(Ee[162],_e([0,1,3,2,16]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(E,_){this._logService=E,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(E,_,C){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(E,_){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E)).acceptDirty(_)}$acceptModelSaved(E){const _=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(E,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",E.path,_);const C=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=ze([Ve(0,S.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(Ee[13],_e([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[163],_e([0,1,26,3]),function(Z,e,f,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(E,_){S.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(E.identifier),it(this,S,_,"f"),Be(this,S,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(E){return Be(this,S,"f").get(this._id,E)}store(E,_){return Be(this,S,"f").store(this._id,E,_)}delete(E){return Be(this,S,"f").delete(this._id,E)}}e.ExtensionSecrets=y,S=new WeakMap}),define(Ee[97],_e([0,1,4,3]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(Ee[68],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(A){A[A.Upsert=0]="Upsert",A[A.RemoveChild=1]="RemoveChild",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp",A[A.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,S=(A,o)=>{const m={controllerId:o};return R.set(A,m),m};e.createPrivateApiFor=S;const y=A=>R.get(A);e.getPrivateApiFor=y;const P=(A,o,m,v)=>{let t=m;return{enumerable:!0,configurable:!1,get(){return t},set(r){v(t,r)||(t=r,A.listener?.({op:3,key:o,value:r}))}}},E=(A,o)=>A===o,_={range:(A,o)=>A===o?!0:!A||!o?!1:A.isEqual(o),label:E,description:E,busy:E,error:E,canResolveChildren:E,tags:(A,o)=>!(A.length!==o.length||A.some(m=>!o.find(v=>m.id===v.id)))},C=Object.keys(_),n=(A,o)=>({range:P(A,"range",void 0,_.range),label:P(A,"label",o,_.label),description:P(A,"description",void 0,_.description),canResolveChildren:P(A,"canResolveChildren",!1,_.canResolveChildren),busy:P(A,"busy",!1,_.busy),error:P(A,"error",void 0,_.error),tags:P(A,"tags",[],_.tags)}),T=(A,o)=>{const m=new Map;for(const v of C)_[v](A[v],o[v])||m.set(v,o[v]);return m};e.diffTestItems=T;class l extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=l;class h extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class u extends Error{constructor(o,m,v){super(`TestItem with ID "${o}" is from controller "${m}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=u;const g=A=>{const o=(0,e.getPrivateApiFor)(A);let m=new Map;return{get size(){return m.size},forEach(v,t){for(const r of m.values())v.call(t,r,this)},replace(v){const t=new Map,r=new Set(m.keys()),a={op:4,ops:[]};for(const i of v){if(!(i instanceof b))throw new h(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==o.controllerId)throw new u(i.id,c,o.controllerId);if(t.has(i.id))throw new l(i.id);t.set(i.id,i),r.delete(i.id),a.ops.push({op:0,item:i})}for(const i of r.keys())a.ops.push({op:1,id:i});o.listener?.(a),m=t},add(v){if(!(v instanceof b))throw new h(v.id);m.set(v.id,v),o.listener?.({op:0,item:v})},delete(v){m.delete(v)&&o.listener?.({op:1,id:v})},get(v){return m.get(v)},toJSON(){return Array.from(m.values())},[Symbol.iterator](){return m.values()}}};class b{constructor(o,m,v,t){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const r=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof w?void 0:r.parent}},children:{value:g(this),enumerable:!0,writable:!1},...n(r,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=b;class w extends b{constructor(o,m){super(o,o,m,void 0)}}e.TestItemRootImpl=w}),define(Ee[69],_e([0,1,4,3,13]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(E){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}E.fromApiTunnel=_;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}E.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let P=class{constructor(_){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,n,T,l){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=ze([Ve(0,S.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[7],_e([0,1,17,12,83,21,85,10,2,37,62,95]),function(Z,e,f,R,S,y,P,E,_,C,n,T){"use strict";var l,h,u,g,b,w,A,o,m,v,t,r,a,i,c,p,d,D,I,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let F=b=class{constructor(L){l.set(this,void 0),it(this,l,L,"f")}static from(...L){let ee=L;return new b(function(){if(ee){for(const ke of ee)ke&&typeof ke.dispose=="function"&&ke.dispose();ee=void 0}})}dispose(){typeof Be(this,l,"f")=="function"&&(Be(this,l,"f").call(this),it(this,l,void 0,"f"))}};l=new WeakMap,F=b=ze([k],F),e.Disposable=F;let x=w=class{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("line must be non-negative");if(ee<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let ke=1;ke<L.length;ke++){const Ye=L[ke];Ye.isBefore(ee)&&(ee=Ye)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let ke=1;ke<L.length;ke++){const Ye=L[ke];Ye.isAfter(ee)&&(ee=Ye)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:ee,character:ke}=L;return typeof ee=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,R.illegalArgument)();let ke;return typeof L=="undefined"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&ee===0?this:new w(this.line+ke,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,R.illegalArgument)();let ke;return typeof L=="undefined"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),ke===this.line&&ee===this.character?this:new w(ke,ee)}toJSON(){return{line:this.line,character:this.character}}};x=w=ze([k],x),e.Position=x;let j=A=class{constructor(L,ee,ke,Ye){let nt,st;if(typeof L=="number"&&typeof ee=="number"&&typeof ke=="number"&&typeof Ye=="number"?(nt=new x(L,ee),st=new x(ke,Ye)):L instanceof x&&ee instanceof x&&(nt=L,st=ee),!nt||!st)throw new Error("Invalid arguments");nt.isBefore(st)?(this._start=nt,this._end=st):(this._start=st,this._end=nt)}static isRange(L){return L instanceof A?!0:L?x.isPosition(L.start)&&x.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof A?this.contains(L._start)&&this.contains(L._end):L instanceof x?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=x.Max(L.start,this._start),ke=x.Min(L.end,this._end);if(!ee.isAfter(ke))return new A(ee,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=x.Min(L.start,this._start),ke=x.Max(L.end,this.end);return new A(ee,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,R.illegalArgument)();let ke;return L?x.isPosition(L)?ke=L:(ke=L.start||this.start,ee=L.end||this.end):ke=this.start,ke.isEqual(this._start)&&ee.isEqual(this.end)?this:new A(ke,ee)}toJSON(){return[this.start,this.end]}};j=A=ze([k],j),e.Range=j;let oe=o=class extends j{constructor(L,ee,ke,Ye){let nt,st;if(typeof L=="number"&&typeof ee=="number"&&typeof ke=="number"&&typeof Ye=="number"?(nt=new x(L,ee),st=new x(ke,Ye)):L instanceof x&&ee instanceof x&&(nt=L,st=ee),!nt||!st)throw new Error("Invalid arguments");super(nt,st);this._anchor=nt,this._active=st}static isSelection(L){return L instanceof o?!0:L?j.isRange(L)&&x.isPosition(L.anchor)&&x.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};oe=o=ze([k],oe),e.Selection=oe;class se{constructor(L,ee,ke){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,R.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,R.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=ke}}e.ResolvedAuthority=se;class V extends Error{constructor(L,ee=T.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L);this._message=L,this._code=ee,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(L,ee){return new V(L,T.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new V(L,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var H;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var M;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=m=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof m?!0:L?j.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new m(L,ee)}static insert(L,ee){return m.replace(new j(L,L),ee)}static delete(L){return m.replace(L,"")}static setEndOfLine(L){const ee=new m(new j(new x(0,0),new x(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!j.isRange(L))throw(0,R.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,R.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,R.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Q=m=ze([k],Q),e.TextEdit=Q;var O;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,ke,Ye){this._edits.push({_type:1,from:L,to:ee,options:ke,metadata:Ye})}createFile(L,ee,ke){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:ke})}deleteFile(L,ee,ke){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:ke})}replaceNotebookMetadata(L,ee,ke){this._edits.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,ke,Ye,nt){let st,ut,St=[],At;if(Bt.isNotebookRange(ee)&&Ft.isNotebookCellDataArray(ke)&&!Ft.isNotebookCellDataArray(Ye)?(st=ee.start,ut=ee.end,St=ke,At=Ye):typeof ee=="number"&&typeof ke=="number"&&Ft.isNotebookCellDataArray(Ye)&&(st=ee,ut=ke,St=Ye,At=nt),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||St.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:ut-st,cells:St,metadata:At})}replaceNotebookCellMetadata(L,ee,ke,Ye){this._edits.push({_type:3,metadata:Ye,uri:L,edit:{editType:8,index:ee,metadata:ke}})}replace(L,ee,ke,Ye){this._edits.push({_type:2,uri:L,edit:new Q(ee,ke),metadata:Ye})}insert(L,ee,ke,Ye){this.replace(L,new j(ee,ee),ke,Ye)}delete(L,ee,ke){this.replace(L,ee,"",ke)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const ke of ee)ke&&this._edits.push({_type:2,uri:L,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ye=this._edits[ke];Ye._type===2&&Ye.uri.toString()===L.toString()&&(this._edits[ke]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(L){const ee=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===L.toString()&&ee.push(ke.edit);return ee}entries(){const L=new y.ResourceMap;for(let ee of this._edits)if(ee._type===2){let ke=L.get(ee.uri);ke||(ke=[ee.uri,[]],L.set(ee.uri,ke)),ke[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=ze([k],G),e.WorkspaceEdit=G;let fe=v=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof v?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=v._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const ke=new v;ke._tabstop=this._tabstop,L(ke),this._tabstop=ke._tabstop,L=ke.value}else L=v._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const ke=L.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const ke=new v;ke._tabstop=this._tabstop,ee(ke),this._tabstop=ke._tabstop,ee=ke.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};fe=v=ze([k],fe),e.SnippetString=fe;var W;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var te;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(te=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let he=t=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof j)this.range=ee;else if(ee instanceof x)this.range=new j(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof t?!0:L?j.isRange(L.range)&&_.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};he=t=ze([k],he),e.Location=he;let Se=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&j.isRange(L.location.range)&&_.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};Se=ze([k],Se),e.DiagnosticRelatedInformation=Se;let Le=class{constructor(L,ee,ke=te.Error){if(!j.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=ke}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,f.equals)(L.tags,ee.tags)&&(0,f.equals)(L.relatedInformation,ee.relatedInformation,Se.isEqual)}};Le=ze([k],Le),e.Diagnostic=Le;let Me=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ee}};Me=ze([k],Me),e.Hover=Me;var $e;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Xe=class{constructor(L,ee=$e.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Xe=ze([k],Xe),e.DocumentHighlight=Xe;var qe;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(N){N[N.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let U=r=class{constructor(L,ee,ke,Ye,nt){this.name=L,this.kind=ee,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Ye instanceof he?this.location=Ye:ke instanceof j&&(this.location=new he(Ye,ke)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};U=r=ze([k],U),e.SymbolInformation=U;let K=a=class{constructor(L,ee,ke,Ye,nt){this.name=L,this.detail=ee,this.kind=ke,this.range=Ye,this.selectionRange=nt,this.children=[],a.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(a.validate)}};K=a=ze([k],K),e.DocumentSymbol=K;var J;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(L,ee){this.title=L,this.kind=ee}};ie=ze([k],ie),e.CodeAction=ie;let q=i=class{constructor(L){this.value=L}append(L){return new i(this.value?this.value+i.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=ze([k],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ne=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ne=ze([k],ne),e.SelectionRange=ne;class pe{constructor(L,ee,ke,Ye,nt,st){this.kind=L,this.name=ee,this.detail=ke,this.uri=Ye,this.range=nt,this.selectionRange=st}}e.CallHierarchyItem=pe;class Re{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=Re;class We{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=We;var we;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(we=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};Je=ze([k],Je),e.CodeLens=Je;let z=c=class{constructor(L,ee=!1){h.set(this,void 0),it(this,h,new S.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof c?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Be(this,h,"f").value}set value(L){Be(this,h,"f").value=L}get isTrusted(){return Be(this,h,"f").isTrusted}set isTrusted(L){Be(this,h,"f").isTrusted=L}get supportThemeIcons(){return Be(this,h,"f").supportThemeIcons}set supportThemeIcons(L){Be(this,h,"f").supportThemeIcons=L}appendText(L){return Be(this,h,"f").appendText(L),this}appendMarkdown(L){return Be(this,h,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return Be(this,h,"f").appendCodeblock(ee??"",L),this}};h=new WeakMap,z=c=ze([k],z),e.MarkdownString=z;let X=class{constructor(L,ee){this.label=L,this.documentation=ee}};X=ze([k],X),e.ParameterInformation=X;let de=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};de=ze([k],de),e.SignatureInformation=de;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=ze([k],Ue),e.SignatureHelp=Ue;var xe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Ce=class{constructor(L,ee,ke){this.text=L,this.position=ee,this.kind=ke}};Ce=ze([k],Ce),e.InlayHint=Ce;var De;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Pe;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Pe=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(N){N[N.Deprecated=1]="Deprecated"})(re=e.CompletionItemTag||(e.CompletionItemTag={}));let ae=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ae=ze([k],ae),e.CompletionItem=ae;let me=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};me=ze([k],me),e.CompletionList=me;let ve=class{constructor(L,ee,ke){this.text=L,this.range=ee,this.command=ke}};ve=ze([k],ve),e.InlineSuggestion=ve;let B=class{constructor(L){this.items=L}};B=ze([k],B),e.InlineSuggestions=B;var ge;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ge=e.ViewColumn||(e.ViewColumn={}));var be;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(be=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Oe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var He;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(He=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ke;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Ke=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(ee){switch(ee){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let lt=class{constructor(L,ee){if(ee&&!_.URI.isUri(ee))throw(0,R.illegalArgument)("target");if(!j.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.target=ee}};lt=ze([k],lt),e.DocumentLink=lt;let ht=class{constructor(L,ee,ke,Ye){this.red=L,this.green=ee,this.blue=ke,this.alpha=Ye}};ht=ze([k],ht),e.Color=ht;let Et=class{constructor(L,ee){if(ee&&!(ee instanceof ht))throw(0,R.illegalArgument)("color");if(!j.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.color=ee}};Et=ze([k],Et),e.ColorInformation=Et;let ot=class{constructor(L){if(!L||typeof L!="string")throw(0,R.illegalArgument)("label");this.label=L}};ot=ze([k],ot),e.ColorPresentation=ot;var at;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var Dt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ye{constructor(L,ee,ke){if(this.startIndex=L,this.length=ee,this.tooltip=ke,typeof L!="number"||L<0)throw(0,R.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,R.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=ye;class ce{constructor(L){this.options=L,typeof L!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=ce;var le;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(le=e.TaskRevealKind||(e.TaskRevealKind={}));var $;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})($=e.TaskPanelKind||(e.TaskPanelKind={}));let Ae=p=class{constructor(L,ee){if(typeof L!="string"||typeof ee!="string")throw(0,R.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};Ae.Clean=new p("clean","Clean"),Ae.Build=new p("build","Build"),Ae.Rebuild=new p("rebuild","Rebuild"),Ae.Test=new p("test","Test"),Ae=p=ze([k],Ae),e.TaskGroup=Ae;function Ne(N){let L="";for(let ee=0;ee<N.length;ee++)L+=N[ee].replace(/,/g,",,")+",";return L}let tt=class{constructor(L,ee,ke){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=ke):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return Ne(L)}};tt=ze([k],tt),e.ProcessExecution=tt;let je=class{constructor(L,ee,ke){if(this._args=[],Array.isArray(ee)){if(!L)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L,this._args=ee,this._options=ke}else{if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return Ne(L)}};je=ze([k],je),e.ShellExecution=je;var gt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=kt;let ft=d=class{constructor(L,ee,ke,Ye,nt,st){this.__deprecated=!1,this._definition=this.definition=L;let ut;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=ke,this.execution=Ye,ut=nt,this.__deprecated=!0):ee===bt.Global||ee===bt.Workspace?(this.target=ee,this._name=this.name=ke,this._source=this.source=Ye,this.execution=nt,ut=st):(this.target=ee,this._name=this.name=ke,this._source=this.source=Ye,this.execution=nt,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof tt?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof je?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(d.EmptyType===ee||d.ProcessType===ee||d.ShellType===ee||d.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=d=ze([k],ft),e.Task=ft;var ct;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(L,ee=_t.None){this.collapsibleState=ee,_.URI.isUri(L)?this.resourceUri=L:this.label=L}};mt=ze([k],mt),e.TreeItem=mt;var _t;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(L,ee){this.id=L,this.color=ee}};Tt=ze([k],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor(L){this.id=L}};It=ze([k],It),e.ThemeColor=It;var bn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(L,ee){if(typeof L!="string"&&(!L||!_.URI.isUri(L)&&!_.URI.isUri(L.uri)))throw(0,R.illegalArgument)("base");if(typeof ee!="string")throw(0,R.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=_.URI.file(L),this.base=L):_.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};Vt=ze([k],Vt),e.RelativePattern=Vt;let yt=class{constructor(L,ee,ke,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof ke=="string"&&(this.hitCondition=ke),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};yt=ze([k],yt),e.Breakpoint=yt;let Yt=class extends yt{constructor(L,ee,ke,Ye,nt){super(ee,ke,Ye,nt);if(L===null)throw(0,R.illegalArgument)("location");this.location=L}};Yt=ze([k],Yt),e.SourceBreakpoint=Yt;let Jt=class extends yt{constructor(L,ee,ke,Ye,nt){super(ee,ke,Ye,nt);this.functionName=L}};Jt=ze([k],Jt),e.FunctionBreakpoint=Jt;let pt=class extends yt{constructor(L,ee,ke,Ye,nt,st,ut){super(Ye,nt,st,ut);if(!ee)throw(0,R.illegalArgument)("dataId");this.label=L,this.dataId=ee,this.canPersist=ke}};pt=ze([k],pt),e.DataBreakpoint=pt;let qt=class{constructor(L,ee,ke){this.command=L,this.args=ee||[],this.options=ke}};qt=ze([k],qt),e.DebugAdapterExecutable=qt;let Wt=class{constructor(L,ee){this.port=L,this.host=ee}};Wt=ze([k],Wt),e.DebugAdapterServer=Wt;let Xt=class{constructor(L){this.path=L}};Xt=ze([k],Xt),e.DebugAdapterNamedPipeServer=Xt;let Zt=class{constructor(L){this.implementation=L}};Zt=ze([k],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor(L,ee){this.range=L,this.expression=ee}};Pt=ze([k],Pt),e.EvaluatableExpression=Pt;var dn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(L,ee){this.range=L,this.text=ee}};en=ze([k],en),e.InlineValueText=en;let xt=class{constructor(L,ee,ke=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=ke}};xt=ze([k],xt),e.InlineValueVariableLookup=xt;let dt=class{constructor(L,ee){this.range=L,this.expression=ee}};dt=ze([k],dt),e.InlineValueEvaluatableExpression=dt;let tn=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};tn=ze([k],tn),e.InlineValueContext=tn;var Lt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Lt=e.FileChangeType||(e.FileChangeType={}));let Nt=D=class extends Error{constructor(L,ee=n.FileSystemProviderErrorCode.Unknown,ke){super(_.URI.isUri(L)?L.toString(!0):L);this.code=ke?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(L){return new D(L,n.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(L){return new D(L,n.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(L){return new D(L,n.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(L){return new D(L,n.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(L){return new D(L,n.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(L){return new D(L,n.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Nt=D=ze([k],Nt),e.FileSystemError=Nt;let jt=class{constructor(L,ee,ke){this.start=L,this.end=ee,this.kind=ke}};jt=ze([k],jt),e.FoldingRange=jt;var En;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=fn;function nn(N){return typeof N=="undefined"||(0,E.isStringArray)(N)}class rn{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,ke=L.tokenTypes.length;ee<ke;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,ke=L.tokenModifiers.length;ee<ke;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,ke,Ye,nt){if(typeof L=="number"&&typeof ee=="number"&&typeof ke=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(L,ee,ke,Ye,nt);if(j.isRange(L)&&typeof ee=="string"&&nn(ke))return this._push(L,ee,ke);throw(0,R.illegalArgument)()}_push(L,ee,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ye=L.start.line,nt=L.start.character,st=L.end.character-L.start.character,ut=this._tokenTypeStrToInt.get(ee);let St=0;if(ke)for(const At of ke){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);St|=1<<Rt>>>0}this._pushEncoded(Ye,nt,st,ut,St)}_pushEncoded(L,ee,ke,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Rt=0;for(let Mt=0;Mt<St;Mt++){let Ot=this._data[5*Mt],un=this._data[5*Mt+1];Ot===0?(Ot=At,un+=Rt):Ot+=At,this._data[5*Mt]=Ot,this._data[5*Mt+1]=un,At=Ot,Rt=un}}let st=L,ut=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const ke=L.length/5|0;for(let ut=0;ut<ke;ut++)ee[ut]=ut;ee.sort((ut,St)=>{const At=L[5*ut],Rt=L[5*St];if(At===Rt){const Mt=L[5*ut+1],Ot=L[5*St+1];return Mt-Ot}return At-Rt});const Ye=new Uint32Array(L.length);let nt=0,st=0;for(let ut=0;ut<ke;ut++){const St=5*ee[ut],At=L[St+0],Rt=L[St+1],Mt=L[St+2],Ot=L[St+3],un=L[St+4],xn=At-nt,Gn=xn===0?Rt-st:Rt,cn=5*ut;Ye[cn+0]=xn,Ye[cn+1]=Gn,Ye[cn+2]=Mt,Ye[cn+3]=Ot,Ye[cn+4]=un,nt=At,st=Rt}return Ye}build(L){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),L):new Ht(rn._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=rn;class Ht{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=Ht;class sn{constructor(L,ee,ke){this.start=L,this.deleteCount=ee,this.data=ke}}e.SemanticTokensEdit=sn;class yn{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=yn;var Sn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=ze([k],Gt),e.QuickInputButtons=Gt;var Dn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(L,ee,ke){this.badge=L,this.tooltip=ee,this.color=ke}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor(L){this.kind=L}};on=ze([k],on),e.ColorTheme=on;var an;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("start must be positive");if(ee<0)throw(0,R.illegalArgument)("end must be positive");L<=ee?(this._start=L,this._end=ee):(this._start=ee,this._end=L)}static isNotebookRange(L){return L instanceof Bt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,ke=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(ke=L.end),ee===this._start&&ke===this._end?this:new Bt(ee,ke)}}e.NotebookRange=Bt;class Ft{constructor(L,ee,ke,Ye,nt,st,ut){this.kind=L,this.value=ee,this.languageId=ke,this.mime=Ye,this.outputs=nt??[],this.metadata=st,this.executionSummary=ut,Ft.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>Ft.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ft;class Kt{constructor(L){this.cells=L}}e.NotebookData=Kt;class Fe{constructor(L,ee){this.data=L,this.mime=ee;const ke=(0,P.normalizeMimeType)(ee,!0);if(!ke)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(L){return L instanceof Fe?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return Fe.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return Fe.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Fe.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new Fe(L,ee)}static text(L,ee=P.Mimes.text){const ke=Be(Fe,u,"f",g).encode(String(L));return new Fe(ke,ee)}static json(L,ee="application/json"){const ke=JSON.stringify(L,void 0,"	");return Fe.text(ke,ee)}}e.NotebookCellOutputItem=Fe,u=Fe,g={value:new TextEncoder};class $t{constructor(L,ee,ke){this.items=$t.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=ke):(this.id=(0,C.generateUuid)(),this.metadata=ee??ke)}static isNotebookCellOutput(L){return L instanceof $t?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,E.isArray)(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const ke=new Set,Ye=new Set;for(let nt=0;nt<L.length;nt++){const st=L[nt],ut=(0,P.normalizeMimeType)(st.mime);if(!ke.has(ut)){ke.add(ut);continue}Ye.add(nt),ee&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ye.size===0?L:L.filter((nt,st)=>!Ye.has(st))}}e.NotebookCellOutput=$t;var mn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var vt;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(vt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(L,ee){this.text=L,this.alignment=ee}}e.NotebookCellStatusBarItem=gn;var pn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(L,ee=[]){this.uri=L,this.provides=(0,f.asArray)(ee)}}e.NotebookRendererScript=Pn;let ln=class{constructor(L,ee){this.label=L,this.timestamp=ee}};ln=ze([k],ln),e.TimelineItem=ln;var An;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=Rn;class Fn{constructor(L,ee){this._port=L,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var Ln;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(Ln=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Y=class{constructor(L,ee,ke){this.include=L,this.exclude=ee,this.profile=ke}};Y=ze([k],Y),e.TestRunRequest=Y;let ue=I=class{constructor(L){this.message=L}static diff(L,ee,ke){const Ye=new I(L);return Ye.expectedOutput=ee,Ye.actualOutput=ke,Ye}};ue=I=ze([k],ue),e.TestMessage=ue;let Te=class{constructor(L,ee){this.id=L,this.label=ee}};Te=ze([k],Te),e.TestTag=Te;let rt=class{constructor(L,ee){this.covered=L,this.total=ee}};rt=ze([k],rt),e.CoveredCount=rt;let wt=s=class{constructor(L,ee,ke,Ye){this.uri=L,this.statementCoverage=ee,this.branchCoverage=ke,this.functionCoverage=Ye}static fromDetails(L,ee){const ke=new rt(0,0),Ye=new rt(0,0),nt=new rt(0,0);for(const ut of ee)if("branches"in ut){ke.total+=1,ke.covered+=ut.executionCount>0?1:0;for(const St of ut.branches)Ye.total+=1,Ye.covered+=St.executionCount>0?1:0}else nt.total+=1,nt.covered+=ut.executionCount>0?1:0;const st=new s(L,ke,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return st.detailedCoverage=ee,st}};wt=s=ze([k],wt),e.FileCoverage=wt;let Ct=class{constructor(L,ee,ke=[]){this.executionCount=L,this.location=ee,this.branches=ke}};Ct=ze([k],Ct),e.StatementCoverage=Ct;let On=class{constructor(L,ee){this.executionCount=L,this.location=ee}};On=ze([k],On),e.BranchCoverage=On;let Un=class{constructor(L,ee){this.executionCount=L,this.location=ee}};Un=ze([k],Un),e.FunctionCoverage=Un;var zn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class jn{constructor(L,ee,ke,Ye,nt,st){this.kind=L,this.name=ee,this.detail=ke,this.uri=Ye,this.range=nt,this.selectionRange=st}}e.TypeHierarchyItem=jn}),define(Ee[98],_e([0,1,41,11,8,124,88,7,17]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(u,g){g?C.set(u,g):C.delete(u)}e.setWordDefinitionFor=n;function T(u){return C.get(u)}e.getWordDefinitionFor=T;class l extends y.MirrorTextModel{constructor(g,b,w,A,o,m,v,t){super(b,w,A,o);this._proxy=g,this._languageId=m,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,_.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===R.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(b){return b?g._getTextInRange(b):g.getText()},get eol(){return g._eol===`
`?E.EndOfLine.LF:E.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(b){return g._lineAt(b)},offsetAt(b){return g._offsetAt(b)},positionAt(b){return g._positionAt(b)},validateRange(b){return g._validateRange(b)},validatePosition(b){return g._validatePosition(b)},getWordRangeAtPosition(b,w){return g._getWordRangeAtPosition(b,w)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,f.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,f.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const b=this._validateRange(g);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const w=this._eol,A=b.start.line,o=b.end.line,m=[];m.push(this._lines[A].substring(b.start.character));for(let v=A+1;v<o;v++)m.push(this._lines[v]);return m.push(this._lines[o].substring(0,b.end.character)),m.join(w)}_lineAt(g){let b;if(g instanceof E.Position?b=g.line:typeof g=="number"&&(b=g),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new h(b,this._lines[b],b===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(g),w=this._lines[b.index].length;return new E.Position(b.index,Math.min(b.remainder,w))}_validateRange(g){if(!(g instanceof E.Range))throw new Error("Invalid argument");const b=this._validatePosition(g.start),w=this._validatePosition(g.end);return b===g.start&&w===g.end?g:new E.Range(b.line,b.character,w.line,w.character)}_validatePosition(g){if(!(g instanceof E.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:b,character:w}=g,A=!1;if(b<0)b=0,w=0,A=!0;else if(b>=this._lines.length)b=this._lines.length-1,w=this._lines[b].length,A=!0;else{const o=this._lines[b].length;w<0?(w=0,A=!0):w>o&&(w=o,A=!0)}return A?new E.Position(b,w):g}_getWordRangeAtPosition(g,b){const w=this._validatePosition(g);if(!b)b=T(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const A=(0,P.getWordAtText)(w.character+1,(0,P.ensureValidWordDefinition)(b),this._lines[w.line],0);if(A)return new E.Range(w.line,A.startColumn-1,w.line,A.endColumn-1)}}e.ExtHostDocumentData=l;class h{constructor(g,b,w){this._line=g,this._text=b,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new E.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new E.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(Ee[164],_e([0,1,7,3,90,6,58,21,2,37]),function(Z,e,f,R,S,y,P,E,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,h,u,g){this._notebook=u,this._selector=g,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(w=>{const A=this._cellUris.get(w.document.uri);A!==void 0&&(this._cellLengths.changeValue(A,this._cells[A].document.getText().length+1),this._cellLines.changeValue(A,this._cells[A].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>b(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new E.ResourceMap;const l=[],h=[];for(const u of this._notebook.getCells())u.kind===f.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),l.push(u.document.getText().length+1),h.push(u.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(l){if(!l){let A="";for(const o of this._cells)A+=o.document.getText()+`
`;return A=A.slice(0,-1),A}if(l.isEmpty)return"";const h=this.locationAt(l.start),u=this.locationAt(l.end),g=this._cellUris.get(h.uri),b=this._cellUris.get(u.uri);if(g===void 0||b===void 0)return"";if(g===b)return this._cells[g].document.getText(new f.Range(h.range.start,u.range.end));const w=[this._cells[g].document.getText(new f.Range(h.range.start,new f.Position(this._cells[g].document.lineCount,0)))];for(let A=g+1;A<b;A++)w.push(this._cells[A].document.getText());return w.push(this._cells[b].document.getText(new f.Range(new f.Position(0,0),u.range.end))),w.join(`
`)}offsetAt(l){const h=this._cellLines.getIndexOf(l.line),u=this._cellLengths.getPrefixSum(h.index-1),g=this._cells[h.index].document.offsetAt(l.with(h.remainder));return u+g}positionAt(l){if(typeof l=="number"){const u=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(g)}const h=this._cellUris.get(l.uri);if(h!==void 0){const u=this._cellLines.getPrefixSum(h-1);return new f.Position(u+l.range.start.line,l.range.start.character)}return new f.Position(0,0)}locationAt(l){f.Range.isRange(l)||(l=new f.Range(l,l));const h=this._cellLines.getIndexOf(l.start.line);let u=h;l.isEmpty||(u=this._cellLines.getIndexOf(l.end.line));const g=new f.Position(h.remainder,l.start.character),b=new f.Position(u.remainder,l.end.character),w=new f.Range(g,b),A=this._cells[h.index];return new f.Location(A.document.uri,A.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const h=this.validatePosition(l.start),u=this.validatePosition(l.end);return l.with(h,u)}validatePosition(l){const h=this._cellLines.getIndexOf(l.line),u=new f.Position(h.remainder,l.character),g=this._cells[h.index].document.validatePosition(u),b=this._cellLines.getPrefixSum(h.index-1);return new f.Position(b+g.line,g.character)}}e.ExtHostNotebookConcatDocument=n}),define(Ee[165],_e([0,1,7,13,3]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(E){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(E){let _=E==="light"?f.ColorThemeKind.Light:E==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=ze([Ve(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(Ee[70],_e([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=R}),define(Ee[166],_e([0,1,24]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function S(E,_){if(_.serializeBuffersForPostMessage){const C=new R,n=(h,u)=>{if(u instanceof ArrayBuffer){const g=C.add(u);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(u)){const g=y(u);if(g){const b=C.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:g,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},T=JSON.stringify(E,n),l=C.buffers.map(h=>{const u=new Uint8Array(h);return f.VSBuffer.wrap(u)});return{message:T,buffers:l}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeWebviewMessage=S;function y(E){switch(E.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(E,_){const C=_.map(l=>{const h=new ArrayBuffer(l.byteLength);return new Uint8Array(h).set(l.buffer),h}),n=_.length?(l,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const u=h,{index:g}=u,b=C[g];if(u.view)switch(u.view.type){case 1:return new Int8Array(b,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return h}:void 0;return{message:JSON.parse(E,n),arrayBuffers:C}}e.deserializeWebviewMessage=P}),define(Ee[167],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(R){function S(P){const E={items:new Map};return P.types.forEach((_,C)=>{E.items.set(_,{asString:async()=>P.items[C].asString})}),E}R.toITreeDataTransfer=S;async function y(P){const E={types:[],items:[]},_=Array.from(P.items.entries());for(const C of _)E.types.push(C[0]),E.items.push({asString:await C[1].asString()});return E}R.toTreeDataTransferDTO=y})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[71],_e([0,1,11,2]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(E,_){return E.scheme===f.Schemas.http||E.scheme===f.Schemas.https?E:(_&&_.authority&&_.isRemote&&E.scheme===f.Schemas.file&&(E=R.URI.from({scheme:f.Schemas.vscodeRemote,authority:_.authority,path:E.path})),R.URI.from({scheme:f.Schemas.https,authority:`${E.scheme}+${y(E.authority)}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=S;function y(E){return E.replace(/./g,_=>{const C=_.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?_:"-"+C.toString(16).padStart(4,"0")})}function P(E){return E.replace(/-([0-9a-f]{4})/g,(_,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=P}),define(Ee[168],_e([0,1,3,6,71]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(E,_,C){this._proxy=E,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const T of this._insets.values())n.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,_,C,n,T){let l;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===E){l=o;break}if(!l)throw new Error("not a visible editor");const h=this,u=this._handlePool++,g=new f.Emitter,b=new f.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,S.asWebviewUri)(o,h._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(o){this._options=o,h._proxy.$setOptions(u,o)}get options(){return this._options}set html(o){this._html=o,h._proxy.$setHtml(u,o)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(o){return h._proxy.$postMessage(u,o)}},A=new class{constructor(){this.editor=E,this.line=_,this.height=C,this.webview=w,this.onDidDispose=b.event}dispose(){h._insets.has(u)&&(h._insets.delete(u),h._proxy.$disposeEditorInset(u),b.fire(),b.dispose(),g.dispose())}};return this._proxy.$createEditorInset(u,l.id,l.value.document.uri,_+1,C,n||{},T.identifier,T.extensionLocation),this._insets.set(u,{editor:E,inset:A,onDidReceiveMessage:g}),A}$onDidDispose(E){const _=this._insets.get(E);_&&_.inset.dispose()}$onDidReceiveMessage(E,_){const C=this._insets.get(E);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=y}),define(Ee[169],_e([0,1,140,10,2,6,4,45,28,17,11]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.ActiveEditorDirtyContext=new E.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(2,null)),e.ActiveEditorPinnedContext=new E.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(3,null)),e.ActiveEditorStickyContext=new E.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(4,null)),e.ActiveEditorReadonlyContext=new E.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(5,null)),e.ActiveEditorCanRevertContext=new E.RawContextKey("activeEditorCanRevert",!1,(0,f.localize)(6,null)),e.ActiveEditorContext=new E.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new E.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(8,null)),e.TextCompareEditorVisibleContext=new E.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(9,null)),e.TextCompareEditorActiveContext=new E.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(10,null)),e.EditorGroupEditorsCountContext=new E.RawContextKey("groupEditorsCount",0,(0,f.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new E.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(12,null)),e.ActiveEditorGroupIndexContext=new E.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(13,null)),e.ActiveEditorGroupLastContext=new E.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(14,null)),e.MultipleEditorGroupsContext=new E.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new E.RawContextKey("editorIsOpen",!1,(0,f.localize)(16,null)),e.InEditorZenModeContext=new E.RawContextKey("inZenMode",!1,(0,f.localize)(17,null)),e.IsCenteredLayoutContext=new E.RawContextKey("isCenteredLayout",!1,(0,f.localize)(18,null)),e.SplitEditorsVertically=new E.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(19,null)),e.EditorAreaVisibleContext=new E.RawContextKey("editorAreaVisible",!0,(0,f.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function T(s){return typeof s?.getViewState=="function"}e.isTextEditorPane=T;function l(s){if(o(s))return!1;const k=s;return S.URI.isUri(k?.resource)}e.isResourceEditorInput=l;function h(s){if(o(s))return!1;const k=s;return k?.original!==void 0&&k.modified!==void 0}e.isResourceDiffEditorInput=h;function u(s){if(o(s))return!1;const k=s;return k?k.resource===void 0||k.resource.scheme===n.Schemas.untitled||k.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var g;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var b;(function(s){s[s.EXPLICIT=1]="EXPLICIT",s[s.AUTO=2]="AUTO",s[s.FOCUS_CHANGE=3]="FOCUS_CHANGE",s[s.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var w;(function(s){s[s.None=0]="None",s[s.Readonly=2]="Readonly",s[s.Untitled=4]="Untitled",s[s.Singleton=8]="Singleton",s[s.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class A extends y.Disposable{}e.AbstractEditorInput=A;function o(s){return s instanceof A}e.isEditorInput=o;function m(s){const k=s;return S.URI.isUri(k?.preferredResource)}function v(s){const k=s;return o(k?.primary)&&o(k?.secondary)}e.isSideBySideEditorInput=v;function t(s){return o(s?.editor)}e.isEditorInputWithOptions=t;function r(s){const k=s;return t(s)&&k?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function a(s){const k=s;return typeof k?.groupId=="number"&&o(k.editor)}e.isEditorIdentifier=a;var i;(function(s){s[s.PRIMARY=1]="PRIMARY",s[s.SECONDARY=2]="SECONDARY",s[s.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(k,F){if(!k)return;const x=v(k)?k.primary:h(k)?k.modified:void 0,j=v(k)?k.secondary:h(k)?k.original:void 0;if(F?.supportSideBySide&&x&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:F.filterByScheme})};k=F.supportSideBySide===i.PRIMARY?x:j}if(h(k))return;const oe=m(k)?k.preferredResource:k.resource;return!oe||!F||!F.filterByScheme?oe:this.filterUri(oe,F.filterByScheme)}getCanonicalUri(k,F){if(!k)return;const x=v(k)?k.primary:h(k)?k.modified:void 0,j=v(k)?k.secondary:h(k)?k.original:void 0;if(F?.supportSideBySide&&x&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:F.filterByScheme})};k=F.supportSideBySide===i.PRIMARY?x:j}if(h(k))return;const oe=k.resource;return!oe||!F||!F.filterByScheme?oe:this.filterUri(oe,F.filterByScheme)}filterUri(k,F){if(Array.isArray(F)){if(F.some(x=>k.scheme===x))return k}else if(F===k.scheme)return k}}e.EditorResourceAccessor=new c;var p;(function(s){s[s.LEFT=0]="LEFT",s[s.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class d{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(k){const F=this.instantiationService=k.get(P.IInstantiationService);for(const[x,j]of this.editorSerializerConstructors)this.createEditorSerializer(x,j,F);this.editorSerializerConstructors.clear()}createEditorSerializer(k,F,x){const j=x.createInstance(F);this.editorSerializerInstances.set(k,j)}registerFileEditorFactory(k){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=k}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(k,F){if(this.editorSerializerConstructors.has(k)||this.editorSerializerInstances.has(k))throw new Error(`A editor serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorSerializer(k,F,this.instantiationService):this.editorSerializerConstructors.set(k,F),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(k),this.editorSerializerInstances.delete(k)})}getEditorSerializer(k){return this.editorSerializerInstances.get(typeof k=="string"?k:k.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new d);async function D(s,k){if(!s||!s.length)return[];const F=await Promise.all(s.map(async x=>{const j=S.URI.revive(x.fileUri);if(!j||(await k.activateProvider(j.scheme),!k.canHandleResource(j)))return;const oe=typeof x.exists=="boolean"?x.exists:await k.exists(j);if(!oe&&x.openOnlyIfExists)return;const se=oe&&!(0,R.isUndefined)(x.selection)?{selection:x.selection,pinned:!0,override:x.editorOverrideId}:{pinned:!0,override:x.editorOverrideId};let V;return oe?V={resource:j,options:se,forceFile:!0}:V={resource:j,options:se,forceUntitled:!0},V}));return(0,C.coalesce)(F)}e.pathsToEditors=D;var I;(function(s){s[s.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",s[s.SEQUENTIAL=1]="SEQUENTIAL"})(I=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[170],_e([0,1,3,45,141,4,6,21,28,17,51,23,35,160]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",l.Codicon.window,(0,S.localize)(0,null));var u;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var g;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={}));function b(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=b;function w(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=w;class A extends P.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new f.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new f.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(p,d,D){const I=this.get(p.id);if(I)return I;const s=p;return s.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,E.getOrSet)(this.viewContainers,d,[]).push(s),D?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:d}),s}deregisterViewContainer(p){for(const d of this.viewContainers.keys()){const D=this.viewContainers.get(d),I=D?.indexOf(p);if(I!==-1){D?.splice(I,1),D.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:p,viewContainerLocation:d});return}}}get(p){return this.all.filter(d=>d.id===p)[0]}getViewContainers(p){return[...this.viewContainers.get(p)||[]]}getViewContainerLocation(p){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(D=>D?.id===p.id).length>0)[0]}getDefaultViewContainer(p){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===p)}}_.Registry.add(u.ViewContainersRegistry,new A);var o;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function m(c,p){const d=c.group??o.More,D=p.group??o.More;return d!==D?d.localeCompare(D):(c.order??5)-(p.order??5)}class v extends P.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new f.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new f.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new f.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new f.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(p,d){this.registerViews2([{views:p,viewContainer:d}])}registerViews2(p){p.forEach(({views:d,viewContainer:D})=>this.addViews(d,D)),this._onViewsRegistered.fire(p)}deregisterViews(p,d){const D=this.removeViews(p,d);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:d})}moveViews(p,d){for(const D of this._views.keys())if(D!==d){const I=this.removeViews(p,D);I.length&&(this.addViews(I,d),this._onDidChangeContainer.fire({views:I,from:D,to:d}))}}getViews(p){return this._views.get(p)||[]}getView(p){for(const d of this._viewContainers){const D=(this._views.get(d)||[]).filter(I=>I.id===p)[0];if(D)return D}return null}getViewContainer(p){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(I=>I.id===p)[0])return d;return null}registerViewWelcomeContent(p,d){return this._viewWelcomeContents.add(p,d),this._onDidChangeViewWelcomeContent.fire(p),(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(p,d),this._onDidChangeViewWelcomeContent.fire(p)})}registerViewWelcomeContent2(p,d){const D=new Map;for(const[I,s]of d)this._viewWelcomeContents.add(p,s),D.set(I,(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(p,s),this._onDidChangeViewWelcomeContent.fire(p)}));return this._onDidChangeViewWelcomeContent.fire(p),D}getViewWelcomeContent(p){const d=[];return this._viewWelcomeContents.forEach(p,D=>d.push(D)),d.sort(m)}addViews(p,d){let D=this._views.get(d);D||(D=[],this._views.set(d,D),this._viewContainers.push(d));for(const I of p){if(this.getView(I.id)!==null)throw new Error((0,S.localize)(1,null,I.id));D.push(I)}}removeViews(p,d){const D=this._views.get(d);if(!D)return[];const I=[],s=[];for(const k of D)p.includes(k)?I.push(k):s.push(k);return I.length&&(s.length?this._views.set(d,s):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),I}}_.Registry.add(u.ViewsRegistry,new v),e.IViewsService=(0,y.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,S.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,y.createDecorator)("viewDescriptorService");var r;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(p,d){this.resolved=!1,this._hasResolve=!1,(0,T.mixin)(this,p),this._hasResolve=!!d,this.resolve=async D=>{if(d&&!this.resolved){const I=await d(D);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(Ee[171],_e([0,1,3,15,142]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(E){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=E}onEvent(E){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=E}onRequest(E){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=E}sendResponse(E){E.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${E.command}`)):this.internalSend("response",E)}sendRequest(E,_,C,n){const T={command:E};if(_&&Object.keys(_).length>0&&(T.arguments=_),this.internalSend("request",T),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const h=this.pendingRequests.get(T.seq);if(h){this.pendingRequests.delete(T.seq);const u={type:"response",seq:0,request_seq:T.seq,success:!1,command:E,message:(0,S.localize)(0,null,n,E)};h(u)}},n)}return C&&this.pendingRequests.set(T.seq,C),T.seq}acceptMessage(E){this.messageCallback?this.messageCallback(E):(this.queue.push(E),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(E,_){return E.type!=="event"||_.type!=="event"}async processQueue(){let E;for(;this.queue.length;){if((!E||this.needsTaskBoundaryBetween(this.queue[0],E))&&await(0,R.timeout)(0),E=this.queue.shift(),!E)return;switch(E.type){case"event":this.eventCallback&&this.eventCallback(E);break;case"request":this.requestCallback&&this.requestCallback(E);break;case"response":const _=E,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(E,_){_.type=E,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const E=new Map;this.pendingRequests.forEach((_,C)=>E.set(C,_)),await(0,R.timeout)(500),E.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(Ee[172],_e([0,1,8,2,14,23,11]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const E=/{([^}]+)}/g;function _(r,a,i){return r.replace(E,function(c,p){return a&&p.length>0&&p[0]!=="_"?c:i&&i.hasOwnProperty(p)?i[p]:c})}e.formatPII=_;function C(r){const a={};for(const i of Object.keys(r))i.startsWith("!")||(a[i]=r[i]);return a}e.filterExceptionsFromTelemetry=C;function n(r){return r.configuration.request==="attach"&&!T(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function T(r){let a=r.configuration.type;if(!!a)return a==="vslsShare"&&(a=r.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(a,"extensionhost")||(0,f.equalsIgnoreCase)(a,"pwa-extensionhost")?r:r.parentSession?T(r.parentSession):void 0}e.getExtensionHostDebugSession=T;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function h(r,a,i){let c,p=0,d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=d.exec(r);){let I=D.index+1,s=I+D[0].length;if(I<=a&&s>=i){c=D[0],p=I;break}}if(c){let I=/\w+/g,s=null;for(;(s=I.exec(c))&&!(s.index+1+p+s[0].length>=i););s&&(c=c.substring(0,I.lastIndex))}return c?{start:p,end:p+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(u))}e.isUri=g;function b(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return R.URI.parse(r.path);if((0,S.isAbsolute)(r.path))return R.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const a=R.URI.revive(r.path);if(a)return a.scheme===P.Schemas.file?a.fsPath:a.toString()}return r.path}function A(r,a){const i=a?b:w,c=(0,y.deepClone)(r);return m(c,(p,d)=>{p&&d&&(d.path=i(d))}),c}e.convertToDAPaths=A;function o(r,a){const i=a?b:w,c=(0,y.deepClone)(r);return m(c,(p,d)=>{!p&&d&&(d.path=i(d))}),c}e.convertToVSCPaths=o;function m(r,a){switch(r.type){case"event":const i=r;switch(i.event){case"output":a(!1,i.body.source);break;case"loadedSource":a(!1,i.body.source);break;case"breakpoint":a(!1,i.body.breakpoint.source);break;default:break}break;case"request":const c=r;switch(c.command){case"setBreakpoints":a(!0,c.arguments.source);break;case"breakpointLocations":a(!0,c.arguments.source);break;case"source":a(!0,c.arguments.source);break;case"gotoTargets":a(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(d=>a(!1,d));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(d=>a(!1,d.source));break;case"loadedSources":p.body.sources.forEach(d=>a(!1,d));break;case"scopes":p.body.scopes.forEach(d=>a(!1,d.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(d=>a(!1,d.source));break;case"setBreakpoints":p.body.breakpoints.forEach(d=>a(!1,d.source));break;default:break}break}}function v(r){return r.filter(a=>!a.presentation?.hidden).sort((a,i)=>a.presentation?i.presentation?a.presentation.group?i.presentation.group?a.presentation.group!==i.presentation.group?a.presentation.group.localeCompare(i.presentation.group):t(a.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(a.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=v;function t(r,a){return typeof r!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:r-a}}),define(Ee[72],_e([0,1,27,85,11,14,22,45]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(s){s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeLanguage=5]="ChangeLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var b;(function(s){s.scheme=S.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function F(V,H){return V.with({scheme:s.scheme,fragment:`ch${H.toString().padStart(7,"0")}${V.scheme!==S.Schemas.file?V.scheme:""}`})}s.generate=F;function x(V){if(V.scheme!==s.scheme)return;const H=k.exec(V.fragment);return H?{handle:Number(H[1]),notebook:V.with({scheme:V.fragment.substr(H[0].length)||S.Schemas.file,fragment:null})}:void 0}s.parse=x;function j(V){if(V.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const H=k.exec(V.fragment);return H?{handle:Number(H[1]),notebook:V.with({scheme:V.fragment.substr(H[0].length)||S.Schemas.file,fragment:null})}:void 0}s.parseCellMetadataUri=j;function oe(V,H,M){return V.with({scheme:M,fragment:`ch${H.toString().padStart(7,"0")}${V.scheme!==S.Schemas.file?V.scheme:""}`})}s.generateCellUri=oe;function se(V,H){if(V.scheme!==H)return;const M=k.exec(V.fragment);return M?{handle:Number(M[1]),notebook:V.with({scheme:V.fragment.substr(M[0].length)||S.Schemas.file,fragment:null})}:void 0}s.parseCellUri=se})(b=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function A(s){return w.get(s)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=A;function o(s){return w.get(s)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function m(s){return w.get(s)?.mergeable??!1}e.mimeTypeIsMergeable=m;function v(s,k){return P.isWindows&&(s=s.replace(/\//g,"\\"),k=k.replace(/\//g,"\\")),f.match(s,k)}function t(s,k,F){let x=0;for(let j=0;j<k.length;j++){if(v(k[j],s))return x;x++}for(let j=0;j<F.length;j++){if(v(F[j],s))return x;x++}return x}function r(s,k,F){return s.sort((x,j)=>t(x,k,F)-t(j,k,F))}e.sortMimeTypes=r;function a(s,k,F,x=(j,oe)=>j===oe){const j=[];function oe(H,M,Q){if(M===0&&Q.length===0)return;const O=j[j.length-1];O&&O.start+O.deleteCount===H?(O.deleteCount+=M,O.toInsert.push(...Q)):j.push({start:H,deleteCount:M,toInsert:Q})}let se=0,V=0;for(;;){if(se===s.length){oe(se,0,k.slice(V));break}if(V===k.length){oe(se,s.length-se,[]);break}const H=s[se],M=k[V];if(x(H,M)){se+=1,V+=1;continue}F(M)?(oe(se,1,[]),se+=1):(oe(se,0,[M]),V+=1)}return j}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(s){s.default="default",s.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(s){const k=s;return!!((typeof k.include=="string"||f.isRelativePattern(k.include))&&(typeof k.exclude=="string"||f.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=c;function p(s,k,F){if(Array.isArray(s.viewType)&&s.viewType.indexOf(k)>=0||s.viewType===k)return!0;if(s.filenamePattern){let x=c(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,j=c(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(f.match(x,(0,y.basename)(F.fsPath).toLowerCase()))return!(j&&f.match(j,(0,y.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class d{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)k[F]=this.textModel.cells[F].getHashValue();return k}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var D;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class I{static create(k){return`${I._prefix}${k}`}static parse(k){if(k.startsWith(I._prefix))return k.substr(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/"}),define(Ee[173],_e([0,1,144,4,45]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[174],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=f;function R(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=R}),define(Ee[99],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var f;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(f=e.TestResultState||(e.TestResultState={}));var R;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(R=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var S;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const y=(n,T)=>{T.expand!==void 0&&(n.expand=T.expand),T.item!==void 0&&(n.item=n.item?Object.assign(n.item,T.item):T.item)};e.applyTestItemUpdate=y;var P;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var E;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire"})(E=e.TestDiffOpType||(e.TestDiffOpType={}));class _{add(T){}update(T){}remove(T,l){}complete(){}}e.IncrementalChangeCollector=_;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(T){const l=this.createChangeCollector();for(const h of T)switch(h[0]){case 0:{const u=h[1];if(u.parent){if(this.items.has(u.parent)){const g=this.items.get(u.parent);g.children.add(u.item.extId);const b=this.createItem(u,g);this.items.set(u.item.extId,b),l.add(b)}}else{const g=this.createItem(u);this.roots.add(g),this.items.set(u.item.extId,g),l.add(g)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=h[1],g=this.items.get(u.extId);if(!g)break;u.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,u),l.update(g);break}case 2:{const u=this.items.get(h[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const g=[[h[1]]];for(;g.length;)for(const b of g.pop()){const w=this.items.get(b);w&&(g.push(w.children),this.items.delete(b),l.remove(w,w!==u),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break}l.complete()}retireTest(T){}updatePendingRoots(T){this.pendingRootCount+=T}createChangeCollector(){return new _}}e.AbstractIncrementalTestCollection=C}),define(Ee[73],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(y){y.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(y){y[y.IsSame=0]="IsSame",y[y.Disconnected=1]="Disconnected",y[y.IsChild=2]="IsChild",y[y.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class S{constructor(P,E=P.length){if(this.path=P,this.viewEnd=E,P.length===0||E<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,E,_=P.parent){if(P.id===E)return new S([E]);let C=[P.id];for(let n=_;n&&n.id!==E;n=n.parent)C.push(n.id);return C.push(E),new S(C.reverse())}static isRoot(P){return!P.includes("\0")}static fromString(P){return new S(P.split("\0"))}static join(P,E){return new S([...P.path,E])}static joinToString(P,E){return P.toString()+"\0"+E}static compare(P,E){return P===E?0:E.startsWith(P+"\0")?2:P.startsWith(E+"\0")?3:1}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new S(this.path,P)}compare(P){if(typeof P=="string")return S.compare(this.toString(),P);for(let E=0;E<P.viewEnd&&E<this.viewEnd;E++)if(P.path[E]!==this.path[E])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=S}),define(Ee[175],_e([0,1,14,42,10,23,22,84,145]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(T,l,h){this._contributedVariables=new Map,this._context=T,this._labelService=l,h&&(this._envVariablesPromise=h.then(u=>this.prepareEnv(u)))}prepareEnv(T){if(P.isWindows){const l=Object.create(null);return Object.keys(T).forEach(h=>{l[h.toLowerCase()]=T[h]}),l}return T}resolveWithEnvironment(T,l,h){return this.recursiveResolve(this.prepareEnv(T),l?l.uri:void 0,h)}async resolveAsync(T,l){return this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,l)}async resolveAnyBase(T,l,h,u){const g=y.deepClone(l);return P.isWindows&&g.windows?Object.keys(g.windows).forEach(b=>g[b]=g.windows[b]):P.isMacintosh&&g.osx?Object.keys(g.osx).forEach(b=>g[b]=g.osx[b]):P.isLinux&&g.linux&&Object.keys(g.linux).forEach(b=>g[b]=g.linux[b]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,g,h,u)}async resolveAnyAsync(T,l,h){return this.resolveAnyBase(T,l,h)}async resolveAnyMap(T,l,h){const u=new Map;return{newConfig:await this.resolveAnyBase(T,l,h,u),resolvedVariables:u}}resolveWithInteractionReplace(T,l,h,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,l,h,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,l){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,l)}recursiveResolve(T,l,h,u,g){if(S.isString(h))return this.resolveString(T,l,h,u,g);if(S.isArray(h))return h.map(b=>this.recursiveResolve(T,l,b,u,g));if(S.isObject(h)){let b=Object.create(null);return Object.keys(h).forEach(w=>{const A=this.resolveString(T,l,w,u,g);b[A]=this.recursiveResolve(T,l,h[w],u,g)}),b}return h}resolveString(T,l,h,u,g){return h.replace(C.VARIABLE_REGEXP,(w,A)=>{if(A.includes(C.VARIABLE_LHS))return w;let o=this.evaluateSingleVariable(T,w,A,l,u);return g&&g.set(A,o),o!==w&&S.isString(o)&&o.match(C.VARIABLE_REGEXP)&&(o=this.resolveString(T,l,o,u,g)),o})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}evaluateSingleVariable(T,l,h,u,g){let b;const w=h.split(":");w.length>1&&(h=w[0],b=w[1]);const A=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,_.localize)(0,null,l))},o=()=>{const v=A();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,_.localize)(1,null,l,f.basename(v)))},m=()=>{if(b){const v=this._context.getFolderUri(b);if(v)return v;throw new Error((0,_.localize)(2,null,l,b))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(h){case"env":if(b){if(T){const v=T[P.isWindows?b.toLowerCase():b];if(S.isString(v))return v}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(b){const v=this._context.getConfigurationValue(u,b);if(S.isUndefinedOrNull(v))throw new Error((0,_.localize)(6,null,l,b));if(S.isObject(v))throw new Error((0,_.localize)(7,null,l,b));return v}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,b,g,"command");case"input":return this.resolveFromMap(l,b,g,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return u||b?(0,E.normalizeDriveLetter)(this.fsPath(m())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(m()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,_.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,_.localize)(10,null,l));case"file":return A();case"fileWorkspaceFolder":return o();case"relativeFile":return u||b?f.relative(this.fsPath(m()),A()):A();case"relativeFileDirname":const r=f.dirname(A());if(u||b){const p=f.relative(this.fsPath(m()),r);return p.length===0?".":p}return r;case"fileDirname":return f.dirname(A());case"fileExtname":return f.extname(A());case"fileBasename":return f.basename(A());case"fileBasenameNoExtension":const a=f.basename(A());return a.slice(0,a.length-f.extname(a).length);case"fileDirnameBasename":return f.basename(f.dirname(A()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return f.sep;default:try{const p=b?`${h}:${b}`:h;return this.resolveFromMap(l,p,g,void 0)}catch(p){return l}}}}resolveFromMap(T,l,h,u){if(l&&h){const g=u===void 0?h[l]:h[u+":"+l];if(typeof g=="string")return g;throw new Error((0,_.localize)(11,null,T))}return T}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[100],_e([0,1,4,169]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var S;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var y;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var E;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function C(g){const b=g;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=C;var n;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=8]="EDITOR_PIN",g[g.EDITOR_STICKY=9]="EDITOR_STICKY",g[g.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(T=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const b=g;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=h;function u(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(Ee[176],_e([0,1,4,100]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(y){const P=y;return typeof y=="number"||(0,R.isEditorGroup)(P)}e.isPreferredGroup=S}),define(Ee[9],_e([0,1,17,83,233,57,23,10,2,31,61,146,92,68,72,73,176,7]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var A;(function(ye){function ce($){const{selectionStartLineNumber:Ae,selectionStartColumn:Ne,positionLineNumber:tt,positionColumn:je}=$,gt=new w.Position(Ae-1,Ne-1),bt=new w.Position(tt-1,je-1);return new w.Selection(gt,bt)}ye.to=ce;function le($){const{anchor:Ae,active:Ne}=$;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}ye.from=le})(A=e.Selection||(e.Selection={}));var o;(function(ye){function ce($){if(!$)return;const{start:Ae,end:Ne}=$;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}ye.from=ce;function le($){if(!$)return;const{startLineNumber:Ae,startColumn:Ne,endLineNumber:tt,endColumn:je}=$;return new w.Range(Ae-1,Ne-1,tt-1,je-1)}ye.to=le})(o=e.Range||(e.Range={}));var m;(function(ye){function ce(le){switch(le){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ye.to=ce})(m=e.TokenType||(e.TokenType={}));var v;(function(ye){function ce($){return new w.Position($.lineNumber-1,$.column-1)}ye.to=ce;function le($){return{lineNumber:$.line+1,column:$.character+1}}ye.from=le})(v=e.Position||(e.Position={}));var t;(function(ye){function ce($){switch($){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ye.from=ce;function le($){switch($){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ye.to=le})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ye){function ce($){let Ae;return $.code&&((0,E.isString)($.code)||(0,E.isNumber)($.code)?Ae=String($.code):Ae={value:String($.code.value),target:$.code.target}),{...o.from($.range),message:$.message,source:$.source,code:Ae,severity:i.from($.severity),relatedInformation:$.relatedInformation&&$.relatedInformation.map(a.from),tags:Array.isArray($.tags)?(0,f.coalesce)($.tags.map(t.from)):void 0}}ye.from=ce;function le($){const Ae=new w.Diagnostic(o.to($),$.message,i.to($.severity));return Ae.source=$.source,Ae.code=(0,E.isString)($.code)?$.code:$.code?.value,Ae.relatedInformation=$.relatedInformation&&$.relatedInformation.map(a.to),Ae.tags=$.tags&&(0,f.coalesce)($.tags.map(t.to)),Ae}ye.to=le})(r=e.Diagnostic||(e.Diagnostic={}));var a;(function(ye){function ce($){return{...o.from($.location.range),message:$.message,resource:$.location.uri}}ye.from=ce;function le($){return new w.DiagnosticRelatedInformation(new w.Location($.resource,o.to($)),$.message)}ye.to=le})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ye){function ce($){switch($){case w.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}ye.from=ce;function le($){switch($){case l.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ye.to=le})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ye){function ce($){return typeof $=="number"&&$>=w.ViewColumn.One?$-1:$===w.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}ye.from=ce;function le($){if(typeof $=="number"&&$>=0)return $+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(c=e.ViewColumn||(e.ViewColumn={}));function p(ye){return typeof ye.range!="undefined"}function d(ye){return ye.length===0?!0:!!p(ye[0])}e.isDecorationOptionsArr=d;var D;(function(ye){function ce(je){return je.map(ye.from)}ye.fromMany=ce;function le(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function $(je){let gt;if(le(je)){const{language:ct,value:mt}=je;gt={value:"```"+ct+`
`+mt+"\n```\n"}}else w.MarkdownString.isMarkdownString(je)?gt={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons}:typeof je=="string"?gt={value:je}:gt={value:""};const bt=Object.create(null);gt.uris=bt;const kt=ct=>{try{let mt=_.URI.parse(ct,!0);mt=mt.with({query:Ae(mt.query,bt)}),bt[ct]=mt}catch(mt){}return""},ft=new S.Renderer;return ft.link=kt,ft.image=ct=>kt(R.parseHrefAndDimensions(ct).href),S(gt.value,{renderer:ft}),gt}ye.from=$;function Ae(je,gt){if(!je)return je;let bt;try{bt=(0,y.parse)(je)}catch(ft){}if(!bt)return je;let kt=!1;return bt=(0,P.cloneAndChange)(bt,ft=>{if(_.URI.isUri(ft)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[ct]=ft,kt=!0,ct}else return}),kt?JSON.stringify(bt):je}function Ne(je){const gt=new w.MarkdownString(je.value,je.supportThemeIcons);return gt.isTrusted=je.isTrusted,gt}ye.to=Ne;function tt(je){if(!!je)return typeof je=="string"?je:ye.from(je)}ye.fromStrict=tt})(D=e.MarkdownString||(e.MarkdownString={}));function I(ye){return d(ye)?ye.map(ce=>({range:o.from(ce.range),hoverMessage:Array.isArray(ce.hoverMessage)?D.fromMany(ce.hoverMessage):ce.hoverMessage?D.from(ce.hoverMessage):void 0,renderOptions:ce.renderOptions})):ye.map(ce=>({range:o.from(ce)}))}e.fromRangeOrRangeWithMessage=I;function s(ye){return typeof ye=="undefined"?ye:typeof ye=="string"?_.URI.file(ye):ye}e.pathOrURIToURI=s;var k;(function(ye){function ce(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?s(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=ce})(k=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ye){function ce(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?s(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?k.from(le.before):void 0,after:le.after?k.from(le.after):void 0}}ye.from=ce})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(ye){function ce(le){if(typeof le=="undefined")return le;switch(le){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=ce})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(ye){function ce(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?x.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?F.from(le.light):void 0,dark:le.dark?F.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?s(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?k.from(le.before):void 0,after:le.after?k.from(le.after):void 0}}ye.from=ce})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var oe;(function(ye){function ce($){return{text:$.newText,eol:$.newEol&&de.from($.newEol),range:o.from($.range)}}ye.from=ce;function le($){const Ae=new w.TextEdit(o.to($.range),$.text);return Ae.newEol=typeof $.eol=="undefined"?void 0:de.to($.eol),Ae}ye.to=le})(oe=e.TextEdit||(e.TextEdit={}));var se;(function(ye){function ce($,Ae,Ne){const tt={edits:[]};if($ instanceof w.WorkspaceEdit)for(let je of $._allEntries())if(je._type===1)tt.edits.push({_type:1,oldUri:je.from,newUri:je.to,options:je.options,metadata:je.metadata});else if(je._type===2){const gt=Ae?.getDocument(je.uri);tt.edits.push({_type:2,resource:je.uri,edit:oe.from(je.edit),modelVersionId:gt?.version,metadata:je.metadata})}else je._type===3?tt.edits.push({_type:3,metadata:je.metadata,resource:je.uri,edit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ne?.getNotebookDocument(je.uri,!0)?.apiNotebook.version}):je._type===5&&tt.edits.push({_type:3,metadata:je.metadata,resource:je.uri,notebookVersionId:Ne?.getNotebookDocument(je.uri,!0)?.apiNotebook.version,edit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(B.from)}});return tt}ye.from=ce;function le($){const Ae=new w.WorkspaceEdit;for(const Ne of $.edits)Ne.edit?Ae.replace(_.URI.revive(Ne.resource),o.to(Ne.edit.range),Ne.edit.text):Ae.renameFile(_.URI.revive(Ne.oldUri),_.URI.revive(Ne.newUri),Ne.options);return Ae}ye.to=le})(se=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(ye){const ce=Object.create(null);ce[w.SymbolKind.File]=0,ce[w.SymbolKind.Module]=1,ce[w.SymbolKind.Namespace]=2,ce[w.SymbolKind.Package]=3,ce[w.SymbolKind.Class]=4,ce[w.SymbolKind.Method]=5,ce[w.SymbolKind.Property]=6,ce[w.SymbolKind.Field]=7,ce[w.SymbolKind.Constructor]=8,ce[w.SymbolKind.Enum]=9,ce[w.SymbolKind.Interface]=10,ce[w.SymbolKind.Function]=11,ce[w.SymbolKind.Variable]=12,ce[w.SymbolKind.Constant]=13,ce[w.SymbolKind.String]=14,ce[w.SymbolKind.Number]=15,ce[w.SymbolKind.Boolean]=16,ce[w.SymbolKind.Array]=17,ce[w.SymbolKind.Object]=18,ce[w.SymbolKind.Key]=19,ce[w.SymbolKind.Null]=20,ce[w.SymbolKind.EnumMember]=21,ce[w.SymbolKind.Struct]=22,ce[w.SymbolKind.Event]=23,ce[w.SymbolKind.Operator]=24,ce[w.SymbolKind.TypeParameter]=25;function le(Ae){return typeof ce[Ae]=="number"?ce[Ae]:6}ye.from=le;function $(Ae){for(const Ne in ce)if(ce[Ne]===Ae)return Number(Ne);return w.SymbolKind.Property}ye.to=$})(V=e.SymbolKind||(e.SymbolKind={}));var H;(function(ye){function ce($){switch($){case w.SymbolTag.Deprecated:return 1}}ye.from=ce;function le($){switch($){case 1:return w.SymbolTag.Deprecated}}ye.to=le})(H=e.SymbolTag||(e.SymbolTag={}));var M;(function(ye){function ce($){return{name:$.name,kind:V.from($.kind),tags:$.tags&&$.tags.map(H.from),containerName:$.containerName,location:W.from($.location)}}ye.from=ce;function le($){const Ae=new w.SymbolInformation($.name,V.to($.kind),$.containerName,W.to($.location));return Ae.tags=$.tags&&$.tags.map(H.to),Ae}ye.to=le})(M=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(ye){function ce($){const Ae={name:$.name||"!!MISSING: name!!",detail:$.detail,range:o.from($.range),selectionRange:o.from($.selectionRange),kind:V.from($.kind),tags:$.tags?.map(H.from)??[]};return $.children&&(Ae.children=$.children.map(ce)),Ae}ye.from=ce;function le($){const Ae=new w.DocumentSymbol($.name,$.detail,V.to($.kind),o.to($.range),o.to($.selectionRange));return(0,f.isNonEmptyArray)($.tags)&&(Ae.tags=$.tags.map(H.to)),$.children&&(Ae.children=$.children.map(le)),Ae}ye.to=le})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var O;(function(ye){function ce($){const Ae=new w.CallHierarchyItem(V.to($.kind),$.name,$.detail||"",_.URI.revive($.uri),o.to($.range),o.to($.selectionRange));return Ae._sessionId=$._sessionId,Ae._itemId=$._itemId,Ae}ye.to=ce;function le($,Ae,Ne){if(Ae=Ae??$._sessionId,Ne=Ne??$._itemId,Ae===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ne,name:$.name,detail:$.detail,kind:V.from($.kind),uri:$.uri,range:o.from($.range),selectionRange:o.from($.selectionRange),tags:$.tags?.map(H.from)}}ye.from=le})(O=e.CallHierarchyItem||(e.CallHierarchyItem={}));var G;(function(ye){function ce(le){return new w.CallHierarchyIncomingCall(O.to(le.from),le.fromRanges.map($=>o.to($)))}ye.to=ce})(G=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var fe;(function(ye){function ce(le){return new w.CallHierarchyOutgoingCall(O.to(le.to),le.fromRanges.map($=>o.to($)))}ye.to=ce})(fe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var W;(function(ye){function ce($){return{range:$.range&&o.from($.range),uri:$.uri}}ye.from=ce;function le($){return new w.Location(_.URI.revive($.uri),o.to($.range))}ye.to=le})(W=e.location||(e.location={}));var te;(function(ye){function ce($){const Ae=$,Ne=$;return{originSelectionRange:Ae.originSelectionRange?o.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ne.uri,range:o.from(Ae.targetRange?Ae.targetRange:Ne.range),targetSelectionRange:Ae.targetSelectionRange?o.from(Ae.targetSelectionRange):void 0}}ye.from=ce;function le($){return{targetUri:_.URI.revive($.uri),targetRange:o.to($.range),targetSelectionRange:$.targetSelectionRange?o.to($.targetSelectionRange):void 0,originSelectionRange:$.originSelectionRange?o.to($.originSelectionRange):void 0}}ye.to=le})(te=e.DefinitionLink||(e.DefinitionLink={}));var he;(function(ye){function ce($){return{range:o.from($.range),contents:D.fromMany($.contents)}}ye.from=ce;function le($){return new w.Hover($.contents.map(D.to),o.to($.range))}ye.to=le})(he=e.Hover||(e.Hover={}));var Se;(function(ye){function ce($){return{range:o.from($.range),expression:$.expression}}ye.from=ce;function le($){return new w.EvaluatableExpression(o.to($.range),$.expression)}ye.to=le})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Le;(function(ye){function ce($){if($ instanceof w.InlineValueText)return{type:"text",range:o.from($.range),text:$.text};if($ instanceof w.InlineValueVariableLookup)return{type:"variable",range:o.from($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};if($ instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:o.from($.range),expression:$.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=ce;function le($){switch($.type){case"text":return{range:o.to($.range),text:$.text};case"variable":return{range:o.to($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};case"expression":return{range:o.to($.range),expression:$.expression}}}ye.to=le})(Le=e.InlineValue||(e.InlineValue={}));var Me;(function(ye){function ce($){return{frameId:$.frameId,stoppedLocation:o.from($.stoppedLocation)}}ye.from=ce;function le($){return new w.InlineValueContext($.frameId,o.to($.stoppedLocation))}ye.to=le})(Me=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ye){function ce($){return{range:o.from($.range),kind:$.kind}}ye.from=ce;function le($){return new w.DocumentHighlight(o.to($.range),$.kind)}ye.to=le})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Xe;(function(ye){function ce(le){switch(le){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ye.to=ce})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(ye){function ce(le){return{triggerKind:Xe.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=ce})(qe=e.CompletionContext||(e.CompletionContext={}));var Ge;(function(ye){function ce($){switch($){case w.CompletionItemTag.Deprecated:return 1}}ye.from=ce;function le($){switch($){case 1:return w.CompletionItemTag.Deprecated}}ye.to=le})(Ge=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(ye){const ce=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function le(Ne){return ce.get(Ne)??9}ye.from=le;const $=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Ae(Ne){return $.get(Ne)??w.CompletionItemKind.Property}ye.to=Ae})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(ye){function ce(le,$){const Ae=new w.CompletionItem(le.label);return Ae.insertText=le.insertText,Ae.kind=U.to(le.kind),Ae.tags=le.tags?.map(Ge.to),Ae.detail=le.detail,Ae.documentation=R.isMarkdownString(le.documentation)?D.to(le.documentation):le.documentation,Ae.sortText=le.sortText,Ae.filterText=le.filterText,Ae.preselect=le.preselect,Ae.commitCharacters=le.commitCharacters,C.Range.isIRange(le.range)?Ae.range=o.to(le.range):typeof le.range=="object"&&(Ae.range={inserting:o.to(le.range.insert),replacing:o.to(le.range.replace)}),Ae.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Ae.insertText=new w.SnippetString(le.insertText):(Ae.insertText=le.insertText,Ae.textEdit=Ae.range instanceof w.Range?new w.TextEdit(Ae.range,Ae.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ae.additionalTextEdits=le.additionalTextEdits.map(Ne=>oe.to(Ne))),Ae.command=$&&le.command?$.fromInternal(le.command):void 0,Ae}ye.to=ce})(K=e.CompletionItem||(e.CompletionItem={}));var J;(function(ye){function ce($){return{label:$.label,documentation:$.documentation?D.fromStrict($.documentation):void 0}}ye.from=ce;function le($){return{label:$.label,documentation:R.isMarkdownString($.documentation)?D.to($.documentation):$.documentation}}ye.to=le})(J=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(ye){function ce($){return{label:$.label,documentation:$.documentation?D.fromStrict($.documentation):void 0,parameters:Array.isArray($.parameters)?$.parameters.map(J.from):[],activeParameter:$.activeParameter}}ye.from=ce;function le($){return{label:$.label,documentation:R.isMarkdownString($.documentation)?D.to($.documentation):$.documentation,parameters:Array.isArray($.parameters)?$.parameters.map(J.to):[],activeParameter:$.activeParameter}}ye.to=le})(ie=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(ye){function ce($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(ie.from):[]}}ye.from=ce;function le($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(ie.to):[]}}ye.to=le})(q=e.SignatureHelp||(e.SignatureHelp={}));var ne;(function(ye){function ce($){return{text:$.text,position:v.from($.position),kind:pe.from($.kind??w.InlayHintKind.Other),whitespaceBefore:$.whitespaceBefore,whitespaceAfter:$.whitespaceAfter}}ye.from=ce;function le($){const Ae=new w.InlayHint($.text,v.to($.position),pe.to($.kind));return Ae.whitespaceAfter=$.whitespaceAfter,Ae.whitespaceBefore=$.whitespaceBefore,Ae}ye.to=le})(ne=e.InlayHint||(e.InlayHint={}));var pe;(function(ye){function ce($){return $}ye.from=ce;function le($){return $}ye.to=le})(pe=e.InlayHintKind||(e.InlayHintKind={}));var Re;(function(ye){function ce($){return{range:o.from($.range),url:$.target,tooltip:$.tooltip}}ye.from=ce;function le($){let Ae;if($.url)try{Ae=typeof $.url=="string"?_.URI.parse($.url,!0):_.URI.revive($.url)}catch(Ne){}return new w.DocumentLink(o.to($.range),Ae)}ye.to=le})(Re=e.DocumentLink||(e.DocumentLink={}));var We;(function(ye){function ce($){const Ae=new w.ColorPresentation($.label);return $.textEdit&&(Ae.textEdit=oe.to($.textEdit)),$.additionalTextEdits&&(Ae.additionalTextEdits=$.additionalTextEdits.map(Ne=>oe.to(Ne))),Ae}ye.to=ce;function le($){return{label:$.label,textEdit:$.textEdit?oe.from($.textEdit):void 0,additionalTextEdits:$.additionalTextEdits?$.additionalTextEdits.map(Ae=>oe.from(Ae)):void 0}}ye.from=le})(We=e.ColorPresentation||(e.ColorPresentation={}));var we;(function(ye){function ce($){return new w.Color($[0],$[1],$[2],$[3])}ye.to=ce;function le($){return[$.red,$.green,$.blue,$.alpha]}ye.from=le})(we=e.Color||(e.Color={}));var Je;(function(ye){function ce($){return{range:o.from($.range)}}ye.from=ce;function le($){return new w.SelectionRange(o.to($.range))}ye.to=le})(Je=e.SelectionRange||(e.SelectionRange={}));var z;(function(ye){function ce(le){switch(le){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ye.to=ce})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(ye){function ce($){switch($){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=ce;function le($){switch($){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ye.to=le})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var de;(function(ye){function ce($){if($===w.EndOfLine.CRLF)return 1;if($===w.EndOfLine.LF)return 0}ye.from=ce;function le($){if($===1)return w.EndOfLine.CRLF;if($===0)return w.EndOfLine.LF}ye.to=le})(de=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(ye){function ce(le){if(typeof le=="object")return le.viewId;switch(le){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=ce})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(ye){function ce(le){const $={start:le.start+1,end:le.end+1};return le.kind&&($.kind=et.from(le.kind)),$}ye.from=ce})(xe=e.FoldingRange||(e.FoldingRange={}));var et;(function(ye){function ce(le){if(le)switch(le){case w.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}ye.from=ce})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ce;(function(ye){function ce(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?o.from(le.selection):void 0,override:typeof le.override=="boolean"?T.EditorResolution.DISABLED:void 0}}ye.from=ce})(Ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var De;(function(ye){function ce($){return $ instanceof w.RelativePattern||typeof $=="string"?$:le($)?new w.RelativePattern($.base,$.pattern):$}ye.from=ce;function le($){const Ae=$;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(De=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(ye){function ce(le){if(le){if(Array.isArray(le))return le.map(ce);if(typeof le=="string")return le;{const $=le;return{language:$.language,scheme:$.scheme,pattern:typeof $.pattern=="undefined"?void 0:De.from($.pattern),exclusive:$.exclusive}}}else return}ye.from=ce})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var re;(function(ye){function ce($){return{start:$.start,end:$.end}}ye.from=ce;function le($){return new w.NotebookRange($.start,$.end)}ye.to=le})(re=e.NotebookRange||(e.NotebookRange={}));var ae;(function(ye){function ce($){return{timing:typeof $.runStartTime=="number"&&typeof $.runEndTime=="number"?{startTime:$.runStartTime,endTime:$.runEndTime}:void 0,executionOrder:$.executionOrder,success:$.lastRunSuccess}}ye.to=ce;function le($){return{lastRunSuccess:$.success,runStartTime:$.timing?.startTime,runEndTime:$.timing?.endTime,executionOrder:$.executionOrder}}ye.from=le})(ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var me;(function(ye){function ce($){switch($){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}ye.from=ce;function le($){switch($){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}ye.to=le})(me=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(ye){function ce($){const Ae={metadata:$.metadata??Object.create(null),cells:[]};for(let Ne of $.cells)w.NotebookCellData.validate(Ne),Ae.cells.push(B.from(Ne));return Ae}ye.from=ce;function le($){const Ae=new w.NotebookData($.cells.map(B.to));return(0,E.isEmptyObject)($.metadata)||(Ae.metadata=$.metadata),Ae}ye.to=le})(ve=e.NotebookData||(e.NotebookData={}));var B;(function(ye){function ce($){return{cellKind:me.from($.kind),language:$.languageId,mime:$.mime,source:$.value,metadata:$.metadata,internalMetadata:ae.from($.executionSummary??{}),outputs:$.outputs?$.outputs.map(be.from):[]}}ye.from=ce;function le($){return new w.NotebookCellData(me.to($.cellKind),$.source,$.language,$.mime,$.outputs?$.outputs.map(be.to):void 0,$.metadata,$.internalMetadata?ae.to($.internalMetadata):void 0)}ye.to=le})(B=e.NotebookCellData||(e.NotebookCellData={}));var ge;(function(ye){function ce($){return{mime:$.mime,valueBytes:Array.from($.data)}}ye.from=ce;function le($){return new w.NotebookCellOutputItem(new Uint8Array($.valueBytes),$.mime)}ye.to=le})(ge=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var be;(function(ye){function ce($){return{outputId:$.id,items:$.items.map(ge.from),metadata:$.metadata}}ye.from=ce;function le($){const Ae=$.items.map(ge.to);return new w.NotebookCellOutput(Ae,$.outputId,$.metadata)}ye.to=le})(be=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(ye){function ce(Ne){if(Ne!=null){if(Ne instanceof w.RelativePattern||typeof Ne=="string")return Ne;if(Ae(Ne))return new w.RelativePattern(Ne.base,Ne.pattern);if($(Ne))return{include:De.from(Ne.include)||void 0,exclude:De.from(Ne.exclude)||void 0}}}ye.from=ce;function le(Ne){return typeof Ne=="string"?Ne:Ae(Ne)?{base:Ne.base,pattern:Ne.pattern}:{include:Ne.include,exclude:Ne.exclude}}ye.to=le;function $(Ne){const tt=Ne,je=De.from(tt.include);if(!(je&&je instanceof w.RelativePattern||typeof je=="string"))return!1;const gt=De.from(tt.exclude);return!!(gt&&gt instanceof w.RelativePattern||typeof gt=="string")}function Ae(Ne){const tt=Ne;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(ye){function ce(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?k.from(le.top):void 0}}ye.from=ce})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var He;(function(ye){function ce(le,$,Ae){const Ne=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:$.toInternal(Ne,Ae),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=ce})(He=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(ye){function ce(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}ye.from=ce})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ke;(function(ye){function ce($){return{uri:$.uri,provides:$.provides}}ye.from=ce;function le($){return new w.NotebookRendererScript(_.URI.revive($.uri),$.provides)}ye.to=le})(Ke=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Qe;(function(ye){function ce($){return{message:D.fromStrict($.message)||"",severity:w.TestMessageSeverity.Error,expectedOutput:$.expectedOutput,actualOutput:$.actualOutput,location:$.location?W.from($.location):void 0}}ye.from=ce;function le($){const Ae=new w.TestMessage(typeof $.message=="string"?$.message:D.to($.message));return Ae.actualOutput=$.actualOutput,Ae.expectedOutput=$.expectedOutput,Ae}ye.to=le})(Qe=e.TestMessage||(e.TestMessage={}));var lt;(function(ye){let ce;(function($){$.Delimiter="\0"})(ce||(ce={})),ye.namespace=($,Ae)=>$+"\0"+Ae;function le($,Ae){return{displayId:Ae.id,id:ye.namespace($,Ae.id),label:Ae.label}}ye.display=le,ye.denamespace=$=>{const Ae=$.indexOf("\0");return{ctrlId:$.slice(0,Ae),tagId:$.slice(Ae+1)}}})(lt=e.TestTag||(e.TestTag={}));var ht;(function(ye){function ce(Ne){const tt=(0,h.getPrivateApiFor)(Ne).controllerId;return{extId:g.TestId.fromExtHostTestItem(Ne,tt).toString(),label:Ne.label,uri:Ne.uri,tags:Ne.tags.map(je=>lt.namespace(tt,je.id)),range:o.from(Ne.range)||null,description:Ne.description||null,error:Ne.error&&D.fromStrict(Ne.error)||null}}ye.from=ce;function le(Ne){return{id:g.TestId.fromString(Ne.extId).localId,label:Ne.label,uri:_.URI.revive(Ne.uri),tags:Ne.tags.map(tt=>{const{tagId:je}=lt.denamespace(tt);return new w.TestTag(je,je)}),range:o.to(Ne.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ne.description||void 0}}ye.toPlain=le;function $(Ne){const tt=g.TestId.fromString(Ne.extId),je=new h.TestItemImpl(tt.controllerId,tt.localId,Ne.label,_.URI.revive(Ne.uri));return je.range=o.to(Ne.range||void 0),je.description=Ne.description||void 0,je}function Ae(Ne){let tt;for(const je of Ne.tests){const gt=$(je.item);(0,h.getPrivateApiFor)(gt).parent=tt,tt=gt}return tt}ye.toItemFromContext=Ae})(ht=e.TestItem||(e.TestItem={})),function(ye){function ce($){return{id:$.id,label:$.label}}ye.from=ce;function le($){return new w.TestTag($.id,$.label)}ye.to=le}(lt=e.TestTag||(e.TestTag={}));var Et;(function(ye){const ce=($,Ae)=>{const Ne={...ht.toPlain($.item),parent:void 0,taskStates:$.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Qe.to)})),children:$.children.map(tt=>Ae.get(tt)).filter(E.isDefined).map(tt=>ce(tt,Ae))};for(const tt of Ne.children)tt.parent=Ne;return Ne};function le($){const Ae=[],Ne=new Map;for(const tt of $.items)Ne.set(tt.item.extId,tt),$.request.targets.some(je=>je.controllerId===tt.controllerId&&je.testIds.includes(tt.item.extId))&&Ae.push(tt);return{completedAt:$.completedAt,results:Ae.map(tt=>ce(tt,Ne))}}ye.to=le})(Et=e.TestResults||(e.TestResults={}));var ot;(function(ye){function ce(Ne){return{covered:Ne.covered,total:Ne.covered}}function le(Ne){return"line"in Ne?v.from(Ne):o.from(Ne)}function $(Ne){return"branches"in Ne?{count:Ne.executionCount,location:le(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(tt=>({count:tt.executionCount,location:tt.location&&le(tt.location)})):void 0}:{type:0,count:Ne.executionCount,location:le(Ne.location)}}ye.fromDetailed=$;function Ae(Ne){return{uri:Ne.uri,statement:ce(Ne.statementCoverage),branch:Ne.branchCoverage&&ce(Ne.branchCoverage),function:Ne.functionCoverage&&ce(Ne.functionCoverage),details:Ne.detailedCoverage?.map($)}}ye.fromFile=Ae})(ot=e.TestCoverage||(e.TestCoverage={}));var at;(function(ye){function ce(le){switch(le){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ye.to=ce})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Dt;(function(ye){function ce($){const Ae=new w.TypeHierarchyItem(V.to($.kind),$.name,$.detail||"",_.URI.revive($.uri),o.to($.range),o.to($.selectionRange));return Ae._sessionId=$._sessionId,Ae._itemId=$._itemId,Ae}ye.to=ce;function le($,Ae,Ne){if(Ae=Ae??$._sessionId,Ne=Ne??$._itemId,Ae===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ne,kind:V.from($.kind),name:$.name,detail:$.detail??"",uri:$.uri,range:o.from($.range),selectionRange:o.from($.selectionRange),tags:$.tags?.map(H.from)}}ye.from=le})(Dt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[177],_e([0,1,2,12,7,9,80]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class E{constructor(C,n,T,l={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=T,this._thresholds=l,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,T,l)=>{const u={dispose:this._callbacks.push([n,T,C])};return Array.isArray(l)&&l.push(u),u}}async $participateInSave(C,n){const T=f.URI.revive(C);let l=!1;const h=setTimeout(()=>l=!0,this._thresholds.timeout),u=[];try{for(let g of[...this._callbacks]){if(l)break;const b=this._documents.getDocument(T),w=await this._deliverEventAsyncAndBlameBadListeners(g,{document:b,reason:y.TextDocumentSaveReason.to(n)});u.push(w)}}finally{clearTimeout(h)}return u}_deliverEventAsyncAndBlameBadListeners([C,n,T],l){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,C,n,l).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const g=this._badListeners.get(C);this._badListeners.set(C,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,T,l){const h=[],u=Date.now(),{document:g,reason:b}=l,{version:w}=g,A=Object.freeze({document:g,reason:b,waitUntil(o){if(Object.isFrozen(h))throw(0,R.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(o))}});try{n.apply(T,[A])}catch(o){return Promise.reject(o)}return Object.freeze(h),new Promise((o,m)=>{const v=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(v),o(t)}).catch(t=>{clearTimeout(v),m(t)})}).then(o=>{const m={edits:[]};for(const v of o)if(Array.isArray(v)&&v.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:r,range:a}of v)m.edits.push({_type:2,resource:g.uri,edit:{range:a&&y.Range.from(a),text:t,eol:r&&y.EndOfLine.from(r)}});if(m.edits.length!==0)return w===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=E}),define(Ee[178],_e([0,1,3,27,2,9,7]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(n,T,l,h,u){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter,this._config=0,l&&(this._config+=1),h&&(this._config+=2),u&&(this._config+=4);const g=(0,R.parse)(T),b=n(w=>{if(!l)for(let A of w.created){const o=S.URI.revive(A);g(o.fsPath)&&this._onDidCreate.fire(o)}if(!h)for(let A of w.changed){const o=S.URI.revive(A);g(o.fsPath)&&this._onDidChange.fire(o)}if(!u)for(let A of w.deleted){const o=S.URI.revive(A);g(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(n,T,l){this._logService=T,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,T,l,h){return new E(this._onFileSystemEvent.event,n,T,l,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,T){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(l=>({oldUri:S.URI.revive(l.source),newUri:S.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(l=>S.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:T.map(l=>S.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,T){return(l,h,u)=>{const g=function(w){l.call(h,w)};return g.extension=n,T.event(g,void 0,u)}}async $onWillRunFileOperation(n,T,l,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(u=>({oldUri:S.URI.revive(u.source),newUri:S.URI.revive(u.target)}))},l,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(u=>S.URI.revive(u.target))},l,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(u=>S.URI.revive(u.target))},l,h)}}async _fireWillEvent(n,T,l,h){const u=new Set,g=[];if(await n.fireAsync(T,h,async(w,A)=>{const o=Date.now(),m=await Promise.resolve(w);m instanceof P.WorkspaceEdit&&(g.push(m),u.add(A.extension.displayName??A.extension.identifier.value)),Date.now()-o>l&&this._logService.warn("SLOW file-participant",A.extension.identifier)}),h.isCancellationRequested||g.length===0)return;const b={edits:[]};for(let w of g){let{edits:A}=y.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(A)}return{edit:b,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=_}),define(Ee[179],_e([0,1,11,23,2,9,7,72]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,h,u,g){this.start=l,this.deletedCount=h,this.deletedItems=u,this.items=g}static asApiEvents(l){return l.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(u=>u.apiCell)}))}}class C{constructor(l,h,u){this.notebook=l,this._extHostDocument=h,this._cellData=u,this.handle=u.handle,this.uri=S.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(l,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return l._mime},set mime(u){l._mime=u},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(y.NotebookCellOutput.to)}setOutputItems(l,h,u){const g=u.map(y.NotebookCellOutputItem.to),b=this._outputs.find(w=>w.id===l);b&&(h||(b.items.length=0),b.items.push(...g))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=C;class n{constructor(l,h,u,g,b,w){this._proxy=l,this._textDocumentsAndEditors=h,this._textDocuments=u,this._emitter=g,this.uri=b,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===f.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(h){return h=l._validateIndex(h),l._cells[h].apiCell},getCells(h){return(h?l._getCells(h):l._cells).map(g=>g.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,h){this._versionId=l.versionId,this._isDirty=h;for(const u of l.rawEvents)u.kind===E.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===E.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===E.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===E.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===E.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===E.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===E.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===E.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let h=l.start|0,u=l.end|0;return h<0&&(h=0),u>this._cells.length&&(u=this._cells.length),l.with({start:h,end:u})}_getCells(l){l=this._validateRange(l);const h=[];for(let u=l.start;u<l.end;u++)h.push(this._cells[u]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,h){if(this._disposed)return;const u=[],g=[],b=[];l.reverse().forEach(w=>{const o=w[2].map(t=>{const r=new C(this,this._textDocumentsAndEditors,t);return h||g.push(C.asModelAddData(this.apiNotebook,t)),r}),m=new _(w[0],w[1],[],o),v=this._cells.splice(w[0],w[1],...o);for(const t of v)b.push(t.uri),m.deletedItems.push(t.apiCell);u.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:b}),h||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(u)}))}_moveCell(l,h){const u=this._cells.splice(l,1);this._cells.splice(h,0,...u);const g=[new _(l,1,u.map(b=>b.apiCell),[]),new _(h,0,[],u)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(g)}))}_setCellOutputs(l,h){const u=this._cells[l];u.setOutputs(h),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(l,h,u,g){const b=this._cells[l];b.setOutputItems(h,u,g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_changeCellLanguage(l,h){const u=this._cells[l];u.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(u.uri,h)}_changeCellMime(l,h){const u=this._cells[l];u.apiCell.mime=h}_changeCellMetadata(l,h){const u=this._cells[l],g=u.apiCell.metadata;u.setMetadata(h);const b=u.apiCell.metadata;(0,R.equals)(g,b)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(l,h){const u=this._cells[l],g=u.internalMetadata;if(u.setInternalMetadata(h),g.runState!==h.runState){const b=h.runState??P.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:b}))}}getCellFromApiCell(l){return this._cells.find(h=>h.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(h=>h.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(Ee[101],_e([0,1,7,9,12]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,n){this._throwIfFinalized(),!(_===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:n.map(R.NotebookCellData.from)})}}class P{constructor(_,C,n,T,l,h){this.id=_,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=T,this._viewColumn=h}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(f.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,n){_._proxy.$tryRevealRange(_.id,R.NotebookRange.from(C),n??f.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const n=new y(this.document.version);return C(n),_._applyEdit(n.finalize())},setDecorations(C,n){return _.setDecorations(C,n)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(R.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let T=0;T<_.cellEdits.length;T++){if(n<0){C.push(_.cellEdits[T]),n++;continue}const h=C[n],u=_.cellEdits[T];if(h.editType===1&&u.editType===1&&h.index===u.index){h.cells.push(..._.cellEdits[T].cells),h.count+=_.cellEdits[T].count;continue}C.push(_.cellEdits[T]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(Ee[180],_e([0,1,9,156,135,20,52]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(T){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=T}withProgress(T,l,h){const u=this._handles++,{title:g,location:b,cancellable:w}=l,A={label:(0,S.localize)(0,null,T.displayName||T.name),id:T.identifier.value};return this._proxy.$startProgress(u,{location:f.ProgressLocation.from(b),title:g,source:A,cancellable:w},T),this._withProgress(u,h,!!w)}_withProgress(T,l,h){let u;h&&(u=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(T,u));const g=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let b;try{b=l(new C(this._proxy,T),h&&u?u.token:y.CancellationToken.None)}catch(w){throw g(T),w}return b.then(w=>g(T),w=>g(T)),b}$acceptProgressCanceled(T){const l=this._mapHandleToCancellationSource.get(T);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(T))}}e.ExtHostProgress=E;function _(n,T){return n.message=T.message,typeof T.increment=="number"&&(typeof n.increment=="number"?n.increment+=T.increment:n.increment=T.increment),n}class C extends R.Progress{constructor(T,l){super(h=>this.throttledReport(h));this._proxy=T,this._handle=l}throttledReport(T){this._proxy.$progressReport(this._handle,T)}}ze([(0,P.throttle)(100,(n,T)=>_(n,T),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(Ee[102],_e([0,1,41,12,54,9,7]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class E{constructor(l,h,u){const g=E._Keys.nextId();l.$registerTextEditorDecorationType(h.identifier,g,y.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=E,E._Keys=new S.IdGenerator("TextEditorDecorationType");class _{constructor(l,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,h){this._throwIfFinalized();let u=null;if(l instanceof P.Position)u=new P.Range(l,l);else if(l instanceof P.Range)u=l;else throw new Error("Unrecognized location");this._pushEdit(u,h,!1)}insert(l,h){this._throwIfFinalized(),this._pushEdit(new P.Range(l,l),h,!0)}delete(l){this._throwIfFinalized();let h=null;if(l instanceof P.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(l,h,u){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:h,forceMoveMarkers:u})}setEndOfLine(l){if(this._throwIfFinalized(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class C{constructor(l,h,u,g){this._proxy=l,this._id=h,this._accept(u),this._logService=g;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(w){b._setTabSize(w)},get insertSpaces(){return b._insertSpaces},set insertSpaces(w){b._setInsertSpaces(w)},get cursorStyle(){return b._cursorStyle},set cursorStyle(w){b._setCursorStyle(w)},get lineNumbers(){return b._lineNumbers},set lineNumbers(w){b._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const h=Math.floor(l);return h>0?h:null}if(typeof l=="string"){const h=parseInt(l,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(l){const h=this._validateTabSize(l);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const h=this._validateInsertSpaces(l);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const h={};let u=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(u=!0,h.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,u=!0,h.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(u=!0,h.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,u=!0,h.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,u=!0,h.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,u=!0,h.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(l){l.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class n{constructor(l,h,u,g,b,w,A,o){this.id=l,this._proxy=h,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new C(this._proxy,this.id,w,u),this._visibleRanges=A,this._viewColumn=o;const m=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,R.readonly)("document")},get selection(){return m._selections&&m._selections[0]},set selection(v){if(!(v instanceof P.Selection))throw(0,R.illegalArgument)("selection");m._selections=[v],m._trySetSelection()},get selections(){return m._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof P.Selection)))throw(0,R.illegalArgument)("selections");m._selections=v,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(v){throw(0,R.readonly)("visibleRanges")},get options(){return m._options.value},set options(v){m._disposed||m._options.assign(v)},get viewColumn(){return m._viewColumn},set viewColumn(v){throw(0,R.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new _(g.getValue(),t);return v(r),m._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=m._selections.map(i=>y.Range.from(i));else if(t instanceof P.Position){const{lineNumber:i,column:c}=y.Position.from(t);a=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof P.Range)a=[y.Range.from(t)];else{a=[];for(const i of t)if(i instanceof P.Range)a.push(y.Range.from(i));else{const{lineNumber:c,column:p}=y.Position.from(i);a.push({startLineNumber:c,startColumn:p,endLineNumber:c,endColumn:p})}}return h.$tryInsertSnippet(l,v.value,a,r)},setDecorations(v,t){const r=t.length===0;r&&!m._hasDecorationsForKey.has(v.key)||(r?m._hasDecorationsForKey.delete(v.key):m._hasDecorationsForKey.add(v.key),m._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return h.$trySetDecorations(l,v.key,y.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const p=t[i];a[4*i]=p.start.line+1,a[4*i+1]=p.start.character+1,a[4*i+2]=p.end.line+1,a[4*i+3]=p.end.character+1}return h.$trySetDecorationsFast(l,v.key,a)}}))},revealRange(v,t){m._runOnProxy(()=>h.$tryRevealRange(l,y.Range.from(v),t||P.TextEditorRevealType.Default))},show(v){h.$tryShowEditor(l,y.ViewColumn.from(v))},hide(){h.$tryHideEditor(l)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,f.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,f.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,f.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,f.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const h=l.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const u=h.edits.map(b=>b.range);u.sort((b,w)=>b.end.line===w.end.line?b.end.character===w.end.character?b.start.line===w.start.line?b.start.character-w.start.character:b.start.line-w.start.line:b.end.character-w.end.character:b.end.line-w.end.line);for(let b=0,w=u.length-1;b<w;b++){const A=u[b].end;if(u[b+1].start.isBefore(A))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=h.edits.map(b=>({range:y.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,g,{setEndOfLine:typeof h.setEndOfLine=="number"?y.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(Ee[181],_e([0,1,138,25,2,3,6,170,15,7,10,17,9,20,167]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(A,o){if((0,n.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let m;return Array.isArray(A.highlights)&&(m=A.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),m=m.length?m:void 0),{label:A.label,highlights:m}}}class b{constructor(o,m,v){this._proxy=o,this.commands=m,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}m.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(a=>t(a)?this.convertArgument(a):a):r})}registerTreeDataProvider(o,m,v){const t=this.createTreeView(o,{treeDataProvider:m},v);return{dispose:()=>t.dispose()}}createTreeView(o,m,v){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=m.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,canDragAndDrop:t}),a=this.createExtHostTreeView(o,m,v);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(i){a.message=i},get title(){return a.title},set title(i){a.title=i},get description(){return a.description},set description(i){a.description=i},reveal:(i,c)=>a.reveal(i,c),dispose:async()=>{await r,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,m){const v=this.treeViews.get(o);return v?v.getChildren(m):Promise.reject(new Error((0,f.localize)(0,null,o)))}async $onDrop(o,m,v){const t=this.treeViews.get(o);if(!t)return Promise.reject(new Error((0,f.localize)(1,null,o)));const r=u.TreeDataTransferConverter.toITreeDataTransfer(m);if(r.items.has(E.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(E.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>t.getExtensionElement(c)).filter(c=>!!c);i.length>0?r.items.set(E.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(E.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(o){const m=this.treeViews.get(o);if(!m)throw new Error((0,f.localize)(2,null,o));return m.hasResolve}$resolve(o,m,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,f.localize)(3,null,o));return t.resolveTreeItem(m,v)}$setExpanded(o,m,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,f.localize)(4,null,o));t.setExpanded(m,v)}$setSelection(o,m){const v=this.treeViews.get(o);if(!v)throw new Error((0,f.localize)(5,null,o));v.setSelection(m)}$setVisible(o,m){const v=this.treeViews.get(o);if(!v)throw new Error((0,f.localize)(6,null,o));v.setVisible(m)}createExtHostTreeView(o,m,v){const t=new w(o,m,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(o,t),t}convertArgument(o){const m=this.treeViews.get(o.$treeViewId);return m?m.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=b;class w extends P.Disposable{constructor(o,m,v,t,r,a){super();if(this.viewId=o,this.proxy=v,this.commands=t,this.logService=r,this.extension=a,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,a.contributes&&a.contributes.views)for(const p in a.contributes.views)for(const d of a.contributes.views[p])d.id===o&&(this._title=d.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let i,c;this._register(y.Event.debounce(this._onDidChangeData.event,(p,d)=>(p||(p={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(D=>c=D),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?p.elements.push(...d.element):p.elements.push(d.element)),d.message&&(p.message=!0),p),200,!0)(({message:p,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=c;return i=null,this.refresh(d).then(()=>D())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,n.isUndefinedOrNull)(o))}getChildren(o){const m=o?this.getExtensionElement(o):void 0;if(o&&!m)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(o);return(v?Promise.resolve(v):this.fetchChildrenNodes(m)).then(t=>t.map(r=>r.item))}getExtensionElement(o){return this.elements.get(o)}reveal(o,m){m=m||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(m.select)?!0:m.select,t=(0,n.isUndefinedOrNull)(m.focus)?!1:m.focus,r=(0,n.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(a=>this.resolveTreeNode(o,a[a.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:a.map(c=>c.item)},{select:v,focus:t,expand:r})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,m){const v=this.getExtensionElement(o);v&&(m?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(o){(0,T.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,m){const v=this.getExtensionElement(m);if(!!v)return(0,_.asPromise)(()=>this.dndController?.onDrop(o,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,m){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(o);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,m)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(m=>m?this.resolveUnknownParentChain(m).then(v=>this.resolveTreeNode(m,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(o){const m=this.nodes.get(o);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,m){const v=this.nodes.get(o);return v?Promise.resolve(v):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>this.createHandle(o,t,m,!0)).then(t=>this.getChildren(m?m.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const a=this.nodes.get(r);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(o){if(o){let m;if(typeof o=="string"){const v=this.getExtensionElement(o);m=v?this.nodes.get(v):void 0}else m=o;return m&&m.children||null}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const m=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=o?this.nodes.get(o):void 0,t=await this.dataProvider.getChildren(o);if(m.token.isCancellationRequested)return[];const r=await Promise.all((0,T.coalesce)(t||[]).map(async a=>{const i=await this.dataProvider.getTreeItem(a);return i&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(a,i,v):null}));return m.token.isCancellationRequested?[]:(0,T.coalesce)(r)}finally{m.dispose()}}refresh(o){if(o.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(o);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const m=new Set,v=o.map(r=>this.nodes.get(r));for(const r of v)if(r&&!m.has(r.item.handle)){let a=r;for(;a&&a.parent&&v.findIndex(i=>a&&a.parent&&i&&i.item.handle===a.parent.item.handle)===-1;){const i=this.elements.get(a.parent.item.handle);a=i?this.nodes.get(i):void 0}a&&!a.parent&&m.add(r.item.handle)}const t=[];return m.forEach(r=>{const a=this.elements.get(r);if(a){const i=this.nodes.get(a);i&&(!i.parent||!m.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(o){const m={};return Promise.all(o.map(v=>this.refreshNode(v).then(t=>{t&&(m[v]=t.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(o){const m=this.getExtensionElement(o);if(m){const v=this.nodes.get(m);if(v)return this.clearChildren(m),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(t=>{if(t){const r=this.createTreeNode(m,t,v.parent);return this.updateNodeCache(m,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,m,v){const t=this.createTreeNode(o,m,v);if(m.id&&this.elements.has(t.item.handle))throw new Error((0,f.localize)(7,null,m.id));return this.addNodeToCache(o,t),this.addNodeToParentCache(t,v),t}getTooltip(o){return C.MarkdownString.isMarkdownString(o)?l.MarkdownString.from(o):o}getCommand(o,m){return m?this.commands.toInternal(m,o):void 0}createTreeNode(o,m,v){const t=new P.DisposableStore,r=this.createHandle(o,m,v),a=this.getLightIconPath(m);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:g(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(t,m.command),contextValue:m.contextValue,icon:a,iconDark:this.getDarkIconPath(m)||a,themeIcon:this.getThemeIcon(m),collapsibleState:(0,n.isUndefinedOrNull)(m.collapsibleState)?C.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(o){return o.iconPath instanceof C.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:m,label:v,resourceUri:t},r,a){if(m)return`${w.ID_HANDLE_PREFIX}/${m}`;const i=g(v,this.extension),c=r?r.item.handle:w.LABEL_HANDLE_PREFIX;let p=i?i.label:t?(0,R.basename)(t):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const d=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,D=this.getChildrenNodes(r)||[];let I,s=0;do{if(I=`${c}/${s}:${p}`,a||!this.elements.has(I)||d===I)break;s++}while(s<=D.length);return I}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof C.ThemeIcon))return typeof o.iconPath=="string"||S.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof C.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return S.URI.isUri(o)?o:S.URI.file(o)}addNodeToCache(o,m){this.elements.set(m.item.handle,o),this.nodes.set(o,m)}updateNodeCache(o,m,v,t){this.elements.delete(m.item.handle),this.nodes.delete(o),m.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(o,m);const r=this.getChildrenNodes(t)||[],a=r.filter(i=>i.item.handle===v.item.handle)[0];a&&r.splice(r.indexOf(a),1,m)}addNodeToParentCache(o,m){m?(m.children||(m.children=[]),m.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const m=this.nodes.get(o);if(m){if(m.children)for(const v of m.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}m.children=void 0}}else this.clearAll()}clear(o){const m=this.nodes.get(o);if(m){if(m.children)for(const v of m.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(o),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(Ee[182],_e([0,1,15,3,6,10,68,9,99,73]),function(Z,e,f,R,S,y,P,E,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends S.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const l=this.diff;return this.diff=[],l}*tags(){const l=new Set;for(const h of this.tree.values())for(const u of h.actual.tags)l.has(u.id)||(l.add(u.id),yield u)}pushDiff(l){const h=this.diff[this.diff.length-1];if(h&&l[0]===1){if(h[0]===1&&h[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(h[1],l[1]);return}if(h[0]===0&&h[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(h[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,h){const u=this.tree.get(l);if(!!u){if((u.expandLevels===void 0||h>u.expandLevels)&&(u.expandLevels=h),u.expand===1){const g=this.resolveChildren(u);return g.isOpen()?this.expandChildren(u,h-1):g.wait().then(()=>this.expandChildren(u,h-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,h-1)):this.expandChildren(u,h-1)}}dispose(){for(const l of this.tree.values())(0,P.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,h){switch(h.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(C.TestId.joinToString(l.fullId,h.id));break;case 0:this.upsertItem(h.item,l);break;case 4:for(const w of h.ops)this.onTestItemEvent(l,w);break;case 3:const{key:u,value:g}=h,b=l.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.pushDiff([1,{extId:b,item:{tags:g.map(w=>w.id)}}]);break;case"range":this.pushDiff([1,{extId:b,item:{range:E.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:E.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[u]:g??null}}]);break}break;default:(0,y.assertNever)(h)}}upsertItem(l,h){if(!(l instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const u=C.TestId.fromExtHostTestItem(l,this.root.id,h?.actual),g=(0,P.getPrivateApiFor)(l);g.parent&&g.parent!==h?.actual&&g.parent.children.delete(l.id);let b=this.tree.get(u.toString());if(!b){b={fullId:u,actual:l,parent:h?u.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},this.tree.set(b.fullId.toString(),b),this.setItemParent(l,h),this.pushDiff([0,{parent:b.parent&&b.parent.toString(),controllerId:this.controllerId,expand:b.expand,item:E.TestItem.from(l)}]),this.connectItemAndChildren(l,b,h);return}if(b.actual===l){this.connectItem(l,b,h);return}const w=b.actual.children,A=b.actual,o=(0,P.diffTestItems)(A,l);(0,P.getPrivateApiFor)(A).listener=void 0,b.actual=l,b.expand=0;for(const[m,v]of o)this.onTestItemEvent(b,{op:3,key:m,value:v});this.connectItemAndChildren(l,b,h);for(const m of w)l.children.get(m.id)||this.removeItem(C.TestId.joinToString(u,m.id))}setItemParent(l,h){(0,P.getPrivateApiFor)(l).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(l,h,u){this.setItemParent(l,u);const g=(0,P.getPrivateApiFor)(l);g.parent=u?.actual,g.listener=b=>this.onTestItemEvent(h,b),this.updateExpandability(h)}connectItemAndChildren(l,h,u){this.connectItem(l,h,u);for(const g of l.children)this.upsertItem(g,h)}updateExpandability(l){let h;this._resolveHandler?l.resolveBarrier?h=l.resolveBarrier.isOpen()?3:2:h=l.actual.canResolveChildren?1:0:h=0,h!==l.expand&&(l.expand=h,this.pushDiff([1,{extId:l.fullId.toString(),expand:h}]),h===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,h){if(h<0)return;const u=[];for(const g of l.actual.children){const b=this.expand(C.TestId.joinToString(l.fullId,g.id),h);(0,f.isThenable)(b)&&u.push(b)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const b=new f.Barrier;return b.open(),b}l.expand=2,this.pushExpandStateUpdate(l);const h=l.resolveBarrier=new f.Barrier,u=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=b.stack||b.message||String(b))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(b){u(b)}return(0,f.isThenable)(g)?g.catch(u).then(()=>{h.open(),this.updateExpandability(l)}):(h.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const h=this.tree.get(l);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const u=[h];for(;u.length;){const g=u.pop();if(!!g){(0,P.getPrivateApiFor)(g.actual).listener=void 0,this.tree.delete(g.fullId.toString());for(const b of g.actual.children)u.push(this.tree.get(C.TestId.joinToString(g.fullId,b.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=n}),define(Ee[183],_e([0,1,4,151]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(R.IEnvironmentService)}),define(Ee[184],_e([0,1,26,3,14]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class P{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let T of n.activationEvents)T==="onUri"&&(T=`onUri:${f.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(T)||this._activationMap.set(T,[]),this._activationMap.get(T).push(n)}}keepOnly(n){const T=new Set;n.forEach(l=>T.add(f.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>T.has(f.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,T){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=P._findLoopingExtensions(this._extensionDescriptions);if(T=T.concat(l.map(h=>h.identifier)),T.length>0){const h=new Set;T.forEach(u=>h.add(f.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!h.has(f.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(n){const T=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,w){this.addNode(b),this.addNode(w),this._arcs.has(b)?this._arcs.get(b).push(w):this._arcs.set(b,[w])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,w){const A=T.getArcs(b);for(let o=0;o<A.length;o++)if(!w.has(A[o]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let b of n){const w=f.ExtensionIdentifier.toKey(b.identifier);if(l.set(w,b),b.extensionDependencies)for(let A of b.extensionDependencies){const o=f.ExtensionIdentifier.toKey(A);T.addArc(w,o)}}let h=new Set;T.getNodes().filter(b=>T.getArcs(b).length===0).forEach(b=>h.add(b));let u=T.getNodes().filter(b=>!h.has(b)),g;do{g=!1;for(let b=0;b<u.length;b++){const w=u[b];T.hasOnlyGoodArcs(w,h)&&(u.splice(b,1),b--,h.add(w),g=!0)}}while(g);return u.map(b=>l.get(b))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const T=this._activationMap.get(n);return T?T.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const T=this._extensionsMap.get(f.ExtensionIdentifier.toKey(n));return T||void 0}}e.ExtensionDescriptionRegistry=P;var E;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(E||(E={}));function _(C,n){const T=C.isBuiltin?0:C.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(T!==l)return T-l;const h=S.posix.basename(C.extensionLocation.path),u=S.posix.basename(n.extensionLocation.path);return h<u?-1:h>u?1:0}}),define(Ee[185],_e([0,1,24]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function y(E){const _=f.VSBuffer.alloc(1);switch(E){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=y;function P(E,_){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=P}),define(Ee[30],_e([0,1,3,2,4,26,152]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class E{constructor(A){this.dependency=A}}e.MissingExtensionDependency=E;var _;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(A,o,m,v){this.codeLoadingTime=A,this.activateCallTime=o,this.activateResolvedTime=m,this.activationReason=v}}e.ActivationTimes=C;class n{constructor(A,o){this.description=A,this.value=o}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var T;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(T=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||h(w)}e.checkProposedApiEnabled=l;function h(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=h;function u(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=u;function g(w,A){return{identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!A,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=g;class b{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(A){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(A){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(A){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(A){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(A,o){return Promise.resolve()}_onWillActivateExtension(A){}_onDidActivateExtension(A,o,m,v,t){}_onDidActivateExtensionError(A,o){}_onExtensionRuntimeError(A,o){}_onExtensionHostExit(A){}}e.NullExtensionService=b}),define(Ee[186],_e([0,1,26,30,16]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class P{constructor(u,g,b,w){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=w}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class E{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,g){return u===-1||g===-1?-1:g-u}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class _{constructor(u,g,b,w,A,o){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=b,this.module=w,this.exports=A,this.subscriptions=o}}e.ActivatedExtension=_;class C extends _{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends _{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class T extends _{constructor(u){super(!0,u,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=T;let l=class{constructor(u,g,b,w,A){this._logService=A,this._registry=u,this._resolvedExtensionsSet=new Set,g.forEach(o=>this._resolvedExtensionsSet.add(f.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,b.forEach(o=>this._hostExtensionsMap.set(f.ExtensionIdentifier.toKey(o),o)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const g=f.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(g)}getActivatedExtension(u){const g=f.ExtensionIdentifier.toKey(u),b=this._activatedExtensions.get(g);if(!b)throw new Error("Extension `"+u.value+"` is not known or not activated");return b}activateByEvent(u,g){if(this._alreadyActivatedEvents[u])return y;const b=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(b.map(w=>({id:w.identifier,reason:{startup:g,extensionId:w.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,g){const b=this._registry.getExtensionDescription(u);if(!b)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:b.identifier,reason:g}])}_handleActivateRequest(u,g,b){if(this._hostExtensionsMap.has(f.ExtensionIdentifier.toKey(u.id))){g[f.ExtensionIdentifier.toKey(u.id)]=u;return}const w=this._registry.getExtensionDescription(u.id);if(!w){const m=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,m,new R.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(u.id),new T(m));return}const A=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let o=!0;for(let m=0,v=A.length;m<v;m++){const t=A[m];if(this._resolvedExtensionsSet.has(f.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(f.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const p=w.displayName||w.identifier.value,d=this._registry.getExtensionDescription(t),D=d&&d.displayName||t,I=new Error(`Cannot activate the '${p}' extension because its dependency '${D}' failed to activate`);I.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,I,null),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(w.identifier),new T(I));return}if(this._hostExtensionsMap.has(f.ExtensionIdentifier.toKey(t))){o=!1,g[f.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(f.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const a=this._registry.getExtensionDescription(t);if(a){o=!1,g[f.ExtensionIdentifier.toKey(t)]={id:a.identifier,reason:u.reason};continue}const i=w.displayName||w.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,c,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(w.identifier),new T(c));return}o?g[f.ExtensionIdentifier.toKey(w.identifier)]=u:b.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(A=>!this._activatedExtensions.has(f.ExtensionIdentifier.toKey(A.id))),u.length===0))return Promise.resolve(void 0);const g=Object.create(null),b=[];for(let A=0,o=u.length;A<o;A++)this._handleActivateRequest(u[A],g,b);for(let A=0,o=b.length;A<o;A++){const m=f.ExtensionIdentifier.toKey(b[A].id);g[m]&&delete g[m]}const w=Object.keys(g).map(A=>g[A]);return b.length===0?Promise.all(w.map(A=>this._activateExtension(A.id,A.reason))).then(A=>{}):this._activateExtensions(w).then(A=>this._activateExtensions(b))}_activateExtension(u,g){const b=f.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const w=this._activatingExtensions.get(b);if(w)return w;const A=this._host.actualActivateExtension(u,g).then(void 0,o=>{const m=new Error;return o&&o.name&&(m.name=o.name),o&&o.message?m.message=`Activating extension '${u.value}' failed: ${o.message}.`:m.message=`Activating extension '${u.value}' failed: ${o}.`,o&&o.stack&&(m.stack=o.stack),this._host.onExtensionActivationError(u,m,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(o),new T(o)}).then(o=>{this._activatedExtensions.set(b,o),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,A),A}};l=ze([Ve(4,S.ILogService)],l),e.ExtensionsActivator=l}),define(Ee[187],_e([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,P)=>{this._actualOk=y,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,f.onUnexpectedError)(y))}then(y,P){return this._ensureActual().then(y,P)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(Ee[103],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(_,C){this._proxyIdentifierBrand=void 0,this.isMain=_,this.sid=C,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const R=[];function S(E){const _=new f(!0,E);return R[_.nid]=_,_}e.createMainContextProxyIdentifier=S;function y(E){const _=new f(!1,E);return R[_.nid]=_,_}e.createExtHostContextProxyIdentifier=y;function P(E){return R[E].sid}e.getStringIdentifierForProxy=P}),define(Ee[5],_e([0,1,57,2,103]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var P;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var E;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(o){o.name="$ident";function m(t,r){return Object.defineProperty(t,o.name,{value:r,enumerable:!0}),t}o.mixin=m;function v(t){return t[o.name]}o.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(m){return m._id=h._n++,m}}e.IdObject=h,h._n=0;var u;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(o){if(o&&o.edits)for(const m of o.edits)typeof m.resource=="object"?m.resource=R.URI.revive(m.resource):(m.newUri=R.URI.revive(m.newUri),m.oldUri=R.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,f.revive)(m.metadata));return o}e.reviveWorkspaceEditDto=w;var A;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(A=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[74],_e([0,1,5,3,4]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(E){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=E.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(E){this._onDidChangePassword.fire(E)}get(E,_){return this._proxy.$getPassword(E,_)}store(E,_,C){return this._proxy.$setPassword(E,_,C)}delete(E,_){return this._proxy.$deletePassword(E,_)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(Ee[75],_e([0,1,4,16,5,13]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(S.MainContext.MainThreadTelemetry)}report(_,C,n){const T=this.getUsageKey(_,C);this._reportedUsages.has(T)||(this._reportedUsages.add(T),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};P=ze([Ve(0,y.IExtHostRpcService),Ve(1,R.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(E,_,C){}})}),define(Ee[188],_e([0,1,3,5,7,26]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,C,n,T={}){const l=y.ExtensionIdentifier.toKey(_.identifier),h=this._inFlightRequests.get(l)||[],u=[...n].sort().join(" ");let g=h.find(b=>b.scopes===u);if(g)return g.result;{const b=this._getSession(_,l,C,n,T);g={scopes:u,result:b},h.push(g),this._inFlightRequests.set(l,h);try{await b}finally{const w=h.findIndex(A=>A.scopes===u);w>-1&&(h.splice(w),this._inFlightRequests.set(l,h))}return b}}async _getSession(_,C,n,T,l={}){await this._proxy.$ensureProvider(n);const h=_.displayName||_.name;return this._proxy.$getSession(n,T,C,h,l)}async removeSession(_,C){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,n,T){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:n,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===_)||this._providers.push({id:_,label:C});const l=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(_,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,C,T?.supportsMultipleAccounts??!1),new S.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const h=this._providers.findIndex(u=>u.id===_);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(Ee[189],_e([0,1,5,13,9]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(E,_){this._extHostDocumentsAndEditors=_,this._proxy=E.getProxy(f.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(E){const _=S.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};y=ze([Ve(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(Ee[190],_e([0,1,5]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const P=y.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(E){return P.$writeText(E)}})}}e.ExtHostClipboard=R}),define(Ee[48],_e([0,1,10,7,9,23,5,17,16,57,31,38,2,6,4,13]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(P.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,a=>{const i=this._apiCommands.get(a);return i?.result===o.Void?i:void 0},r),this._argumentProcessors=[{processArgument(a){return(0,C.revive)(a)}},{processArgument(a){return(0,y.cloneAndChange)(a,function(i){if(n.Range.isIRange(i))return S.Range.to(i);if(T.Position.isIPosition(i))return S.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return S.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...a)=>{const i=t.args.map((p,d)=>{if(!p.validate(a[d]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${a[d]}`);return p.convert(a[d])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,a,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,a,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:a,thisArg:i,description:c}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,a){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,y.cloneAndChange)(r,function(c){if(c instanceof R.Position)return S.Position.from(c);if(c instanceof R.Range)return S.Range.from(c);if(c instanceof R.Location)return S.location.from(c);if(R.NotebookRange.isNotebookRange(c))return S.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,a);return(0,C.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const a=this._commands.get(t);if(!a)throw new Error("Unknown command");let{callback:i,thisArg:c,description:p}=a;if(p)for(let d=0;d<p.args.length;d++)try{(0,f.validateConstraint)(r[d],p.args[d].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[d].name}' - ${p.args[d].description}`)}try{return await i.apply(c,r)}catch(d){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(d,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(a=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),a)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(a=>a[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,a]of this._commands){let{description:i}=a;i&&(t[r]=i)}return Promise.resolve(t)}};b=ze([Ve(0,g.IExtHostRpcService),Ve(1,_.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class w{constructor(t,r,a){this._commands=t,this._lookupApiCommand=r,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const a={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return a;const i=this._lookupApiCommand(t.command);if(i)a.id=i.internalId,a.arguments=i.args.map((c,p)=>c.convert(t.arguments&&t.arguments[p]));else if((0,E.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add((0,h.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),a.$ident=c,a.id=this.delegatingCommandId,a.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return a}fromInternal(t){const r=P.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class A{constructor(t,r,a,i){this.name=t,this.description=r,this.validate=a,this.convert=i}optional(){return new A(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new A(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=A,A.Uri=new A("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v),A.Position=new A("position","A position in a text document",v=>R.Position.isPosition(v),S.Position.from),A.Range=new A("range","A range in a text document",v=>R.Range.isRange(v),S.Range.from),A.Selection=new A("selection","A selection in a text document",v=>R.Selection.isSelection(v),S.Selection.from),A.Number=new A("number","",v=>typeof v=="number",v=>v),A.String=new A("string","",v=>typeof v=="string",v=>v),A.CallHierarchyItem=new A("item","A call hierarchy item",v=>v instanceof R.CallHierarchyItem,S.CallHierarchyItem.from),A.TypeHierarchyItem=new A("item","A type hierarchy item",v=>v instanceof R.TypeHierarchyItem,S.TypeHierarchyItem.from);class o{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=o,o.Void=new o("no result",v=>v);class m{constructor(t,r,a,i,c){this.id=t,this.internalId=r,this.description=a,this.args=i,this.result=c}}e.ApiCommand=m}),define(Ee[191],_e([0,1,9,7,61,48,17,89]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(f.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if((0,P.isFalsyOrEmpty)(l))return;class u extends R.SymbolInformation{static to(b){const w=new u(b.name,f.SymbolKind.to(b.kind),b.containerName||"",new R.Location(h[0],f.Range.to(b.range)));return w.detail=b.detail,w.range=w.location.range,w.selectionRange=f.Range.to(b.selectionRange),w.children=b.children?b.children.map(u.to):[],w}}return l.map(u.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(f.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(f.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>R.Position.isPosition(h)),l=>l.map(f.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let u;for(const g of h.reverse())u=new R.SelectionRange(f.Range.to(g),u);return u}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let u of l)h.push(...u[1].map(f.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return f.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(f.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,E.decodeSemanticTokensDto)(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,E.decodeSemanticTokensDto)(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,u)=>{if(!l)return new R.CompletionList([]);const g=l.suggestions.map(b=>f.CompletionItem.to(b,u));return new R.CompletionList(g,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return f.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,u)=>n(g=>new R.CodeLens(f.Range.to(g.range),g.command&&u.fromInternal(g.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?f.Selection.from(l):f.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,u)=>n(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const b=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=f.WorkspaceEdit.to(g.edit)),g.command&&(b.command=u.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new R.ColorInformation(f.Range.to(h.range),f.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,f.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:f.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(f.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(f.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>f.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(f.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to)))];class C{static register(h){_.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function n(l){return h=>{if(Array.isArray(h))return h.map(l)}}function T(l){if(!Array.isArray(l))return;const h=[];for(const u of l)S.isLocationLink(u)?h.push(f.DefinitionLink.to(u)):h.push(f.location.to(u));return h}}),define(Ee[192],_e([0,1,15,52,3,6,2,61,26,9,7,5]),function(Z,e,f,R,S,y,P,E,_,C,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(h,u,g){const b=h.getProxy(T.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.commentThreadHandle);return p||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.thread.commentThreadHandle);return p?{thread:p,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.thread.commentThreadHandle);if(!p)return i;let d=i.commentUniqueId,D=p.getCommentByUniqueId(d);return D||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const p=c.getCommentThread(i.thread.commentThreadHandle);if(!p)return i;let d=i.text,D=i.commentUniqueId,I=p.getCommentByUniqueId(D);return I?(I.body=d,I):i}return i}})}createCommentController(i,c,p){const d=w.handlePool++,D=new o(i,d,c,p);this._commentControllers.set(D.handle,D);const I=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(i.identifier))||[];return I.push(D),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(i.identifier),I),D.value}$createCommentThreadTemplate(i,c,p){const d=this._commentControllers.get(i);!d||d.$createCommentThreadTemplate(c,p)}async $updateCommentThreadTemplate(i,c,p){const d=this._commentControllers.get(i);!d||d.$updateCommentThreadTemplate(c,p)}$deleteCommentThread(i,c){const p=this._commentControllers.get(i);p&&p.$deleteCommentThread(c)}$provideCommentingRanges(i,c,p){const d=this._commentControllers.get(i);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const D=g.getDocument(P.URI.revive(c));return(0,f.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(D,p)).then(I=>I?I.map(s=>C.Range.from(s)):void 0)}$toggleReaction(i,c,p,d,D){const I=this._commentControllers.get(i);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const s=I.getCommentThread(c);if(s){const k=s.getCommentByUniqueId(d.uniqueIdInThread);if(I!==void 0&&k&&I.reactionHandler)return I.reactionHandler(k,t(D))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class A{constructor(i,c,p,d,D,I,s){this._commentControllerHandle=c,this._id=p,this._uri=d,this._range=D,this._comments=I,this.handle=A._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),b.$createCommentThread(c,this.handle,this._id,this._uri,C.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this._localDisposables.push({dispose:()=>{b.$deleteCommentThread(c,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(F){k.range=F},get comments(){return k.comments},set comments(F){k.comments=F},get collapsibleState(){return k.collapsibleState},set collapsibleState(F){k.collapsibleState=F},get canReply(){return k.canReply},set canReply(F){k.canReply=F},get contextValue(){return k.contextValue},set contextValue(F){k.contextValue=F},get label(){return k.label},set label(F){k.label=F},dispose:()=>{k.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const i=p=>Object.prototype.hasOwnProperty.call(this.modifications,p),c={};i("range")&&(c.range=C.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(p=>m(this,p,this._commentsMap))),i("collapsibleState")&&(c.collapseState=r(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},b.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let p=c[0],d=c[1];if(i===d)return p}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}A._handlePool=0,ze([(0,R.debounce)(100)],A.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(i,c,p,d){this._extension=i,this._handle=c,this._id=p,this._label=d,this._threads=new Map,b.$registerCommentController(this.handle,p,d);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(I){D.options=I},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(I){D.commentingRangeProvider=I},get reactionHandler(){return D.reactionHandler},set reactionHandler(I){D.reactionHandler=I},createCommentThread(I,s,k){return D.createCommentThread(I,s,k).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{b.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,b.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,b.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,p,d){if(typeof i=="string"){const D=new A(this.id,this.handle,i,c,p,d,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new A(this.id,this.handle,void 0,i,c,p,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(i,c){const p=new A(this.id,this.handle,void 0,P.URI.revive(i),C.Range.to(c),[],this._extension.identifier);return p.collapsibleState=E.CommentThreadCollapsibleState.Expanded,this._threads.set(p.handle,p),p}$updateCommentThreadTemplate(i,c){let p=this._threads.get(i);p&&(p.range=C.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function m(a,i,c){let p=c.get(i);p||(p=++a.commentHandle,c.set(i,p));const d=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:p,body:C.MarkdownString.from(i.body),userName:i.author.name,userIconPath:d,label:i.label,commentReactions:i.reactions?i.reactions.map(D=>v(D)):void 0}}function v(a){return{label:a.label,iconPath:a.iconPath?C.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function t(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?P.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function r(a){if(a!==void 0)switch(a){case n.CommentThreadCollapsibleState.Expanded:return E.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return E.CommentThreadCollapsibleState.Collapsed}return E.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=l}),define(Ee[104],_e([0,1,2,5,7,4,13,16,17,8,14]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class wn{constructor(h,u){this._logService=u,this._provider=new Map,this._proxy=h.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,u){const g=wn._handlePool++;this._provider.set(g,{provider:h,extensionId:u}),this._proxy.$registerDecorationProvider(g,u.value);const b=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(g,null);return}let A=(0,_.asArray)(w);if(A.length<=wn._maxEventSize){this._proxy.$onDidChange(g,A);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,A.length);const o=A.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),m=(0,_.groupBy)(o,(t,r)=>t.rank-r.rank||(0,C.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of m){let r;for(let a of t){let i=(0,n.dirname)(a.uri.path);if(r!==i&&(r=i,v.push(a.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new S.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(h,u,g){if(!this._provider.has(h))return Object.create(null);const b=Object.create(null),{provider:w,extensionId:A}=this._provider.get(h);return await Promise.all(u.map(async o=>{try{const{uri:m,id:v}=o,t=await Promise.resolve(w.provideFileDecoration(f.URI.revive(m),g));if(!t)return;try{S.FileDecoration.validate(t),b[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${A.value}': ${r}`)}}catch(m){this._logService.error(m)}})),b}};T._handlePool=0,T._maxEventSize=250,T=ze([Ve(0,P.IExtHostRpcService),Ve(1,E.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")}),define(Ee[193],_e([0,1,133,92,2,5,7,9,3,16,21]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class T{constructor(u,g,b,w,A){this._name=u,this._owner=g,this._maxDiagnosticsPerFile=b,this._proxy=w,this._onDidChangeDiagnostics=A,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,g){if(!u){this.clear();return}this._checkDisposed();let b=[];if(S.URI.isUri(u)){if(!g){this.delete(u);return}this._data.set(u,g.slice()),b=[u]}else if(Array.isArray(u)){b=[];let A;u=[...u].sort(T._compareIndexedTuplesByUri);for(const o of u){const[m,v]=o;if((!A||m.toString()!==A.toString())&&(A&&this._data.get(A).length===0&&this._data.delete(A),A=m,b.push(m),this._data.set(m,[])),v){const t=this._data.get(m);t&&t.push(...v)}else{const t=this._data.get(m);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!this._proxy)return;const w=[];for(let A of b){let o=[];const m=this._data.get(A);if(m)if(m.length>this._maxDiagnosticsPerFile){o=[];const v=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of m)if(r.severity===v[t]&&o.push(E.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;o.push({severity:R.MarkerSeverity.Info,message:(0,f.localize)(0,null,m.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=m.map(v=>E.Diagnostic.from(v));w.push([A,o])}this._proxy.$changeMany(this._owner,w)}delete(u){this._checkDisposed(),this._onDidChangeDiagnostics.fire([u]),this._data.delete(u),this._proxy&&this._proxy.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(u,g){this._checkDisposed();for(let b of this._data.keys())u.apply(g,[b,this.get(b),this])}get(u){this._checkDisposed();const g=this._data.get(u);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this._data.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,g){return u[0].toString()<g[0].toString()?-1:u[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=T;let l=class Qt{constructor(u,g){this._logService=g,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=u.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(u){const g=new n.ResourceMap;for(const b of u)g.set(b,b);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(u,g){const{_collections:b,_proxy:w,_onDidChangeDiagnostics:A,_logService:o}=this,m=new class{$changeMany(r,a){w.$changeMany(r,a),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,r,a.length===0?"CLEARING":a)}$clear(r){w.$clear(r),o.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,r)}dispose(){w.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+Qt._idPool++,v=g;else if(!b.has(g))v=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+Qt._idPool++;while(b.has(v))}return new class extends T{constructor(){super(g,v,Qt._maxDiagnosticsPerFile,m,A);b.set(v,this)}dispose(){super.dispose(),b.delete(v)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const g=new Map,b=[];for(const w of this._collections.values())w.forEach((A,o)=>{let m=g.get(A.toString());typeof m=="undefined"&&(m=b.length,g.set(A.toString(),m),b.push([A,[]])),b[m][1]=b[m][1].concat(...o)});return b}}_getDiagnostics(u){let g=[];for(let b of this._collections.values())b.has(u)&&(g=g.concat(b.get(u)));return g}$acceptMarkersChange(u){if(!this._mirrorCollection){const g="_generated_mirror",b=new T(g,g,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(g,b),this._mirrorCollection=b}for(const[g,b]of u)this._mirrorCollection.set(S.URI.revive(g),b.map(E.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([Ve(1,C.ILogService)],l),e.ExtHostDiagnostics=l}),define(Ee[194],_e([0,1,2,5]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(P){this._proxy=P.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(E=>E?E.map(_=>f.URI.revive(_)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(E=>E?f.URI.revive(E):void 0)}}e.ExtHostDialogs=S}),define(Ee[195],_e([0,1,12,2,7,5,11,20,8]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(T,l,h){this._documentsAndEditors=l,this._logService=h,this._documentContentProviders=new Map,this._proxy=T.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,l){if(Object.keys(P.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,l),this._proxy.$registerTextContentProvider(h,T);let u;return typeof l.onDidChange=="function"&&(u=l.onDidChange(g=>{if(g.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(h,g).then(b=>{if(!b&&typeof b!="string")return;const w=this._documentsAndEditors.getDocument(g);if(!w)return;const A=(0,_.splitLines)(b);if(!w.equalLines(A))return this._proxy.$onVirtualDocumentChange(g,b)},f.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(T,l){const h=this._documentContentProviders.get(T);return h?Promise.resolve(h.provideTextDocumentContent(R.URI.revive(l),E.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(Ee[196],_e([0,1,3,6,2,5,98,9,10,23,7]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(h,u){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const b of g)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const b of g)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const u=this._documentsAndEditors.getDocument(h);if(u)return u}getDocument(h){const u=this.getDocumentData(h);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return u.document}ensureDocumentData(h){const u=this._documentsAndEditors.getDocument(h);if(u)return Promise.resolve(u);let g=this._documentLoader.get(h.toString());return g||(g=this._proxy.$tryOpenDocument(h).then(b=>{this._documentLoader.delete(h.toString());const w=S.URI.revive(b);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(w))},b=>(this._documentLoader.delete(h.toString()),Promise.reject(b))),this._documentLoader.set(h.toString(),g)),g}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(u=>S.URI.revive(u))}$acceptModelModeChanged(h,u){const g=S.URI.revive(h),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(u),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(h){const u=S.URI.revive(h),g=this._documentsAndEditors.getDocument(u);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(h,u){const g=S.URI.revive(h),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");b._acceptIsDirty(u),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,u,g){const b=S.URI.revive(h),w=this._documentsAndEditors.getDocument(b);if(!w)throw new Error("unknown document");w._acceptIsDirty(g),w.onEvents(u);let A;u.isUndoing?A=n.TextDocumentChangeReason.Undo:u.isRedoing&&(A=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:w.document,contentChanges:u.changes.map(o=>({range:E.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:A}))}setWordDefinitionFor(h,u){(0,P.setWordDefinitionFor)(h,u)}}e.ExtHostDocuments=T}),define(Ee[49],_e([0,1,41,3,6,2,4,5,98,13,102,9,16,21,11,55,112]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let A=class{constructor(m,v){this._extHostRpc=m,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const v=[],t=[],r=[];if(m.removedDocuments)for(const a of m.removedDocuments){const i=y.URI.revive(a),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),v.push(c.value))}if(m.addedDocuments)for(const a of m.addedDocuments){const i=y.URI.revive(a.uri);let c=this._documents.get(i);if(c&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new w(new _.ExtHostDocumentData(this._extHostRpc.getProxy(E.MainContext.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(m.removedEditors)for(const a of m.removedEditors){const i=this._editors.get(a);this._editors.delete(a),i&&r.push(i)}if(m.addedEditors)for(const a of m.addedEditors){const i=y.URI.revive(a.documentUri);f.ok(this._documents.has(i),`document '${i}' does not exist`),f.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const c=this._documents.get(i).value,p=new n.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(E.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>c.document),a.selections.map(T.Selection.to),a.options,a.visibleRanges.map(d=>T.Range.to(d)),typeof a.editorPosition=="number"?T.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,p)}m.newActiveEditor!==void 0&&(f.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),(0,S.dispose)(v),(0,S.dispose)(r),m.removedDocuments&&this._onDidRemoveDocuments.fire(v),m.addedDocuments&&this._onDidAddDocuments.fire(t),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){return this._documents.get(m)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return m?v:v?.value}allEditors(){return[...this._editors.values()]}};A=ze([Ve(0,C.IExtHostRpcService),Ve(1,l.ILogService)],A),e.ExtHostDocumentsAndEditors=A,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[197],_e([0,1,2,5,6,7,9,122,8,24]),function(Z,e,f,R,S,y,P,E,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const u=this._schemes.indexOf(h);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),u=[];let g,b,w=14,A=14;for(const o of h){let m=g?(0,_.commonPrefixLength)(g,o):0;for(m===0?b=1:b=A;m<o.length;m++)m+1===o.length?(w=A,A=9):A+=1,u.push([b,o.toUpperCase().charCodeAt(m),A]),u.push([b,o.toLowerCase().charCodeAt(m),A]),b=A;g=o,A=w}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new E.StateMachine(u)}}provideDocumentLinks(h){this._initStateMachine();const u=[],g=E.LinkComputer.computeLinks({getLineContent(b){return h.lineAt(b-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const b of g){const w=P.DocumentLink.to(b);w.target&&u.push(w)}return u}}class T{constructor(h,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,u,g,b={},w){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const A=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(A,g),this._enableProposedApi.set(A,w??!1);let o=2;b.isCaseSensitive&&(o+=1024),b.isReadonly&&(o+=2048),typeof g.copy=="function"&&(o+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(o+=4),this._proxy.$registerFileSystemProvider(A,u,o).catch(v=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${u}`),console.error(v)});const m=g.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:a,type:i}=r;if(a.scheme!==u)continue;let c;switch(i){case y.FileChangeType.Changed:c=0;break;case y.FileChangeType.Created:c=1;break;case y.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:a,type:c})}this._proxy.$onFileSystemChange(A,t)});return(0,S.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(A),this._enableProposedApi.delete(A),this._proxy.$unregisterProvider(A)})}static _asIStat(h,u){const{type:g,ctime:b,mtime:w,size:A,permissions:o}=h;return u?{type:g,ctime:b,mtime:w,size:A,permissions:o}:{type:g,ctime:b,mtime:w,size:A}}$stat(h,u){return Promise.resolve(this._getFsProvider(h).stat(f.URI.revive(u))).then(g=>T._asIStat(g,this._enableProposedApi.get(h)??!1))}$readdir(h,u){return Promise.resolve(this._getFsProvider(h).readDirectory(f.URI.revive(u)))}$readFile(h,u){return Promise.resolve(this._getFsProvider(h).readFile(f.URI.revive(u))).then(g=>C.VSBuffer.wrap(g))}$writeFile(h,u,g,b){return Promise.resolve(this._getFsProvider(h).writeFile(f.URI.revive(u),g.buffer,b))}$delete(h,u,g){return Promise.resolve(this._getFsProvider(h).delete(f.URI.revive(u),g))}$rename(h,u,g,b){return Promise.resolve(this._getFsProvider(h).rename(f.URI.revive(u),f.URI.revive(g),b))}$copy(h,u,g,b){const w=this._getFsProvider(h);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(f.URI.revive(u),f.URI.revive(g),b))}$mkdir(h,u){return Promise.resolve(this._getFsProvider(h).createDirectory(f.URI.revive(u)))}$watch(h,u,g,b){const w=this._getFsProvider(h).watch(f.URI.revive(g),b);this._watches.set(u,w)}$unwatch(h,u){const g=this._watches.get(u);g&&(g.dispose(),this._watches.delete(u))}$open(h,u,g){const b=this._getFsProvider(h);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(f.URI.revive(u),g))}$close(h,u){const g=this._getFsProvider(h);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(u))}$read(h,u,g,b){const w=this._getFsProvider(h);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const A=C.VSBuffer.alloc(b);return Promise.resolve(w.read(u,g,A.buffer,0,b)).then(o=>A.slice(0,o))}$write(h,u,g,b){const w=this._getFsProvider(h);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(u,g,b.buffer,0,b.byteLength))}_getFsProvider(h){const u=this._fsProvider.get(h);if(!u){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return u}}e.ExtHostFileSystem=T}),define(Ee[76],_e([0,1,5,62,7,24,4,13,47]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ut{constructor(T,l){const h=T.getProxy(f.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return h.$stat(u).catch(Ut._handleError)},readDirectory(u){return h.$readdir(u).catch(Ut._handleError)},createDirectory(u){return h.$mkdir(u).catch(Ut._handleError)},async readFile(u){return h.$readFile(u).then(g=>g.buffer).catch(Ut._handleError)},writeFile(u,g){return h.$writeFile(u,y.VSBuffer.wrap(g)).catch(Ut._handleError)},delete(u,g){return h.$delete(u,{recursive:!1,useTrash:!1,...g}).catch(Ut._handleError)},rename(u,g,b){return h.$rename(u,g,{overwrite:!1,...b}).catch(Ut._handleError)},copy(u,g,b){return h.$copy(u,g,{overwrite:!1,...b}).catch(Ut._handleError)},isWritableFileSystem(u){const g=l.getCapabilities(u);if(typeof g=="number")return!(g&2048)}})}static _handleError(T){if(!(T instanceof Error))throw new S.FileSystemError(String(T));if(T.name==="ENOPRO")throw S.FileSystemError.Unavailable(T.message);switch(T.name){case R.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(T.message);case R.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(T.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(T.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(T.message);case R.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(T.message);case R.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(T.message);default:throw new S.FileSystemError(T.message,T.name)}}};C=ze([Ve(0,E.IExtHostRpcService),Ve(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[198],_e([0,1,2,48]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(P,E,_,C){this._extHostNotebooks=E,this._textDocumentsAndEditors=_,this._commands=C;const n=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",T=>!0,T=>T),new R.ApiCommandArgument("resource","Interactive resource Uri",T=>!0,T=>T),new R.ApiCommandArgument("controllerId","Notebook controller Id",T=>!0,T=>T),new R.ApiCommandArgument("title","Interactive editor title",T=>!0,T=>T)],new R.ApiCommandResult("Notebook and input URI",T=>{if(T.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(T.notebookEditorId);return{notebookUri:f.URI.revive(T.notebookUri),inputUri:f.URI.revive(T.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:f.URI.revive(T.notebookUri),inputUri:f.URI.revive(T.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(P,E,_,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:E,lines:[""],modeId:_,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=S}),define(Ee[199],_e([0,1,6,5]),function(Z,e,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(P){this._handlePool=0,this._proxy=P.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const E=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(E,P),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(E)})}}e.ExtHostLabelService=S}),define(Ee[200],_e([0,1,2,23,9,7,5,8,31,17,10,119,6,89,54,66,56,12,3]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentSymbols(U,K){const J=this._documents.getDocument(U),ie=await this._provider.provideDocumentSymbols(J,K);if(!(0,C.isFalsyOrEmpty)(ie))return ie[0]instanceof y.DocumentSymbol?ie.map(S.DocumentSymbol.from):o._asDocumentSymbolTree(ie)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((ie,q)=>{let ne=ie.location.range.start.compareTo(q.location.range.start);return ne===0&&(ne=q.location.range.end.compareTo(ie.location.range.end)),ne});const K=[],J=[];for(const ie of U){const q={name:ie.name||"!!MISSING: name!!",kind:S.SymbolKind.from(ie.kind),tags:ie.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:ie.containerName,range:S.Range.from(ie.location.range),selectionRange:S.Range.from(ie.location.range),children:[]};for(;;){if(J.length===0){J.push(q),K.push(q);break}const ne=J[J.length-1];if(_.Range.containsRange(ne.range,q.range)&&!_.Range.equalsRange(ne.range,q.range)){ne.children&&ne.children.push(q),J.push(q);break}J.pop()}}return K}}class m{constructor(U,K,J){this._documents=U,this._commands=K,this._provider=J,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,K){const J=this._documents.getDocument(U),ie=await this._provider.provideCodeLenses(J,K);if(!ie||K.isCancellationRequested)return;const q=this._cache.add(ie),ne=new l.DisposableStore;this._disposables.set(q,ne);const pe={cacheId:q,lenses:[]};for(let Re=0;Re<ie.length;Re++)pe.lenses.push({cacheId:[q,Re],range:S.Range.from(ie[Re].range),command:this._commands.toInternal(ie[Re].command,ne)});return pe}async resolveCodeLens(U,K){const J=U.cacheId&&this._cache.get(...U.cacheId);if(!J)return;let ie;if(typeof this._provider.resolveCodeLens!="function"||J.isResolved?ie=J:ie=await this._provider.resolveCodeLens(J,K),ie||(ie=J),K.isCancellationRequested)return;const q=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!q)return U.command=this._commands.toInternal(ie.command??m._badCmd,q),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(Ge){return Array.isArray(Ge)?Ge.map(S.DefinitionLink.from):Ge?[S.DefinitionLink.from(Ge)]:[]}class t{constructor(U,K){this._documents=U,this._provider=K}async provideDefinition(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideDefinition(ie,q,J);return v(ne)}}class r{constructor(U,K){this._documents=U,this._provider=K}async provideDeclaration(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideDeclaration(ie,q,J);return v(ne)}}class a{constructor(U,K){this._documents=U,this._provider=K}async provideImplementation(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideImplementation(ie,q,J);return v(ne)}}class i{constructor(U,K){this._documents=U,this._provider=K}async provideTypeDefinition(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideTypeDefinition(ie,q,J);return v(ne)}}class c{constructor(U,K){this._documents=U,this._provider=K}async provideHover(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideHover(ie,q,J);if(!(!ne||(0,C.isFalsyOrEmpty)(ne.contents)))return ne.range||(ne.range=ie.getWordRangeAtPosition(q)),ne.range||(ne.range=new y.Range(q,q)),S.Hover.from(ne)}}class p{constructor(U,K){this._documents=U,this._provider=K}async provideEvaluatableExpression(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideEvaluatableExpression(ie,q,J);if(ne)return S.EvaluatableExpression.from(ne)}}class d{constructor(U,K){this._documents=U,this._provider=K}async provideInlineValues(U,K,J,ie){const q=this._documents.getDocument(U),ne=await this._provider.provideInlineValues(q,S.Range.to(K),S.InlineValueContext.to(J),ie);if(Array.isArray(ne))return ne.map(pe=>S.InlineValue.from(pe))}}class D{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentHighlights(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideDocumentHighlights(ie,q,J);if(Array.isArray(ne))return ne.map(S.DocumentHighlight.from)}}class I{constructor(U,K){this._documents=U,this._provider=K}async provideLinkedEditingRanges(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.provideLinkedEditingRanges(ie,q,J);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,C.coalesce)(ne.ranges.map(S.Range.from)),wordPattern:ne.wordPattern}}}class s{constructor(U,K){this._documents=U,this._provider=K}async provideReferences(U,K,J,ie){const q=this._documents.getDocument(U),ne=S.Position.to(K),pe=await this._provider.provideReferences(q,ne,J,ie);if(Array.isArray(pe))return pe.map(S.location.from)}}class k{constructor(U,K,J,ie,q,ne,pe){this._documents=U,this._commands=K,this._diagnostics=J,this._provider=ie,this._logService=q,this._extension=ne,this._apiDeprecation=pe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,K,J,ie){const q=this._documents.getDocument(U),ne=T.Selection.isISelection(K)?S.Selection.to(K):S.Range.to(K),pe=[];for(const X of this._diagnostics.getDiagnostics(U))if(ne.intersection(X.range)&&pe.push(X)>k._maxCodeActionsPerFile)break;const Re={diagnostics:pe,only:J.only?new y.CodeActionKind(J.only):void 0,triggerKind:S.CodeActionTriggerKind.to(J.trigger)},We=await this._provider.provideCodeActions(q,ne,Re,ie);if(!(0,C.isNonEmptyArray)(We)||ie.isCancellationRequested)return;const we=this._cache.add(We),Je=new l.DisposableStore;this._disposables.set(we,Je);const z=[];for(let X=0;X<We.length;X++){const de=We[X];!de||(k._isCommand(de)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),z.push({_isSynthetic:!0,title:de.title,command:this._commands.toInternal(de,Je)})):(Re.only&&(de.kind?Re.only.contains(de.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${de.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),z.push({cacheId:[we,X],title:de.title,command:de.command&&this._commands.toInternal(de.command,Je),diagnostics:de.diagnostics&&de.diagnostics.map(S.Diagnostic.from),edit:de.edit&&S.WorkspaceEdit.from(de.edit),kind:de.kind&&de.kind.value,isPreferred:de.isPreferred,disabled:de.disabled?.reason})))}return{cacheId:we,actions:z}}async resolveCodeAction(U,K){const[J,ie]=U,q=this._cache.get(J,ie);if(!q||k._isCommand(q)||!this._provider.resolveCodeAction)return;const ne=await this._provider.resolveCodeAction(q,K)??q;return ne?.edit?S.WorkspaceEdit.from(ne.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}k._maxCodeActionsPerFile=1e3;class F{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentFormattingEdits(U,K,J){const ie=this._documents.getDocument(U),q=await this._provider.provideDocumentFormattingEdits(ie,K,J);if(Array.isArray(q))return q.map(S.TextEdit.from)}}class x{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentRangeFormattingEdits(U,K,J,ie){const q=this._documents.getDocument(U),ne=S.Range.to(K),pe=await this._provider.provideDocumentRangeFormattingEdits(q,ne,J,ie);if(Array.isArray(pe))return pe.map(S.TextEdit.from)}}class j{constructor(U,K){this._documents=U,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,K,J,ie,q){const ne=this._documents.getDocument(U),pe=S.Position.to(K),Re=await this._provider.provideOnTypeFormattingEdits(ne,pe,J,ie,q);if(Array.isArray(Re))return Re.map(S.TextEdit.from)}}class oe{constructor(U,K){this._provider=U,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,K){const J=P.IdObject.mixin({symbols:[]}),ie=await this._provider.provideWorkspaceSymbols(U,K);if((0,C.isNonEmptyArray)(ie))for(const q of ie){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ne=P.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(ne._id,q),J.symbols.push(ne)}return J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J}async resolveWorkspaceSymbol(U,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const J=this._symbolCache.get(U._id);if(J){const ie=await this._provider.resolveWorkspaceSymbol(J,K);return ie&&(0,R.mixin)(U,S.WorkspaceSymbol.from(ie),!0)}}releaseWorkspaceSymbols(U){const K=this._resultCache.get(U);if(K){for(let[J,ie]=K;J<=ie;J++)this._symbolCache.delete(J);this._resultCache.delete(U)}}}class se{constructor(U,K,J){this._documents=U,this._provider=K,this._logService=J}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,K,J,ie){const q=this._documents.getDocument(U),ne=S.Position.to(K);try{const pe=await this._provider.provideRenameEdits(q,ne,J,ie);return pe?S.WorkspaceEdit.from(pe):void 0}catch(pe){const Re=se._asMessage(pe);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(U,K,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ie=this._documents.getDocument(U),q=S.Position.to(K);try{const ne=await this._provider.prepareRename(ie,q,J);let pe,Re;if(y.Range.isRange(ne)?(pe=ne,Re=ie.getText(ne)):(0,n.isObject)(ne)&&(pe=ne.range,Re=ne.placeholder),!pe||!Re)return;if(pe.start.line>q.line||pe.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(pe),text:Re}}catch(ne){const pe=se._asMessage(ne);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(ne)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class V{constructor(U,K){this.resultId=U,this.tokens=K}}class H{constructor(U,K){this._documents=U,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,K,J){const ie=this._documents.getDocument(U),q=K!==0?this._previousResults.get(K):null;let ne=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ie,q.resultId,J):await this._provider.provideDocumentSemanticTokens(ie,J);return q&&this._previousResults.delete(K),ne?(ne=H._fixProvidedSemanticTokens(ne),this._send(H._convertToEdits(q,ne),ne)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return H._isSemanticTokens(U)?H._isCorrectSemanticTokens(U)?U:new y.SemanticTokens(new Uint32Array(U.data),U.resultId):H._isSemanticTokensEdits(U)?H._isCorrectSemanticTokensEdits(U)?U:new y.SemanticTokensEdits(U.edits.map(K=>new y.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const K of U.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,K){if(!H._isSemanticTokens(K)||!U||!U.tokens)return K;const J=U.tokens,ie=J.length,q=K.data,ne=q.length;let pe=0;const Re=Math.min(ie,ne);for(;pe<Re&&J[pe]===q[pe];)pe++;if(pe===ie&&pe===ne)return new y.SemanticTokensEdits([],K.resultId);let We=0;const we=Re-pe;for(;We<we&&J[ie-We-1]===q[ne-We-1];)We++;return new y.SemanticTokensEdits([{start:pe,deleteCount:ie-pe-We,data:q.subarray(pe,ne-We)}],K.resultId)}_send(U,K){if(H._isSemanticTokens(U)){const J=this._nextResultId++;return this._previousResults.set(J,new V(U.resultId,U.data)),(0,h.encodeSemanticTokensDto)({id:J,type:"full",data:U.data})}if(H._isSemanticTokensEdits(U)){const J=this._nextResultId++;return H._isSemanticTokens(K)?this._previousResults.set(J,new V(K.resultId,K.data)):this._previousResults.set(J,new V(U.resultId)),(0,h.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(U.edits||[]).map(ie=>({start:ie.start,deleteCount:ie.deleteCount,data:ie.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class M{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentRangeSemanticTokens(U,K,J){const ie=this._documents.getDocument(U),q=await this._provider.provideDocumentRangeSemanticTokens(ie,S.Range.to(K),J);return q?this._send(q):null}_send(U){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=M;class Q{constructor(U,K,J,ie,q){this._documents=U,this._commands=K,this._provider=J,this._apiDeprecation=ie,this._extension=q,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,K,J,ie){const q=this._documents.getDocument(U),ne=S.Position.to(K),pe=q.getWordRangeAtPosition(ne)||new y.Range(ne,ne),Re=pe.with({end:ne}),We=new b.StopWatch(!0),we=await this._provider.provideCompletionItems(q,ne,ie,S.CompletionContext.to(J));if(!we||ie.isCancellationRequested)return;const Je=Array.isArray(we)?new y.CompletionList(we):we,z=Q.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),X=new l.DisposableStore;this._disposables.set(z,X);const de=[],Ue={x:z,b:de,a:{replace:S.Range.from(pe),insert:S.Range.from(Re)},c:Je.isIncomplete||void 0,d:We.elapsed()};for(let xe=0;xe<Je.items.length;xe++){const et=Je.items[xe],Ce=this._convertCompletionItem(et,[z,xe],Re,pe);de.push(Ce)}return Ue}async resolveCompletionItem(U,K){if(typeof this._provider.resolveCompletionItem!="function")return;const J=this._cache.get(...U);if(!J)return;const ie=await this._provider.resolveCompletionItem(J,K);if(!!ie)return this._convertCompletionItem(ie,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,K,J,ie){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const ne={x:K,a:U.label,b:U.kind!==void 0?S.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(S.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(U.command,q)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ne.h=U.textEdit.newText):typeof U.insertText=="string"?ne.h=U.insertText:U.insertText instanceof y.SnippetString&&(ne.h=U.insertText.value,ne.i|=4);let pe;return U.textEdit?pe=U.textEdit.range:U.range&&(pe=U.range),y.Range.isRange(pe)?ne.j=S.Range.from(pe):pe&&(!J?.isEqual(pe.inserting)||!ie?.isEqual(pe.replacing))&&(ne.j={insert:S.Range.from(pe.inserting),replace:S.Range.from(pe.replacing)}),ne}}class O{constructor(U,K,J){this._documents=U,this._provider=K,this._commands=J,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,K,J,ie){const q=this._documents.getDocument(U),ne=S.Position.to(K),pe=await this._provider.provideInlineCompletionItems(q,ne,J,ie);if(!pe||ie.isCancellationRequested)return;const Re=(0,n.isArray)(pe)?{items:pe}:pe,We=this._cache.add(Re.items);let we;return{pid:We,items:Re.items.map((Je,z)=>{let X;return Je.command&&(we||(we=new l.DisposableStore,this._disposables.set(We,we)),X=this._commands.toInternal(Je.command,we)),{text:Je.text,range:Je.range?S.Range.from(Je.range):void 0,command:X,idx:z}})}}disposeCompletions(U){this._cache.delete(U);const K=this._disposables.get(U);K&&K.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,K){const J=this._cache.get(U,K);J&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:J})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new A.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let K=G.map.get(U);return K||(K=new G,G.map.set(U,K)),K}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=G,G.map=new WeakMap;class fe{constructor(U,K){this._documents=U,this._provider=K,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(U,K,J,ie){const q=this._documents.getDocument(U),ne=S.Position.to(K),pe=this.reviveContext(J),Re=await this._provider.provideSignatureHelp(q,ne,ie,pe);if(Re){const We=this._cache.add([Re]);return{...S.SignatureHelp.from(Re),id:We}}}reviveContext(U){let K;if(U.activeSignatureHelp){const J=S.SignatureHelp.to(U.activeSignatureHelp),ie=this._cache.get(U.activeSignatureHelp.id,0);ie?(K=ie,K.activeSignature=J.activeSignature,K.activeParameter=J.activeParameter):K=J}return{...U,activeSignatureHelp:K}}releaseSignatureHelp(U){this._cache.delete(U)}}class W{constructor(U,K){this._documents=U,this._provider=K}async provideInlayHints(U,K,J){const ie=this._documents.getDocument(U),q=await this._provider.provideInlayHints(ie,S.Range.to(K),J);return q?{hints:q.map(S.InlayHint.from)}:void 0}}class te{constructor(U,K){this._documents=U,this._provider=K,this._cache=new g.Cache("DocumentLink")}async provideLinks(U,K){const J=this._documents.getDocument(U),ie=await this._provider.provideDocumentLinks(J,K);if(!(!Array.isArray(ie)||ie.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ie.filter(te._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(ie),ne={links:[],id:q};for(let pe=0;pe<ie.length;pe++){if(!te._validateLink(ie[pe]))continue;const Re=S.DocumentLink.from(ie[pe]);Re.cacheId=[q,pe],ne.links.push(Re)}return ne}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,K){if(typeof this._provider.resolveDocumentLink!="function")return;const J=this._cache.get(...U);if(!J)return;const ie=await this._provider.resolveDocumentLink(J,K);if(!(!ie||!te._validateLink(ie)))return S.DocumentLink.from(ie)}releaseLinks(U){this._cache.delete(U)}}class he{constructor(U,K){this._documents=U,this._provider=K}async provideColors(U,K){const J=this._documents.getDocument(U),ie=await this._provider.provideDocumentColors(J,K);return Array.isArray(ie)?ie.map(ne=>({color:S.Color.from(ne.color),range:S.Range.from(ne.range)})):[]}async provideColorPresentations(U,K,J){const ie=this._documents.getDocument(U),q=S.Range.to(K.range),ne=S.Color.to(K.color),pe=await this._provider.provideColorPresentations(ne,{document:ie,range:q},J);if(!!Array.isArray(pe))return pe.map(S.ColorPresentation.from)}}class Se{constructor(U,K){this._documents=U,this._provider=K}async provideFoldingRanges(U,K,J){const ie=this._documents.getDocument(U),q=await this._provider.provideFoldingRanges(ie,K,J);if(!!Array.isArray(q))return q.map(S.FoldingRange.from)}}class Le{constructor(U,K,J){this._documents=U,this._provider=K,this._logService=J}async provideSelectionRanges(U,K,J){const ie=this._documents.getDocument(U),q=K.map(S.Position.to),ne=await this._provider.provideSelectionRanges(ie,q,J);if(!(0,C.isNonEmptyArray)(ne))return[];if(ne.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Re=0;Re<q.length;Re++){const We=[];pe.push(We);let we=q[Re],Je=ne[Re];for(;;){if(!Je.range.contains(we))throw new Error("INVALID selection range, must contain the previous range");if(We.push(S.SelectionRange.from(Je)),!Je.parent)break;we=Je.range,Je=Je.parent}}return pe}}class Me{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.prepareCallHierarchy(ie,q,J);if(!ne)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ne)?ne.map(Re=>this._cacheAndConvertItem(pe,Re)):[this._cacheAndConvertItem(pe,ne)]}async provideCallsTo(U,K,J){const ie=this._itemFromCache(U,K);if(!ie)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(ie,J);if(!!q)return q.map(ne=>({from:this._cacheAndConvertItem(U,ne.from),fromRanges:ne.fromRanges.map(pe=>S.Range.from(pe))}))}async provideCallsFrom(U,K,J){const ie=this._itemFromCache(U,K);if(!ie)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(ie,J);if(!!q)return q.map(ne=>({to:this._cacheAndConvertItem(U,ne.to),fromRanges:ne.fromRanges.map(pe=>S.Range.from(pe))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){const J=this._cache.get(U),ie=S.CallHierarchyItem.from(K,U,J.size.toString(36));return J.set(ie._itemId,K),ie}_itemFromCache(U,K){return this._cache.get(U)?.get(K)}}class $e{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,J){const ie=this._documents.getDocument(U),q=S.Position.to(K),ne=await this._provider.prepareTypeHierarchy(ie,q,J);if(!ne)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ne)?ne.map(Re=>this._cacheAndConvertItem(pe,Re)):[this._cacheAndConvertItem(pe,ne)]}async provideSupertypes(U,K,J){const ie=this._itemFromCache(U,K);if(!ie)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(ie,J);if(!!q)return q.map(ne=>this._cacheAndConvertItem(U,ne))}async provideSubtypes(U,K,J){const ie=this._itemFromCache(U,K);if(!ie)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(ie,J);if(!!q)return q.map(ne=>this._cacheAndConvertItem(U,ne))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){const J=this._cache.get(U),ie=S.TypeHierarchyItem.from(K,U,J.size.toString(36));return J.set(ie._itemId,K),ie}_itemFromCache(U,K){return this._cache.get(U)?.get(K)}}class Xe{constructor(U,K){this.adapter=U,this.extension=K}}class qe{constructor(U,K,J,ie,q,ne,pe){this._adapter=new Map,this._uriTransformer=K,this._proxy=U.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=ie,this._diagnostics=q,this._logService=ne,this._apiDeprecation=pe}_transformDocumentSelector(U){return(0,C.coalesce)((0,C.asArray)(U).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:S.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new y.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return qe._handlePool++}_withAdapter(U,K,J,ie,q=!1){const ne=this._adapter.get(U);if(!ne)return Promise.resolve(ie);if(ne.adapter instanceof K){let pe;ne.extension&&(pe=Date.now(),this._logService.trace(`[${ne.extension.identifier.value}] INVOKE provider '${K.name}'`));const Re=J(ne.adapter,ne.extension),We=ne.extension;return We&&Promise.resolve(Re).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-pe}ms`),we=>{q&&we instanceof w.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(we))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,K){const J=this._nextHandle();return this._adapter.set(J,new Xe(U,K)),J}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,K,J,ie){const q=this._addNewAdapter(new o(this._documents,J),U),ne=ie&&ie.label||qe._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),ne),this._createDisposable(q)}$provideDocumentSymbols(U,K,J){return this._withAdapter(U,o,ie=>ie.provideDocumentSymbols(f.URI.revive(K),J),void 0)}registerCodeLensProvider(U,K,J){const ie=this._nextHandle(),q=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ie,new Xe(new m(this._documents,this._commands.converter,J),U)),this._proxy.$registerCodeLensSupport(ie,this._transformDocumentSelector(K),q);let ne=this._createDisposable(ie);if(q!==void 0){const pe=J.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));ne=y.Disposable.from(ne,pe)}return ne}$provideCodeLenses(U,K,J){return this._withAdapter(U,m,ie=>ie.provideCodeLenses(f.URI.revive(K),J),void 0)}$resolveCodeLens(U,K,J){return this._withAdapter(U,m,ie=>ie.resolveCodeLens(K,J),void 0)}$releaseCodeLenses(U,K){this._withAdapter(U,m,J=>Promise.resolve(J.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(U,K,J){const ie=this._addNewAdapter(new t(this._documents,J),U);return this._proxy.$registerDefinitionSupport(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideDefinition(U,K,J,ie){return this._withAdapter(U,t,q=>q.provideDefinition(f.URI.revive(K),J,ie),[])}registerDeclarationProvider(U,K,J){const ie=this._addNewAdapter(new r(this._documents,J),U);return this._proxy.$registerDeclarationSupport(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideDeclaration(U,K,J,ie){return this._withAdapter(U,r,q=>q.provideDeclaration(f.URI.revive(K),J,ie),[])}registerImplementationProvider(U,K,J){const ie=this._addNewAdapter(new a(this._documents,J),U);return this._proxy.$registerImplementationSupport(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideImplementation(U,K,J,ie){return this._withAdapter(U,a,q=>q.provideImplementation(f.URI.revive(K),J,ie),[])}registerTypeDefinitionProvider(U,K,J){const ie=this._addNewAdapter(new i(this._documents,J),U);return this._proxy.$registerTypeDefinitionSupport(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideTypeDefinition(U,K,J,ie){return this._withAdapter(U,i,q=>q.provideTypeDefinition(f.URI.revive(K),J,ie),[])}registerHoverProvider(U,K,J,ie){const q=this._addNewAdapter(new c(this._documents,J),U);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover(U,K,J,ie){return this._withAdapter(U,c,q=>q.provideHover(f.URI.revive(K),J,ie),void 0)}registerEvaluatableExpressionProvider(U,K,J,ie){const q=this._addNewAdapter(new p(this._documents,J),U);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression(U,K,J,ie){return this._withAdapter(U,p,q=>q.provideEvaluatableExpression(f.URI.revive(K),J,ie),void 0)}registerInlineValuesProvider(U,K,J,ie){const q=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new d(this._documents,J),U);this._proxy.$registerInlineValuesProvider(ne,this._transformDocumentSelector(K),q);let pe=this._createDisposable(ne);if(q!==void 0){const Re=J.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(q));pe=y.Disposable.from(pe,Re)}return pe}$provideInlineValues(U,K,J,ie,q){return this._withAdapter(U,d,ne=>ne.provideInlineValues(f.URI.revive(K),J,ie,q),void 0)}registerDocumentHighlightProvider(U,K,J){const ie=this._addNewAdapter(new D(this._documents,J),U);return this._proxy.$registerDocumentHighlightProvider(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideDocumentHighlights(U,K,J,ie){return this._withAdapter(U,D,q=>q.provideDocumentHighlights(f.URI.revive(K),J,ie),void 0)}registerLinkedEditingRangeProvider(U,K,J){const ie=this._addNewAdapter(new I(this._documents,J),U);return this._proxy.$registerLinkedEditingRangeProvider(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideLinkedEditingRanges(U,K,J,ie){return this._withAdapter(U,I,async q=>{const ne=await q.provideLinkedEditingRanges(f.URI.revive(K),J,ie);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?qe._serializeRegExp(ne.wordPattern):void 0}},void 0)}registerReferenceProvider(U,K,J){const ie=this._addNewAdapter(new s(this._documents,J),U);return this._proxy.$registerReferenceSupport(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideReferences(U,K,J,ie,q){return this._withAdapter(U,s,ne=>ne.provideReferences(f.URI.revive(K),J,ie,q),void 0)}registerCodeActionProvider(U,K,J,ie){const q=new l.DisposableStore,ne=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,J,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(ne,this._transformDocumentSelector(K),{providedKinds:ie?.providedCodeActionKinds?.map(pe=>pe.value),documentation:ie?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,q)}))},qe._extLabel(U),Boolean(J.resolveCodeAction)),q.add(this._createDisposable(ne)),q}$provideCodeActions(U,K,J,ie,q){return this._withAdapter(U,k,ne=>ne.provideCodeActions(f.URI.revive(K),J,ie,q),void 0)}$resolveCodeAction(U,K,J){return this._withAdapter(U,k,ie=>ie.resolveCodeAction(K,J),void 0)}$releaseCodeActions(U,K){this._withAdapter(U,k,J=>Promise.resolve(J.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(U,K,J){const ie=this._addNewAdapter(new F(this._documents,J),U);return this._proxy.$registerDocumentFormattingSupport(ie,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(ie)}$provideDocumentFormattingEdits(U,K,J,ie){return this._withAdapter(U,F,q=>q.provideDocumentFormattingEdits(f.URI.revive(K),J,ie),void 0)}registerDocumentRangeFormattingEditProvider(U,K,J){const ie=this._addNewAdapter(new x(this._documents,J),U);return this._proxy.$registerRangeFormattingSupport(ie,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(ie)}$provideDocumentRangeFormattingEdits(U,K,J,ie,q){return this._withAdapter(U,x,ne=>ne.provideDocumentRangeFormattingEdits(f.URI.revive(K),J,ie,q),void 0)}registerOnTypeFormattingEditProvider(U,K,J,ie){const q=this._addNewAdapter(new j(this._documents,J),U);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),ie,U.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(U,K,J,ie,q,ne){return this._withAdapter(U,j,pe=>pe.provideOnTypeFormattingEdits(f.URI.revive(K),J,ie,q,ne),void 0)}registerWorkspaceSymbolProvider(U,K){const J=this._addNewAdapter(new oe(K,this._logService),U);return this._proxy.$registerNavigateTypeSupport(J),this._createDisposable(J)}$provideWorkspaceSymbols(U,K,J){return this._withAdapter(U,oe,ie=>ie.provideWorkspaceSymbols(K,J),{symbols:[]})}$resolveWorkspaceSymbol(U,K,J){return this._withAdapter(U,oe,ie=>ie.resolveWorkspaceSymbol(K,J),void 0)}$releaseWorkspaceSymbols(U,K){this._withAdapter(U,oe,J=>J.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(U,K,J){const ie=this._addNewAdapter(new se(this._documents,J,this._logService),U);return this._proxy.$registerRenameSupport(ie,this._transformDocumentSelector(K),se.supportsResolving(J)),this._createDisposable(ie)}$provideRenameEdits(U,K,J,ie,q){return this._withAdapter(U,se,ne=>ne.provideRenameEdits(f.URI.revive(K),J,ie,q),void 0)}$resolveRenameLocation(U,K,J,ie){return this._withAdapter(U,se,q=>q.resolveRenameLocation(f.URI.revive(K),J,ie),void 0)}registerDocumentSemanticTokensProvider(U,K,J,ie){const q=this._nextHandle(),ne=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Xe(new H(this._documents,J),U)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),ie,ne);let pe=this._createDisposable(q);if(ne){const Re=J.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ne));pe=y.Disposable.from(pe,Re)}return pe}$provideDocumentSemanticTokens(U,K,J,ie){return this._withAdapter(U,H,q=>q.provideDocumentSemanticTokens(f.URI.revive(K),J,ie),null,!0)}$releaseDocumentSemanticTokens(U,K){this._withAdapter(U,H,J=>J.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(U,K,J,ie){const q=this._addNewAdapter(new M(this._documents,J),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),ie),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(U,K,J,ie){return this._withAdapter(U,M,q=>q.provideDocumentRangeSemanticTokens(f.URI.revive(K),J,ie),null,!0)}registerCompletionItemProvider(U,K,J,ie){const q=this._addNewAdapter(new Q(this._documents,this._commands.converter,J,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),ie,Q.supportsResolving(J),`${U.identifier.value}(${ie.join("")})`),this._createDisposable(q)}$provideCompletionItems(U,K,J,ie,q){return this._withAdapter(U,Q,ne=>ne.provideCompletionItems(f.URI.revive(K),J,ie,q),void 0)}$resolveCompletionItem(U,K,J){return this._withAdapter(U,Q,ie=>ie.resolveCompletionItem(K,J),void 0)}$releaseCompletionItems(U,K){this._withAdapter(U,Q,J=>J.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(U,K,J){const ie=this._addNewAdapter(new O(this._documents,J,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideInlineCompletions(U,K,J,ie,q){return this._withAdapter(U,O,ne=>ne.provideInlineCompletions(f.URI.revive(K),J,ie,q),void 0)}$handleInlineCompletionDidShow(U,K,J){this._withAdapter(U,O,async ie=>{ie.handleDidShowCompletionItem(K,J)},void 0)}$freeInlineCompletionsList(U,K){this._withAdapter(U,O,async J=>{J.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(U,K,J,ie){const q=Array.isArray(ie)?{triggerCharacters:ie,retriggerCharacters:[]}:ie,ne=this._addNewAdapter(new fe(this._documents,J),U);return this._proxy.$registerSignatureHelpProvider(ne,this._transformDocumentSelector(K),q),this._createDisposable(ne)}$provideSignatureHelp(U,K,J,ie,q){return this._withAdapter(U,fe,ne=>ne.provideSignatureHelp(f.URI.revive(K),J,ie,q),void 0)}$releaseSignatureHelp(U,K){this._withAdapter(U,fe,J=>J.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(U,K,J){const ie=typeof J.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new W(this._documents,J),U);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),ie);let ne=this._createDisposable(q);if(ie!==void 0){const pe=J.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(ie));ne=y.Disposable.from(ne,pe)}return ne}$provideInlayHints(U,K,J,ie){return this._withAdapter(U,W,q=>q.provideInlayHints(f.URI.revive(K),J,ie),void 0)}registerDocumentLinkProvider(U,K,J){const ie=this._addNewAdapter(new te(this._documents,J),U);return this._proxy.$registerDocumentLinkProvider(ie,this._transformDocumentSelector(K),typeof J.resolveDocumentLink=="function"),this._createDisposable(ie)}$provideDocumentLinks(U,K,J){return this._withAdapter(U,te,ie=>ie.provideLinks(f.URI.revive(K),J),void 0)}$resolveDocumentLink(U,K,J){return this._withAdapter(U,te,ie=>ie.resolveLink(K,J),void 0)}$releaseDocumentLinks(U,K){this._withAdapter(U,te,J=>J.releaseLinks(K),void 0)}registerColorProvider(U,K,J){const ie=this._addNewAdapter(new he(this._documents,J),U);return this._proxy.$registerDocumentColorProvider(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideDocumentColors(U,K,J){return this._withAdapter(U,he,ie=>ie.provideColors(f.URI.revive(K),J),[])}$provideColorPresentations(U,K,J,ie){return this._withAdapter(U,he,q=>q.provideColorPresentations(f.URI.revive(K),J,ie),void 0)}registerFoldingRangeProvider(U,K,J){const ie=this._nextHandle(),q=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ie,new Xe(new Se(this._documents,J),U)),this._proxy.$registerFoldingRangeProvider(ie,this._transformDocumentSelector(K),q);let ne=this._createDisposable(ie);if(q!==void 0){const pe=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ne=y.Disposable.from(ne,pe)}return ne}$provideFoldingRanges(U,K,J,ie){return this._withAdapter(U,Se,q=>q.provideFoldingRanges(f.URI.revive(K),J,ie),void 0)}registerSelectionRangeProvider(U,K,J){const ie=this._addNewAdapter(new Le(this._documents,J,this._logService),U);return this._proxy.$registerSelectionRangeProvider(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$provideSelectionRanges(U,K,J,ie){return this._withAdapter(U,Le,q=>q.provideSelectionRanges(f.URI.revive(K),J,ie),[])}registerCallHierarchyProvider(U,K,J){const ie=this._addNewAdapter(new Me(this._documents,J),U);return this._proxy.$registerCallHierarchyProvider(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$prepareCallHierarchy(U,K,J,ie){return this._withAdapter(U,Me,q=>Promise.resolve(q.prepareSession(f.URI.revive(K),J,ie)),void 0)}$provideCallHierarchyIncomingCalls(U,K,J,ie){return this._withAdapter(U,Me,q=>q.provideCallsTo(K,J,ie),void 0)}$provideCallHierarchyOutgoingCalls(U,K,J,ie){return this._withAdapter(U,Me,q=>q.provideCallsFrom(K,J,ie),void 0)}$releaseCallHierarchy(U,K){this._withAdapter(U,Me,J=>Promise.resolve(J.releaseSession(K)),void 0)}registerTypeHierarchyProvider(U,K,J){const ie=this._addNewAdapter(new $e(this._documents,J),U);return this._proxy.$registerTypeHierarchyProvider(ie,this._transformDocumentSelector(K)),this._createDisposable(ie)}$prepareTypeHierarchy(U,K,J,ie){return this._withAdapter(U,$e,q=>Promise.resolve(q.prepareSession(f.URI.revive(K),J,ie)),void 0)}$provideTypeHierarchySupertypes(U,K,J,ie){return this._withAdapter(U,$e,q=>q.provideSupertypes(K,J,ie),void 0)}$provideTypeHierarchySubtypes(U,K,J,ie){return this._withAdapter(U,$e,q=>q.provideSubtypes(K,J,ie),void 0)}$releaseTypeHierarchy(U,K){this._withAdapter(U,$e,J=>Promise.resolve(J.releaseSession(K)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,E.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:qe._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?qe._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?qe._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:qe._serializeRegExp(U.beforeText),afterText:U.afterText?qe._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?qe._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(qe._serializeOnEnterRule)}setLanguageConfiguration(U,K,J){let{wordPattern:ie}=J;if(ie&&(0,E.regExpLeadsToEndlessLoop)(ie))throw new Error(`Invalid language configuration: wordPattern '${ie}' is not allowed to match the empty string.`);ie?this._documents.setWordDefinitionFor(K,ie):this._documents.setWordDefinitionFor(K,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const q=this._nextHandle(),ne={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?qe._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?qe._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?qe._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,ne),this._createDisposable(q)}$setWordDefinitions(U){for(const K of U)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(Ee[201],_e([0,1,5,9,7,36,15]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(C,n){this._handlePool=0,this._proxy=C.getProxy(f.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,n){await this._proxy.$changeLanguage(C,n);const T=this._documents.getDocumentData(C);if(!T)throw new Error(`document '${C.toString}' NOT found`);return T.document}async tokenAtPosition(C,n){const T=C.version,l=R.Position.from(n),h=await this._proxy.$tokensAtPosition(C.uri,l),u={type:S.StandardTokenType.Other,range:C.getWordRangeAtPosition(n)??new S.Range(n.line,n.character,n.line,n.character)};if(!h)return u;const g={range:R.Range.to(h.range),type:R.TokenType.to(h.type)};return!g.range.contains(n)||T!==C.version?u:g}createLanguageStatusItem(C){const n=this._handlePool++,T=this._proxy,l={selector:C,text:"",detail:"",severity:S.LanguageStatusSeverity.Information};let h;const u=()=>{h?.dispose(),h=(0,P.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:l.selector,text:l.text,message:typeof l.detail=="string"?l.detail:R.MarkdownString.from(l.detail),severity:l.severity===S.LanguageStatusSeverity.Error?y.default.Error:l.severity===S.LanguageStatusSeverity.Warning?y.default.Warning:y.default.Info})},0)},g={get selector(){return l.selector},set selector(b){l.selector=b,u()},get text(){return l.text},set text(b){l.text=b,u()},get detail(){return l.detail},set detail(b){l.detail=b,u()},get severity(){return l.severity},set severity(b){l.severity=b,u()},dispose(){h?.dispose(),T.$removeLanguageStatus(n)}};return u(),g}}e.ExtHostLanguages=E}),define(Ee[202],_e([0,1,5,16,30]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(E){return E&&E.title}let P=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(f.MainContext.MainThreadMessageService)}showMessage(_,C,n,T,l){const h={extension:_};let u;typeof T=="string"||y(T)?u=[T,...l]:(h.modal=T?.modal,h.useCustom=T?.useCustom,h.detail=T?.detail,u=l),h.useCustom&&(0,S.checkProposedApiEnabled)(_);const g=[];for(let b=0;b<u.length;b++){const w=u[b];if(typeof w=="string")g.push({title:w,handle:b,isCloseAffordance:!1});else if(typeof w=="object"){let{title:A,isCloseAffordance:o}=w;g.push({title:A,isCloseAffordance:!!o,handle:b})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(C,n,h,g).then(b=>{if(typeof b=="number")return u[b]})}};P=ze([Ve(1,R.ILogService)],P),e.ExtHostMessageService=P}),define(Ee[203],_e([0,1,24,3,43,6,21,8,10,2,66,5,9,7,179,101]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(A,o,m,v,t){this._textDocumentsAndEditors=m,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=A.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=A.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=A.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const a=r.notebookEditor?.notebookUri,i=r.cell.handle,p=this._documents.get(a)?.getCell(i);if(p)return p.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(A=>A.apiEditor)}getEditorById(A){const o=this._editors.get(A);if(!o)throw new Error(`unknown text editor: ${A}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(A){for(const[o,m]of this._editors)if(m.apiEditor===A)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(A,o){const m=this._documents.get(A);if(!m&&!o)throw new Error(`NO notebook document for '${A}'`);return m}_getProviderData(A){const o=this._notebookContentProviders.get(A);if(!o)throw new Error(`NO provider for '${A}'`);return o}registerNotebookContentProvider(A,o,m,v,t){if((0,E.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:A,provider:m});let r;return m.onDidChangeNotebookContentOptions&&(r=m.onDidChangeNotebookContentOptions(()=>{const a=l.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(o,a)})),this._notebookProxy.$registerNotebookProvider({id:A.identifier,location:A.extensionLocation},o,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(A,t)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(A,o){if(!o)return;const m=o.filenamePattern.map(v=>l.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(o.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:A.identifier,providerDisplayName:A.displayName||A.name,displayName:o.displayName,filenamePattern:m,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(A,o,m){const v=b._notebookStatusBarItemProviderHandlePool++,t=typeof m.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,o);let r;return t!==void 0&&(r=m.onDidChangeCellStatusBarItems(a=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),r&&r.dispose()})}async createNotebookDocument(A){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:A.viewType,content:A.content&&l.NotebookData.from(A.content)});return C.URI.revive(o)}async openNotebookDocument(A){const o=this._documents.get(A);if(o)return o.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(A),v=this._documents.get(C.URI.revive(m));return(0,_.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(A,o){C.URI.isUri(A)&&(A=await this.openNotebookDocument(A));let m;typeof o=="object"?m={position:l.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(l.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:m={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(A.uri,A.notebookType,m),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(A,o,m,v){const t=this._notebookStatusBarItemProviders.get(A),r=C.URI.revive(o),a=this._documents.get(r);if(!a||!t)return;const i=a.getCellFromIndex(m);if(!i)return;const c=await t.provideCellStatusBarItems(i.apiCell,v);if(!c)return;const p=new y.DisposableStore,d=this._statusBarCache.add([p]),I=(Array.isArray(c)?c:[c]).map(s=>l.NotebookStatusBarItem.from(s,this._commandsConverter,p));return{cacheId:d,items:I}}$releaseNotebookCellStatusBarItems(A){this._statusBarCache.delete(A)}registerNotebookSerializer(A,o,m,v,t){if((0,E.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,m),this._notebookProxy.$registerNotebookSerializer(r,{id:A.identifier,location:A.extensionLocation},o,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(A,t)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(A,o,m){const v=this._notebookSerializer.get(A);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(o.buffer,m);return l.NotebookData.from(t)}async $notebookToData(A,o,m){const v=this._notebookSerializer.get(A);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(l.NotebookData.to(o),m);return f.VSBuffer.wrap(t)}async $openNotebook(A,o,m,v,t){const{provider:r}=this._getProviderData(A),a=await r.openNotebook(C.URI.revive(o),{backupId:m,untitledDocumentData:v?.buffer},t);return{metadata:a.metadata??Object.create(null),cells:a.cells.map(l.NotebookCellData.from)}}async $saveNotebook(A,o,m){const v=this.getNotebookDocument(C.URI.revive(o)),{provider:t}=this._getProviderData(A);return await t.saveNotebook(v.apiNotebook,m),!0}async $saveNotebookAs(A,o,m,v){const t=this.getNotebookDocument(C.URI.revive(o)),{provider:r}=this._getProviderData(A);return await r.saveNotebookAs(C.URI.revive(m),t.apiNotebook,v),!0}async $backupNotebook(A,o,m){const v=this.getNotebookDocument(C.URI.revive(o)),t=this._getProviderData(A),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),a=String((0,S.hash)([v.uri.toString(),this._backupIdPool++])),i=C.URI.joinPath(r,a),c=await t.provider.backupNotebook(v.apiNotebook,{destination:i},m);return v.updateBackup(c),c.id}_createExtHostEditor(A,o,m){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const v=new g.ExtHostNotebookEditor(o,this._notebookEditorsProxy,A,m.visibleRanges.map(l.NotebookRange.to),m.selections.map(l.NotebookRange.to),typeof m.viewColumn=="number"?l.ViewColumn.to(m.viewColumn):void 0);this._editors.set(o,v)}$acceptDocumentAndEditorsDelta(A){if(A.removedDocuments)for(const m of A.removedDocuments){const v=C.URI.revive(m),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===v.toString()&&this._editors.delete(r.id)}if(A.addedDocuments){const m=[];for(const v of A.addedDocuments){const t=C.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,a=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){r._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){r._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){r._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){r._onDidChangeCellExecutionState.fire(i)}},t,v);m.push(...v.cells.map(i=>u.ExtHostCell.asModelAddData(a.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(A.addedEditors)for(const m of A.addedEditors){if(this._editors.has(m.id))return;const v=C.URI.revive(m.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,m.id,m)}const o=[];if(A.removedEditors)for(const m of A.removedEditors){const v=this._editors.get(m);v&&(this._editors.delete(m),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),o.push(v))}if(A.visibleEditors){this._visibleNotebookEditors=A.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const m=new Set;this._visibleNotebookEditors.forEach(v=>m.add(v.id));for(const v of this._editors.values()){const t=m.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}A.newActiveEditor===null?this._activeNotebookEditor=void 0:A.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(A.newActiveEditor)),A.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(Ee[204],_e([0,1,3,54,16,5,13,9]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(T,l){const h=_._Keys.nextId();T.$registerNotebookEditorDecorationType(h,E.NotebookDecorationRenderOptions.from(l)),this.value={key:h,dispose(){T.$removeNotebookEditorDecorationType(h)}}}}_._Keys=new R.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(T,l,h){this._logService=T,this._extHostRpc=l,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(T){return new _(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),T).value}$acceptEditorPropertiesChanged(T,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,l);const h=this._notebooksAndEditors.getEditorById(T);l.visibleRanges&&h._acceptVisibleRanges(l.visibleRanges.ranges.map(E.NotebookRange.to)),l.selections&&h._acceptSelections(l.selections.selections.map(E.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const l in T)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(E.ViewColumn.to(T[l]))}};C=ze([Ve(0,S.ILogService),Ve(1,P.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(Ee[205],_e([0,1,3,6,5,26,2,9,71,21,15,72,20,17,16,7,30]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,a,i){this._initData=r,this._extHostNotebook=a,this._logService=i,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,a,i,c,p){for(let O of this._kernelData.values())if(O.controller.id===r&&y.ExtensionIdentifier.equals(t.identifier,O.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const d=this._handlePool++,D=this;this._logService.trace(`NotebookController[${d}], CREATED by ${t.identifier.value}, ${r}`);const I=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${t.identifier}'`);let s=!1;const k=new R.DisposableStore,F=new f.Emitter,x=new f.Emitter,j={id:`${t.identifier.value}/${r}`,notebookType:a,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:p?p.map(E.NotebookRendererScript.from):[]};let oe=c??I,se;this._proxy.$addKernel(d,j).catch(O=>{console.log(O),s=!0});let V=0;const H=()=>{if(s)return;const O=++V;Promise.resolve().then(()=>{O===V&&this._proxy.$updateKernel(d,j)})},M=new C.ResourceMap,Q={get id(){return r},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return j.label},set label(O){j.label=O??t.displayName??t.name,H()},get detail(){return j.detail??""},set detail(O){j.detail=O,H()},get description(){return j.description??""},set description(O){j.description=O,H()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(O){j.supportedLanguages=O,H()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(O){j.supportsExecutionOrder=O,H()},get rendererScripts(){return j.preloads?j.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return oe},set executeHandler(O){oe=O??I},get interruptHandler(){return se},set interruptHandler(O){se=O,j.supportsInterrupt=Boolean(O),H()},createNotebookCellExecution(O){if(s)throw new Error("notebook controller is DISPOSED");if(!M.has(O.notebook.uri))throw D._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(M.keys()).map(G=>G.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return D._createNotebookCellExecution(O)},dispose:()=>{s||(this._logService.trace(`NotebookController[${d}], DISPOSED`),s=!0,this._kernelData.delete(d),k.dispose(),F.dispose(),x.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(O,G){D._proxy.$updateNotebookPriority(d,O.uri,G)},onDidReceiveMessage:x.event,postMessage(O,G){return(0,b.checkProposedApiEnabled)(t),D._proxy.$postMessage(d,G&&D._extHostNotebook.getIdByEditor(G),O)},asWebviewUri(O){return(0,b.checkProposedApiEnabled)(t),(0,_.asWebviewUri)(O,D._initData.remote)}};return this._kernelData.set(d,{extensionId:t.identifier,controller:Q,onDidReceiveMessage:x,onDidChangeSelection:F,associatedNotebooks:M}),Q}$acceptNotebookAssociation(t,r,a){const i=this._kernelData.get(t);if(i){const c=this._extHostNotebook.getNotebookDocument(P.URI.revive(r));a?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,c.uri.toString(),a),i.onDidChangeSelection.fire({selected:a,notebook:c.apiNotebook})}}async $executeCells(t,r,a){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(P.URI.revive(r)),p=[];for(let d of a){const D=c.getCell(d);D&&p.push(D.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,c.uri.toString(),p.length),await i.controller.executeHandler.call(i.controller,p,c.apiNotebook,i.controller)}catch(d){this._logService.error(`NotebookController[${t}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(t,r,a){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(P.URI.revive(r));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(let p of a){const d=c.getCell(p);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,a){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:a}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const i=new o(a.notebook,a,this._proxy);this._activeExecutions.set(a.uri,i);const c=i.onDidChangeState(()=>{i.state===A.Resolved&&(i.dispose(),c.dispose(),this._activeExecutions.delete(a.uri))});return i.asApiObject()}};w=ze([Ve(3,u.ILogService)],w),e.ExtHostNotebookKernels=w;var A;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(A||(A={}));class o extends R.Disposable{constructor(t,r,a){super();this._document=t,this._cell=r,this._proxy=a,this._onDidChangeState=new f.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=A.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new m(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:T.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===A.Init)throw new Error("Must call start before modifying cell output");if(this._state===A.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const a=g.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return a===r.items?E.NotebookCellOutput.from(r):E.NotebookCellOutput.from({items:a,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,a){const i=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,h.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:a,outputs:c})}async updateOutputItems(t,r,a){return t=g.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(E.NotebookCellOutputItem.from),outputId:r.id,append:a})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(a){t._executionOrder=a,t.mixinMetadata({executionOrder:a})},start(a){if(t._state===A.Resolved||t._state===A.Started)throw new Error("Cannot call start again");t._state=A.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:T.NotebookCellExecutionState.Executing,runStartTime:a??null})},end(a,i){if(t._state===A.Resolved)throw new Error("Cannot call resolve twice");t._state=A.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:a??null,runEndTime:i??null})},clearOutput(a){return t.verifyStateForOutput(),t.updateOutputs([],a,!1)},appendOutput(a,i){return t.verifyStateForOutput(),t.updateOutputs(a,i,!0)},replaceOutput(a,i){return t.verifyStateForOutput(),t.updateOutputs(a,i,!1)},appendOutputItems(a,i){return t.verifyStateForOutput(),t.updateOutputItems(a,i,!0)},replaceOutputItems(a,i){return t.verifyStateForOutput(),t.updateOutputItems(a,i,!1)}})}}class m{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(Ee[206],_e([0,1,3,5,101]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(E,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=E.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(E,_,C){const n=this._extHostNotebook.getEditorById(E);this._rendererMessageEmitters.get(_)?.fire({editor:n.apiEditor,message:C})}createRendererMessaging(E,_){if(!E.contributes?.notebookRenderer?.some(l=>l.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const C=!!E.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(l,h,u)=>{const g=C?l:b=>{const w={};n.set(w,b.editor),l({editor:w,message:b.message})};return this.getOrCreateEmitterFor(_).event(g,h,u)},postMessage:(l,h)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(l)&&([l,h]=[h,l]);const u=C?h:n.get(h),g=u&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(g?.id,_,l)}}}getOrCreateEmitterFor(E){let _=this._rendererMessageEmitters.get(E);return _||(_=new f.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(E)}}),this._rendererMessageEmitters.set(E,_),_)}}e.ExtHostNotebookRenderers=y}),define(Ee[105],_e([0,1,5,3,6,24,4,13]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends S.Disposable{constructor(u,g,b,w,A){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=A,this._id=A.$register(this.name,g,b,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?y.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(g=>this._proxy.$clear(g,u))}show(u,g){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof u=="boolean"?u:g)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(u,g,b){super(u,!1,void 0,g,b)}append(u){super.append(u),this._id.then(g=>this._proxy.$append(g,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends _{constructor(u,g,b){super(u,!0,g,void 0,b)}append(u){throw new Error("Not supported")}}class T{constructor(u,g){this.name=u,this._channel=g}append(u){this._channel.then(g=>g.append(u))}appendLine(u){this._channel.then(g=>g.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,g){this._channel.then(b=>b.show(u,g))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=T;let l=class{constructor(u){this._proxy=u.getProxy(f.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new C(u,g.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new n(u,g,this._proxy)}};l=ze([Ve(0,E.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(Ee[207],_e([0,1,15,20,3,6,5,2,7,12,17,36]),function(Z,e,f,R,S,y,P,E,_,C,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(h,u,g){const b=h.getProxy(P.MainContext.MainThreadQuickOpen);class w{constructor(i,c){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=c}showQuickPick(i,c,p,d=R.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(i),I=++this._instances,s=b.$show(I,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},d),k={},F=s.then(()=>k);return Promise.race([F,D]).then(x=>{if(x!==k)return D.then(j=>{const oe=[];for(let se=0;se<j.length;se++){const V=j[se];let H,M,Q,O,G;typeof V=="string"?H=V:(H=V.label,M=V.description,Q=V.detail,O=V.picked,G=V.alwaysShow),oe.push({label:H,description:M,handle:se,detail:Q,picked:O,alwaysShow:G})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=se=>{p.onDidSelectItem(j[se])}),b.$setItems(I,oe),s.then(se=>{if(typeof se=="number")return j[se];if(Array.isArray(se))return se.map(V=>j[V])})})}).then(void 0,x=>{if(!(0,C.isPromiseCanceledError)(x))return b.$setError(I,x),Promise.reject(x)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,c=R.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,b.$input(i,typeof this._validateInput=="function",c).then(void 0,p=>{if(!(0,C.isPromiseCanceledError)(p))return Promise.reject(p)})}$validateInput(i){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,c=R.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!p)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(D=>D.uri.toString()===p.uri.toString())}createQuickPick(i,c){const p=new t(i,c,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(i){const c=new r(i,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(i,c){const p=this._sessions.get(i);p&&p._fireDidChangeValue(c)}$onDidAccept(i){const c=this._sessions.get(i);c&&c._fireDidAccept()}$onDidChangeActive(i,c){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeActive(c)}$onDidChangeSelection(i,c){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeSelection(c)}$onDidTriggerButton(i,c){const p=this._sessions.get(i);p&&p._fireDidTriggerButton(c)}$onDidHide(i){const c=this._sessions.get(i);c&&c._fireDidHide()}}class A{constructor(i,c){this._extensionId=i,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((c,p)=>{const d=c===_.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(d,c)}),this.update({buttons:i.map((c,p)=>({iconPath:o(c.iconPath),tooltip:c.tooltip,handle:c===_.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const c=this._handlesToButtons.get(i);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(i){if(!this._disposed){for(const c of Object.keys(i)){const p=i[c];this._pendingUpdate[c]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}A._nextId=1;function o(a){if(a instanceof _.ThemeIcon)return{id:a.id};const i=v(a),c=m(a);return{dark:typeof i=="string"?E.URI.file(i):i,light:typeof c=="string"?E.URI.file(c):c}}function m(a){return typeof a=="object"&&"light"in a?a.light:a}function v(a){return typeof a=="object"&&"dark"in a?a.dark:a}class t extends A{constructor(i,c,p){super(i,p);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((c,p)=>{this._handlesToItems.set(p,c),this._itemsToHandles.set(c,p)}),this.update({items:i.map((c,p)=>({label:c.label,description:c.description,handle:p,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(i){const c=(0,n.coalesce)(i.map(p=>this._handlesToItems.get(p)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(i){const c=(0,n.coalesce)(i.map(p=>this._handlesToItems.get(p)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class r extends A{constructor(i,c){super(i,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?T.default.Error:T.default.Ignore})}}return new w(u,g)}e.createExtHostQuickOpen=l}),define(Ee[208],_e([0,1,2,3,52,6,15,5,17,116,16,26,30,65,9]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(p){if(p)return typeof p.iconPath=="string"?f.URI.file(p.iconPath):f.URI.isUri(p.iconPath)||h.ThemeIcon.isThemeIcon(p.iconPath)?p.iconPath:void 0}function b(p,d){if(!p.iconPath&&!d.iconPath)return 0;if(p.iconPath){if(!d.iconPath)return 1}else return-1;const D=typeof p.iconPath=="string"?p.iconPath:f.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id,I=typeof d.iconPath=="string"?d.iconPath:f.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,C.comparePaths)(D,I)}function w(p,d){let D=0;if(p.strikeThrough!==d.strikeThrough)return p.strikeThrough?1:-1;if(p.faded!==d.faded)return p.faded?1:-1;if(p.tooltip!==d.tooltip)return(p.tooltip||"").localeCompare(d.tooltip||"");if(D=b(p,d),D!==0)return D;if(p.light&&d.light)D=b(p.light,d.light);else{if(p.light)return 1;if(d.light)return-1}if(D!==0)return D;if(p.dark&&d.dark)D=b(p.dark,d.dark);else{if(p.dark)return 1;if(d.dark)return-1}return D}function A(p,d){if(p.command!==d.command)return p.command<d.command?-1:1;if(p.title!==d.title)return p.title<d.title?-1:1;if(p.tooltip!==d.tooltip){if(p.tooltip!==void 0&&d.tooltip!==void 0)return p.tooltip<d.tooltip?-1:1;if(p.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(p.arguments===d.arguments)return 0;if(p.arguments)if(d.arguments){if(p.arguments.length!==d.arguments.length)return p.arguments.length-d.arguments.length}else return 1;else return-1;for(let D=0;D<p.arguments.length;D++){const I=p.arguments[D],s=d.arguments[D];if(I!==s)return I<s?-1:1}return 0}function o(p,d){let D=(0,C.comparePaths)(p.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(D!==0)return D;if(p.command&&d.command)D=A(p.command,d.command);else{if(p.command)return 1;if(d.command)return-1}if(D!==0)return D;if(p.decorations&&d.decorations)D=w(p.decorations,d.decorations);else{if(p.decorations)return 1;if(d.decorations)return-1}return D}function m(p,d){for(let D=0;D<p.length;D++)if(p[D]!==d[D])return!1;return!0}function v(p,d){return p.command===d.command&&p.title===d.title&&p.tooltip===d.tooltip&&(p.arguments&&d.arguments?m(p.arguments,d.arguments):p.arguments===d.arguments)}function t(p,d){return(0,_.equals)(p,d,v)}class r{constructor(d,D,I){this._extension=d,this._proxy=D,this._sourceControlHandle=I,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,l.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,D){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,D)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=r;class a{constructor(d,D,I,s,k){this._proxy=d,this._commands=D,this._sourceControlHandle=I,this._id=s,this._label=k,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,D){const I=this._resourceStatesCommandsMap.get(d);return I?(0,P.asPromise)(()=>this._commands.executeCommand(I.command,...I.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(o),I=(0,_.sortedDiff)(this._resourceSnapshot,d,o).map(F=>{const x=F.toInsert.map(j=>{const oe=this._resourceHandlePool++;this._resourceStatesMap.set(oe,j);const se=j.resourceUri;let V;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const Se=new y.DisposableStore;V=this._commands.converter.toInternal(j.command,Se),this._resourceStatesDisposablesMap.set(oe,Se)}else this._resourceStatesCommandsMap.set(oe,j.command);const H=g(j.decorations),M=j.decorations&&g(j.decorations.light)||H,Q=j.decorations&&g(j.decorations.dark)||H,O=[M,Q],G=j.decorations&&j.decorations.tooltip||"",fe=j.decorations&&!!j.decorations.strikeThrough,W=j.decorations&&!!j.decorations.faded,te=j.contextValue||"";return{rawResource:[oe,se,O,G,fe,W,te,V],handle:oe}});return{start:F.start,deleteCount:F.deleteCount,toInsert:x}}),s=I.map(({start:F,deleteCount:x,toInsert:j})=>[F,x,j.map(oe=>oe.rawResource)]),k=I.reverse();for(const{start:F,deleteCount:x,toInsert:j}of k){const oe=j.map(V=>V.handle),se=this._handlesSnapshot.splice(F,x,...oe);for(const V of se)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),this._resourceStatesDisposablesMap.get(V)?.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=d,s}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class i{constructor(d,D,I,s,k,F){this._proxy=D,this._commands=I,this._id=s,this._label=k,this._rootUri=F,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,s,k,F)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=d;const D=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:D})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=d;const D=(d||[]).map(I=>this._commands.converter.toInternal(I,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}createResourceGroup(d,D){const I=new a(this._proxy,this._commands,this.handle,d,D),s=R.Event.once(I.onDidDispose)(()=>this.createdResourceGroups.delete(I));return this.createdResourceGroups.set(I,s),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const d=[],D=[];for(const[I,s]of this.createdResourceGroups){s.dispose();const k=I.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(I),this.eventuallyUpdateResourceStates()});R.Event.once(I.onDidDispose)(()=>{this.updatedResourceGroups.delete(I),k.dispose(),this._groups.delete(I.handle),this._proxy.$unregisterGroup(this.handle,I.handle)}),d.push([I.handle,I.id,I.label,I.features]);const F=I._takeResourceStateSnapshot();F.length>0&&D.push([I.handle,F]),this._groups.set(I.handle,I)}this._proxy.$registerGroups(this.handle,d,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(D=>{const I=D._takeResourceStateSnapshot();I.length!==0&&d.push([D.handle,I])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,ze([(0,S.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let c=class Bn{constructor(d,D,I){this._commands=D,this.logService=I,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=d.getProxy(E.MainContext.MainThreadSCM),this._telemetry=d.getProxy(E.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===3){const k=this._sourceControls.get(s.sourceControlHandle);if(!k)return s;const F=k.getResourceGroup(s.groupHandle);return F?F.getResourceState(s.handle):s}else if(s&&s.$mid===4){const k=this._sourceControls.get(s.sourceControlHandle);return k?k.getResourceGroup(s.groupHandle):s}else if(s&&s.$mid===5){const k=this._sourceControls.get(s.handle);return k||s}return s}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,D,I,s){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,D,I,s),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const k=Bn._handlePool++,F=new i(d,this._proxy,this._commands,D,I,s);this._sourceControls.set(k,F);const x=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(d.identifier))||[];return x.push(F),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(d.identifier),x),F}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const D=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(d.identifier)),I=D&&D[D.length-1];return I&&I.inputBox}$provideOriginalResource(d,D,I){const s=f.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,s.toString());const k=this._sourceControls.get(d);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(s,I)).then(F=>F||null)}$onInputBoxValueChange(d,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const I=this._sourceControls.get(d);return I&&I.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(d,D,I,s){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,D,I);const k=this._sourceControls.get(d);if(!k)return Promise.resolve(void 0);const F=k.getResourceGroup(D);return F?F.$executeResourceCommand(I,s):Promise.resolve(void 0)}$validateInput(d,D,I){this.logService.trace("ExtHostSCM#$validateInput",d);const s=this._sourceControls.get(d);return!s||!s.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>s.inputBox.validateInput(D,I)).then(k=>{if(!k)return Promise.resolve(void 0);const F=u.MarkdownString.fromStrict(k.message);return F?Promise.resolve([F,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};c._handlePool=0,c=ze([Ve(2,n.ILogService)],c),e.ExtHostSCM=c});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[209],_e([0,1,7,5,136,6,9]),function(Z,e,f,R,S,y,P){"use strict";var E,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(h,u,g,b,w=f.StatusBarAlignment.Left,A){E.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,it(this,E,h,"f"),it(this,_,u,"f"),this._entryId=C.ID_GEN++,this._extension=g,this._id=b,this._alignment=w,this._priority=A}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!C.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Be(this,_,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Be(this,_,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let u;this._name?u=this._name:u=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,E,"f").$setEntry(this._entryId,h,u,this._text,b,this._command?.internal,g,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,E=new WeakMap,_=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const u={message:h};return this._messages.unshift(u),this._update(),new f.Disposable(()=>{const g=this._messages.indexOf(u);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(h,u){this._proxy=h.getProxy(R.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(h,u,g,b){return new C(this._proxy,this._commands,h,u,g,b)}setStatusBarMessage(h,u){const g=this._statusMessage.setMessage(h);let b;return typeof u=="number"?b=setTimeout(()=>g.dispose(),u):typeof u!="undefined"&&u.then(()=>g.dispose(),()=>g.dispose()),new f.Disposable(()=>{g.dispose(),clearTimeout(b)})}}e.ExtHostStatusBar=T}),define(Ee[77],_e([0,1,5,3,4]),function(Z,e,f,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(E){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=E.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(E,_){this._proxy.$registerExtensionStorageKeysToSync(E,_)}getValue(E,_,C){return this._proxy.$getValue(E,_).then(n=>n||C)}setValue(E,_,C){return this._proxy.$setValue(E,_,C)}$acceptValue(E,_,C){this._onDidChangeStorage.fire({shared:E,key:_,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ee[78],_e([0,1,4,29,16,76,2]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let E=class{constructor(C,n,T){this._logService=n,this._extHostFileSystem=T,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(C){return P.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,n=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(C){if(this._value)return P.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return P.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};E=ze([Ve(0,R.IExtHostInitDataService),Ve(1,S.ILogService),Ve(2,y.IExtHostConsumerFileSystem)],E),e.ExtensionStoragePaths=E}),define(Ee[39],_e([0,1,3,5,4,2,13,6,7,137,12,174,20,37,158,65,10]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class w{constructor(c,p,d,D){this._proxy=c,this._id=p,this._creationOptions=d,this._name=D,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(s=>this._pidPromiseComplete=s);const I=this;this.value={get name(){return I._name||""},get processId(){return I._pidPromise},get creationOptions(){return I._creationOptions},get exitStatus(){return I._exitStatus},sendText(s,k=!0){I._checkDisposed(),I._proxy.$sendText(I._id,s,k)},show(s){I._checkDisposed(),I._proxy.$show(I._id,s)},hide(){I._checkDisposed(),I._proxy.$hide(I._id)},dispose(){I._disposed||(I._disposed=!0,I._proxy.$dispose(I._id))},get dimensions(){if(!(I._cols===void 0||I._rows===void 0))return{columns:I._cols,rows:I._rows}}}}async create(c,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,b.withNullAsUndefined)(c.shellPath),shellArgs:(0,b.withNullAsUndefined)(c.shellArgs),cwd:(0,b.withNullAsUndefined)(c.cwd),env:(0,b.withNullAsUndefined)(c.env),icon:(0,b.withNullAsUndefined)(r(c.iconPath)),color:g.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,b.withNullAsUndefined)(c.message),strictEnv:(0,b.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(p?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(p?.useShellEnvironment),isSplitTerminal:p?.isSplitTerminal,target:p?.target})}async createExtensionTerminal(c,p,d,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:g.ThemeColor.isThemeColor(D)?D.id:void 0,isSplitTerminal:c,target:p}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,p){return c===this._cols&&p===this._rows||c===0||p===0?!1:(this._cols=c,this._rows=p,!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(p=>{p!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=w;class A{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new f.Emitter,this._onProcessTitleChanged=new f.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new f.Emitter,this._onProcessShellTypeChanged=new f.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,p){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:p})}async processBinary(c){}acknowledgeDataEvent(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(p=>this._onProcessData.fire(p)),this._pty.onDidClose&&this._pty.onDidClose((p=void 0)=>{this._onProcessExit.fire(p===void 0?void 0:p)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(p=>this._onProcessOverrideDimensions.fire(p&&{cols:p.columns,rows:p.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(p=>this._onProcessTitleChanged.fire(p)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=A;let o=1,m=class extends E.Disposable{constructor(c,p){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this._onDidOpenTerminal=new f.Emitter,this._onDidChangeActiveTerminal=new f.Emitter,this._onDidChangeTerminalDimensions=new f.Emitter,this._proxy=p.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[d,D]of this._terminalProcesses)D.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,p){const d=new w(this._proxy,(0,h.generateUuid)(),c,c.name),D=new A(c.pty);return d.createExtensionTerminal(p?.isSplitTerminal,p?.target,r(c.iconPath),a(c.color)).then(I=>{const s=this._setupExtHostProcessListeners(I,D);this._terminalProcessDisposables[I]=s}),this._terminals.push(d),d.value}attachPtyToTerminal(c,p){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const D=new A(p),I=this._setupExtHostProcessListeners(c,D);this._terminalProcessDisposables[c]=I}async $acceptActiveTerminalChanged(c){const p=this._activeTerminal;if(c===null){this._activeTerminal=void 0,p!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(c);d&&(this._activeTerminal=d,p!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,p){const d=this._getTerminalById(c);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:p})}async $acceptTerminalDimensions(c,p,d){const D=this._getTerminalById(c);D&&D.setDimensions(p,d)&&this._onDidChangeTerminalDimensions.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(c,p,d){this._terminalProcesses.get(c)?.resize(p,d)}async $acceptTerminalTitleChange(c,p){const d=this._getTerminalById(c);d&&(d.name=p)}async $acceptTerminalClosed(c,p){const d=this._getTerminalObjectIndexById(this._terminals,c);if(d!==null){const D=this._terminals.splice(d,1)[0];D.setExitCode(p),this._onDidCloseTerminal.fire(D.value)}}$acceptTerminalOpened(c,p,d,D){if(p){const k=this._getTerminalObjectIndexById(this._terminals,p);if(k!==null){this._terminals[k]._id=c,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const I={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:y.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},s=new w(this._proxy,c,I,d);this._terminals.push(s),this._onDidOpenTerminal.fire(s.value),s.isOpen=!0}async $acceptTerminalProcessId(c,p){const d=this._getTerminalById(c);d&&d._setProcessId(p)}async $startExtensionTerminal(c,p){const d=this._getTerminalById(c);if(!d)return{message:(0,C.localize)(0,null,c)};d.isOpen||await new Promise(I=>{const s=this.onDidOpenTerminal(async k=>{k===d.value&&(s.dispose(),I())})});const D=this._terminalProcesses.get(c);D?D.startSendingEvents(p):this._extensionTerminalAwaitingStart[c]={initialDimensions:p}}_setupExtHostProcessListeners(c,p){const d=new E.DisposableStore;d.add(p.onProcessReady(I=>this._proxy.$sendProcessReady(c,I.pid,I.cwd))),d.add(p.onProcessTitleChanged(I=>this._proxy.$sendProcessTitle(c,I))),this._bufferer.startBuffering(c,p.onProcessData),d.add(p.onProcessExit(I=>this._onProcessExit(c,I))),p.onProcessOverrideDimensions&&d.add(p.onProcessOverrideDimensions(I=>this._proxy.$sendOverrideDimensions(c,I))),this._terminalProcesses.set(c,p);const D=this._extensionTerminalAwaitingStart[c];return D&&p instanceof A&&(p.startSendingEvents(D.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),d}$acceptProcessAckDataEvent(c,p){this._terminalProcesses.get(c)?.acknowledgeDataEvent(p)}$acceptProcessInput(c,p){this._terminalProcesses.get(c)?.input(p)}$acceptProcessResize(c,p,d){try{this._terminalProcesses.get(c)?.resize(p,d)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(c,p){this._terminalProcesses.get(c)?.shutdown(p)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(p=>this._proxy.$sendProcessInitialCwd(c,p))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(p=>this._proxy.$sendProcessCwd(c,p))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,p,d){if(this._profileProviders.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this._profileProviders.set(p,d),this._proxy.$registerProfileProvider(p,c.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(p),this._proxy.$unregisterProfileProvider(p)})}async $createContributedProfileTerminal(c,p){const d=new l.CancellationTokenSource().token,D=await this._profileProviders.get(c)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,p);return}this.createTerminalFromOptions(D.options,p)}}async $provideLinks(c,p){const d=this._getTerminalById(c);if(!d)return[];this._terminalLinkCache.delete(c);const D=this._terminalLinkCancellationSource.get(c);D&&D.dispose(!0);const I=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,I);const s=[],k={terminal:d.value,line:p},F=[];for(const oe of this._linkProviders)F.push(new Promise(async se=>{I.token.onCancellationRequested(()=>se({provider:oe,links:[]}));const V=await oe.provideTerminalLinks(k,I.token)||[];I.token.isCancellationRequested||se({provider:oe,links:V})}));const x=await Promise.all(F);if(I.token.isCancellationRequested)return[];const j=new Map;for(const oe of x)oe&&oe.links.length>0&&s.push(...oe.links.map(se=>{const V={id:o++,startIndex:se.startIndex,length:se.length,label:se.tooltip};return j.set(V.id,{provider:oe.provider,link:se}),V}));return this._terminalLinkCache.set(c,j),s}$activateLink(c,p){const d=this._terminalLinkCache.get(c)?.get(p);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(c,p){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const d=this._terminalProcessDisposables[c];d&&(d.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,p)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,p){const d=this._getTerminalObjectIndexById(c,p);return d!==null?c[d]:null}_getTerminalObjectIndexById(c,p){let d=null;return c.some((D,I)=>D._id===p?(d=I,!0):!1),d}getEnvironmentVariableCollection(c){let p=this._environmentVariableCollections.get(c.identifier.value);return p||(p=new v,this._setEnvironmentVariableCollection(c.identifier.value,p)),p}_syncEnvironmentVariableCollection(c,p){const d=(0,T.serializeEnvironmentVariableCollection)(p.map);this._proxy.$setEnvironmentVariableCollection(c,p.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(c){c.forEach(p=>{const d=p[0],D=new v(p[1]);this._setEnvironmentVariableCollection(d,D)})}$acceptDefaultProfile(c,p){this._defaultProfile=c,this._defaultAutomationProfile=p}_setEnvironmentVariableCollection(c,p){this._environmentVariableCollections.set(c,p),p.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,p)})}};m=ze([Ve(1,P.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class v{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,p){this._setIfDiffers(c,{value:p,type:_.EnvironmentVariableMutatorType.Replace})}append(c,p){this._setIfDiffers(c,{value:p,type:_.EnvironmentVariableMutatorType.Append})}prepend(c,p){this._setIfDiffers(c,{value:p,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,p){const d=this.map.get(c);(!d||d.value!==p.value||d.type!==p.type)&&(this.map.set(c,p),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,p){this.map.forEach((d,D)=>c.call(p,D,d,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends m{constructor(c){super(!1,c)}createTerminal(c,p,d){throw new n.NotSupportedError}createTerminalFromOptions(c,p){throw new n.NotSupportedError}};t=ze([Ve(0,P.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function a(i){return g.ThemeColor.isThemeColor(i)?i:void 0}});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[210],_e([0,1,24,20,3,53,43,55,6,23,10,37,5,13,68,9,7,182,99,73]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(F,x){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(l.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new r(this.proxy),x.registerArgumentProcessor({processArgument:j=>j?.$mid===13?g.TestItem.toItemFromContext(j):j})}createTestController(F,x){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const j=new _.DisposableStore,oe=j.add(new w.SingleUseTestCollection(F));oe.root.label=x;const se=new Map,V=this.proxy,H={items:oe.root.children,get label(){return x},set label(Q){x=Q,oe.root.label=Q,V.$updateControllerLabel(F,x)},get id(){return F},createRunProfile:(Q,O,G,fe,W)=>{let te=(0,P.hash)(Q);for(;se.has(te);)te++;const he=new I(this.proxy,F,te,Q,O,G,fe,W);return se.set(te,he),he},createTestItem(Q,O,G){return new u.TestItemImpl(F,Q,O,G)},createTestRun:(Q,O,G=!0)=>this.runTracker.createTestRun(F,oe,Q,O,G),set resolveHandler(Q){oe.resolveHandler=Q},get resolveHandler(){return oe.resolveHandler},dispose:()=>{j.dispose()}};H.createRunConfiguration=H.createRunProfile,V.$registerTestController(F,x),j.add((0,_.toDisposable)(()=>V.$unregisterTestController(F)));const M={controller:H,collection:oe,profiles:se};return this.controllers.set(F,M),j.add((0,_.toDisposable)(()=>this.controllers.delete(F))),j.add(oe.onDidGenerateDiff(Q=>V.$publishDiff(F,Q))),H}createTestObserver(){return this.observer.checkout()}async runTests(F,x=R.CancellationToken.None){const j=a(F);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const oe=this.controllers.get(j.controllerId);if(!oe)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:F.include?.map(se=>se.id)??[oe.collection.root.id],profileGroup:s[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:F.exclude?.map(se=>se.id)},x)}$provideFileCoverage(F,x,j){return E.Iterable.find(this.runTracker.trackers,oe=>oe.id===F)?.getCoverage(x)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(F,x,j,oe){return E.Iterable.find(this.runTracker.trackers,se=>se.id===F)?.getCoverage(x)?.resolveFileCoverage(j,oe)??Promise.resolve([])}$configureRunProfile(F,x){this.controllers.get(F)?.profiles.get(x)?.configureHandler?.()}$getTestTags(F){const x=this.controllers.get(F);if(!x)return Promise.resolve([]);const j=new Map;for(const oe of x.profiles.values())if(oe.tag){const se=g.TestTag.display(F,oe.tag);j.set(se.id,se)}for(const oe of x.collection.tags()){const se=g.TestTag.display(F,oe);j.set(se.id,se)}return Promise.resolve([...j.values()])}$publishTestResults(F){this.results=Object.freeze(F.map(x=>(0,C.deepFreeze)(g.TestResults.to(x))).concat(this.results).sort((x,j)=>j.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,x){const j=this.controllers.get(o.TestId.fromString(F).controllerId)?.collection;j&&(await j.expand(F,x<0?Infinity:x),j.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,x){const j=this.controllers.get(F.controllerId);if(!j)return;const{collection:oe,profiles:se}=j,V=se.get(F.profileId);if(!V)return;const H=F.testIds.map(G=>oe.tree.get(G)).filter(n.isDefined),M=F.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(n.isDefined).filter(G=>H.some(fe=>fe.fullId.compare(G.fullId)===2));if(!H.length)return;const Q=new b.TestRunRequest(H.some(G=>G.actual instanceof u.TestItemRootImpl)?void 0:H.map(G=>G.actual),M.map(G=>G.actual),V),O=this.runTracker.prepareForMainThreadTestRun(Q,i.fromInternal(F,j.collection),x);try{await V.runHandler(Q,x)}finally{O.isRunning&&!x.isCancellationRequested&&await S.Event.toPromise(O.onEnd),this.runTracker.cancelRunById(F.runId)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};v=ze([Ve(0,h.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends _.Disposable{constructor(F,x,j){super();this.dto=F,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(j)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:oe}of this.tasks.values())oe.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const x=this.dto.id,j=this.dto.controllerId,oe=(0,T.generateUuid)(),se=new c(this.proxy,x,oe),V=Q=>(O,...G)=>{if(H){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),Q(O,...G))};let H=!1;const M={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return se.coverageProvider},set coverageProvider(Q){se.coverageProvider=Q},enqueued:V(Q=>{this.proxy.$updateTestStateInRun(x,oe,o.TestId.fromExtHostTestItem(Q,j).toString(),1)}),skipped:V(Q=>{this.proxy.$updateTestStateInRun(x,oe,o.TestId.fromExtHostTestItem(Q,j).toString(),5)}),started:V(Q=>{this.proxy.$updateTestStateInRun(x,oe,o.TestId.fromExtHostTestItem(Q,j).toString(),2)}),errored:V((Q,O,G)=>{this.proxy.$appendTestMessagesInRun(x,oe,o.TestId.fromExtHostTestItem(Q,j).toString(),O instanceof Array?O.map(g.TestMessage.from):[g.TestMessage.from(O)]),this.proxy.$updateTestStateInRun(x,oe,o.TestId.fromExtHostTestItem(Q,j).toString(),6,G)}),failed:V((Q,O,G)=>{this.proxy.$appendTestMessagesInRun(x,oe,o.TestId.fromExtHostTestItem(Q,j).toString(),O instanceof Array?O.map(g.TestMessage.from):[g.TestMessage.from(O)]),this.proxy.$updateTestStateInRun(x,oe,o.TestId.fromExtHostTestItem(Q,j).toString(),4,G)}),passed:V((Q,O)=>{this.proxy.$updateTestStateInRun(x,oe,o.TestId.fromExtHostTestItem(Q,this.dto.controllerId).toString(),3,O)}),appendOutput:Q=>{H||this.proxy.$appendOutputToRun(x,oe,f.VSBuffer.fromString(Q))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(x,oe),this.tasks.delete(oe),this.isRunning||this.dispose())}};return this.tasks.set(oe,{run:M,coverage:se}),this.proxy.$startedTestRunTask(x,{id:oe,name:F,running:!0}),M}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof u.TestItemImpl))throw new u.InvalidTestItemError(F.id);if(this.sharedTestIds.has(F.id))return;const x=[];for(;x.unshift(g.TestItem.from(F)),!(this.sharedTestIds.has(F.id)||(this.sharedTestIds.add(F.id),!F.parent));)F=F.parent;const j=this.dto.colllection.root;this.sharedTestIds.has(j.id)||(this.sharedTestIds.add(j.id),x.unshift(g.TestItem.from(j))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class r{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,x,j){return this.getTracker(F,x,j)}cancelRunById(F){for(const x of this.tracked.values())if(x.id===F){x.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,x,j,oe,se){const V=this.tracked.get(j);if(V)return V.createRun(oe);const H=i.fromPublic(F,x,j,se),M=a(j);this.proxy.$startedExtensionTestRun({controllerId:F,profile:M&&{group:s[M.kind],id:M.profileId},exclude:j.exclude?.map(O=>O.id)??[],id:H.id,include:j.include?.map(O=>O.id)??[x.root.id],persist:se});const Q=this.getTracker(j,H);return Q.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),Q.createRun(oe)}getTracker(F,x,j){const oe=new t(x,this.proxy,j);return this.tracked.set(F,oe),oe.onEnd(()=>this.tracked.delete(F)),oe}}e.TestRunCoordinator=r;const a=k=>{if(!!k.profile){if(!(k.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class i{constructor(F,x,j,oe,se,V){this.controllerId=F,this.id=x,this.isPersisted=se,this.colllection=V,this.includePrefix=j.map(H=>H+"\0"),this.excludePrefix=oe.map(H=>H+"\0")}static fromPublic(F,x,j,oe){return new i(F,(0,T.generateUuid)(),j.include?.map(se=>o.TestId.fromExtHostTestItem(se,F).toString())??[F],j.exclude?.map(se=>o.TestId.fromExtHostTestItem(se,F).toString())??[],oe,x)}static fromInternal(F,x){return new i(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,x)}isIncluded(F){const x=o.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const j of this.excludePrefix)if(x===j||x.startsWith(j))return!1;for(const j of this.includePrefix)if(x===j||x.startsWith(j))return!0;return!1}}e.TestRunDto=i;class c{constructor(F,x,j){this.proxy=F,this.runId=x,this.taskId=j}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(F,x){const j=await this.fileCoverage;let oe=j?.[F];return!this._coverageProvider||!j||!oe?[]:(oe.detailedCoverage||(oe=j[F]=await this._coverageProvider.resolveFileCoverage?.(oe,x)??oe),oe.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class p extends A.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,g.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:x,removed:j}=this;return{get added(){return[...F].map(oe=>oe.revived)},get updated(){return[...x].map(oe=>oe.revived)},get removed(){return[...j].map(oe=>oe.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,x){return{...F,revived:g.TestItem.toPlain(F.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new p(this.changeEmitter)}}e.MirroredTestCollection=d;class D{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(x=>x.revived)},dispose:(0,y.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class I{constructor(F,x,j,oe,se,V,H=!1,M=void 0){this.controllerId=x,this.profileId=j,this._label=oe,this.kind=se,this.runHandler=V,this._isDefault=H,this._tag=M,m.set(this,void 0),it(this,m,F,"f");const Q=s[se];if(typeof Q!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);Be(this,m,"f").$publishTestRunProfile({profileId:j,controllerId:x,tag:M?g.TestTag.namespace(this.controllerId,M.id):null,label:oe,group:Q,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Be(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Be(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Be(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?g.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Be(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Be(this,m,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=I,m=new WeakMap;const s={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(Ee[211],_e([0,1,3,17,5,102,9,7]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const T=this._extHostDocumentsAndEditors.allEditors();return n?T:T.map(l=>l.value)}async showTextDocument(n,T,l){let h;typeof T=="number"?h={position:P.ViewColumn.from(T),preserveFocus:l}:typeof T=="object"?h={position:P.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?P.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:h={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,h),g=u&&this._extHostDocumentsAndEditors.getEditor(u);if(g)return g.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,T){return new y.TextEditorDecorationType(this._proxy,n,T).value}$acceptEditorPropertiesChanged(n,T){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(T.options&&l._acceptOptions(T.options),T.selections){const h=T.selections.selections.map(P.Selection.to);l._acceptSelections(h)}if(T.visibleRanges){const h=R.coalesce(T.visibleRanges.map(P.Range.to));l._acceptVisibleRanges(h)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...T.options,lineNumbers:P.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const h=E.TextEditorSelectionChangeKind.fromValue(T.selections.source),u=T.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:u,kind:h})}if(T.visibleRanges){const h=R.coalesce(T.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const T in n){const l=this._extHostDocumentsAndEditors.getEditor(T);if(!l)throw new Error("Unknown text editor");const h=P.ViewColumn.to(n[T]);l.value.viewColumn!==h&&(l._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_}),define(Ee[212],_e([0,1,2,4,5,6,7]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class E{constructor(n,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const h=l.uri===void 0?void 0:f.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(h))?.get(l.handle)}return l}})}async $getTimeline(n,T,l,h,u){return this._providers.get(n)?.provideTimeline(f.URI.revive(T),l,h,u)}registerTimelineProvider(n,T,l,h){const u=new y.DisposableStore,g=this.convertTimelineItem(T.id,h,u).bind(this);let b;T.onDidChange&&(b=T.onDidChange(A=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...A,id:T.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:n,onDidChange:void 0,async provideTimeline(A,o,m,v){v?.resetCache&&(u.clear(),w.get(T.id)?.clear());const t=await T.provideTimeline(A,o,m);if(t==null)return;const r=g(A,v);return{...t,source:T.id,items:t.items.map(r)}},dispose(){for(const A of w.values())A.get(T.id)?.clear();b?.dispose(),u.dispose()}})}convertTimelineItem(n,T,l){return(h,u)=>{let g;if(u?.cacheResults){let b=this._itemsBySourceAndUriMap.get(n);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(n,b));const w=_(h);g=b.get(w),g===void 0&&(g=new Map,b.set(w,g))}return b=>{const{iconPath:w,...A}=b,o=`${n}|${b.id??b.timestamp}`;g?.set(o,b);let m,v,t;return b.iconPath&&(w instanceof P.ThemeIcon?t={id:w.id,color:w.color}:f.URI.isUri(w)?(m=w,v=w):{light:m,dark:v}=w),{...A,id:A.id??void 0,handle:o,source:n,command:b.command?T.toInternal(b.command,l):void 0,icon:m,iconDark:v,themeIcon:t,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,y.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=E;function _(C){return C?.toString()}}),define(Ee[213],_e([0,1,6,11,2,5]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(_){this._openers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,n,T){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const l=T.schemes.find(h=>!P.supportedSchemes.has(h));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,T.schemes,_,T.label),(0,f.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,n){const T=this._openers.get(_);if(!T)throw new Error(`Unknown opener with id: ${_}`);const l=S.URI.revive(C);return T.canOpenExternalUri(l,n)}async $openUri(_,C,n){const T=this._openers.get(_);if(!T)throw new Error(`Unknown opener id: '${_}'`);return T.openExternalUri(S.URI.revive(C.resolvedUri),{sourceUri:S.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(Ee[214],_e([0,1,5,2,6,12,26]),function(Z,e,f,R,S,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class E{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(P.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const T=E.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(C)),this.handlers.set(T,n),this._proxy.$registerUriHandler(T,C),(0,S.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(C)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(C,n){const T=this.handlers.get(C);if(!T)return Promise.resolve(void 0);try{T.handleUri(R.URI.revive(n))}catch(l){(0,y.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(C){return R.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=E,E.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[50],_e([0,1,3,2,147,166,71,5]),function(Z,e,f,R,S,y,P,E){"use strict";var _,C,n,T,l,h,u,g,b,w,A,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(d,D,I,s,k,F,x){_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),T.set(this,void 0),l.set(this,void 0),h.set(this,void 0),u.set(this,""),g.set(this,void 0),b.set(this,!1),w.set(this,!1),A.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new f.Emitter),this._onDidDispose=Be(this,o,"f").event,it(this,_,d,"f"),it(this,C,D,"f"),it(this,g,I,"f"),it(this,T,s,"f"),it(this,l,k,"f"),it(this,h,F,"f"),it(this,A,v(F),"f"),it(this,n,x,"f")}dispose(){it(this,b,!0,"f"),Be(this,o,"f").fire(),Be(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return it(this,w,!0,"f"),(0,P.asWebviewUri)(d,Be(this,T,"f").remote)}get cspSource(){return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,u,"f")}set html(d){this.assertNotDisposed(),Be(this,u,"f")!==d&&(it(this,u,d,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(it(this,w,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,C,"f").$setHtml(Be(this,_,"f"),d))}get options(){return this.assertNotDisposed(),Be(this,g,"f")}set options(d){this.assertNotDisposed(),Be(this,C,"f").$setOptions(Be(this,_,"f"),a(Be(this,h,"f"),Be(this,l,"f"),d)),it(this,g,d,"f")}async postMessage(d){if(Be(this,b,"f"))return!1;const D=(0,y.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Be(this,A,"f")});return Be(this,C,"f").$postMessage(Be(this,_,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Be(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,_=new WeakMap,C=new WeakMap,n=new WeakMap,T=new WeakMap,l=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,A=new WeakMap,o=new WeakMap;function v(p){try{const d=(0,S.normalizeVersion)((0,S.parseVersion)(p.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(d,D,I,s,k){this.initData=D,this.workspace=I,this._logService=s,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=d.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(d,D,...I){const s=this.getWebview(d);if(s){const{message:k}=(0,y.deserializeWebviewMessage)(D,I);s._onMessageEmitter.fire(k)}}$onMissingCsp(d,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,D,I){const s=new m(d,this._webviewProxy,i(D),this.initData,this.workspace,I,this._deprecationService);return this._webviews.set(d,s),s._onDidDispose(()=>{this._webviews.delete(d)}),s}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function r(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=r;function a(p,d,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||c(p,d)}}e.serializeWebviewOptions=a;function i(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(d=>R.URI.from(d))}}e.reviveOptions=i;function c(p,d){return[...(d?.getWorkspaceFolders()||[]).map(D=>D.uri),p.extensionLocation]}}),define(Ee[215],_e([0,1,20,43,6,11,25,2,9,50,66,5,7]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=m(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class u{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,a){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const c=new h(r,a);return this._documents.set(i,c),c}delete(t,r){const a=this.key(t,r.uri);this._documents.delete(a)}key(t,r){return`${t}@@@${r}`}}var g;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(g||(g={}));class b{constructor(){this._providers=new Map}addTextProvider(t,r,a){return this.add(0,t,r,a)}addCustomProvider(t,r,a){return this.add(1,t,r,a)}get(t){return this._providers.get(t)}add(t,r,a,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:a,provider:i}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,a,i,c){this._extHostDocuments=r,this._extensionStoragePaths=a,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new b,this._documents=new u,this._proxy=t.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,a,i){const c=new S.DisposableStore;return A(a)?(c.add(this._editorProviders.addTextProvider(r,t,a)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(r,t,a)),this.supportEditing(a)&&c.add(a.onDidChangeCustomDocument(p=>{const d=this.getCustomDocumentEntry(r,p.document.uri);if(o(p)){const D=d.addEdit(p);this._proxy.$onDidEdit(p.document.uri,r,D,p.label)}else this._proxy.$onContentChange(p.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,a,i,c){const p=this._editorProviders.get(r);if(!p)throw new Error(`No provider found for '${r}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${r}'`);const d=E.URI.revive(t),D=await p.provider.openCustomDocument(d,{backupId:a,untitledDocumentData:i?.buffer},c);let I;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(I=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(r,D,I),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,r){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=E.URI.revive(t),{document:c}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,c),c.dispose()}async $resolveWebviewEditor(t,r,a,i,c,p){const d=this._editorProviders.get(a);if(!d)throw new Error(`No provider found for '${a}'`);const D=_.ViewColumn.to(c),I=this._extHostWebview.createNewWebview(r,i.webviewOptions,d.extension),s=this._extHostWebviewPanels.createNewWebviewPanel(r,a,i.title,D,i.panelOptions,I),k=E.URI.revive(t);switch(d.type){case 1:{const{document:F}=this.getCustomDocumentEntry(a,k);return d.provider.resolveCustomEditor(F,s,p)}case 0:{const F=this._extHostDocuments.getDocument(k);return d.provider.resolveCustomTextEditor(F,s,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,a){this.getCustomDocumentEntry(r,t).disposeEdits(a)}async $onMoveCustomEditor(t,r,a){const i=this._editorProviders.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const p=E.URI.revive(r),d=this._extHostDocuments.getDocument(p);await i.provider.moveCustomTextEditor(d,c,f.CancellationToken.None)}async $undo(t,r,a,i){return this.getCustomDocumentEntry(r,t).undo(a,i)}async $redo(t,r,a,i){return this.getCustomDocumentEntry(r,t).redo(a,i)}async $revert(t,r,a){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,a),i.disposeBackup()}async $onSave(t,r,a){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,a),i.disposeBackup()}async $onSaveAs(t,r,a,i){const c=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(c.document,E.URI.revive(a),i)}async $backup(t,r,a){const i=this.getCustomDocumentEntry(r,t),p=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},a);return i.updateBackup(p),p.id}getCustomDocumentEntry(t,r){const a=this._documents.get(t,E.URI.revive(r));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(t){const a=this._editorProviders.get(t)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function A(v){return typeof v.resolveCustomTextEditor=="function"}function o(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function m(v){const t=v.scheme===y.Schemas.file||v.scheme===y.Schemas.untitled?v.fsPath:v.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[216],_e([0,1,3,6,2,37,9,50,5,7]),function(Z,e,f,R,S,y,P,E,_,C){"use strict";var n,T,l,h,u,g,b,w,A,o,m,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(p,d,D,I,s,k,F){super();n.set(this,void 0),T.set(this,void 0),l.set(this,void 0),h.set(this,void 0),u.set(this,void 0),g.set(this,void 0),b.set(this,void 0),w.set(this,void 0),A.set(this,!0),o.set(this,!0),m.set(this,!1),v.set(this,this._register(new f.Emitter)),this.onDidDispose=Be(this,v,"f").event,t.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,it(this,n,p,"f"),it(this,T,d,"f"),it(this,l,D,"f"),it(this,u,k,"f"),it(this,w,s,"f"),it(this,g,I,"f"),it(this,h,F,"f")}dispose(){Be(this,m,"f")||(it(this,m,!0,"f"),Be(this,v,"f").fire(),Be(this,T,"f").$disposeWebview(Be(this,n,"f")),Be(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,h,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(p){this.assertNotDisposed(),Be(this,g,"f")!==p&&(it(this,g,p,"f"),Be(this,T,"f").$setTitle(Be(this,n,"f"),p))}get iconPath(){return this.assertNotDisposed(),Be(this,b,"f")}set iconPath(p){this.assertNotDisposed(),Be(this,b,"f")!==p&&(it(this,b,p,"f"),Be(this,T,"f").$setIconPath(Be(this,n,"f"),S.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Be(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,o,"f")}get visible(){return this.assertNotDisposed(),Be(this,A,"f")}_updateViewState(p){Be(this,m,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(it(this,o,p.active,"f"),it(this,A,p.visible,"f"),it(this,w,p.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(p,d){this.assertNotDisposed(),Be(this,T,"f").$reveal(Be(this,n,"f"),{viewColumn:p?P.ViewColumn.from(p):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Be(this,m,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,T=new WeakMap,l=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,A=new WeakMap,o=new WeakMap,m=new WeakMap,v=new WeakMap,t=new WeakMap;class a{constructor(p,d,D){this.webviews=d,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(p,d,D,I,s={}){const k=typeof I=="object"?I.viewColumn:I,F={viewColumn:P.ViewColumn.from(k),preserveFocus:typeof I=="object"&&!!I.preserveFocus},x=(0,E.shouldSerializeBuffersForPostMessage)(p),j=a.newHandle();this._proxy.$createWebviewPanel((0,E.toExtensionData)(p),j,d,{title:D,panelOptions:i(s),webviewOptions:(0,E.serializeWebviewOptions)(p,this.workspace,s),serializeBuffersForPostMessage:x},F);const oe=this.webviews.createNewWebview(j,s,p);return this.createNewWebviewPanel(j,d,D,k,s,oe)}$onDidChangeWebviewPanelViewStates(p){const d=Object.keys(p);d.sort((D,I)=>{const s=p[D],k=p[I];return s.active?1:k.active?-1:+s.visible-+k.visible});for(const D of d){const I=this.getWebviewPanel(D);if(!I)continue;const s=p[D];I._updateViewState({active:s.active,visible:s.visible,viewColumn:P.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,d,D){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:D,extension:p}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,E.shouldSerializeBuffersForPostMessage)(p)}),new C.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(p,d,D,I){const s=this._serializers.get(d);if(!s)throw new Error(`No serializer found for '${d}'`);const{serializer:k,extension:F}=s,x=this.webviews.createNewWebview(p,D.webviewOptions,F),j=this.createNewWebviewPanel(p,d,D.title,I,D.panelOptions,x);await k.deserializeWebviewPanel(j,D.state)}createNewWebviewPanel(p,d,D,I,s,k){const F=new r(p,this._proxy,d,D,I,s,k);return this._webviewPanels.set(p,F),F}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=a;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[217],_e([0,1,3,6,50,5,7]),function(Z,e,f,R,S,y,P){"use strict";var E,_,C,n,T,l,h,u,g,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(m,v,t,r,a,i){super();E.set(this,void 0),_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),T.set(this,!1),l.set(this,void 0),h.set(this,void 0),u.set(this,void 0),g.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Be(this,g,"f").event,b.set(this,this._register(new f.Emitter)),this.onDidDispose=Be(this,b,"f").event,it(this,C,t,"f"),it(this,h,r,"f"),it(this,E,m,"f"),it(this,_,v,"f"),it(this,n,a,"f"),it(this,l,i,"f")}dispose(){Be(this,T,"f")||(it(this,T,!0,"f"),Be(this,b,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(m){this.assertNotDisposed(),Be(this,h,"f")!==m&&(it(this,h,m,"f"),Be(this,_,"f").$setWebviewViewTitle(Be(this,E,"f"),m))}get description(){return this.assertNotDisposed(),Be(this,u,"f")}set description(m){this.assertNotDisposed(),Be(this,u,"f")!==m&&(it(this,u,m,"f"),Be(this,_,"f").$setWebviewViewDescription(Be(this,E,"f"),m))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,C,"f")}_setVisible(m){m===Be(this,l,"f")||Be(this,T,"f")||(it(this,l,m,"f"),Be(this,g,"f").fire())}show(m){this.assertNotDisposed(),Be(this,_,"f").$show(Be(this,E,"f"),!!m)}assertNotDisposed(){if(Be(this,T,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,_=new WeakMap,C=new WeakMap,n=new WeakMap,T=new WeakMap,l=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap;class A{constructor(m,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:m}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(m),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(m,v,t,r,a){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:p}=i,d=this._extHostWebview.createNewWebview(m,{},p),D=new w(m,this._proxy,v,t,d,!0);this._webviewViews.set(m,D),await c.resolveWebviewView(D,{state:r},a)}async $onDidChangeWebviewViewVisibility(m,v){this.getWebviewView(m)._setVisible(v)}async $disposeWebviewView(m){const v=this.getWebviewView(m);this._webviewViews.delete(m),v.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const v=this._webviewViews.get(m);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=A}),define(Ee[106],_e([0,1,3,5,2,11,8,4,13]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class $n{constructor(T){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=T.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,l){let h;if(typeof T=="string"){h=T;try{T=S.URI.parse(T)}catch(u){return Promise.reject(`Invalid uri - '${T}'`)}}return(0,P.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,h,l)}async asExternalUri(T,l){if((0,P.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(T,l);return S.URI.from(h)}};C.InitialState={focused:!0},C=ze([Ve(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,E.createDecorator)("IExtHostWindow")}),define(Ee[218],_e([0,1,16,5,29,13]),function(Z,e,f,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends f.AbstractLogger{constructor(_,C){super();this._proxy=_.getProxy(R.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...C){this.getLevel()<=f.LogLevel.Trace&&this._proxy.$log(this._logFile,f.LogLevel.Trace,Array.from(arguments))}debug(_,...C){this.getLevel()<=f.LogLevel.Debug&&this._proxy.$log(this._logFile,f.LogLevel.Debug,Array.from(arguments))}info(_,...C){this.getLevel()<=f.LogLevel.Info&&this._proxy.$log(this._logFile,f.LogLevel.Info,Array.from(arguments))}warn(_,...C){this.getLevel()<=f.LogLevel.Warning&&this._proxy.$log(this._logFile,f.LogLevel.Warning,Array.from(arguments))}error(_,...C){this.getLevel()<=f.LogLevel.Error&&this._proxy.$log(this._logFile,f.LogLevel.Error,Array.from(arguments))}critical(_,...C){this.getLevel()<=f.LogLevel.Critical&&this._proxy.$log(this._logFile,f.LogLevel.Critical,Array.from(arguments))}flush(){}};P=ze([Ve(0,y.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Ee[219],_e([0,1,15,20,12,3,6,117,187,103,24]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,c){try{return JSON.stringify(i,c)}catch(p){return"null"}}function h(i,c){return JSON.stringify(i,c)}function u(i){return i?(c,p)=>p&&p.$mid===1?i.transformOutgoing(p):p:null}var g;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},A=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class m extends P.Disposable{constructor(c,p=null,d=null){super();this[T]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=p,this._uriTransformer=d,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,I=C.ProxyIdentifier.count;D<I;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,E.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:p,sid:d}=c;return this._proxies[p]||(this._proxies[p]=this._createProxy(p,d)),this._proxies[p]}_createProxy(c,p){let d={get:(D,I)=>(typeof I=="string"&&!D[I]&&I.charCodeAt(0)===36&&(D[I]=(...s)=>this._remoteCall(c,I,s)),I===o?p:D[I])};return new Proxy(Object.create(null),d)}set(c,p){return this._locals[c.nid]=p,p}assertRegistered(c){for(let p=0,d=c.length;p<d;p++){const D=c[p];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const p=c.byteLength,d=v.read(c,0),D=d.readUInt8(),I=d.readUInt32();switch(D){case 1:case 2:{let{rpcId:s,method:k,args:F}=t.deserializeRequestJSONArgs(d);this._uriTransformer&&(F=(0,E.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(p,I,s,k,F,D===2);break}case 3:case 4:{let{rpcId:s,method:k,args:F}=t.deserializeRequestMixedArgs(d);this._uriTransformer&&(F=(0,E.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(p,I,s,k,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(p,I,0,"ack"),this._onDidReceiveAcknowledge(I);break}case 6:{this._receiveCancel(p,I);break}case 7:{this._receiveReply(p,I,void 0);break}case 9:{let s=t.deserializeReplyOKJSON(d);this._uriTransformer&&(s=(0,E.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReply(p,I,s);break}case 8:{let s=t.deserializeReplyOKVSBuffer(d);this._receiveReply(p,I,s);break}case 10:{let s=t.deserializeReplyErrError(d);this._uriTransformer&&(s=(0,E.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReplyErr(p,I,s);break}case 11:{this._receiveReplyErr(p,I,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,p,d,D,I,s){this._logger&&this._logger.logIncoming(c,p,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(d)}.${D}(`,I);const k=String(p);let F,x;if(s){const oe=new R.CancellationTokenSource;I.push(oe.token),F=this._invokeHandler(d,D,I),x=()=>oe.cancel()}else F=this._invokeHandler(d,D,I),x=w;this._cancelInvokedHandlers[k]=x;const j=t.serializeAcknowledged(p);this._logger&&this._logger.logOutgoing(j.byteLength,p,1,"ack"),this._protocol.send(j),F.then(oe=>{delete this._cancelInvokedHandlers[k];const se=t.serializeReplyOK(p,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(se.byteLength,p,1,"reply:",oe),this._protocol.send(se)},oe=>{delete this._cancelInvokedHandlers[k];const se=t.serializeReplyErr(p,oe);this._logger&&this._logger.logOutgoing(se.byteLength,p,1,"replyErr:",oe),this._protocol.send(se)})}_receiveCancel(c,p){this._logger&&this._logger.logIncoming(c,p,1,"receiveCancel");const d=String(p);this._cancelInvokedHandlers[d]&&this._cancelInvokedHandlers[d]()}_receiveReply(c,p,d){this._logger&&this._logger.logIncoming(c,p,0,"receiveReply:",d);const D=String(p);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const I=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],I.resolveOk(d)}_receiveReplyErr(c,p,d){this._logger&&this._logger.logIncoming(c,p,0,"receiveReplyErr:",d);const D=String(p);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const I=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let s;d&&(d.$isError?(s=new Error,s.name=d.name,s.message=d.message,s.stack=d.stack):s=d),I.resolveErr(s)}_invokeHandler(c,p,d){try{return Promise.resolve(this._doInvokeHandler(c,p,d))}catch(D){return Promise.reject(D)}}_doInvokeHandler(c,p,d){const D=this._locals[c];if(!D)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(c));let I=D[p];if(typeof I!="function")throw new Error("Unknown method "+p+" on actor "+(0,C.getStringIdentifierForProxy)(c));return I.apply(D,d)}_remoteCall(c,p,d){if(this._isDisposed)return Promise.reject(S.canceled());let D=null;if(d.length>0&&R.CancellationToken.isCancellationToken(d[d.length-1])&&(D=d.pop()),D&&D.isCancellationRequested)return Promise.reject(S.canceled());const I=t.serializeRequestArguments(d,this._uriReplacer),s=++this._lastMessageId,k=String(s),F=new _.LazyPromise;D&&D.onCancellationRequested(()=>{const j=t.serializeCancel(s);this._logger&&this._logger.logOutgoing(j.byteLength,s,0,"cancel"),this._protocol.send(t.serializeCancel(s))}),this._pendingRPCReplies[k]=F,this._onWillSendRequest(s);const x=t.serializeRequest(s,c,p,I,!!D);return this._logger&&this._logger.logOutgoing(x.byteLength,s,0,`request: ${(0,C.getStringIdentifierForProxy)(c)}.${p}(`,d),this._protocol.send(x),F}}e.RPCProtocol=m,T=A,m.UNRESPONSIVE_TIME=3*1e3;class v{constructor(c,p){this._buff=c,this._offset=p}static alloc(c,p,d){let D=new v(n.VSBuffer.alloc(d+1+4),0);return D.writeUInt8(c),D.writeUInt32(p),D}static read(c,p){return new v(c,p)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const d=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,d}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,d}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,p}static sizeMixedArray(c,p){let d=0;d+=1;for(let D=0,I=c.length;D<I;D++){const s=c[D],k=p[D];switch(d+=1,k){case 1:d+=this.sizeLongString(s);break;case 2:d+=this.sizeVSBuffer(s);break;case 3:break}}return d}writeMixedArray(c,p){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let d=0,D=c.length;d<D;d++){const I=c[d];switch(p[d]){case 1:this.writeUInt8(1),this.writeLongString(I);break;case 2:this.writeUInt8(2),this.writeVSBuffer(I);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let p=new Array(c);for(let d=0;d<c;d++)switch(this.readUInt8()){case 1:p[d]=this.readLongString();break;case 2:p[d]=this.readVSBuffer();break;case 3:p[d]=void 0;break}return p}}class t{static _arrayContainsBufferOrUndefined(c){for(let p=0,d=c.length;p<d;p++)if(c[p]instanceof n.VSBuffer||typeof c[p]=="undefined")return!0;return!1}static serializeRequestArguments(c,p){if(this._arrayContainsBufferOrUndefined(c)){let d=[],D=[];for(let I=0,s=c.length;I<s;I++){const k=c[I];k instanceof n.VSBuffer?(d[I]=k,D[I]=2):typeof k=="undefined"?(d[I]=n.VSBuffer.alloc(0),D[I]=3):(d[I]=n.VSBuffer.fromString(h(k,p)),D[I]=1)}return{type:"mixed",args:d,argsType:D}}return{type:"simple",args:h(c,p)}}static serializeRequest(c,p,d,D,I){return D.type==="mixed"?this._requestMixedArgs(c,p,d,D.args,D.argsType,I):this._requestJSONArgs(c,p,d,D.args,I)}static _requestJSONArgs(c,p,d,D,I){const s=n.VSBuffer.fromString(d),k=n.VSBuffer.fromString(D);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(s),F+=v.sizeLongString(k);let x=v.alloc(I?2:1,c,F);return x.writeUInt8(p),x.writeShortString(s),x.writeLongString(k),x.buffer}static deserializeRequestJSONArgs(c){const p=c.readUInt8(),d=c.readShortString(),D=c.readLongString();return{rpcId:p,method:d,args:JSON.parse(D)}}static _requestMixedArgs(c,p,d,D,I,s){const k=n.VSBuffer.fromString(d);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(k),F+=v.sizeMixedArray(D,I);let x=v.alloc(s?4:3,c,F);return x.writeUInt8(p),x.writeShortString(k),x.writeMixedArray(D,I),x.buffer}static deserializeRequestMixedArgs(c){const p=c.readUInt8(),d=c.readShortString(),D=c.readMixedArray(),I=new Array(D.length);for(let s=0,k=D.length;s<k;s++){const F=D[s];typeof F=="string"?I[s]=JSON.parse(F):I[s]=F}return{rpcId:p,method:d,args:I}}static serializeAcknowledged(c){return v.alloc(5,c,0).buffer}static serializeCancel(c){return v.alloc(6,c,0).buffer}static serializeReplyOK(c,p,d){return typeof p=="undefined"?this._serializeReplyOKEmpty(c):p instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,p):this._serializeReplyOKJSON(c,l(p,d))}static _serializeReplyOKEmpty(c){return v.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,p){let d=0;d+=v.sizeVSBuffer(p);let D=v.alloc(8,c,d);return D.writeVSBuffer(p),D.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,p){const d=n.VSBuffer.fromString(p);let D=0;D+=v.sizeLongString(d);let I=v.alloc(9,c,D);return I.writeLongString(d),I.buffer}static deserializeReplyOKJSON(c){const p=c.readLongString();return JSON.parse(p)}static serializeReplyErr(c,p){return p?this._serializeReplyErrEror(c,p):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,p){const d=n.VSBuffer.fromString(l(S.transformErrorForSerialization(p),null));let D=0;D+=v.sizeLongString(d);let I=v.alloc(10,c,D);return I.writeLongString(d),I.buffer}static deserializeReplyErrError(c){const p=c.readLongString();return JSON.parse(p)}static _serializeReplyErrEmpty(c){return v.alloc(11,c,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var a;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(a||(a={}))}),define(Ee[220],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const f=function(y){const P=E=>{self.removeEventListener("message",P);const _=E.data;Object.defineProperties(self,{postMessage:{value(C,n){_.postMessage(C,n)}},onmessage:{get(){return _.onmessage},set(C){_.onmessage=C}}}),_.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(y)};self.addEventListener("message",P)}.toString();class R extends EventTarget{constructor(y,P,E){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${f})('${P}'))`,C=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(C),T=new MessageChannel,l=n,h={type:"_newWorker",id:l,port:T.port2,url:n,options:E};y(h,[T.port2]),this.postMessage=T.port1.postMessage.bind(T.port1),this.terminate=()=>{const u={type:"_terminateWorker",id:l};T.port1.postMessage(u),URL.revokeObjectURL(n),T.port1.close(),T.port2.close()},Object.defineProperties(this,{onmessage:{get(){return T.port1.onmessage},set(u){T.port1.onmessage=u}},onmessageerror:{get(){return T.port1.onmessageerror},set(u){T.port1.onmessageerror=u}}}),T.port1.addEventListener("messageerror",u=>{const g=new MessageEvent("messageerror",{data:u.data});this.dispatchEvent(g)}),T.port1.addEventListener("message",u=>{const g=new MessageEvent("message",{data:u.data});this.dispatchEvent(g)}),T.port1.start()}}e.NestedWorker=R}),define(Ee[221],_e([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(Ee[222],_e([0,1,11,14,22,2,4,96,46,183,221]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,P.createDecorator)("pathService");let T=class Wn{constructor(h,u,g,b){this.localUserHome=h,this.remoteAgentService=u,this.environmentService=g,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||S.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||h})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,u){if(h.remoteAuthority)return f.Schemas.vscodeRemote;const g=(0,E.getVirtualWorkspaceScheme)(u.getWorkspace());if(g)return g;const b=u.getWorkspace().folders[0];if(b)return b.uri.scheme;const w=u.getWorkspace().configuration;return w?w.scheme:f.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?R.win32:R.posix)}async fileURI(h){let u="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const b=h.indexOf("/",2);b===-1?(u=h.substring(2),h="/"):(u=h.substring(2,b),h=h.substring(b)||"/")}return y.URI.from({scheme:f.Schemas.file,authority:u,path:h,query:"",fragment:""})}};T=ze([Ve(1,n.IRemoteAgentService),Ve(2,C.IWorkbenchEnvironmentService),Ve(3,_.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ee[107],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(P,E){this.line=P,this.character=E}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,E){return new f(0,0)}with(P){return new f(0,0)}}e.Position=f;class R{constructor(P,E,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(P,E),this.end=new f(_,C)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new R(0,0,0,0)}with(P){return new R(0,0,0,0)}}e.Range=R;var S;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],_e([0,1,17,27,23,44,8,4,14,12,107]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",l=" characters skipped \u27EB",h=(T.length+l.length+5)*2;e.ISearchService=(0,E.createDecorator)("searchService");var u;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function b(M){return!!M.preview}e.resultIsMatch=b;function w(M){return!!M.resource}e.isFileMatch=w;function A(M){return!!M.message}e.isProgressMessage=A;var o;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(Q){this.resource=Q,this.results=[]}}e.FileMatch=m;class v{constructor(Q,O,G){this.ranges=O;const fe=Array.isArray(O)?O:[O];if(G&&G.matchLines===1&&t(fe)){Q=(0,P.getNLines)(Q,G.matchLines);let W="",te=0,he=0;const Se=Math.floor(G.charsPerLine/5),Le=[];for(const Me of fe){const $e=Math.max(Me.startColumn-Se,0),Xe=Me.startColumn+G.charsPerLine;if($e>he+Se+h){const qe=T+($e-he)+l;W+=qe+Q.slice($e,Xe),te+=$e-(he+qe.length)}else W+=Q.slice(he,Xe);Le.push(new a(0,Me.startColumn-te,Me.endColumn-te)),he=Xe}this.preview={text:W,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const W=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:Q,matches:(0,f.mapArrayOrNot)(O,te=>new r(te.startLineNumber-W,te.startColumn,te.endLineNumber-W,te.endColumn))}}}}e.TextSearchMatch=v;function t(M){const Q=M[0].startLineNumber;for(const O of M)if(O.startLineNumber!==Q||O.endLineNumber!==Q)return!1;return!0}class r{constructor(Q,O,G,fe){this.startLineNumber=Q,this.startColumn=O,this.endLineNumber=G,this.endColumn=fe}}e.SearchRange=r;class a extends r{constructor(Q,O,G){super(Q,O,Q,G)}}e.OneLineRange=a;var i;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function c(M,Q=!0){const O=M&&M.files&&M.files.exclude,G=Q&&M&&M.search&&M.search.exclude;if(!O&&!G)return;if(!O||!G)return O||G;let fe=Object.create(null);return fe=S.mixin(fe,S.deepClone(O)),fe=S.mixin(fe,S.deepClone(G),!0),fe}e.getExcludes=c;function p(M,Q){return M.excludePattern&&R.match(M.excludePattern,Q)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&R.match(M.includePattern,Q)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(O=>{const G=O.folder.fsPath;if(y.isEqualOrParent(Q,G)){const fe=_.relative(G,Q);return!O.includePattern||!!R.match(O.includePattern,fe)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var d;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(Q,O){super(Q);this.code=O}}e.SearchError=D;function I(M){const Q=M.message;if((0,C.isPromiseCanceledError)(M))return new D(Q,d.canceled);try{const O=JSON.parse(Q);return new D(O.message,O.code)}catch(O){return new D(Q,d.other)}}e.deserializeSearchError=I;function s(M){const Q={message:M.message,code:M.code};return new Error(JSON.stringify(Q))}e.serializeSearchError=s;function k(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=k;function F(M){return M.type==="success"}e.isSerializedSearchSuccess=F;function x(M){return!!M.path}e.isSerializedFileMatch=x;function j(M,Q){const O=M.searchPath?M.searchPath:M.relativePath;return(0,P.fuzzyContains)(O,Q)}e.isFilePatternMatch=j;class oe{constructor(Q){this.path=Q,this.results=[]}addMatch(Q){this.results.push(Q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=oe;function se(M,Q){const O={...M||{},...Q||{}};return Object.keys(O).filter(G=>{const fe=O[G];return typeof fe=="boolean"&&fe})}e.resolvePatternsForProvider=se;class V{constructor(Q,O){this._parsedIncludeExpression=null,this._excludeExpression={...Q.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let G=Q.includePattern;O.includePattern&&(G?G={...G,...O.includePattern}:G=O.includePattern),G&&(this._parsedIncludeExpression=R.parse(G))}includedInQuerySync(Q,O,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,O,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Q,O,G))}includedInQuery(Q,O,G){return Promise.resolve(this._parsedExcludeExpression(Q,O,G)).then(W=>!!W).then(W=>W?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(Q,O,G)).then(te=>!!te):Promise.resolve(!0)).then(W=>W)}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=V;function H(M){for(const Q in M)if(typeof M[Q]!="boolean")return!0;return!1}}),define(Ee[32],_e([0,1,17,15,20,3,21,11,81,25,8,10,2,139,4,16,154,46,47,29,13,7,40,5]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o,m,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(k,F,x){return new C.ExtUri(j=>d(j,x)).isEqual(k,F)}function i(k,F,x){return a(k.uri,F.uri,x)?0:(0,n.compare)(k.uri.toString(),F.uri.toString())}function c(k,F,x){return k.index!==F.index?k.index<F.index?-1:1:a(k.uri,F.uri,x)?(0,n.compare)(k.name,F.name):(0,n.compare)(k.uri.toString(),F.uri.toString())}function p(k,F,x,j){const oe=k.slice(0).sort((V,H)=>x(V,H,j)),se=F.slice(0).sort((V,H)=>x(V,H,j));return(0,f.delta)(oe,se,(V,H)=>x(V,H,j))}function d(k,F){const x=F.getCapabilities(k.scheme);return!(x&&x&1024)}class D extends w.Workspace{constructor(F,x,j,oe,se,V){super(F,j.map(H=>new w.WorkspaceFolder(H)),oe,V);this._name=x,this._isUntitled=se,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(V),j.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(F,x,j,oe){if(!F)return{workspace:null,added:[],removed:[]};const{id:se,name:V,folders:H,configuration:M,isUntitled:Q}=F,O=[],G=x;x?H.forEach((he,Se)=>{const Le=l.URI.revive(he.uri),Me=D._findFolder(j||x,Le,oe);Me?(Me.name=he.name,Me.index=he.index,O.push(Me)):O.push({uri:Le,name:he.name,index:Se})}):O.push(...H.map(({uri:he,name:Se,index:Le})=>({uri:l.URI.revive(he),name:Se,index:Le}))),O.sort((he,Se)=>he.index<Se.index?-1:1);const fe=new D(se,V,O,M?l.URI.revive(M):null,!!Q,he=>d(he,oe)),{added:W,removed:te}=p(G?G.workspaceFolders:[],fe.workspaceFolders,i,oe);return{workspace:fe,added:W,removed:te}}static _findFolder(F,x,j){for(let oe=0;oe<F.folders.length;oe++){const se=F.workspaceFolders[oe];if(a(se.uri,x,j))return se}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,C.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let I=class{constructor(F,x,j,oe){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=oe,this._extHostFileSystemInfo=j,this._requestIdProvider=new _.Counter,this._barrier=new R.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const se=x.workspace;this._confirmedWorkspace=se?new D(se.id,se.name,[],se.configuration?l.URI.revive(se.configuration):null,!!se.isUntitled,V=>d(V,j)):void 0}$initializeWorkspace(F,x){this._trusted=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:E.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,j,...oe){const se=[];if(Array.isArray(oe)&&oe.forEach(O=>{l.URI.isUri(O.uri)&&!se.some(G=>a(G.uri,O.uri,this._extHostFileSystemInfo))&&se.push({uri:O.uri,name:O.name||(0,C.basenameOrAuthority)(O.uri)})}),this._unconfirmedWorkspace||[x,j].some(O=>typeof O!="number"||O<0)||j===0&&se.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+j>V.length)return!1;const H=V.slice(0);H.splice(x,j,...se.map(O=>({uri:O.uri,name:O.name||(0,C.basenameOrAuthority)(O.uri),index:void 0})));for(let O=0;O<H.length;O++){const G=H[O];if(H.some((fe,W)=>W!==O&&a(G.uri,fe.uri,this._extHostFileSystemInfo)))return!1}H.forEach((O,G)=>O.index=G);const{added:M,removed:Q}=p(V,H,c,this._extHostFileSystemInfo);if(M.length===0&&Q.length===0)return!1;if(this._proxy){const O=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(O,x,j,se).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,(0,h.localize)(0,null,O,G.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(F,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,x){let j,oe="";if(typeof F=="string"?(j=l.URI.file(F),oe=F):typeof F!="undefined"&&(j=F,oe=F.fsPath),!j)return oe;const se=this.getWorkspaceFolder(j,!0);if(!se)return oe;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let V=(0,C.relativePath)(se.uri,j);return x&&se.name&&(V=`${se.name}/${V}`),V}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:j,removed:oe}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:oe}))}findFiles(F,x,j,oe,se=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${oe.value}, entryPoint: findFiles`);let V;if(x===null?V=!1:x&&(typeof x=="string"?V=x:V=x.pattern),se&&se.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:M}=s(F);return this._proxy.$startFileSearch((0,T.withUndefinedAsNull)(H),(0,T.withUndefinedAsNull)(M),(0,T.withUndefinedAsNull)(V),(0,T.withUndefinedAsNull)(j),se).then(Q=>Array.isArray(Q)?Q.map(O=>l.URI.revive(O)):[])}async findTextInFiles(F,x,j,oe,se=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${oe.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),H=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:M,folder:Q}=s(x.include),O=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,G={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:H,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:M,excludePattern:O},fe=!1;if(this._activeSearchCallbacks[V]=W=>{if(fe)return;const te=l.URI.revive(W.resource);W.results.forEach(he=>{(0,t.resultIsMatch)(he)?j({uri:te,preview:{text:he.preview.text,matches:(0,f.mapArrayOrNot)(he.preview.matches,Se=>new v.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,f.mapArrayOrNot)(he.ranges,Se=>new v.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):j({uri:te,text:he.text,lineNumber:he.lineNumber})})},se.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(F,(0,T.withUndefinedAsNull)(Q),G,V,se);return delete this._activeSearchCallbacks[V],W||{}}catch(W){throw delete this._activeSearchCallbacks[V],W}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};I=ze([Ve(0,m.IExtHostRpcService),Ve(1,o.IExtHostInitDataService),Ve(2,A.IExtHostFileSystemInfo),Ve(3,g.ILogService)],I),e.ExtHostWorkspace=I,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function s(k){let F,x;return k&&(typeof k=="string"?F=k:(F=k.pattern,x=k.baseFolder||l.URI.file(k.base))),{includePattern:F,folder:x}}}),define(Ee[33],_e([0,1,23,3,32,5,7,157,64,10,15,4,13,16,2]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(r,a){if(a){const i=a.split(".");let c=r;for(let p=0;c&&p<i.length;p++)c=c[i[p]];return c}}function b(r){return r instanceof u.URI}function w(r){return r&&r.uri instanceof u.URI&&r.languageId&&typeof r.languageId=="string"}function A(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function o(r){return r&&r.uri instanceof u.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function m(r){if(b(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(A(r))return{overrideIdentifier:r.languageId};if(o(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(a,i,c){this._proxy=a.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,i))}};v=ze([Ve(0,l.IExtHostRpcService),Ve(1,S.IExtHostWorkspace),Ve(2,h.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(a,i,c,p){this._onDidChangeConfiguration=new R.Emitter,this._proxy=a,this._logService=p,this._extHostWorkspace=i,this._configuration=E.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=E.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(a,i,c){const p=m(i)||{},d=this._toReadonlyValue(a?g(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,p,c?.identifier);function D(s){if(s==null)return null;if(typeof s=="boolean")return s?1:4;switch(s){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const I={has(s){return typeof g(d,s)!="undefined"},get:(s,k)=>{this._validateConfigurationAccess(a?`${a}.${s}`:s,p,c?.identifier);let F=g(d,s);if(typeof F=="undefined")F=k;else{let x;const j=(oe,se)=>{let V;const H=()=>{x=x||(0,f.deepClone)(d),V=V||g(x,se)};return(0,C.isObject)(oe)?new Proxy(oe,{get:(M,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return H(),()=>V;if(x)return V=V||g(x,se),V[Q];const O=M[Q];return typeof Q=="string"?j(O,`${se}.${Q}`):O},set:(M,Q,O)=>(H(),V&&(V[Q]=O),!0),deleteProperty:(M,Q)=>(H(),V&&delete V[Q],!0),defineProperty:(M,Q,O)=>(H(),V&&Object.defineProperty(V,Q,O),!0)}):oe};F=j(F,s)}return F},update:(s,k,F,x)=>{s=a?`${a}.${s}`:s;const j=D(F);return k!==void 0?this._proxy.$updateConfigurationOption(j,s,k,p,x):this._proxy.$removeConfigurationOption(j,s,p,x)},inspect:s=>{s=a?`${a}.${s}`:s;const k=(0,f.deepClone)(this._configuration.inspect(s,p,this._extHostWorkspace.workspace));if(k)return{key:s,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof d=="object"&&(0,f.mixin)(I,d,!1),Object.freeze(I)}_toReadonlyValue(a){const i=c=>(0,C.isObject)(c)?new Proxy(c,{get:(p,d)=>i(p[d]),set:(p,d,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(p,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(p,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(a)}_validateConfigurationAccess(a,i,c){const p=_.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),d=c?`[${c.value}] `:"";if(p===4){typeof i?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){i?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,i){const c=new E.ConfigurationChangeEvent(a,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,d)=>c.affectsConfiguration(p,m(d))})}_toMap(a){return a.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[108],_e([0,1,2,15,3,5,23,7,32,49,33,20,39,13,29,4,11,22,16,75,173,12]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o,m,v){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(V){function H(Q){if(Q!=null)return Q}V.from=H;function M(Q){if(Q!=null)return Q}V.to=M})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var a;(function(V){function H(Q){if(Q!=null)return Q}V.from=H;function M(Q){if(Q!=null)return Q}V.to=M})(a=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(V){function H(Q){if(Q!=null)return Q}V.from=H;function M(Q){if(Q!=null)return Q}V.to=M})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var c;(function(V){function H(O){if(O){const G=O;return G&&!!G.process}else return!1}V.is=H;function M(O){if(O==null)return;const G={process:O.process,args:O.args};return O.options&&(G.options=i.from(O.options)),G}V.from=M;function Q(O){if(O!=null)return new E.ProcessExecution(O.process,O.args,O.options)}V.to=Q})(c=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(V){function H(Q){if(Q!=null)return Q}V.from=H;function M(Q){if(Q!=null)return Q}V.to=M})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(V){function H(O){if(O){const G=O;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=H;function M(O){if(O==null)return;const G={};return O.commandLine!==void 0?G.commandLine=O.commandLine:(G.command=O.command,G.args=O.args),O.options&&(G.options=p.from(O.options)),G}V.from=M;function Q(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new E.ShellExecution(O.commandLine,O.options):new E.ShellExecution(O.command,O.args?O.args:[],O.options)}V.to=Q})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var D;(function(V){function H(O){if(O){let G=O;return G&&G.customExecution==="customExecution"}else return!1}V.is=H;function M(O){return{customExecution:"customExecution"}}V.from=M;function Q(O,G){return G.get(O)}V.to=Q})(D=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(V){function H(M,Q){let O;return M.scope!==void 0&&typeof M.scope!="number"?O=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===E.TaskScope.Workspace&&Q&&Q.workspaceFile?O=Q.workspaceFile:O=m.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:O}}V.from=H})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var s;(function(V){function H(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}V.from=H})(s=e.TaskGroupDTO||(e.TaskGroupDTO={}));var k;(function(V){function H(O,G){if(O==null)return[];const fe=[];for(let W of O){const te=M(W,G);te&&fe.push(te)}return fe}V.fromMany=H;function M(O,G){if(O==null)return;let fe;O.execution instanceof E.ProcessExecution?fe=c.from(O.execution):O.execution instanceof E.ShellExecution?fe=d.from(O.execution):O.execution&&O.execution instanceof E.CustomExecution&&(fe=D.from(O.execution));const W=r.from(O.definition);let te;return O.scope?typeof O.scope=="number"?te=O.scope:te=O.scope.uri:te=E.TaskScope.Workspace,!W||!te?void 0:{_id:O._id,definition:W,name:O.name,source:{extensionId:G.identifier.value,label:O.source,scope:te},execution:fe,isBackground:O.isBackground,group:s.from(O.group),presentationOptions:a.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}V.from=M;async function Q(O,G,fe){if(O==null)return;let W;c.is(O.execution)?W=c.to(O.execution):d.is(O.execution)?W=d.to(O.execution):D.is(O.execution)&&(W=D.to(O._id,fe));const te=r.to(O.definition);let he;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?he=O.source.scope:he=await G.resolveWorkspaceFolder(f.URI.revive(O.source.scope)):he=E.TaskScope.Workspace),!te||!he)return;const Se=new E.Task(te,he,O.name,O.source.label,W,O.problemMatchers);return O.isBackground!==void 0&&(Se.isBackground=O.isBackground),O.group!==void 0&&(Se.group=E.TaskGroup.from(O.group._id),Se.group&&(Se.group=P.deepClone(Se.group),O.group.isDefault&&(Se.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Se.presentationOptions=a.to(O.presentationOptions)),O._id&&(Se._id=O._id),O.detail&&(Se.detail=O.detail),Se}V.to=Q})(k=e.TaskDTO||(e.TaskDTO={}));var F;(function(V){function H(Q){return Q}V.from=H;function M(Q){if(!!Q)return Object.assign(Object.create(null),Q)}V.to=M})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class x{constructor(H,M,Q){this._id=M,this._task=Q,t.set(this,void 0),it(this,t,H,"f")}get task(){return this._task}terminate(){Be(this,t,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}t=new WeakMap;var j;(function(V){function H(M){return{id:M._id,task:void 0}}V.from=H})(j=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let oe=class{constructor(H,M,Q,O,G,fe,W,te){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=H.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=Q,this._editorService=O,this._configurationService=G,this._terminalService=fe,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=te,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,M,Q){if(!Q)return new E.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:M,provider:Q,extension:H}),this._proxy.$registerTaskProvider(O,M),new E.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(H,M){this._proxy.$registerTaskSystem(H,M)}fetchTasks(H){return this._proxy.$fetchTasks(F.from(H)).then(async M=>{const Q=[];for(let O of M){const G=await k.to(O,this._workspaceProvider,this._providedCustomExecutions2);G&&Q.push(G)}return Q})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(M=>H.push(M)),H}terminateTask(H){if(!(H instanceof x))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,M,Q){const O=this._providedCustomExecutions2.get(H.id);if(O){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,O),this._terminalService.attachPtyToTerminal(M,await O.callback(Q))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const M=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const M=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:M,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const M=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:H.exitCode})}$provideTasks(H,M){const Q=this._handlers.get(H);if(!Q)return Promise.reject(new Error("no handler found"));const O=[],G=(0,R.asPromise)(()=>Q.provider.provideTasks(T.CancellationToken.None)).then(fe=>this.provideTasksInternal(M,O,Q,fe));return new Promise(fe=>{G.then(W=>{Promise.all(O).then(()=>{fe(W)})})})}async $resolveTask(H,M){const Q=this._handlers.get(H);if(!Q)return Promise.reject(new Error("no handler found"));if(M.definition.type!==Q.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${Q.type}].`);const O=await k.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const G=await Q.provider.resolveTask(O,T.CancellationToken.None);if(!G)return;this.checkDeprecation(G,Q);const fe=k.from(G,Q.extension);if(!fe)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(fe.execution)&&await this.addCustomExecution(fe,G,!0),await this.resolveTaskInternal(fe)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,M,Q){const O=await this._proxy.$createTaskId(H);!Q&&!this._providedCustomExecutions2.has(O)&&this._notProvidedCustomExecutions.add(O),this._providedCustomExecutions2.set(O,M.execution)}async getTaskExecution(H,M){if(typeof H=="string"){const G=this._taskExecutionPromises.get(H);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let Q=this._taskExecutionPromises.get(H.id);if(Q)return Q;const O=new Promise(async(G,fe)=>{const W=M||await k.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);W?G(new x(this,H.id,W)):fe("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,O),O.then(G=>(this._taskExecutions.set(H.id,G),G),G=>Promise.reject(G))}checkDeprecation(H,M){H._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let Q=this._notProvidedCustomExecutions.values(),O=Q.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=Q.next()}};oe=ze([Ve(0,h.IExtHostRpcService),Ve(1,u.IExtHostInitDataService),Ve(2,_.IExtHostWorkspace),Ve(3,C.IExtHostDocumentsAndEditors),Ve(4,n.IExtHostConfiguration),Ve(5,l.IExtHostTerminalService),Ve(6,A.ILogService),Ve(7,o.IExtHostApiDeprecationService)],oe),e.ExtHostTaskBase=oe;let se=class extends oe{constructor(H,M,Q,O,G,fe,W,te){super(H,M,Q,O,G,fe,W,te);this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(H,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const Q=k.from(M,H);if(Q===void 0)throw new Error("Task is not valid");if(D.is(Q.execution))await this.addCustomExecution(Q,M,!1);else throw new v.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(Q),M);return this._proxy.$executeTask(Q).catch(G=>{throw new Error(G)}),O}provideTasksInternal(H,M,Q,O){const G=[];if(O)for(let fe of O){this.checkDeprecation(fe,Q),(!fe.definition||!H[fe.definition.type])&&this._logService.warn(`The task [${fe.source}, ${fe.name}] uses an undefined task type. The task will be ignored in the future.`);const W=k.from(fe,Q.extension);W&&D.is(W.execution)?(G.push(W),M.push(this.addCustomExecution(W,fe,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:Q.extension}}async resolveTaskInternal(H){if(D.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,M,Q){}};se=ze([Ve(0,h.IExtHostRpcService),Ve(1,u.IExtHostInitDataService),Ve(2,_.IExtHostWorkspace),Ve(3,C.IExtHostDocumentsAndEditors),Ve(4,n.IExtHostConfiguration),Ve(5,l.IExtHostTerminalService),Ve(6,A.ILogService),Ve(7,o.IExtHostApiDeprecationService)],se),e.WorkerExtHostTask=se,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Ee[223],_e([0,1,17,51,27,84,21,11,14,25,8,10,2,120,143,94,46,100,222,40]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(D,I,s,k){this.configurationService=D,this.workspaceContextService=I,this.editorGroupsService=s,this.pathService=k}text(D,I,s={}){D=this.getContentPattern(D,s);const k=this.configurationService.getValue(),F=I&&I.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep);return{...this.commonQuery(I?.map(b.toWorkspaceFolder),s),type:2,contentPattern:D,previewOptions:s.previewOptions,maxFileSize:s.maxFileSize,usePCRE2:k.search.usePCRE2||F||!1,beforeContext:s.beforeContext,afterContext:s.afterContext,userDisabledExcludesAndIgnoreFiles:s.disregardExcludeSettings&&s.disregardIgnoreFiles}}getContentPattern(D,I){const s=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const k={...D,wordSeparators:s.editor.wordSeparators};return this.isCaseSensitive(D,I)&&(k.isCaseSensitive=!0),this.isMultiline(D)&&(k.isMultiline=!0),k}file(D,I={}){return{...this.commonQuery(D,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}handleIncludeExclude(D,I){return D?(D=Array.isArray(D)?D.map(i):i(D),I?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],I={}){const s=this.handleIncludeExclude(I.includePattern,I.expandPatterns),k=this.handleIncludeExclude(I.excludePattern,I.expandPatterns),F=D.length>1,x=(s.searchPaths&&s.searchPaths.length?s.searchPaths.map(se=>this.getFolderQueryForSearchPath(se,I,k)):D.map(se=>this.getFolderQueryForRoot(se,I,k,F))).filter(se=>!!se),j={_reason:I._reason,folderQueries:x,usingSearchPaths:!!(s.searchPaths&&s.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:k.pattern,includePattern:s.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const V=f.coalesce(f.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(Q=>Q.resource)))).filter(M=>(0,o.pathIncludedInQuery)(j,M.fsPath)),H=this.commonQueryFromFileList(V);return{...j,...H}}const oe=I.extraFileResources&&I.extraFileResources.filter(se=>(0,o.pathIncludedInQuery)(j,se.fsPath));return j.extraFileResources=oe&&oe.length?oe:void 0,j}commonQueryFromFileList(D){const I=[],s=new P.ResourceMap,k={};let F=!1;return D.forEach(x=>{if(x.scheme===E.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(x)){const oe=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:_.dirname(x.fsPath)});let se=s.get(oe);se||(F=!0,se={folder:oe,includePattern:{}},I.push(se),s.set(oe,se));const V=_.relative(oe.fsPath,x.fsPath);(0,T.assertIsDefined)(se.includePattern)[V.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,k[x.fsPath]=!0)}),{folderQueries:I,includePattern:k,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,I){if(I.isSmartCase){if(D.isRegExp){if(n.containsUppercaseCharacter(D.pattern,!0))return!0}else if(n.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,h.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const I=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),k=(Array.isArray(D)?D:r(D)).map(H=>{const M=this.pathService.resolvedUserHome;return M?(0,y.untildify)(H,M.scheme===E.Schemas.file?M.fsPath:M.path):H}),F=R.groupBy(k,H=>I(H)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(H=>n.rtrim(H,"/")).map(H=>n.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),a(H))),j={},oe=this.expandSearchPathPatterns(F.searchPaths||[]);oe&&oe.length&&(j.searchPaths=oe);const se=f.flatten(x),V=t(...se);return V&&(j.pattern=V),j}getExcludesForFolder(D,I){return I.disregardExcludeSettings?void 0:(0,o.getExcludes)(D,!I.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const I=f.flatten(D.map(k=>{let{pathPortion:F,globPortion:x}=v(k);x&&(x=c(x));const j=this.expandOneSearchPath(F);return f.flatten(j.map(oe=>this.resolveOneSearchPathPattern(oe,x)))})),s=new Map;return I.forEach(k=>{const F=k.searchPath.toString(),x=s.get(F);x?k.pattern&&(x.pattern=x.pattern||{},x.pattern[k.pattern]=!0):s.set(F,{searchPath:k.searchPath,pattern:k.pattern?t(k.pattern):void 0})}),Array.from(s.values())}expandOneSearchPath(D){if(_.isAbsolute(D)){const I=this.workspaceContextService.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==E.Schemas.file?[{searchPath:I[0].uri.with({path:D})}]:[{searchPath:l.URI.file(_.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const I=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=i(D),D.startsWith("../")||D===".."){const k=_.posix.resolve(I.path,D);return[{searchPath:I.with({path:k})}]}const s=c(D);return[{searchPath:I,pattern:s}]}else{if(D==="./"||D===".\\")return[];{const I=D.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(F=>{const x=I.match(new RegExp(`^${n.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return x?{match:x,folder:F}:null}).filter(T.isDefined);if(k.length)return k.map(F=>{const x=F.match[1];return{searchPath:F.folder.uri,pattern:x&&c(x)}});{const F=D.match(/\.[\/\\](.+)[\/\\]?/),x=F?F[1]:D,j=u.localize(0,null,x);throw new Error(j)}}}}resolveOneSearchPathPattern(D,I){const s=D.pattern&&I?`${D.pattern}/${I}`:D.pattern||I,k=[{searchPath:D.searchPath,pattern:s}];return s&&!s.endsWith("**")&&k.push({searchPath:D.searchPath,pattern:s+"/**"}),k}getFolderQueryForSearchPath(D,I,s){const k=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(D.searchPath),I,s,!1);return k?{...k,includePattern:D.pattern}:null}getFolderQueryForRoot(D,I,s,k){let F;const x=l.URI.isUri(D)?D:D.uri;if(s.searchPaths){const H=s.searchPaths.filter(M=>(0,C.isEqual)(M.searchPath,x))[0];if(H&&!H.pattern)return null;H&&(F=H.pattern)}const j=this.configurationService.getValue({resource:x}),se={...this.getExcludesForFolder(j,I)||{},...F||{}},V=l.URI.isUri(D)?(0,C.basename)(D):D.name;return{folder:x,folderName:k?V:void 0,excludePattern:Object.keys(se).length>0?se:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!j.search.followSymlinks}}};m=ze([Ve(0,g.IConfigurationService),Ve(1,b.IWorkspaceContextService),Ve(2,w.IEditorGroupsService),Ve(3,A.IPathService)],m),e.QueryBuilder=m;function v(d){const D=d.match(/[\*\{\}\(\)\[\]\?]/);if(D){const I=D.index,s=d.substr(0,I).match(/[/|\\][^/\\]*$/);if(s){let k=d.substr(0,s.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:d.substr((s.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((D,I)=>(D[I]=!0,D),Object.create(null)):void 0}function r(d){return S.splitGlobAware(d,",").map(D=>D.trim()).filter(D=>!!D.length)}function a(d){return[`**/${d}/**`,`**/${d}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function i(d){return d.replace(/\\/g,"/")}function c(d){return i(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(d,D){d=f.distinct(d,k=>k.toString());const I=[],s=D.getWorkspace();return d&&d.forEach(k=>{let F;if(D.getWorkbenchState()===2)F=(0,C.relativePath)(s.folders[0].uri,k),F&&F!=="."&&(F="./"+F);else{const x=D.getWorkspaceFolder(k);if(x){const j=x.name;if(s.folders.filter(se=>se.name===j).length===1){const se=(0,C.relativePath)(x.uri,k);se===""?F=`./${x.name}`:F=`./${x.name}/${se}`}else F=k.fsPath}}F&&I.push(F)}),I}e.resolveResourcesForSearchIncludes=p}),define(Ee[224],_e([0,1,25,2,20,12,4,223,40,46]),function(Z,e,f,R,S,y,P,E,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function T(g,b){const w=b.activationEvents;if(!w)return Promise.resolve(void 0);const A=[],o=[];for(const i of w)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||g.forceUsingSearch?o.push(c):A.push(c)}if(A.length===0&&o.length===0)return Promise.resolve(void 0);let m;const v=new Promise((i,c)=>{m=i}),t=i=>m({activationEvent:i}),r=Promise.all(A.map(i=>l(g,i,t))).then(()=>{}),a=h(g,b.identifier,o,t);return Promise.all([r,a]).then(()=>{m(void 0)}),v}e.checkActivateWorkspaceContainsExtension=T;async function l(g,b,w){for(const A of g.folders)if(await g.exists(f.joinPath(R.URI.revive(A),b))){w(`workspaceContains:${b}`);return}}async function h(g,b,w,A){if(w.length===0)return Promise.resolve(void 0);const o=new S.CancellationTokenSource,m=g.checkExists(g.folders,w,o.token),v=setTimeout(async()=>{o.cancel(),A(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await m}catch(r){y.isPromiseCanceledError(r)||y.onUnexpectedError(r)}o.dispose(),clearTimeout(v),t&&A(`workspaceContains:${w.join(",")}`)}function u(g,b,w,A){const o=g.get(P.IInstantiationService),m=g.get(_.ISearchService),t=o.createInstance(E.QueryBuilder).file(b.map(r=>(0,C.toWorkspaceFolder)(R.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return m.fileSearch(t,A).then(r=>!!r.limitHit,r=>y.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=u});var it=this&&this.__classPrivateFieldSet||function(Z,e,f,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(Z,f):S?S.value=f:e.set(Z,f),f},Be=this&&this.__classPrivateFieldGet||function(Z,e,f,R){if(f==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!R:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?R:f==="a"?R.call(Z):R?R.value:e.get(Z)};define(Ee[34],_e([0,1,134,14,79,25,15,6,21,2,16,5,33,186,77,32,30,184,12,26,24,161,7,95,4,29,78,13,63,69,39,3,224,74,163]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o,m,v,t,r,a,i,c,p,d,D,I,s,k,F,x){"use strict";var j,oe,se;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let V=class Hn extends E.Disposable{constructor(O,G,fe,W,te,he,Se,Le,Me,$e){super();this._onDidChangeRemoteConnectionData=this._register(new s.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=fe,this._initData=Se,this._extHostWorkspace=W,this._extHostConfiguration=te,this._logService=he,this._extHostTunnelService=Me,this._extHostTerminalService=$e,this._disposables=new E.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=O.createChild(new d.ServiceCollection([u.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(qe=>Xe.add(o.ExtensionIdentifier.toKey(qe))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,Ge,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,A.transformErrorForSerialization(Ge),U)},actualActivateExtension:async(qe,Ge)=>{if(Xe.has(o.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,Ge),new h.HostExtension;const U=this._registry.getExtensionDescription(qe);return this._activateExtension(U,Ge)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){A.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch(G){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,G){return this._activator.activateByEvent(O,G)}_activateById(O,G){return this._activator.activateById(O,G)}activateByIdWithErrors(O,G){return this._activateById(O,G).then(()=>{const fe=this._activator.getActivatedExtension(O);if(fe.activationFailed)return Promise.reject(fe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=_.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(fe=>{if(!!this._getEntryPoint(fe))return this._hostUtils.realpath(fe.extensionLocation.fsPath).then(W=>O.set(C.URI.file(W).fsPath,fe))});this._extensionPathIndex=Promise.all(G).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return G;const fe=this._activator.getActivatedExtension(O);if(!fe)return G;try{typeof fe.module.deactivate=="function"&&(G=Promise.resolve(fe.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,E.dispose)(fe.subscriptions)}catch(W){this._logService.error(W)}return G}async _activateExtension(O,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,G).then(fe=>{const W=fe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,G),this._logExtensionActivationTimes(O,G,"success",W),fe},fe=>{throw this._logExtensionActivationTimes(O,G,"failure"),fe})}_logExtensionActivationTimes(O,G,fe,W){const te=H(O,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...te,...W||{},outcome:fe})}_doActivateExtension(O,G){const fe=H(O,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",fe);const W=this._getEntryPoint(O);if(!W)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const te=new h.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,y.joinPath)(O.extensionLocation,W),te),this._loadExtensionContext(O)]).then(he=>(S.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Hn._callActivate(this._logService,O.identifier,he[0],he[1],te))).then(he=>(S.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),he))}_loadExtensionContext(O){const G=new v.ExtensionGlobalMemento(O,this._storage),fe=new v.ExtensionMemento(O.identifier.value,!1,this._storage),W=new x.ExtensionSecrets(O,this._secretState),te=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([G.whenReady,fe.whenReady,this._storagePath.whenReady]).then(()=>{const Se=this;let Le;return Object.freeze({globalState:G,workspaceState:fe,secrets:W,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Me){return R.join(O.extensionLocation.fsPath,Me)},get storagePath(){return Se._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return Se._storagePath.globalValue(O).fsPath},get logPath(){return R.join(Se._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return C.URI.joinPath(Se._initData.logsLocation,O.identifier.value)},get storageUri(){return Se._storagePath.workspaceValue(O)},get globalStorageUri(){return Se._storagePath.globalValue(O)},get extensionMode(){return te},get extension(){return Le===void 0&&(Le=new M(Se,O.identifier,O,he)),Le},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(O),Se.extensionRuntime},get environmentVariableCollection(){return Se._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,G,fe,W,te){return fe=fe||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,G,fe,W,te).then(he=>new h.ActivatedExtension(!1,null,te.build(),fe,he,W.subscriptions))}static _callActivateOptional(O,G,fe,W,te){if(typeof fe.activate=="function")try{te.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${G.value}`);const he=typeof global=="object"?global:self,Se=fe.activate.apply(he,[W]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(Se).then(Le=>(te.activateResolveStop(),Le))}catch(he){return Promise.reject(he)}else return Promise.resolve(fe)}_activateOneStartupFinished(O,G){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:G}).then(void 0,fe=>{this._logService.error(fe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const G of O.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(O,G)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],fe=this._handleWorkspaceContainsEagerExtensions(G),W=Promise.all([O,fe]).then(()=>{});return Promise.race([W,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(O,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,G){if(this.isActivated(G.identifier))return;const fe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:O.map(he=>he.uri),forceUsingSearch:fe,exists:he=>this._hostUtils.exists(he.fsPath),checkExists:(he,Se,Le)=>this._mainThreadWorkspaceProxy.$checkExists(he,Se,Le)},te=await(0,k.checkActivateWorkspaceContainsExtension)(W,G);if(!!te)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:te.activationEvent}).then(void 0,he=>this._logService.error(he))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:G}=this._initData.environment;if(!O||!G)throw new Error(f.localize(0,null));const fe=await this._loadCommonJSModule(null,G,new h.ExtensionActivationTimesBuilder(!1));if(!fe||typeof fe.run!="function")throw new Error(f.localize(1,null,G.toString()));return new Promise((W,te)=>{const he=(Me,$e)=>{Me?te(Me):W(typeof $e=="number"&&$e>0?1:0)},Se=(0,y.originalFSPath)(G),Le=fe.run(Se,he);Le&&Le.then&&Le.then(()=>{W(0)}).catch(Me=>{te(Me.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,G){return this._resolvers[O]=G,(0,E.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const G=O.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const fe=O.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${fe}`,!1),{authorityPrefix:fe,resolver:this._resolvers[fe]}}async $resolveAuthority(O,G){const{authorityPrefix:fe,resolver:W}=await this._activateAndGetResolver(O);if(!W)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${fe}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),S.mark(`code/extHost/willResolveAuthority/${fe}`);const te=await W.resolve(O,{resolveAttempt:G});S.mark(`code/extHost/didResolveAuthorityOK/${fe}`);const he={authority:O,host:te.host,port:te.port,connectionToken:te.connectionToken},Se={extensionHostEnv:te.extensionHostEnv,isTrusted:te.isTrusted};return{type:"ok",value:{authority:he,options:Se,tunnelInformation:{environmentTunnels:te.environmentTunnels}}}}catch(te){if(S.mark(`code/extHost/didResolveAuthorityError/${fe}`),te instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te}}async $getCanonicalURI(O,G){const{authorityPrefix:fe,resolver:W}=await this._activateAndGetResolver(O);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${fe}`);const te=C.URI.revive(G);if(typeof W.getCanonicalURI=="undefined")return te;const he=await(0,P.asPromise)(()=>W.getCanonicalURI(te));return he||te}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,G){return G===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(fe=>this._activateByEvent(O,!1))}async $activate(O,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,G),!0):!1}async $deltaExtensions(O,G){O.forEach(W=>W.extensionLocation=C.URI.revive(W.extensionLocation));const fe=await this.getExtensionPathIndex();return await Promise.all(G.map(async W=>{const te=this._registry.getExtensionDescription(W);if(!te)return;const he=await this._hostUtils.realpath(te.extensionLocation.fsPath);fe.delete(C.URI.file(he).fsPath)})),await Promise.all(O.map(async W=>{const te=await this._hostUtils.realpath(W.extensionLocation.fsPath);fe.set(C.URI.file(te).fsPath,W)})),this._registry.deltaExtensions(O,G),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let G=m.VSBuffer.alloc(O),fe=Math.random()%256;for(let W=0;W<O;W++)G.writeUInt8(fe,W);return G}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};V=ze([Ve(0,a.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,p.IExtHostRpcService),Ve(3,g.IExtHostWorkspace),Ve(4,l.IExtHostConfiguration),Ve(5,n.ILogService),Ve(6,i.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,D.IExtHostTunnelService),Ve(9,I.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function H(Q,O){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class M{constructor(O,G,fe,W){j.set(this,void 0),oe.set(this,void 0),se.set(this,void 0),it(this,j,O,"f"),it(this,oe,G,"f"),it(this,se,fe.identifier,"f"),this.id=fe.identifier.value,this.extensionUri=fe.extensionLocation,this.extensionPath=R.normalize((0,y.originalFSPath)(fe.extensionLocation)),this.packageJSON=fe,this.extensionKind=W}get isActive(){return Be(this,j,"f").isActivated(Be(this,se,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,j,"f").getExtensionExports(Be(this,se,"f"))}activate(){return Be(this,j,"f").activateByIdWithErrors(Be(this,se,"f"),{startup:!1,extensionId:Be(this,oe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,j=new WeakMap,oe=new WeakMap,se=new WeakMap}),define(Ee[109],_e([0,1,14,2,3,15,5,7,171,32,34,49,175,33,172,13,4,10,42,67]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let m=class{constructor(d,D,I,s,k,F){this._workspaceService=D,this._extensionService=I,this._editorsService=s,this._configurationService=k,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=d.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(j=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,D){const I=d;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let s=`debug:${encodeURIComponent(I.path||"")}`,k="?";return D&&(s+=`${k}session=${encodeURIComponent(D.id)}`,k="&"),s+=`${k}ref=${I.sourceReference}`,R.URI.parse(s)}else{if(I.path)return R.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const D=[];for(const I of d.getAllExtensionDescriptions())if(I.contributes){const s=I.contributes.debuggers;if(s&&s.length>0)for(const k of s)(0,u.isDebuggerMainContribution)(k)&&D.push(k.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(D=>d.push(D)),d}addBreakpoints(d){this.startBreakpoints();const D=d.filter(k=>{const F=k.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,k),!0)});this.fireBreakpointChanges(D,[],[]);const I=[],s=new Map;for(const k of D)if(k instanceof E.SourceBreakpoint){let F=s.get(k.location.uri.toString());F||(F={type:"sourceMulti",uri:k.location.uri,lines:[]},s.set(k.location.uri.toString(),F),I.push(F)),F.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof E.FunctionBreakpoint&&I.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(I)}removeBreakpoints(d){this.startBreakpoints();const D=d.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],D,[]);const I=D.filter(F=>F instanceof E.SourceBreakpoint).map(F=>F.id),s=D.filter(F=>F instanceof E.FunctionBreakpoint).map(F=>F.id),k=D.filter(F=>F instanceof E.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(I,s,k)}startDebugging(d,D,I){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,D,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,debugUI:I.debugUI})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,D,I){if(!D)return new E.Disposable(()=>{});const s=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:s,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,I,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,s),new E.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(d,D,I){if(!I)return new E.Disposable(()=>{});if(!this.definesDebugType(d,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:s,factory:I}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,s),new E.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==I),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(d,D){if(!D)return new E.Disposable(()=>{});const I=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:I,factory:D}),new E.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(s=>s.factory!==D)})}async $runInTerminal(d,D){return Promise.resolve(void 0)}async $substituteVariables(d,D){if(!this._variableResolver){const[k,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,F)}let I;const s=await this.getFolder(d);return s&&(I={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(I,D)}createDebugAdapter(d,D){if(d.type==="implementation")return new i(d.implementation)}createSignService(){}async $startDASession(d,D){const I=this,s=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(s.type),s).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const F=this.convertToDto(k),x=this.createDebugAdapter(F,s);if(!x)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const j=x;return this._debugAdapters.set(d,j),this.getDebugAdapterTrackers(s).then(oe=>(oe&&this._debugAdaptersTrackers.set(d,oe),j.onMessage(async se=>{if(se.type==="request"&&se.command==="handshake"){const V=se,H={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(V.arguments.value);H.body={signature:M},j.sendResponse(H)}else throw new Error("no signer")}catch(M){H.success=!1,H.message=M.message,j.sendResponse(H)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(se),se=(0,u.convertToVSCPaths)(se,!0),I._debugServiceProxy.$acceptDAMessage(d,se)}),j.onError(se=>{oe&&oe.onError&&oe.onError(se),this._debugServiceProxy.$acceptDAError(d,se.name,se.message,se.stack)}),j.onExit(se=>{oe&&oe.onExit&&oe.onExit((0,w.withNullAsUndefined)(se),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,w.withNullAsUndefined)(se),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),j.startSession()))})}$sendDAMessage(d,D){D=(0,u.convertToDAPaths)(D,!1);const I=this._debugAdaptersTrackers.get(d);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(D);const s=this._debugAdapters.get(d);s&&s.sendMessage(D)}$stopDASession(d){const D=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),D&&D.onWillStopSession&&D.onWillStopSession();const I=this._debugAdapters.get(d);return this._debugAdapters.delete(d),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const D=[],I=[],s=[];if(d.added)for(const k of d.added){const F=k.id;if(F&&!this._breakpoints.has(F)){let x;if(k.type==="function")x=new E.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")x=new E.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const j=R.URI.revive(k.uri);x=new E.SourceBreakpoint(new E.Location(j,new E.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}x._id=F,this._breakpoints.set(F,x),D.push(x)}}if(d.removed)for(const k of d.removed){const F=this._breakpoints.get(k);F&&(this._breakpoints.delete(k),I.push(F))}if(d.changed){for(const k of d.changed)if(k.id){const F=this._breakpoints.get(k.id);if(F){if(F instanceof E.FunctionBreakpoint&&k.type==="function"){const x=F;x.enabled=k.enabled,x.condition=k.condition,x.hitCondition=k.hitCondition,x.logMessage=k.logMessage,x.functionName=k.functionName}else if(F instanceof E.SourceBreakpoint&&k.type==="source"){const x=F;x.enabled=k.enabled,x.condition=k.condition,x.hitCondition=k.hitCondition,x.logMessage=k.logMessage,x.location=new E.Location(R.URI.revive(k.uri),new E.Position(k.line,k.character))}s.push(F)}}}this.fireBreakpointChanges(D,I,s)}$provideDebugConfigurations(d,D,I){return(0,y.asPromise)(async()=>{const s=this.getConfigProviderByHandle(d);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(D);return s.provideDebugConfigurations(k,I)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(d,D,I,s){return(0,y.asPromise)(async()=>{const k=this.getConfigProviderByHandle(d);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(D);return k.resolveDebugConfiguration(F,I,s)})}$resolveDebugConfigurationWithSubstitutedVariables(d,D,I,s){return(0,y.asPromise)(async()=>{const k=this.getConfigProviderByHandle(d);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(D);return k.resolveDebugConfigurationWithSubstitutedVariables(F,I,s)})}async $provideDebugAdapter(d,D){const I=this.getAdapterDescriptorFactoryByHandle(d);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.getSession(D);return this.getAdapterDescriptor(I,s).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(d){const D=await this.getSession(d);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(d){const D=await this.getSession(d);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,D){const I=await this.getSession(d);I&&I._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(d,D){const s={session:await this.getSession(d),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(s)}convertToDto(d){if(d instanceof E.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof E.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const D=this._adapterFactories.filter(I=>I.type===d);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(d){const D=this._adapterFactories.filter(I=>I.handle===d);if(D.length>0)return D[0].factory}getConfigProviderByHandle(d){const D=this._configProviders.filter(I=>I.handle===d);if(D.length>0)return D[0].provider}definesDebugType(d,D){if(d.contributes){const I=d.contributes.debuggers;if(I&&I.length>0){for(const s of I)if(s.label&&s.type&&s.type===D)return!0}}return!1}getDebugAdapterTrackers(d){const I=d.configuration.type,s=this._trackerFactories.filter(k=>k.type===I||k.type==="*").map(k=>(0,y.asPromise)(()=>k.factory.createDebugAdapterTracker(d)).then(F=>F,F=>null));return Promise.race([Promise.all(s).then(k=>{const F=k.filter(x=>!!x);if(F.length>0)return new a(F)}),new Promise((k,F)=>{const x=setTimeout(()=>{clearTimeout(x),F(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(d,D){const I=D.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new E.DebugAdapterServer(I));if(d){const k=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>d.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,k))).then(F=>{if(F)return F})}const s=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,s))}daExecutableFromPackage(d,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,D,I){(d.length>0||D.length>0||I.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:D,changed:I}))}async getSession(d){if(d)if(typeof d=="string"){const D=this._debugSessions.get(d);if(D)return D}else{let D=this._debugSessions.get(d.id);if(!D){const I=await this.getFolder(d.folderUri),s=d.parent?this._debugSessions.get(d.parent):void 0;D=new v(this._debugServiceProxy,d.id,d.type,d.name,I,d.configuration,s),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(d){if(d){const D=R.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};m=ze([Ve(0,g.IExtHostRpcService),Ve(1,C.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,T.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,o.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class v{constructor(d,D,I,s,k,F,x){this._debugServiceProxy=d,this._id=D,this._type=I,this._name=s,this._workspaceFolder=k,this._configuration=F,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,D)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=v;class t{constructor(d){this.value=Object.freeze({append(D){d.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(d,D,I,s,k){function F(){if(D){const x=D.activeEditor();if(x)return x.document.uri;const j=s.tabs.filter(oe=>oe.isActive);if(j.length>0)return j[0].resource}}super({getFolderUri:x=>{const j=d.filter(oe=>oe.name===x);if(j&&j.length>0)return j[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(x,j)=>I.getConfiguration(void 0,x).get(j),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=F();if(x)return f.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const x=F();if(x){const j=k.getWorkspaceFolder(x);if(j)return f.normalize(j.uri.fsPath)}}},getSelectedText:()=>{if(D){const x=D.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(D){const x=D.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(A.env))}}e.ExtHostVariableResolverService=r;class a{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(D=>D.onError?D.onError(d):void 0)}onExit(d,D){this.trackers.forEach(I=>I.onExit?I.onExit(d,D):void 0)}}class i extends _.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends m{constructor(d,D,I,s,k,F){super(d,D,I,s,k,F)}createVariableResolver(d,D,I){return new r(d,D,I,this._editorTabs)}};c=ze([Ve(0,g.IExtHostRpcService),Ve(1,C.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,T.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,o.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(Ee[225],_e([0,1,79,2,5,33,30,26,13,29,4,34,42,16]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(o,m,v,t,r,a,i){this._apiFactory=o,this._extensionRegistry=m,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=a,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,m,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,m,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let m of o.nodeModuleName)this._factories.set(m,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(m=>o.alternativeModuleName(m))}};u=ze([Ve(2,n.IInstantiationService),Ve(3,y.IExtHostConfiguration),Ve(4,T.IExtHostExtensionService),Ve(5,C.IExtHostInitDataService),Ve(6,h.ILogService)],u),e.RequireInterceptor=u;class g{constructor(o,m,v,t,r){this._apiFactory=o,this._extensionPaths=m,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,m){const v=this._extensionPaths.findSubstr(m.fsPath);if(v){let t=this._extApiImpl.get(E.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(E.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,a)=>t+=`	${a} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(o,m){this.nodeModuleName="keytar";const{environment:v}=m,t=o.getProxy(S.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,a)=>t.$getPassword(r,a),setPassword:(r,a,i)=>t.$setPassword(r,a,i),deletePassword:(r,a)=>t.$deletePassword(r,a),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(o,m){return this._impl}alternativeModuleName(o){const m=o.length;if(m<=7||!this.alternativeNames)return;const v=m-7;if((o.charAt(v)==="/"||o.charAt(v)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};b=ze([Ve(0,_.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],b);let w=class{constructor(o,m,v){this._extensionPaths=o,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(S.MainContext.MainThreadTelemetry);const t=v.getProxy(S.MainContext.MainThreadWindow);this._impl=(r,a)=>{const i=R.URI.parse(r);return a?this.callOriginal(r,a):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,a)}}load(o,m,v){const t=this._extensionPaths.findSubstr(m.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(o),this._impl}callOriginal(o,m){return this.sendNoForwardTelemetry(),this._original(o,m)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=ze([Ve(2,_.IExtHostRpcService)],w)}),define(Ee[226],_e([0,1,15,12,79,6,2,5,219,16,60,63,29,153,13,70,34,39]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class A{constructor(m,v,t,r){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(m,null,r),v=A._transform(v,this._rpcProtocol);const a=new T.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());a.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),a.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),a.set(g.IURITransformerService,new g.URITransformerService(r)),a.set(b.IHostUtils,t);const i=new h.InstantiationService(a,!0),c=i.invokeFunction(I=>I.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(I=>I.get(C.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(I=>I.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(I=>{Error.prepareStackTrace=(s,k)=>{let F="",x,j;for(const oe of k)F+=`
	at ${oe.toString()}`,j=oe.getFileName(),!x&&j&&(x=I.findSubstr(j));return p.set(s,x),`${s.name||"Error"}: ${s.message||""}${F}`}});const d=this._rpcProtocol.getProxy(E.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(E.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(I=>{const s=R.transformErrorForSerialization(I),k=p.get(I);k?d.$onExtensionRuntimeError(k.identifier,s):D.$onUnexpectedError(s)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,f.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(m,v){m.extensions.forEach(r=>r.extensionLocation=P.URI.revive(v.transformIncomingURIs(r.extensionLocation))),m.environment.appRoot=P.URI.revive(v.transformIncomingURIs(m.environment.appRoot));const t=m.environment.extensionDevelopmentLocationURI;return t&&(m.environment.extensionDevelopmentLocationURI=t.map(r=>P.URI.revive(v.transformIncomingURIs(r)))),m.environment.extensionTestsLocationURI=P.URI.revive(v.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=P.URI.revive(v.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=P.URI.revive(v.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=P.URI.revive(v.transformIncomingURIs(m.logsLocation)),m.logFile=P.URI.revive(v.transformIncomingURIs(m.logFile)),m.workspace=v.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=A}),define(Ee[227],_e([0,1,14,20,59,27,25,56,40]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(l,h,u){this.config=l,this.provider=h,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const h=this.config.folderQueries||[];return new Promise((u,g)=>{const b=w=>{this.resultCount++,l(w)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const A=w.toString(),o=f.basename(A);this.globalExcludePattern&&this.globalExcludePattern(A,o)||this.matchFile(b,{base:w,basename:o})}),Promise.all(h.map(w=>this.searchInFolder(w,b))).then(w=>{u({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{g(new Error((0,S.toErrorMessage)(w)))})})}async searchInFolder(l,h){const u=new R.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),b=this.initDirectoryTree(),w=new _.QueryGlobTester(this.config,l),A=!w.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(u),o=E.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,u.token),v=o.elapsed(),t=E.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(r=>{const a=f.posix.relative(l.folder.path,r.path);if(A){const i=f.basename(r.path);this.matchFile(h,{base:l.folder,relativePath:a,basename:i});return}this.addDirectoryEntries(b,l.folder,a,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,w,h),{providerTime:v,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(l){const h=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),u=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:u,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},h,u,g){if(u===this.filePattern){const w=f.basename(this.filePattern);this.matchFile(g,{base:h,relativePath:this.filePattern,basename:w})}function b(w){const A=f.basename(w),o=f.dirname(w);let m=l[o];m||(m=l[o]=[],b(o)),m.push({base:h,relativePath:w,basename:A})}b(u)}matchDirectoryTree({rootEntries:l,pathToEntries:h},u,g){const b=this,w=this.filePattern;function A(o){const m=y.hasSiblingFn(()=>o.map(v=>v.basename));for(let v=0,t=o.length;v<t;v++){const r=o[v],{relativePath:a,basename:i}=r;if(!u.includedInQuerySync(a,i,w!==i?m:void 0))continue;const c=h[a];if(c)A(c);else{if(a===w)continue;b.matchFile(g,r)}if(b.isLimitHit)break}}A(l)}matchFile(l,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(h))}}class n{constructor(){this.sessions=new Map}fileSearch(l,h,u,g){const b=this.getSessionTokenSource(l.cacheKey),w=new C(l,h,b&&b.token);let A=0;const o=m=>{A+=m.length,u(m.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,n.BATCH_SIZE,o,g).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:A,detailStats:m.stats}}))}clearCache(l){const h=this.getSessionTokenSource(l);h&&h.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:P.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,h,u,g){g.onCancellationRequested(()=>{l.cancel()});const b=A=>{A&&(w.push(A),h>0&&w.length>=h&&(u(w),w=[]))};let w=[];return l.search(b).then(A=>(w.length&&u(w),A),A=>(w.length&&u(w),Promise.reject(A)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(Ee[228],_e([0,1,14,17,20,59,25,27,2,40,11,10]),function(Z,e,f,R,S,y,P,E,_,C,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(o,m,v){this.query=o,this.provider=m,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,m){const v=this.query.folderQueries||[],t=new S.CancellationTokenSource;return m.onCancellationRequested(()=>t.cancel()),new Promise((r,a)=>{this.collector=new u(o);let i=!1;const c=(p,d)=>{if(!i&&!this.isLimitHit){const D=this.resultSize(p);b(p)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const I=this.resultSize(p);this.resultCount+=I,(I>0||!b(p))&&this.collector.add(p,d)}};Promise.all(v.map((p,d)=>this.searchInFolder(p,D=>c(D,d),t.token))).then(p=>{t.dispose(),this.collector.flush();const d=p.some(D=>!!D&&!!D.limitHit);r({limitHit:this.isLimitHit||d,messages:(0,R.flatten)(p.map(D=>D?.message?(0,T.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:"textSearchProvider"}})},p=>{t.dispose();const d=(0,y.toErrorMessage)(p);a(new Error(d))})})}resultSize(o){return b(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,m){const v=Array.isArray(o.ranges)?o.ranges:[o.ranges],t=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:v.slice(0,m),preview:{matches:t.slice(0,m),text:o.preview.text},uri:o.uri}}async searchInFolder(o,m,v){const t=new C.QueryGlobTester(this.query,o),r=[],a={report:p=>{if(!this.validateProviderResult(p))return;const d=o.folder.scheme===n.Schemas.file?E.hasSiblingPromiseFn(()=>this.fileUtils.readdir(P.dirname(p.uri))):void 0,D=P.relativePath(o.folder,p.uri);D&&r.push(t.includedInQuery(D,f.basename(D),d).then(I=>{I&&m(p)}))}},i=this.getSearchOptionsForFolder(o),c=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,a,v);return await Promise.all(r),c}validateProviderResult(o){if(b(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const m=(0,C.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),v=(0,C.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),t={folder:_.URI.from(o.folder),excludes:v,includes:m,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function h(A){return{isCaseSensitive:A.isCaseSensitive||!1,isRegExp:A.isRegExp||!1,isWordMatch:A.isWordMatch||!1,isMultiline:A.isMultiline||!1,pattern:A.pattern}}class u{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,m=>this.sendItems(m))}add(o,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!P.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(g(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=u;function g(A){return b(A)?{preview:{matches:(0,R.mapArrayOrNot)(A.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:A.preview.text},ranges:(0,R.mapArrayOrNot)(A.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:A.text,lineNumber:A.lineNumber}}function b(A){return!!A.preview}e.extensionResultIsMatch=b;class w{constructor(o,m){this.maxBatchSize=o,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,m){!o||this.addItemToBatch(o,m)}addItems(o,m){!o||this.addItemsToBatch(o,m)}addItemToBatch(o,m){this.batch.push(o),this.batchSize+=m,this.onUpdate()}addItemsToBatch(o,m){this.batch=this.batch.concat(o),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(Ee[110],_e([0,1,6,5,4,227,13,70,16,2,228]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let T=class{constructor(g,b,w){this.extHostRpc=g,this._uriTransformer=b,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,b){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const w=this._handlePool++;return this._textSearchProvider.set(w,b),this._proxy.$registerTextSearchProvider(w,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(g,b){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const w=this._handlePool++;return this._fileSearchProvider.set(w,b),this._proxy.$registerFileSearchProvider(w,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(g,b,w,A){const o=l(w),m=this._fileSearchProvider.get(g);if(m)return this._fileSearchManager.fileSearch(o,m,v=>{this._proxy.$handleFileMatch(g,b,v.map(t=>t.resource))},A);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,b,w,A){const o=this._textSearchProvider.get(g);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const m=l(w);return this.createTextSearchManager(m,o).search(t=>this._proxy.$handleTextMatch(g,b,t),A)}createTextSearchManager(g,b){return new n.TextSearchManager(g,b,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};T=ze([Ve(0,P.IExtHostRpcService),Ve(1,E.IURITransformerService),Ve(2,_.ILogService)],T),e.ExtHostSearch=T;function l(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(h),extraFileResources:u.extraFileResources&&u.extraFileResources.map(g=>C.URI.revive(g))}}e.reviveQuery=l;function h(u){return{...u,folder:C.URI.revive(u.folder)}}}),define(Ee[229],_e([0,1,20,12,3,36,2,127,87,121,58,62,5,191,190,48,192,33,193,194,195,177,196,49,34,197,178,200,201,202,105,180,207,208,209,77,39,211,181,9,7,214,50,106,32,30,51,168,199,96,104,108,109,110,16,70,13,29,203,165,69,75,188,212,164,78,76,217,215,216,189,47,210,213,74,67,97,205,107,206,11,155,204,162,198]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o,m,v,t,r,a,i,c,p,d,D,I,s,k,F,x,j,oe,se,V,H,M,Q,O,G,fe,W,te,he,Se,Le,Me,$e,Xe,qe,Ge,U,K,J,ie,q,ne,pe,Re,We,we,Je,z,X,de,Ue,xe,et,Ce,De,Pe,re,ae,me,ve,B,ge,be,Ie,Oe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Ke){const Qe=Ke.get(J.IExtHostInitDataService),lt=Ke.get(et.IExtHostFileSystemInfo),ht=Ke.get(z.IExtHostConsumerFileSystem),Et=Ke.get(a.IExtHostExtensionService),ot=Ke.get(fe.IExtHostWorkspace),at=Ke.get(ae.IExtHostTelemetry),Dt=Ke.get(w.IExtHostConfiguration),ye=Ke.get(U.IURITransformerService),ce=Ke.get(K.IExtHostRpcService),le=Ke.get(j.IExtHostStorage),$=Ke.get(Je.IExtensionStoragePaths),Ae=Ke.get(Ge.ILogService),Ne=Ke.get(ne.IExtHostTunnelService),tt=Ke.get(pe.IExtHostApiDeprecationService),je=Ke.get(G.IExtHostWindow),gt=Ke.get(Pe.IExtHostSecretState),bt=Ke.get(re.IExtHostEditorTabs);ce.set(l.ExtHostContext.ExtHostFileSystemInfo,lt),ce.set(l.ExtHostContext.ExtHostLogService,Ae),ce.set(l.ExtHostContext.ExtHostWorkspace,ot),ce.set(l.ExtHostContext.ExtHostConfiguration,Dt),ce.set(l.ExtHostContext.ExtHostExtensionService,Et),ce.set(l.ExtHostContext.ExtHostStorage,le),ce.set(l.ExtHostContext.ExtHostTunnelService,Ne),ce.set(l.ExtHostContext.ExtHostWindow,je),ce.set(l.ExtHostContext.ExtHostSecretState,gt),ce.set(l.ExtHostContext.ExtHostTelemetry,at),ce.set(l.ExtHostContext.ExtHostEditorTabs,bt);const kt=ce.set(l.ExtHostContext.ExtHostDecorations,Ke.get(Me.IExtHostDecorations)),ft=ce.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(r.IExtHostDocumentsAndEditors)),ct=ce.set(l.ExtHostContext.ExtHostCommands,Ke.get(g.IExtHostCommands)),mt=ce.set(l.ExtHostContext.ExtHostTerminalService,Ke.get(oe.IExtHostTerminalService)),_t=ce.set(l.ExtHostContext.ExtHostDebugService,Ke.get(Xe.IExtHostDebugService)),Tt=ce.set(l.ExtHostContext.ExtHostSearch,Ke.get(qe.IExtHostSearch)),It=ce.set(l.ExtHostContext.ExtHostTask,Ke.get($e.IExtHostTask)),bn=ce.set(l.ExtHostContext.ExtHostOutputService,Ke.get(I.IExtHostOutputService)),Vt=ce.set(l.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(ce)),yt=ce.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ce,ft)),Yt=ce.set(l.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(ce,ft,Ae)),Jt=ce.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Ae,yt,ce.getProxy(l.MainContext.MainThreadBulkEdits))),pt=ce.set(l.ExtHostContext.ExtHostNotebook,new ie.ExtHostNotebookController(ce,ct,ft,yt,$)),qt=ce.set(l.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(Ae,pt)),Wt=ce.set(l.ExtHostContext.ExtHostNotebookEditors,new Ie.ExtHostNotebookEditors(Ae,ce,pt)),Xt=ce.set(l.ExtHostContext.ExtHostNotebookKernels,new me.ExtHostNotebookKernels(ce,Qe,pt,Ae)),Zt=ce.set(l.ExtHostContext.ExtHostNotebookRenderers,new B.ExtHostNotebookRenderers(ce,pt)),Pt=ce.set(l.ExtHostContext.ExtHostEditors,new se.ExtHostEditors(ce,ft)),dn=ce.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(ce.getProxy(l.MainContext.MainThreadTreeViews),ct,Ae)),en=ce.set(l.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(ce.getProxy(l.MainContext.MainThreadEditorInsets),Pt,Qe)),xt=ce.set(l.ExtHostContext.ExtHostDiagnostics,new A.ExtHostDiagnostics(ce,Ae)),dt=ce.set(l.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(ce,ye,yt,ct,xt,Ae,tt)),tn=ce.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ce,dt)),Lt=ce.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(ce,Ae,ft)),Nt=ce.set(l.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(ce,ot,ct)),jt=ce.set(l.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(ce,ct,Ae)),En=ce.set(l.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(ce,ct,yt)),hn=ce.set(l.ExtHostContext.ExtHostProgress,new s.ExtHostProgress(ce.getProxy(l.MainContext.MainThreadProgress))),_n=ce.set(l.ExtHostContext.ExtHosLabelService,new Se.ExtHostLabelService(ce)),fn=ce.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(ce)),nn=ce.set(l.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(ce)),rn=ce.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(ce,ct)),Ht=ce.set(l.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ce,{remote:Qe.remote},ot,Ae,tt)),sn=ce.set(l.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(ce,Ht,ot)),yn=ce.set(l.ExtHostContext.ExtHostCustomEditors,new de.ExtHostCustomEditors(ce,yt,$,Ht,sn)),Sn=ce.set(l.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(ce,Ht)),zt=ce.set(l.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(ce,ct)),Gt=ce.set(l.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(ce));ce.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(ce,pt,ft,ct));const Dn=(0,te.values)(l.ExtHostContext);ce.assertRegistered(Dn);const Cn=new xe.ExtHostBulkEdits(ce,ft),on=new u.ExtHostClipboard(ce),an=new D.ExtHostMessageService(ce,Ae),Bt=new o.ExtHostDialogs(ce),Ft=new x.ExtHostStatusBar(ce,ct.converter),Kt=new d.ExtHostLanguages(ce,yt);return h.ExtHostApiCommands.register(ct),function(Fe,$t,mn){const vt=function(){let Y=!Fe.isUnderDevelopment;function ue(Te){Y||(Ae.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")ue(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&ue(rt),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,W.throwProposedApiError)(Fe)}return rt}}(),kn={getSession(Y,ue,Te){return Te?.forceNewSession&&(0,W.checkProposedApiEnabled)(Fe),nn.getSession(Fe,Y,ue,Te)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(Y,ue,Te,rt){return nn.registerAuthenticationProvider(Y,ue,Te,rt)}},In={registerCommand(Y,ue,Te){return ct.registerCommand(!0,Y,ue,Te)},registerTextEditorCommand(Y,ue,Te){return ct.registerCommand(!0,Y,(...rt)=>{const wt=Pt.getActiveTextEditor();if(!wt){Ae.warn("Cannot execute "+Y+" because there is no active text editor.");return}return wt.edit(Ct=>{ue.apply(Te,[wt,Ct,...rt])}).then(Ct=>{Ct||Ae.warn("Edits from command "+Y+" were not applied.")},Ct=>{Ae.warn("An error occurred while running command "+Y,Ct)})})},registerDiffInformationCommand:(Y,ue,Te)=>((0,W.checkProposedApiEnabled)(Fe),ct.registerCommand(!0,Y,async(...rt)=>{const wt=ft.activeEditor(!0);if(!wt){Ae.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);ue.apply(Te,[Ct,...rt])})),executeCommand(Y,...ue){return ct.executeCommand(Y,...ue)},getCommands(Y=!1){return ct.getCommands(Y)}},gn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){return Qe.environment.appRoot?.fsPath??""},get embedderIdentifier(){return Qe.environment.embedderIdentifier},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ue){return je.openUri(Y,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===Qe.environment.appUriScheme)return Vt.createAppUri(Y);try{return await je.asExternalUri(Y,{allowTunneling:!!Qe.remote.authority})}catch(ue){if((0,be.matchesScheme)(Y,ge.Schemas.http)||(0,be.matchesScheme)(Y,ge.Schemas.https))return Y;throw ue}},get remoteName(){return(0,Le.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Qe.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pn={createTestController(Y,ue){return zt.createTestController(Y,ue)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Fe),zt.createTestObserver()},runTests(Y){return(0,W.checkProposedApiEnabled)(Fe),zt.runTests(Y)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Fe),zt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Fe),zt.results}},ln={getExtension(Y){const ue=$t.getExtensionDescription(Y);if(ue)return new a.Extension(Et,Fe.identifier,ue,pn)},get all(){return $t.getAllExtensionDescriptions().map(Y=>new a.Extension(Et,Fe.identifier,Y,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(Y){return xt.createDiagnosticCollection(Fe.identifier,Y)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:Y=>xt.getDiagnostics(Y),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(Y,ue){return Kt.changeLanguage(Y.uri,ue)},match(Y,ue){return(0,n.score)(H.LanguageSelector.from(Y),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Y,ue,Te){return dt.registerCodeActionProvider(Fe,vt(Y),ue,Te)},registerCodeLensProvider(Y,ue){return dt.registerCodeLensProvider(Fe,vt(Y),ue)},registerDefinitionProvider(Y,ue){return dt.registerDefinitionProvider(Fe,vt(Y),ue)},registerDeclarationProvider(Y,ue){return dt.registerDeclarationProvider(Fe,vt(Y),ue)},registerImplementationProvider(Y,ue){return dt.registerImplementationProvider(Fe,vt(Y),ue)},registerTypeDefinitionProvider(Y,ue){return dt.registerTypeDefinitionProvider(Fe,vt(Y),ue)},registerHoverProvider(Y,ue){return dt.registerHoverProvider(Fe,vt(Y),ue,Fe.identifier)},registerEvaluatableExpressionProvider(Y,ue){return dt.registerEvaluatableExpressionProvider(Fe,vt(Y),ue,Fe.identifier)},registerInlineValuesProvider(Y,ue){return dt.registerInlineValuesProvider(Fe,vt(Y),ue,Fe.identifier)},registerDocumentHighlightProvider(Y,ue){return dt.registerDocumentHighlightProvider(Fe,vt(Y),ue)},registerLinkedEditingRangeProvider(Y,ue){return dt.registerLinkedEditingRangeProvider(Fe,vt(Y),ue)},registerReferenceProvider(Y,ue){return dt.registerReferenceProvider(Fe,vt(Y),ue)},registerRenameProvider(Y,ue){return dt.registerRenameProvider(Fe,vt(Y),ue)},registerDocumentSymbolProvider(Y,ue,Te){return dt.registerDocumentSymbolProvider(Fe,vt(Y),ue,Te)},registerWorkspaceSymbolProvider(Y){return dt.registerWorkspaceSymbolProvider(Fe,Y)},registerDocumentFormattingEditProvider(Y,ue){return dt.registerDocumentFormattingEditProvider(Fe,vt(Y),ue)},registerDocumentRangeFormattingEditProvider(Y,ue){return dt.registerDocumentRangeFormattingEditProvider(Fe,vt(Y),ue)},registerOnTypeFormattingEditProvider(Y,ue,Te,...rt){return dt.registerOnTypeFormattingEditProvider(Fe,vt(Y),ue,[Te].concat(rt))},registerDocumentSemanticTokensProvider(Y,ue,Te){return dt.registerDocumentSemanticTokensProvider(Fe,vt(Y),ue,Te)},registerDocumentRangeSemanticTokensProvider(Y,ue,Te){return dt.registerDocumentRangeSemanticTokensProvider(Fe,vt(Y),ue,Te)},registerSignatureHelpProvider(Y,ue,Te,...rt){return typeof Te=="object"?dt.registerSignatureHelpProvider(Fe,vt(Y),ue,Te):dt.registerSignatureHelpProvider(Fe,vt(Y),ue,typeof Te=="undefined"?[]:[Te,...rt])},registerCompletionItemProvider(Y,ue,...Te){return dt.registerCompletionItemProvider(Fe,vt(Y),ue,Te)},registerInlineCompletionItemProvider(Y,ue){return(0,W.checkProposedApiEnabled)(Fe),dt.registerInlineCompletionsProvider(Fe,vt(Y),ue)},registerDocumentLinkProvider(Y,ue){return dt.registerDocumentLinkProvider(Fe,vt(Y),ue)},registerColorProvider(Y,ue){return dt.registerColorProvider(Fe,vt(Y),ue)},registerFoldingRangeProvider(Y,ue){return dt.registerFoldingRangeProvider(Fe,vt(Y),ue)},registerSelectionRangeProvider(Y,ue){return dt.registerSelectionRangeProvider(Fe,Y,ue)},registerCallHierarchyProvider(Y,ue){return dt.registerCallHierarchyProvider(Fe,Y,ue)},setLanguageConfiguration:(Y,ue)=>dt.setLanguageConfiguration(Fe,Y,ue),getTokenInformationAtPosition(Y,ue){return(0,W.checkProposedApiEnabled)(Fe),Kt.tokenAtPosition(Y,ue)},registerInlayHintsProvider(Y,ue){return(0,W.checkProposedApiEnabled)(Fe),dt.registerInlayHintsProvider(Fe,Y,ue)},registerTypeHierarchyProvider(Y,ue){return(0,W.checkProposedApiEnabled)(Fe),dt.registerTypeHierarchyProvider(Fe,Y,ue)},createLanguageStatusItem(Y){return(0,W.checkProposedApiEnabled)(Fe),Kt.createLanguageStatusItem(Y)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(Y,ue,Te){const rt=await(P.URI.isUri(Y)?Promise.resolve(vn.openTextDocument(Y)):Promise.resolve(Y));return Pt.showTextDocument(rt,ue,Te)},createTextEditorDecorationType(Y){return Pt.createTextEditorDecorationType(Fe,Y)},onDidChangeActiveTextEditor(Y,ue,Te){return Pt.onDidChangeActiveTextEditor(Y,ue,Te)},onDidChangeVisibleTextEditors(Y,ue,Te){return Pt.onDidChangeVisibleTextEditors(Y,ue,Te)},onDidChangeTextEditorSelection(Y,ue,Te){return Pt.onDidChangeTextEditorSelection(Y,ue,Te)},onDidChangeTextEditorOptions(Y,ue,Te){return Pt.onDidChangeTextEditorOptions(Y,ue,Te)},onDidChangeTextEditorVisibleRanges(Y,ue,Te){return Pt.onDidChangeTextEditorVisibleRanges(Y,ue,Te)},onDidChangeTextEditorViewColumn(Y,ue,Te){return Pt.onDidChangeTextEditorViewColumn(Y,ue,Te)},onDidCloseTerminal(Y,ue,Te){return mt.onDidCloseTerminal(Y,ue,Te)},onDidOpenTerminal(Y,ue,Te){return mt.onDidOpenTerminal(Y,ue,Te)},onDidChangeActiveTerminal(Y,ue,Te){return mt.onDidChangeActiveTerminal(Y,ue,Te)},onDidChangeTerminalDimensions(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),mt.onDidChangeTerminalDimensions(Y,ue,Te)},onDidWriteTerminalData(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),mt.onDidWriteTerminalData(Y,ue,Te)},get state(){return je.state},onDidChangeWindowState(Y,ue,Te){return je.onDidChangeWindowState(Y,ue,Te)},showInformationMessage(Y,...ue){return an.showMessage(Fe,y.default.Info,Y,ue[0],ue.slice(1))},showWarningMessage(Y,...ue){return an.showMessage(Fe,y.default.Warning,Y,ue[0],ue.slice(1))},showErrorMessage(Y,...ue){return an.showMessage(Fe,y.default.Error,Y,ue[0],ue.slice(1))},showQuickPick(Y,ue,Te){return Nt.showQuickPick(Y,!!Fe.enableProposedApi,ue,Te)},showWorkspaceFolderPick(Y){return Nt.showWorkspaceFolderPick(Y)},showInputBox(Y,ue){return Nt.showInput(Y,ue)},showOpenDialog(Y){return Bt.showOpenDialog(Y)},showSaveDialog(Y){return Bt.showSaveDialog(Y)},createStatusBarItem(Y,ue,Te){let rt,wt,Ct;return typeof Y=="string"?(rt=Y,wt=ue,Ct=Te):(wt=Y,Ct=ue),Ft.createStatusBarEntry(Fe,rt,wt,Ct)},setStatusBarMessage(Y,ue){return Ft.setStatusBarMessage(Y,ue)},withScmProgress(Y){return tt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),hn.withProgress(Fe,{location:M.ProgressLocation.SourceControl},(ue,Te)=>Y({report(rt){}}))},withProgress(Y,ue){return hn.withProgress(Fe,Y,ue)},createOutputChannel(Y){return bn.createOutputChannel(Y,Fe)},createWebviewPanel(Y,ue,Te,rt){return sn.createWebviewPanel(Fe,Y,ue,Te,rt)},createWebviewTextEditorInset(Y,ue,Te,rt){return(0,W.checkProposedApiEnabled)(Fe),en.createWebviewEditorInset(Y,ue,Te,rt,Fe)},createTerminal(Y,ue,Te){return typeof Y=="object"?(Y.color&&(0,W.checkProposedApiEnabled)(Fe),"pty"in Y?mt.createExtensionTerminal(Y):mt.createTerminalFromOptions(Y)):mt.createTerminal(Y,ue,Te)},registerTerminalLinkProvider(Y){return mt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ue){return mt.registerProfileProvider(Fe,Y,ue)},registerTreeDataProvider(Y,ue){return dn.registerTreeDataProvider(Y,ue,Fe)},createTreeView(Y,ue){return dn.createTreeView(Y,ue,Fe)},registerWebviewPanelSerializer:(Y,ue)=>sn.registerWebviewPanelSerializer(Fe,Y,ue),registerCustomEditorProvider:(Y,ue,Te={})=>yn.registerCustomEditorProvider(Fe,Y,ue,Te),registerFileDecorationProvider(Y){return kt.registerFileDecorationProvider(Y,Fe.identifier)},registerUriHandler(Y){return Vt.registerUriHandler(Fe.identifier,Y)},createQuickPick(){return Nt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Nt.createInputBox(Fe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(Y,ue,Te){return fn.onDidChangeActiveColorTheme(Y,ue,Te)},registerWebviewViewProvider(Y,ue,Te){return Sn.registerWebviewViewProvider(Fe,Y,ue,Te?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Fe),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),pt.onDidChangeActiveNotebookEditor(Y,ue,Te)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Fe),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Fe),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),Wt.onDidChangeNotebookEditorSelection(Y,ue,Te)},onDidChangeNotebookEditorVisibleRanges(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),Wt.onDidChangeNotebookEditorVisibleRanges(Y,ue,Te)},showNotebookDocument(Y,ue){return(0,W.checkProposedApiEnabled)(Fe),pt.showNotebookDocument(Y,ue)},registerExternalUriOpener(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),Gt.registerExternalUriOpener(Fe.identifier,Y,ue,Te)},get openEditors(){return(0,W.checkProposedApiEnabled)(Fe),bt.tabs},get onDidChangeOpenEditors(){return(0,W.checkProposedApiEnabled)(Fe),bt.onDidChangeTabs},getInlineCompletionItemController(Y){return(0,W.checkProposedApiEnabled)(Fe),p.InlineCompletionController.get(Y)}},vn={get rootPath(){return tt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(Y){throw R.readonly()},getWorkspaceFolder(Y){return ot.getWorkspaceFolder(Y)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(Y){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(Y){throw R.readonly()},updateWorkspaceFolders:(Y,ue,...Te)=>ot.updateWorkspaceFolders(Fe,Y,ue||0,...Te),onDidChangeWorkspaceFolders:function(Y,ue,Te){return ot.onDidChangeWorkspace(Y,ue,Te)},asRelativePath:(Y,ue)=>ot.getRelativePath(Y,ue),findFiles:(Y,ue,Te,rt)=>ot.findFiles(H.GlobPattern.from(Y),H.GlobPattern.from(ue),Te,Fe.identifier,rt),findTextInFiles:(Y,ue,Te,rt)=>{let wt,Ct;return typeof ue=="object"?(wt=ue,Ct=Te):(wt={},Ct=ue,rt=Te),ot.findTextInFiles(Y,wt||{},Ct,Fe.identifier,rt)},saveAll:Y=>ot.saveAll(Y),applyEdit(Y){return Cn.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ue,Te,rt)=>Lt.createFileSystemWatcher(H.GlobPattern.from(Y),ue,Te,rt),get textDocuments(){return yt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw R.readonly()},openTextDocument(Y){let ue;const Te=Y;if(typeof Y=="string")ue=Promise.resolve(P.URI.file(Y));else if(P.URI.isUri(Y))ue=Promise.resolve(Y);else if(!Te||typeof Te=="object")ue=yt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>yt.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(Y,ue,Te)=>yt.onDidAddDocument(Y,ue,Te),onDidCloseTextDocument:(Y,ue,Te)=>yt.onDidRemoveDocument(Y,ue,Te),onDidChangeTextDocument:(Y,ue,Te)=>yt.onDidChangeDocument(Y,ue,Te),onDidSaveTextDocument:(Y,ue,Te)=>yt.onDidSaveDocument(Y,ue,Te),onWillSaveTextDocument:(Y,ue,Te)=>Jt.getOnWillSaveTextDocumentEvent(Fe)(Y,ue,Te),get notebookDocuments(){return pt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ue){let Te;if(P.URI.isUri(Y))Te=Y,await pt.openNotebookDocument(Y);else if(typeof Y=="string")Te=P.URI.revive(await pt.createNotebookDocument({viewType:Y,content:ue}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ue,Te,rt){return pt.registerNotebookSerializer(Fe,Y,ue,Te,Fe.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(Y,ue,Te,rt)=>((0,W.checkProposedApiEnabled)(Fe),pt.registerNotebookContentProvider(Fe,Y,ue,Te,Fe.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(Y,ue,Te)=>mn.onDidChangeConfiguration(Y,ue,Te),getConfiguration(Y,ue){return ue=arguments.length===1?void 0:ue,mn.getConfiguration(Y,ue,Fe)},registerTextDocumentContentProvider(Y,ue){return Yt.registerTextDocumentContentProvider(Y,ue)},registerTaskProvider:(Y,ue)=>(tt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Fe,Y,ue)),registerFileSystemProvider(Y,ue,Te){return tn.registerFileSystemProvider(Fe.identifier,Y,ue,Te,Fe.enableProposedApi)},get fs(){return ht.value},registerFileSearchProvider:(Y,ue)=>((0,W.checkProposedApiEnabled)(Fe),Tt.registerFileSearchProvider(Y,ue)),registerTextSearchProvider:(Y,ue)=>((0,W.checkProposedApiEnabled)(Fe),Tt.registerTextSearchProvider(Y,ue)),registerRemoteAuthorityResolver:(Y,ue)=>((0,W.checkProposedApiEnabled)(Fe),Et.registerRemoteAuthorityResolver(Y,ue)),registerResourceLabelFormatter:Y=>((0,W.checkProposedApiEnabled)(Fe),_n.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ue,Te)=>Lt.onDidCreateFile(Y,ue,Te),onDidDeleteFiles:(Y,ue,Te)=>Lt.onDidDeleteFile(Y,ue,Te),onDidRenameFiles:(Y,ue,Te)=>Lt.onDidRenameFile(Y,ue,Te),onWillCreateFiles:(Y,ue,Te)=>Lt.getOnWillCreateFileEvent(Fe)(Y,ue,Te),onWillDeleteFiles:(Y,ue,Te)=>Lt.getOnWillDeleteFileEvent(Fe)(Y,ue,Te),onWillRenameFiles:(Y,ue,Te)=>Lt.getOnWillRenameFileEvent(Fe)(Y,ue,Te),openTunnel:Y=>((0,W.checkProposedApiEnabled)(Fe),Ne.openTunnel(Fe,Y).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,W.checkProposedApiEnabled)(Fe),Ne.getTunnels()},onDidChangeTunnels:(Y,ue,Te)=>((0,W.checkProposedApiEnabled)(Fe),Ne.onDidChangeTunnels(Y,ue,Te)),registerPortAttributesProvider:(Y,ue)=>((0,W.checkProposedApiEnabled)(Fe),Ne.registerPortsAttributesProvider(Y,ue)),registerTimelineProvider:(Y,ue)=>((0,W.checkProposedApiEnabled)(Fe),rn.registerTimelineProvider(Y,ue,Fe.identifier,ct.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:Y=>((0,W.checkProposedApiEnabled)(Fe),ot.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ue,Te)=>ot.onDidGrantWorkspaceTrust(Y,ue,Te)},Rn={get inputBox(){return tt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),jt.getLastInputBox(Fe)},createSourceControl(Y,ue,Te){return jt.createSourceControl(Fe,Y,ue,Te)}},Fn={createCommentController(Y,ue){return En.createCommentController(Fe,Y,ue)}},Mn={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(Y,ue,Te){return _t.onDidStartDebugSession(Y,ue,Te)},onDidTerminateDebugSession(Y,ue,Te){return _t.onDidTerminateDebugSession(Y,ue,Te)},onDidChangeActiveDebugSession(Y,ue,Te){return _t.onDidChangeActiveDebugSession(Y,ue,Te)},onDidReceiveDebugSessionCustomEvent(Y,ue,Te){return _t.onDidReceiveDebugSessionCustomEvent(Y,ue,Te)},onDidChangeBreakpoints(Y,ue,Te){return _t.onDidChangeBreakpoints(Y,ue,Te)},registerDebugConfigurationProvider(Y,ue,Te){return _t.registerDebugConfigurationProvider(Y,ue,Te||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ue){return _t.registerDebugAdapterDescriptorFactory(Fe,Y,ue)},registerDebugAdapterTrackerFactory(Y,ue){return _t.registerDebugAdapterTrackerFactory(Y,ue)},startDebugging(Y,ue,Te){return!Te||typeof Te=="object"&&"configuration"in Te?_t.startDebugging(Y,ue,{parentSession:Te}):_t.startDebugging(Y,ue,Te||{})},stopDebugging(Y){return _t.stopDebugging(Y)},addBreakpoints(Y){return _t.addBreakpoints(Y)},removeBreakpoints(Y){return _t.removeBreakpoints(Y)},asDebugSourceUri(Y,ue){return _t.asDebugSourceUri(Y,ue)}},Ln={registerTaskProvider:(Y,ue)=>It.registerTaskProvider(Fe,Y,ue),fetchTasks:Y=>It.fetchTasks(Y),executeTask:Y=>It.executeTask(Fe,Y),get taskExecutions(){return It.taskExecutions},onDidStartTask:(Y,ue,Te)=>It.onDidStartTask(Y,ue,Te),onDidEndTask:(Y,ue,Te)=>It.onDidEndTask(Y,ue,Te),onDidStartTaskProcess:(Y,ue,Te)=>It.onDidStartTaskProcess(Y,ue,Te),onDidEndTaskProcess:(Y,ue,Te)=>It.onDidEndTaskProcess(Y,ue,Te)},Nn={createNotebookController(Y,ue,Te,rt,wt){return Xt.createNotebookController(Fe,Y,ue,Te,rt,Fe.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ue)=>pt.registerNotebookCellStatusBarItemProvider(Fe,Y,ue),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Fe),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,W.checkProposedApiEnabled)(Fe),Wt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return Zt.createRendererMessaging(Fe,Y)},onDidChangeNotebookDocumentMetadata(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),qt.onDidChangeNotebookDocumentMetadata(Y,ue,Te)},onDidChangeNotebookCells(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),pt.onDidChangeNotebookCells(Y,ue,Te)},onDidChangeNotebookCellExecutionState(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),pt.onDidChangeNotebookCellExecutionState(Y,ue,Te)},onDidChangeCellOutputs(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),pt.onDidChangeCellOutputs(Y,ue,Te)},onDidChangeCellMetadata(Y,ue,Te){return(0,W.checkProposedApiEnabled)(Fe),pt.onDidChangeCellMetadata(Y,ue,Te)},createConcatTextDocument(Y,ue){return(0,W.checkProposedApiEnabled)(Fe),new we.ExtHostNotebookConcatDocument(pt,yt,Y,ue)}};return{version:Qe.version,authentication:kn,commands:In,comments:Fn,debug:Mn,env:gn,extensions:ln,languages:An,notebooks:Nn,scm:Rn,tasks:Ln,tests:Pn,window:Tn,workspace:vn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:C.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,Task2:M.Task,TaskGroup:M.TaskGroup,TaskGroup2:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:l.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:ve.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(Ee[230],_e([0,1,60,105,32,104,33,48,49,39,108,109,110,77,69,75,106,76,47,74,97,67]),function(Z,e,f,R,S,y,P,E,_,C,n,T,l,h,u,g,b,w,A,o,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,f.registerSingleton)(E.IExtHostCommands,E.ExtHostCommands),(0,f.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,f.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,f.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService),(0,f.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,f.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(A.IExtHostFileSystemInfo,A.ExtHostFileSystemInfo),(0,f.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,f.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,f.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,f.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,f.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,f.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,f.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,f.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,f.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,f.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry),(0,f.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(Ee[231],_e([0,1,229,34,225,7,15,5,11]),function(Z,e,f,R,S,y,P,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(u){const g=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...A)=>{A.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const o=A.slice(0,-1).join(","),m=A.pop().toString();return`(function anonymous(${o}) {
${m}
})`}});function b(...w){return g?self.eval(g.createScript("",...w)):new Function(...w)}u.create=b})(C||(C={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(g,b){for(let w of this._alternatives){let A=w(g);if(A){g=A;break}}if(this._factories.has(g))return this._factories.get(g).load(g,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const g=this._extHostContext.getProxy(E.MainContext.MainThreadConsole);h(g,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(f.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(g){return g.browser}async _loadCommonJSModule(g,b,w){b=b.with({path:l(b.path,".js")}),g&&performance.mark(`code/extHost/willFetchExtensionCode/${g.value}`);const A=await fetch(_.FileAccess.asBrowserUri(b).toString(!0));if(g&&performance.mark(`code/extHost/didFetchExtensionCode/${g.value}`),A.status!==200)throw new Error(A.statusText);const o=await A.text(),m=`${b.toString(!0)}#vscode-extension`,v=`${o}
//# sourceURL=${m}`;let t;try{t=C.create(T._ttpExtensionScripts?.createScript("module")??"module",T._ttpExtensionScripts?.createScript("exports")??"exports",T._ttpExtensionScripts?.createScript("require")??"require",T._ttpExtensionScripts?.createScript(v)??v)}catch(c){throw console.error(g?`Loading code for extension ${g.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${b.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const r={},a={exports:r},i=c=>{const p=this._fakeModules.getModule(c,b);if(p===void 0)throw new Error(`Cannot load module '${c}'`);return p};try{return w.codeLoadingStart(),g&&performance.mark(`code/extHost/willLoadExtensionCode/${g.value}`),t(a,r,i),a.exports!==r?a.exports:r}finally{g&&performance.mark(`code/extHost/didLoadExtensionCode/${g.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(g){throw new Error("Not supported")}async _waitForDebuggerAttachment(g=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+g;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=T,T._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:u=>u});function l(u,g){return u.endsWith(g)?u:u+g}function h(u,g){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(o,m){const v=console[o];console[o]=function(){u.$logExtensionHostMessage({type:"__$console",severity:m,arguments:A(arguments)}),g&&v.apply(console,arguments)}}const w=1e5;function A(o){const m=[],v=[];if(o.length)for(let t=0;t<o.length;t++){if(typeof o[t]=="undefined")o[t]="undefined";else if(o[t]instanceof Error){const r=o[t];r.stack?o[t]=r.stack:o[t]=r.toString()}v.push(o[t])}try{const t=JSON.stringify(v,function(r,a){if(a&&typeof a=="object"){if(m.indexOf(a)!==-1)return"[Circular]";m.push(a)}return a});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(Ee[232],_e([0,1,60,16,34,78,231,218]),function(Z,e,f,R,S,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(S.IExtHostExtensionService,P.ExtHostExtensionService),(0,f.registerSingleton)(R.ILogService,E.ExtHostLogService),(0,f.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths)}),define(Ee[234],_e([0,1,24,3,185,226,220,14,79,11,2,230,232]),function(Z,e,f,R,S,y,P,E,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const T=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const A=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:m=>m}),o=self.Worker;Worker=function(m,v){/^file:/i.test(m.toString())&&(m=C.FileAccess.asBrowserUri(n.URI.parse(m.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${m}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;v=v||{},v.name=v.name||E.basename(m.toString());const r=new Blob([t],{type:"application/javascript"}),a=URL.createObjectURL(r);return new o(A?A.createScriptURL(a):a,v)}}else self.Worker=class extends P.NestedWorker{constructor(A,o){super(l,A,{name:E.basename(A.toString()),...o})}};const h=new class{exit(A){T()}async exists(A){return!0}async realpath(A){return A}};class u{constructor(){const o=new MessageChannel,m=new R.Emitter;let v=!1;l(o.port2,[o.port2]),o.port1.onmessage=t=>{const{data:r}=t;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const a=f.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,S.isMessageOfType)(a,2)){v=!0,b("received terminate message from renderer");return}m.fire(a)},this.protocol={onMessage:m.event,send:t=>{if(!v){const r=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);o.port1.postMessage(r,[r])}}}}}function g(A){return new Promise(o=>{const m=A.onMessage(v=>{m.dispose();const t=JSON.parse(v.toString());A.send((0,S.createMessageOfType)(0)),o({protocol:A,initData:t})});A.send((0,S.createMessageOfType)(1))})}let b=A=>T();function w(){const A=new u;_.mark("code/extHost/willConnectToRenderer"),g(A.protocol).then(o=>{_.mark("code/extHost/didWaitForInitData");const m=new y.ExtensionHostMain(o.protocol,o.initData,h,null);b=v=>m.terminate(v)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/71b299184f7908491345aec5e231599c3ae8753b/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
